C
C write out haplotypes in nuclear family and grandparents
C
      subroutine dohaplo(wrk,wrk2,trait,iter,nloci,loc,loctyp,locpos,
     &             pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &             numloc,hset,showorig)
      integer KNOWN, MAXHAP, MAXSIZ, MAXLOC, MISS
      parameter(KNOWN=0,MAXSIZ=1000,MAXLOC=120,
     &          MAXHAP=MAXLOC/2,MISS=-9999)

      integer iter,showorig,trait,wrk,wrk2
C
C Pedigree structure
      character*10 pedigree
      integer actset, num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
      integer numloc
C
C Locus structure 
      integer nloci
      character*10 loc(MAXLOC)
      integer loctyp(MAXLOC),locpos(MAXLOC)
C
C Storage space for haplotypes
      integer hset(MAXSIZ,MAXHAP,2)
C
C Marker list
      integer nmark, mark(MAXHAP)
C 
      integer currf, currm, gene, gen2, i, j, sta
      logical last 

      nmark=0
      do 1 j=1,nloci
      if (loctyp(j).eq.1) then
        nmark=nmark+1
        mark(nmark)=j
        if (nmark.eq.MAXHAP) goto 2
      end if
    1 continue
    2 continue

      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc,last)
       if (last) goto 20

       if (actset.le.0) goto 10
C
        do 25 i=1,num
        do 25 j=1,nmark
          gene=locpos(mark(j))
          gen2=gene+1
          if (locus(i,gene).gt.KNOWN) then
            hset(i,j,1)=int(locus(i,gene))
            hset(i,j,2)=int(locus(i,gen2))
          else
            hset(i,j,1)=MISS
            hset(i,j,2)=MISS
          end if
   25   continue

        currf=fa(nfound+1)
        currm=mo(nfound+1)
        sta=nfound+1
        do 30 i=nfound+1,num
C Print results of last sibship and do parents of current sibship
          if (fa(i).ne.currf .or. mo(i).ne.currm) then
            call wrhaplo(wrk2,pedigree,currf,currm,sta,i-1,nmark,mark, 
     &            iter,trait,nloci,loc,id,fa,mo,sex,locus,hset,showorig)
            sta=i
            currf=fa(i)
            currm=mo(i)
          end if
   30   continue
        call wrhaplo(wrk2,pedigree,currf,currm,sta,num,nmark,mark, 
     &         iter,trait,nloci,loc,id,fa,mo,sex,locus,hset,showorig)
      goto 10
   20 continue

      return
      end
C end-of-dohaplo
C
C Write haplotypes for sibship, parents, and grandparents, if available
C
      subroutine wrhaplo(wrk2,pedigree,currf,currm,sta,fin,nmark,mark, 
     2             iter,trait,nloci,loc,id,fa,mo,sex,locus,
     3             hset,showorig)
      integer MAXSIZ, MAXLOC, MAXHAP, MISS, WIDE
      parameter(MAXSIZ=1000,MAXLOC=120,MAXHAP=MAXLOC/2,
     &          MISS=-9999,WIDE=12)

      integer currf, currm, fin, iter, sta, trait,wrk2
      integer showorig
C Marker list
      integer nmark, mark(MAXHAP)
C
C Pedigree structure
      character*10 pedigree
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C
C Locus structure:
      integer nloci
      character*10 loc(MAXLOC)
C
C Storage space for haplotypes
      integer hset(MAXSIZ,MAXHAP,2)
C
C local variables
      integer i, j, eol, eop, leftm, npars, pos, nsibs
      logical gp1, gp2, use
      character*1 pchrom(4),mchrom(4)
      character*3 all
      character*7 gtp
      character*10 chid
      character*128 lin
C
C functions
      integer eow,gpsrc

      data mchrom,pchrom /'|','c','d','*','|','a','b','*'/

      if (showorig.lt.2) then
        mchrom(1)=' '
        mchrom(2)=' '
        mchrom(3)=' '
        pchrom(1)=' '
        pchrom(2)=' '
        pchrom(3)=' '
        if (showorig.lt.1) then
          mchrom(4)=' '
          pchrom(4)=' '
        end if
      end if
      eop=eow(pedigree)
C
C Check if useful to view (some typed siblings or one child plus parent)
C
      npars=0
      nsibs=0
      call usehap(currf,nmark,hset,use)
      if (use) npars=npars+1
      call usehap(currm,nmark,hset,use)
      if (use) npars=npars+1
      do 2 i=sta,fin
        call usehap(i,nmark,hset,use)
        if (use) then
          nsibs=nsibs+1 
        end if
    2 continue
    
      if (nsibs.eq.0 .or. (nsibs.eq.1 .and. npars.eq.0)) return
C
C Utility of grandparents
C
      if (fa(currf).ne.MISS) then
        call usehap(fa(currf),nmark,hset,gp1)
        if (.not.gp1) call usehap(mo(currf),nmark,hset,gp1)
      else
        gp1=.false.
      end if
      if (fa(currm).ne.MISS) then
        call usehap(fa(currm),nmark,hset,gp2)
        if (.not.gp2) call usehap(mo(currm),nmark,hset,gp2)
      else
        gp2=.false.
      end if

C note the nuclear family level inconsistencies
      write(*,'(8a/)')
     2  'Sibship: ',pedigree(1:eop),'-',id(currf)(1:eow(id(currf))),
     3  ' x ',pedigree(1:eop),'-',id(currm)(1:eow(id(currm))) 
      call check2(pedigree,eop,currf,currm,sta,fin,id,
     &            nmark,mark,loc,hset)
      call maxshare(currf,currm,fa(currf),mo(currf),
     &              fa(currm),mo(currm),sta,fin,iter,nmark,hset)
      if (iter.gt.0) then
        call recmin(wrk2,currf,currm,fa(currf),mo(currf),
     &              fa(currm),mo(currm),sta,fin,iter,nmark,hset)
      end if
      lin=' '
C
C Show grandparental generation if useful and present
C
C IDs
      if (gp1 .or. gp2) then
        if (gp1) then
          call wrid('c',id(fa(currf)),chid,sex(fa(currf)))
          lin(17:26)=chid
          call wrid('c',id(mo(currf)),chid,sex(mo(currf)))
          lin(27:36)=chid
          eol=35
        end if
        if (gp2) then
          call wrid('c',id(fa(currm)),chid,sex(fa(currm)))
          lin(37:46)=chid
          call wrid('c',id(mo(currm)),chid,sex(mo(currm)))
          lin(47:56)=chid
          eol=55
        end if
        write(*,'(a)') lin(1:eol)
C trait if requested
        if (trait.ne.MISS) then
          if (gp1) then
            call wraff7(locus(fa(currf),trait),gtp)
            lin(18:24)=gtp
            call wraff7(locus(mo(currf),trait),gtp)
            lin(28:34)=gtp
            eol=34
          end if
          if (gp2) then
            call wraff7(locus(fa(currm),trait),gtp)
            lin(38:44)=gtp
            call wraff7(locus(mo(currm),trait),gtp)
            lin(48:54)=gtp
            eol=54
          end if
          write(*,'(a)') lin(1:eol)
        end if
C markers
        do 10 j=1,nmark
          lin=' '
          if (gp1) then
            call wrgtp(hset(fa(currf),j,1),
     &                 hset(fa(currf),j,2),gtp,0)
            lin(18:24)=gtp
            call wrgtp(hset(mo(currf),j,1),
     &                 hset(mo(currf),j,2),gtp,0)
            lin(28:34)=gtp
            eol=34
          end if
          if (gp2) then
            call wrgtp(hset(fa(currm),j,1),
     &                 hset(fa(currm),j,2),gtp,0)
            lin(38:44)=gtp
            call wrgtp(hset(mo(currm),j,1),
     &                 hset(mo(currm),j,2),gtp,0)
            lin(48:54)=gtp
            eol=54
          end if
          write(*,'(a)') lin(1:eol)
   10   continue
        lin=' '
        if (gp1) then
          lin(21:21)='|'
          lin(31:31)='|'
          eol=31
        end if
        if (gp2) then
          lin(41:41)='|'
          lin(51:51)='|'
          eol=51
        end if
        write(*,'(a)') lin(1:eol)
        lin=' '
        if (gp1) then
          lin(21:31)='+====+====+'
          eol=31
        end if
        if (gp2) then
          lin(41:51)='+====+====+'
          eol=51
        end if
        write(*,'(a)') lin(1:eol)
        lin=' '
        if (gp1) then
          lin(26:26)='|'
          eol=26
        end if
        if (gp2) then
          lin(46:46)='|'
          eol=46
        end if
        write(*,'(a)') lin(1:eol)
        lin=' '
      end if
C
C Now the parents of the nuclear family
C
      call wrid('c',id(currf),chid,sex(currf))
      lin(22:31)=chid
      call wrid('c',id(currm),chid,sex(currm))
      lin(42:51)=chid
      write(*,'(a)') lin(1:50)
      if (trait.ne.MISS) then
        lin=' '
        lin(11:20)=loc(trait)
        call wraff7(locus(currf,trait),gtp)
        lin(23:29)=gtp
        call wraff7(locus(currm,trait),gtp)
        lin(43:49)=gtp
        write(*,'(a)') lin(1:49)
      end if
      do 20 j=1,nmark
        lin=' '
        lin(11:20)=loc(mark(j))
        call wrgtp(hset(currf,j,1),hset(currf,j,2),gtp,0)
        lin(23:29)=gtp
        call wrgtp(hset(currm,j,1),hset(currm,j,2),gtp,0)
        lin(43:49)=gtp
        write(*,'(a)') lin(1:49)
        lin=' '
   20 continue
      write(*,'(25x,a1,19x,a1/25x,a21/35x,a1)')
     &  '|','|','+=========+=========+','|'
C
C Then the children
C
      nsibs=fin-sta+1
      if (nsibs.eq.1) then
        call wrid('c',id(sta),chid,sex(sta))
        write(*,'(35x,a1/31x,a10)') '|',chid
        if (trait.ne.MISS) then
          call wraff7(locus(sta,trait),gtp)
          write(*,'(20x,a10,2x,a7)') loc(trait),gtp
        end if
        do 30 j=1,nmark
          call wrgtp(hset(sta,j,1),hset(sta,j,2),gtp,0)
          write(*,'(20x,a10,1x,a1,a7,a1)') loc(mark(j)),
     2      pchrom(gpsrc(currf,sta,1,j,hset)+1),
     3      gtp,
     4      mchrom(gpsrc(currm,sta,2,j,hset)+1)
   30   continue
        if (showorig.gt.0 .and. iter.gt.0) then
          call recnum(sta,currf,currm,nmark,hset,gtp)
          write(*,'(32x,a7)') gtp 
        end if
      elseif (nsibs.gt.WIDE) then
        do 40 i=sta,fin
          write(*,*)
          lin=' '
          pos=1
          do 41 j=1,nmark
            call wrall(hset(i,j,1),all)
            lin(pos:pos+2)=all
            pos=pos+4
   41     continue
          write(*,'(28x,a8,a)') id(i),lin(1:pos)
          lin=' '
          pos=1
          do 42 j=1,nmark
            call wrall(hset(i,j,2),all)
            lin(pos:pos+2)=all
            pos=pos+4
   42     continue
          call recnum(i,currf,currm,nmark,hset,gtp)
          write(*,'(28x,a,1x,a)') gtp,lin(1:pos)
   40   continue
      else
        leftm=max(13,38-5*nsibs)
        pos=leftm+3
        do 50 i=1,nsibs-1
          lin(pos:pos+10)='+---------+'
          pos=pos+10
   50   continue
        lin(36:36)='+'
        write(*,'(a)') lin(1:pos)
        lin=' '
        pos=leftm+3
        do 60 i=1,nsibs
          lin(pos:pos)='|'
          pos=pos+10
   60   continue
        write(*,'(a)') lin(1:pos)
        lin=' '
        pos=leftm
        do 70 i=sta,fin
          call wrid('c',id(i),chid,sex(i))
          lin(pos:pos+9)=chid
          pos=pos+11
   70   continue
        write(*,'(a)') lin(1:pos)
        if (trait.ne.MISS) then
          lin=' '
          lin(leftm-12:leftm-3)=loc(trait)
          pos=leftm
          do 75 i=sta,fin
            call wraff7(locus(i,trait),gtp)
            lin(pos:pos+6)=gtp
            pos=pos+10
   75     continue
          write(*,'(a)') lin(1:pos)
        end if
        do 80 j=1,nmark
          lin=' '
          lin(leftm-12:leftm-3)=loc(mark(j))
          pos=leftm
          do 90 i=sta,fin
            call wrgtp(hset(i,j,1),hset(i,j,2),gtp,0)
            lin(pos:pos+6)=gtp
            lin(pos-1:pos-1)=pchrom(gpsrc(currf,i,1,j,hset)+1)
            lin(pos+7:pos+7)=mchrom(gpsrc(currm,i,2,j,hset)+1)
            pos=pos+10
   90     continue
          write(*,'(a)') lin(1:pos)
   80   continue

        if (showorig.gt.0 .and. iter.gt.0) then
          lin=' '
          pos=leftm 
          do 100 i=sta,fin
            call recnum(i,currf,currm,nmark,hset,gtp)
            lin(pos:pos+6)=gtp
            pos=pos+10
  100     continue
          write(*,'(a)') lin(1:pos)
        end if
      end if
      write(*,*)

      return
      end
C end-of-wrhaplo 
C
C write out allele   
C
      subroutine wrall(iall,all)
      integer MISS,KNOWN
      parameter(MISS=-9999,KNOWN=0)
      integer iall
      character*3 all
      if (iall.eq.MISS) then 
        all='  x'
      elseif (iall.lt.KNOWN) then
        write(all,'(i3)') -iall
      else
        write(all,'(i3)') iall 
      end if
      return
      end
C end-of-wrall
C
C Search for best haplotypes based on recmin criterion
C
      subroutine recmin(wrk2,currf,currm,gran1,gran2,gran3,gran4,
     &                  sta,fin,iter,nmark,hset)
      integer KNOWN, MAXLOC, MAXHAP, MAXSIZ, MISS
      parameter(KNOWN=0, MAXLOC=120, MAXHAP=MAXLOC/2, 
     &          MAXSIZ=1000, MISS=-9999)

      integer iter, wrk2
      integer currf, currm, fin, gran1, gran2, gran3, gran4, sta
      integer nmark, hset(MAXSIZ,MAXHAP,2)

      integer nchoice, choice(MAXSIZ)

      integer i, it, kids, maxit, nerr, nrec
      integer id1, id2, id3, loc1, loc2, loc3, pos1, pos2, tmp, type
      integer oall1, oall2, whp1, whp2, whgp1, whgp2
      logical gp1, gp2, gp3, gp4, s1

      integer hicount, hicrit, minstart, nconverge, starts
      integer bestcrit, newcrit, oldcrit
      real rate, temp
C functions
      integer irandom
      logical metrop
C
C Only visit useful individuals
C
      nchoice=0
      if (gran1.ne.MISS) then
        call addhap(gran1,nmark,hset,nchoice,choice,gp1)
        call addhap(gran2,nmark,hset,nchoice,choice,gp2)
      else
        gp1=.false.
        gp2=.false.
      end if
      if (gran3.ne.MISS) then
        call addhap(gran3,nmark,hset,nchoice,choice,gp3)
        call addhap(gran4,nmark,hset,nchoice,choice,gp4)
      else
        gp3=.false.
        gp4=.false.
      end if
C Always include parents
      nchoice=nchoice+1
      choice(nchoice)=currf
      nchoice=nchoice+1
      choice(nchoice)=currm
C
C Mark start of children's IDs in choice()
C
      kids=nchoice+1
      do 2 i=sta,fin
        call addhap(i,nmark,hset,nchoice,choice,s1)
    2 continue
C
C maxit is maximum number of iterations of SA search algorithm
C and controls the cooling schedule: rate
C
C pos1 and pos2 are the boundaries of the region currently being worked on
C (sliding window which traverses the whole region repeatedly)
C
C The stopping criterion is a failure to improve for nconverge proposals
C
C The SA algorithm is restarted a minimum of minstart occasions, since the
C solution space is multimodal, and the best criterion found in the
C 1st minstart iterations is then read back from wrk2
C
C wrk2 is the stream for the scratch file where solutions from each 
C iteration are stored.
C
      rewind(wrk2)

      bestcrit=0
      minstart=5
      maxit=iter*nmark*nchoice
      nconverge=50*nmark*nchoice
      oldcrit=0
      pos1=1
      pos2=min(nmark,5)
      rate=0.02**(2.0/float(maxit))
C
C Loop to minimize recmin criterion
C Tries minstart restarts
C
      starts=0
    4 continue

      starts=starts+1
C zero out imputed haplotypes
      call delhap(currf,nmark,hset)
      call delhap(currm,nmark,hset)
      if (gp1) call delhap(gran1,nmark,hset)
      if (gp2) call delhap(gran2,nmark,hset)
      if (gp3) call delhap(gran3,nmark,hset)
      if (gp4) call delhap(gran4,nmark,hset)

      hicount=0
      hicrit=0
      temp=20.0

      it=0
    5 continue
        it=it+1
C
C Generate proposal: either 1,2,3 switches of origin,
C or impute one or two parental alleles based on a child
C
        type=irandom(1,5)
        if (type.lt.4) then
          id1=choice(irandom(1,nchoice))
          loc1=irandom(pos1,pos2)
          call shuffhap(id1,loc1,hset)
          if (type.ge.2) then
            id2=choice(irandom(1,nchoice))
            loc2=irandom(pos1,pos2)
            call shuffhap(id2,loc2,hset)
            if (type.eq.3) then
              id3=choice(irandom(1,nchoice))
              loc3=irandom(pos1,pos2)
              call shuffhap(id3,loc3,hset)
            end if
          end if
        else
C Pick an index person with included parents
   10     continue
            id1=choice(irandom(kids-2,nchoice))
          if ((id1.eq.currf .and. .not.gp1) .or. 
     &        (id1.eq.currm .and. .not.gp3)) goto 10
          loc1=irandom(pos1,pos2)
          whp1=irandom(1,2)
          whgp1=irandom(1,2)
          if (id1.eq.currf) then
            id2=gran1
            id3=gran2
          elseif (id1.eq.currm) then
            id2=gran3
            id3=gran4
          else
            id2=currf
            id3=currm
          end if
          if (whp1.eq.2) then
            tmp=id2
            id2=id3
            id3=tmp
          end if
          oall1=hset(id2,loc1,whgp1)
          if (oall1.lt.KNOWN) then
            hset(id2,loc1,whgp1)=-abs(hset(id1,loc1,whp1))
          end if
          if (type.eq.5) then
            whp2=3-whp1
            whgp2=irandom(1,2)
            oall2=hset(id3,loc1,whgp2)
            if (oall2.lt.KNOWN) then
              hset(id3,loc1,whgp2)=-abs(hset(id1,loc1,whp2))
            end if
            if (whp1.eq.2) call shuffhap(id1,loc1,hset)
          end if 
        end if
C Calculate criterion
        newcrit=0
C grandparents v. parents
        if (gp1) then
          call scorerec(gran1,currf,1,nmark,hset,nrec,nerr,newcrit)
        end if
        if (gp2) then
          call scorerec(gran2,currf,2,nmark,hset,nrec,nerr,newcrit)
        end if
        if (gp3) then
          call scorerec(gran3,currm,1,nmark,hset,nrec,nerr,newcrit)
        end if
        if (gp4) then
          call scorerec(gran4,currm,2,nmark,hset,nrec,nerr,newcrit)
        end if
C parents v. children
        do 60 i=kids, nchoice
          call scorerec(currf,choice(i),1,nmark,hset,nrec,nerr,newcrit)
   60   continue
        do 70 i=kids, nchoice
          call scorerec(currm,choice(i),2,nmark,hset,nrec,nerr,newcrit)
   70   continue
C
C Test if (still) at a local or global minumum
C
        if (newcrit.gt.hicrit) then
          hicrit=newcrit
          hicount=1
        elseif (newcrit.eq.hicrit) then
          hicount=hicount+1
        end if
C
C Reverse proposal if worsens fit criterion, else accept new model
C
        if (metrop(newcrit,oldcrit,temp)) then
          oldcrit=newcrit
        else
          if (type.lt.4) then
            call shuffhap(id1,loc1,hset)
            if (type.ge.2) then
              call shuffhap(id2,loc2,hset)
              if (type.eq.3) call shuffhap(id3,loc3,hset)
            end if
          else
            hset(id2,loc1,whgp1)=oall1
            if (type.eq.5) then
              hset(id3,loc1,whgp2)=oall2
              if (whp1.eq.2) call shuffhap(id1,loc1,hset)
            end if
          end if
        end if

        if (mod(it,10*nchoice).eq.0) then
          pos2=pos2+1
          if (pos2.gt.nmark) then
            pos2=min(5,nmark)
            pos1=1
          else
            pos1=pos1+1
          end if
        end if

        temp=rate*temp
C
C End of while loop: stop if stuck or maximum iterations exceeded
C
      if (it.le.maxit .and. hicount.le.nconverge) goto 5

      if (oldcrit.gt.bestcrit) bestcrit=oldcrit
      write(wrk2) oldcrit, hset

      if (starts.le.minstart) goto 4

      write(*,'(a,i5,a/)') '(Recmin criterion=',bestcrit,')' 
C
C Retrieve best solution
C
      rewind(wrk2)
  100 continue
        read(wrk2) oldcrit, hset
      if (oldcrit.lt.bestcrit) goto 100

      return
      end
C end-of-recmin
C
C Metropolis crit allowing for overflow/underflow
C
      logical function metrop(new,old,temp)
      integer new, old
      real temp
      real ratio
C functions
      real random
      if (new.ge.old) then
        metrop=.true.
        return
      end if
      ratio=float(new-old)/temp
      if (ratio.gt.-8.0) then
        metrop=(random().lt.exp(ratio))
      else
        metrop=.false.
      end if
      return
      end
C end-of-metrop
C
C shuffle alleles between haplotype
C
      subroutine shuffhap(idx,target,hset)
      integer MAXLOC, MAXHAP, MAXSIZ, MISS
      parameter(MAXLOC=120, MAXHAP=MAXLOC/2, MAXSIZ=1000, MISS=-9999)

      integer idx, target
C Haplotypes
      integer hset(MAXSIZ,MAXHAP,2)
      integer tmp

      tmp=hset(idx,target,1)
      hset(idx,target,1)=hset(idx,target,2)
      hset(idx,target,2)=tmp
      return
      end
C end-of-shuffhap
C
C check if useful genotypes and add to list
C
      subroutine addhap(idx,nmark,hset,nchoice,choice,use)
      integer KNOWN, MAXLOC, MAXHAP, MAXSIZ, MISS
      parameter(KNOWN=0, MAXLOC=120, MAXHAP=MAXLOC/2, 
     &          MAXSIZ=1000, MISS=-9999)
      integer idx
C Haplotypes
      integer nmark, hset(MAXSIZ,MAXHAP,2)
      integer nchoice, choice(MAXSIZ)
      logical use

      call usehap(idx,nmark,hset,use)
      if (use) then
        nchoice=nchoice+1
        choice(nchoice)=idx
      end if
      return
      end
C end-of-addhap
C
C check if useful genotypes
C
      subroutine usehap(idx,nmark,hset,use)
      integer KNOWN, MAXLOC, MAXHAP, MAXSIZ
      parameter(KNOWN=0, MAXLOC=120, MAXHAP=MAXLOC/2, MAXSIZ=1000)
      integer idx
C Haplotypes
      integer nmark, hset(MAXSIZ,MAXHAP,2)
      logical use

      integer j

      use=.false.
      do 10 j=1,nmark
      if (hset(idx,j,1).gt.KNOWN) then
        use=.true.
        return
      end if
   10 continue

      return
      end
C end-of-usehap
C
C zero imputed haplotypes
C
      subroutine delhap(idx,nmark,hset)
      integer KNOWN, MAXLOC, MAXHAP, MAXSIZ, MISS
      parameter(KNOWN=0, MAXLOC=120, MAXHAP=MAXLOC/2, 
     &          MAXSIZ=1000, MISS=-9999)
      integer idx
C Haplotypes
      integer nmark, hset(MAXSIZ,MAXHAP,2)

      integer j

      do 10 j=1,nmark
      if (hset(idx,j,1).lt.KNOWN) then
        hset(idx,j,1)=MISS
        hset(idx,j,2)=MISS
      end if
   10 continue

      return
      end
C end-of-delhap
C
C score match of parental haplotypes to child haplotype: 
C  length of matched haplotype and number of recombinants
C
      subroutine scorerec(parent,child,orig,nmark,hset,nrec,nerr,match)
      integer KNOWN, MAXLOC, MAXHAP, MAXSIZ, MISS
      parameter(KNOWN=0, MAXLOC=120, MAXHAP=MAXLOC/2, 
     &          MAXSIZ=1000, MISS=-9999)

      integer  child, orig, nerr, nrec, parent, match 
C Haplotypes
      integer nmark, hset(MAXSIZ,MAXHAP,2)
      integer contrib, gpar, j, source
C functions
      integer gpsrc

      contrib=0
      nerr=0
      nrec=0
      source=0
      do 10 j=1,nmark
      if (hset(child,j,orig).ne.MISS) then
C
C score for number of known or imputed genotypes
C penalise imputed homozygous genotypes
C
        contrib=contrib+2
        if (hset(parent,j,1).ne.MISS) then
          contrib=contrib+1
          if (hset(parent,j,1).lt.KNOWN .and. 
     &        hset(parent,j,1).eq.hset(parent,j,2)) then
            contrib=contrib-1
          end if
        end if
        if (hset(parent,j,2).ne.MISS) then
          contrib=contrib+1
        end if
C
C Count recombinants and errors/mutations
C
        gpar=gpsrc(parent,child,orig,j,hset)
        if (gpar.eq.3) then
          nerr=nerr+1
        elseif (gpar.ne.0) then
          if (source.ne.0 .and. gpar.ne.source) nrec=nrec+1
          source=gpar
        end if
      end if
   10 continue
      match=match+contrib-3*nrec-10*nerr
      return
      end
C end-of-scorerec
C
C Count recombination and "mutation" events: write number as string 
C (same length as a genotype, so looks nice in output)
C
      subroutine recnum(child,currf,currm,nmark,hset,str)
      integer KNOWN, MAXLOC, MAXHAP, MAXSIZ, MISS
      parameter(KNOWN=0, MAXLOC=120, MAXHAP=MAXLOC/2, 
     &          MAXSIZ=1000, MISS=-9999)

      integer currf,currm,child
      character*7 str
      integer nmark, hset(MAXSIZ,MAXHAP,2)

      integer dum, materr, matrec, nerr, nrec, paterr, patrec
      character*1 ch

      dum=0
      call scorerec(currf,child,1,nmark,hset,patrec,paterr,dum)
      call scorerec(currm,child,2,nmark,hset,matrec,materr,dum)
      nerr=paterr+materr
      nrec=patrec+matrec
      if (nerr.gt.0) then
        ch='*'
      elseif (nrec.gt.0) then
        ch='+'
      else
        ch=' '
      end if
      write(str,'(a1,a1,i1,a1,i1,a1,a1)') ch,'[',nrec,';',nerr,']',ch

      return
      end
C end-of-recnum
C
C check for simple inconsistencies between child and parent
C
      subroutine check2(pedigree,eop,currf,currm,sta,fin,id,
     &                  nmark,mark,loc,hset)
      integer KNOWN, MAXLOC,MAXHAP,MAXSIZ,MISS
      parameter (KNOWN=0,MAXLOC=120, MAXHAP=MAXLOC/2,
     &           MAXSIZ=1000,MISS=-9999)

      integer currf, currm, eop, fin, sta
C Pedigree structure
      character*10 pedigree
      character*8 id(MAXSIZ) 
      integer hset(MAXSIZ,MAXHAP,2)
C
C Locus names and list of marker loci
      character*10 loc(MAXLOC)
      integer nmark, mark(MAXHAP)
C
C count of segregating alleles
      integer nall, allele(4)
C parental phenoset
      integer nset, p1(5,2), p2(5,2)
C other local variables
      integer c1,c2,i,j,p11,p12,p21,p22
      logical anyerr, err, thiserr, xmale
      character*7 gtp
C functions
      integer eow, parcon
      logical opcon
C
      xmale=.false.

      anyerr=.false.
      do 10 j=1,nmark
        err=.false.
        p11=hset(currf,j,1)
        p12=hset(currf,j,2)
        call order(p11,p12)
        p21=hset(currm,j,1)
        p22=hset(currm,j,2)
        call order(p21,p22)
        nall=0
        ptyped=0
        if (p11.gt.KNOWN) then
          ptyped=ptyped+1
          call addall(p11,nall,allele)
          call addall(p12,nall,allele)
        end if
        if (p21.gt.KNOWN) then
          ptyped=ptyped+2
          call addall(p21,nall,allele)
          call addall(p22,nall,allele)
        end if
Cx      if (ptyped.ne.3) then
Cx        nset=0
Cx        call initp(p1,p2)
Cx      end if
C do each typed child in the sibship
        do 20 i=sta,fin
        if (hset(i,j,1).gt.KNOWN) then
          thiserr=.false.
          c1=hset(i,j,1)
          c2=hset(i,j,2)
          call order(c1,c2)
C test for simple parent-offspring inconsistency
          if ((ptyped.eq.3 .and.
     2         parcon(c1,c2,p11,p12,p21,p22,xmale).eq.0) .or.
     3        (ptyped.eq.1 .and. .not.opcon(c1,c2,p11,p12)) .or.
     4        (ptyped.eq.2 .and. .not.opcon(c1,c2,p21,p22))) then
            thiserr=.true.
C or too many alleles segregating in sibship
          else
            call addall(c1,nall,allele)
            call addall(c2,nall,allele)
            if (nall.gt.4) then
              thiserr=.true.
C else test for more complex errors
Cx          elseif (.not.err .and. ptyped.ne.3) then
Cx            call nucheck(c1,c2,xmale,nset,p1,p2,thiserr)
            end if
          end if
C If an error, note the responsible child
          if (thiserr) then
            err=.true.
            call wrgtp(c1,c2,gtp,1)
            write(*,'(9a)') 'NOTE:  Inconsistency due child ',
     2        pedigree(1:eop),'-',id(i)(1:eow(id(i))),
     3        ' at locus ',loc(mark(j)),' {',gtp,'}'
          end if
        end if
   20   continue
        if (err) anyerr=.true.
   10 continue

      if (anyerr) write(*,*)
      return
      end
C end-of-check2
C
C Write a trait value as a seven-character string
C
      subroutine wraff7(value,string)
      real value
      character*7 string
      if (value.eq.1.0) then
        string='  UnA  '
      elseif (value.eq.2.0) then
        string='  Aff  '
      else
        string='   ?   '
      end if
      return
      end
C end-of-wraff7
C
C Assess grandparental origin of allele
C
      integer function gpsrc(parent,child,orig,loc,hset)
      integer MAXLOC, MAXHAP, MAXSIZ, MISS
      parameter(MAXLOC=120, MAXHAP=MAXLOC/2, MAXSIZ=1000, MISS=-9999)

      integer  child, loc, orig, parent
C Haplotypes
      integer hset(MAXSIZ,MAXHAP,2)

      integer c1, p1, p2

      gpsrc=0
      c1=abs(hset(child,loc,orig))
      if (-c1.eq.MISS) return

      p1=abs(hset(parent,loc,1))
      p2=abs(hset(parent,loc,2))
      if (c1.eq.p1 .and. c1.ne.p2) then
        gpsrc=1
      elseif (c1.eq.p2 .and. c1.ne.p1) then
        gpsrc=2
      elseif (-p1.ne.MISS .and. c1.ne.p1 .and.
     &        -p2.ne.MISS .and. c1.ne.p2) then
        gpsrc=3
      end if
      return
      end
C end-of-gpsrc
C
C Search for best haplotypes based on simple sharing criterion.
C Called either as preliminary to recmin or in own right.
C Imputes missing parental haplotypes in simple-minded fashion.
C
      subroutine maxshare(currf,currm,gran1,gran2,gran3,gran4,
     &                    sta,fin,iter,nmark,hset)
      integer KNOWN, MAXHAP, MAXLOC, MAXSIZ, MISS
      parameter(KNOWN=0, MAXLOC=120, MAXHAP=MAXLOC/2, MAXSIZ=1000, 
     &          MISS=-9999)

      integer currf, currm, fin, gran1, gran2, gran3, gran4, iter, sta
      integer nmark, hset(MAXSIZ,MAXHAP,2)

      integer nchoice, choice(MAXSIZ)

      integer i, it, j, kids, maxit, newcrit, oldcrit
      integer id1, id2, loc1, loc2, type
      logical gp1, gp2, gp3, gp4, p1, p1imp, p2, p2imp, s1
      real rate, temp
C functions
      integer irandom
      logical metrop
C
C Only visit useful individuals
C
      nchoice=0
      if (gran1.ne.MISS) then
        call addhap(gran1,nmark,hset,nchoice,choice,gp1)
        call addhap(gran2,nmark,hset,nchoice,choice,gp2)
      else
        gp1=.false.
        gp2=.false.
      end if
      if (gran3.ne.MISS) then
        call addhap(gran3,nmark,hset,nchoice,choice,gp3)
        call addhap(gran4,nmark,hset,nchoice,choice,gp4)
      else
        gp3=.false.
        gp4=.false.
      end if
      
      call addhap(currf,nmark,hset,nchoice,choice,p1)
      call addhap(currm,nmark,hset,nchoice,choice,p2)

C
C Mark start of children's IDs in choice()
C
      kids=nchoice+1
      do 2 i=sta,fin
        call addhap(i,nmark,hset,nchoice,choice,s1)
    2 continue

      maxit=max(200,iter)*nmark*nchoice/4
      oldcrit=0
      rate=0.02**(2.0/float(maxit))
      temp=100.0

      do 5 it=1,maxit
C
C Generate proposal: either a single switch or double switch of origin
C
      type=irandom(1,2)
      id1=choice(irandom(1,nchoice))
      loc1=irandom(1,nmark)
      call shuffhap(id1,loc1,hset)
      if (type.eq.2) then
        id2=choice(irandom(1,nchoice))
        loc2=irandom(1,nmark)
        call shuffhap(id2,loc2,hset)
      end if
C Calculate criterion
      newcrit=0
C grandparents v. parents
      if (gp1) then
        call hmatch(gran1,currf,1,1,4,nmark,hset,newcrit)
        call hmatch(gran1,currf,2,1,4,nmark,hset,newcrit)
        if (.not.p1) then
          do 20 i=kids, nchoice
            call hmatch(currf,choice(i),1,1,10,nmark,hset,newcrit)
            call hmatch(currf,choice(i),2,1,10,nmark,hset,newcrit)
   20     continue
        end if
      end if
      if (gp2) then
        call hmatch(gran2,currf,1,2,4,nmark,hset,newcrit)
        call hmatch(gran2,currf,2,2,4,nmark,hset,newcrit)
        if (.not.p1) then
          do 30 i=kids, nchoice
            call hmatch(currf,choice(i),1,1,10,nmark,hset,newcrit)
            call hmatch(currf,choice(i),2,1,10,nmark,hset,newcrit)
   30     continue
        end if
      end if
      if (gp3) then
        call hmatch(gran3,currm,1,1,4,nmark,hset,newcrit)
        call hmatch(gran3,currm,2,1,4,nmark,hset,newcrit)
        if (.not.p2) then
          do 40 i=kids, nchoice
            call hmatch(currf,choice(i),1,2,10,nmark,hset,newcrit)
            call hmatch(currf,choice(i),2,2,10,nmark,hset,newcrit)
   40     continue
        end if
      end if
      if (gp4) then
        call hmatch(gran4,currm,1,2,4,nmark,hset,newcrit)
        call hmatch(gran4,currm,2,2,4,nmark,hset,newcrit)
        if (.not.p2) then
          do 50 i=kids, nchoice
            call hmatch(currf,choice(i),1,2,10,nmark,hset,newcrit)
            call hmatch(currf,choice(i),2,2,10,nmark,hset,newcrit)
   50     continue
        end if
      end if
C parents v. children
      if (p1) then
        do 60 i=kids, nchoice
          call hmatch(currf,choice(i),1,1,10,nmark,hset,newcrit)
          call hmatch(currf,choice(i),2,1,10,nmark,hset,newcrit)
   60   continue
      end if
      if (p2) then
        do 70 i=kids, nchoice
          call hmatch(currm,choice(i),1,2,10,nmark,hset,newcrit)
          call hmatch(currm,choice(i),2,2,10,nmark,hset,newcrit)
   70   continue
      end if
C children v. children
      do 80 i=kids, nchoice-1
      do 80 j=i+1, nchoice
        call hmatch(choice(i),choice(j),1,1,1,nmark,hset,newcrit)
        call hmatch(choice(i),choice(j),2,2,1,nmark,hset,newcrit)
   80 continue
C
C Reverse proposal if worsens fit criterion, else accept new model
C
      if (metrop(newcrit,oldcrit,temp)) then
        oldcrit=newcrit
      else
        call shuffhap(id1,loc1,hset)
        if (type.eq.2) call shuffhap(id2,loc2,hset)
      end if

      temp=rate*temp
C
    5 continue
C
C Impute missing parental genotypes where possible
C Note when there are preexisting imputed genotypes from other marriages
C
      p1imp=.false.
      p2imp=.false.
      do 100 j=1,nmark
        if (.not.p1imp .and. 
     2      (hset(currf,j,1).gt.MISS .and. hset(currf,j,1).lt.KNOWN).or.
     3      (hset(currf,j,2).gt.MISS .and. hset(currf,j,2).lt.KNOWN)) 
     4  then
          p1imp=.true.
        end if
        if (.not.p2imp .and. 
     2      (hset(currm,j,1).gt.MISS .and. hset(currm,j,1).lt.KNOWN).or.
     3      (hset(currm,j,2).gt.MISS .and. hset(currm,j,2).lt.KNOWN)) 
     4  then
          p2imp=.true.
        end if
C Impute paternal alleles based on these children
        if (hset(currf,j,1).eq.MISS .or. hset(currf,j,2).eq.MISS) then
          do 110 i=kids, nchoice
          if (hset(choice(i),j,1).ne.MISS) then
            if (hset(currf,j,1).eq.MISS) then
              hset(currf,j,1)=-hset(choice(i),j,1)
            elseif (hset(currf,j,2).eq.MISS .or. 
     &              hset(currf,j,1).eq.hset(currf,j,2)) then
              hset(currf,j,2)=-hset(choice(i),j,1)
            end if
          end if
  110     continue
        end if
C Impute maternal alleles based on these children
        if (hset(currm,j,1).eq.MISS .or. hset(currm,j,2).eq.MISS) then
          do 120 i=kids, nchoice
          if (hset(choice(i),j,2).ne.MISS) then
            if (hset(currm,j,1).eq.MISS) then
              hset(currm,j,1)=-hset(choice(i),j,2)
            elseif (hset(currm,j,2).eq.MISS .or. 
     &              hset(currm,j,1).eq.hset(currm,j,2)) then
              hset(currm,j,2)=-hset(choice(i),j,2)
            end if
          end if
  120     continue
        end if
  100 continue
C
      if (p1imp) then
        write(*,'(2a/)') 'NOTE:  Some paternal alleles were imputed ',
     &                   'via another marriage.'
      end if
      if (p2imp) then
        write(*,'(2a/)') 'NOTE:  Some maternal alleles were imputed ',
     &                   'via another marriage.'
      end if
C     
      return
      end
C end-of-maxshare
C
C score match of haplotype 1 to haplotype 2: length of match as well as
C absolute number of matches
C
      subroutine hmatch(id1,id2,orig1,orig2,mult,nmark,hset,match)
      integer MAXHAP, MAXLOC, MAXSIZ, MISS
      parameter(MAXLOC=120, MAXHAP=MAXLOC/2, MAXSIZ=1000, MISS=-9999)

      integer id1, id2, match, mult, orig1, orig2
C Haplotypes
      integer nmark, hset(MAXSIZ,MAXHAP,2)
      integer contrib, j, weight

      contrib=0
      weight=0
      do 10 j=1,nmark
      if (hset(id1,j,orig1).eq.hset(id2,j,orig2)) then
        weight=weight+1
        contrib=contrib+weight
      elseif (hset(id1,j,orig1).ne.MISS .and. 
     &        hset(id2,j,orig2).ne.MISS) then
        weight=weight/2
      end if
   10 continue
      match=match+mult*contrib
      return
      end
C end-of-hmatch

C
C perform sibship association permutation test
C
      subroutine sibship(wrk,wrk2,trait,gene,mche,iter,mincnt,weight,
     2                   pedigree,num,nfound,id,fa,mo,sex,locus,
     3                   numloc,numal,name,set,plevel)
C
      integer KNOWN, MAXALL, MAXG, MAXSIZ, MAXLOC, MISS
      parameter(KNOWN=0, MAXALL=60, MAXG=MAXALL*(MAXALL+1)/2, 
     &          MAXSIZ=1000, MAXLOC=120, MISS=-9999)
      integer gene,iter,mincnt,plevel,trait,weight,wrk,wrk2
      logical mche
C  Pedigree structure
      character*10 pedigree
      integer num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ)
      integer sex(MAXSIZ)
      integer numloc
      real locus(MAXSIZ,MAXLOC)
C allele frequencies structure
      integer numal, name(MAXALL)
C array for allele counts in cases and controls
      integer cntall(MAXG,4)
C work arrays for counts and MC iteration
      integer aff(MAXSIZ),set(MAXSIZ,2)
C local variables
      integer contrib,gen2,i,it,j,k,nuntyp
      integer currf, currm, fin, nfam, sta, tailp
      logical last
C functions
      integer getnam
      double precision hibd, probst, regwt
C
      gen2=gene+1
      do 2 j=1,numal  
      do 2 k=1,3
        cntall(j,k)=0
    2 continue
      nfam=0
      nuntyp=0
      last=.false.
      rewind(wrk)
    5 continue
        call wrkin(wrk,pedigree,num,nfound,id,fa,mo,sex,locus,numloc,
     &             last)
        if (last) goto 20
C
C Full sibs
C
        famdf=0
        fin=num
        currf=fa(fin)
        currm=mo(fin)
        do 10 k=num-1,nfound,-1
          if (fa(k).ne.currf .or. mo(k).ne.currm) then
            contrib=0
            do 12 i=k+1,fin
            if (locus(i,trait).ne.MISS) then
              if (locus(i,gene).lt.KNOWN) then
                nuntyp=nuntyp+1
              else
                contrib=contrib+1
                aff(contrib)=int(isaff(locus(i,trait),thresh,gt))
                set(contrib,1)=getnam(locus(i,gene),numal,name)
                set(contrib,2)=getnam(locus(i,gen2),numal,name)
              end if
            end if
   12       continue
C
C Skip if no usable individuals in this sibship
C
            if (contrib.gt.1) then
              nfam=nfam+1
              do 14 i=1,contrib
                cntall(set(i,1),aff(i))=cntall(set(i,1),aff(i))+1
                cntall(set(i,2),aff(i))=cntall(set(i,2),aff(i))+1
   14         continue
              write(wrk2) contrib,(aff(i),set(i,1),set(i,2),i=1,contrib)
            end if
C Now update to next sibship
            fin=k
            currf=fa(fin)
            currm=mo(fin)
          end if
   10   continue
C mark end of sibships in current pedigree
      goto 5
   20 continue

      write(*,'(/a/a/a)') 
     2  '  --------- Sibship Permutation Analysis --------',
     3  '    Allele   Affected   Unaffected   Total    Dev',
     4  '  -----------------------------------------------'
      do 25 i=1,numal
        nco=nco+cntall(i,1)
        nca=nca+cntall(i,2)
   25 continue
      pexp=dfloat(nca)/dfloat(nca+nco)
      if (nca.eq.0) then
        casden=1.0
      else
        casden=float(nca)
      end if
      if (nco.eq.0) then
        conden=1.0
      else
        conden=float(nco)
      end if
      do 30 i=1,numal  
        cntall(i,3)=cntall(i,1)+cntall(i,2)
        if (cntall(i,3).gt.0) df=df+1
        write(*,'(i8,2(2x,i5,1x,a1,f3.2,a1),i8,1x,f6.1)') 
     2   name(i),cntall(i,2),'(',float(cntall(i,2))/casden,')',
     3   cntall(i,1),'(',float(cntall(i,1))/conden,')',cntall(i,3),
     4   binz(cntall(i,2),cntall(i,3),pexp)
   30 continue
      write(*,'(a/a8,2(2x,i5,6x),i8)') 
     2  '  -----------------------------------------------',
     3    'Total',nca,nco,nca+nco
      ochisq=twobyk(numal,cntall,pexp)

      write(*,'(3(/a,i6)') 
     2  '       No. trait(+) marker(-) =',nuntyp,
     3  '       No. trait(+) marker(+) =',(nca+nco)/2,
     4  '          No. useful sibships =',nfam 
      write(*,'(a,f6.1/a,i4/a,3x,f6.4)')
     2  '   Contingency Pearson chi-sq =',ochisq,
     3  '   Nominal degrees of freedom =',df,
     4  '              Nominal P-value =',chip(ochisq,df)
C
C MC P-value estimation
C
      if (iter.eq.0 .or. nfam.lt.1) return
C
C Now can simulate genotypes and do sequential P-value simulation
C
      it=0
      tailp=0
   49 continue
      if (it.eq.iter .or. tailp.eq. mincnt) goto 50
        it=it+1
        do 52 j=1,numal  
        do 52 k=1,3
          cntall(j,k)=0
   52   continue
        rewind(wrk2)
   55   continue
          read(wrk2,end=70) contrib,
     &      (aff(i),set(i,1),set(i,2),i=1,contrib)
          call setperm(contrib,set)
          do 65 i=1,num
          if (.not.untyped(i).and.(aff(i).eq.1.or.aff(i).eq.2)) then
            cntall(set(i,1),aff(i))=cntall(set(i,1),aff(i))+1
            cntall(set(i,2),aff(i))=cntall(set(i,2),aff(i))+1
          endif
   65     continue
        goto 55
   70   continue

        do 80 i=1,numal  
          cntall(i,3)=cntall(i,1)+cntall(i,2)
   80   continue
        chisq=twobyk(numal,cntall,pexp)
        call moment(it,chisq,mchisq,vchisq)
        if (chisq.gt.ochisq .or. (chisq.eq.ochisq .and.
     2      random().gt.0.5)) 
     3  then
          tailp=tailp+1
        end if
        if (plevel.gt.1) then
          write(*,'(/a,i4,a,f6.1)') 
     &      'Pseudosample ',it,': Chisq=',chisq
          do 85 i=1,numal
            write(*,'(i8,2(2x,i5,1x,a1,f3.2,a1),i8)') 
     2        name(i),cntall(i,2),'(',float(cntall(i,2))/float(nca),')',
     3        cntall(i,1),'(',float(cntall(i,1))/float(nco),')',
     4        cntall(i,3)
   85     continue
        end if
        goto 49
   50   continue
C   
        if (tailp.lt.mincnt) then
          tailp=tailp+1
          it=it+1
        end if
        vchisq=vchisq/dfloat(max(1,it-1))
        write(*,'(a,i4,a,i5,a,f6.4,a/a,f6.1,a,f6.1,a)')
     2    '      Equalled or exceeded by =',tailp,'/',it,
     3    ' simulated values (',dfloat(tailp)/dfloat(it),')',
     4    ' Mean (Var) simulated chi-sqs =',mchisq,' (',vchisq,')'
      return
      end
C end-of-sibship
C
C Permute alleles of genotypes for set of sibs
C
      subroutine setperm(num,set)
      integer MAXSIZ
      parameter(MAXSIZ=1000)
      integer num  
      integer set(MAXSIZ,2)
C 
      integer i, swap, toa, tmp
C functions
      integer irandom

      do 20 i=1,num
      do 20 j=1,2
        swap=irandom(1,num)
        toa=irandom(1,2)
        tmp=set(swap,toa)
        set(swap,toa)=set(i,j)
        set(i,j)=tmp
   20 continue
      return
      end
C end-of-setperm

C |||| SIB-PAIR: A program for simple genetic analysis
C |\/| Version : HEAD_TXT
C |/\| Author  : David L Duffy (c) 1995-2003
C ||||
C Program SIB-PAIR imputes missing parental genotypes where unequivocal
C and does TDT,APM, association and sib-pair analyses.
C Data is read from a GAS type datafile.
C
C C-Preprocessor (ifdef) statements are used to select
C platform specific features: the non-F77-standard time, date and
C iand functions.
C
C
      integer INSTRM,CSTRM,OSTR,OSTR2,WRK,WRK2,TWRK
      parameter(INSTRM=3,CSTRM=4,OSTR=7,OSTR2=8,WRK=1,WRK2=2,TWRK=8)
C
C job control indicators:
C cutoff=min cell size to use in TDT, iter=#Monte Carlo iterations,
C burnin=#prelim MCMC iterations, mincnt=min numerator for MC P-value
C fraction, imp=level of imputation missing vals, gene=col of current gene,
C plevel=print level, showorig=detail on haplotyping output,
C trait=col of current trait, wrknum=ver of workfile,
C typ=ibd or ibs for APM etc, parental contrib for TDT,
C twomark=markers for 3-pt, H-E regression, th1, th2, th12 the thetas.
C sibr the full-sib trait correlation for S&P regression
C sibm, sibv the trait mean and variance for S&P regression
C
C addsex=sex as dummy quant trait, assfnd=assoc in founders only,
C chek=check mendelisms, droperr=delete genotypes causing mendelian errors,
C famerr=error in pedigree structure, fndr=freq in founders only, 
C gt=side of threshhold, loconly=including locus information only,
C last=last pedigree, link=Linkage format, prompt=show a prompt,
C red=file read, mche=MC P-val for H-E regression,
C use2=restrict TDT to cases both parents typed, 
C xlin xlinkd=x-linked markers
C
      logical addsex, assfnd, chek, echo, famerr, filexist,
     &   gt, last, link, loconly, prompt, red, mche, xlinkd
      integer burnin, iter, mincnt
      integer cutoff, droperr, fndr, imp, gene, mapf, nwarn,
     &   plevel, prob, showorig, trait, typ, use2, wrknum, xlin
      integer twomark(2)
      real sibm, sibr, sibv, th1, th2, th12, thresh
C
C input stream (ilevel =1 stdin or =2 include file)
C workfile directory and files
C
      integer ilevel
      character*40 version
      character*72 datdir,wrkdir 
      character*144 infil,outfil,pedfil,wrkfil,wrk2fil
C
C Various counts:
C nfam=sibships in pedigree, nobs=total subjects, nped=pedigrees, 
C nships=total sibships, tfound=total founders, inconsist=problems,
C badfam=number of discarded families, badnum=number of discarded records,
C ndiscard=number of discarded genotypes (caused inconsistencies)
C imputd=imputed genotypes, typed=no. typed at marker, ntyped=no. any genotype
C tottyp=total number of genotypes in data
C biggest=size of largest ped, deepest=largest number of generations,
C totgen=accum generations per family, onemem=number of families with 
C only 1 member, onegen=number of families with only 1 generation.
C
      integer nfam,nobs,nped,nships,tfound 
      integer badfam, badnum, inconsist, imputd, ndiscard
      integer biggest,deepest,ntyped,onegen,onemem,totgen,tottyp,typed
C
C Pedigree structure:
C pedigree name; selected; size; no. of founders; individual ids & sexes; 
C pointers to parental ids; 
C trait and genotype values; number of values;
C depth (number of generations)
C
C LINSIZ=input buffer size (chars)
C MAXALL=maximum number of alleles; MAXG=maximum number of genotype
C MAXSIZ=maximum pedigree size; MAXLOC=maximum number of columns used
C by loci (so MAXLOC/2 maximum for codom markers); MISS=missing data
C point placeholder; LOT=all loci; MAXCOL=max columns for id + loci;
C HAPSIZ=haplotype array size, WRKSIZ=phenoset array size,
C MAXIBD=maximum pedigree size for relative-pairwise statistics
C IBDSIZ=maximum array size for relative-pairwise statistics
C MAXTER=maximum number of variables for regression etc
C MAXCOV=maximum size of covariance matrix of variables
C
      integer HAPSIZ, IBDSIZ, LINSIZ, MAXALL, MAXCOL, MAXCOV, MAXG,
     &        MAXHAP,  MAXIBD, MAXLOC, MAXSIZ, MAXTER, MISS, WRKSIZ
      parameter(LINSIZ=1024, MAXALL=60, MAXG=MAXALL*(MAXALL+1)/2, 
     2   MAXSIZ=1000, MAXLOC=120, MAXHAP=MAXLOC/2, MISS=-9999, 
     3   MAXCOL=MAXLOC+5, HAPSIZ=MAXSIZ*MAXLOC, MAXIBD=1000, 
     4   IBDSIZ=MAXIBD*(MAXIBD+1)/2, MAXTER=MAXIBD/2,
     5   MAXCOV=MAXTER*(MAXTER+1)/2,  WRKSIZ=MAXSIZ*MAXG*2)
C    6   WRKSIZ=HAPSIZ+7*MAXSIZ+10*MAXG+ 5*MAXALL+ 4*IBDSIZ)
     
      character*10 pedigree
      integer actset,num,nfound 
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ),mo(MAXSIZ),sex(MAXSIZ)
      integer numloc
      real locus(MAXSIZ,MAXLOC)
      integer higen
C
C Locus structure:
C number of loci, locus name, locus type, and locus position in file
C loctyp 1=marker 2=x-marker 3=quant 4=affection 5-8=deleted
C
      integer nloci
      character*10 loc(MAXLOC)
      integer loctyp(MAXLOC),locpos(MAXLOC)
C
C position of locus on sex-averaged linkage map
C
      real map(MAXLOC)
C
C position of locus in output locus and pedigree files
C may be fewer than nloci loci for output
C
      integer nord, locord(MAXLOC)
C
C Phenoset arrays: possible genotypes for each individual in the pedigree
C
      integer ngeno,gset(MAXSIZ,MAXG,2)
C
C Storage space for haplotypes
C
      integer hset(MAXSIZ,MAXHAP,2)
C work array for quantitative values 
C notably contingency tables (equivalenced to hset)
      real vset(HAPSIZ)
C
C workspace: genotype array or list of parents or linked list...
C
      integer set(MAXSIZ,2)
C
C ibd-genotype
      integer sibd(MAXSIZ,2)
C proposed genotype array
      integer set2(MAXSIZ,2)
C list of founder alleles or sort key
C work arrays for sorting etc (equivalenced)
      integer key(2*MAXSIZ)
      integer key1(MAXSIZ), key2(MAXSIZ)
C work arrays for quantitative traits (equivalenced)
      real value(MAXSIZ)
      real valu1(MAXSIZ), valu2(MAXSIZ)
C indicate if individual typed at locus
      logical untyped(MAXSIZ)
C work arrays for sorting/listing (equivalenced) 
      integer ord(MAXSIZ)
C
C allele and genotype frequencies within entire sample for given locus 
C
      integer numal, name(MAXALL)
      double precision alfrq(MAXALL), cumfrq(MAXALL), gfrq(MAXG)
      integer numal2, name2(MAXALL)
      double precision alfrq2(MAXALL)
C
C Genotype counts: allele1,allele2, number transmitted, number not trans
C Arrays used by association and TDT analyses
C
      integer nallele,cntall(MAXG,4), ngcount,gcount(MAXG,4)
C
C mean ibd (or ibs) sharing for all relative pairs
C
      double precision ibdcount(IBDSIZ)
      double precision count2(IBDSIZ)
C
C Regression parameters and work arrays
C
      double precision x(MAXTER), r(MAXCOV), b(MAXTER), cov(MAXCOV)
C
C recode (combine alleles, adjust quant variables)
C
      integer nf
      real recto, recfro(MAXALL)
      real adjval
C
C Box-cox transformation and/or truncation of variable
C
      real divisor, hival, loval, offset, power
C
C Number of decimal digits and width in output pedigree file:
C All quantitative variables default to 9 characters
C
      integer ndec, nwid
C
C character array to initially read data into
      character*(LINSIZ) lin
      character*20 words(MAXCOL)
      character*80 bigwor(MAXCOL/4)
C
C list for evaluation of expressions (tag1,value1)...(tagNTERM,valueNTERM)
      integer nterm
      integer wtyp(MAXCOL)
      double precision expr(MAXCOL)
C
C keywords not hard coded
C
C Token name, left binding power, right binding power, operation
      integer TOKNUM
      parameter (TOKNUM=44)
      character*6 token(TOKNUM)
      integer lbp(0:TOKNUM), rbp(0:TOKNUM), op(0:TOKNUM)
C
C Environmental (automatic) variables for evaluator
      integer ENVNUM
      parameter (ENVNUM=11)
      character*6 env(ENVNUM)
C
C equivalence to reuse workspace
C Note that the reserved space may be excessive for the data type, in order
C to avoid misalignment (eg character must not force integer to start on
C an odd-byte boundary)
C
C  Array   Dimension         Type   Cumulative space (4 byt) reserved in work()
C  ------- ----------       -----   --------------------------------------------
C     gset MAXSIZ*MAXG*2    I (4)   2*MAXSIZ*MAXG
C 
C     hset MAXSIZ*MAXHAP*2  I (4)   2*MAXSIZ*MAXHAP (=HAPSIZ)
C 
C     vset MAXSIZ*MAXHAP*2  R (4)   2*MAXSIZ*MAXHAP (=HAPSIZ)
C
C     sibd 2*MAXSIZ         I (4)   HAPSIZ+2*MAXSIZ
C     set2 2*MAXSIZ         I (4)   HAPSIZ+4*MAXSIZ
C     key1 MAXSIZ           I (4)   HAPSIZ+5*MAXSIZ
C     key2 MAXSIZ           I (4)   HAPSIZ+6*MAXSIZ
C      key 2*MAXSIZ         I (4)   HAPSIZ+6*MAXSIZ
C    valu1 MAXSIZ           R (4)   HAPSIZ+5*MAXSIZ  
C    valu2 MAXSIZ           R (4)   HAPSIZ+6*MAXSIZ  
C    value MAXSIZ           R (4)   HAPSIZ+6*MAXSIZ  
C  untyped MAXSIZ           L (4)   HAPSIZ+7*MAXSIZ
C      ord MAXSIZ           I (4)   HAPSIZ+7*MAXSIZ  
C   cntall 4*MAXG           I (4)   HAPSIZ+7*MAXSIZ+ 4*MAXG
C   gcount 4*MAXG           I (4)   HAPSIZ+7*MAXSIZ+ 8*MAXG
C   recfro MAXALL           R (4)   HAPSIZ+7*MAXSIZ+ 8*MAXG+ 1*MAXALL
C    name2 MAXALL           I (4)   HAPSIZ+7*MAXSIZ+ 8*MAXG+ 1*MAXALL
C   alfrq2 MAXALL           D (8)   HAPSIZ+7*MAXSIZ+ 8*MAXG+ 3*MAXALL
C   cumfrq MAXALL           D (8)   HAPSIZ+7*MAXSIZ+ 8*MAXG+ 5*MAXALL
C     gfrq MAXG             D (8)   HAPSIZ+7*MAXSIZ+10*MAXG+ 5*MAXALL
C ibdcount IBDSIZ           D (8)   HAPSIZ+7*MAXSIZ+10*MAXG+ 5*MAXALL+ 2*IBDSIZ
C   count2 IBDSIZ           D (8)   HAPSIZ+7*MAXSIZ+10*MAXG+ 5*MAXALL+ 4*IBDSIZ 
C
C        x MAXTER           D (8)   HAPSIZ+7*MAXSIZ+10*MAXG+ 5*MAXALL+ 2*MAXTER
C        r MAXCOV           D (8)   HAPSIZ+7*MAXSIZ+10*MAXG+ 5*MAXALL+ 
C                                   2*MAXTER+2*MAXCOV
C        b MAXTER           D (8)   HAPSIZ+7*MAXSIZ+10*MAXG+ 5*MAXALL+
C                                   2*IBDSIZ+2*MAXTER
C      cov MAXCOV           D (8)   HAPSIZ+7*MAXSIZ+10*MAXG+ 5*MAXALL+
C                                   2*IBDSIZ+2*MAXTER+2*MAXCOV
C
C      lin LINSIZ           C (1)   HAPSIZ+7*MAXSIZ+10*MAXG+ 5*MAXALL+ LINSIZ
C    words 20*MAXCOL        C (1)   HAPSIZ+7*MAXSIZ+10*MAXG+ 5*MAXALL+ 
C                                   20*MAXCOL+ LINSIZ
C   bigwor 20*MAXCOL        C (1)   HAPSIZ+7*MAXSIZ+10*MAXG+ 5*MAXALL+ 
C                                   20*MAXCOL+ LINSIZ
C
      integer work(WRKSIZ)
C
      equivalence (work(1), gset(1,1,1))
      equivalence (work(1), hset(1,1,1))
      equivalence (work(1), vset(1))
C
      equivalence (work(HAPSIZ+1), sibd(1,1))
      equivalence (work(HAPSIZ+1), value(1))
      equivalence (work(HAPSIZ+2*MAXSIZ+1), set2(1,1))
      equivalence (work(HAPSIZ+4*MAXSIZ+1), key(1))
      equivalence (work(HAPSIZ+4*MAXSIZ+1), key1(1))
      equivalence (work(HAPSIZ+5*MAXSIZ+1), key2(1))
      equivalence (work(HAPSIZ+4*MAXSIZ+1), valu1(1))
      equivalence (work(HAPSIZ+5*MAXSIZ+1), valu2(1))
      equivalence (work(HAPSIZ+6*MAXSIZ+1), untyped(1))
      equivalence (work(HAPSIZ+6*MAXSIZ+1), ord(1))
      equivalence (work(HAPSIZ+7*MAXSIZ+1), cntall(1,1))
      equivalence (work(HAPSIZ+7*MAXSIZ+4*MAXG+1), gcount(1,1))
      equivalence (work(HAPSIZ+7*MAXSIZ+8*MAXG+1), recfro(1))
      equivalence (work(HAPSIZ+7*MAXSIZ+8*MAXG+1), name2(1))
      equivalence (work(HAPSIZ+7*MAXSIZ+8*MAXG+1*MAXALL+1), alfrq2(1))
      equivalence (work(HAPSIZ+7*MAXSIZ+8*MAXG+3*MAXALL+1), cumfrq(1))
      equivalence (work(HAPSIZ+7*MAXSIZ+8*MAXG+5*MAXALL+1), gfrq(1))
      equivalence (work(HAPSIZ+7*MAXSIZ+10*MAXG+5*MAXALL+1),ibdcount(1))
      equivalence (work(HAPSIZ+7*MAXSIZ+10*MAXG+5*MAXALL+2*IBDSIZ+1),
     &             count2(1))
C
      equivalence (work(HAPSIZ+7*MAXSIZ+10*MAXG+5*MAXALL+1),x(1))
      equivalence (work(HAPSIZ+7*MAXSIZ+10*MAXG+5*MAXALL+2*MAXTER+1),
     &             r(1))
      equivalence (work(HAPSIZ+7*MAXSIZ+10*MAXG+5*MAXALL+2*IBDSIZ+1),
     &             b(1))
      equivalence (work(HAPSIZ+7*MAXSIZ+10*MAXG+5*MAXALL+2*IBDSIZ+
     &             2*MAXTER+1),cov(1))
C
      equivalence (work(HAPSIZ+7*MAXSIZ+10*MAXG+5*MAXALL+1), lin)
      equivalence (work(HAPSIZ+7*MAXSIZ+10*MAXG+5*MAXALL+LINSIZ+1), 
     &             words(1))
      equivalence (work(HAPSIZ+7*MAXSIZ+10*MAXG+5*MAXALL+LINSIZ+1), 
     &             bigwor(1))
C
C time/random number generator seeds
C
C C library (DJGPP libc, GNU glibc etc):
C   time() -- date and time as sec since 1/1/1970
C   ctime() -- date and time as 24 character string
C   difftime(t0,t1) -- elapsed time
C
C f77 library (libU77):
C   time() -- date and time as sec since 1/1/1970 as integer
C   fdate() -- date and time as 24 character string 
C
      integer ix,iy,iz
      common /rndseed/ ix,iy,iz
C
C "local" counters etc
C
C actn=type of expression (arithmetic, dry run, evaluate),
C eop=length of pedigree name, gen2=position of 2nd allele, 
C length=line length, longnam=highest value of eop, nlin=line of command file, 
C nmark=marker loci found for twopoint() or other procedures
C bigped=name of largest pedigree, deeped=name of the deepest pedigree 
C h2=heritability, weight=variable containing weight for weighted H-E
C istyp=typed at any marker, maxsibs=sibship size to truncate to
C nprob=number of index individuals in pedigree, newloc=added locus,
C newtyp=added locus type, oldnam=check if already used
C nrc=number of lines per record, varlen=length of an outputted variable
C
      integer actn,eop,error,gen2,i,j,k,length,longnam,maxsibs,
     &        newloc,newtyp,nlin,nmark,nrc,varlen,weight
      logical istyp, oldnam
      character*3 keyword, keyw2
      character*8 cmark(2)
      character*10 bigped, deeped
      real candal, dist, tmp
C
C functions
      logical allmiss, alltyped, isreal
      integer eow, findwh, topall
      double precision chip

#ifdef HPUX
      character*8 timestr
      character*9 today
      integer t0

      version=VERSION // ' HPUX'

      t0=int(secnds(0.0))
      call date(today)
      call time(timestr)
      ix=int(30000*ran(t0))
      iy=int(30000*ran(t0))
      iz=int(30000*ran(t0))
 
      write(*,'(a/2a/a/4a/)')
     2  '|||| SIB-PAIR: A program for simple genetic analysis',
     3  '|\\/| Version : ',version,
     4  '|/\\| Author  : David L Duffy (c) 1995-2003',
     5  '|||| Job run : ',today,' at ',timestr
      prompt=.false.

#endif HPUX
#ifdef F2C
      external fdate
      integer time
      character*24 fdate
C stamp and initialize
      integer t0
C
      version=VERSION 

      t0=time()
      ix=mod(t0,29282)
      if (t0.gt.29282) then
        iy=mod(t0/29282,29282)
      else
        iy=mod(419*ix+6173,29282)
      end if
      iz=mod(419*iy+6173,29282)
      write(*,'(a/2a/a/2a/)')
     2  '|||| SIB-PAIR: A program for simple genetic analysis',
     3  '|\\/| Version : ',version,
     4  '|/\\| Author  : David L Duffy (c) 1995-2003',
     5  '|||| Job run : ',fdate()
#ifdef DOS
      prompt=.false.
#else
      prompt=isatty(5)
#endif
#endif F2C
#ifdef DEC
      character*8 tim
      character*9 dat
      integer t0

      version=VERSION // ' DEC'

      t0=int(secnds(0.0))
      call time(tim)
      call date(dat)
      call itime(ix,iy,iz)
      write(*,'(a/2a/a/4a/)')
     2  '|||| SIB-PAIR: A program for simple genetic analysis',
     3  '|\\/| Version : ',version,
     4  '|/\\| Author  : David L Duffy (c) 1995-2003',
     5  '|||| Job run : ',dat,' at ',tim
      prompt=.false.

#endif DEC
#ifdef SUN
      character*24 date
      integer t0
      integer it(3)

      version=VERSION // ' SUN'

      t0=int(secnds(0.0))
      call fdate(date)
      call itime(it)
      ix=it(1)
      iy=it(2)
      iz=it(3)
C
      write(*,'(a/2a/a/2a/)')
     2  '|||| SIB-PAIR: A program for simple genetic analysis',
     3  '|\\/| Version : ',version,
     4  '|/\\| Author  : David L Duffy (c) 1995-2003',
     5  '|||| Job run : ',date
      prompt=.false.

#endif SUN

C
C Initialize list of reserved words
C
C Token name, left binding power, right binding power, operation
C
C Pos Name     LBP  RBP  Op (1=unary postfix; 2=binary, infix; 3=if; 
C --- -------  ---  ---  --  10=zero-arg functions eg rand)
C   0 unbound    0    0   0
C   1 (        200    0   0
C   2 )          0    5   0
C   3 if         0   45   3
C   4 then       5   25   0
C   5 else       5   25   0
C   6 *        120  121   2
C   7 /        120  121   2
C   8 +        100  101   2
C   9 -        100  101   2
C  10 ^        139  138   2
C  11 =          0    0   2
C  12 not       70   70   1
C  13 and       65   66   2
C  14 or        60   61   2
C  15 <         80   80   2
C  16 >         80   80   2
C  17 ge        80   80   2
C  18 le        80   80   2
C  19 ne        80   80   2
C  20 eq        80   80   2
C  21 neg       138 138   1
C  22 pos       138 138   1
C  23 abs       140 140   1
C  24 sqrt      140 140   1
C  25 log       140 140   1
C  26 exp       140 140   1
C  27 sin       140 140   1
C  28 cos       140 140   1
C  29 tan       140 140   1
C  30 asin      140 140   1
C  31 acos      140 140   1
C  32 atan      140 140   1
C  33 inht      140 140   1
C  34 int       140 140   1
C  35 round     140 140   1
C  36 istyp     140 140   1
C  37 untyp     140 140   1
C  38 rand        0   0  10
C  39 rnorm       0   0  10
C  40 pi          0   0  10
C  41 y           0   0  10
C  42 n           0   0  10
C  43 x           0   0  10
C  44 NUM         0   0  10
C
      data token /'(',')','if','then','else','*','/',
     2     '+','-','^','=','not','and','or','<','>',
     3     'ge','le','ne','eq','neg','pos','abs','sqrt','log','exp',
     4     'sin','cos','tan','asin','acos','atan','inht','int','round',
     5     'istyp','untyp','rand','rnorm','pi','y','n','x','NUM'/
      data lbp /0, 200,0,0,5,5,120,120,
     2     100,100,139,0,70,65,60,80,80,
     3     80,80,80,80,138,138,140,140,140,140,
     4     140,140,140,140,140,140,140,140,140,
     5     140,140,0,0,0,0,0,0,0/
      data rbp /0, 0,5,45,25,25,121,121,
     2     101,101,138,0,70,66,61,80,80,
     3     80,80,80,80,138,138,140,140,140,140,
     4     140,140,140,140,140,140,140,140,140,
     5     140,140,0,0,0,0,0,0,0/
      data op /0, 0,0,3,0,0,2,2,
     2     2,2,2,2,1,2,2,2,2, 2,2,2,2,1,1,1,1,1,1,
     4     1,1,1,1,1,1,1,1,1, 1,1,10,10,10,10,10,10,10/
C
C And environmental (automatically defined) variables 
      data env /'female','male','isfou','isnon','num',
     &          'nfoun','anytyp','alltyp','numtyp','famnum','index'/
C
      cmark(1)='marker '
      cmark(2)='xmarker'
      burnin=100
      datdir=' '
      echo=.false.
      ilevel=1
      imp=1
      iter=200
      lin=' '
      mapf=1
      mincnt=20
      ndec=4
      nwid=9
      nlin=0
      plevel=0
      showorig=2
      wrkdir=' '
C Global restart

  999 continue

      pedfil=' '
      outfil=' '
      call uniqnam(t0,wrkfil,'wrk')
      call uniqnam(t0,wrk2fil,'tmp')
      ngeno=0
      nloci=0
      numloc=0
      wrknum=1
      addsex=.false.
      chek=.true.
      droperr=0
      fndr=0
      last=.false.
      link=.false.
      loconly=.false.
      red=.false.
      use2=2
      pedigree=' '
C
C main loop -- reads stdin, parses
C
    1 continue
        if (prompt) write(*,'(/a,$)') '>> '
        i=1
    3   continue
          if (ilevel.eq.1) then
            read(*,'(a)',end=2) lin(i:LINSIZ)
          else
            read(CSTRM,'(a)',end=2) lin(i:LINSIZ)
          end if
          nlin=nlin+1
          i=eow(lin)
        if (i.gt.1 .and. lin(i-1:i).eq.' \\') goto 3

        if (echo .or. plevel.gt.0) then
          write(*,'(/2a/)') '-> ',lin(1:75)
        end if
        narg=MAXCOL
        call args(lin,narg,words,1)
        keyword=words(1)(1:3)
        keyw2=words(2)(1:3)
C
C Locus description
        if (keyword.eq.'set' .and. keyw2.eq.'loc') then
          newloc=numloc+1
          if (words(4)(1:3).eq.'mar' .or. words(4)(1:3).eq.'nam') then
            newtyp=1
            newloc=newloc+1
          elseif (words(4)(1:3).eq.'xma') then
            newtyp=2
            newloc=newloc+1
          elseif (words(4)(1:3).eq.'aff') then
            newtyp=4
          else
            newtyp=3
            if (words(4)(1:3).ne.'qua') then
              write(*,'(3a/7x,a/)') 
     2          'ERROR: Do not recognise locus type ',words(4),'.',
     3               'Treating as quantitative trait.'
            end if
          end if
C Check if enough room and whether previously declared locus name or
C reserved word
          oldnam=.false.
          do 730 i=1, nloci
          if (loc(i).eq.words(3)(1:10)) then
            oldnam=.true.
          end if
  730     continue
          do 740 i=1, toknum
          if (token(i).eq.words(3)) then
            oldnam=.true.
          end if
  740     continue
          if (isreal(words(3))) oldnam=.true.
          if (newloc.gt.MAXLOC) then
            write(*,'(a,i3,a1/7x,3a/)') 
     2        'ERROR: Number of columns of data exceeds maximum ',
     3        MAXLOC,'.','Variable ',words(3)(1:10),' not added.'
          else
            nloci=nloci+1
            loc(nloci)=words(3)(1:10)
            if (oldnam) then
              k=min(10,eow(loc(nloci))+1)
              loc(nloci)(k:k)='_'
              write(*,'(a/7x,3a/)') 
     2        'WARNING: Locus is already declared or a reserved word.',
     3        'Changed name to "',loc(nloci)(1:k),'".'
            end if
            loctyp(nloci)=newtyp
            locpos(nloci)=numloc+1
            if (narg.gt.4) then
              map(nloci)=fval(words(5))
            else
              map(nloci)=MISS
            end if
C If pedigree workfile already exists, create a new variable
            if (red) then
              call newnam(wrknum, wrkfil)
              open(TWRK,file=wrkfil,form='unformatted')
              call addvar(WRK,TWRK,newloc,pedigree,actset,num,nfound,
     &                id,fa,mo,sex,locus,numloc)
              close(WRK,status='delete')
              close(TWRK,status='keep')
              open(WRK,file=wrkfil,form='unformatted')
            end if
            numloc=newloc
          end if
C
C Marker map 
        elseif (keyword.eq.'set' .and. keyw2.eq.'map') then
          if (words(3)(1:3).eq.'fun') then
            if (words(4)(1:3).eq.'kos') then
              write(*,'(/a/)') 'NOTE:  Using Kosambi mapping function.' 
              mapf=2
            else
              write(*,'(/a/)') 'NOTE:  Using Haldane mapping function.' 
              mapf=1
            end if
          else
            j=2
            do 710 i=1,nloci
            if (loctyp(i).le.2) then
              j=j+1
              if (j.le.narg) then
                dist=fval(words(j))
              else
                write(*,'(a/)') 
     &            'NOTE:  Ran out of user specified map positions.'
                dist=dist+100.0
              end if
              map(i)=dist
            end if
  710       continue
          end if
        elseif (keyword.eq.'set' .and. keyw2.eq.'dis') then
          j=1
          do 712 i=1,nloci
          if (loctyp(i).le.2) then
            j=j+1
            if (j.eq.2) then
              dist=0.0
            elseif (j.le.narg) then
              dist=fval(words(j))+dist
            else
              write(*,'(a/)') 
     &          'NOTE:  Ran out of user specified map distances.'
              dist=dist+100.0
            end if
            map(i)=dist
          end if
  712     continue
        elseif (keyword.eq.'sho' .and. keyw2.eq.'map') then
          call wrmap(0,10,mapf,nloci,loc,loctyp,nord,locord,map)
        elseif (keyword.eq.'rea' .and. keyw2.eq.'loc' ) then
          if (words(3)(1:3).eq.'lin') then
            inquire(file=words(4),exist=filexist)
            if (filexist) then
              open(TWRK,file=words(4),status='old')
              call rdlinloc(TWRK,lin,words,nloci,loc,  
     &                      locpos,loctyp,locord,map,numloc)
              close(TWRK)
              write(*,'(/a,i4,a/)') 'Read in names of ', nloci,
     &          ' loci from locus file.'
            else
              write(*,'(3a)') 
     &          'ERROR:  File',words(4)(1:eow(words(4))),' not found.'
            end if

          else
            write(*,'(a)') 'ERROR:  Locus file type not supported'
          end if
C
C Pedigree file to read from
        elseif (keyword.eq.'rea' .and. (keyw2.eq.'ped' 
     &          .or. keyw2.eq.'lin')) then
          call args(lin,narg,bigwor,1)
          link=(bigwor(2)(1:3).eq.'lin') 
          pedfil=bigwor(3)
C
C pedigree data may be inline: transfer data to temporary file
C following lines are pedigree data, and are terminated by a line
C starting  ";;;;".  Require exact keyword match to avoid clashes with files.
C
          if (pedfil.eq.'inl' .or. pedfil.eq.'inline') then
            pedfil='inline.ped' 
            call mknewfil(OSTR, pedfil, wrkdir)
            open(OSTR,file=pedfil)
  350       continue
              if (ilevel.eq.1) then
                read(*,'(a)',end=2) lin(1:LINSIZ)
              else
                read(CSTRM,'(a)',end=2) lin(1:LINSIZ)
              end if
              nlin=nlin+1
            if (lin(1:4).ne.';;;;') then
              write(OSTR,*) lin(1:eow(lin))
              goto 350
            end if
            close(OSTR,status='keep')
C else check if file exists
          else
            call cat(datdir,pedfil)
            inquire(file=pedfil,exist=filexist)
            if (.not.filexist) then
              write(*,'(/3a/7x,3a/)') 
     2          'NOTE:  Pedigree file "',pedfil(1:eow(pedfil)),
     3          '" does not exist.','Trying "',
     4          bigwor(3)(1:eow(bigwor(3))),'".'
              pedfil=bigwor(3)
              inquire(file=pedfil,exist=filexist)
              if (.not.filexist) then
                write(*,'(/3a/)') 
     2            'ERROR: Pedigree file "',pedfil(1:eow(pedfil)),
     3            '" does not exist.'
                pedfil=' '
              end if
            end if
          end if
C set output number of decimal points
        elseif (keyword.eq.'set' .and. keyw2.eq.'nde') then
          if (narg.gt.3) then
            nwid=ival(words(3))
            ndec=ival(words(4))
          else
            ndec=ival(words(3))
          end if
          if (nwid.le.0) then
            nwid=9
          elseif (nwid.gt.20) then
            nwid=20
          end if
          if (ndec.gt.nwid) then
            ndec=nwid
          elseif (ndec.lt.0) then
            ndec=0
          end if
          write(*,'(/a,i2,a,i2/)') 
     &      'NOTE:  Number of decimal digits w.d w=',nwid,' d=',ndec
C set output verbosity
        elseif (keyword.eq.'set' .and. 
     2          (keyw2.eq.'out'.or.keyw2.eq.'ple')) 
     3  then
          if (words(3)(1:3).eq.'ver') then
            plevel=2
          elseif (words(3).eq.'on') then
            plevel=1
          elseif (words(3)(1:3).eq.'off') then
            plevel=0
          else
            plevel=ival(words(3))
          end if
          write(*,'(/a,i2/)') 'NOTE:  Print level ',plevel
C set haplotyping output verbosity
        elseif (keyword.eq.'set' .and. keyw2.eq.'hap') then
          if (words(3)(1:3).eq.'ver') then
            showorig=2
          elseif (words(3).eq.'on') then
            showorig=1
          elseif (words(3)(1:3).eq.'off') then
            showorig=0
          else
            showorig=ival(words(3))
          end if
          write(*,'(/a,i2/)') 'NOTE:  Haplotype print level ', showorig
C set pedigree weighting formula
        elseif (keyword.eq.'set'.and.keyw2.eq.'wei') then
          if (words(3)(1:3).eq.'fou') then
            fndr=1
            write(*,'(/a/7x,a/)') 
     2        'NOTE:  Using pedigree gene frequencies',
     3        'weighted by number of founders in pedigree'
          elseif (words(3)(1:3).eq.'imp') then
            fndr=2
            write(*,'(/a,a/)') 
     2        'NOTE:  Using count of imputed alleles',
     3        ' in founders of pedigree'
          else
            fndr=0
            write(*,'(/a/)') 
     &        'NOTE:  Using unweighted sample gene frequencies'
          end if
C set name of data directory
        elseif (keyword.eq.'set' .and. 
     2          (keyw2.eq.'dir' .or. keyw2.eq.'dat')) 
     3  then
          call args(lin,narg,bigwor,1)
          datdir=bigwor(3)
          inquire(file=datdir,exist=filexist)
          if (.not.filexist) then
            write(*,'(/3a/7x,a/)') 
     2        'NOTE:  Directory "',datdir(1:eow(datdir)),
     3        '" not found.','Using ./ as data directory.'
            datdir=' '
          else
            write(*,'(/3a/)') 
     2        'NOTE:  Directory for pedigree files now "',
     3        datdir(1:eow(datdir)),'".'
          end if
C set name of workfile directory
        elseif (keyword.eq.'set'.and.keyw2.eq.'wor') then
          call args(lin,narg,bigwor,1)
          wrkdir=bigwor(3)
          inquire(file=wrkdir,exist=filexist)
          if (.not.filexist) then
            write(*,'(/3a/7x,a/)') 
     2        'NOTE:  Directory "',wrkdir(1:eow(wrkdir)),
     3        '" not found.','Using ./ as work directory.'
          else
            write(*,'(/3a/)') 
     2        'NOTE:  Directory for temporary files now "',
     3        wrkdir(1:eow(wrkdir)),'".'
            call cat(wrkdir,wrkfil)
            call cat(wrkdir,wrk2fil)
          end if
C add sex to data file as dummy quantitative trait
        elseif (keyword.eq.'set'.and.words(2).eq.'sex'.and..not.red) 
     &  then
          addsex=.true.
          do 300 i=nloci,1,-1
            gen2=i+1
            loc(gen2)=loc(i)
            loctyp(gen2)=loctyp(i)
            locpos(gen2)=locpos(i)+1
  300     continue
          loc(1)='sex'
          loctyp(1)=3
          locpos(1)=1
          nloci=nloci+1
          numloc=numloc+1
        elseif (keyword.eq.'set'.and.keyw2.eq.'ech') then
          echo=.true.
          if (words(3).eq.'off') then
            echo=.false.
          end if
C set initial burn-in iterations for Monte-Carlo Markov Chain routines
        elseif (keyword.eq.'set'.and.keyw2.eq.'bur') then
          burnin=ival(words(3))
          write(*,'(/a,i6/)') 
     &      'NOTE:  Number of MC burn-in iterations ',burnin
        elseif (keyword.eq.'set'.and.keyw2.eq.'ite') then
          iter=ival(words(3))
          write(*,'(/a,i6/)') 
     &      'NOTE:  Number of MC iterations ',iter
        elseif (keyword.eq.'set'.and.keyw2.eq.'min') then
          mincnt=ival(words(3))
          write(*,'(/a,i6/)') 
     &      'NOTE:  Minimum numerator for MC P-values ',mincnt
        elseif (keyword.eq.'set'.and.keyw2.eq.'see') then
          if (narg.gt.2) then
            ix=ival(words(3))
            iy=ival(words(4))
            iz=ival(words(5))
            if (iy.eq.0) iy=ix
            if (iz.eq.0) iz=iy
          end if
          write(*,'(a,3(1x,i5)/)') 'Seeds for RNG (AS183)=',ix,iy,iz
        elseif (keyword.eq.'set'.and.keyw2.eq.'pro') then
          prompt=.true.
          if (words(3).eq.'off') then
            prompt=.false.
          end if
        elseif (keyword.eq.'set'.and.keyw2.eq.'che') then
          if (words(3).eq.'off') then
            chek=.false.
          elseif (words(3).eq.'on') then
            chek=.true.
          end if
        elseif (keyword.eq.'set'.and.keyw2.eq.'err') then
          if (words(3).eq.'off') then
            droperr=0
          elseif (words(3).eq.'on') then
            droperr=2
          else
            droperr=ival(words(3))
          end if
        elseif (keyword.eq.'set'.and.keyw2.eq.'tdt') then
          if (words(3)(1:3).eq.'bot') then
            use2=2
            write(*,'(/2a/)') 
     2        'NOTE:  Index may contribute to TDT only where ',
     3        'both parents typed.'
          elseif (words(3)(1:3).eq.'fir') then
            use2=3
            write(*,'(/2a/)') 
     2        'NOTE:  Only one index case per pedigree used -- ',
     3        'both parents must be typed.'
          else
            use2=1
            write(*,'(/2a/)') 
     2        'NOTE:  Index may contribute to TDT if one or ',
     3        'both parents typed.'
          end if
        elseif (keyword.eq.'set'.and.keyw2.eq.'imp') then
          if (words(3).eq.'off') then
            imp=0
          elseif (words(3).eq.'on') then
            imp=1
          else
            imp=ival(words(3))
          end if
          if (imp.gt.0) chek=.true.
        elseif (keyword.eq.'dro') then
          call loadnam(2,narg,words,nloci,loc,loctyp,locord,nmark,ord,1)
          do 301 i=1,nloci
          if (locord(i).gt.0) then
            loctyp(i)=loctyp(i)+4
          end if
  301     continue
        elseif (keyword.eq.'kee') then
          call loadnam(2,narg,words,nloci,loc,loctyp,locord,nmark,ord,1)
          do 31 i=1,nloci
          if (loctyp(i).le.4) then
            loctyp(i)=loctyp(i)+4  
          end if
   31     continue
          do 302 i=1,nloci
          if (locord(i).gt.0) then
            loctyp(i)=loctyp(i)-4
          end if
  302     continue
        elseif (keyword.eq.'und') then
          call loadnam(2,narg,words,nloci,loc,loctyp,locord,nmark,ord,2)
          do 33 i=1,nloci
          if (loctyp(i).gt.4 .and. locord(i).gt.0) then
            loctyp(i)=loctyp(i)-4
          end if
   33     continue
C
        elseif (keyword.eq.'run') then
          if (imp.eq.0) then
            write(*,'(/2a/8x,a/)') 
     2        'NOTE:  Imputation level 0.  ',
     3        'Not imputing parental genotypes',
     4        'in program step for purposes of TDT etc.'
          elseif (imp.eq.1 .or. imp.eq.4) then
            write(*,'(/a/7x,a/)') 
     2        'NOTE:  Imputation level 1.  Imputing untyped parental',
     3       ' genotypes where unequivocal.'
          elseif (imp.eq.2 .or. imp.eq.5) then
            write(*,'(/a/4(7x,a/))') 
     2        'NOTE:  Imputation level 2.  Imputing untyped parental',
     3        'genotypes where unequivocal.',
     4        'If only the joint parental genotype can be',
     5        'imputed ie {ab} x {cd} .eqv. {cd} x {ab}, then',
     6        'the father is assigned lowest (order) genotype.'
          elseif (imp.eq.3 .or. imp.eq.6) then
            write(*,'(/a/4(7x,a/))') 
     2        'NOTE:  Imputation level 3.  Imputing ALL untyped', 
     3        'genotypes as that conditionally most likely given',
     4        'both the observed genotypes and those imputed up to',
     5        'that point (sequential imputation).'
          end if
          if (plevel.gt.0) then
            call info(burnin,imp,iter,ix,iy,iz,mapf,mincnt,plevel,
     2             showorig,addsex,chek,droperr,prompt,use2,
     3             datdir,version,wrkdir)
          end if
          write(*,'(a,a/a,i5)')    
     2        'Pedigree file        = ',pedfil,
     3        'Number of loci       = ',nloci
          call listloci(nloci,loc,loctyp,locpos,1)
          if (pedfil.eq.' ') then
            write(*,'(/a/7x,a/)') 
     2        'ERROR: Pedigree file not defined yet.',
     3               'Making dummy pedigree file "inline.ped".'
            pedfil='inline.ped' 
            call mknewfil(OSTR, pedfil, wrkdir)
            open(OSTR,file=pedfil)
            do 400 i=1, 10
              write(OSTR,'(i2,1x,i2,100a:)') i,i,(' x',j=1,numloc+3)
  400       continue
            close(OSTR)
          else
            inquire(file=pedfil,exist=filexist)
            if (.not.filexist) then
              write(*,'(/3a/7x,a/)') 
     2          'ERROR: Pedigree file "',pedfil(1:eow(pedfil)),
     3          '" not found.', 'Stopping prematurely.'
              call stamp(t0)
              stop
            end if
          end if
          inquire(file=wrkfil,exist=filexist)
          if (filexist) then
            close(WRK,status='delete')
          end if
          open(INSTRM,file=pedfil,status='OLD')
          open(WRK,file=wrkfil,form='unformatted')
C
C read in pedigree file, accumulate descriptive statistics,
C do preliminary checks (resolving nonmendelisms by deleting
C problem genotypes) and write to workfile
C
          badfam=0
          badnum=0
          inconsist=0
          imputd=0
          longnam=0
          ndiscard=0
          nwarn=0
          nobs=0
          nped=0
          nships=0
          ntyped=0
          tfound=0
          tottyp=0
          bigped=' '
          biggest=0
          deeped=' '
          deepest=0
          totgen=0
          onegen=0
          onemem=0

    5     continue
            famerr=.false.
            open(WRK2,file=wrk2fil,form='unformatted')
            call pedin(INSTRM,WRK,WRK2,addsex,link,pedigree,num, nfound,
     2                 id,fa,mo,sex,locus,ord,key1,key2,set,last,higen,
     3                 numloc,lin,words,nwarn,nfam,famerr,plevel)
            close(WRK2,status='delete')
            eop=eow(pedigree)
C 
C If pedigree error, drop from further analysis
            if (famerr) then
              write(*,'(/4a/)') 
     2          'ERROR:  Too many pedigree errors. ',
     3          'Dropping pedigree ',pedigree(1:eop),'.' 
              badfam=badfam+1
              badnum=badnum+num
C
C else write to work file
            else  
              if (eop.gt.longnam) longnam=eop
              if (higen.eq.1) onegen=onegen+1
              if (num.eq.1) onemem=onemem+1
              if (num.gt.biggest) then
                biggest=num
                bigped=pedigree
              end if
              if (higen.gt.deepest) then
                deepest=higen
                deeped=pedigree
              end if
              nobs=nobs+num
              nped=nped+1
              nships=nships+nfam
              tfound=tfound+nfound
              totgen=totgen+higen
C
C order alleles in genotype, rounding as go
C count total genotyped individuals
C
              do 68 i=1,num
                istyp=.false.
                do 69 j=1,nloci
                  if (loctyp(j).le.2) then 
                    gene=locpos(j)
                    gen2=gene+1
C make males homozygotes if X-linked and second allele set to missing
                    if (loctyp(j).eq.2 .and. sex(i).eq.1 .and.
     2                locus(i,gene).ne.MISS .and. locus(i,gene).ne.0.0
     3                .and. (locus(i,gen2).eq.MISS .or.
     4                       locus(i,gen2).eq.0.0)) then
                      locus(i,gen2)=locus(i,gene)
                    end if

                    if (locus(i,gene).eq.0.0 .or. locus(i,gen2).eq.0.0
     2               .or. locus(i,gene).eq.MISS 
     3               .or. locus(i,gen2).eq.MISS) then
                      locus(i,gene)=MISS
                      locus(i,gen2)=MISS
                    elseif (locus(i,gene).gt.locus(i,gen2)) then
                      istyp=.true.
                      tmp=anint(locus(i,gen2))
                      locus(i,gen2)=anint(locus(i,gene))
                      locus(i,gene)=tmp
                    else
                      istyp=.true.
                      locus(i,gene)=anint(locus(i,gene))
                      locus(i,gen2)=anint(locus(i,gen2))
                    end if
                  else if (loctyp(j).eq.4) then
                    gene=locpos(j)
                    if (locus(i,gene).ne.1.0 .and. 
     &                  locus(i,gene).ne.2.0) then
                      locus(i,gene)=MISS
                    end if
                  end if
   69           continue
                if (istyp) ntyped=ntyped+1
   68         continue
C
              if (plevel.ge.0) then
                write(*,'(a,a10,3(1x,a,i4))') 
     2            'Pedigree: ',pedigree, 'No. members: ',num, 
     3            'No. founders: ',nfound, 'No. sibships: ',nfam
              end if
C
C Do nuclear family level Mendelian checking
C
              if (chek) then
                call check(pedigree,num,nfound,id,fa,mo,sex,locus,
     2                     nloci,loc,loctyp,locpos,set,untyped,
     3                     droperr,ndiscard,inconsist,plevel)
              end if
              actset=1
              call wrkout(WRK,pedigree,actset,num,nfound,id,fa,mo,sex,
     &                    locus,numloc)
            end if
          if (.not.last) goto 5
   10     close(INSTRM)
C
C List number of problems encountered
C
          if (droperr.gt.0) then
            write(*,'(/a/a,i5)')  
     2        'Nuclear family error checking completed.',
     3        'Number discarded genotypes = ',ndiscard 
          end if
          if (inconsist.gt.0) then
            write(*,'(/a/a,i5/a)')  
     2        'Nuclear family error checking completed.',
     3        'Number of data problems    = ',inconsist,
     4        'NOTE:  Stopping prematurely.'
            close(WRK,status='delete')
            call stamp(t0)
            stop
          end if
C
C end of 1st while loop
C now perform imputation if requested
C
          if (imp.ge.0) then

            open(WRK2,file=wrk2fil,form='unformatted')
            do 95 i=1,nloci
            if (loctyp(i).le.2) then
              xlinkd=(loctyp(i).eq.2)
              call freq(WRK,locpos(i),pedigree,actset,num,nfound,id,fa,
     &               mo,sex,locus,numloc,numal,name,fndr,alfrq,typed)
              call wrfreq(WRK2,loc(i),numal,name,alfrq,map(i),
     &                    typed,nobs,3)
              tottyp=tottyp+typed
            end if
   95       continue
            call newnam(wrknum, wrkfil)
            open(TWRK,file=wrkfil,form='unformatted')
            rewind(WRK)
            last=.false.

  100       continue
            call wrkin(WRK,pedigree,actset,num,nfound,id,fa,mo,sex,
     &                 locus, numloc,last)
            if (last) goto 200
              rewind(WRK2)
              do 120 i=1,nloci
              if (loctyp(i).le.2) then
                xlinkd=(loctyp(i).eq.2)
                read(WRK2) numal,(name(j),j=1,numal),
     &            (alfrq(j),j=1,numal)
                if (allmiss(locpos(i),num,locus)) then
                  if (numal.eq.0) name(1)=1
                  if (plevel.gt.0) then
                    write(*,'(/4a/)') 
     2                'NOTE:  All members of pedigree ',
     3                pedigree(1:eow(pedigree)),
     4                ' are untyped at locus ',loc(i)
                  end if
                  call setall(locpos(i),num,locus, -float(name(1)))
                elseif (imp.gt.0) then
                  call exclude(imp,loc(i),xlinkd,locpos(i),pedigree,
     2              num,nfound,id,fa,mo,sex,locus,numal,name,alfrq,set,
     3              ngeno,gset,inconsist,imputd,plevel)
                  if (imp.gt.3) then
                    call accum(numal,alfrq,cumfrq)
                    call start(loc(i),xlinkd,locpos(i),pedigree,num,
     &                         nfound,id,fa,mo,sex,locus,numal,name,
     3                         cumfrq,set,sibd,key,inconsist,plevel)
                  end if
                elseif (imp.eq.0.and..not.alltyped(locpos(i),num,locus))
     &          then
                  call accum(numal,alfrq,cumfrq)
                  call start(loc(i),xlinkd,locpos(i),pedigree,num,
     &                       nfound,id,fa,mo,sex,locus,numal,name,
     3                       cumfrq,set,sibd,key,inconsist,plevel)
                end if
              end if
  120         continue
              call wrkout(TWRK,pedigree,actset,num,nfound,id,fa,mo,sex,
     &                    locus, numloc)
            goto 100
  200       continue
            close(WRK2,status='delete')
            close(WRK,status='delete')
            close(TWRK,status='keep')
            open(WRK,file=wrkfil,form='unformatted')
          end if
C
C Summary statistics on families
C
          write(*,'(4(/a,i5))') 
     2      'Total number of pedigrees  = ',nped,
     3      'Number with only 1 member  = ',onemem,
     4      'Total number of sibships   = ',nships,
     5      'Total number of subjects   = ',nobs 
          write(*,'(a,i5,a,f5.1,a/a,i6)') 
     2      'Total subjects genotyped   = ',ntyped,
     3      ' (',float(100*ntyped)/float(nobs),'%)',
     4      'Total number of genotypes  = ',tottyp/2
          write(*,'(a,i5,3a/a,i5,3a)') 
     2      'Largest pedigree (members) = ',biggest,
     3      ' (Pedigree ',bigped(1:eow(bigped)),')',
     4      'Deepest pedigree (genrtns) = ',deepest,
     5      ' (Pedigree ',deeped(1:eow(deeped)),')' 
          write(*,'(/a,f7.1/a,f7.1)') 
     2      'Mean size of pedigrees     = ',dfloat(nobs)/dfloat(nped),
     3      'Mean pedigree depth        = ',dfloat(totgen)/dfloat(nped) 
          if (nped.gt.onegen) then
            write(*,'(a,f7.1/a,f7.1)') 
     2      'Mean size where >1 members = ',
     3       dfloat(nobs-onemem)/dfloat(nped-onemem),
     4      'Mean depth where >1 geners = ',
     5       dfloat(totgen-onegen)/dfloat(nped-onegen)
          end if
          write(*,'(a,i5//a,i5/a,i5)') 
     2      'Number of imputed genotypes= ',imputd,
     3      'Number of pedigree errors  = ',badfam,
     4      'Number of deleted records  = ',badnum
          if (nwarn.gt.0) then
            write(*,'(/a,i5)')  
     &      'Number of warnings         = ',nwarn
          end if
C
C Abort if persisting problems
C
          if (inconsist.gt.0) then
            write(*,'(/a,i5)') 
     &      'Number of problems         = ',inconsist 
            if (droperr.lt.2) then
              write(*,'(a)') 'NOTE:  Stopping prematurely.'
              close(WRK,status='delete')
              call stamp(t0)
              stop
            end if
          end if
          red=.true.
C If reading only locus information from included file return control
          if (loconly) goto 2
C Break into component nuclear families
        elseif (keyword.eq.'nuc' .and. red) then
          maxsibs=MAXSIZ-2
          typ=1
          do 48 i=2,narg
          if (words(i)(1:3).eq.'gra') then
            typ=2
          else
            maxsibs=ival(words(i))
          end if
   48     continue
          if (maxsibs.lt.0 .or. maxsibs.gt.(MAXSIZ-2)) maxsibs=MAXSIZ-2
          write(*,'(/a,i4,a,i4,a/a)') 
     2      'Dividing ',nped,' pedigrees into ',nships, 
     3      ' nuclear families.', 
     4      'Individuals are duplicated as necessary.'
          if (maxsibs.ne.(MAXSIZ-2)) then
            write(*,'(a,i3,a/)') 
     2        'Sibships with more than ',maxsibs,
     3        ' members are truncated.'
          else
            write(*,*)
          end if
          longnam=min(longnam+3,10)
          call newnam(wrknum, wrkfil)
          open(TWRK,file=wrkfil,form='unformatted')
          call nuclear(WRK,TWRK,pedigree,actset,num,nfound,
     &                 id,fa,mo,sex,locus,numloc,maxsibs,typ)
          close(WRK,status='delete')
          close(TWRK,status='keep')
          open(WRK,file=wrkfil,form='unformatted')
C break into unrelated cases and controls
        elseif (keyword.eq.'cas' .and. red) then
          call gettrait(words(2),10,0,nloci,loc,loctyp,trait)
          if (trait.ne.MISS) then
            write(*,'(/a/3a/)') 
     2         'Extracting unrelated cases from pedigrees.',
     3         'Subjects must be nonmissing for "',
     4         loc(trait)(1:eow(loc(trait))),'".'
            longnam=min(longnam+3,10)
            call newnam(wrknum, wrkfil)
            open(TWRK,file=wrkfil,form='unformatted')
            call wricas(WRK,TWRK,locpos(trait),pedigree,actset,
     &                  num,nfound,id,fa,mo,sex,locus,numloc)
            close(WRK,status='delete')
            close(TWRK,status='keep')
            open(WRK,file=wrkfil,form='unformatted')
          end if
C extract disjoint subpedigrees
        elseif (keyword.eq.'sub' .and. red) then
          longnam=min(longnam+3,10)
          write(*,'(/a/)') 
     &      'Dividing compound pedigrees into component pedigrees.'  
          call newnam(wrknum, wrkfil)
          open(TWRK,file=wrkfil,form='unformatted')
          call disjoin(WRK,TWRK,pedigree,actset,num,nfound,id,fa,mo,sex,
     &                 locus,numloc,ord,set,plevel)
          close(WRK,status='delete')
          close(TWRK,status='keep')
          open(WRK,file=wrkfil,form='unformatted')
C prune pedigree to affecteds plus connectors
        elseif (keyword.eq.'pru' .and. red) then
          call getbin(2,narg,words,nloci,loc,loctyp,trait,gt,thresh)
          if (trait.ne.MISS) then
            call newnam(wrknum, wrkfil)
            open(TWRK,file=wrkfil,form='unformatted')
            call prunep(WRK,TWRK,loc(trait),locpos(trait),gt,thresh,
     2              pedigree,num,nfound,id,fa,mo,sex,locus,numloc,
     3              key,ord,set,plevel)
            close(WRK,status='delete')
            close(TWRK,status='keep')
            open(WRK,file=wrkfil,form='unformatted')
          end if
C edit <pedigree> <person> <trait> to <value1> [<value2>]
        elseif (keyword.eq.'edi' .and. red) then
          call gettrait(words(4),10,0,nloci,loc,loctyp,trait)
          if (trait.ne.MISS) then
            if (loctyp(trait).le.2) then
              all1=fval(words(narg-1))
              all2=fval(words(narg))
            else
              all1=fval(words(narg))
            end if
            call newnam(wrknum, wrkfil)
            open(TWRK,file=wrkfil,form='unformatted')
            call edit(WRK,TWRK,words(2)(1:10),words(3)(1:8),
     2                locpos(trait),loc(trait),
     3                loctyp(trait),all1,all2,
     4                pedigree,actset,num,nfound,
     5                id,fa,mo,sex,locus,numloc)
            close(WRK,status='delete')
            close(TWRK,status='keep')
            open(WRK,file=wrkfil,form='unformatted')
          end if
C delete data for <pedigree> <person> or condition
        elseif (keyword.eq.'del' .and. red) then
          typ=0
          call args(lin,narg,words,2)
          i=findwh(2, narg, narg, words)
          if (i.ne.0) then
            typ=2
            call loadnam(2,i-1,words,nloci,loc,loctyp,
     &                   locord,nmark,ord,1)
          else if (narg.eq.3) then
            typ=1
          end if
          if (typ.ne.0) then
            call newnam(wrknum, wrkfil)
            open(TWRK,file=wrkfil,form='unformatted')
            if (typ.eq.1) then
              call edit(WRK,TWRK,words(2)(1:10),words(3)(1:8),
     2                MISS,'          ',MISS,0.0,0.0,
     3                pedigree,actset,num,nfound,id,fa,mo,sex,
     4                locus,numloc)
            else
              call seldel(WRK,TWRK,nmark,ord,i+1,narg,words,nloci,loc,
     2               loctyp,locpos,token,env,lbp,rbp,op,wtyp,expr,
     3               pedigree,actset,num,nfound,id,fa,mo,sex,
     4               locus,numloc,plevel)
            end if
            close(WRK,status='delete')
            close(TWRK,status='keep')
            open(WRK,file=wrkfil,form='unformatted')
          end if
C standardize quantitative trait
        elseif (keyword.eq.'sta'.and.red) then
          call gettrait(words(2),3,0,nloci,loc,loctyp,trait)
          if (trait.ne.MISS) then
            typ=1
            if (words(3)(1:3).eq.'fam') then
              typ=2
              write(*,'(/3a)') 'Standardizing "',loc(trait),
     &          '" WITHIN each family to mean=0, variance=1.'
            else
              write(*,'(/3a)') 'Standardizing "',loc(trait),
     &          '" to mean=0, variance=1.'
            end if
            call newnam(wrknum, wrkfil)
            open(TWRK,file=wrkfil,form='unformatted')
            call stand(WRK,TWRK,locpos(trait),pedigree,actset,num,
     &                 nfound,id,fa,mo,sex,locus,numloc,typ)
            close(WRK,status='delete')
            close(TWRK,status='keep')
            open(WRK,file=wrkfil,form='unformatted')
          end if
C K-M survival analysis and nonparametric survivor residuals
        elseif (keyword.eq.'kap'.and.red) then
          call gettrait(words(2),3,0,nloci,loc,loctyp,trait)
          call gettrait(words(3),4,0,nloci,loc,loctyp,prob)
          if (trait.ne.MISS .and. prob.ne.MISS) then
            write(*,'(/a/a,a10,a/a/3a)')
     2       '------------------------------------------------',
     3       'Kaplan-Meier survivor function for "',loc(trait),'"',
     4       '------------------------------------------------', 
     5       '"',loc(prob)(1:eow(loc(prob))), 
     6       '" is outcome (censoring) trait.'
            typ=1
            if (words(4)(1:2).eq.'re') then
              typ=2
              write(*,'(/3a)') 'Replacing value of "',
     2          loc(trait)(1:eow(loc(trait))), 
     3          '" with nonparametric residual.'
              call newnam(wrknum, wrkfil)
              open(TWRK,file=wrkfil,form='unformatted')
              call prodlim(WRK,TWRK,locpos(trait),locpos(prob),
     2               pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     3               numloc,valu1,valu2,set,typ,plevel)
              close(WRK,status='delete')
              close(TWRK,status='keep')
              open(WRK,file=wrkfil,form='unformatted')
            else
              call prodlim(WRK,TWRK,locpos(trait),locpos(prob),
     2               pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     3               numloc,valu1,valu2,set,typ,plevel)
            end if
          end if
C linear regressive adjustment of quantitative trait
        elseif (keyword.eq.'adj'.and.words(3).eq.'on'.and.red) 
     &  then
          call gettrait(words(2),3,0,nloci,loc,loctyp,trait)
          call gettrait(words(4),10,0,nloci,loc,loctyp,gene)
          if (trait.ne.MISS .and. gene.ne.MISS) then
            write(*,'(/5a)') 
     2        'Performing regression adjustment of "',
     3        loc(trait)(1:eow(loc(trait))), '" on "', 
     4        loc(gene)(1:eow(loc(gene))),'"'
            if (words(5).eq.'to' .and. narg.eq.6) then
              if (words(6).eq.'m' .or. words(6).eq.'M') then
                adjval=1.0
                write(*,'(a/)') 'Adjusting to male expectation'
              elseif (words(6).eq.'f' .or. words(6).eq.'F') then
                adjval=0.0
                write(*,'(a/)') 'Adjusting to female expectation'
              else
                adjval=fval(words(6))
                write(*,'(3a,f12.4/)') 
     &            'Adjusting to ',loc(gene),' =',adjval
              end if
            else
              adjval=MISS
              write(*,'(3a/)') 
     &          'Adjusting to ',loc(gene),' = mean value'
            end if
            call newnam(wrknum, wrkfil)
            open(TWRK,file=wrkfil,form='unformatted')
            call adjust(WRK,TWRK,locpos(trait),locpos(gene),adjval,
     2                  pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     3                  numloc,plevel)
            close(WRK,status='delete')
            close(TWRK,status='keep')
            open(WRK,file=wrkfil,form='unformatted')
          end if
C Box-Cox transformation of quantitative trait
        elseif ((keyword.eq.'tra' .or. keyword.eq.'box')
     2          .and. red)  then
          call gettrait(words(2),3,0,nloci,loc,loctyp,trait)
          if (trait.ne.MISS) then
            divisor=fval(words(3))
            offset=fval(words(4))
            power=fval(words(5))
            loval=fval(words(6))
            hival=fval(words(7))
            if (divisor.eq.MISS .or. divisor.eq.0.0) divisor=1.0
            if (offset.eq.MISS) offset=0.0
            if (power.eq.MISS) power=1.0
            write(*,'(/3a/3(/a,f9.4))') 
     2        'Transforming locus "',loc(trait)(1:eow(loc(trait))),
     3        '" via boxcox{(x-m)/d,p}', ' Divisor d= ',divisor,
     5        ' Offset  m= ',offset, ' Power p= ',power 
            if (power.eq.1.0d0) then
              write(*,'(a)') ' boxcox{x}= x' 
            elseif (power.eq.0.0d0) then
              write(*,'(a)') ' boxcox{x}= log(x)' 
            else
              write(*,'(a)') ' boxcox{x}= (x^p-1)/p'
            end if
            if (loval.ne.MISS) then
              write(*,'(a,f9.4)') 
     &          ' Truncating transformed values < ',loval
            end if
            if (hival.ne.MISS) then
              write(*,'(a,f9.4)') 
     &          ' Truncating transformed values > ',hival
            end if
            call newnam(wrknum, wrkfil)
            open(TWRK,file=wrkfil,form='unformatted')
            call boxcox(WRK,TWRK,locpos(trait),offset,divisor,power,
     2                  loval, hival, pedigree,actset,num,nfound,
     3                  id,fa,mo,sex,locus,numloc)
            close(WRK,status='delete')
            close(TWRK,status='keep')
            open(WRK,file=wrkfil,form='unformatted')
          end if
C global recoding of trait values
        elseif(keyword.eq.'rec'.and.words(narg-1).eq.'to'.and.red) 
     &  then
          call gettrait(words(2),10,0,nloci,loc,loctyp,trait)
          recto=fval(words(narg))
          nf=narg-4
          do 49 i=1,nf
            recfro(i)=fval(words(2+i))
   49     continue
          if (trait.ne.MISS) then
            call newnam(wrknum, wrkfil)
            open(TWRK,file=wrkfil,form='unformatted')
            call recode(WRK,TWRK,loc(trait),locpos(trait),loctyp(trait),
     2              recto,nf,recfro,pedigree,actset,num,nfound,
     3              id,fa,mo,sex,locus,numloc)
            close(WRK,status='delete')
            close(TWRK,status='keep')
            open(WRK,file=wrkfil,form='unformatted')
          end if
C combine rare alleles for marker loci
        elseif(keyword.eq.'com'.and.red) then
          thresh=0.05
          if (isreal(words(narg))) then
            thresh=fval(words(narg))
            narg=narg-1
          end if
          call loadnam(2,narg,words,nloci,loc,loctyp,locord,nmark,ord,1)
          do 59 i=1,nmark
            j=ord(i)
            if (loctyp(j).eq.1 .or. loctyp(j).eq.2) then
              write(*,'(3a)') 'Combining rare alleles for ',loc(j),'.'
              call freq(WRK,locpos(j),pedigree,actset,num,nfound,id,fa,
     &                  mo,sex,locus,numloc,numal,name,fndr,alfrq,typed)
              call combine(thresh,recto,nf,recfro,numal,name,alfrq)
              if (nf.gt.1) then
                 call newnam(wrknum, wrkfil)
                 open(TWRK,file=wrkfil,form='unformatted')
                 call recode(WRK,TWRK,loc(j),locpos(j),
     2                   loctyp(j),recto,nf,recfro,pedigree,actset,
     3                   num,nfound,id,fa,mo,sex,locus,numloc)
                 close(WRK,status='delete')
                 close(TWRK,status='keep')
                 open(WRK,file=wrkfil,form='unformatted')
              end if
            end if
   59     continue
        elseif ((keyword.eq.'fac' .or. keyword.eq.'ran').and.red) 
     &  then
          call gettrait(words(2),10,0,nloci,loc,loctyp,gene)
          call gettrait(words(3),3,0,nloci,loc,loctyp,trait)
          if (trait.ne.MISS .and. gene.ne.MISS) then
            if (loctyp(gene).le.2) then
              call freq(WRK,locpos(gene),pedigree,actset,num,nfound,id,
     2                  fa,mo, sex,locus,numloc,numal,name,fndr,
     3                  alfrq,typed)
              write(*,'(/3a,i3,3a)') 
     2          'Coding genotypes at "', loc(gene)(1:eow(loc(gene))),
     3          '" to a number 1...',(numal*(numal+1))/2,' in "',
     4          loc(trait)(1:eow(loc(trait))), '".'  
            else 
              write(*,'(/5a)') 
     2          'Placing ranks at "', loc(gene)(1:eow(loc(gene))),
     3          '" in "', loc(trait)(1:eow(loc(trait))), '".'  
            end if
            call newnam(wrknum, wrkfil)
            open(TWRK,file=wrkfil,form='unformatted')
            if (loctyp(gene).le.2) then
              call factor(WRK,TWRK,locpos(trait),locpos(gene),numal,
     2               name,pedigree,actset,num,nfound,id,fa,mo,sex,
     3               locus,numloc)
            else
              call dorank(WRK,TWRK,locpos(trait),locpos(gene),pedigree,
     &               actset,num,nfound,id,fa,mo,sex,locus,numloc,
     3               value,ord)
            end if
            close(WRK,status='delete')
            close(TWRK,status='keep')
            open(WRK,file=wrkfil,form='unformatted')
          end if
C
C selection of pedigrees on name
C
        elseif (keyword.eq.'sel' .and. red .and.  keyw2.eq.'ped') then
          i=3
          typ=1
          do 66 j=3, 4
            if (words(j).eq.'not') then
              i=i+1
              typ=2
            else if (words(j).eq.'in') then
              i=i+1
            end if
   66     continue
          call newnam(wrknum, wrkfil)
          open(TWRK,file=wrkfil,form='unformatted')
          call selped(WRK,TWRK,typ,i,narg,words, pedigree,actset,num,
     &                nfound, id,fa,mo,sex,locus,numloc,plevel)
          close(WRK,status='delete')
          close(TWRK,status='keep')
          open(WRK,file=wrkfil,form='unformatted')
        elseif (keyword.eq.'pri' .and. red .and. keyw2.eq.'ped') then
          i=narg+2
          do 67 j=3, narg
          if (words(j).eq.'id') then
            i=j+1
          end if
   67     continue
          call showdata(WRK,3,i,narg,words,nloci,loc,loctyp,locpos,
     &            pedigree,actset,num,nfound,id,fa,mo,sex,locus,numloc)
C
C selection of pedigrees on logical expression 
C eg given trait value or pedigree size
C
        elseif (keyword.eq.'sel' .and. red) then
          call args(lin,narg,words,2)
          if ((keyw2.eq.'con' .or. keyw2.eq.'exa') .and.
     &        words(4)(1:3).eq.'whe') then
            typ=4
            nprob=ival(words(3))
            if (nprob.eq.0 .or. keyw2.eq.'exa') typ=typ+1
            i=5
          else
            typ=3
            nprob=1
            i=2
            if (keyw2.eq.'whe') i=i+1
          end if
          call typwords(i,narg,words,nloci,loc,loctyp,token,env,
     &                  wtyp,expr,actn)
          if (actn.eq.0) then
            write(*,'(/a)') 'ERROR: Could not parse condition.'
          else
            call newnam(wrknum, wrkfil)
            open(TWRK,file=wrkfil,form='unformatted')
            call select(WRK,TWRK,typ,nprob,i,narg,words,nloci,loc,
     2             loctyp,locpos,token,env,lbp,rbp,op,wtyp,expr,
     3             pedigree,actset,num,nfound,id,fa,mo,sex,locus,numloc,
     4             nobs,plevel)
            close(WRK,status='delete')
            close(TWRK,status='keep')
            open(WRK,file=wrkfil,form='unformatted')
          end if
        elseif ((keyword.eq.'uns' .or. keyword.eq.'pac').and. red) then
            typ=1
            if (keyword.eq.'pac') typ=2
            call newnam(wrknum, wrkfil)
            open(TWRK,file=wrkfil,form='unformatted')
            call unsel(WRK,TWRK,typ,pedigree,actset,num,nfound,
     &              id,fa,mo,sex,locus,numloc,nobs,plevel)
            close(WRK,status='delete')
            close(TWRK,status='keep')
            open(WRK,file=wrkfil,form='unformatted')
C count pedigrees, sibships on simple expression
        elseif ((keyword.eq.'cou' .or. keyword.eq.'pri') .and. red) then
          typ=1
          if (keyword.eq.'pri') typ=2
          call args(lin,narg,words,2)
          i=2
          if (keyw2.eq.'whe') i=i+1
          call typwords(i,narg,words,nloci,loc,loctyp,token,env,
     &                  wtyp,expr,actn)
          if (actn.eq.0) then
            write(*,'(/a)') 'ERROR: Could not parse condition.'
          else
            call docount(WRK,typ,i,narg,words,nloci,loc,loctyp,locpos,
     2            token,env,lbp,rbp,op,wtyp,expr,pedigree,actset,
     3            num,nfound,id,fa,mo,sex,locus,numloc,plevel)
          end if
C recmin haplotypes
        elseif (keyword.eq.'hap' .and. red) then
          call gettrait(words(2),4,0,nloci,loc,loctyp,trait)
          write(*,'(/a/a/a)')
     2    '------------------------------------------------',
     3    'Summary of sibship haplotypes',
     4    '------------------------------------------------' 
          open(WRK2,file=wrk2fil,form='unformatted')
          call dohaplo(WRK,WRK2,trait,iter,nloci,loc,loctyp,locpos,
     2           pedigree,actset,num,nfound,id,fa,mo,sex,locus,numloc,
     3           hset,showorig)
          close(WRK2,status='delete')
C pedigree listing
        elseif (keyword.eq.'gen' .and. red) then
          call gettrait(words(2),3,0,nloci,loc,loctyp,trait)
          write(*,'(/a/a/a)')
     2    '------------------------------------------------',
     3    'Summary of structure of pedigrees',
     4    '------------------------------------------------' 
          if (trait.ne.MISS) then
            write(*,'(3a/)') 
     2        'NOTE:  Writing generation number to ',
     3        loc(trait)(1:eow(loc(trait))),'.'
            trait=locpos(trait)
            call newnam(wrknum, wrkfil)
            open(TWRK,file=wrkfil,form='unformatted')
            call dogen(WRK,TWRK,pedigree,actset,num,nfound,id,fa,mo,sex,
     &                 locus, numloc,ord,set,trait,plevel)
            close(WRK,status='delete')
            close(TWRK,status='keep')
            open(WRK,file=wrkfil,form='unformatted')
          else
            call dogen(WRK,TWRK,pedigree,actset,num,nfound,id,fa,mo,sex,
     &                 locus, numloc,ord,set,trait,plevel)
          end if
C HWE chi-squares
        elseif (keyword.eq.'hwe' .and. red) then
          if (keyw2.eq.'fou') then
            assfnd=.true.
          else
            assfnd=.false.
          end if

          write(*,'(/a/a/a)')
     2    '--------------------------------------------------',
     3    'Hardy-Weinberg equilibrium for all marker loci',
     4    '--------------------------------------------------'
          if (assfnd) then
            write(*,'(a/)') 
     &        'NOTE:  Analysis restricted to founders only.'
          end if
          if (plevel.lt.1) then
            write(*,'(/a/a)')
     2      'Marker     Typed  Genos  Chi-square Asy P  Emp P  Iters',
     3      '---------- ------ ------ ---------- ------ ------ ------'
          end if
          do 219 i=1,nloci
          if (loctyp(i).eq.1) then
            call freq(WRK,locpos(i),pedigree,actset,num,nfound,id,fa,mo,
     &                sex, locus,numloc,numal,name,fndr,alfrq,typed)
            call accum(numal,alfrq,cumfrq)
            open(WRK2,file=wrk2fil,form='unformatted')
            call dohwe(WRK,WRK2,loc(i),locpos(i),iter,mincnt,assfnd,
     2             pedigree,actset,num,nfound,id,fa,mo,sex,locus,numloc,
     3             numal,name,cumfrq,set,untyped,ngcount,gcount,plevel)
            close(WRK2,status='delete')
            if (plevel.gt.0) then
              call domar(WRK,locpos(i),pedigree,actset,num,nfound,id,fa,
     &                   mo,sex, locus,numloc,numal,name,alfrq,plevel)
            end if
          end if
  219     continue
C LD chi-squares
        elseif (keyword.eq.'dis' .and. red) then
          call gettrait(words(2),1,2,nloci,loc,loctyp,trait)
          call gettrait(words(3),1,2,nloci,loc,loctyp,gene)
          write(*,'(/a/a/a/)')
     2      '---------------------------------------------------',
     3      'Inter-marker allelic association analysis',
     4      '---------------------------------------------------' 
          if (plevel.lt.1) then
            write(*,'(a/a)') 
     2      'Marker 1   Marker 2      N mean D''  Chi-sq  df Asy P',
     3      '---------- ---------- ---- -------- ------ --- ------'
          end if

          if (trait.ne.MISS) then
            call freq(WRK,locpos(trait),pedigree,actset,num,nfound,id,
     2                fa,mo, sex,locus,numloc,numal,name,fndr,
     3                alfrq,typed)
            if (gene.ne.MISS .and. loctyp(trait).eq.loctyp(gene)) then
              typ=loctyp(trait)
              call freq(WRK,locpos(gene),pedigree,actset,num,nfound,id,
     2                  fa,mo, sex,locus,numloc,numal2,name2,
     3                  fndr,alfrq2,typed)
              call twold(WRK,typ,locpos(trait),loc(trait),locpos(gene),
     2             loc(gene),iter,pedigree,actset,num,nfound,id,fa,mo,
     3             sex,locus,numloc,numal,name,alfrq,numal2,name2,
     4             alfrq2,untyped,ngcount,gcount,gfrq,plevel)
            else
              do 430 i=1,nloci
              if ((loctyp(i).eq.1 .or. loctyp(i).eq.2) .and.
     &            i.ne.trait .and. loctyp(trait).eq.loctyp(gene)) then
                typ=loctyp(i)
                call freq(WRK,locpos(trait),pedigree,actset,num,nfound,
     2                    id,fa,mo,sex,locus,numloc,numal,name,fndr,
     3                    alfrq,typed)
                call freq(WRK,locpos(i),pedigree,actset,num,nfound,id,
     2                    fa,mo, sex,locus,numloc,numal2,name2,fndr,
     3                    alfrq2,typed)
                call twold(WRK,typ,locpos(trait),loc(trait),locpos(i),
     2             loc(i),iter,pedigree,actset,num,nfound,id,fa,mo,sex,
     3             locus,numloc,numal,name,alfrq,numal2,name2,alfrq2,
     4             untyped,ngcount,gcount,gfrq,plevel)
              end if
 430          continue
            end if
          else
            do 431 i=1,nloci
            if (loctyp(i).eq.1 .or. loctyp(i).eq.2) then
              typ=loctyp(i)
              if (trait.ne.MISS .and. loctyp(trait).eq.typ) then
                call freq(WRK,locpos(trait),pedigree,actset,num,nfound,
     2             id,fa,mo,sex,locus,numloc,numal,name,fndr,alfrq,
     3             typed)
                call freq(WRK,locpos(i),pedigree,actset,num,nfound,id,
     2                    fa,mo, sex,locus,numloc,numal2,name2,fndr,
     3                    alfrq2,typed)
                call twold(WRK,typ,locpos(trait),loc(trait),locpos(i),
     2             loc(i),iter,pedigree,actset,num,nfound,id,fa,mo,sex,
     3             locus,numloc,numal,name,alfrq,numal2,name2,alfrq2,
     4             untyped,ngcount,gcount,gfrq,plevel)
                trait=i
              else
                trait=i
              end if
            end if
 431        continue
          end if
C association analysis (ANOVA or chi-square)
        elseif (keyword.eq.'ass' .and. red) then
          call gettrait(words(2),3,4,nloci,loc,loctyp,trait)
          assfnd=.false.
          gt=.true.
          thresh=MISS
          typ=1
C while not end of list of keywords
          i=3
  441     if (i.gt.narg) goto 442
            keyword=words(i)(1:3)
            if (keyword.eq.'ove') then
              thresh=fval(words(i+1))
              i=i+2
            elseif (keyword.eq.'und') then
              gt=.false.
              thresh=fval(words(i+1))
              i=i+2
            elseif (keyword.eq.'gen') then
              typ=2
              i=i+1
            elseif (keyword.eq.'fou') then
              assfnd=.true.
              i=i+1
            else
              i=i+1
            end if  
            goto 441
  442     continue
          if (trait.ne.MISS) then
            write(*,'(/a/a,a10,a/a)')
     2      '--------------------------------------------------',
     3      'Allelic association testing for trait "',loc(trait),'"',
     4      '--------------------------------------------------'
            if (assfnd) then
              write(*,'(a/)') 
     &          'NOTE:  Analysis restricted to founders only.'
            end if
            if (thresh.ne.MISS) then
              if (gt) then
                write(*,'(a,f9.4/)') 
     &            'NOTE:  Proband defined as trait value > ',thresh
              else
                write(*,'(a,f9.4/)') 
     &            'NOTE:  Proband defined as trait value < ',thresh
              end if
            end if
            if (typ.eq.2) then
              write(*,'(a/)') 
     &          'NOTE:  Genotypic rather than allelic association test.'
            end if
            if (plevel.lt.1) then
              write(*,'(/a/a)')
     2      'Marker     Typed  Allels Chi-square Asy P  Emp P  Iters',
     3      '---------- ------ ------ ---------- ------ ------ ------'
            end if
            do 600 i=1,nloci
            if (loctyp(i).eq.1) then
              call freq(WRK,locpos(i),pedigree,actset,num,nfound,id,fa,
     2                  mo,sex, locus,numloc,numal,name,fndr,
     3                  alfrq,typed)
              call accum(numal,alfrq,cumfrq)
              open(WRK2,file=wrk2fil,form='unformatted')
              if (loctyp(trait).eq.3 .and. thresh.eq.MISS) then
                call doanova(WRK,WRK2,locpos(trait),loc(i),locpos(i),
     2                   iter,mincnt,assfnd,x,r,b,cov,pedigree,actset,
     3                   num,nfound,id,fa,mo,sex,locus,numloc,numal,
     4                   name,cumfrq,untyped,value,key2,set,plevel)
                close(WRK2,status='delete')
                open(WRK2,file=wrk2fil,form='unformatted')
                call qtdt(WRK,WRK2,locpos(trait),loc(i),locpos(i),
     2                iter,mincnt,x,r,b,cov,pedigree,actset,num,nfound,
     3                id,fa,mo,sex,locus,numloc,numal,name,
     4                untyped,value,key2,set,plevel)
              else
                call doassoc(WRK,WRK2,locpos(trait),loc(i),locpos(i),
     2                   iter,mincnt,assfnd,gt,thresh,pedigree,actset,
     3                   num,nfound,id,fa,mo,sex,locus, numloc,numal,
     4                   name,cntall,cumfrq,key1,untyped,set,plevel,typ)
                close(WRK2,status='delete')
                open(WRK2,file=wrk2fil,form='unformatted')
                call rctdt(WRK,WRK2,locpos(trait),loc(i),locpos(i),
     2                   iter,mincnt,gt,thresh,pedigree,actset,
     3                   num,nfound,id,fa,mo,sex,locus,numloc,numal,
     4                   name,cntall,key1,set,alfrq,cumfrq,gfrq,plevel)
              end if
              close(WRK2,status='delete')
            end if
  600       continue
          end if
C homozygosity analysis
        elseif (keyword.eq.'hom' .and. red) then
          call getbin(2,narg,words,nloci,loc,loctyp,trait,gt,thresh)
          if (trait.ne.MISS) then
            write(*,'(/a/a,a10,a/a)')
     2      '--------------------------------------------------',
     3      'Marker homozygosity in cases of trait "',loc(trait),'"',
     4      '--------------------------------------------------'
            if (thresh.ne.MISS) then
              if (gt) then
                write(*,'(a,f9.4/)') 
     &          'NOTE:  Proband defined as trait value > ',thresh
              else
                write(*,'(a,f9.4/)') 
     &          'NOTE:  Proband defined as trait value < ',thresh
              end if
            end if
            trait=locpos(trait)
          else
            write(*,'(/a/a/a)')
     2      '--------------------------------------------------',
     3      'Marker homozygosity in all typed individuals',
     4      '--------------------------------------------------'
          end if
          write(*,'(/a/a)')
     2    'Marker        N    Obs    Exp    Fis     Z  Emp P  Iters',
     3    '---------- ---- ------ ------ ------ ------ ------ ------'
          do 660 i=1,nloci
          if (loctyp(i).eq.1) then
            call freq(WRK,locpos(i),pedigree,actset,num,nfound,id,fa,mo,
     &                sex,
     2                locus,numloc,numal,name,fndr,alfrq,typed)
            call accum(numal,alfrq,cumfrq)
            open(WRK2,file=wrk2fil,form='unformatted')
            call dohomoz(WRK,WRK2,trait,loc(i),locpos(i),
     2                  iter,mincnt,gt,thresh,pedigree,actset,num,
     3                  nfound,id,fa,mo,sex,locus,numloc,numal,alfrq,
     4                  cumfrq,untyped,set,plevel)
            close(WRK2,status='delete')
          end if
  660     continue
C Schaid and Sommer
        elseif (keyword.eq.'sch' .and. red) then
          call gettrait(words(2),4,0,nloci,loc,loctyp,trait)
          call gettrait(words(3),1,0,nloci,loc,loctyp,gene)
          candal=fval(words(4))
          if (trait.ne.MISS .and. gene.ne.MISS) then
            write(*,'(/a/a,a10,a/a)')
     2      '--------------------------------------------------',
     3      'Schaid & Sommer HWE analysis of trait "',loc(trait),'"',
     4      '--------------------------------------------------'
            call freq(WRK,locpos(gene),pedigree,actset,num,nfound,id,fa,
     2                mo,sex,
     3                locus,numloc,numal,name,fndr,alfrq,typed)
            if (candal.le.0.0d0) then
              candal=float(topall(numal,name,alfrq) )
            end if
            write(*,'(a,i3,2a)') 
     &        'Versus allele ',int(candal),' of marker ',loc(gene)
            call nucseg(WRK,locpos(trait),locpos(gene),candal,
     2             x,r,b,cov,pedigree,actset,num,nfound,id,fa,mo,sex,
     3             locus, numloc, key, plevel)
          end if
C TDTs
        elseif (keyword.eq.'tdt'.and.red) then
          call getbin(2,narg,words,nloci,loc,loctyp,trait,gt,thresh)
          cutoff=0
          typ=3
C while not end of list of keywords
          i=3
  318     if (i.gt.narg) goto 319
            keyword=words(i)(1:3)
            if (keyword.eq.'cut') then
              cutoff=ival(words(i+1))
              i=i+2
            elseif (keyword.eq.'mat') then
              typ=1
              i=i+1
            elseif (keyword.eq.'pat') then
              typ=2
              i=i+1
            else
              i=i+1
            end if  
            goto 318
  319     continue
C
          if (trait.ne.MISS) then
            write(*,'(/a/a,a10,a/a/)')
     2      '------------------------------------------------',
     3      'TDT for trait "',loc(trait),'" v. all markers',
     4      '------------------------------------------------'
            if (typ.eq.1) then
                write(*,'(a/)') 'NOTE:  Maternal contributions only.'
            elseif (typ.eq.2) then
                write(*,'(a/)') 'NOTE:  Paternal contributions only.'
            end if
            if (thresh.ne.MISS) then
              if (gt) then
                write(*,'(a,f9.4/)') 
     &            'NOTE:  Proband defined as trait value > ',thresh
              else
                write(*,'(a,f9.4/)') 
     &            'NOTE:  Proband defined as trait value < ',thresh
              end if
            end if
            if (plevel.lt.1) then
              write(*,'(/a/a)')
     2        'Marker     Typed  NParam Chi-square Asy P  Emp P  Iters',
     3        '---------- ------ ------ ---------- ------ ------ ------'
            end if
            do 20 i=1,nloci
            if (loctyp(i).eq.1 .or. loctyp(i).eq.2) then
              call freq(WRK,locpos(i),pedigree,actset,num,nfound,id,fa,
     &                  mo,sex,locus,numloc,numal,name,fndr,alfrq,typed)
              open(WRK2,file=wrk2fil,form='unformatted')
              call dotdt(WRK,WRK2,locpos(trait),loc(i),locpos(i),iter,
     2               mincnt,use2,typ,cutoff,gt,thresh,pedigree,actset,
     3               num,nfound,id,fa,mo,sex,locus,numloc,numal,name,
     4               untyped,set,nallele,cntall,ngcount,gcount,plevel)
              close(WRK2,status='delete')
            end if
   20       continue
          end if
C descriptive statistics for traits
        elseif ((keyword.eq.'fre' .or. keyword.eq.'des')
     2          .and. red)  then
          call loadnam(2,narg,words,nloci,loc,loctyp,locord,nmark,ord,1)
          do 19 i=1,nmark
            j=ord(i)
            if (loctyp(j).eq.1 .or. loctyp(j).eq.2) then
              call freq(WRK,locpos(j),pedigree,actset,num,nfound,id,fa,
     &                  mo,sex,locus,numloc,numal,name,fndr,alfrq,typed)
              call wrfreq(WRK2,loc(j),numal,name,alfrq,map(i),
     &               typed,nobs,1)
            elseif (loctyp(j).eq.3) then
              call famcor(WRK,loc(j),locpos(j),pedigree,actset,num,
     &               nfound,id,fa,mo,sex, locus, numloc,plevel)
            elseif (loctyp(j).eq.4) then
              call segrat(WRK,loc(j),locpos(j),pedigree,actset,num,
     &               nfound,id,fa,mo,sex, locus, numloc)
            end if
   19     continue
C Corrected segregation ratios following Davie 1976
        elseif (keyword.eq.'dav'.and.red) then
          call gettrait(words(2),4,0,nloci,loc,loctyp,trait)
          call gettrait(words(3),4,0,nloci,loc,loctyp,prob)
          if (trait.ne.MISS) then
            if (prob.eq.MISS) prob=trait
            call davie(WRK,loc(trait),locpos(trait),loc(prob),
     2               locpos(prob),pedigree,actset,num,nfound,id,fa,mo,
     3               sex,locus,numloc,plevel)
          end if
C variance components analysis
        elseif (keyword.eq.'var' .and. red) then
          call gettrait(words(2),3,0,nloci,loc,loctyp,trait)
          if (trait.ne.MISS) then
            typ=2
            if (words(3).eq.'ae') typ=1
            open(WRK2,file=wrk2fil,form='unformatted')
            call varcom(WRK,WRK2,loc(trait),locpos(trait),
     2                  pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     3                  numloc,untyped,ibdcount,count2,plevel,typ)
            close(WRK2,status='delete')
          end if
C Test relative pair relatedness using mean IBS sharing 
        elseif (keyword.eq.'sha'.and.red) then
          typ=1
          if (keyw2.eq.'typ') typ=2
          open(WRK2,file=wrk2fil,form='unformatted')
          do 352 i=1,nloci
          if (loctyp(i).eq.1) then
            call freq(WRK,locpos(i),pedigree,actset,num,nfound,id,fa,mo,
     &                sex,locus,numloc,numal,name,fndr,alfrq,typed)
            call accum(numal,alfrq,cumfrq)
            write(WRK2) numal,(cumfrq(j),j=1,numal)
          end if
  352     continue
          call allibs(WRK,WRK2,iter,nloci,loc,loctyp,locpos,
     2           map,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     3           numloc,hset,ibdcount,count2,numal,cumfrq,typ,plevel)
          close(WRK2,status='delete')
C Test sib pair relatedness using mean IBS sharing 
        elseif (keyword.eq.'cki'.and.red) then
          open(WRK2,file=wrk2fil,form='unformatted')
          do 351 i=1,nloci
          if (loctyp(i).eq.1) then
            call freq(WRK,locpos(i),pedigree,actset,num,nfound,id,fa,mo,
     &                sex,locus,numloc,numal,name,fndr,alfrq,typed)
            call wrfreq(WRK2,loc(i),numal,name,alfrq,map(i),
     &                  typed,nobs,3)
          end if
  351     continue
          call ckibs(WRK,WRK2,pedigree,actset,num, nfound, id,fa,mo,sex,
     &               locus,numloc,nloci,loctyp,locpos,numal,name,alfrq)
          close(WRK2,status='delete')
C Test mixture of distributions for quantitative trait
        elseif ((keyword.eq.'mix'.or. keyword.eq.'his').and.red) then
          call gettrait(words(2),3,0,nloci,loc,loctyp,trait)
          if (trait.ne.MISS) then
            nmix=ival(words(3))
            if (keyword.eq.'his') then
              nmix=1
            elseif (nmix.lt.1 .or. nmix.gt.5) then
              nmix=2
            end if
            if (words(4)(1:3).eq.'nor') then
              typ=1
            elseif (words(4)(1:3).eq.'poo') then
              typ=2
            elseif (words(4)(1:3).eq.'exp') then
              typ=3
            elseif (words(4)(1:3).eq.'poi') then
              typ=4
            else
              typ=ival(words(4))
            end if
            if (typ.lt.1 .or. typ.gt.4) typ=1
            call domix(WRK,loc(trait),locpos(trait),nmix,typ,
     2             pedigree,actset,num,nfound,
     3             id,fa,mo,sex,locus,numloc,valu1,ord,plevel)
          end if
C Means and correlations for traits
        elseif ((keyword.eq.'mea' .or. keyword.eq.'cor') .and. red) then
          call loadnam(2,narg,words,nloci,loc,loctyp,locord,nmark,ord,1)
          call docov(WRK,nmark,ord,loc,loctyp,locpos,
     2             x,b,cov,pedigree,actset,num,nfound,id,fa,mo,sex,
     3             locus,numloc,plevel)
C Multiple linear or logistic regression of trait
        elseif ((keyword.eq.'reg' .or. keyword.eq.'imp' .or. 
     2           keyword.eq.'pre' .or. keyword.eq.'res') .and.
     3           narg.gt.3 .and. red) then
          nf=narg
          typ=0
          if (keyword.eq.'res') then
            typ=1
          elseif (keyword.eq.'imp') then
            typ=2
          elseif (keyword.eq.'pre') then
            typ=3
          end if
C any flags at end of line
          if (words(nf).eq.'complete') then
            typ=typ+10
            nf=nf-1
          end if
C first read the x variables
          call loadnam(4,nf,words,nloci,loc,loctyp,locord,nmark,ord,1)
C then read the y variable which is added onto the end of the list
          call gettrait(words(2),3,4,nloci,loc,loctyp,trait)
          if (trait.ne.MISS .and. nmark.gt.0) then
            if (loctyp(trait).eq.4) typ=4
            nmark=nmark+1
            ord(nmark)=trait
            if (typ.eq.0) then
              call regress(WRK,TWRK,typ,nmark,ord,loc,loctyp,locpos,
     2               x,r,b,cov,pedigree,actset,num,nfound,id,fa,mo,sex,
     3               locus,numloc,plevel)
            else if (typ.eq.4) then
              call binreg(WRK,WRK2,TWRK,nmark,ord,loc,loctyp,locpos,
     2               x,r,b,cov,pedigree,actset,num,nfound,id,fa,mo,sex,
     3               locus,numloc,plevel)
            else
              call newnam(wrknum, wrkfil)
              open(TWRK,file=wrkfil,form='unformatted')
              call regress(WRK,TWRK,typ,nmark,ord,loc,loctyp,locpos,
     2               x,r,b,cov,pedigree,actset,num,nfound,id,fa,mo,sex,
     3               locus,numloc,plevel)
              close(WRK,status='delete')
              close(TWRK,status='keep')
              open(WRK,file=wrkfil,form='unformatted')
            end if
          end if
C cross-tabulation
        elseif ((keyword.eq.'tab' .or. keyword.eq.'kru') .and. red) then
          typ=1
          if (keyword.eq.'kru' .and. narg.eq.3) then
            call gettrait(words(2),3,0,nloci,loc,loctyp,trait)
            call gettrait(words(3),10,0,nloci,loc,loctyp,gene)
            if (trait.ne.MISS .and. gene.ne.MISS) then
              typ=2
              nmark=2
              ord(1)=gene 
              ord(2)=trait
              call xtab(WRK,typ,nmark,ord,loc,locpos,loctyp,
     2                  pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     3                  numloc,value,vset,key1,key2,plevel)
            end if
          elseif (narg.gt.1) then
            call loadnam(2,narg,words,nloci,loc,loctyp,locord,
     &                   nmark,ord,1)
            call xtab(WRK,typ,nmark,ord,loc,locpos,loctyp,
     2                pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     3                numloc,value,vset,key1,key2,plevel)
          else
            nmark=1
            write(*,*)
            do 129 i=1,nloci
            if (loctyp(i).lt.5) then
              ord(1)=i 
              call xtab(WRK,typ,nmark,ord,loc,locpos,loctyp,
     2                pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     3                numloc,value,vset,key1,key2,plevel)
            end if
  129       continue
          end if
C APM analyses - IBD or IBS based
        elseif (keyword.eq.'apm'.and.red) then
          call getbin(2,narg,words,nloci,loc,loctyp,trait,gt,thresh)
          if (trait.ne.MISS .and. iter.gt.0) then
            typ=1
            if (words(3).eq.'ibd' .or.words(5).eq.'ibd') typ=2
            write(*,'(/a/a,a10,a/a/)')
     2      '------------------------------------------------',
     3      'APM for trait "',loc(trait),'" v. all markers',
     4      '------------------------------------------------'
            if (typ.eq.2) then
              write(*,'(a/)') 
     &          'NOTE:  Identity-by-descent based statistic used.'
            end if
            if (thresh.ne.MISS) then
              if (gt) then
                write(*,'(a,f9.4/)') 
     &            'NOTE:  Proband defined as trait value > ',thresh
              else
                write(*,'(a,f9.4/)') 
     &            'NOTE:  Proband defined as trait value < ',thresh
              end if
            end if
            if (plevel.lt.1) then
              write(*,'(/a/a)')
     2        'Marker     NFams  NAff   Z-value    Asy P  Emp P  Iters',
     3        '---------- ------ ------ ---------- ------ ------ ------'
            end if
            do 45 i=1,nloci
            if (loctyp(i).eq.1) then
              call freq(WRK,locpos(i),pedigree,actset,num,nfound,id,fa,
     &                  mo,sex,
     &                locus,numloc,numal,name,fndr,alfrq,typed)
              call accum(numal,alfrq,cumfrq)
              call doapm(WRK,locpos(trait),loc(i),locpos(i),typ,iter,
     2               burnin,gt,thresh,pedigree,actset,num,nfound,id,
     3               fa,mo,sex,locus,numloc,numal,name,alfrq,cumfrq,
     4               gfrq,set,set2,sibd,key,untyped,plevel)
            end if
   45       continue
          end if
C ASP analyses
        elseif (keyword.eq.'asp'.and.red) then
          call getbin(2,narg,words,nloci,loc,loctyp,trait,gt,thresh)
          if (trait.ne.MISS) then
            write(*,'(/a/a,a10,a/a/)')
     2      '------------------------------------------------',
     3      'IBS ASP for "',loc(trait),'" v. all marker loci',
     4      '------------------------------------------------'
            if (thresh.ne.MISS) then
              if (gt) then
                write(*,'(a,f9.4/)') 
     &            'NOTE:  Proband defined as trait value > ',thresh
              else
                write(*,'(a,f9.4/)') 
     &            'NOTE:  Proband defined as trait value < ',thresh
              end if
            end if
            if (plevel.lt.1) then
              write(*,'(a/a)')
     2        'Marker     NPairs mIBS   ExpIBS Asy P  mIBD   Asy P',
     3        '---------- ------ ------ ------ ------ ------ ------'
            end if
            do 230 i=1,nloci
            if (loctyp(i).eq.1) then
              call freq(WRK,locpos(i),pedigree,actset,num,nfound,id,fa,
     &                  mo,sex,
     &                  locus,numloc,numal,name,fndr,alfrq,typed)
              call doasp(WRK,locpos(trait),loc(i),locpos(i),gt,thresh,
     2                   pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     3                   numloc,numal,name,alfrq,ibdcount,untyped,set,
     4                   plevel)
            end if
 230        continue
          end if
C H-E sib-pair linkage analysis
        elseif ((keyword.eq.'sib' .or. keyword.eq.'he1' 
     2          .or. keyword.eq.'he2' .or. keyword.eq.'vis') .and. red)
     3  then
          call gettrait(words(2),3,4,nloci,loc,loctyp,trait)
          if (trait.ne.MISS) then
            typ=3
            words(1)='Sham S+D'
            if (keyword.eq.'he1') then
              typ=1
              words(1)='Standard'
            elseif (keyword.eq.'he2') then
              typ=1
              words(1)='CP-based'
            elseif (keyword.eq.'vis') then
              typ=4
              words(1)='V&H S+D '
            end if
            gene=MISS
            sibm=MISS
            sibr=MISS
            sibv=MISS
            weight=MISS
            mche=.false.
            i=3
  433       continue
              if (words(i).eq.'sim') then
                mche=.true.
              elseif (words(i).eq.'var') then
                i=i+1
                sibv=fval(words(i))
              elseif (words(i).eq.'sd') then
                i=i+1
                sibv=fval(words(i))**2
              elseif (words(i).eq.'mea') then
                i=i+1
                sibm=fval(words(i))
              elseif (words(i).eq.'cor') then
                i=i+1
                sibr=fval(words(i))
              else
                call gettrait(words(i),3,0,nloci,loc,loctyp,gene)
                if (gene.ne.MISS) weight=locpos(gene)
              end if
              i=i+1
            if (i.le.narg) goto 433

            write(*,'(/a/a8,a,a10,a/a)')
     2 '---------------------------------------------------------',
     3 words(1),' H-E for trait "',loc(trait),'" v. all markers',
     4 '---------------------------------------------------------'
            if (gene.ne.MISS) then
              write(*,'(3a,2(/7x,a))') 
     2          'NOTE:  Each pair contribution weighted by mean of "',
     3          loc(gene)(1:eow(loc(gene))),'"',
     4          'for each member. Weight is taken as proportional to',
     5          'the variance for that contribution (WLS).'
            end if
            if (sibr.ne.MISS) then
              write(*,'(a,f5.3)') 
     &          'NOTE:  Using trait sibling correlation provided: ',sibr
            end if
            if (sibm.ne.MISS) then
              write(*,'(a,f10.4,a,f10.4,a)') 
     2          'NOTE:  Using trait mean (SD) provided: ',
     3           sibm,' (',sqrt(sibv),')'
            end if
            if (plevel.lt.1) then
              write(*,'(/a/a)')
     2      'Marker     FSibs  HSibs  t-value    Asy P  Emp P  Iters',
     3      '---------- ------ ------ ---------- ------ ------ ------'
            end if
            do 30 i=1,nloci
            if (loctyp(i).eq.1) then
              call freq(WRK,locpos(i),pedigree,actset,num,nfound,id,fa,
     &                  mo,sex,
     &                  locus,numloc,numal,name,fndr,alfrq,typed)
              call accum(numal,alfrq,cumfrq)
              open(WRK2,file=wrk2fil,form='unformatted')
              call sibpair(WRK,WRK2,loc(trait),locpos(trait),
     2               loc(i),locpos(i),typ,sibm,sibr,sibv,
     3               mche,iter,mincnt,weight,pedigree,actset,num,nfound,
     4               id,fa,mo,sex,locus,numloc,numal,name,alfrq,cumfrq,
     5               ibdcount,untyped,set,plevel)
              close(WRK2,status='delete')
            end if
  30        continue
          end if
C VC QTL linkage analysis
        elseif (keyword.eq.'qtl'.and.red) then
          call gettrait(words(2),3,4,nloci,loc,loctyp,trait)
          if (trait.ne.MISS) then
            write(*,'(/a/a,a10,a/a)')
     2 '---------------------------------------------------------',
     3 'VC linkage analysis for trait "',loc(trait),'" v. all markers',
     4 '---------------------------------------------------------'
            if (plevel.lt.1) then
              write(*,'(/a/a)')
     2      'Marker     FSibs  HSibs  lod score  Asy P  Emp P  Iters',
     3      '---------- ------ ------ ---------- ------ ------ ------'
            end if
            do 130 i=1,nloci
            if (loctyp(i).eq.1) then
              call freq(WRK,locpos(i),pedigree,actset,num,nfound,id,fa,
     &                  mo,
     &                  sex,locus,numloc,numal,name,fndr,alfrq,typed)
              open(WRK2,file=wrk2fil,form='unformatted')
              call sibqtl(WRK,WRK2,loc(trait),locpos(trait),
     2               loc(i),locpos(i),pedigree,actset,num,nfound,
     3               id,fa,mo,sex,locus,numloc,numal,name,alfrq, 
     4               untyped,set,ibdcount,count2,plevel)
              close(WRK2,status='delete')
            end if
 130        continue
          end if
C sib-pair linkage between markers after Elston
        elseif (keyword.eq.'lin'.and.red) then
          write(*,'(/a/a/a//a/a)')
     2 '---------------------------------------------------',
     3 'Inter-marker sib pair linkage analysis',
     4 '---------------------------------------------------',
     5 'Marker 1   Marker 2   Sibships Sibpairs  r(IBD) Recomb',
     6 '---------- ---------- -------- --------  ------ -------'
          call gettrait(words(2),1,0,nloci,loc,loctyp,trait)
          call gettrait(words(3),1,0,nloci,loc,loctyp,gene)
          if (trait.ne.MISS) then
            call freq(WRK,locpos(trait),pedigree,actset,num,nfound,
     2             id,fa,mo,sex,locus,numloc,numal,name,fndr,alfrq,
     3             typed)
            if (gene.ne.MISS) then
              call freq(WRK,locpos(gene),pedigree,actset,num,nfound,
     2             id,fa,mo,sex,locus,numloc,numal2,name2,fndr,alfrq2,
     3             typed)
              call twopoi(WRK,locpos(trait),loc(trait),numal,name,alfrq,
     2           locpos(gene), loc(gene), numal2, name2, alfrq2,
     3           pedigree,actset,num,nfound, id, fa, mo, sex, locus,
     4           numloc, ibdcount,count2,untyped,set,set2,plevel)
            else
              do 330 i=1,nloci
              if (loctyp(i).eq.1 .and. i.ne.trait) then
                call freq(WRK,locpos(i),pedigree,actset,num,nfound,id,
     2                 fa,mo,
     3                 sex,locus,numloc,numal2,name2,fndr,alfrq2,typed)
                call twopoi(WRK,locpos(trait),loc(trait),numal,name,
     2                 alfrq,locpos(i), loc(i), numal2, name2, alfrq2,
     3                 pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     4                 numloc, ibdcount,count2,untyped,set,set2,plevel)
              end if
 330          continue
            end if
          else
            do 331 i=1,nloci
            if (loctyp(i).eq.1) then
              if (trait.ne.MISS) then
                call freq(WRK,locpos(trait),pedigree,actset,num,nfound,
     2             id,fa,mo,sex,locus,numloc,numal,name,fndr,alfrq,
     3             typed)
                call freq(WRK,locpos(i),pedigree,actset,num,nfound,id,
     &                    fa,mo,
     &               sex,locus,numloc,numal2,name2,fndr,alfrq2,typed)
                call twopoi(WRK,locpos(trait),loc(trait),numal,name,
     2               alfrq,locpos(i), loc(i), numal2, name2, alfrq2,
     3               pedigree,actset,num,nfound, id, fa, mo, sex, locus,
     4               numloc, ibdcount,count2,untyped,set,set2,plevel)
                trait=i
              else
                trait=i
              end if
            end if
 331        continue
          end if
C Interval H-E
        elseif (keyword.eq.'two'.and.red) then
          trait=MISS
          nmark=0
          do 27 i=1,nloci
          do 27 j=2,narg
          if (words(j).eq.loc(i)) then
             if (loctyp(i).eq.3 .or. loctyp(i).eq.4) then
               trait=i
             elseif (loctyp(i).eq.1 .and. nmark.lt.2) then
               nmark=nmark+1
               twomark(nmark)=i
             end if
          end if
          th12=fval(words(5))
   27     continue
          write(*,'(/a/a,a10,a,a10,a,a10,a/a/)')
     2   '------------------------------------------------------------',
     3   '2-point trait "',loc(trait),'" v. loci "',loc(twomark(1)),
     4   '", "',loc(twomark(2)),'"',
     5   '------------------------------------------------------------'
          write(*,'(3a)') 'Theta12 Theta1 Theta2   N     Pi',
     2                    '      Intcpt      Slope      t-value',
     3                    '  P-value'
          call freq(WRK,locpos(twomark(1)),pedigree,actset,num,nfound,
     2              id,fa,mo,sex,locus,numloc,numal,name,fndr,alfrq,
     3              typed)
          call freq(WRK,locpos(twomark(2)),pedigree,actset,num,nfound,
     2              id,fa,mo,sex,locus,numloc,numal2,name2,fndr,alfrq2,
     3              typed)
C
C No interference 
          do 35 i=0,5
            th1=0.2*th12*float(i)
            th2=th12-th1+2.0*th1*th12
            call twopair(WRK,locpos(trait),locpos(twomark(1)),
     2                   locpos(twomark(2)),th1, th2, th12,
     3                   pedigree,actset,num,nfound,id,fa,mo,sex,locus, 
     4                   numloc, numal,name,alfrq,numal2,name2,alfrq2)
   35     continue
C
C List individuals and matings with largest number of affected 
C descendants for each pedigree
C
        elseif (keyword.eq.'anc'.and.red) then
          call getbin(2,narg,words,nloci,loc,loctyp,trait,gt,thresh)
          if (trait.ne.MISS) then
            call ancest(WRK,loc(trait),locpos(trait),gt,thresh,pedigree,
     2             actset,num,nfound,id,fa,mo,sex,locus,numloc,ord,
     3             plevel)
          end if 
C kinship and inbreeding coefficients
        elseif (keyword.eq.'kin'.and.red) then
          typ=1
          if (keyw2.eq.'pai') typ=2
          if (keyw2.eq.'inb') typ=3
          call dokin(WRK,typ,pedigree,actset,num,nfound,id,fa,mo,sex,
     &               locus,numloc,ibdcount)
C IBD matrices
        elseif ((keyword.eq.'ibd'.or.keyword.eq.'ibs').and.red) then
          call gettrait(words(2),1,0,nloci,loc,loctyp,gene)
          typ=1
          if (keyword.eq.'ibs') typ=typ+2
          if (words(3)(1:3).eq.'pai') typ=typ+1
          if (gene.ne.MISS .and. iter.gt.0) then
            write(*,'(/a/3a,a10,a/a)')
     2       '------------------------------------------------',
     3       'Estimated ',keyword,' sharing at locus "',loc(gene),'"',
     4       '------------------------------------------------' 
            if (mod(typ,2).eq.0) then
              write(*,'(a//a/)') 
     2          'NOTE:  Writing one relative pair per record',
     3          'Pedigree   Person-1 Person-2   ibd'
            end if
            call freq(WRK,locpos(gene),pedigree,actset,num,nfound,id,fa,
     &                mo,sex, locus,numloc,numal,name,fndr,alfrq,typed)
            call wribd(WRK,locpos(gene),iter,burnin,typ,
     2                 pedigree,actset,num,nfound,id,fa,mo,sex,locus, 
     3                 numloc,numal,name,alfrq,gfrq,untyped,
     4                 set,set2,sibd,key,ibdcount,plevel)
          end if
C
C write out locus file
        elseif (keyword.eq.'wri'.and. keyw2.eq.'loc') then
          if (words(3).eq.'gas') then
            outfil=words(4)
            open(OSTR,file=outfil)
            write(*,'(/2a)') 
     &        'Writing GAS type locus file: ',outfil
            do 60 i=1,nloci
            if (loctyp(i).eq.1) then
              call freq(WRK,locpos(i),pedigree,actset,num,nfound,id,
     &                  fa,mo,
     &                  sex,locus,numloc,numal,name,fndr,alfrq,typed)
              write(OSTR,'(1x,3a)') 'set locus ',loc(i),' named'
              call wrfreq(OSTR,loc(i),numal,name,alfrq,map(i),
     &                    typed,nobs,4)
              write(OSTR,'(a2)') ' ;'
            else if (loctyp(i).eq.3) then
              write(OSTR,'(1x,3a/1x,a/1x,a)') 
     2          'set locus ',loc(i),' quantitative',
     3          '2 eqfreq', 'nostat ;'
            else if (loctyp(i).eq.4) then
              write(OSTR,'(1x,3a/1x,a/1x,a/1x,a)') 
     2          'set locus ',loc(i),' affection',
     3          '2 eqfreq','1', '0.1 0.1 0.1 ;'
            end if
   60       continue
          elseif (words(3)(1:3).eq.'sib') then
            outfil=words(4)
            if (narg.eq.4) words(5)=pedfil
            open(OSTR,file=outfil)
            write(*,'(/2a)') 
     &        'Writing Sib-pair type script: ',outfil
            do 61 i=1,nloci
            if (loctyp(i).le.2) then
              if (map(i).ne.MISS) then
                write(OSTR,'(3(a,1x),f8.2)') 
     &            'set locus',loc(i),cmark(loctyp(i)), map(i)
              else
                write(OSTR,'(3(a,1x))') 
     &            'set locus ',loc(i),cmark(loctyp(i))
              end if
            else if (loctyp(i).eq.3) then
              write(OSTR,'(3a)') 'set locus ',loc(i),' quantitative' 
            else if (loctyp(i).eq.4) then
              write(OSTR,'(3a)') 'set locus ',loc(i),' affection' 
            end if
   61       continue
            write(OSTR,'(2a/a)') 'read pedigree ',words(5),'run'
          elseif (words(3)(1:3).eq.'mer') then
            outfil=words(4)
            open(OSTR,file=outfil)
            write(*,'(/2a)') 
     &        'Writing MERLIN locus file: ',outfil
            do 62 i=1,nloci
            if (loctyp(i).le.2) then
              write(OSTR,'(2a)') 'M ',loc(i)
            else if (loctyp(i).eq.3) then
              write(OSTR,'(2a)') 'T ',loc(i)
            else if (loctyp(i).eq.4) then
              write(OSTR,'(2a)') 'A ',loc(i)
            end if
   62       continue
          elseif (words(3)(1:3).eq.'lin' .or. words(3)(1:2).eq.'gh') 
     &    then
            outfil=words(4)
            typ=0
            if (words(5)(1:3).eq.'dum') then
              typ=1
            end if
            if (words(3)(1:2).eq.'gh') then
              typ=3-typ
            elseif (words(5)(1:2).eq.'gh') then
              typ=2
              if (words(6)(1:2).eq.'no') typ=3
            end if
            xlin=0
            if (words(5)(1:3).eq.'xli') xlin=1
            call lorder(typ,nloci,loctyp,nord,locord)
            open(OSTR,file=outfil)
            write(*,'(/2a)') 
     &        'Writing LINKAGE type locus file: ',outfil
            call cntmark(nloci,loctyp,nmark,5)
            if (typ.eq.1 .or. typ.eq.2) nmark=nmark+1

            write(OSTR,'(4i3/a/100(i3,1x):)')
     &        nmark,0,xlin,5,'0 0.0 0.0 0',(i,i=1,nmark)
            if (typ.eq.1 .or. typ.eq.2) then
              write(*,'(a)') 'First locus is a dummy binary trait.'
              write(OSTR,'(i1,1x,i5,a/2(f8.6,1x)/i5/3(f8.6,1x))') 
     2          1, 2, ' # Dummy ', 0.5, 0.5, 1, 0.5, 0.5, 0.5
              if (xlin.eq.1) then
                write(OSTR,'(2(f8.6,1x))') 0.0, 0.0
              end if
            end if
            do 65 k=1,nord 
            i=locord(k)
            if (loctyp(i).le.2) then
              call freq(WRK,locpos(i),pedigree,actset,num,nfound,id,
     &                  fa,mo,
     &                  sex,locus,numloc,numal,name,fndr,alfrq,typed)
              call wrfreq(OSTR,loc(i),numal,name,alfrq,map(i),
     &                    typed,nobs,8)
            else if (loctyp(i).eq.3) then
              write(OSTR,
     2        '(i1,1x,i5,a,a10/2(f8.6,1x)/f8.6/3(f8.6,1x)/f8.6/f8.6)')
     3          0, 2, ' # ',loc(i), 0.1, 0.9, 1.0, 
     4          1.0, 1.0, 1.0, 1.0, 1.0
            else if (loctyp(i).eq.4) then
              write(OSTR,'(i1,1x,i5,a,a10/2(f8.6,1x)/i5/3(f8.6,1x))') 
     2          1, 2, ' # ',loc(i), 0.99, 0.01, 1, 0.05, 0.5, 0.5
              if (xlin.eq.1) then
                write(OSTR,'(2(f8.6,1x))') 0.0, 0.0
              end if
            end if
   65       continue
            write(OSTR,'(a)') '0 0'
            call wrmap(OSTR,typ,mapf,nloci,loc,loctyp,nord,locord,map)
            write(OSTR,'(/a)') '0.1 0.5'
          elseif (words(3)(1:3).eq.'sag') then
            outfil=words(4)
            open(OSTR,file=outfil)
            write(*,'(/2a)') 
     &        'Writing SAGE type locus file: ',outfil
            do 70 i=1,nloci
            if (loctyp(i).eq.1) then
              call freq(WRK,locpos(i),pedigree,actset,num,nfound,id,
     2               fa,mo,sex,locus,numloc,numal,name,fndr,
     3               alfrq,typed)
              call wrfreq(OSTR,loc(i),numal,name,alfrq,map(i),
     &                    typed,nobs,5)
            end if
   70       continue
          elseif (words(3)(1:3).eq.'lok') then
            outfil=words(4)
            lin=words(5)
            if (narg.eq.4) lin=pedfil
            open(OSTR,file=outfil)
            write(*,'(/2a)') 
     &        'Writing Loki prep type control file: ',outfil
            write(OSTR,'(3a/a/a/3a,$)') 
     2        '/* Loki type control file for ', lin(1:eow(lin)),
     3        ' */','/* Written by Sib-pair */', 'MISSING "x"', 
     4        'FILE "',lin(1:eow(lin)),
     5        '", fam, id, father, mother, sx'
            trait=1
            length=80
            do 72 i=1,nloci
              call addlet(loc(i), lin)
              j=eow(lin)
              if (loctyp(i).eq.1) then
                write(OSTR,'(5a,$)') 
     &            ', ',lin(1:j),'_A, ',lin(1:j),'_B' 
                length=length+2*j+8
              elseif (loctyp(i).eq.3 .or. loctyp(i).eq.4) then
                write(OSTR,'(2a,$)') ', ',lin(1:j)
                length=length+j+2
                if (loctyp(i).gt.2 .and. trait.eq.1) trait=i
              end if
              if (length.gt.67) then
                write(OSTR,'(/a,$)') '      '
                length=6
              end if
   72       continue
            write(OSTR,'(/a)') 'PEDIGREE fam, id, father, mother'
            write(OSTR,'(/a)') 'SEX sx "m","f"'
            do 73 i=1,nloci
            if (loctyp(i).eq.1) then
              call addlet(loc(i), lin)
              j=eow(lin)
              write(OSTR,'(7a)') 'MARKER LOCUS ',lin,
     &                   '[',lin(1:j),'_A, ',lin(1:j),'_B]'
            end if
   73       continue
            write(OSTR,'(/a,$)') 'LINK "chrom A"'
            length=15
            do 74 i=1,nloci
            if (loctyp(i).eq.1) then
              call addlet(loc(i), lin)
              j=eow(lin)
              write(OSTR,'(2a,$)') ', ',lin(1:j)
              length=length+j+3
              if (length.gt.70) then
                write(OSTR,'(/a,$)') '      '
                length=6
              end if
            end if
   74       continue
            write(OSTR,*)
            if (loctyp(trait).eq.4) then
              j=eow(loc(trait))
              write(OSTR,'(2a/3a)') 'DISCRETE ',loc(trait),
     &          'AFFECTED WHERE (',loc(trait)(1:j),'="y")'
            end if
            write(OSTR,'(a/3a)') 
     &        'TRAIT LOCUS qtl','MODEL ',loc(trait),'= qtl'
          elseif (words(3).eq.'pap') then
            open(OSTR,file='header.dat')
            open(OSTR2,file='popln.dat')
            write(*,'(/a)') 
     &        'Writing PAP locus files: header.dat and popln.dat'
            gene=1
            gen2=0
            set(1,1)=1
            set(1,2)=0
            words(1)='Gender'
            do 71 i=1,nloci
            if (loctyp(i).le.2) then
              gene=gene+1
              gen2=gen2+1
              set(gene,1)=3
              set(gene,2)=gen2
              words(gene)=loc(i)
              call freq(WRK,locpos(i),pedigree,actset,num,nfound,id,
     2                  fa,mo,sex,locus,numloc,numal,name,fndr,
     3                  alfrq,typed)
              call wrfreq(OSTR2,loc(i),numal,name,alfrq,map(i),
     &                    typed,nobs,9)
            elseif (loctyp(i).eq.3) then
              gene=gene+1
              set(gene,1)=2
              set(gene,2)=0
              words(gene)=loc(i)
            elseif (loctyp(i).eq.4) then
              gene=gene+1
              gen2=gen2+1
              set(gene,1)=1
              set(gene,2)=0
              words(gene)=loc(i)
              write(OSTR2,'(a,a10/2i4,2f8.6)') 
     &          '   1     # ',loc(i),0,100,0.05,0.05
            end if
   71       continue
            if (gene.gt.39) then
              write(*,'(a)') 
     &        'ERROR: PAP phen.dat may have no more than 39 columns'
            elseif (gene.gt.0) then
              write(OSTR,'(2i4,9a8/(10a8):)') 
     &          gene,gene,(words(i),i=1,gene)
              write(OSTR,'(8x,18i4/(20i4):)') 
     &          (set(i,1),set(i,2),i=1,gene)
            end if
            write(OSTR2,*)
            close(OSTR2,status='keep')
          elseif (words(3)(1:3).eq.'men') then
            outfil=words(4)
            open(OSTR,file=outfil)
            write(*,'(/2a)') 
     &        'Writing MENDEL type locus file: ',outfil
            call lorder(4,nloci,loctyp,nord,locord)
            do 75 k=1,nord 
              i=locord(k)
              if (loctyp(i).le.2) then
                typ=7
                if (loctyp(i).eq.2) typ=10
                call freq(WRK,locpos(i),pedigree,actset,num,nfound,id,
     2                 fa,mo, sex,locus,numloc,
     3                 numal,name,fndr,alfrq,typed)
                call wrfreq(OSTR,loc(i),numal,name,alfrq,map(i),
     &                 typed,nobs,typ)
              elseif (loctyp(i).eq.4) then
                if (words(5)(1:3).eq.'tra') then
                  write(OSTR,'(2a8,2i2,i4,1x,f8.3,10(/a))') 
     2             loc(i),'AUTOSOME', 2, 2, 1, max(0.0,0.01*map(i)),
     3             '     0010.010000','     0020.990000',
     4             'AFFECTED 3','001/001','001/002','002/002',
     5             'NORMAL   3','001/001','001/002','002/002'
                else
                  write(OSTR,'(2a8,2i2,2(/a))') 
     &             loc(i),'FACTOR  ', 2, 0, 'AFFECTED  ','NORMAL    '
                end if
              end if
   75       continue
          elseif (words(3)(1:3).eq.'asp' .or. words(3)(1:3).eq.'tcl')
     &    then
            outfil=words(4)
            open(OSTR,file=outfil)
            call cntmark(nloci,loctyp,nmark,1)
            write(*,'(/2a)') 
     &        'Writing ASPEX type (tcl) locus file: ',outfil
            if (words(5)(1:3).eq.'dis') then 
              write(*,'(a)') 'Using discordant sib pairs.'
              write(OSTR,'(a)') 'set count_discordant true'
            end if
            write(OSTR,'(2(a/),a,i3,6(/a),$)')
     2    'set has_disease_data true', 'set linkage_format true',
     4    'set nloc ',nmark, 'set blank "0"', 
     5    'set discard_partial true','set truncate_sharing false',
     6    'set most_likely true', 'set show_pairs false', 'set loc {' 
            length=0
            do 85 i=1,nloci
            if (loctyp(i).le.2) then
              length=length+1
              write(OSTR,'(1x,a,$)') loc(i)(1:eow(loc(i)))
              if (length.eq.6) then
                length=0
                write(OSTR,'(/a,$)') '         '
              end if
            end if
   85       continue
            write(OSTR,'(a)') ' }'
            call wrmap(OSTR,5,mapf,nloci,loc,loctyp,nord,locord,map)
          elseif (words(3)(1:3).eq.'str') then
            if (narg.eq.4) then
              outfil='mainparams'
            else
              outfil=words(5)
            end if
            call cntmark(nloci,loctyp,nmark,1)
            write(*,'(/2a)') 
     &        'Writing STRUCTURE mainparams file to: ',outfil
            open(OSTR,file=outfil)
            write(OSTR,'(a//a/a/a)') 
     2   'mainparam written by Sib-pair.',
     3   'KEY PARAMETERS FOR THE PROGRAM structure.',
     4   'YOU WILL NEED TO SET THESE IN ORDER TO RUN THE PROGRAM.', 
     5   'VARIOUS OPTIONS CAN BE ADJUSTED IN THE FILE extraparams.'
            write(OSTR,'(a//3a/a/a,i5,a/a,i4,a)') 'Data File', 
     2   '#define INFILE ', words(4), '// (str) input data file',
     4   '#define OUTFILE results  //(str) results file',
     5   '#define NUMINDS  ', tfound ,' // (int) no. individuals',
     6   '#define NUMLOCI  ', nmark ,'  // (int) no. loci' 
            write(OSTR,'(a)') 
     2   '#define LABEL 1', '#define POPDATA 1', '#define POPFLAG 0',
     3   '#define PHENOTYPE 1','#define EXTRACOLS 0',
     4   '#define PHASEINFO 0','#define MARKOVPHASE 1',
     5   '#define MISSING -9','#define PLOIDY 2',
     6   '#define ONEROWPERIND 1', '#define MARKERNAMES 1',
     7   '#define MAPDISTANCES 1' 
            write(OSTR,'(/a/3(/a))') 'Program Parameters',
     2   '#define MAXPOPS 2 // (int) assumed no. of pops', 
     3   '#define BURNIN 2000 // (int) length of burnin period',
     4   '#define NUMREPS 2000 // (int) no. MCMC reps' 
            write(OSTR,'(/a/8(/a))') 'Command line options:',
     2   '-m mainparams', '-e extraparams', '-s stratparams', 
     3   '-K MAXPOPS', '-L NUMLOCI', '-N NUMINDS', 
     4   '-i input file','-o output file'
          elseif (words(3)(1:3).eq.'mim') then
            outfil=words(4)
            open(OSTR,file=outfil)
            write(*,'(/2a)') 
     &        'Writing header for a MIM pedigree file to: ',outfil
            call cntmark(nloci,loctyp,nmark,1)
            write(OSTR,'(2a/a/a/i5,a/i5,a)') 
     2        'MIM data file from ',pedfil,'  0.0 # missing value',
     3        '1 0.5 # genetic variance',nmark,' # number of markers',
     4         nmark-2,' # number of analyses'
            do 189 i=2,nmark-1
              write(OSTR,'(a,3(1x,i3))') '999.0 0.0 0.0',i-1,i,i+1
  189       continue
            do 190 i=1,nloci
            if (loctyp(i).eq.1) then
              call freq(WRK,locpos(i),pedigree,actset,num,nfound,id,
     &                  fa,mo,
     &                  sex,locus,numloc,numal,name,fndr,alfrq,typed)
              write(OSTR,'(a/2(f6.1,1x),i3,100(1x,f6.4):)') 
     2          loc(i),map(i),map(i),numal,(alfrq(j),j=1,numal)
            end if
  190       continue
          else
            write(*,'(a)') 'ERROR: Locus file type not supported.'
          end if
          close(OSTR,status='keep')
C
C Write map file
        elseif (keyword.eq.'wri' .and. keyw2.eq.'map') then
          if (words(3)(1:3).eq.'men') then
            outfil=words(4)
            open(OSTR,file=outfil)
            write(*,'(/2a)') 
     &        'Writing MENDEL type map file: ',outfil
            call wrmap(OSTR,4,mapf,nloci,loc,loctyp,nord,locord, map)
            close(OSTR,status='keep')
          else if (words(3)(1:3).eq.'mer') then
            outfil=words(4)
            open(OSTR,file=outfil)
            write(*,'(/2a)') 
     &        'Writing MERLIN type map file: ',outfil
            call wrmap(OSTR,6,mapf,nloci,loc,loctyp,nord,locord, map)
            close(OSTR,status='keep')
          else if (words(3)(1:3).eq.'lok') then
            outfil=words(4)
            open(OSTR,file=outfil)
            write(*,'(/2a)') 
     &        'Writing LOKI type parameter file: ',outfil
            call wrmap(OSTR,7,mapf,nloci,loc,loctyp,nord,locord, map)
            close(OSTR,status='keep')
          else
            write(*,'(a)') 'ERROR: Map file type not supported.'
          end if
          close(OSTR,status='keep')
C
C write pedigree file
        elseif (keyword.eq.'wri'.and.red) then
          if (narg.eq.1) then
            call pedhead(longnam,nwid,nloci,loc,loctyp,locpos,lin)
            call pedout(WRK,6,2,imp,nwid,ndec,longnam,
     2            pedigree,actset,num,nfound,
     3            id,fa,mo,sex,locus,nloci,loctyp,locpos,numloc,lin)
          elseif ((narg.eq.2 .and. words(2).ne.'pap') .or. 
     &        keyw2.eq.'ped' .or. words(2).eq.'gas') then
            if (narg.eq.2) then
              outfil=words(2)
            else
              outfil=words(3)
            end if
            open(OSTR,file=outfil,status='unknown')
            write(*,'(/2a)') 
     &        'Writing GAS type pedigree file: ',outfil
            call pedout(WRK,OSTR,1,imp,nwid,ndec,longnam,
     2            pedigree,actset,num,nfound,
     3            id,fa,mo,sex,locus,nloci,loctyp,locpos,numloc,lin)
          elseif (keyw2.eq.'fis') then
            outfil=words(3)
            open(OSTR,file=outfil)
            write(*,'(/2a)') 
     &        'Writing FISHER type pedigree file: ',outfil
            call lorder(4,nloci,loctyp,nord,locord)
            call wrfish(WRK,OSTR,pedigree,actset,num,nfound,id,fa,mo,
     &             sex,locus,nloci,loctyp,locpos,numloc,nord,locord,1)
          elseif (keyw2.eq.'cri') then
            outfil=words(3)
            open(OSTR,file=outfil,status='unknown')
            open(WRK2,file=wrk2fil,form='unformatted')
            call cntmark(nloci,loctyp,nmark,1)
            write(*,'(/2a)') 
     &        'Writing CRIMAP type pedigree file: ',outfil
            write(OSTR,'(2(1x,i3))') nped,nmark
            do 246 i=1,nloci
            if (loctyp(i).eq.1) then
              write(OSTR,'(a10)') loc(i)
              call freq(WRK,locpos(i),pedigree,actset,num,nfound,id,fa,
     &                  mo,sex,locus,numloc,numal,name,fndr,alfrq,typed)
              call wrfreq(WRK2,loc(i),numal,name,alfrq,map(i),
     &                    typed,nobs,3)
            end if
  246       continue
            call wrcri(WRK,WRK2,OSTR,pedigree,actset,num,id,fa,mo,sex,
     2                  locus,nloci,loctyp,locpos,numloc,
     3                  numal,name,alfrq)
            close(WRK2,status='delete')
          elseif (keyw2.eq.'men') then
            outfil=words(3)
            open(OSTR,file=outfil,status='unknown')
            write(*,'(/2a)') 
     &        'Writing MENDEL type pedigree file: ',outfil
            call lorder(4,nloci,loctyp,nord,locord)
            call wrfish(WRK,OSTR,pedigree,actset,num,nfound,id,fa,mo,
     &             sex,locus,nloci,loctyp,locpos,numloc,nord,locord,2)
          elseif (keyw2.eq.'dot') then
            outfil=words(3)
            call gettrait(words(4),4,0,nloci,loc,loctyp,trait)
            if (trait.ne.MISS) trait=locpos(trait)
            open(OSTR,file=outfil,status='unknown')
            write(*,'(/2a)') 
     &        'Writing pedigree drawing for dot: ',outfil
            call wrdot(WRK,OSTR,trait,pedigree,actset,num,nfound,
     &             id,fa,mo,sex,locus,nloci,loctyp,locpos,numloc,lin)
          elseif (keyw2.eq.'lin' .or.keyw2.eq.'asp'.or.
     &            keyw2.eq.'tcl' .or.words(2)(1:2).eq.'gh') then
            outfil=words(3)
            typ=0
            if (words(4)(1:3).eq.'dum') then
              typ=1
            end if
            if (words(2)(1:2).eq.'gh') then
              typ=3-typ
            elseif (words(4)(1:2).eq.'gh') then
              typ=2
              if (words(5)(1:2).eq.'no') typ=3
            end if
            call lorder(typ,nloci,loctyp,nord,locord)
            open(OSTR,file=outfil,status='unknown')
            open(WRK2,file=wrk2fil,form='unformatted')
            if (keyw2.eq.'lin' .or. words(2)(1:2).eq.'gh') then
              write(*,'(/2a)') 
     &          'Writing LINKAGE type pedigree file: ',outfil
              do 50 i=1,nloci
              if (loctyp(i).le.2) then
                call freq(WRK,locpos(i),pedigree,actset,num,nfound,id,
     &                    fa,mo,
     &                  sex,locus,numloc,numal,name,fndr,alfrq,typed)
                call wrfreq(WRK2,loc(i),numal,name,alfrq,map(i),
     &                  typed,nobs,3)
              end if
   50         continue
            else
              write(*,'(/2a)') 
     &          'Writing ASPEX type pedigree file: ',outfil
              do 51 i=1,nloci
              if (loctyp(i).le.2) then
                write(OSTR,'(2a,$)') loc(i)(1:eow(loc(i))),' '
                call freq(WRK,locpos(i),pedigree,actset,num,nfound,id,
     &                    fa,mo,
     &                    sex,locus,numloc,numal,name,fndr,alfrq,typed)
                call wrfreq(WRK2,loc(i),numal,name,alfrq,map(i),
     &                      typed,nobs,3)
              end if
   51         continue
              write(OSTR,*)
            end if
            if (typ.eq.1 .or. typ.eq.2) then
              write(*,'(a)') 'Position 6 is a dummy binary trait.'
            end if
            call wrlink(WRK,WRK2,OSTR,typ,nwid,ndec,pedigree,actset,num,
     2                  nfound,id,fa,mo,sex,locus,nloci,loctyp,locpos,
     3                  nord,locord,numloc,numal,name,alfrq)
            close(WRK2,status='delete')
          elseif (keyw2.eq.'sag') then
            outfil=words(3)
            open(OSTR,file=outfil,status='unknown')
            length=0
            nrc=2
            write(*,'(/2a,7(/a))') 
     2       'Writing FSP type pedigree file: ',outfil,
     3       'Record 1:','  Pedigree     6- 10','  ID          11- 18',
     4       '  Father ID   19- 26','  Mother ID   27- 34', 
     5       '  Sex         35- 35','Record 2:'
            do 80 i=1,nloci
              if (length.gt.122) then
                nrc=nrc+1
                length=0
                write(*,'(a,i2,a1)') 'Record',nrc,':'
              end if
              if (loctyp(i).lt.5) then
                varlen=9
                if (loctyp(i).eq.4) varlen=4
                write(*,'(2x,a10,1x,i3,a1,i3)') 
     &            loc(i),length+1,'-',length+varlen
                length=length+varlen
              end if
   80       continue
C write an fsp control file then the fsp pedigree file
            open(OSTR2,file='fsp.par')
            write(OSTR2,'(a,i2,a/5i5,a2/a)') 
     2        'FSP input parameters -- ',nrc,' records per person',
     3        1,0,0,0,nrc,'MF','(a5,i5,3a8,a1)'
            close(OSTR2,status='keep')
            call wrsage(WRK,OSTR,pedigree,actset,num,id,fa,mo,sex,
     &                  locus,nloci,loctyp,locpos,numloc)
          elseif (words(2).eq.'pap') then
            open(OSTR,file='trip.dat')
            open(OSTR2,file='phen.dat')
            open(WRK2,file=wrk2fil,form='unformatted')
            do 250 i=1,nloci
            if (loctyp(i).eq.1) then
              call freq(WRK,locpos(i),pedigree,actset,num,nfound,id,fa,
     &                  mo,
     &                  sex,locus,numloc,numal,name,fndr,alfrq,typed)
              call wrfreq(WRK2,loc(i),numal,name,alfrq,map(i),
     7                    typed,nobs,3)
            end if
  250       continue
            write(*,'(/a)') 
     &        'Writing PAP type pedigree files: phen.dat and trip.dat'
            call wrpap(WRK,WRK2,OSTR,OSTR2,pedigree,actset,num,nfound,
     2                 id,fa,mo,sex,locus,nloci,loctyp,locpos,numloc,
     3                 numal,name,alfrq)
            close(WRK2,status='delete')
            close(OSTR2,status='keep')
          elseif (keyw2.eq.'gda') then
            outfil=words(3)
            open(OSTR,file=outfil)
            typ=1
            if (words(4)(1:3).eq.'all') typ=2
            write(*,'(/2a)') 
     &        'Writing GDA (gdatype) data file: ',outfil
            call wrgda(WRK,OSTR,pedigree,actset,num,nfound,id,fa,mo,sex,
     &                 locus,nloci,loc,loctyp,locpos,numloc,typ)
          elseif (keyw2.eq.'str') then
            outfil=words(3)
            call gettrait(words(4),4,0,nloci,loc,loctyp,trait)
            if (trait.ne.MISS) then
              trait=locpos(trait)
            end if
            typ=1
            if (words(narg).eq.'all') typ=2
            write(*,'(/2a)') 
     &        'Writing structure data file: ',outfil
            open(OSTR,file=outfil)
            call wrmap(OSTR,8,mapf,nloci,loc,loctyp,nord,locord, map)
            call wrprd(WRK,OSTR,trait,pedigree,actset,num,nfound,id,fa,
     &             mo,sex,locus,nloci,loc,loctyp,locpos,numloc,typ)
          elseif (keyw2.eq.'arl') then
            outfil=words(3)
            open(OSTR,file=outfil)
            open(WRK2,file=wrk2fil,form='unformatted')
            if (words(4)(1:3).eq.'par') then 
              typ=2
              write(*,'(a/2a)') 'Writing 4 longest parental haplotypes',
     &        ' per family to Arlequin data file: ',outfil
            else if (words(4)(1:3).eq.'all') then 
              typ=0
              write(*,'(2a)') 
     &        'Writing all genotypes to Arlequin data file: ',outfil
            else
              typ=1
              write(*,'(a/2a)') 'Writing 2 longest haplotypes',
     &        ' per family to Arlequin data file: ',outfil
            end if
            call wrarl(WRK,WRK2,OSTR,pedigree,actset,num,nfound,id,fa,
     &                 mo,sex,
     2                 locus,nloci,loc,loctyp,locpos,numloc,
     3                 locord,hset,typ)
            close(WRK2,status='delete')
          elseif (keyw2.eq.'phe') then
            outfil=words(3)
            open(OSTR,file=outfil)
            write(*,'(/2a)') 
     &        'Writing Mapmaker-Sibs phenotype data file: ',outfil
            call wrphe(WRK,OSTR,pedigree,actset,num,nfound,id,fa,mo,sex,
     &                 locus,nloci,loctyp,locpos,numloc)
          else
            write(*,'(a)') 'ERROR: Pedigree file type not supported.'
          end if
          close(OSTR,status='keep')
C
C SML predicted recurrence risks, ibd sharing etc
        elseif (keyword.eq.'grr') then
          if (narg.ge.4) then
            write(*,'(3(/a))')
     2        '------------------------------------------------',
     3        'Single Major Locus Recurrence Risk Calculation',
     4        '------------------------------------------------'
            call grrpen(words(5)(1:3),dble(fval(words(2))),
     &                  dble(fval(words(3))),dble(fval(words(4))))
          end if
        elseif (keyword.eq.'sml') then
          typ=1
          do 195  i=2, narg
            expr(i-1)=dble(fval(words(i)))
            if (expr(i-1).gt.1.0d0) typ=2
  195     continue
          do 196  i=narg+1,8
            expr(i-1)=0.0d0
  196     continue
          if (narg.gt.5) typ=2
          if (typ.eq.2 .and. narg.ge.5 .and. narg.lt.8) then
            j=max(5,narg-1)
            do 197  i=narg+1, 8
              expr(i-1)=expr(j)
  197       continue
          end if
          if (typ.eq.1 .and. narg.ge.2) then
            write(*,'(3(/a))')
     2      '------------------------------------------------',
     3      'Single Major Locus Recurrence Risk Calculation',
     4      '------------------------------------------------'
            call recrisk(expr(1), expr(2), expr(3), expr(4))
          else if (typ.eq.2 .and. narg.ge.2) then
            write(*,'(3(/a))')
     2      '------------------------------------------------',
     3      'Quantitative Trait SML Expectations',
     4      '------------------------------------------------'
            call qtlpars(expr(1), expr(2), expr(3), expr(4),
     &                   expr(5), expr(6), expr(7))
          end if
        elseif (keyword.eq.'pro') then
          i=ival(words(2))
          j=ival(words(3))
          tmp=fval(words(4))
          call propci(i,j,tmp)
        elseif (keyword.eq.'pch') then
          tmp=fval(words(2))
          i=ival(words(3))
          write(*,*) chip(dble(tmp),i)
        elseif (keyword.eq.'lis') then
          call listloci(nloci,loc,loctyp,locpos,1)
        elseif (keyword.eq.'ls') then
          call listloci(nloci,loc,loctyp,locpos,2)
        elseif (keyword.eq.'inf') then
          call info(burnin,imp,iter,ix,iy,iz,mapf,mincnt,plevel,
     2              showorig,addsex,chek,droperr,prompt,use2,
     3              datdir,version,wrkdir)
        elseif (keyword.eq.'hel' .or. keyword.eq.'?') then
          typ=5
          if (keyw2.eq.'all') then
            typ=1
          elseif (keyw2.eq.'glo') then
            typ=2
          elseif (keyw2.eq.'dat') then
            typ=3
          elseif (keyw2.eq.'ana') then
            typ=4
          end if
          call help(typ)
        elseif (keyword.eq.'tim') then
          call stamp(t0)
        elseif (keyword(1:1).eq.'!' .or. keyword(1:1).eq.'#') then
          write(*,'(a)') lin(1:79)
        elseif ((keyword(1:1).eq.'%'.or.keyword(1:1).eq.'$') .and.
     &          eow(lin).gt.1) then
          call shell(lin)
        elseif ((keyword.eq.'inc' .or. keyword.eq.'loc') .and.
     &          ilevel.eq.1) then
          call args(lin,narg,bigwor,1)
          infil=bigwor(2)
          inquire(file=infil,exist=filexist)
          if (filexist) then
            write(*,'(/3a)') 
     &        'Reading commands from "', infil(1:eow(infil)),'".'
            ilevel=ilevel+1
            open(CSTRM,file=infil,status='unknown')
            loconly=(keyword.eq.'loc')
          else
            write(*,'(/3a/)') 
     &        'ERROR:  Unable to open "', infil(1:eow(infil)),'".'
          end if
        elseif (keyword.eq.'cle') then
          close(WRK,status='delete')
          goto 999
        elseif (keyword(1:1).eq.' ') then
          continue
        elseif (keyword.eq.'sto' .or. keyword.eq.'qui' .or.
     &          keyword.eq.'exi' .or.keyword(1:2).eq.'by') then
          goto 2
C
C Maybe an expression?
        else
          call args(lin,narg,words,2)
          nterm=narg
          call typwords(1,nterm,words,nloci,loc,loctyp,token,env,
     &                  wtyp,expr,actn)
          if (actn.eq.0) then
            error=1
          else
            if (actn.eq.2) call dryrun(1,nterm,wtyp)
            call parser(nterm,wtyp,expr,lbp,rbp,op,error)
C Write answer
            if (error.gt.0 .or. nterm.gt.1) then
              error=1
            else if (actn.eq.1) then 
              if (wtyp(1).eq.1000) then
                write(*,*) '=> ',expr(1)
              else
                write(*,'(a)') '=> MISS'
              end if
            else if (red) then
              write(*,'(a/)') 'Operating on pedigree file' 

              call newnam(wrknum, wrkfil)
              open(TWRK,file=wrkfil,form='unformatted')
              call evalped(WRK,TWRK,narg,words,nloci,loc,loctyp,locpos,
     2               token,env,lbp,rbp,op,wtyp,expr, pedigree, actset,
     3               num,nfound,id,fa,mo,sex,locus,numloc,plevel)
              close(WRK,status='delete')
              close(TWRK,status='keep')
              open(WRK,file=wrkfil,form='unformatted')
            else 
              error=1
            end if
          end if
          if (error.eq.1) then
            write(*,'(a,i3,a/7x,a/)')   
     &        'ERROR: problematic input at line ',nlin,':',lin(1:72)
            if (.not.red) write(*,'(a/7x,a/)')
     2        'NOTE:  data set has not yet been read in.',
     3        'Most procedures require a preceding "run" statement.'
          end if
        end if
      goto 1
    2 continue   
      if (ilevel.gt.1) then
        write(*,'(/3a/)') 
     &    'Closing include file "',infil(1:eow(infil)),'".'
        ilevel=ilevel-1
        close(CSTRM,status='keep')
        goto 1
      end if
C
C end of main loop
C
      close(WRK,status='delete')
      call stamp(t0)
      end
C end-of-main

C
C Calculate variances for a given SML model
C
      subroutine qtlpars(p,m1,m2,m3,sd1,sd2,sd3)

      double precision m1,m2,m3, p, sd1, sd2, sd3
      double precision expx, iqr, h2, midp, mu,q, sd, va,vd,ve,vt

      q=1.0d0-p
      mu=p*p*m1+2*q*p*m2+q*q*m3
      va=2*p*q*(p*(m1-m2)+q*(m2-m3))**2
      vd=p*p*q*q*(m1-2*m2+m3)**2

      ve=p*p*sd1*sd1 + 2*p*q*sd2*sd2 + q*q*sd3*sd3
      vt=va+vd+ve
      sd=sqrt(vt)
      h2=(va+vd)/vt

      write(*,'(/a,f5.3/a/a,3(4x,f5.3,4x),2(/a,3(1x,f12.6)))')
     2  'A allele frequency       = ', p, 
     3  'Genotypes                =      A/A         A/B          B/B',
     4  'Genotype frequencies     = ', p*p, 2*p*q, q*q,
     5  'Genotypic means          =', m1,  m2,  m3,
     6  'Genotypic SDs            =', sd1, sd2, sd3
      write(*,'(/a,f12.6,a,f12.6,a/a,3(1x,f12.6)/a,5x,f5.3)')
     2   'Expected trait mean (SD) = ', mu, ' (',sd,')',
     3   'Variances (A, D, E)      =', va, vd, ve,
     4   'Broad heritability       =', h2 
      midp=mu-4*sd
      h2=va/vt
      iqr=0.67449d0*vt*(1.0d0-0.5d0*h2*h2)
      write(*,'(/a/a)') '   Midparent    E(Child)        Expected IQR',
     &  ' ----------- ------------ -------------------------'
      do 10 i=1,7
        midp=midp+sd
        expx= mu+h2*(midp-mu)
        write(*,'(f12.4,3(1x,f12.4))') midp, expx, expx-iqr, expx+iqr
   10 continue

      return
      end
C end-of-qtlpars
C
C Calculate penetrances for a particular prevalence and genotypic RR
C
      subroutine grrpen(model,prev,q,grr)
      character*3 model
      double precision grr, prev, q 
      double precision f1,f2,f3,p,r

      r=1.0d0/grr
      p=1.0d0-q
C recessive
      if (model.eq.'rec') then
        f1 = prev/((q*(q+(2.0d0*p*r)))+(p*p*r))
        f2 = r*f1
        f3 = f2
C additive
      else if (model.eq.'add') then
        f1 = prev/((q*(q+(2.0d0*p*r)))+((p*r)**2))
        f2 = r*f1
        f3 = r*f2
C dominant 
      else 
        f1 = prev/((q*(q+(p+p)))+((p*p)*r))
        f2 = f1
        f3 = r * f1
      end if
      if (f1.lt.0.0d0) f1=0.0d0
      if (f2.lt.0.0d0) f2=0.0d0
      if (f3.lt.0.0d0) f3=0.0d0
      if (f1.gt.1.0d0) f1=1.0d0
      if (f2.gt.1.0d0) f2=1.0d0
      if (f3.gt.1.0d0) f3=1.0d0
      call recrisk(q,f1,f2,f3)
      return
      end
C end-of-grrpen
C
C Calculate recurrence risks and risk ratios for given SML model
C
      subroutine recrisk(q,f1,f2,f3)

      double precision f1,f2,f3, p, q, qa, qu
      integer rel,ii,jj
      double precision i(3,3),t(3,3),o(3,3),r(3,3),a(3),b(3)
      double precision ci(4),ct(4),co(4),riska(4),risku(4),rr(4)
      double precision ff(3),kp,kq,va,vd,oddsr(4),mating(3),pap
      data ci /1.0, 0.25, 0.0, 0.0/
      data ct /0.0, 0.5 , 1.0, 0.5/
      data co /0.0, 0.25, 0.0, 0.5/

      p=1.0d0-q
      kp=q*q*f1+2.0d0*p*q*f2+p*p*f3
      kq=1.0d0-kp
      qa=(q*q*f1+q*(1-q)*f2)/kp
      qu=(q*q*(1.0d0-f1)+q*p*(1.0d0-f2))/kq
      a(1)=q*q*f1/kp
      a(2)=2*p*q*f2/kp
      a(3)=p*p*f3/kp
      b(1)=q*q*(1.0d0-f1)/kq
      b(2)=2*p*q*(1.0d0-f2)/kq
      b(3)=p*p*(1.0d0-f3)/kq
      do 10 rel=1,4
        do 20 ii=1,3
        do 20 jj=1,3
          i(ii,jj)=0.0d0
          t(ii,jj)=0.0d0
   20   continue
        do 30 ii=1,3
          i(ii,ii)=1.0d0
          o(ii,1)=q*q
          o(ii,2)=2.0d0*q*p
          o(ii,3)=p*p
   30   continue
        t(1,1)=q
        t(3,2)=q
        t(1,2)=p
        t(3,3)=p
        t(2,1)=0.5d0*q
        t(2,2)=0.5d0
        t(2,3)=0.5d0*p
        do 40 ii=1, 3
        do 40 jj=1, 3
          i(ii,jj)=i(ii,jj)*ci(rel)
          t(ii,jj)=t(ii,jj)*ct(rel)
          o(ii,jj)=o(ii,jj)*co(rel)
          r(ii,jj)=i(ii,jj)+t(ii,jj)+o(ii,jj)
   40   continue
        riska(rel)=0.0d0
        risku(rel)=0.0d0
        ff(1)=f1*r(1,1)+f2*r(1,2)+f3*r(1,3)
        ff(2)=f1*r(2,1)+f2*r(2,2)+f3*r(2,3)
        ff(3)=f1*r(3,1)+f2*r(3,2)+f3*r(3,3)
        do 60 ii=1,3
          riska(rel)=riska(rel)+ff(ii)*a(ii)
          risku(rel)=risku(rel)+ff(ii)*b(ii)
   60   continue     
        if (risku(rel).le.0.0d0) then
          rr(rel)=9999.9d0
          oddsr(rel)=9999.9d0
        else 
          if (riska(rel)/risku(rel).gt.10000.0d0) then
            rr(rel)=9999.9d0
            oddsr(rel)=9999.9d0
          else
            rr(rel)=riska(rel)/risku(rel)
            oddsr(rel)=riska(rel)/(1.0d0-riska(rel))*
     &                 (1.0d0-risku(rel))/risku(rel)
          end if
        end if
   10 continue
      va=2*q*p*(q*(f1-f2)+p*(f2-f3))**2
      vd=q*q*p*p*(f1-2.0d0*f2+f3)**2
      mating(1)=qu*qu*f1+2.0d0*(1.0d0-qu)*qu*f2+(1.0d0-qu)*(1.0d0-qu)*f3
      mating(2)=qa*qu*f1+((1.0d0-qu)*qa+
     &                    (1.0d0-qa)*qu)*f2+(1.0d0-qa)*(1.0d0-qu)*f3
      mating(3)=qa*qa*f1+2.0d0*(1.0d0-qa)*qa*f2+(1.0d0-qa)*(1.0d0-qa)*f3
      pap=100.d0*(1.0d0-min(f1,f2,f3)/kp)

      write(*,993) q,f1,f2,f3
      write(*,994) kp,pap,va,vd
      write(*,995)
      write(*,996) 'Rec risk',riska(1),riska(2),riska(3),riska(4),
     2 'Rel risk',rr(1),rr(2),rr(3),rr(4),
     3 'Odds rat',oddsr(1),oddsr(2),oddsr(3),oddsr(4),
     4 'PRR     ',riska(1)/kp,riska(2)/kp,riska(3)/kp,riska(4)/kp  
      write(*,996) 'ibd|A-A ',1.0,0.25*(riska(1)+riska(3))/riska(2),
     2  0.5,0.5*riska(3)/(riska(3)+kp),
     3 'ibd|A-U ',1.0,(0.5-0.25*(riska(1)+riska(3)))/(1.0-riska(2)),
     4  0.5,(0.25-0.25*riska(3))/(1.0-riska(4))
      write(*,997) qa, q*q*f1/kp, 2.0*q*(1.0-q)*f2/kp,
     2             (1.0-q)*(1.0-q)*f3/kp,
     3             qu, q*q*(1.0-f1)/kq, 2.0*q*(1.0-q)*(1.0-f2)/kq, 
     4             (1.0-q)*(1.0-q)*(1.0-f3)/kq
      write(*,998) (1.0-kp)**2,mating(1),2.0*kp*(1.0-kp),
     &             mating(2),kp*kp,mating(3)
  993 format(/1x,'Frequency(A): ',f8.6,'; Pen(AA): ',f5.3,
     &           '; Pen(AB): ',f5.3,'; Pen(BB): ',f5.3)
  994 format( 1x,'Trait Prev  : ',f8.6,'; Pop AR: ',f5.1,
     &           '%; Var(Add): ',f8.6,'; Var(Dom): ',f8.6)
  995 format(/1x,'Measure      MZ Twin       Sib-Sib        Par-Off  ',
     2           '    Second    '/
     3           '----------   ----------    ----------     ---------',
     4           '    ----------')
  996 format((1x,a8,2x,4(1x,f11.3,2x)))
  997 format(/1x,'Freq of A if Affected: ',f8.6,
     2  ' (',f5.3,',',f5.3,',',f5.3,') '/1x,'Freq of A if Unaffctd: ',
     3  f8.6,' (',f5.3,',',f5.3,',',f5.3,')')
  998 format(/1x,'Mating       Proportion    Risk to offspring'/
     2           '----------   -----------   ------------------ '/
     3        'UnA x UnA',2x,2(1x,f11.3,2x)/
     4        'Aff x UnA',2x,2(1x,f11.3,2x)/
     5        'Aff x Aff',2x,2(1x,f11.3,2x))
      return
      end
C end-of-recrisk
C
C Produce a histogram with histcat intervals from sorted tabulation
C
      subroutine dohist(histcat,nvals,value,count,nobs)
      integer histcat
      integer nobs, nvals
      real value(nvals)
      integer count(nvals)
C
      integer cum, histcnt, histscale, i, j, n, oldcum
      integer stats(3)
      character*1 ch
      real histwidth,midval,upper
C
      stats(1)=nobs/4
      stats(2)=nobs/2
      stats(3)=3*nobs/4
      histscale=max(1,nobs/100)
      histwidth=(value(nvals)-value(1))/float(histcat)
      histcnt=0
      cum=0
      oldcum=0
      n=0
      i=1
      upper=value(1)+histwidth
      write(*,'(/a/a)') 
     2    ' Intvl Midpt  Count   Histogram',
     3    ' -------------------------------------------------------' 
   20 continue
        if (value(i).le.upper) then
          histcnt=histcnt+count(i)
          n=n+1
          i=i+1
        else
          cum=cum+histcnt
          if (n.eq.1) then
            midval=value(i-1)
          else
            midval=upper-0.5*histwidth 
          end if
          if (oldcum.le.stats(2) .and. cum.ge.stats(2)) then
            ch='+'
          elseif (oldcum.le.stats(3) .and. cum.ge.stats(1)) then
            ch='|'
          else
            ch=' '
          end if
          write(*,'(f12.4,1x,i6,x,a1,x,50a:)') midval,
     &      histcnt,ch,('*',j=1,min(50,histcnt/histscale))
          upper=upper+histwidth
          histcnt=0
          n=0
          oldcum=cum
        end if
      if (i.le.nvals) goto 20

      if (n.eq.1) then
        midval=value(i-1)
      else
        midval=upper-0.5*histwidth 
      end if
      write(*,'(f12.4,1x,i6,3x,50a:/)') midval,
     &  histcnt,('*',j=1,min(50,histcnt/histscale))
      return
      end
C end-of-dohist
C
C Filliben correlation here testing for normality
C
C   m(i) = 1 - m(n) for i = 1
C   m(i) = (i - 0.3175)/(n + 0.365) for i = 2, 3, ..., n-1
C   m(i) = 0.5**(1/n) for i = n
C
      subroutine filliben(nobs,nvals,value,count)
      integer MAXSIZ
      parameter(MAXSIZ=1000)
      integer nobs, nvals, count(MAXSIZ)
      real value(MAXSIZ)
C local variables
      integer i, n
      double precision cov(3), den, dn, mean(2), p, r, x(2)
C functions
      double precision ppnd, zp

      mean(1)=0.0d0
      mean(2)=0.0d0
      cov(1)=0.0d0
      cov(2)=0.0d0
      cov(3)=0.0d0
      n=count(1)
      dn=dfloat(nobs)
      x(1)=ppnd(1.0d0-0.5d0**(1.0d0/dn))
      x(2)=dble(value(1))
      call dssp(2, n, count(1), x, mean, cov)
      den=1.0d0/(0.365d0+dn)
      do 10 i=2, nvals-1
        n=n+count(i)
        x(1)=ppnd(den*(dfloat(i) - 0.3175d0))
        x(2)=dble(value(i))
        call dssp(2, n, count(i), x, mean, cov)
   10 continue
      n=n+count(nvals)
      x(1)=ppnd(0.5d0**(1.0d0/dn))
      x(2)=dble(value(nvals))
      call dssp(2, n, count(nvals), x, mean, cov)

      r=cov(2)/sqrt(cov(1))/sqrt(cov(3))
C
C Approximate P-value modelled on that for Royston 1993 for W'
C
      p=log(1.0d0-r)+1.99196d0+1.0402d0*(log(dn)-log(log(dn)))
      p=zp(p/(0.31239d0+0.788392d0/log(dn)))
      write(*,'(/a,f13.4,a,f5.3,a)')
     &  'Filliben correlation = ', r, ' (P=',p,')'
      return
      end
C end-of-filliben
C
C David & Johnson's Jr test for symmetry of a distribution
C Resek Busi Stat 1975; 546-551
C Doksum Biometrika 1977; 64: 473-487
C 
C Standard error of Jr based on simulations under Gaussian true distribution
C
      subroutine symtest(nobs,nvals,value,count)
      integer MAXSIZ
      parameter(MAXSIZ=1000)
      integer nobs, nvals, count(MAXSIZ)
      real value(MAXSIZ)
C local variables
      integer i, n, nstat, pos(5)
      double precision dn,j02,x(5)
C functions
      double precision zp

      dn=dfloat(nobs)
      pos(1)=nint(0.02d0*dn)
      pos(2)=nint(0.25d0*dn)
      pos(3)=nint(0.50d0*dn)
      pos(4)=nint(0.75d0*dn)
      pos(5)=nint(0.98d0*dn)
      n=0
      nstat=1
      do 10 i=1, nvals
        n=n+count(i)
        if (n.ge.pos(nstat)) then
          x(nstat)=dble(value(i))
          nstat=nstat+1
          if (nstat.gt.5) goto 11
        end if
   10 continue
   11 continue
      j02=(0.5d0*(x(1)+x(5))-x(3))/(x(4)-x(2))
      write(*,'(a,f13.4,a,f5.3,a)') 'Symmetry test J(.02) = ',
     &  j02,' (P=',zp(0.735d0*sqrt(dn)*abs(j02)),')'
      return
      end
C end-of-symtest
C
C calculate McNemar statistic
C
       double precision function clcmcn(b,c)
       integer b,c
       clcmcn=0.0d0
       if ((b+c).gt.0) then
         clcmcn=dfloat((b-c)*(b-c))/dfloat(b+c)
       end if
       return
       end
C end-of-clcmcn
C
C normal approx binomial deviate
C
      double precision function binz(x,n,e)
      integer x,n
      double precision e
      binz=0.0d0
      if (e.ne.0.0d0 .and. e.ne.1.0d0 .and. n.gt.1) then
        binz=(dfloat(x)-dfloat(n)*e)/sqrt(e*(1.0d0-e)*dfloat(n-1))
      end if
      return
      end 
C end-of-binz
C
C Freeman-Tukey deviates
C
      double precision function ftdev(o,e)
      double precision o,e
      ftdev=sqrt(o)+sqrt(o+1.0d0)-sqrt(4.0d0*e+1.0d0)
      return
      end 
C end-of-ft
C
C find index of coefficient for pair i,j in 1-D array
C
      integer function clcpos(i,j)
      integer i,j
      if (i.gt.j) then
        clcpos=i*(i-1)/2+j
      else
        clcpos=j*(j-1)/2+i
      end if
      return
      end
C end-of-clcpos
C
C Initialize array with value of index
C
      subroutine ascend(n, ia)
      integer n
      integer ia(*)
      do 10 i=1,n
        ia(i)=i
   10 continue
      return
      end
C end-of-ascend
C
C Copy integer array A to integer array B
C
      subroutine copy(n, ia, ib)
      integer n
      integer ia(*), ib(*)
      do 10 i=1,n
        ib(i)=ia(i)
   10 continue
      return
      end
C end-of-copy
C
C Load a lower triangular matrix 
      subroutine filltri(n,nn,a,dval,oval)
      integer n, nn
      double precision a(nn), dval, oval
      integer i,j
      do 10 i=1, nn
        a(i)=oval
   10 continue
      if (dval.ne.oval) then
        j=0
        do 20 i=1, n
          j=j+i
          a(j)=dval
   20   continue
      end if
      return
      end
C end-of-filltri
C
C Binary search for position of value in an ascending sorted array
C
      subroutine match(ival,num,key,pos)
      integer ival, pos, num
      integer key(*)
      
      integer hi, lo

      hi=num
      lo=1
   10 continue
        pos=(hi+lo)/2
        if (ival.gt.key(pos)) then
          lo=pos+1
        elseif (ival.lt.key(pos)) then
          hi=pos-1
        else
          return
        end if
      if (hi.ge.lo) goto 10
        pos=0
      return
      end
C end-of-match
C
C Evaluate (y-m)' S (y-m) where S is symmetric lower triangular matrix
C
      subroutine quadmult(n,x,m,nn,c,w1,w2,res)
      integer n, nn
      double precision res
      double precision c(nn), m(n), w1(n), w2(n), x(n)
      integer i,j,pos, k

      do 10 i=1, n
        w1(i)=x(i)-m(i)
   10 continue
      pos=0
      do 20 i=1, n
        w2(i)=0.0d0
        do 30 j=1, i-1
          w2(i)=w2(i)+w1(j)*c(pos+j)
   30   continue
        k=pos
        do 40 j=i,n
          w2(i)=w2(i)+w1(j)*c(k+i)
          k=k+j
   40   continue
        pos=pos+i
   20 continue
      res=0.0d0
      do 50 i=1, n
        res=res+w2(i)*w1(i)
   50 continue
      return
      end
C end-of-quadmult
C
C  Invert real symmetric positive-definite matrix using
C  AS 7 Applied Stat 1968; 17:198
C  Reads in and returns a lower triangular matrix.
C
      subroutine syminv(a,n,nn,c,w, logdet, nullty,ifault)

      double precision a(nn),c(nn),w(n),logdet,x,zero,one
      data zero,one /0.0d0,1.0d0/
C
      logdet=0.0d0
      call chol(a,n,nn,c,nullty,ifault)
      if (ifault.ne.0) return

      l=0
      do 5 i=1, n
        l=l+i
        logdet=logdet+log(c(l))
    5 continue
      logdet=logdet+logdet

      irow=n
      ndiag=nn
   10 l=ndiag
      if (c(ndiag).eq.zero) goto 60
      do 20 i=irow,n
        w(i)=c(l)
        l=l+i
   20 continue
      icol=n
      jcol=nn
      mdiag=nn
   30 l=jcol
      x=zero
      if (icol.eq.irow) x=one/w(irow)
      k=n
   40 if (k.eq.irow) goto 50
        x=x-w(k)*c(l)
        k=k-1
        l=l-1
        if (l.gt.mdiag) l=l-k+1
        goto 40
   50 c(l)=x/w(irow)
      if (icol.eq.irow) goto 80
      mdiag=mdiag-icol
      icol=icol-1
      jcol=jcol-1
      goto 30
C
   60 do 70 j=irow,n
        c(l)=zero
        l=l+j
   70 continue
   80 ndiag=ndiag-irow
      irow=irow-1
      if (irow.ne.0) goto 10
      return
      end
C end-of-syminv
C
C AS 6 Appl Stat 1968; 17:195
C
      subroutine chol(a,n,nn,u,nullty,ifault)
      double precision a(nn),u(nn),eta,eta2,x,w,zero,zabs,zsqrt
      data eta,zero /1.0e-15, 0.0/
      zabs(x)=abs(x)
      zsqrt(x)=sqrt(x)
C
      ifault=1
      if (n.le.0) return
      ifault=3
      if (nn.ne.n*(n+1)/2) return
      ifault=2
      nullty=0
      j=1
      k=0
      eta2=eta*eta
      i1=0
      do 80 icol=1,n
        i1=i1+icol
        x=eta2*a(i1)
        l=0
        kk=0
        do 40 irow=1,icol
          kk=kk+irow
          k=k+1
          w=a(k)
          m=j
          do 10 i=1,irow
            l=l+1
            if (i.eq.irow) goto 20
            w=w-u(l)*u(m)
            m=m+1
   10     continue
   20     if (irow.eq.icol) goto 50
           if (u(l).eq.zero) goto 30
           u(k)=w/u(l)
           goto 40
C
   30     if(w*w.gt.zabs(x*a(kk))) return
           u(k)=zero
   40     continue
   50 if (zabs(w).le.zabs(eta*a(k))) goto 60
      if (w.lt.zero) return
      u(k)=zsqrt(w)
      goto 70
C
   60 u(k)=zero
      nullty=nullty+1
   70 j=j+icol
   80 continue
      ifault=0
      return
      end
C end-of-chol
C
C SLATEC quicksort routine for character key.  Jones, Kahaner and Wisniewski.
C The options to sort descending and not reorder the second array have been 
C removed, and argument order changed.
C
      subroutine csort(n, cx, iy)
      integer n
      character*8 cx(*)  
      integer iy(*)
C local variables
      real r
      character*8 t, tt
      integer i, ij, j, k, l, m, nn, ty, tty
      integer il(21), iu(21)

      nn = n
      if (nn .lt. 1) return
C
C Sort CX and carry IY along
C
  100 m = 1
      i = 1
      j = nn
      r = 0.375e0
C
  110 if (i .eq. j) go to 150
      if (r .le. 0.5898437e0) then
         r = r+3.90625e-2
      else
         r = r-0.21875e0
      endif
C
  120 k = i
C
C Select a central element of the array and save it in location T
C
      ij = i + int((j-i)*r)
      t = cx(ij)
      ty = iy(ij)
C
C If first element of array is greater than T, interchange with T
C
      if (cx(i) .gt. t) then
         cx(ij) = cx(i)
         cx(i) = t
         t = cx(ij)
         iy(ij) = iy(i)
         iy(i) = ty
         ty = iy(ij)
      endif
      l = j
C
C If last element of array is less than T, interchange with T
C
      if (cx(j) .lt. t) then
         cx(ij) = cx(j)
         cx(j) = t
         t = cx(ij)
         iy(ij) = iy(j)
         iy(j) = ty
         ty = iy(ij)
C
C If first element of array is greater than T, interchange with T
C
         if (cx(i) .gt. t) then
            cx(ij) = cx(i)
            cx(i) = t
            t = cx(ij)
            iy(ij) = iy(i)
            iy(i) = ty
            ty = iy(ij)
         endif
      endif
C
C Find an element in the second half of the array which is smaller
C than T
C
  130 l = l-1
      if (cx(l) .gt. t) go to 130
C
C Find an element in the first half of the array which is greater
C than T
C
  140 k = k+1
      if (cx(k) .lt. t) go to 140
C
C Interchange these elements
C
      if (k .le. l) then
         tt = cx(l)
         cx(l) = cx(k)
         cx(k) = tt
         tty = iy(l)
         iy(l) = iy(k)
         iy(k) = tty
         go to 130
      endif
C
C Save upper and lower subscripts of the array yet to be sorted
C
      if (l-i .gt. j-k) then
         il(m) = i
         iu(m) = l
         i = k
         m = m+1
      else
         il(m) = k
         iu(m) = j
         j = l
         m = m+1
      endif
      go to 160
C
C Begin again on another portion of the unsorted array
C
  150 m = m-1
      if (m .eq. (1-1)) return
      i = il(m)
      j = iu(m)
C
  160 if (j-i .ge. 1) go to 120
      if (i .eq. 1) go to 110
      i = i-1
C
  170 i = i+1
      if (i .eq. j) go to 150
      t = cx(i+1)
      ty = iy(i+1)
      if (cx(i) .le. t) go to 170
      k = i
C
  180 cx(k+1) = cx(k)
      iy(k+1) = iy(k)
      k = k-1
      if (t .lt. cx(k)) go to 180
      cx(k+1) = t
      iy(k+1) = ty
      go to 170
C
      end
C end-of-csort
C
C SLATEC quicksort routine.  Jones, Kahaner and Wisniewski.
C The option to sort descending has been removed, the argument order 
C changed, and the sort is now from bot...top, rather than 1...top.
C
      subroutine isort(bot, top, ix, iy, kflag)
      integer kflag, bot, top
      integer ix(*), iy(*)
C local variables
      real r
      integer i, ij, j, k, l, m, nn, t, tt, ty, tty
      integer il(21), iu(21)

      nn = top
      if (nn .lt. bot) return
C
      if (kflag .eq. 2) go to 100
C
C Sort IX only
C
      m = 1
      i = bot
      j = nn
      r = 0.375e0
C
   20 if (i .eq. j) go to 60
      if (r .le. 0.5898437e0) then
         r = r+3.90625e-2
      else
         r = r-0.21875e0
      endif
C
   30 k = i
C
C Select a central element of the array and save it in location T
C
      ij = i + int((j-i)*r)
      t = ix(ij)
C
C If first element of array is greater than T, interchange with T
C
      if (ix(i) .gt. t) then
         ix(ij) = ix(i)
         ix(i) = t
         t = ix(ij)
      endif
      l = j
C
C If last element of array is less than than T, interchange with T
C
      if (ix(j) .lt. t) then
         ix(ij) = ix(j)
         ix(j) = t
         t = ix(ij)
C
C If first element of array is greater than T, interchange with T
C
         if (ix(i) .gt. t) then
            ix(ij) = ix(i)
            ix(i) = t
            t = ix(ij)
         endif
      endif
C
C Find an element in the second half of the array which is smaller
C than T
C
   40 l = l-1
      if (ix(l) .gt. t) go to 40
C
C Find an element in the first half of the array which is greater
C than T
C
   50 k = k+1
      if (ix(k) .lt. t) go to 50
C
C Interchange these elements
C
      if (k .le. l) then
         tt = ix(l)
         ix(l) = ix(k)
         ix(k) = tt
         go to 40
      endif
C
C Save upper and lower subscripts of the array yet to be sorted
C
      if (l-i .gt. j-k) then
         il(m) = i
         iu(m) = l
         i = k
         m = m+1
      else
         il(m) = k
         iu(m) = j
         j = l
         m = m+1
      endif
      go to 70
C
C Begin again on another portion of the unsorted array
C
   60 m = m-1
      if (m .eq. 0) return
      i = il(m)
      j = iu(m)
C
   70 if (j-i .ge. 1) go to 30
      if (i .eq. 1) go to 20
      i = i-1
C
   80 i = i+1
      if (i .eq. j) go to 60
      t = ix(i+1)
      if (ix(i) .le. t) go to 80
      k = i
C
   90 ix(k+1) = ix(k)
      k = k-1
      if (t .lt. ix(k)) go to 90
      ix(k+1) = t
      go to 80
C
C Sort IX and carry IY along
C
  100 m = 1
      i = bot
      j = nn
      r = 0.375e0
C
  110 if (i .eq. j) go to 150
      if (r .le. 0.5898437e0) then
         r = r+3.90625e-2
      else
         r = r-0.21875e0
      endif
C
  120 k = i
C
C Select a central element of the array and save it in location T
C
      ij = i + int((j-i)*r)
      t = ix(ij)
      ty = iy(ij)
C
C If first element of array is greater than T, interchange with T
C
      if (ix(i) .gt. t) then
         ix(ij) = ix(i)
         ix(i) = t
         t = ix(ij)
         iy(ij) = iy(i)
         iy(i) = ty
         ty = iy(ij)
      endif
      l = j
C
C If last element of array is less than T, interchange with T
C
      if (ix(j) .lt. t) then
         ix(ij) = ix(j)
         ix(j) = t
         t = ix(ij)
         iy(ij) = iy(j)
         iy(j) = ty
         ty = iy(ij)
C
C If first element of array is greater than T, interchange with T
C
         if (ix(i) .gt. t) then
            ix(ij) = ix(i)
            ix(i) = t
            t = ix(ij)
            iy(ij) = iy(i)
            iy(i) = ty
            ty = iy(ij)
         endif
      endif
C
C Find an element in the second half of the array which is smaller
C than T
C
  130 l = l-1
      if (ix(l) .gt. t) go to 130
C
C Find an element in the first half of the array which is greater
C than T
C
  140 k = k+1
      if (ix(k) .lt. t) go to 140
C
C Interchange these elements
C
      if (k .le. l) then
         tt = ix(l)
         ix(l) = ix(k)
         ix(k) = tt
         tty = iy(l)
         iy(l) = iy(k)
         iy(k) = tty
         go to 130
      endif
C
C Save upper and lower subscripts of the array yet to be sorted
C
      if (l-i .gt. j-k) then
         il(m) = i
         iu(m) = l
         i = k
         m = m+1
      else
         il(m) = k
         iu(m) = j
         j = l
         m = m+1
      endif
      go to 160
C
C Begin again on another portion of the unsorted array
C
  150 m = m-1
      if (m .eq. 0) return
      i = il(m)
      j = iu(m)
C
  160 if (j-i .ge. 1) go to 120
      if (i .eq. 1) go to 110
      i = i-1
C
  170 i = i+1
      if (i .eq. j) go to 150
      t = ix(i+1)
      ty = iy(i+1)
      if (ix(i) .le. t) go to 170
      k = i
C
  180 ix(k+1) = ix(k)
      iy(k+1) = iy(k)
      k = k-1
      if (t .lt. ix(k)) go to 180
      ix(k+1) = t
      iy(k+1) = ty
      go to 170
C
      end
C end-of-isort
C
C inverse Haldane (mapf=1) or Kosambi (mapf=2) mapping x cM->r
C
      real function invmap(x,mapf)
      integer mapf
      real x

      if (mapf.eq.1) then
        invmap=0.5*(1.0-exp(-0.02*abs(x)))
      elseif (mapf.eq.2) then
        invmap=0.5*(exp(0.04*abs(x))-1)/(exp(0.04*abs(x))+1)
      else
        invmap=x
      end if
      if (invmap.lt.0.001) invmap=0.001
      return
      end
C end-of-invmap
C
C Factorial
C
      double precision function fact(n)
      integer i,n
      double precision lookup(0:20)
      data lookup /1.0d0,1.0d0,2.0d0,6.0d0,2.4d1,1.2d2,7.2d2,5.04d3,
     2             4.032d4,3.6288d5,3.6288d6,3.99168d7,4.790016d8,
     3             6.2270208d9,8.71782912d10,1.307674368d12,
     4             2.0922789888d13,3.55687428096d14,6.402373705728d15,
     5             1.21645100408832d17,2.43290200817664d18/
      if (n.lt.21) then
        fact=lookup(n)
      else
        fact=lookup(20)
        do 10 i=21,n
          fact=fact*dfloat(i)
   10   continue
      end if
      return
      end
C end-of-fact
C
C Calculate Bonferroni corrected P-value for given number of tests
C
      double precision function bonf(ntest,alpha)
      integer ntest
      double precision alpha
      bonf=alpha
      if (ntest.gt.1) then
        bonf=1.0d0-(1.0d0-alpha)**(1.0d0/dfloat(ntest))
      end if
      return
      end
C end-of-bonf
C 
C Confidence intervals around a proportion: approach of Wilson (Agresti
C & Coull)
C
      subroutine propci(num, den, width)
      integer num, den
      real width
      double precision alpha, ll, phat, rtot, t1, t2, t3, ul, z, z2
C functions
      double precision ppnd

      if (width.le.0.0 .or. width.ge.100.0) width=95.0
      alpha=(1.0d0-0.01d0*dble(width))
      z=ppnd(0.5d0*alpha)
      z2=z*z
      rtot=1.0d0/dfloat(den)
      phat=dfloat(num)*rtot
      t1=rtot*0.5d0*z2
      t2=z * sqrt((phat * (1.0d0 - phat) + 0.25*rtot*z2)*rtot)
      t3=1.0d0+rtot*z2
      ll=(phat+t1 + t2)/t3
      ul=(phat+t1 - t2)/t3
      if (num.eq.1) ll= -log(1.0d0-alpha)*rtot
      if ((den-num).eq.1) ul= 1 + log(1 - alpha)*rtot

      write(*,'(a,f8.6,1x,i2,a,f8.6,a,f8.6)') 
     2  'Prop=',phat, int(width), '%CI=', ll, ' -- ', ul
      return
      end
C end-of-propci
C
C Binomial probabilities for x,n-x with p=0.5
C
      double precision function binp(np,nq)
      double precision np, nq
      integer i
      double precision a,b,bt
C Functions
      double precision alngam, betacf
      if (np.eq.nq) then
        binp=1.0d0
        return
      end if
      if (np.gt.nq) then
        a=np
        b=nq+1.0d0
      else
        a=nq
        b=np+1.0d0
      end if
      bt=dexp(alngam(a+b,i)-alngam(a,i)-alngam(b,i)+(a+b)*dlog(0.5d0))
      binp=bt*betacf(a,b,0.5d0)/a
C two-tailed P
      binp=binp+binp
      if (binp.gt.1.0d0) binp=1.0d0
      return
      end
C end-of-binp
C
C betacf from Numerical Recipes, 1986
C
      double precision function betacf(a,b,x)

      double precision a,b,x,qab,qap,qam,eps
      double precision bz,d,ap,bp,app,bpp,am,bm,az,aold,tem,em
      parameter (itmax=100,eps=3.0d-7)
      am=1.0d0
      bm=1.0d0
      az=1.0d0
      qab=a+b
      qap=a+1.0d0
      qam=a-1.0d0
      bz=1.0d0-qab*x/qap
      do 11 m=1,itmax
        em=m
        tem=em+em
        d=em*(b-m)*x/((qam+tem)*(a+tem))
        ap=az+d*am
        bp=bz+d*bm
        d=-(a+em)*(qab+em)*x/((a+tem)*(qap+tem))
        app=ap+d*az
        bpp=bp+d*bz
        aold=az
        am=ap/bpp
        bm=bp/bpp
        az=app/bpp
        bz=1.0d0
        if (dabs(az-aold).lt.eps*dabs(az)) goto 1
   11 continue
      write(*,'(a/)') 'ERROR: In betacf().'
    1 betacf=az
      return
      end
C end-of-betacf
C
C Evaluate central chi-square in FORTRAN
C
      double precision function chip(chisq,df)
      double precision chisq
      integer df
      integer ifault
C functions
      double precision gammad

      if (df.le.0 .or. chisq.le.0.0d0) then
         chip=1.0d0
         return
      end if
      chip=1.0d0-gammad(0.5d0*chisq, 0.5d0*dfloat(df), ifault)
      return
      end
C end-of-chip
C
C Algorithm AS239  Appl. Statist. (1988) Vol. 37, No. 3
C
C Computation of the Incomplete Gamma Integral
C
        double precision function gammad(x, p, ifault)
C
        integer ifault
        double precision pn1, pn2, pn3, pn4, pn5, pn6, x, tol, oflo,
     *          xbig, arg, c, rn, p, a, b, one, zero, alngam, zp,
     *          an, two, elimit, plimit, three, nine
        parameter (zero = 0.d0, one = 1.d0, two = 2.d0, oflo = 1.d+37,
     *          three = 3.d0, nine = 9.d0, tol = 1.d-14, xbig = 1.d+8,
     *          plimit = 1000.d0, elimit = -88.d0)
        external alngam, zp
C
        gammad = zero
C
C       Check that we have valid values for X and P
C
C       if (p .le. zero .or. x .lt. zero) then
C         ifault = 1
C         return
C       end if
C       ifault = 0
C       if (x .eq. zero) return
C
C       Use a normal approximation if P > PLIMIT
C
        if (p .gt. plimit) then
          pn1 = three * sqrt(p) * ((x / p) ** (one / three) + one /
     *          (nine * p) - one)
          gammad = 1.0d0-zp(pn1)
          return
        end if
C
C       If X is extremely large compared to P then set GAMMAD = 1
C
        if (x .gt. xbig) then
          gammad = one
          return
        end if
C
        if (x .le. one .or. x .lt. p) then
C
C       Use Pearson's series expansion.
C       (Note that P is not large enough to force overflow in ALNGAM).
C       No need to test IFAULT on exit since P > 0.
C
          arg = p * log(x) - x - alngam(p + one, ifault)
          c = one
          gammad = one
          a = p
   40     a = a + one
          c = c * x / a
          gammad = gammad + c
          if (c .gt. tol) go to 40
          arg = arg + log(gammad)
          gammad = zero
          if (arg .ge. elimit) gammad = exp(arg)
C
        else
C
C       Use a continued fraction expansion
C
          arg = p * log(x) - x - alngam(p, ifault)
          a = one - p
          b = a + x + one
          c = zero
          pn1 = one
          pn2 = x
          pn3 = x + one
          pn4 = x * b
          gammad = pn3 / pn4
   60     a = a + one
          b = b + two
          c = c + one
          an = a * c
          pn5 = b * pn3 - an * pn1
          pn6 = b * pn4 - an * pn2
          if (abs(pn6) .gt. zero) then
            rn = pn5 / pn6
            if (abs(gammad - rn) .le. min(tol, tol * rn)) go to 80
            gammad = rn
          end if
C
          pn1 = pn3
          pn2 = pn4
          pn3 = pn5
          pn4 = pn6
          if (abs(pn5) .ge. oflo) then
C
C       Re-scale terms in continued fraction if terms are large
C
            pn1 = pn1 / oflo
            pn2 = pn2 / oflo
            pn3 = pn3 / oflo
            pn4 = pn4 / oflo
          end if
          go to 60
   80     arg = arg + log(gammad)
          gammad = one
          if (arg .ge. elimit) gammad = one - exp(arg)
        end if
C
        return
        end
C end-of-gammad (AS239)
C
C ALGORITHM AS245  APPL. STATIST. (1989) VOL. 38, NO. 2
C
C Calculation of the logarithm of the gamma function
C
      double precision function alngam(xvalue, ifault)
      integer ifault
      double precision alr2pi, four, half, one, onep5, r1(9), r2(9),
     +          r3(9), r4(5), twelve, x, x1, x2, xlge, xlgst, xvalue,
     +          y, zero
C
C     Coefficients of rational functions
C
      data r1/-2.66685 51149 5d0, -2.44387 53423 7d1,
     +        -2.19698 95892 8d1,  1.11667 54126 2d1,
     +         3.13060 54762 3d0,  6.07771 38777 1d-1,
     +         1.19400 90572 1d1,  3.14690 11574 9d1,
     +         1.52346 87407 0d1/
      data r2/-7.83359 29944 9d1, -1.42046 29668 8d2,
     +         1.37519 41641 6d2,  7.86994 92415 4d1,
     +         4.16438 92222 8d0,  4.70668 76606 0d1,
     +         3.13399 21589 4d2,  2.63505 07472 1d2,
     +         4.33400 02251 4d1/
      data r3/-2.12159 57232 3d5,  2.30661 51061 6d5,
     +         2.74647 64470 5d4, -4.02621 11997 5d4,
     +        -2.29660 72978 0d3, -1.16328 49500 4d5,
     +        -1.46025 93751 1d5, -2.42357 40962 9d4,
     +        -5.70691 00932 4d2/
      data r4/ 2.79195 31791 8525d-1, 4.91731 76105 05968d-1,
     +         6.92910 59929 1889d-2, 3.35034 38150 22304d0,
     +         6.01245 92597 64103d0/
C
C     Fixed constants
C
      data alr2pi/9.18938 53320 4673d-1/, four/4.d0/, half/0.5d0/,
     +     one/1.d0/, onep5/1.5d0/, twelve/12.d0/, zero/0.d0/
C
C     Machine-dependant constants.
C     A table of values is given at the top of page 399 of the paper.
C     These values are for the IEEE double-precision format for which
C     B = 2, t = 53 and U = 1023 in the notation of the paper.
C
      data xlge/5.10d6/, xlgst/1.d+305/
C
      x = xvalue
      alngam = zero
C
C     Test for valid function argument
C
      ifault = 2
      if (x .ge. xlgst) return
      ifault = 1
      if (x .le. zero) return
      ifault = 0
C
C     Calculation for 0 < X < 0.5 and 0.5 <= X < 1.5 combined
C
      if (x .lt. onep5) then
        if (x .lt. half) then
          alngam = -log(x)
          y = x + one
C
C     Test whether X < machine epsilon
C
          if (y .eq. one) return
        else
          alngam = zero
          y = x
          x = (x - half) - half
        end if
        alngam = alngam + x * ((((r1(5)*y + r1(4))*y + r1(3))*y
     +                + r1(2))*y + r1(1)) / ((((y + r1(9))*y + r1(8))*y
     +                + r1(7))*y + r1(6))
        return
      end if
C
C     Calculation for 1.5 <= X < 4.0
C
      if (x .lt. four) then
        y = (x - one) - one
        alngam = y * ((((r2(5)*x + r2(4))*x + r2(3))*x + r2(2))*x
     +              + r2(1)) / ((((x + r2(9))*x + r2(8))*x + r2(7))*x
     +              + r2(6))
        return
      end if
C
C     Calculation for 4.0 <= X < 12.0
C
      if (x .lt. twelve) then
        alngam = ((((r3(5)*x + r3(4))*x + r3(3))*x + r3(2))*x + r3(1)) /
     +            ((((x + r3(9))*x + r3(8))*x + r3(7))*x + r3(6))
        return
      end if
C
C     Calculation for X >= 12.0
C
      y = log(x)
      alngam = x * (y - one) - half * y + alr2pi
      if (x .gt. xlge) return
      x1 = one / x
      x2 = x1 * x1
      alngam = alngam + x1 * ((r4(3)*x2 + r4(2))*x2 + r4(1)) /
     +              ((x2 + r4(5))*x2 + r4(4))
      return
      end
C end-of-alngam (AS245)
C
C Algorithm AS66 Applied Statistics (1973) vol22 no.3
C
C Evaluates the tail area of the standardised normal curve
C       from x to infinity if up is .true. or
C       from minus infinity to x if up is .false.
C
      double precision function zp(x)
      double precision zero,one,half
      double precision con,z,y,x
      double precision p,q,r,a1,a2,a3,b1,b2,c1,c2,c3,c4,c5,c6
      double precision d1,d2,d3,d4,d5
      logical up
C* machine dependent constants
      double precision ltone,utzero
      data zero/0.0d0/, one/1.0d0/, half/0.5d0/
      data ltone/7.0d0/,utzero/18.66d0/
      data con/1.28d0/
      data p/0.398942280444d0/,q/0.39990348504d0/,r/0.398942280385d0/
      data a1/5.75885480458d0/,a2/2.62433121679d0/,a3/5.92885724438d0/
      data b1/-29.8213557807d0/,b2/48.6959930692d0/
      data c1/-3.8052d-8/,c2/3.98064794d-4/,c3/-0.151679116635d0/
      data c4/4.8385912808d0/,c5/0.742380924027d0/,c6/3.99019417011d0/
      data d1/1.00000615302d0/,d2/1.98615381364d0/,d3/5.29330324926d0/
      data d4/-15.1508972451d0/,d5/30.789933034d0/
C
      up=.true.
      z=x
      if (z.ge.zero) goto 10
        up=.not.up
        z=-z
   10 if (z.le.ltone .or. up .and. z.le.utzero) goto 20
        zp=zero
        goto 40
   20 y=half*z*z
      if (z.gt.con) goto 30
c
      zp=half-z*(p-q*y/(y+a1+b1/(y+a2+b2/(y+a3))))
      goto 40
   30 zp=r*dexp(-y)/(z+c1+d1/(z+c2+d2/(z+c3+d3/(z+c4+d4/(z+c5+d5/
     2   (z+c6))))))
   40 if (.not.up) zp=one-zp
      return
      end
C end-of-zp (AS66)
C
C Algorithm AS 111, Appl.Statist., vol.26, 118-121, 1977.
C Produces normal deviate corresponding to lower tail area = p.
C
        double precision function ppnd(p)
        double precision p, q, r
        double precision a0, a1, a2, a3, b1, b2, b3, b4,
     &                   c0, c1, c2, c3, d1, d2, split
        double precision half, one, zero

        data split/0.42d0/
        data a0,a1,a2,a3/2.50662823884d0,-18.61500062529d0,
     1  41.39119773534d0,-25.44106049637d0/, b1,b2,b3,b4/
     2  -8.47351093090d0,23.08336743743d0,-21.06224101826d0,
     3  3.13082909833d0/, c0,c1,c2,c3/-2.78718931138d0,-2.29796479134d0,
     4  4.85014127135d0,2.32121276858d0/, d1,d2/3.54388924762d0,
     5  1.63706781897d0/
        data zero/0.d0/, one/1.d0/, half/0.5d0/
C
        q = p-half
        if (abs(q).gt.split) go to 10
C
C       0.08 < p < 0.92
C
        r = q*q
        ppnd = q*(((a3*r + a2)*r + a1)*r + a0)/((((b4*r + b3)*r + b2)*r
     1          + b1)*r + one)
        return
C
C       p < 0.08 or p > 0.92, set r = min(p,1-p)
C
   10   r = p
        if (q.gt.zero) r = one-p
        if (r.le.zero) go to 20
        r = sqrt(-log(r))
        ppnd = (((c3*r + c2)*r + c1)*r + c0)/((d2*r + d1)*r + one)
        if (q.lt.zero) ppnd = -ppnd
        return
   20   continue
        ppnd = zero
        return
        end
C end-of-ppnd (AS111)
C
C Algorithm AS 3  Appl. Statist. (1968) vol.17, p.189
C student t probability (lower tail)
C
      double precision function probst(t, idf, ifault)
      integer idf, ifault, im2, ioe
      double precision a, b, c, f, g1, s, fk, t, zero, 
     &                 one, two, half, zsqrt, zatan
C
C g1 is reciprocal of pi
      data zero, one, two, half, g1
     &     /0.0d0, 1.0d0, 2.0d0, 0.5d0, 0.3183098861838d0/
C
      zsqrt(a) = sqrt(a)
      zatan(a) = atan(a)
C
      ifault = 1
      probst = zero
      if (idf .lt. 1) return
      ifault = 0
      f = idf
      a = t / zsqrt(f)
      b = f / (f + t ** 2)
      im2 = idf - 2
      ioe = mod(idf, 2)
      s = one
      c = one
      f = one
      ks = 2 + ioe
      fk = ks
      if (im2 .lt. 2) goto 20
      do 10 k = ks, im2, 2
      c = c * b * (fk - one) / fk
      s = s + c
      if (s .eq. f) goto 20
      f = s
      fk = fk + two
   10 continue
   20 if (ioe .eq. 1) goto 30
      probst = half + half * a * zsqrt(b) * s
      return
   30 if (idf .eq. 1) s = zero
      probst = half + (a * b * s + zatan(a)) * g1
      return
      end
C end-of-probst (AS3)
C
C accumulate mean and sum-of-squares following AS41
C
      subroutine moment(n,x,mean,ss)
      integer n
      double precision mean, ss, x
C local variables
      double precision dev

      dev=x-mean
      mean=mean+dev/dfloat(n)
      ss=ss+dev*dev*dfloat(n-1)/dfloat(n)
      return
      end
C end-of-moment
C
C accumulate means and SSCP following AS41
C
      subroutine dssp(nvar, nobs, iwt, x, mean, cov)
      integer iwt, nobs, nvar
      double precision cov(*), mean(*), x(*)
C local variables
      integer i,j,k
      double precision b, c
      b=dfloat(iwt)/dfloat(nobs)
      c=dfloat(iwt)-b
      k=0
      do 10 i=1, nvar
        x(i)=x(i)-mean(i)
        mean(i)=mean(i)+b*x(i)
        do 15 j=1, i
          k=k+1
          cov(k)=cov(k)+c*x(i)*x(j)
   15   continue
   10 continue
      return
      end
C end-of-dssp
C
C Initialize covariance matrix used by AS164
C
      subroutine inicov(nter, ncov, r)
      integer ncov, nter
      double precision r(ncov)
C
      call filltri(nter,ncov,r,-1.0d0,0.0d0)
      return
      end
C end-of-inicov
C
C Algorithm AS164  Appl. Statist. (1981) vol.30, no.2
C Incorporate new row of data into R matrix
C
      subroutine givenc(r, ir, nvars, x, v, ifault)
      double precision zero, eps0, eps1
      parameter(zero=0.0d0, eps0=0.0d0, eps1=0.0d0)
      integer ifault, ir, nvars
      double precision r(ir), x(nvars), v
C
      integer i, ii, ij, iplus, j
      double precision c, ctemp, rtemp, s, vlocal, vnew, xi, xi2
C
      ifault = 0
      irused = nvars*(nvars+1)/2
      if (ir.lt.irused) go to 1003
      if (v.lt.zero) go to 1002
      vlocal = v
C
C for each row of upper triangular r
C
      ii = 0
      do 60 i = 1, nvars
        ii = ii + i
        xi = x(i)
        xi2 = xi*xi
        if (xi2.le.abs(vlocal)*eps0) go to 60
        ctemp = r(ii)
        ij = ii
        iplus = i + 1
C
C if zero weight on row of r, simple pivot
C
        if (ctemp.ge.zero) go to 20
        r(ii) = vlocal/xi2
        if (i.eq.nvars) go to 70
        do 10 j = iplus, nvars
          ij = ij + j - 1
          r(ij) = x(j)/xi
   10   continue
        return
C
C if infinite weight on row of r, simple pivot
C
   20   if (ctemp.gt.eps1) go to 40
        do 30 j = iplus, nvars
          ij = ij + j - 1
          x(j) = x(j) - xi*r(ij)
   30   continue
        go to 60
C
C otherwise ordinary givens rotation
C
   40   vnew = vlocal + ctemp*xi2
        c = vlocal/vnew
        s = ctemp*xi/vnew
        vlocal = vnew
        r(ii) = ctemp*c
        if (i.eq.nvars) go to 70
        do 50 j = iplus, nvars
          ij = ij + j - 1
          rtemp = c*r(ij) + s*x(j)
          x(j) = x(j) - xi*r(ij)
          r(ij) = rtemp
   50   continue
C
   60 continue
C
C check for inconsistent or duplicated constraints
C
   70 if (abs(r(irused)).le.eps1) go to 1001
      if (vlocal.le.eps1) ifault = -1
      return
C
C error flag set
C
 1001 ifault = ifault + 1
 1002 ifault = ifault + 1
 1003 ifault = ifault + 1
      return
      end
C end-of-givenc (AS164)
C
C Algorithm AS 164.1  Appl. Statist. (1981) vol.30, no.2
C Perform back substitution to get regression coefficient estimates
C
      subroutine bsub(r, ir, idep, coeff, ic, ifault)
      double precision zero
      parameter(zero=0.0d0)
      integer ic,idep,ifault,ir
      double precision r(ir), coeff(ic)
C
      integer i,ii,ij,k,nx,nxvars
      double precision temp
C
      ifault = 0
      ii = idep*(idep+1)/2
      nxvars = idep - 1
      if (ir.lt.ii.or.ic.lt.nxvars) go to 1001
      if (nxvars.lt.1) return
C
C back substitution
C
      k = ii
      nx = idep
      do 30 i = 1, nxvars
        ii = ii - nx
        k = k - 1
        temp = r(k)
        if (r(ii).lt.zero) ifault = ifault - 1
        if (i.eq.1) go to 20
        ij = ii
        do 10 j = nx, nxvars
          ij = ij + j - 1
          temp = temp - r(ij)*coeff(j)
   10   continue
   20   nx = nx - 1
        coeff(nx) = temp
   30 continue
      return
C
 1001 ifault = 1
      return
      end
C end-of-bsub (AS164.1)
C
C Algorithm AS 164.2  Appl. Statist. (1981) Vol.30, No.2
C Finds (icomp)th component of total sum of sqrs
C Zero-th component is residual ssq
C
C
      subroutine sscomp(r, ir, idep, nobs, icomp, ssq, idf, ifault)
      integer icomp, idf, ifault, idep, ir, nobs
      double precision r(ir), ssq
C local variables
      integer i, ii, ij, nxvars
      double precision one, zero
      data zero/0.0d0/, one/1.0d0/
C
C Small constant that the user can modify
C
      data eps1/0.0d0/
C
C Check for valid parameters
C
      ifault = 0
      irused = idep*(idep + 1)/2
      if (ir.lt.irused) ifault = ifault + 1
      if (icomp.lt.0.or.icomp.ge.idep) ifault = ifault + 2
      if (ifault.gt.0) return
C
C Test if residual ssq required
C
      if (icomp.ge.1) go to 20
      nxvars = idep - 1
      idf = nobs - nxvars
      ii = 0
      do 10 i = 1, nxvars
        ii = ii + i
        if (r(ii).le.eps1) idf = idf + 1
   10 continue
      ssq = zero
      if (r(irused).gt.eps1) ssq = one/r(irused)
      return
C
C Ordinary component
C
   20 idf = 0
      ssq = zero
      ii = icomp*(icomp+1)/2
      if (r(ii).le.eps1) return
      idf = 1
      ij = irused - idep + icomp
      ssq = r(ij)*r(ij)/r(ii)
      return
      end
C end-of-sscomp
C
C Algorithm AS164.3  Appl. Statist. (1981) vol.30, no.2
C Estimates var/covar matrix of regression coefficients
C
      subroutine var(r, ir, s, is, idep, nobs, typ, ifault)
      double precision zero, one, eps1
      parameter(zero=0.0d0, one=1.0d0, eps1=0.0d0)
      integer idep, ifault, ir, is, nobs, typ
      double precision r(ir), s(is)
C
      integer idf, ij, irused, j, jj, k, ki, kj, kk, kmax,kmin, nxvars
      double precision sigma, stemp
C
C check for valid parameters
C
      ifault = 0
      irused = idep*(idep+1)/2
      if (ir.lt.irused.or.is.lt.(irused-idep)) go to 1002
      nxvars = idep - 1
C
C invert unit upper triangular matrix
C
      ncons = 0
      ij = 0
      do 50 i = 1, nxvars
        jj = 0
        j = 0
   10   j = j + 1
        ij = ij + 1
        jj = jj + j
        if (j.lt.i) go to 20
        if (r(ij).le.eps1) ncons = ncons + 1
        go to 50
   20   stemp = -r(ij)
        ik = ij
        kj = jj
        kmax = i - 1
        kmin = j + 1
        if (kmax.lt.kmin) go to 40
        do 30 k = kmin, kmax
          ik = ik + 1
          kj = kj + k - 1
          stemp = stemp - r(ik)*s(kj)
   30   continue
   40   s(ij) = stemp
        go to 10
   50 continue
C
C estimate variance and apply identifiability constraints
C
      idf = nobs - nxvars + ncons
      if (idf.le.0) go to 1001
      sigma = zero
      if (r(irused).gt.zero) then
        if (typ.eq.1) then
          sigma = one/(r(irused)*dfloat(idf))
        else
          sigma = one
        end if
      end if
      ii = 0
      do 60 i = 1, nxvars
        ii = ii + i
        s(ii) = sigma*r(ii)
        if (r(ii).lt.zero) s(ii) = zero
   60 continue
C
C multiply matrices together to form est of var
C
      ii = 0
      ij = 0
      do 90 i = 1, nxvars
        ii = ii + i
        do 90 j = 1, i
          kk = ii
          ij = ij + 1
          ki = ij
          kj = ii
          stemp = s(kk)
          if (i.ne.j) stemp = stemp*s(ij)
          k = i
   70     k = k + 1
          if (k.gt.nxvars) go to 80
          kk = kk + k
          ki = ki + k - 1
          kj = kj + k - 1
          stemp = stemp + s(ki)*s(kj)*s(kk)
          go to 70
C
   80     s(ij) = stemp
   90 continue
      return
C
 1001 ifault = ifault + 1
 1002 ifault = ifault + 1
      return
      end
C end-of-var (AS164.3)
C
C Algorithm AS164.4  Appl. Statist. (1981) vol.30, no.2
C Assumes any diagonal elements of d less than eps are
C Rounding errors and reduces them to zero
C
      subroutine alias(r, ir, nvars, eps, worksp, ifault)
      double precision zero, one, oneneg
      parameter(zero=0.0d0, one=1.0d0, oneneg=-1.0d0)
C
      integer ifault,ir,nvars
      double precision eps, r(ir), worksp(nvars)
C local
      integer i,ii,ij,iplus,irused, nxvars
      double precision v
C
C check for valid parameters
C
      ifault = 0
      irused = nvars*(nvars+1)/2
      if (ir.lt.irused) go to 1001
      nxvars = nvars - 1
C
C for each row of triangular r
C
      ii = 0
      do 20 i = 1, nxvars
        ii = ii + i
        worksp(i) = zero
C
C check for weight of row near zero
C
        if (abs(r(ii))*eps.le.one) go to 20
        ifault = ifault - 1
        v = r(ii)
        r(ii) = oneneg
        ij = ii
        iplus = i + 1
C
C rotate modified row with givens
C
        do 10 j = iplus, nvars
          ij = ij + j - 1
          worksp(j) = r(ij)
          r(ij) = zero
   10   continue
        call givenc(r, ir, nvars, worksp, v, ifail)
   20 continue
      return
C
C set fault indicator
C
 1001 ifault = 1
      return
      end
C end-of-alias (AS164.4)
C
C Use AS164 to fit a log-linear model
C
      subroutine loglin(ncells,totpars,npars,count,model,
     &              x,r,b,cov,lrts)
      integer MAXIBD, MAXTER, MAXCOV
      double precision DELTA, EPS
      parameter(DELTA=1.0d-5, EPS=1.0d-6, MAXIBD=1000,
     &          MAXTER=MAXIBD/2, MAXCOV=MAXTER*(MAXTER+1)/2)
      integer ncells, npars, totpars
      
      real count(*), model(*)
      double precision lrts
C
C regression work arrays
      double precision x(MAXTER),r(MAXCOV),b(MAXTER),cov(MAXCOV)
      double precision eta(MAXTER), weight(MAXTER)
C local variables
      integer ifail, it, ncov, nter, pos
      double precision obs, oldx2, pred

      ifail=0
      nter=npars+1
      ncov=nter*(nter+1)/2
      nobs=0
      do 1 i=1, ncells
        eta(i)=log(dble(count(i))+0.5d0)
        weight(i)=1.0d0/(dble(count(i))+0.5d0)
        nobs=nobs+int(count(i))
    1 continue

      it=0
      lrts=-1.0d0
    5 continue
        it=it+1
        oldx2=lrts
        call inicov(nter, ncov, r)
        do 10 i=1, ncells
          pos=(i-1)*totpars
          do 15 j=1,npars 
            pos=pos+1
            x(j)=dble(model(pos))
   15     continue
          x(nter)=eta(i)
          call givenc(r, ncov, nter, x, weight(i), ifail)
   10   continue
        call alias(r, ncov, nter, 1.0d-15, x, ifail)
        call bsub(r, ncov, nter, b, npars, ifail)
        lrts=0.0d0
        do 30 i=1,ncells
          pred=0.0d0
          pos=(i-1)*totpars
          do 35 j=1,npars
            pos=pos+1
            pred=pred+b(j)*dble(model(pos))
   35     continue
          pred=exp(pred)
          obs=dble(count(i))
          eta(i)=log(pred)+(obs-pred)/pred
          if (obs.gt.EPS .and. pred.gt.EPS) lrts=lrts+obs*log(obs/pred)
          weight(i)=1.0d0/pred
   30   continue
      if (it.lt.50 .and. abs(lrts-oldx2).gt.DELTA) goto 5

      call alias(r, ncov, nter, 1.0d-15, x, ifail)
      call bsub(r, ncov, nter, b, npar, ifail)
      call var(r, ncov, cov, ncov, nter, nobs, 2, ifail)

      return
      end
C end-of-loglin
C
C logit of p
      double precision function logit(p)
      double precision p
      if (p.le.0.00000001d0) then
        logit=-18.42068073d0
      elseif (p.gt.0.99999999d0) then
        logit=+18.42068073d0
      else
        logit=log(p)-log(1-p)
      end if
      return
      end
C end-of-logit
C
C reverse logit
      double precision function alogit(x)
      double precision x
      alogit=exp(x)/(1+exp(x))
      return
      end
C end-of-alogit
C
C  The function RANDN() returns a normally distributed pseudo-random
C  number with zero mean and unit variance.  Calls are made to a
C  function subprogram RANDOM() which returns independent random
C  numbers uniform in the interval (0,1).
C
C  The algorithm uses the ratio of uniforms method of A.J. Kinderman
C  and J.F. Monahan augmented with quadratic bounding curves.
C
        real function randn()
        real a,b,r1,r2,s,t
C functions
        real random
        data s,t,a,b / 0.449871, -0.386595, 0.19600, 0.25472/
        data r1,r2/ 0.27597, 0.27846/

C
C  Generate P = (u,v) uniform in rectangle enclosing acceptance region
 50     u = random()
        v = random()
        v = 1.7156 * (v - 0.5)
C  Evaluate the quadratic form
        x  = u - s
        y  = abs(v) - t
        q  = x**2 + y*(a*y - b*x)
C  Accept P if inside inner ellipse
        if (q .lt. r1) go to 100
C  Reject P if outside outer ellipse
        if (q .gt. r2) go to 50
C  Reject P if outside acceptance region
        if (v**2 .gt. -4.0*log(u)*u**2) go to 50
C  Return ratio of P's coordinates as the normal deviate
 100    randn = v/u
        return
        end
C end-of-randn
C
C Return a pseudo-random integer from integer U(lo..hi)
C
      integer function irandom(lo,hi)
      integer lo,hi
C functions
      real random
      irandom=lo+int(float(hi-lo+1)*random())
      if (irandom.gt.hi) irandom=hi
      return      
      end
C end-of-irandom
C
C Algorithm AS 183 Appl Stat 1982; 31:188
C Returns a pseudo-random number from U(0,1)
C
C ix,iy,iz should be "randomly" initialised to 1-30000
C eg via time 
C
      real function random()
      integer ix,iy,iz
      common /rndseed/ ix,iy,iz 
      ix=171*mod(ix,177)-2*(ix/177)
      iy=172*mod(iy,176)-35*(iy/176)
      iz=170*mod(iz,178)-63*(iz/178)
C
      if (ix.lt.0) ix=ix+30269
      if (iy.lt.0) iy=iy+30307
      if (iz.lt.0) iz=iz+30323
C
      random=amod(float(ix)/30269.0+float(iy)/30307.0 +
     :		  float(iz)/30323.0,1.0)
      return
      end
C end-of-random (AS183)
C
C end-of-program

C
C N-way cross-tabulation
C
      subroutine xtab(wrk,analys,nloc,loclist,loc,locpos,loctyp,
     2                pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     3                numloc,val, values,idx,icount,plevel)
      integer KNOWN, MAXSIZ, MAXLOC, MISS, VSIZ
      parameter(KNOWN=0, MAXSIZ=1000, MAXLOC=120, 
     &          MISS=-9999, VSIZ=MAXSIZ*MAXLOC)
 
      integer analys,nloc, numloc,plevel,wrk
      integer loclist(nloc)
C current data vector
      real val(MAXSIZ)
C
C Locus structure:
C number of loci, locus name, locus type, and locus position in file
C
      character*10 loc(MAXLOC)
      integer loctyp(MAXLOC),locpos(MAXLOC)
C
C contingency table: idx points to data vector in values
      integer ncells
      integer idx(MAXSIZ), icount(MAXSIZ)
      integer topcat
      real values(VSIZ)
C  Pedigree structure
      character*10 pedigree
      integer actset,num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ)
      integer sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C
      integer i, iwt, j, lpos, margin, nmarg, nmiss, pos, tot, totdim
      integer ndim(MAXSIZ)
      logical last

      nmarg=0
      nmiss=0
      ncells=0
      topcat=0
      tot=0
      last=.false.
      rewind(wrk)
    5 continue
        call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &             numloc, last)
        if (last) goto 20

        if (actset.le.0) goto 5

        do 7 i=1,num
          do 8 j=1, nloc
            lpos=locpos(loclist(j))
            val(j)=locus(i,lpos)
            if (val(j).eq.MISS .or. 
     &          (loctyp(loclist(j)).le.2 .and. val(j).le.KNOWN)) then
              nmiss=nmiss+1
              goto 7
            else if (loctyp(loclist(j)).le.2) then
              val(j)=1000.0*locus(i,lpos)+locus(i,lpos+1)
            end if
    8     continue
          tot=tot+1
          call qtabn(nloc,val,ncells,MAXSIZ,idx,icount,0,
     &               topcat,VSIZ,values,1)
    7   continue
      goto 5
   20 continue
C accumulate table margins
      if (nloc.gt.1) then
        margin=ncells
        do 50 i=1,ncells
          pos=idx(i)
          do 60 j=1, nloc
            val(1)=float(j)
            val(2)=values(pos)
            iwt=icount(i)
            call qtabn(2,val,nmarg,MAXSIZ,idx,icount,margin,
     &                 topcat,VSIZ,values,iwt)
            pos=pos+1
   60     continue
   50   continue
        call dimtab(nloc, ncells, nmarg, idx, values, ndim, totdim)
      end if
C write the table
      if (nloc.eq.1) then
        if (plevel.gt.0) then
          write(*,'(/a/3a/a)')
     2    '------------------------------------',
     3    'Tabulation of "',loc(loclist(1)),'"',
     5    '------------------------------------'
        end if
      else 
        write(*,'(/a/5a/a)')
     2    '------------------------------------------------',
     3    'Cross-tabulation of "',loc(loclist(1)),
     4    '" ... "',loc(loclist(nloc)),'"',
     5    '------------------------------------------------'
      end if
C print rectangular or listwise table
      if (nloc.eq.1 .and. plevel.lt.1) then
        call onetab(nloc, loclist, loc, loctyp, ncells, idx, 
     &              icount, values, nmiss, tot)
      else if (nloc.eq.2) then
        call wrtab(analys, nloc, loclist, ndim, loc, loctyp, ncells,
     &              nmarg, idx, icount, values, tot, totdim)
      else
        call listab(nloc, loclist, loc, loctyp, ncells, idx, 
     &              icount, values, tot)
      end if
      return
      end
C end-of-xtab  
C
C Get extent of contingency table
C
      subroutine dimtab(nloc, ncells, nmarg, idx, values, ndim, totdim)
      integer nloc, nmarg, ncells, totdim
      integer ndim(nloc)
C contingency table
      integer idx(*)
      real values(*)
C local variables 
      integer curr, n, i
      n=0
      curr=1
      do 70 i=ncells+1, ncells+nmarg
        if (int(values(idx(i))).eq.curr) then
          n=n+1
        else
          ndim(curr)=n
          curr=curr+1
          n=1
        end if
   70 continue
      ndim(curr)=n
      totdim=ndim(1)
      do 100 i=2, nloc
        totdim=totdim*ndim(i)
  100 continue
      return
      end
C end-of-dimtab
C
C print summary of one-way table
      subroutine onetab(nloc, loclist, loc, loctyp, ncells, idx, 
     &                  icount, values, nmiss, tot)
      integer KNOWN, MAXSIZ, MAXLOC, MISS, VSIZ
      parameter(KNOWN=0, MAXSIZ=1000, MAXLOC=120, 
     &          MISS=-9999, VSIZ=MAXSIZ*MAXLOC)
      integer nloc, nmiss, tot
      integer loclist(nloc)
C number of loci, locus name, locus type, and locus position in file
      character*10 loc(MAXLOC)
      integer loctyp(MAXLOC)
C contingency table
      integer idx(MAXSIZ), icount(MAXSIZ)
      real values(VSIZ)
C local variables 
      integer i, j, n1, n2
      character*7 gtp
      i=loclist(1)
      if (loctyp(i).eq.4) then
        n1=0
        n2=0
        do 95 j=1, ncells
          if (values(idx(j)).eq.1.0d0) n1=icount(j)
          if (values(idx(j)).eq.2.0d0) n2=icount(j)
   95   continue
        write(*,'(a,1x,a,i4,2(a8,i4))') 
     &    loc(i),'x:',nmiss,'y:',n2,'n:',n1
      elseif (ncells.gt.6) then
        write(*,'(a,1x,a,i4,a8,i4,a,i4,a)') 
     &    loc(i),'x:',nmiss,'y:',tot,' (',ncells,' unique values)'
      else
        write(*,'(a,1x,a,i4,$)') loc(i),'x:',nmiss
        if (loctyp(i).eq.3) then
          do 100 j=1,ncells
            write(*,'(1x,f7.1,a,i4,$)') values(idx(j)),':',icount(j)
  100     continue
        else
          do 110 j=1,ncells
            call wrgtp(int(values(idx(j)))/1000,
     &                 mod(int(values(idx(j))),1000),gtp,1)
            call juststr('r',gtp,7)
            write(*,'(1x,2a,i4,$)') gtp,':',icount(j)
  110     continue
        end if
        write(*,*)
      end if
      return
      end
C end-of-onetab  
C
C print listwise contingency table
      subroutine listab(nloc, loclist, loc, loctyp, ncells, idx, 
     &                  icount, values, tot)
      integer KNOWN, MAXSIZ, MAXLOC, MISS, VSIZ
      parameter(KNOWN=0, MAXSIZ=1000, MAXLOC=120, 
     &          MISS=-9999, VSIZ=MAXSIZ*MAXLOC)
 
      integer nloc, tot
      integer loclist(nloc)
C number of loci, locus name, locus type, and locus position in file
      character*10 loc(MAXLOC)
      integer loctyp(MAXLOC)
C contingency table
      integer idx(MAXSIZ), icount(MAXSIZ)
      real values(VSIZ)
C local variables 
      integer i, j
      character*10 cval
      double precision wt

      do 100 j=1, nloc
        cval=loc(loclist(j))
        call juststr('c',cval,10)
        write(*,'(a10,1x,$)') cval
  100 continue
      write(*,'(a/a,$)') '   Count  Percent',
     &  '------------------'
      do 110 j=1, nloc
        write(*,'(a10,$)') '----------'
  110 continue
      write(*,*)
      wt=100.0d0/dfloat(tot)
      do 150 i=1,ncells
        pos=idx(i)
        do 160 j=1, nloc
          call wrtrait(values(pos),cval,loctyp(loclist(j)))
          write(*,'(a10,1x,$)') cval
          pos=pos+1
  160   continue
        write(*,'(1x,i6,4x,f5.1)') icount(i), wt*dfloat(icount(i))
  150 continue
      return
      end
C end-of-listab
C
C print RxC contingency table 
      subroutine wrtab(analys, nloc, loclist, ndim, loc, loctyp, 
     &                 ncells, nmarg, idx, icount, values, tot, totdim)
      integer KNOWN, MAXSIZ, MAXLOC, MISS, VSIZ
      double precision TOL
      parameter(KNOWN=0, MAXSIZ=1000, MAXLOC=120, 
     &          MISS=-9999, TOL=1.0d-6, VSIZ=MAXSIZ*MAXLOC)
 
      integer analys, nloc, tot, totdim
      integer loclist(nloc), ndim(nloc)
C number of loci, locus name, locus type, and locus position in file
      character*10 loc(MAXLOC)
      integer loctyp(MAXLOC)
C contingency table
      integer ncells, nmarg
      integer idx(MAXSIZ), icount(MAXSIZ)
      real values(VSIZ)
C local variables 
      integer address, cnt, df, i,  icell, n(4), 
     &        nxtcell, offset, pos, t1, t2
      character*10 cval1, cval2
      real curr
      double precision er, e, kwstat, nr, lrts, rank, rankg, ss, ties
C functions
      double precision chip

      t1=loclist(1)
      t2=loclist(2)
      cval1=loc(t1)
      cval2=loc(t2)
      n(1)=0
      n(2)=0
      n(3)=0
      n(4)=0
      lrts=0.0d0
C print as 2x2 table
      if (loctyp(t1).eq.4 .and. loctyp(t2).eq.4) then
        do 10 i=1,ncells
          n(7-2*int(values(idx(i)))-int(values(idx(i)+1)))=icount(i)
   10   continue
        call juststr('c',cval2,10)
        write(*,'(/19x,a10/a10,8x,a3,5x,a/a)') cval2,cval1,
     &    'Yes',' No  Percent','--------------------------------------'
        write(*,'(7x,a3,5x,i6,2x,i6,4x,f5.1)') 
     &    'Yes',n(1),n(2),1.0d2*dfloat(n(1))/dfloat(max(1,n(1)+n(2))) 
        write(*,'(7x,a3,5x,i6,2x,i6,4x,f5.1)') 
     &    ' No',n(3),n(4),1.0d2*dfloat(n(3))/dfloat(max(1,n(3)+n(4))) 
          write(*,'(/a,f6.1)') 'Odds Ratio              = ',
     2      (0.5d0+dfloat(n(1)))*(0.5d0+dfloat(n(4)))/
     3      (0.5d0+dfloat(n(2)))/(0.5d0+dfloat(n(3))) 
C print as RxC table
      else if ((ndim(1).lt.20.or.loctyp(t1).ne.3) .and. 
     &         ndim(2).lt.8 .and. analys.eq.1) then
        write(*,'(/22x,a10/2a,$)') cval2,cval1,' '
        offset=ncells+ndim(1)
        do 20 i=1, ndim(2)
          pos=idx(offset+i)+1
          call wrtrait(values(pos),cval2,loctyp(t2))
          write(*,'(3x,a10,$)') cval2
   20   continue
        write(*,'(/11x,8(a13):)') ('--------------', i=1, ndim(2))
          
        offset=ncells
        icell=0
        nxtcell=1
        call fullidx(nxtcell, nloc, ndim, ncells, idx,
     &               values,totdim,address)
        do 50 i=1, ndim(1)
          call wrtrait(values(idx(offset+i)+1),cval1,loctyp(t1))
          write(*,'(a10,1x,$)') cval1
          nr=dfloat(icount(offset+i))
          er=nr/dfloat(max(1,tot))
          do 25 j=1, ndim(2)
            icell=icell+1
            if (icell.eq.address) then
              cnt=icount(nxtcell)
              nxtcell=nxtcell+1
              call fullidx(nxtcell, nloc, ndim, ncells, idx,
     &                     values, totdim, address)
            else
              cnt=0
            end if
            e=dfloat(cnt)/nr
            if (e.eq.1.0d0) then
              write(*,'(1x,i5,1x,a,$)') cnt,'(1.00)'
            else
              write(*,'(1x,i5,1x,a,f4.3,a,$)') cnt,'(',e,')'
            end if
            e=er*dfloat(icount(offset+ndim(1)+j))
            if (e.gt.TOL .and. cnt.gt.0) then
              lrts=lrts+dfloat(cnt)*log(dfloat(cnt)/e)
            end if
   25     continue
          write(*,*)
   50   continue
        lrts=lrts+lrts
        df=(ndim(1)-1)*(ndim(2)-1)
        write(*,'(/a,i6/a,f6.1/a,i4/a,f6.4)')
     2    '    No. complete observations =',tot,
     3    '    LR contingency chi-square =',lrts,  
     4    '           Degrees of freedom =',df,
     5    '                      P-value =', chip(lrts,df)
C one-way table of means
      else if (analys.eq.2 .or.(ndim(1).lt.8.and.loctyp(t2).eq.3)) then
        write(*,'(/22x,a10/a,6x,a,14x,a,7x,a/11x,a)') 
     2    cval2,cval1,'Mean','SD','Count',
     3       '---------------------------------------'
        e=0.0d0
        kwstat=0.0d0
        rankg=0.0d0
        ss=0.0d0
        icell=0
        offset=ncells+ndim(1)
        curr=values(idx(1))
        do 80 i=1, ncells
          if (values(idx(i)).ne.curr) then
            kwstat=kwstat+rankg*rankg/dfloat(icell)
            call wrtrait(curr,cval1,loctyp(t1))
            write(*,'(a10,3x,f12.4,3x,f12.4,1x,i7)') 
     &        cval1, e, sqrt(ss/dfloat(max(icell-1,1))), icell
            curr=values(idx(i))
            icell=0
            e=0.0d0
            rankg=0.0d0
            ss=0.0d0
          end if
          icell=icell+icount(i)
          call moment(icell,dble(values(idx(i)+1)),e,ss)
          rank=0.0d0
          do 90 j=1, ndim(2)
            rank=rank+dfloat(icount(offset+j))
            if (values(idx(i)+1).eq.values(idx(offset+j)+1)) then
               rank=rank-0.5d0*float(icount(offset+j)-1)
               goto 91
            end if
   90     continue
   91     continue
          rankg=rankg+dfloat(icount(i))*rank
   80   continue
        kwstat=kwstat+rankg*rankg/dfloat(icell)
        call wrtrait(curr,cval1,loctyp(t1))
        write(*,'(a10,3x,f12.4,3x,f12.4,1x,i7)') 
     &    cval1, e, sqrt(ss/dfloat(max(icell-1,1))), icell
C Kruskal-Wallis test statistic, then correction for ties
        kwstat=12.0d0*kwstat/dfloat(tot*(tot+1)) - dfloat(3*(tot+1))
        ties=0.0d0
        do 100 j=1, ndim(2)
          ties=ties+dble(icount(offset+j)**3-icount(offset+j))
  100   continue
        kwstat=kwstat/(1.0d0 - ties/dfloat(tot**3-tot))
        df=(ndim(1)-1)
        write(*,'(/a,f7.2,a,i3,a,f6.4,a)') 
     2     'Kruskal-Wallis H=', kwstat, 
     3     ' df=',df,' (P=', chip(kwstat,df),')'
      else
        call listab(nloc, loclist, loc, loctyp, ncells, idx, 
     &              icount, values, tot)
      end if
      return
      end
C end-of-wrtab 
C
C Location of given cell in complete table
C
      subroutine fullidx(icell, nloc, ndim, ncells, 
     &                   idx, values, totdim, address)
      integer MAXSIZ, MAXLOC, VSIZ
      parameter(MAXSIZ=1000, MAXLOC=120, VSIZ=MAXSIZ*MAXLOC)
      integer address, icell, nloc, offset, totdim 
      integer ndim(nloc)
C contingency table
      integer ncells
      integer idx(MAXSIZ)
      real values(VSIZ)

      integer i, j, mult, pos

      address=1
      mult=totdim
      offset=ncells
      do 10 i=1, nloc
        mult=mult/ndim(i)
        do 20 j=1, ndim(i)
          pos=idx(offset+j)+1
          if (values(pos).eq.values(idx(icell)+i-1)) then
            address=address+mult*(j-1)
          end if
   20   continue
        offset=offset+ndim(i)
   10 continue
      return
      end
C end-of-fullidx
C
C
C Binary trait prevalences and recurrence risks.
C
      subroutine segrat(wrk,locnam,trait,pedigree,actset,num,nfound,
     &                 id,fa,mo,sex, locus, numloc)
C
      integer numloc,trait,wrk
      character*10 locnam
C  Pedigree structure
      integer MAXSIZ, MAXLOC, MISS
      parameter(MAXSIZ=1000, MAXLOC=120, MISS=-9999)
      character*10 pedigree
      integer actset,num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ)
      integer sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C
      integer i, pos, sta, currf,currm
      integer aff(6),den(6),mat(3),matyp,naff,nmiss,nmissf,nsib
      integer sscon, ssdis, hscon, hsdis, gpcon, gpdis, pocon, podis
      real segr(6), ssrec,hsrec,porec, gprec, marrec
      logical last, sibshp
      gpcon=0
      gpdis=0
      gprec=0.0
      hscon=0
      hsdis=0
      hsrec=0.0
      marrec=0.0
      naff=0
      nmiss=0
      nmissf=0
      nsib=0
      pocon=0
      podis=0
      porec=0.0
      sscon=0
      ssdis=0
      ssrec=0.0
      mat(1)=0
      mat(2)=0
      mat(3)=0
      do 1 i=1,6
        aff(i)=0
        den(i)=0
        segr(i)=0.0
    1 continue
      last=.false.
      rewind(wrk)
    5 continue
        call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &             numloc, last)
        if (last) goto 20

        if (actset.le.0) goto 5

        do 7 i=1,num
        if (locus(i,trait).ne.1 .and. locus(i,trait).ne.2) then
          nmiss=nmiss+1
          if (i.le.nfound) nmissf=nmissf+1
        else
          den(4)=den(4)+1
          if (locus(i,trait).eq.2) aff(4)=aff(4)+1
          if (i.le.nfound) then
             den(5)=den(5)+1
             if (locus(i,trait).eq.2) aff(5)=aff(5)+1
          else
             den(6)=den(6)+1
             if (locus(i,trait).eq.2) aff(6)=aff(6)+1
          end if
          do 8 j=max(nfound+1,i+1),num
          if (locus(j,trait).eq.1 .or. locus(j,trait).eq.2) then
            if ((fa(j).eq.i.or.mo(j).eq.i) .or.
     &          (i.gt.nfound .and. (fa(i).eq.j.or.mo(i).eq.j))) then
              if (locus(i,trait).eq.2.and.locus(j,trait).eq.2) then
                pocon=pocon+1
              elseif (locus(i,trait).ne.locus(j,trait)) then
                podis=podis+1
              end if
            elseif ((fa(j).gt.nfound .and. 
     2	             (fa(fa(j)).eq.i .or. mo(fa(j)).eq.i)) .or.
     3              (mo(j).gt.nfound .and. 
     4	             (fa(mo(j)).eq.i .or. mo(mo(j)).eq.i)))
     5      then
              if (locus(i,trait).eq.2.and.locus(j,trait).eq.2) then
                gpcon=gpcon+1
              elseif (locus(i,trait).ne.locus(j,trait)) then
                gpdis=gpdis+1
              end if
            elseif (i.gt.nfound) then
              if (fa(i).eq.fa(j).and.mo(i).eq.mo(j)) then
                if (locus(i,trait).eq.2.and.locus(j,trait).eq.2) then
                  sscon=sscon+1
                elseif (locus(i,trait).ne.locus(j,trait)) then
                  ssdis=ssdis+1
                end if
              elseif (fa(i).eq.fa(j).or.mo(i).eq.mo(j)) then
                if (locus(i,trait).eq.2.and.locus(j,trait).eq.2) then
                  hscon=hscon+1
                elseif (locus(i,trait).ne.locus(j,trait)) then
                  hsdis=hsdis+1
                end if
              elseif ((fa(i).gt.nfound .and. 
     2	               (fa(fa(i)).eq.j .or. mo(fa(i)).eq.j)) .or.
     3                (mo(i).gt.nfound .and. 
     4	               (fa(mo(i)).eq.j .or. mo(mo(i)).eq.j))) 
     5        then
                if (locus(i,trait).eq.2.and.locus(j,trait).eq.2) then
                  gpcon=gpcon+1
                elseif (locus(i,trait).ne.locus(j,trait)) then
                  gpdis=gpdis+1
                end if
              end if
            end if
          end if
    8     continue
        end if
    7   continue
C
C If any nonfounders, do segregation ratios

        if (nfound.eq.num) goto 5

        pos=nfound+1
        sta=pos
        currf=fa(sta)
        currm=mo(sta)
        last=.false.
        sibshp=.false.        
C through sibship by sibship
   10   continue
          if (pos.gt.num) then
            last=.true.
            sibshp=.true.
          elseif (currf.ne.fa(pos) .or. currm.ne.mo(pos)) then
            sibshp=.true.
          end if
          if (sibshp .and. locus(currf,trait).ne.MISS .and.
     2        locus(currm,trait).ne.MISS) 
     3    then
            matyp=1
            if (locus(currf,trait).eq.2) matyp=matyp+1
            if (locus(currm,trait).eq.2) matyp=matyp+1
            mat(matyp)=mat(matyp)+1
            do 12 i=sta,pos-1
              if (locus(i,trait).ne.MISS) then
                nsib=nsib+1
                den(matyp)=den(matyp)+1
              end if
              if (locus(i,trait).eq.2) then
                aff(matyp)=aff(matyp)+1
                naff=naff+1
              end if
   12       continue
          end if
C exit if last sibship
        if (last) goto 5
C else move to next sibship if appropriate and iter
          if (sibshp) then
            sibshp=.false.
            sta=pos
            currf=fa(sta)
            currm=mo(sta)
          end if
          pos=pos+1
        goto 10

C end of segregation ratio loop

   20 continue
C
C last pedigree -- write output
C
      write(*,'(/a/a,a10,a/a/)')
     2  '------------------------------------------------',
     3  'Segregation ratios for trait "',locnam,'"',
     4  '------------------------------------------------'
      do 22 i=1,6
   22   if (den(i).gt.0) segr(i)=float(aff(i))/float(den(i))
      write(*,'(a/a)') 'Total sample   All       Fndrs     Nonfndrs',
     &                 '-------------------------------------------'
      write(*,'(3x,a8,3(1x,i4,a1,i4)/3x,a8,3(5x,f5.3)/3x,a8,3(5x,i5))') 
     2      'Aff/Tot ', aff(4),'/',den(4), aff(5),'/',den(5),
     3      aff(6),'/',den(6), 'Prop Aff',segr(4), segr(5), segr(6),
     4      'Missing ',nmiss,nmissf,nmiss-nmissf
      write(*,'(/a/a)') 'Mating Type     UxU       UxA       AxA',
     &                  '-------------------------------------------'
      write(*,'(3x,a8,3i10/3x,a8,3(1x,i4,a1,i4)/3x,a8,3(5x,f5.3))') 
     2      'Matings ', mat(1),mat(2),mat(3),
     3      'Aff/Tot ', aff(1),'/',den(1), aff(2),'/',den(2),
     4      aff(3),'/',den(3), 'Prop Aff',segr(1), segr(2), segr(3)
      write(*,'(/a/a)') 'Relative pair  RecRisk   Aff-Aff   Aff-UnA',
     &                  '-------------------------------------------'
      if ((pocon+podis).gt.0) 
     &  porec=float(2*pocon)/float(2*pocon+podis)
      if ((sscon+ssdis).gt.0) 
     &  ssrec=float(2*sscon)/float(2*sscon+ssdis)
      if ((hscon+hsdis).gt.0) 
     &  hsrec=float(2*hscon)/float(2*hscon+hsdis)
      if ((gpcon+gpdis).gt.0) 
     &  gprec=float(2*gpcon)/float(2*gpcon+gpdis)
      if ((mat(2)+mat(3)).gt.0) 
     &  marrec=float(2*mat(3))/float(2*mat(3)+mat(2))
      write(*,'(3x,a,5x,f5.3,2(5x,i5),4(/3x,a,5x,f5.3,2(5x,i5)))')  
     2      'Marital ',marrec, mat(3), mat(2),
     3      'Gparent ', gprec, gpcon, gpdis,
     4      'Halfsib ', hsrec, hscon, hsdis,
     5      'Par-Off ', porec, pocon, podis,
     6      'Fullsib ', ssrec, sscon, ssdis
      return
      end
C end-of-segrat
C                                                                           
C  Segregation ratios using Davie 1976
C
      subroutine davie(wrk,loc1,trait,loc2,proband,pedigree,actset,num,
     &                 nfound, id,fa,mo,sex, locus, numloc, plevel)
C
      integer numloc,plevel,proband,trait,wrk
      character*10 loc1, loc2
C  Pedigree structure
      integer MAXSIZ, MAXLOC, MISS, NCLASS
      parameter(MAXSIZ=1000, MAXLOC=120, MISS=-9999, NCLASS=4)
      character*10 pedigree
      integer actset,num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ)
      integer sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C
      integer currf, currm, i, matyp, npro, pos, sta
      integer j(NCLASS), mat(NCLASS), q(NCLASS), r(NCLASS), t(NCLASS)
      double precision den, phat(NCLASS), se(NCLASS)
      logical last, sibshp
C functions
      integer eow

      write(*,'(/a/3a/a)')
     2  '---------------------------------------------------',
     3  'Corrected segregation ratios for trait "',loc1,'"',
     4  '---------------------------------------------------'
      if (trait.eq.proband) then
        write(*,'(a)') 
     &    'NOTE:  Assuming complete ascertainment.'
      else
        write(*,'(3a)') 'NOTE:  Proband defined by "',
     &     loc2(1:eow(loc2)),'".'
      end if

      if (plevel.gt.1) then
        write(*,'(/a,11x,a)') 'Pedigree   Parents',
     &                  'Faff Maff  Npro Naff  Tot'
      end if
      
      do 1 i=1,NCLASS
        j(i)=0
        mat(i)=0
        phat(i)=0.0d0
        r(i)=0
        q(i)=0
        t(i)=0
    1 continue
      last=.false.
      rewind(wrk)
    5 continue
        call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &             numloc, last)
        if (last) goto 20

        if (actset.le.0) goto 5

        pos=nfound+1
        sta=pos
        currf=fa(sta)
        currm=mo(sta)
        last=.false.
        sibshp=.false.        
C through sibship by sibship
   10   continue
          if (pos.gt.num) then
            last=.true.
            sibshp=.true.
          elseif (currf.ne.fa(pos) .or. currm.ne.mo(pos)) then
            sibshp=.true.
          end if
          if (sibshp) then
            npro=0
            do 13 i=sta,pos-1
            if (locus(i,proband).eq.2 .and. locus(i,trait).eq.2) then
              npro=npro+1
            end if
   13       continue
            call davstat(4,pos,sta,npro,trait,locus,mat,j,q,t,r)
            if (locus(currf,trait).ne.MISS .and.  
     &          locus(currm,trait).ne.MISS) then
              matyp=1
              if (locus(currf,trait).eq.2.0) matyp=matyp+1
              if (locus(currm,trait).eq.2.0) matyp=matyp+1
              call davstat(matyp,pos,sta,npro,trait,locus,mat,j,q,t,r)
            end if

            if (plevel.gt.1) then
              call  davwri(pedigree, currf, currm, pos, sta,
     &                     npro, trait, id, locus)
            end if
          end if
C exit if last sibship
        if (last) goto 15
C else move to next sibship if appropriate and iter
          if (sibshp) then
            sibshp=.false.
            sta=pos
            currf=fa(sta)
            currm=mo(sta)
          end if
          pos=pos+1
        goto 10
   15   continue
C
      goto 5
   20 continue
C
C last pedigree -- write output
C
      do 100 i=1,NCLASS
        den=dfloat(t(i)-j(i))
        if (den.gt.0.0d0) then
          phat(i)=dfloat(r(i)-j(i))/den
          se(i)=dfloat((r(i)-j(i))*(t(i)-r(i)))/den**3.0d0 + 
     &          dfloat(2*q(i)*(t(i)-r(i))**2)/den**4.0d0 
          se(i)=sqrt(se(i)) 
        else
          phat(i)=0.0d0
          se(i)=0.0d0
        end if
  100 continue
      write(*,'(/a/a)') 'Mating Type   UxU      UxA      AxA     All',
     &  '-----------------------------------------------'
      write(*,'(3x,a8,4i9/3x,a8,4(1x,i3,a1,i4),2(/3x,a8,4(4x,f5.3)))') 
     2  'Matings ', mat(1),mat(2),mat(3),mat(4), 'Aff/Tot ',
     3   r(1),'/',t(1), r(2),'/',t(2), r(3),'/',t(3), r(4),'/',t(4),
     5  'Risk    ',phat(1), phat(2), phat(3), phat(4),
     6  'Std Err ',se(1),se(2),se(3), se(4)
      return
      end
C end-of-davie
C
C Accumulate counts needed for Davie formula in current family
C
      subroutine davstat(typ,pos,sta,npro,trait,locus,class,j,q,t,r)

      integer MAXSIZ, MAXLOC, MISS, NCLASS
      parameter(MAXSIZ=1000, MAXLOC=120, MISS=-9999, NCLASS=4)
      integer npro, pos, sta, trait, typ
      integer class(NCLASS), j(NCLASS), q(NCLASS), r(NCLASS), t(NCLASS)
      real locus(MAXSIZ,MAXLOC)
C
      integer i

      class(typ)=class(typ)+1
      if (npro.eq.1) then
        j(typ)=j(typ)+1
      end if
      if (npro.eq.2) then
        q(typ)=q(typ)+1
      end if
      do 10 i=sta,pos-1
        if (locus(i,trait).ne.MISS) then
          t(typ)=t(typ)+1
        end if
        if (locus(i,trait).eq.2) then
          r(typ)=r(typ)+1
        end if
   10 continue
      return
      end
C end-of-davstat
C
C print prop affected per sibship
C
      subroutine davwri(pedigree, currf, currm, pos, sta, 
     &                  npro,trait,id,locus)

      integer MAXSIZ, MAXLOC, MISS
      parameter(MAXSIZ=1000, MAXLOC=120, MISS=-9999)
      integer currf, currm, npro, pos, sta, trait
      character*10 pedigree
      character*8 id(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
      integer i, na, nt
      character*1 af, am
C
      na=0
      nt=0
      call wraff(locus(currf,trait),af)
      call wraff(locus(currm,trait),am)
      do 50 i=sta,pos-1
      if (locus(i,trait).ne.MISS) then
        nt=nt+1   
        if (locus(i,trait).eq.2.0) na=na+1   
      end if
   50 continue
      write(*,'(3(a,1x),2(3x,a1,1x),3i5)') 
     &  pedigree, id(currf), id(currm), af, am, npro, na, nt
      return
      end
C end-of-davwri
C
C Quantitative trait relatives means and covariances
C
      subroutine famcor(wrk,locnam,trait,pedigree,actset,num,nfound,
     &                 id,fa,mo,sex, locus, numloc,plevel)
 
      integer numloc,plevel,trait,wrk
      character*10 locnam
C  Pedigree structure
      integer MAXSIZ, MAXLOC, MISS
      parameter(MAXSIZ=1000, MAXLOC=120, MISS=-9999)
      character*10 pedigree
      integer actset,num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ)
      integer sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C
      integer i, pos, sta, currf,currm, nships, nsibs
      integer nmiss,nmissf,npairs(5), tnum(3)
      double precision  mean(3), tvar(3), maxv(3), minv(3)
      double precision cov(5), mu(5,2), cvar(5,2), x1, x2
C Sibship variance test regression results
      double precision x(3),r(6),b(2)
      double precision alpha,beta,sea,seb,ssm,ssw,tvalb
      logical last, sibshp
      character*12 midpar
C functions
      double precision probst
      nmiss=0
      nmissf=0
      nships=0
      do 1 i=1,3
        maxv(i)=-1.0d20
        minv(i)=+1.0d20
        mean(i)=0.0d0
        tvar(i)=0.0d0
        tnum(i)=0 
    1 continue
      do 2 i=1,5
        mu(i,1)=0.0d0
        mu(i,2)=0.0d0
        npairs(i)=0
        cvar(i,1)=0.0d0
        cvar(i,2)=0.0d0
        cov(i)=0.0d0
    2 continue
      do 3 i=1,6
        r(i)=0.0d0
    3 continue
      j=0
      do 4 i=1,3
        j=j+i
        r(j)=-1.0d0
    4 continue
      write(*,'(/a/a,a10,a/a/)')
     2  '------------------------------------------------',
     3  'Summary statistics for trait "',locnam,'"',
     4  '------------------------------------------------'
      if (plevel.gt.1) then
        write(*,'(2a/2a)') 
     2  'Pedigree   Father   Mother   Midparent    Sibship Mean',
     3  ' log(Sibs Var)',
     4  '---------- -------- -------- ------------ ------------',
     5  ' ------------'
      end if
      last=.false.
      rewind(wrk)
    5 continue
        call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &             numloc, last)
        if (last) goto 20

        if (actset.le.0) goto 5

        do 7 i=1,num
        if (locus(i,trait).eq.MISS) then
          nmiss=nmiss+1
          if (i.le.nfound) nmissf=nmissf+1
        else
          x1=dble(locus(i,trait))
          if (x1.gt.maxv(1)) then
            maxv(1)=x1
          end if
          if (x1.lt.minv(1)) then
            minv(1)=x1
          end if
	  tnum(1)=tnum(1)+1
          call moment(tnum(1),x1,mean(1),tvar(1))
          if (i.le.nfound) then
            if (x1.gt.maxv(2)) then
              maxv(2)=x1
            end if
            if (x1.lt.minv(2)) then
              minv(2)=x1
            end if
	    tnum(2)=tnum(2)+1
            call moment(tnum(2),x1,mean(2),tvar(2))
          else
            if (x1.gt.maxv(3)) then
              maxv(3)=x1
            end if
            if (x1.lt.minv(3)) then
              minv(3)=x1
            end if
	    tnum(3)=tnum(3)+1
            call moment(tnum(3),x1,mean(3),tvar(3))
          end if
          do 8 j=max(nfound+1,i+1),num
          if (locus(j,trait).ne.MISS) then
            x2=dble(locus(j,trait))
            if (fa(j).eq.i.or.mo(j).eq.i) then
              call corr(4,x1,x2,npairs,mu,cvar,cov)    
            elseif ((fa(j).gt.nfound .and. 
     2	            (fa(fa(j)).eq.i .or. mo(fa(j)).eq.i)) .or.
     3             (mo(j).gt.nfound .and. 
     4	            (fa(mo(j)).eq.i .or. mo(mo(j)).eq.i))) 
     5      then
              call corr(2,x1,x2,npairs,mu,cvar,cov)    
            elseif (i.gt.nfound) then
              if (fa(i).eq.j.or.mo(i).eq.j) then
                call corr(4,x2,x1,npairs,mu,cvar,cov)    
              elseif (fa(i).eq.fa(j).and.mo(i).eq.mo(j)) then
                call corr(5,x1,x2,npairs,mu,cvar,cov)    
                call corr(5,x2,x1,npairs,mu,cvar,cov)    
              elseif (fa(i).eq.fa(j).or.mo(i).eq.mo(j)) then
                call corr(3,x1,x2,npairs,mu,cvar,cov)    
                call corr(3,x2,x1,npairs,mu,cvar,cov)    
              elseif ((fa(i).gt.nfound .and. 
     2	            (fa(fa(i)).eq.j .or. mo(fa(i)).eq.j)) .or.
     3             (mo(i).gt.nfound .and. 
     4	            (fa(mo(i)).eq.j .or. mo(mo(i)).eq.j))) 
     5        then
                call corr(2,x2,x1,npairs,mu,cvar,cov)    
              end if
            end if
          end if
    8     continue
        end if
    7   continue

        pos=nfound+1
        sta=pos
        currf=fa(sta)
        currm=mo(sta)
        last=.false.
        sibshp=.false.        
C through sibship by sibship
   10   continue
          if (pos.gt.num) then
            last=.true.
            if (num.gt.nfound) sibshp=.true.
          elseif (currf.ne.fa(pos) .or. currm.ne.mo(pos)) then
            sibshp=.true.
          end if
          if (sibshp) then
            if (locus(currf,trait).ne.MISS .and. 
     2          locus(currm,trait).ne.MISS) 
     3      then
C marital correlation
              x1=dble(locus(currf,trait))
              x2=dble(locus(currm,trait))
              call corr(1,x1,x2,npairs,mu,cvar,cov)
              write(midpar,'(f12.4)') 0.5d0*(x1+x2)
            else
              midpar='       x    '
            end if
C within-sibship means and variances
            nsibs=0
            ssm=0.0d0
            ssw=0.0d0
            do 12 i=sta,pos-1
            if (locus(i,trait).ne.MISS) then
              x1=dble(locus(i,trait))
	      nsibs=nsibs+1
              call moment(nsibs,x1,ssm,ssw)
            end if
   12       continue
            if (nsibs.gt.1 .and. ssw.gt.0.0d0) then
              nships=nships+1
              x(1)=1.0d0
              x(2)=ssm
              x(3)=log(ssw/dfloat(max(1,nsibs-1)))
              if (plevel.gt.1) then
                write(*,'(a10,1x,a8,1x,a8,1x,a12,2(1x,f12.4))') 
     &            pedigree,id(currf),id(currm),midpar,x(2),x(3)
              end if
              call givenc(r, 6, 3, x, 1.0d0, ifail)
            end if
          end if
C exit if last sibship
        if (last) goto 15
C else move to next sibship if appropriate and iter
          if (sibshp) then
            sibshp=.false.
            sta=pos
            currf=fa(sta)
            currm=mo(sta)
          end if
          pos=pos+1
        goto 10
   15   continue
C
      goto 5
   20 continue
C
C last pedigree -- write output
C
      if (tnum(1).gt.0) then
        tvar(1)=tvar(1)/dfloat(max(1,tnum(1)-1))
        tvar(2)=tvar(2)/dfloat(max(1,tnum(2)-1))
        tvar(3)=tvar(3)/dfloat(max(1,tnum(3)-1))
	if (tnum(2).eq.0) then
	  maxv(2)=0.0d0
	  minv(2)=0.0d0
	elseif (tnum(3).eq.0) then
	  maxv(3)=0.0d0
	  minv(3)=0.0d0
	end if
        if (plevel.gt.1 .and. nships.gt.0) then
          write(*,*)
        end if
        write(*,'(a/a)')
     2   'Descriptive Stats       All     Founders  Nonfounders',
     3   '-----------------------------------------------------'
        write(*,'(5(a,3x,3(1x,f12.4)/),2(a,2x,3(4x,i5,4x)/))')
     2   'Means      ',mean(1),mean(2),mean(3),
     3   'Variances  ',tvar(1),tvar(2),tvar(3),
     3   'Stand Devs ',sqrt(tvar(1)),sqrt(tvar(2)),sqrt(tvar(3)),
     4   'Maxima     ',maxv(1),maxv(2),maxv(3),
     5   'Minima     ',minv(1),minv(2),minv(3),
     6   'No. obs    ',tnum(1),tnum(2),tnum(3),
     7   'No. missing',nmiss,nmissf,nmiss-nmissf
      else
        write(*,'(a/)') 'NOTE:  No nonmissing observations'
      end if
      do 30 i=1,5
        cvar(i,1)=sqrt(cvar(i,1)/dfloat(max(1,npairs(i)-1)))
        cvar(i,2)=sqrt(cvar(i,2)/dfloat(max(1,npairs(i)-1)))
        if (cvar(i,1).gt.0.0d0 .and. cvar(i,2).gt.0.0d0) then
          cov(i)=cov(i)/dfloat(max(1,npairs(i)-1))/cvar(i,1)
     &                 /cvar(i,2)
        else
          cov(i)=0.0d0
        end if
   30 continue
      write(*,'(a/a/a)')
     2 '-------------- Familial correlations (pairwise) --------------',
     3 'Rel 1   Rel 2    Std Dev 1    Std Dev 2   Correlation  N Pairs',
     4 '--------------------------------------------------------------'
      write(*,'(a,3(1x,f12.4),4x,i5)')
     & 'Husband Wife  ', cvar(1,1),cvar(1,2),cov(1),npairs(1)
      write(*,'(2(a,3(4x,f9.4),4x,i5/a,4x,f9.4,13x,4x,f9.4,4x,i5/))')
     2 'Gparent Gchild', cvar(2,1),cvar(2,2),cov(2),npairs(2),
     3 'Halfsib Hsib  ', cvar(3,1),          cov(3),npairs(3)/2,
     4 'Parent  Off   ', cvar(4,1),cvar(4,2),cov(4),npairs(4),
     5 'Fullsib Fsib  ', cvar(5,1),          cov(5),npairs(5)/2

      write(*,'(a/a)')  'Fain sibship variance test',
     &                  '--------------------------'

      if (nships.gt.2) then
        call alias(r, 6, 3, 1.0d-15, x, ifail)
        call bsub(r, 6, 3, b, 2, ifail)
        call var(r, 6, cov, 6, 3, nships, 1, ifail)
        alpha=b(1)
        sea=sqrt(cov(1))
        beta=b(2)
        seb=sqrt(cov(3))
        tvalb=abs(beta/seb)
        write(*,'(a,i5,2(/a,f10.4,a,f10.4,a)/a,f10.4,a,i3,a,f6.4,a)')
     3    'No. sibships  = ',nships,
     4    'Intercept     = ',alpha,' (ase=',sea,')',
     5    'Slope         = ',beta, ' (ase=',seb,')',
     6    't value       = ',tvalb,' (df=',nships-2,', P=',
     7                       1.0d0-probst(tvalb,nships-2,ifail),')'
      else
        write(*,'(/a/)') 
     &    'NOTE:  Insufficient number of sibships for Fain test.'
      end if
      return
      end
C end-of-famcor
C
C update means and sums of squares and products
C
C 1=Marital 2=Grandparent-Grandchild 3=Half-sib
C 4=Parent-Offspring 5=Full-sib 
C
      subroutine corr(type,x1,x2,npairs,mean,var,cov)
      integer type, npairs(5)
      double precision d1, d2, de, wt, x1,x2
      double precision mean(5,2), var(5,2), cov(5)

      npairs(type)=npairs(type)+1
      de=dfloat(npairs(type))
      wt=(de-1.0d0)/de
      d1=x1-mean(type,1)
      d2=x2-mean(type,2)
      mean(type,1)=mean(type,1)+d1/de
      mean(type,2)=mean(type,2)+d2/de
      var(type,1)=var(type,1)+ d1*d1*wt
      var(type,2)=var(type,2)+ d2*d2*wt
      cov(type)=cov(type)+ d1*d2*wt

      return
      end
C end-of-corr
C
C Means and covariances for multiple trait 
C
      subroutine docov(wrk,nvar,terms,loc,loctyp,locpos,
     2             x,mean,cov,pedigree,actset,num,nfound,id,fa,mo,sex,
     3             locus,numloc,plevel)
C
      integer IBDSIZ, KNOWN, MAXIBD, MAXTER, MAXCOV, MAXSIZ, MAXLOC,MISS
      parameter(KNOWN=0, MAXIBD=1000, IBDSIZ=MAXIBD*(MAXIBD+1)/2, 
     2          MAXTER=MAXIBD/2, MAXCOV=MAXTER*(MAXTER+1)/2,
     3          MAXSIZ=1000, MAXLOC=120, MISS=-9999)
      integer nvar, plevel, wrk
C position of y and x variables
      integer terms(MAXSIZ)
C  Pedigree structure
      character*10 pedigree
      integer actset,num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      integer numloc
      real locus(MAXSIZ,MAXLOC)
C
C Locus structure:
C number of loci, locus name, locus type, and locus position in file
C
      character*10 loc(MAXLOC)
      integer loctyp(MAXLOC),locpos(MAXLOC)
C array of means and covariances
      double precision x(MAXTER),mean(MAXTER), cov(MAXCOV)
C local variables
      integer i, ifail, ii, j, nobs, ncov, ntot 
      logical complete, last
      double precision den

      if (nvar.gt.(MAXTER)) then
        write(*,'(/a,i3,a/)') 
     &    'NOTE:  May analyse only the first ',MAXTER,' variables.'
        nvar=MAXTER
      end if

      ncov=nvar*(nvar+1)/2
      nobs=0
      ntot=0
      ifail=0
      do 1 i=1, nvar
        mean(i)=0.0d0
    1 continue
      do 2 i=1, ncov
        cov(i)=0.0d0
    2 continue

      last=.false.
      rewind(wrk)
    5 continue
        call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &             numloc, last)
        if (last) goto 20

        if (actset.le.0) goto 5

        do 10 i=1,num
          complete=.true.
          do 12 j=1,nvar
          if ((loctyp(terms(j)).le.2 .and. 
     2         locus(i,locpos(terms(j))).lt.KNOWN) .or.
     3        locus(i,locpos(terms(j))).eq.MISS) then
            complete=.false.
            goto 13
          end if
   12     continue
   13     continue

          if (complete) then
            nobs=nobs+1
            do 14 j=1,nvar
              if (loctyp(terms(j)).le.2) then
                x(j)=0.5d0*dble(locus(i,locpos(terms(j)))+
     &                            locus(i,locpos(terms(j))+1))
              elseif (loctyp(terms(j)).eq.4) then
                x(j)=dble(locus(i,locpos(terms(j)))-1.0)
              else
                x(j)=dble(locus(i,locpos(terms(j))))
              end if
   14       continue
            call dssp(nvar, nobs, 1, x, mean, cov)
          end if
   10   continue
        ntot=ntot+num
      goto 5
   20 continue
C
      den=1.0d0/dfloat(max(1,nobs-1))

      ii=0
      do 50 i=1,nvar
        ii=ii+i
        do 55 j=1,i-1
          cov(ii-i+j)=cov(ii-i+j)/sqrt(cov(ii))/sqrt(cov(j*(j+1)/2))
   55   continue
   50 continue

      write(*,'(/a/a)') 
     2  'Variable        Mean      Stand Dev  Correlations',
     3  '---------- ------------ ------------ ---------------------'
      ii=0
      do 60 i=1,nvar
        ii=ii+i
        write(*,'(a10,1x,f12.4,1x,f12.4,12(1x,f4.2))') 
     2     loc(terms(i)),mean(i),sqrt(cov(ii)*den), 
     3     (cov(ii-i+j),j=1,i-1),1.0d0
   60 continue
      write(*,'(2(/a,i7),a,f5.1,a)') 
     2  'Number of variables     =',nvar,
     3  'No. usable observations =',nobs,
     4  '      ( ',float(100*nobs)/float(ntot),'%)' 
C
      return
      end
C end-of-docov  
C
C linear regression analysis of quantitative trait 
C
      subroutine regress(wrk,twrk,typ,nvar,terms,loc,loctyp,locpos,
     2               x,r,b,cov,pedigree,actset,num,nfound,id,fa,mo,sex,
     3               locus,numloc,plevel)
C
      integer KNOWN, MAXIBD, MAXTER, MAXCOV, MAXSIZ, MAXLOC, MISS
      parameter(KNOWN=0, MAXIBD=1000, MAXTER=MAXIBD/2, 
     2          MAXCOV=MAXTER*(MAXTER+1)/2,
     3          MAXSIZ=1000, MAXLOC=120, MISS=-9999)
      integer nvar, plevel, twrk, typ, wrk
C position of y and x variables
      integer terms(MAXSIZ)
C  Pedigree structure
      character*10 pedigree
      integer actset,num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      integer numloc
      real locus(MAXSIZ,MAXLOC)
C
C Locus structure:
C number of loci, locus name, locus type, and locus position in file
C
      character*10 loc(MAXLOC)
      integer loctyp(MAXLOC),locpos(MAXLOC)
C regression work arrays
      double precision x(MAXTER),r(MAXCOV),b(MAXTER),cov(MAXCOV)
C local variables
      integer i,ifail,ii,j,nchange,ncov,nobs,nter,ntot,pos,ypos
      logical complete, fussy, last
C regression results
      integer idf,mdf
      double precision aic,mss,pred,res,rsq,rss,tval
      double precision mean(MAXTER)
      character*3 histo
C functions
      integer eow
      double precision zp

      ypos=terms(nvar)
      write(*,'(/a/3a/a)')
     2  '------------------------------------------------',
     3  'Linear regression analysis of trait "',loc(ypos),'"',
     4  '------------------------------------------------'
      if (nvar.gt.(MAXTER-1)) then
        write(*,'(/a,i3,a/)') 
     &    'NOTE:  May analyse only the first ',MAXTER-1,' variables.'
        nvar=MAXTER-1
      end if

      nobs=0
      ntot=0
      ifail=0
      nter=nvar+1
      ncov=nter*(nter+1)/2
      call inicov(nter, ncov, r)
      do 1 j=1,nvar
        mean(j)=0.0d0
    1 continue

      last=.false.
      rewind(wrk)
    5 continue
        call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &             numloc, last)
        if (last) goto 20

        if (actset.le.0) goto 5
C
        do 10 i=1,num
          complete=.true.
          do 12 j=1,nvar
          if ((loctyp(terms(j)).le.2 .and. 
     2         locus(i,locpos(terms(j))).lt.KNOWN) .or.
     3        locus(i,locpos(terms(j))).eq.MISS) then
            complete=.false.
            goto 13
          end if
   12     continue
   13     continue

          if (complete) then
            nobs=nobs+1
            x(1)=1.0d0
            do 14 j=1,nvar
              pos=terms(j)
              if (loctyp(pos).le.2) then
                x(j+1)=0.5d0*dble(locus(i,locpos(pos))+
     &                            locus(i,locpos(pos)+1))
              elseif (loctyp(pos).eq.4) then
                x(j+1)=dble(locus(i,locpos(pos))-1.0)
              else
                x(j+1)=dble(locus(i,locpos(pos)))
              end if
              mean(j)=mean(j)+x(j+1)
   14       continue
            call givenc(r, ncov, nter, x, 1.0d0, ifail)
          end if
   10   continue
        ntot=ntot+num
      goto 5
   20 continue

      do 30 j=1, nvar
        mean(j)=mean(j)/dfloat(nobs)
   30 continue
C
      call alias(r, ncov, nter, 1.0d-15, x, ifail)
      call bsub(r, ncov, nter, b, nter-1, ifail)
      call var(r, ncov, cov, ncov, nter, nobs, 1, ifail)
      write(*,'(/a/a)') 
     2  '    Variable         Beta    Stand Error        t-Value',
     3  '  -----------------------------------------------------'
      mdf=0
      mss=0.0d0
      tval=abs(b(1))/sqrt(cov(1))
      call phist(zp(tval),1.0d0,histo)
      write(*,'(2x,a10,1x,f12.4,3x,f12.4,3x,f12.4,1x,a3)') 
     &   'Intercept ',b(1),sqrt(cov(1)), tval, histo
      call sscomp(r, ncov, nter, nobs, 1, rss, idf, ifail)
      ii=1
      do 150 i=2,nter-1
        ii=ii+i
        tval=abs(b(i))/sqrt(cov(ii))
        call phist(zp(tval),1.0d0,histo)
        write(*,'(2x,a10,1x,f12.4,3x,f12.4,3x,f12.4,1x,a3)') 
     &     loc(terms(i-1)),b(i),sqrt(cov(ii)), tval, histo
        call sscomp(r, ncov, nter, nobs, i, rss, idf, ifail)
        mdf=mdf+idf
        mss=mss+rss
  150 continue
      call sscomp(r, ncov, nter, nobs, 0, rss, idf, ifail)
      rsq=1.0d0-rss/(rss+mss)
      mss=mss/dfloat(mdf)
      rss=rss/dfloat(idf)
      aic=log(rss)+2.0d0*dfloat(mdf)/dfloat(nobs)
      write(*,'(/a,i7,a,f5.1,a,2(/a,f12.4,a,i4,a),2(/a,f12.4))') 
     2  'No. usable observations =',nobs,
     3  '      ( ',float(100*nobs)/float(ntot),'%)',
     4  'Model Mean Square       =', mss,' (df=',mdf,')',
     5  'Mean Square Error       =', rss,' (df=',idf,')',
     6  'Multiple R**2           =', rsq,
     7  'Akaike Inf. Criterion   =', aic
C
C Write out residuals or predicted values if requested
C
      if (typ.eq.0) return

      nchange=0
      fussy=(typ.gt.10)
      if (fussy) typ=typ-10

      last=.false.
      rewind(wrk)
   55 continue
        call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &             numloc, last)
      if (last) goto 40
        if (actset.gt.0) then
         do 60 i=1,num
           complete=.true.
           pred=b(1)
           do 65 j=1, nvar-1
             pos=terms(j)
             if (loctyp(pos).le.2) then
               if (locus(i,pos).lt.KNOWN) then
                 complete=.false.
                 res=mean(j)
               else
                 res=0.5d0*dble(locus(i,locpos(pos))+
     &                          locus(i,locpos(pos)+1))
               end if
             elseif (locus(i,pos).eq.MISS) then
               complete=.false.
               res=mean(j)
             elseif (loctyp(pos).eq.4) then
               res=dble(locus(i,locpos(pos))-1.0)
             else
               res=dble(locus(i,locpos(pos)))
             end if
             pred=pred + b(j+1)*res
   65      continue
           if (.not.fussy .or. (fussy .and. complete)) then
             if (typ.eq.1 .and. locus(i,ypos).ne.MISS) then
               nchange=nchange+1
               res=dble(locus(i,locpos(ypos)))-pred
               locus(i,locpos(ypos))=sngl(res) 
             elseif (typ.eq.3 .or. 
     &               (typ.eq.2 .and. locus(i,ypos).eq.MISS)) then
               nchange=nchange+1
               locus(i,locpos(ypos))=sngl(pred) 
             end if
           elseif (typ.eq.1) then 
             locus(i,locpos(ypos))=MISS
           end if
   60    continue
        end if
        call wrkout(twrk,pedigree,actset,num,nfound,id,fa,mo,sex,
     &              locus,numloc)
      goto 55
   40 continue
      if (typ.eq.1) then
        write(*,'(/a,i6,3a)') 'Wrote ',nchange,' residuals to ',
     &    loc(ypos)(1:eow(loc(ypos))),'.'
      else
        write(*,'(/a,i6,3a)') 'Wrote ',nchange,' predicted values to ',
     &    loc(ypos)(1:eow(loc(ypos))),'.'
      end if

      return
      end
C end-of-regress
C
C Fit mixture of distributions to quantitative trait
C
      subroutine domix(wrk,locnam,trait,nmix,typ,pedigree,actset,num,
     &             nfound,id,fa,mo,sex,locus,numloc,value,count,plevel)
C
      integer MAXMIX, MAXSIZ, MAXLOC, MISS, VSIZ
      parameter(MAXMIX=5,MAXSIZ=1000,MAXLOC=120,MISS=-9999,
     &          VSIZ=MAXSIZ*MAXLOC)
      integer nmix, plevel, trait, typ, wrk
      character*10 locnam
C  Pedigree structure
      character*10 pedigree
      integer actset,num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      integer numloc
      real locus(MAXSIZ,MAXLOC)
C Quantitative trait values
      integer nobs, nvals
      real value(VSIZ)
      integer count(MAXSIZ)
C Parameter estimates
      real logl
      real alpha(MAXMIX),mean(MAXMIX),sd(MAXMIX) 
C Likelihood contributions
      real prob(MAXSIZ,MAXMIX), den(MAXSIZ)
C local variables
      integer i,ifail,j
      logical last
      real inita,initsd
      character*10 dist(4)
      data dist/'  Normal','Norm: 1 SD','Exponentl',' Poisson'/
C
      nobs=0
      nvals=0

      write(*,'(/a/3a/a)')
     2  '------------------------------------------------',
     3  'Mixture distributions for trait "',locnam,'"',
     4  '------------------------------------------------'

      last=.false.
      rewind(wrk)
    5 continue
        call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &             numloc, last)
        if (last) goto 20

        if (actset.le.0) goto 5
C
C Tabulate sorted values and frequencies
        do 10 i=1,num
        if (locus(i,trait).ne.MISS) then
          nobs=nobs+1
          call qtab(locus(i,trait),nvals,value,count)
        end if
   10   continue
      goto 5
   20 continue
C
C Produce a histogram with HISTCAT intervals
C
      call dohist(min(nvals,21),nvals,value,count,nobs)
      call filliben(nobs,nvals,value,count)
      call symtest(nobs,nvals,value,count)
C
C starting values for mixture
C
      ifail=0
      inita=1.0/float(nmix)
      initsd=sqrt(value(3*nvals/4)-value(nvals/4))
      do 30 i=1,nmix
        alpha(i)=inita
        mean(i)=value(i*nvals/(nmix+1))
        sd(i)=initsd
   30 continue

      call mixture(typ,nmix,nvals,value,count,
     &             alpha,mean,sd,prob,den,nobs,logl,ifail,plevel)

      if (plevel.gt.0) then
        write(*,'(/a/a))') 
     2    ' Rank  Trait value    Obs    Posterior probabilities ',
     3    ' -------------------------------------------------------' 
        do 50 j=1,nvals
          write(*,'(1x,i4,2x,f12.4,i8,5(2x,f5.3):)')
     &      j,value(j),count(j),(alpha(i)*prob(j,i)/den(j),i=1,nmix)
   50   continue
      end if
      if (ifail.ne.0) then
        write(*,'(/a/)') 'ERROR: Problem encountered in estimation.' 
      end if
      write(*,'(/2a,3(/a,i8),/a,f13.4)')
     2  'Distribution type    = ', dist(typ),
     3  'No. of distributions = ', nmix,
     4  'No. of observations  = ', nobs,
     5  'No. of unique values = ', nvals,
     6  '-2*Loglikelihood     = ',-2.0*logl 

      write(*,'(2(/a))')
     2  ' Dist     Mean      Standard Dev  Proportion',
     3  ' -------------------------------------------' 
      do 100 i=1,nmix
        write(*,'(1x,i4,1x,f12.4,2x,f12.4,2x,f6.4)') 
     &    i,mean(i),sd(i),alpha(i)
  100 continue
      return
      end
C end-of-domix
C
C Fit mixture of distributions
C Algorithm AS 203 (Appl Stat 1984; 33:327-332)
C
      subroutine mixture(a,k,m,x,n,alpha,mean,sd,f,g,
     &                   nobs,logl,ifail,plevel)
C
      integer MAXMIX, MAXSIZ
      real TOL
      parameter(MAXMIX=5, MAXSIZ=1000, TOL=1.0d-6)
C
C a=distribution type Nor(k sd) Nor(1 sd) Exp Poi
C k=number of mixture distributions 1..MAXMIX
C m=number of classes 1..MAXSIZ
C
      integer a,k,m,nobs,ifail,plevel
C Parameter estimates
      real logl
      real alpha(MAXMIX),mean(MAXMIX),sd(MAXMIX)
C
C Data: value and number of observations for that value
      integer n(MAXSIZ)
      real x(MAXSIZ)
C Likelihood contributions
      real f(MAXSIZ,MAXMIX), g(MAXSIZ)
C
C Local variables
      logical test
      integer counter
      real oldlogl,part,poolv,poolsd,sumalpha
C Updated estimates
      real nalpha(MAXMIX),nmean(MAXMIX),nsd(MAXMIX),
     &     dt(MAXMIX),nt(MAXMIX),vt(MAXMIX) 
C
      ifail=0
      oldlogl=0.0
      counter=0
      test=.false.
C
C While construct
C
   25 if (test) goto 100 

        if (plevel.gt.2) then
          write(*,'(/a,i5,a,f13.4,a,i2/)') 
     &      'Iter:',counter,' LL:',oldlogl,' Ifail:',ifail
          do 30 j=1,k
            write(*,'(1x,i4,1x,f12.4,2x,f12.4,2x,f6.4)') 
     &        j,mean(j),sd(j),alpha(j)
   30     continue
        end if
        counter=counter+1
        do 40 j=1,k
          if ((alpha(j).gt.1).or.(alpha(j).le.0)) then
            ifail=2
            return
          end if
          if ((mean(j).ge.x(m)).or.(mean(j).le.x(1))) then
            ifail=3
            return
          end if
          if (a.lt.3 .and. sd(j).le.0) then
            ifail=4
            return
          end if
   40   continue
        do 50 i=1,k-1
        do 50 j=i+1,k
          if (mean(i).eq.mean(j)) then
            if (a.lt.3) then
              if (sd(i).eq.sd(j)) then
                ifail=9
                return
              end if
            else
              ifail=8
              return
            end if
          end if
   50   continue
C      
C actual start of EM algorithm a=1-2 Gauss 3 Exp 4 Poisson
C      
        logl=0.0
        do 60 i=1,m
          g(i)=0.0
          do 70 j=1,k
            if (a.eq.3) then
              f(i,j)=exp(-x(i)/mean(j))/mean(j)
            elseif (a.eq.4) then
              if (i.eq.1) then 
                f(i,j)=exp(-mean(j))*mean(j)**x(i)
              else
                f(i,j)=f(i-1,j)*mean(j)**(x(i)-x(i-1))
              end if
            else
              f(i,j)=exp(-0.5*((x(i)-mean(j))/sd(j))**2)/sd(j)
            end if
            g(i)=g(i)+alpha(j)*f(i,j)
   70     continue
          if (g(i).gt.1.0d-25) then
            logl=logl+n(i)*log(g(i))
          end if
   60   continue
C      
C calcs probability densities of the subpopulations which form the
C the mixture, and the loglikelihood function
C      
        test=.true.
        sumalpha=0.0 
C      
        poolv=0.0
        do 80 j=1,k
          nt(j)=0.0
          dt(j)=0.0
          vt(j)=0.0
          do 90 i=1,m
            if (g(i).gt.1.0d-25) then
              part=f(i,j)*n(i)/g(i)
            else
              part=0.0d0
            end if
            dt(j)=dt(j)+part
            nt(j)=nt(j)+part*x(i)
            if (a.lt.3) then 
              vt(j)=vt(j)+part*(x(i)-mean(j))**2
              poolv=poolv+alpha(j)*part*(x(i)-mean(j))**2
            end if
   90     continue
C      
C calc denominators and numerators of new estimates
C      
          nmean(j)=nt(j)/dt(j)
          if (j.ne.k) then
            nalpha(j)=alpha(j)*dt(j)/float(nobs)
            sumalpha=sumalpha+nalpha(j)
          else
            nalpha(k)=1.0-sumalpha
          end if
          if (a.lt.3) then 
            nsd(j)=sqrt(vt(j)/dt(j))
          end if

	  if (abs(oldlogl-logl).gt.TOL) then 
            test= .false.
          end if

          oldlogl=logl
          alpha(j)=nalpha(j)
          mean(j)=nmean(j)
          if (a.lt.3) then 
            sd(j)=nsd(j)
          end if
   80   continue
        if (a.eq.2) then
          poolsd=sqrt(poolv/float(nobs))
          do 82 j=1,k
             sd(j)=poolsd
   82     continue
        end if  
      goto 25
C
C End of While (counter) loop
C
  100 continue
C
C variances for other distributions
C
      if (a.eq.3) then
        do 105 j=1,k
          sd(j)=mean(j)
  105   continue
      elseif (a.eq.4) then
        do 110 j=1,k
          sd(j)=sqrt(mean(j))
  110   continue
      end if

      return
      end
C end-of-mixture
C
C update table of quantitative trait values -- binary search and insertion sort
C 
      subroutine qtab(x,nvals,value,icount)
      integer MAXSIZ
      parameter(MAXSIZ=1000)
      integer nvals
      real value(MAXSIZ), x
      integer icount(MAXSIZ)
      integer hi,lo, pos

      pos=1
      hi=nvals
      lo=1
    1 continue
      if (hi.lt.lo) goto 5
        pos=(hi+lo)/2
        if (x.gt.value(pos)) then
          lo=pos+1
        elseif (x.lt.value(pos)) then
          hi=pos-1
        else
          icount(pos)=icount(pos)+1
          return 
        end if
      goto 1
    5 continue
C 
C else if not found
C
C if enough room, create new category
C
      if (nvals.lt.MAXSIZ) then
        do 25 k=nvals,lo,-1
          value(k+1)=value(k)
          icount(k+1)=icount(k)
   25   continue
        nvals=nvals+1
        value(lo)=x
        icount(lo)=1
C
C else store as average of x and nearest category
C
      else
        value(pos)=value(pos)+(x-value(pos))/float(icount(pos)+1)
        icount(pos)=icount(pos)+1
      end if
      return
      end
C end-of-qtab
C
C update contingency table of trait values -- binary search and insertion sort
C
C ncat=#dimensions, values=data vector, ncells=#cells in table 
C maxcell=max #cells, idx=pointer to label/data for cell,
C icount=count, offset=start of label in workspace, maxcat=workspace
C size, categories=workspace containing all labels/data,
C iwt=contribution of current data vector (usually one)
C 
      subroutine qtabn(ncat,values,ncells,maxcell,idx,icount,
     &                 offset, topcat, maxcat, categories, iwt)
      integer iwt, ncat, offset
      real values(ncat)
C table 
      integer ncells
      integer idx(maxcell),icount(maxcell)
      integer maxcat, topcat
      real categories(maxcat)
C local variables
      integer catpos, endcat, endcell, hi, i, lo, pos

      endcell=offset+ncells

      hi=endcell
      lo=offset+1
      pos=lo
    1 continue
      if (hi.lt.lo) goto 5
        pos=(hi+lo)/2
        catpos=idx(pos)
C test if higher
        do 10 i=1, ncat
          if (values(i).gt.categories(catpos)) then
            lo=pos+1
            goto 1
          else if (values(i).lt.categories(catpos)) then
            goto 11
          end if
          catpos=catpos+1
   10   continue
   11   continue
C test if lower 
        catpos=idx(pos)
        do 20 i=1, ncat
          if (values(i).lt.categories(catpos)) then
            hi=pos-1
            goto 1
          else if (values(i).gt.categories(catpos)) then
            goto 21
          end if
          catpos=catpos+1
   20   continue
   21   continue
C just right
        icount(pos)=icount(pos)+iwt
        return 
C 
C else if not found
C
    5 continue
C
C and if enough room, create new category
C
      endcat=topcat+ncat
      if (endcat.le.maxcat .and. endcell.lt.maxcell) then
        do 25 k=endcell,lo,-1
          idx(k+1)=idx(k)
          icount(k+1)=icount(k)
   25   continue
        ncells=ncells+1
        catpos=topcat+1
        idx(lo)=catpos
        do 50 i=1, ncat
          categories(catpos)=values(i)
          catpos=catpos+1
   50   continue
        icount(lo)=iwt
        topcat=endcat
      else
        write(*,*) 'Too many values for contingency table:'
        write(*,*) (values(i),i=1, ncat), 'n=', iwt
      end if
      return
      end
C end-of-qtabn
C
C
C Binomial regression analysis 
C
      subroutine binreg(wrk,wrk2,twrk,nvar,terms,loc,loctyp,locpos,
     2               x,r,b,cov,pedigree,actset,num,nfound,id,fa,mo,sex,
     3               locus,numloc,plevel)
C
      integer KNOWN, MAXIBD, MAXTER, MAXCOV, MAXSIZ, MAXLOC, MISS
      double precision DELTA, EPS
      parameter(DELTA=1.0d-5, EPS=1.0d-6,
     2          KNOWN=0, MAXIBD=1000, MAXTER=MAXIBD/2, 
     3          MAXCOV=MAXTER*(MAXTER+1)/2,
     4          MAXSIZ=1000, MAXLOC=120, MISS=-9999)
      integer nvar, plevel, twrk, wrk, wrk2
C position of y and x variables
      integer terms(MAXSIZ)
C  Pedigree structure
      character*10 pedigree
      integer actset,num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      integer numloc
      real locus(MAXSIZ,MAXLOC)
C
C Locus structure:
C number of loci, locus name, locus type, and locus position in file
C
      character*10 loc(MAXLOC)
      integer loctyp(MAXLOC),locpos(MAXLOC)
C regression work arrays
      double precision x(MAXTER),r(MAXCOV),b(MAXTER),cov(MAXCOV)
C local variables
      integer i,ifail,ii,itmax,j,ncov,nobs,nter,ntot,pos,wrknum,ypos
      character*12 wrkfil
      logical complete, last
      double precision y
C regression results
      integer idf, naff
      double precision base,tval,x2
      character*3 histo
C functions
      double precision zp

      wrknum=1
      wrkfil='sp-log.wrk'
      ypos=terms(nvar)
      write(*,'(/a/3a/a)')
     2  '------------------------------------------------',
     3  'Binom. regression analysis of trait "',loc(ypos),'"',
     4  '------------------------------------------------'
      if (nvar.gt.(MAXTER-1)) then
        write(*,'(/a,i3,a/)') 
     &    'NOTE:  May analyse only the first ',MAXTER-1,' variables.'
        nvar=MAXTER-1
      end if

      naff=0
      nobs=0
      ntot=0
      ifail=0
      idf=nvar-1
      nter=nvar+1
      ncov=nter*(nter+1)/2

      open(twrk,file=wrkfil,form='unformatted')

      last=.false.
      rewind(wrk)
    5 continue
        call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &             numloc, last)
        if (last) goto 20

        if (actset.le.0) goto 5
C
        do 10 i=1,num
          complete=.true.
          do 12 j=1,nvar
          if ((loctyp(terms(j)).le.2 .and. 
     2         locus(i,locpos(terms(j))).lt.KNOWN) .or.
     3        locus(i,locpos(terms(j))).eq.MISS) then
            complete=.false.
            goto 13
          end if
   12     continue
   13     continue

          if (complete) then
            nobs=nobs+1
            x(1)=1.0d0
            do 14 j=1,nvar
              pos=terms(j)
              if (loctyp(pos).le.2) then
                x(j+1)=0.5d0*dble(locus(i,locpos(pos))+
     &                            locus(i,locpos(pos)+1))
              elseif (loctyp(pos).eq.4) then
                x(j+1)=dble(locus(i,locpos(pos))-1.0)
              else
                x(j+1)=dble(locus(i,locpos(pos)))
              end if
   14       continue
            y=x(nter) 
            if (y.eq.1.0d0) naff=naff+1
            x(nter)=0.25d0*(y-0.5d0)-0.6931472d0
            write(twrk) y, 4.0d0, (x(j), j=1, nter)
          end if
   10   continue
        ntot=ntot+num
      goto 5
   20 continue
      base=dfloat(naff)/dfloat(nobs)
      base=dfloat(naff)*log(base)+dfloat(nobs-naff)*log(1.0d0-base)
      base=-base-base
C
      it=0
      itmax=20
      x2=0.0d0
      oldx2=-1.0d0
  150 continue
      if (it.gt.itmax .or. abs(x2-oldx2).lt.DELTA) goto 50
        it=it+1
        oldx2=x2
        call newnam(wrknum, wrkfil)
        open(wrk2,file=wrkfil,form='unformatted')
        call binirls(twrk,wrk2,nobs,nter,ncov,x2,r,b,y,x,w)
        close(twrk,status='delete')
        close(wrk2,status='keep')
        open(twrk,file=wrkfil,form='unformatted')
        if (plevel.gt.1) then
          write(*,'(i4,a,f16.4)') it, ': ',x2
        end if
      goto 150
   50 continue
      close(twrk,status='delete')

      if (it.gt.itmax) then 
        write(*,'(/a,i4,a/)') 
     &    'NOTE:  Exceeded max (',itmax,') iterations.'
      end if

      call var(r, ncov, cov, ncov, nter, nobs, 2, ifail)
      write(*,'(/a/a)') 
     2  '    Variable         Beta    Stand Error        t-Value',
     3  '  -----------------------------------------------------'
      tval=abs(b(1))/sqrt(cov(1))
      call phist(zp(tval),1.0d0,histo)
      write(*,'(2x,a10,1x,f12.4,3x,f12.4,3x,f12.4,1x,a3)') 
     &   'Intercept ',b(1),sqrt(cov(1)), tval, histo
      ii=1
      do 250 i=2,nter-1
        ii=ii+i
        tval=abs(b(i))/sqrt(cov(ii))
        call phist(zp(tval),1.0d0,histo)
        write(*,'(2x,a10,1x,f12.4,3x,f12.4,3x,f12.4,1x,a3)') 
     &     loc(terms(i-1)),b(i),sqrt(cov(ii)), tval, histo
  250 continue

      write(*,'(/a,i7,a,f5.1,a/a,f12.4/a,i7/a,f12.4,a,i4,a/a,f12.4)') 
     2  'No. usable observations =',nobs,
     3  '      ( ',float(100*nobs)/float(ntot),'%)',
     4  'Null deviance           =', base, 
     5  'Number of iterations    =', it,
     6  'Model LR Chi-square     =', base-x2,' (df=',idf,')',
     7  'Akaike Inf. Criterion   =', dfloat(2*idf)+x2
      return
      end
C end-of-binreg
C
C One iteration of IRLS for binomial regression
C
      subroutine binirls(wrk,wrk2,nobs,nter,nel,x2,r,b,y,x,w)
      integer nter, nel, wrk, wrk2
      double precision r(nel), b(nter), x(nter), x2, y
      double precision EPS
      parameter(EPS=1.0d-6)
      integer i, ifault
      double precision pred, v
C functions
      double precision alogit, logit
      call inicov(nter, nel, r)

      rewind(wrk)
      do 10 i=1, nobs
        read(wrk) y,v,(x(j),j=1, nter)
        call givenc(r, nel, nter, x, v, ifault)
   10 continue
      call alias(r, nel, nter, 1.0d-15, x, ifault)      
      if (ifault.lt.0) then
        write(*,*) 'ERROR: Parameter ',-ifault,' is aliased.'
      end if
      call bsub(r, nel, nter, b, nter, ifault)
      if (ifault.ne.0) write(*,*) 'IRLS Back subst IFAULT=',ifault
      x2=0.0d0
      rewind(wrk)

      do 30 i=1,nobs
        read(wrk) y,v,x
        pred=b(1)
        do 35 j=2,nter-1
          pred=pred+b(j)*x(j)
   35   continue
        pred=alogit(pred)
        v=1.0d0/pred/(1.0d0-pred)
        z=y-pred
        x(nter)=logit(pred)+z*v
        if (pred.gt.EPS .and. (1.0d0-pred).gt.EPS) then
          if (y.eq.1.0d0) then
            x2=x2-log(pred)
          else
            x2=x2-log(1.0d0-pred)
          end if
        end if
        write(wrk2) y, v, (x(j), j=1, nter)
   30 continue
      x2=x2+x2
      return
      end
C end-of-binirls

C
C Two locus linkage disequilibrium: autosomal or X-linked loci
C
      subroutine twold(wrk,loctyp,gene1,loc1,gene2,loc2,iter,
     2             pedigree,actset,num,nfound,id,fa,mo,sex,locus,numloc,
     3             numal,name,alfrq,numal2,name2,alfrq2,
     4             eligible,ngcount,gcount,gfrq,plevel)
      integer MAXALL, MAXG, MAXSIZ, MAXLOC, KNOWN
      parameter(MAXALL=60, MAXG=MAXALL*(MAXALL+1)/2, 
     &          MAXSIZ=1000, MAXLOC=120, KNOWN=0)
      integer gene1,gene2,iter,loctyp,plevel,wrk
      character*10 loc1, loc2
C pedigree structure
      character*10 pedigree
      integer sex(MAXSIZ)
      integer actset,num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C
C allele frequencies within entire sample for given locus 
C
      integer numal, name(MAXALL)
      double precision alfrq(MAXALL)
      integer numal2, name2(MAXALL)
      double precision alfrq2(MAXALL)
C
C Typed founders or nonfounders who have untyped parents
      logical eligible(MAXSIZ)
C
C Genotype counts: allele1,allele2, number transmitted, number not trans
      integer ngcount,gcount(MAXG,4)
      double precision gfrq(MAXG)
C
      integer tr1,tr2,nt1,nt2,tr3,tr4,nt3,nt4
      logical last, xmale
      integer cutoff, df, gene12, gene22, i, idx, j, nhap, ntyped,
     &        tothap  
      character*3 histo
      character*7 gtp
      double precision asyp, bigd, chisq, d, dprime, e, hedrick, 
     &                 p1, p2, pval, tot
C functions 
      logical useld
      double precision chip, ftdev, getfreq
C
      if (plevel.gt.0) then
        write(*,'(/a,a10,a,a10,a/a/)')
     2   'Assoc for locus "',loc1,'" c. locus "',loc2,'"',
     3   '---------------------------------------------------'
      end if
      cutoff=0
      gene12=gene1+1
      gene22=gene2+1
      ntyped=0
      tothap=0
      ngcount=0
      do 2 i=1,numal
        alfrq(i)=0.0d0
        do 3 j=1,numal2
          ngcount=ngcount+1
          gcount(ngcount,1)=name(i)
          gcount(ngcount,2)=name2(j)
          gcount(ngcount,3)=0
    3   continue
    2 continue
      do 4 j=1,numal2
        alfrq2(j)=0.0d0
    4 continue

      last=.false.
      rewind(wrk)
C
C If high print level, then list transmitted and nontransmitted alleles
C for each informative proband
C
      if (plevel.gt.1) then
        write(*,'(a/a)') '  Informative Parent     Trans  Not Tr',
     &                   'Pedigree  ID      Sex    1   2   1   2'
      end if
C
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

       if (actset.le.0) goto 10
C
C
C Identify typed founders or nonfounders who have untyped parents
C
         do 11 i=1,nfound
           if (locus(i,gene1).gt.KNOWN .and.locus(i,gene2).gt.KNOWN)
     &     then
             eligible(i)=.true.
           else
             eligible(i)=.false.
           end if
   11    continue
         do 12 i=nfound+1,num
           if (locus(i,gene1).gt.KNOWN .and.locus(i,gene2).gt.KNOWN 
     2         .and. locus(fa(i),gene1).lt.KNOWN
     3         .and. locus(fa(i),gene2).lt.KNOWN
     4         .and. locus(mo(i),gene1).lt.KNOWN
     5         .and. locus(mo(i),gene2).lt.KNOWN)  then
             eligible(i)=.true.
           else
             eligible(i)=.false.
           end if
   12    continue
C
C Go through eligible offspring
C
         do 15 i=nfound+1,num
           if ((eligible(fa(i)) .or. eligible(mo(i))) .and.
     2         useld(locus(i,gene1),locus(i,gene12),locus(i,gene2),
     3           locus(i,gene22),locus(fa(i),gene1),locus(fa(i),gene12),
     4           locus(fa(i),gene2), locus(fa(i),gene22),
     5           locus(mo(i),gene1),locus(mo(i),gene12),
     6           locus(mo(i),gene2),locus(mo(i),gene22))) then
             xmale=(sex(i).eq.1 .and. loctyp.eq.2)
             if (xmale) then
               call xtrans(
     3             int(locus(mo(i),gene1)), int(locus(mo(i),gene12)),
     4             int(locus(i,gene1)), int(locus(i,gene12)),
     5             tr1,tr2,nt1,nt2)
               call xtrans(
     3             int(locus(mo(i),gene2)), int(locus(mo(i),gene22)),
     4             int(locus(i,gene2)), int(locus(i,gene22)),
     5             tr3,tr4,nt3,nt4)
             else
               call trans(
     2             int(locus(fa(i),gene1)), int(locus(fa(i),gene12)),
     3             int(locus(mo(i),gene1)), int(locus(mo(i),gene12)),
     4             int(locus(i,gene1)), int(locus(i,gene12)),
     5             tr1,tr2,nt1,nt2,0)
               call trans(
     2             int(locus(fa(i),gene2)), int(locus(fa(i),gene22)),
     3             int(locus(mo(i),gene2)), int(locus(mo(i),gene22)),
     4             int(locus(i,gene2)), int(locus(i,gene22)),
     5             tr3,tr4,nt3,nt4,0)
             end if
C
C Note that once the haplotypes are used, the parent is set to ineligible
C along with any other full or half siblings
C
             if (eligible(fa(i)) .and. .not.xmale) then
               idx=fa(i)
               ntyped=ntyped+1
               if (tr2.gt.KNOWN .and. tr4.gt.KNOWN) then
                 tothap=tothap+1
                 call insgen(tr2,tr4,ngcount,gcount,3,2)
                 call insall(tr2,numal,name,alfrq)
                 call insall(nt2,numal,name,alfrq)
               end if
               if (loctyp.eq.1) then
                 tothap=tothap+1
                 call insgen(nt2,nt4,ngcount,gcount,3,2)
                 call insall(tr4,numal2,name2,alfrq2)
                 call insall(nt4,numal2,name2,alfrq2)
               end if
               eligible(idx)=.false.
               if (idx.gt.nfound) then
                 do 21 j=nfound+1,num
                   if (eligible(j) .and. 
     &                 (fa(idx).eq.fa(j) .or.  mo(idx).eq.mo(j))) then
                     eligible(j)=.false.
                   end if
   21            continue
               end if
               if (plevel.gt.1) then
                 write(*,'(a10,a8,x,a1,2x,4(1x,i3))') 
     &           pedigree,id(idx),'m',tr2,tr4, nt2, nt4
               end if
             end if
             if (eligible(mo(i))) then
               idx=mo(i)
               ntyped=ntyped+1
               tothap=tothap+2
               call insgen(tr1,tr3,ngcount,gcount,3,2)
               call insgen(nt1,nt3,ngcount,gcount,3,2)
               call insall(tr1,numal,name,alfrq)
               call insall(nt1,numal,name,alfrq)
               call insall(tr3,numal2,name2,alfrq2)
               call insall(nt3,numal2,name2,alfrq2)
               eligible(idx)=.false.
               if (idx.gt.nfound) then
                 do 22 j=nfound+1,num
                   if (eligible(j) .and. 
     &                 (fa(idx).eq.fa(j) .or.  mo(idx).eq.mo(j))) then
                     eligible(j)=.false.
                   end if
   22            continue
               end if
               if (plevel.gt.1) then
                 write(*,'(a10,a8,x,a1,2x,4(1x,i3))') 
     &             pedigree,id(idx),'f',tr1,tr3, nt1, nt3 
               end if
             end if
           end if
   15    continue
       goto 10
   20  continue
C
      if (plevel.gt.0) then
       write(*,'(2a/2a)') 
     2   '       Haplotype       Observed   Expected',
     3   '     D        D''      Dev',
     4   '  ----------------------------------------',
     5   '-------------------------'
      end if
      asyp=1.0d0
      chisq=0.0d0
      bigd=0.0d0
      hedrick=0.0d0
      pval=1.0d0
      tot=0.0d0
      if (ntyped.gt.0) then
        tot=dfloat(tothap)
        do 225 i=1,ngcount
          p1=getfreq(gcount(i,1),numal,name,alfrq)/tot 
          p2=getfreq(gcount(i,2),numal2,name2,alfrq2)/tot
          e=tot*p1*p2
          gfrq(i)=e
          nhap=gcount(i,3)
          if (nhap.gt.cutoff) then
            chisq=chisq+dfloat(nhap)*
     &            log(dfloat(nhap)/e)
          end if    
          d=(dfloat(nhap)-e)/tot
          if (d.lt.0.0d0) then
            dprime=d/min(p1*p2,(1.0d0-p1)*(1.0d0-p2))
          elseif (d.eq.0.0d0) then
            dprime=0.0d0
          else
            dprime=d/(min(p1,p2)-p1*p2)
          end if
          if (abs(dprime).gt.bigd) bigd=abs(dprime)
          hedrick=hedrick+p1*p2*abs(dprime)

          if (plevel.gt.0) then
            call wrgtp(gcount(i,1),gcount(i,2),gtp,2)
            write(*,999) gtp,nhap,'(',dfloat(nhap)/tot,')',e,
     &                   d,dprime,ftdev(dfloat(nhap),e)
  999       format(8x,a7,1x,i8,1x,1a,f5.3,1a,1x,f9.1,2x,f7.4,
     &             2x,f7.4,1x,f6.1)
          end if
  225   continue

        chisq=chisq+chisq
        df=(numal-1)*(numal2-1)
        asyp=chip(chisq,df)

        call simchi(numal,name,alfrq,numal2,name2,alfrq2,gcount,
     &              gfrq,chisq,tothap,iter,pval)
      end if 
      if (plevel.gt.0) then
        write(*,'(/a,i4/a,3x,f6.4/a,f6.1/a,i4)')
     2  '   Number of individuals used =',ntyped,
     2  '          Pooled D'' (Hedrick) =',hedrick,
     3  'Linkage disequilibrium Chi-sq =',chisq,
     4  '   Nominal degrees of freedom =',df
        write(*,'(14x,a,3x,f6.4)') 'Nominal P-value =',asyp
        write(*,'(14x,a,3x,f6.4,a,i8,a)') 'Empiric P-value =',pval,
     &    ' (',10*int(tot)*iter,' MCMC iterations)'
      else
        call phist(pval,1.0d0,histo)
        write(*,'(2(a10,1x),i4,2x,f6.3,1x,f6.1,1x,i4,1x,f6.4,2(1x,a))')
     &    loc1,loc2,ntyped,hedrick,chisq,df,pval,'LD ',histo
      end if
C
      return
      end
C end-of-twold
C
C MCMC a RxC contingency table retaining given margins
C
      subroutine simchi(nr, rows, rfrq, nc, cols, cfrq,tble, e, obschi, 
     &                  tot, iter, pval)
      integer MAXALL, MAXG
      parameter(MAXALL=60, MAXG=MAXALL*(MAXALL+1)/2) 
      integer iter, nc, nr, tot
      double precision obschi, pval
C
      integer cols(MAXALL), rows(MAXALL), tble(MAXG,4)
      double precision cfrq(MAXALL), rfrq(MAXALL), e(MAXG)

      integer c1, c2, eligc, eligr, i, incr, ip,
     &        it, ncells, r1, r2, isub(4)
      double precision chisq, qa
C functions
      integer irandom
      real random

      pval=1.0d0
      call mkchoose(nr, rows, rfrq, eligr)
      call mkchoose(nc, cols, cfrq, eligc)
      
      if (eligr.lt.2 .or. eligc.lt.2) return

      ip=0
      ncells=nr*nc
      chisq=obschi
      do 10 it=1, 10*iter
C dememorise by sampling each tot'th value
        do 50 i=1, tot 
          call choose(2, eligr, rows)
          call choose(2, eligc, cols)
          r1=rows(1)
          r2=rows(2)
          c1=cols(1)
          c2=cols(2)
          call order(r1,r2)
          call order(c1,c2)
          isub(1)=nc*(r1-1)+c1
          isub(2)=nc*(r1-1)+c2
          isub(3)=nc*(r2-1)+c1
          isub(4)=nc*(r2-1)+c2
          incr=2*irandom(1,2)-3
          qa=0.0d0
          if (incr.eq.-1 .and. tble(isub(1),3).gt.0 .and.
     &        tble(isub(4),3).gt.0) then
            qa=min(1.0d0,dfloat(tble(isub(1),3)*tble(isub(4),3))/
     &                  dfloat((tble(isub(2),3)+1)*(tble(isub(3),3)+1)))
          else if (incr.eq.1 .and. tble(isub(2),3).gt.0 .and.
     &             tble(isub(3),3).gt.0) then
            qa=min(1.0d0,dfloat(tble(isub(2),3)*tble(isub(3),3))/
     &                  dfloat((tble(isub(1),3)+1)*(tble(isub(4),3)+1)))
          end if
C If accepted, update genotypes
C
          if (qa.gt.random()) then
            tble(isub(1),3)=tble(isub(1),3)+incr
            tble(isub(2),3)=tble(isub(2),3)-incr
            tble(isub(3),3)=tble(isub(3),3)-incr
            tble(isub(4),3)=tble(isub(4),3)+incr
          end if
C         write(*,*) 'R1,R2,C1,C2:',r1,r2,c1,c2,
C    &               (tble(kk,3), kk=1, ncells)
   50   continue
        call upchi(ncells, tble, e, chisq)
C     write(*,*) chisq, (tble(kk,3), kk=1, ncells)
        if (chisq.ge.obschi) ip=ip+1
   10 continue
      pval=dfloat(ip)/dfloat(10*iter)
      return
      end
C end-of-simchi
C 
C LRTS for contingency table in MCMC
C
      subroutine upchi(ncells, tble, e, lrts)
      integer MAXALL, MAXG
      double precision TOL 
      parameter(MAXALL=60, MAXG=MAXALL*(MAXALL+1)/2,TOL=1.0d-6) 

      integer ncells
      double precision lrts
      integer tble(MAXG,4)
      double precision e(*)
      integer i, icount

      lrts=0.0d0
      do 10 i=1,ncells
      if (tble(i,3).gt.0 .and. e(i).gt.TOL) then
        icount=tble(i,3)
        lrts=lrts+dfloat(icount)*log(dfloat(icount)/e(i))
      end if
   10 continue
      lrts=lrts+lrts
      return
      end
C end-of-upchi
C   
C Load an array with indices of eligible choices (eg nonmissing alleles)
      subroutine mkchoose(ni, idx, eligible , nelig)
      integer nelig, ni, idx(ni)
      double precision eligible(ni)
      integer i
      nelig=0
      do 5 i=1, ni
      if (eligible(i).gt.0.0d0) then
        nelig=nelig+1
        idx(nelig)=i
      end if
    5 continue
      return
      end
C end-of-mkchoose
C
C Shuffle array of indices so can randomly select combination from
C as first r elements
      subroutine choose(nch, ni, idx)
      integer nch, ni, idx(ni)
      integer i, pos, tmp
C functions
      integer irandom

      do 5 i=1, nch
        pos=irandom(1, ni)
        tmp=idx(pos)
        idx(pos)=idx(i)
        idx(i)=tmp
    5 continue
      return
      end
C end-of-choose
C
C simple increment of allele count where all alleles already identified
C
      subroutine insall(iall,numal,name,alfrq)
      integer MAXALL
      parameter(MAXALL=60)
      integer iall, numal, name(MAXALL)
      double precision alfrq(MAXALL)
      integer idx
C functions
      integer getnam
      idx=getnam(float(iall),numal,name)
      alfrq(idx)=alfrq(idx)+1.0d0
      return
      end
C end-of-insall
C
C Check if useful triad for haplotype inference 
C
      logical function useld(c1,c2,c3,c4,f1,f2,f3,f4,m1,m2,m3,m4)
      integer KNOWN
      parameter(KNOWN=0)
      real c1,c2,c3,c4,f1,f2,f3,f4,m1,m2,m3,m4
      logical het1, het2, hom1, hom2

      useld=.false.
      if (c1.le.KNOWN .or. c3.le.KNOWN) return
      if (f1.le.KNOWN .or. f3.le.KNOWN) return
      if (m1.le.KNOWN .or. m3.le.KNOWN) return
C drop out uninformative triads: eg 1.2/3.4 x 1.2/1.3 -> 1.2/3.3
C                      but keep: eg 1.2/3.3 x 1.2/3.3 -> 1.2/3.3
      het1=(c1.eq.f1 .and. c2.eq.f2 .and. c1.eq.m1 .and. c2.eq.m2 .and.
     &      c1.ne.c2)
      hom1=(f1.eq.f2 .and. m1.eq.m2 .and. f1.eq.m1)
      het2=(c3.eq.f3 .and. c4.eq.f4 .and. c3.eq.m3 .and. c4.eq.m4 .and.
     &      c3.ne.c4)
      hom2=(f3.eq.f4 .and. m3.eq.m4 .and. f3.eq.m3)

      if (het1 .and. .not.hom2) return
      if (het2 .and. .not.hom1) return
      
      useld=.true.
      return
      end
C end-of-useld
C
C Additive allelic model for association with a quantitative trait
C
      subroutine doanova(wrk,wrk2,trait,locnam,gene,iter,mincnt,assfnd,
     2              x,r,b,cov,pedigree,actset,num,nfound,
     3              id,fa,mo,sex,locus,numloc,numal,name,cumfrq,
     4              untyped,value,count,set,plevel)
      integer KNOWN,MAXIBD,MAXSIZ,MAXLOC,MAXALL,MAXCOV,MAXTER,MISS
      parameter (KNOWN=0,MAXSIZ=1000,MAXLOC=120,MAXALL=60,MAXIBD=1000,
     2           MAXTER=MAXIBD/2,MAXCOV=MAXTER*(MAXTER+1)/2,
     3           MISS=-9999)
      integer gene,iter,mincnt,numal,numloc,plevel,trait,wrk,wrk2
      logical assfnd
      character*10 locnam
C Pedigree structure
      character*10 pedigree
      integer actset,num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ), set(MAXSIZ,2)
      real locus(MAXSIZ,MAXLOC)
      logical last, untyped(MAXSIZ)
C allele frequencies structure
      integer name(MAXALL)
      double precision cumfrq(MAXALL)
C Storage for trait values during randomization
      integer count(MAXSIZ)
      real value(MAXSIZ)
C arrays for allelic effects
      double precision x(MAXTER), r(MAXCOV), b(MAXTER), cov(MAXCOV)
C local variables
      integer g1,g2,gen2,i,idf,ii,it,j,mdf,n,ncov,nobs,nter,tailp,nuntyp
      character*3 histo
      double precision asyp, bss, orss, lrts, mss,mu,pval,rss,vss
C functions
      integer getnam
      real random
      double precision chip, ln

      last=.false.
      it=0
      nobs=0
      nter=numal+1
      ncov=nter*(nter+1)/2
      gen2=gene+1
      call inicov(nter, ncov, r)
      bss=0.0d0
      mu=0.0d0
      nuntyp=0
      do 5 i=1,numal
        count(i)=0
    5 continue
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

       if (actset.le.0) goto 10
C
        n=num
        if (assfnd) n=nfound
        do 12 i=1,n
          value(i)=locus(i,trait)
          untyped(i)=.false.
          if (locus(i,gene).lt.KNOWN) then
            untyped(i)=.true.
            if (locus(i,trait).ne.MISS) nuntyp=nuntyp+1
          elseif (locus(i,trait).ne.MISS) then
            g1=getnam(locus(i,gene),numal,name)
            g2=getnam(locus(i,gen2),numal,name)
            nobs=nobs+1
            do 15 j=1,numal
              x(j)=0.0d0
   15       continue
            x(nter)=dble(value(i))
            x(g1)=x(g1)+1
            x(g2)=x(g2)+1
            count(g1)=count(g1)+1
            count(g2)=count(g2)+1
            call moment(nobs,x(nter),mu,bss)
            call givenc(r, ncov, nter, x, 1.0d0, ifail)
          end if
   12   continue
        write(wrk2) n,nfound,(value(i),fa(i),mo(i),untyped(i),i=1,n)
      goto 10
   20 continue
      call alias(r, ncov, nter, 1.0d-15, x, ifail)
      call bsub(r, ncov, nter, b, numal, ifail)
      call var(r, ncov, cov, ncov, nter, nobs, 1, ifail)

      mdf=0
      mss=0.0d0
      do 150 i=1,numal
        call sscomp(r, ncov, nter, nobs, i, rss, idf, ifail)
        mdf=mdf+idf
        mss=mss+rss
  150 continue
      call sscomp(r, ncov, nter, nobs, 0, orss, idf, ifail)

      lrts=dfloat(nobs) * (ln(bss)-ln(orss))
      asyp=chip(lrts,max(1,mdf-1))
      mss=mss/dfloat(max(1,mdf))
      orss=orss/dfloat(max(1,idf))

      if (plevel.gt.0) then
        write(*,'(/3a/a/a)') 
     2    '  ------ QTL Association with "',locnam,'" -----',
     3    '    Allele   Allelic Mean    Stand Error   Count',
     4    '  ----------------------------------------------'
        ii=0
        do 155 i=1,numal
          ii=ii+i
          write(*,'(2x,i8,3x,f12.4,3x,f12.4,1x,i7)') 
     &       name(i),b(i),sqrt(cov(ii)),count(i)
  155   continue
        write(*,'(a/a,f12.4,3x,f12.4,1x,i7)') 
     2    '  ----------------------------------------------',
     3    '  Total      ',mu, sqrt(bss/dfloat(max(1,nobs-1))), 2*nobs
        write(*,'(2(/a,i7),2(/a,f12.4,a,i4,a))') 
     3    ' No. trait(+) marker(-)  =',nuntyp,
     4    ' No. trait(+) marker(+)  =',nobs,
     5    ' Model Mean Square       =', mss,' (df=',mdf,')',
     6    ' Mean Square Error       =',orss,' (df=',idf,')'
        write(*,'(a,f12.4,/a,f12.4)')
     2    ' Likelihood ratio test   =',lrts,
     3    ' Nominal P-value         =',asyp
      end if

      if (iter.gt.0) then
    
C Sequential Monte-Carlo P-value after Besag & Clifford Biometrika 1991
C P= tailp/it if tailp=mincnt or (tailp+1)/(it+1) if tailp<mincnt && it=iter
        mss=0.0d0
        vss=0.0d0
        tailp=0
   49   continue
        if (it.eq.iter .or. tailp.eq. mincnt) goto 50
          it=it+1
          call inicov(nter, ncov, r)
          rewind(wrk2)
   55     continue
            read(wrk2,end=70) n,nfound,
     &        (value(i),fa(i),mo(i),untyped(i),i=1,n)
            call simped(n,nfound,fa,mo,cumfrq,set)
            do 60 i=1,n
            if (.not.untyped(i).and.value(i).ne.MISS) then
              do 65 j=1,numal
                x(j)=0.0d0
   65         continue
              x(nter)=dble(value(i))
              x(set(i,1))=x(set(i,1))+1
              x(set(i,2))=x(set(i,2))+1
              call givenc(r, ncov, nter, x, 1.0d0, ifail)
            end if
   60       continue
          goto 55
   70     continue
          call alias(r, ncov, nter, 1.0d-15, x, ifail)
          call sscomp(r, ncov, nter, nobs, 0, rss, idf, ifail)
          rss=rss/dfloat(max(1,idf))
          call moment(it,rss,mss,vss)
          if (rss.lt.orss .or. (rss.eq.orss .and. 
     2        random().gt.0.5d0))  then
            tailp=tailp+1
          end if
          if (plevel.gt.1) then
            write(*,'(/a,i4,a,f12.4)') 
     &       'Pseudosample ',it,': MSE=',rss
          end if
          goto 49
   50   continue
        if (tailp.lt.mincnt) then
          tailp=tailp+1
          it=it+1
        end if
        vss=vss/dfloat(max(1,it-1))
        pval=dfloat(tailp)/dfloat(it)
      else
        tailp=0
        pval=1.0d0
      end if

      if (plevel.gt.0) then
        write(*,'(a,i4,a,i5,a,f6.4,a/a,f12.4,a,f12.4,a)')
     2    ' Equalled or exceeded by =',tailp,'/',it,
     3    ' simulated values (',pval,')',
     4    ' Mean (SD) simulated MSE =',mss,' (',sqrt(vss),')'
      else
        call phist(asyp,pval,histo)
        write(*,'(a10,2(1x,i6),1x,f10.1,2(1x,f6.4),1x,i6,2(1x,a))')
     &    locnam, nobs, mdf, lrts, asyp, pval, it, 'ANOVA-HWE',histo
      end if
      return
      end
C end-of-doanova
C
C Additive allelic model for association with a quantitative trait
C Conditional on parental genotypes
C
      subroutine qtdt(wrk,wrk2,trait,locnam,gene,iter,mincnt,
     2             x,r,b,cov,pedigree,actset,num,nfound,
     3             id,fa,mo,sex,locus,numloc,
     4             numal,name,untyped,value,count,set,plevel)
      integer KNOWN,MAXIBD,MAXSIZ,MAXLOC,MAXALL,MAXCOV,MAXTER,MISS
      parameter (KNOWN=0,MAXSIZ=1000,MAXLOC=120,MAXALL=60,MAXIBD=1000,
     2           MAXTER=MAXIBD/2,MAXCOV=(MAXALL+1)*(MAXALL+2)/2,
     3           MISS=-9999)
      integer gene,iter,mincnt,numal,numloc,plevel,trait,wrk,wrk2
      character*10 locnam
C Pedigree structure
      character*10 pedigree
      integer actset,num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ), set(MAXSIZ,2)
      real locus(MAXSIZ,MAXLOC)
      logical last, untyped(MAXSIZ)
C allele frequencies structure
      integer name(MAXALL)
C Storage for trait values during randomization
      integer count(MAXSIZ)
      real value(MAXSIZ)
C arrays for allelic effects
      double precision x(MAXTER), r(MAXCOV), b(MAXTER), cov(MAXCOV)
C local variables
      integer contrib,gen2,i,idf,ii,it,j,mdf,ncov,nobs,nter,tailp,nuntyp
      character*3 histo
      double precision asyp,bss,lrts,mss,mu,pval,orss,rss,vss
C functions
      integer getnam
      real random
      double precision chip, ln

      last=.false.
      nobs=0
      nter=numal+1
      ncov=nter*(nter+1)/2
      gen2=gene+1
      call inicov(nter, ncov, r)
      mu=0.0d0
      bss=0.0d0
      nuntyp=0
      do 5 i=1,numal
        count(i)=0
    5 continue
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

       if (actset.le.0) goto 10
C
C
C load set() with genotypes
        do 11 i=1,num
          untyped(i)=.false.
          value(i)=MISS
          if (locus(i,gene).lt.KNOWN) then
            untyped(i)=.true.
            set(i,1)=MISS
            set(i,2)=MISS
          else
            set(i,1)=getnam(locus(i,gene),numal,name)
            set(i,2)=getnam(locus(i,gen2),numal,name)
          end if
   11   continue
C
C Only phenotyped persons with genotyped parents used-> value() set to trait
        contrib=0
        do 12 i=nfound+1,num
          if (locus(i,trait).ne.MISS .and. .not.untyped(i) .and.
     &        .not.untyped(fa(i)) .and. .not.untyped(mo(i))) then
            contrib=contrib+1
            value(i)=locus(i,trait)
            nobs=nobs+1
            do 15 j=1,numal
              x(j)=0.0d0
   15       continue
            x(nter)=dble(value(i))
            x(set(i,1))=x(set(i,1))+1
            x(set(i,2))=x(set(i,2))+1
            count(set(i,1))=count(set(i,1))+1
            count(set(i,2))=count(set(i,2))+1
            call moment(nobs,x(nter),mu,bss)
            call givenc(r, ncov, nter, x, 1.0d0, ifail)
          end if
   12   continue
        if (contrib.gt.0) then
          write(wrk2) num,nfound,
     &     (value(i),fa(i),mo(i),untyped(i),set(i,1),set(i,2),i=1,num) 
        end if
      goto 10
   20 continue

      if (nobs.eq.0) then
        if (plevel.gt.0) then
          write(*,'(/3a/a/a/2(/a,i7))') 
     2    '  ------ QTL Association with "',locnam,'"-------',
     3    '  ------ Conditioned on Parental Genotype -------',
     4    '  -----------------------------------------------',
     5    ' No. trait(+) marker(-)  =',nuntyp,
     6    ' No. trait(+) marker(+)  =',nobs 
        else
          write(*,'(a10,2(1x,i6),1x,f10.1,2(1x,f6.4),1x,i6,1x,a)')
     &    locnam, nobs, 0, 0.0d0, 1.0d0, 1.0d0, 0, 'ANOVA-CPG .'
        end if
        return
      end if
      call alias(r, ncov, nter, 1.0d-15, x, ifail)
      call bsub(r, ncov, nter, b, numal, ifail)
      call var(r, ncov, cov, ncov, nter, nobs, 1, ifail)
      mdf=0
      mss=0.0d0
      do 150 i=1,numal
        call sscomp(r, ncov, nter, nobs, i, rss, idf, ifail)
        mdf=mdf+idf
        mss=mss+rss
  150 continue
      call sscomp(r, ncov, nter, nobs, 0, orss, idf, ifail)
      lrts=dfloat(nobs) * (ln(bss)-ln(orss))
      asyp=chip(lrts,max(1,mdf-1))
      mss=mss/dfloat(max(1,mdf))
      orss=orss/dfloat(max(1,idf))
      if (plevel.gt.0) then
        write(*,'(/3a/a/a/a)') 
     2  '  ------ QTL Association with "',locnam,'"-------',
     3  '  ------ Conditioned on Parental Genotype -------',
     4  '    Allele   Allelic Mean    Stand Error   Count',
     5  '  -----------------------------------------------'
      ii=0
      do 155 i=1,numal
        ii=ii+i
        write(*,'(2x,i8,3x,f12.4,3x,f12.4,1x,i7)') 
     &     name(i),b(i),sqrt(cov(ii)),count(i)
  155 continue
        write(*,'(a/a,f12.4,3x,f12.4,1x,i7)') 
     2    '  ----------------------------------------------',
     3    '  Total      ',mu, sqrt(bss/dfloat(max(1,nobs-1))), 2*nobs
        write(*,'(2(/a,i7),2(/a,f12.4,a,i4,a))') 
     3  ' No. trait(+) marker(-)  =',nuntyp,
     4  ' No. trait(+) marker(+)  =',nobs,
     5  ' Model Mean Square       =', mss,' (df=',mdf,')',
     6  ' Mean Square Error       =',orss,' (df=',idf,')'
        write(*,'(a,f12.4,/a,f12.4)')
     2    ' Likelihood ratio test   =',lrts,
     3    ' Nominal P-value         =',asyp
      end if
      if (iter.gt.0) then
    
C Sequential Monte-Carlo P-value after Besag & Clifford Biometrika 1991
C P= tailp/it if tailp=mincnt or (tailp+1)/(it+1) if tailp<mincnt && it=iter
        mss=0.0d0
        vss=0.0d0
        it=0
        tailp=0
   49   continue
        if (it.eq.iter .or. tailp.eq. mincnt) goto 50
          it=it+1
          call inicov(nter, ncov, r)
          rewind(wrk2)
   55     continue
            read(wrk2,end=70) num,nfound,
     &      (value(i),fa(i),mo(i),untyped(i),set(i,1),set(i,2),i=1,num) 
            call csimped(num,nfound,fa,mo,untyped,set)
            do 60 i=1,num
            if (value(i).ne.MISS) then
              do 65 j=1,numal
                x(j)=0.0d0
   65         continue
              x(nter)=dble(value(i))
              x(set(i,1))=x(set(i,1))+1
              x(set(i,2))=x(set(i,2))+1
              call givenc(r, ncov, nter, x, 1.0d0, ifail)
            end if
   60       continue
          goto 55
   70     continue
          call alias(r, ncov, nter, 1.0d-15, x, ifail)
          call sscomp(r, ncov, nter, nobs, 0, rss, idf, ifail)
          rss=rss/dfloat(max(1,idf))
          call moment(it,rss,mss,vss)
          if (rss.lt.orss .or. (rss.eq.orss .and. 
     2        random().gt.0.5d0))  then
            tailp=tailp+1
          end if
          if (plevel.gt.1) then
            write(*,'(/a,i4,a,f12.4)') 
     &       'Pseudosample ',it,': MSE=',rss
          end if
          goto 49
   50   continue
        if (tailp.lt.mincnt) then
          tailp=tailp+1
          it=it+1
        end if
        vss=vss/dfloat(max(1,it-1))
        pval=dfloat(tailp)/dfloat(it)
      else
        tailp=0
        pval=1.0d0
      end if

      if (plevel.gt.0) then
        write(*,'(a,i4,a,i5,a,f6.4,a/a,f12.4,a,f12.4,a)')
     2    ' Equalled or exceeded by =',tailp,'/',it,
     3    ' simulated values (',pval,')',
     4    ' Mean (SD) simulated MSE =',mss,' (',sqrt(vss),')'
      else
        call phist(asyp,pval,histo)
        write(*,'(a10,2(1x,i6),1x,f10.1,2(1x,f6.4),1x,i6,2(1x,a))')
     &    locnam, nobs, mdf, lrts, asyp, pval, it, 'ANOVA-CPG',histo
      end if
      return
      end
C end-of-qtdt
C
C Count of marker alleles/genotyped in cases and controls -- codominant system
C
      subroutine doassoc(wrk,wrk2,trait,locnam,gene,iter,mincnt,assfnd,
     2                   gt,thresh,pedigree,actset,num,nfound,id,fa,mo,
     3                   sex,locus,numloc,numal,name,cntall,cumfrq,
     4                   aff,untyped,set,plevel,typ)
      integer KNOWN,MAXSIZ,MAXLOC,MAXALL,MAXG,MISS
      parameter (KNOWN=0,MAXSIZ=1000,MAXLOC=120,MAXALL=60,
     &           MAXG=MAXALL*(MAXALL+1)/2,MISS=-9999)
      integer gene,iter,mincnt,numal,numloc,plevel,trait,typ,wrk,wrk2
      real thresh
      logical assfnd, gt
      character*10 locnam
C Pedigree structure
      character*10 pedigree
      integer actset,num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ)
      integer sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
      logical last
C work arrays
      integer aff(MAXSIZ), set(MAXSIZ,2)
      logical untyped(MAXSIZ)
C allele frequencies structure
      integer name(MAXALL)
      double precision cumfrq(MAXALL)
C array for allele counts in cases and controls
      integer cntall(MAXG,4)
C F statistics
      integer eh1, eh2, eh12, nhom(2)
      double precision h0, hs, ht, fis, fit, fst, d1, d2
C other local variables
      integer g1,g2,i,it,df,gen2,gtp,nca,ncats,nco,nuntyp,tailp
      character*3 histo, ana
      real casden, conden
      double precision asyp, chisq, mchisq, ochisq, pexp, pval, vchisq
C functions
      integer clcpos, getnam
      real isaff, random
      double precision twobyk, chip, binz

      ncats=numal
      ana='HWE'
      if (typ.eq.2) then
        ncats=numal*(numal+1)/2
        ana='Gtp'
      end if
        
      df=-1
      gen2=gene+1
      nhom(1)=0
      nhom(2)=0
      nuntyp=0
      do 2 j=1,ncats  
      do 2 k=1,3
        cntall(j,k)=0
    2 continue
      if (typ.eq.1) then
        do 3 j=1, ncats
          cntall(j,4)=name(j)
    3   continue
      else
        do 4 j=1, ncats
          cntall(j,4)=j
    4   continue
      end if
      mchisq=0.0d0
      vchisq=0.0d0
      last=.false.
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

        if (actset.le.0) goto 10
C
        if (assfnd) then
          if (typ.eq.1) then
            do 12 i=1,nfound
              aff(i)=int(isaff(locus(i,trait),thresh,gt))
              if (locus(i,gene).lt.KNOWN) then
                if (aff(i).ne.MISS) nuntyp=nuntyp+1
              elseif (aff(i).eq.1.or.aff(i).eq.2) then
                g1=getnam(locus(i,gene),numal,name)
                g2=getnam(locus(i,gen2),numal,name)
                cntall(g1,aff(i))=cntall(g1,aff(i))+1
                cntall(g2,aff(i))=cntall(g2,aff(i))+1
                if (g1.eq.g2) nhom(aff(i))=nhom(aff(i))+1
              endif
   12       continue
          else
            do 13 i=1,nfound
              aff(i)=int(isaff(locus(i,trait),thresh,gt))
              if (locus(i,gene).lt.KNOWN) then
                if (aff(i).ne.MISS) nuntyp=nuntyp+1
              elseif (aff(i).eq.1.or.aff(i).eq.2) then
                g1=getnam(locus(i,gene),numal,name)
                g2=getnam(locus(i,gen2),numal,name)
                gtp=clcpos(g1,g2)
                cntall(gtp,aff(i))=cntall(gtp,aff(i))+1
              endif
   13       continue
          end if
        else
          if (typ.eq.1) then
            do 14 i=1,num
              untyped(i)=.false.
              aff(i)=int(isaff(locus(i,trait),thresh,gt))
              if (locus(i,gene).lt.KNOWN) then
                untyped(i)=.true.
                if (aff(i).ne.MISS) nuntyp=nuntyp+1
              elseif (aff(i).eq.1.or.aff(i).eq.2) then
                g1=getnam(locus(i,gene),numal,name)
                g2=getnam(locus(i,gen2),numal,name)
                cntall(g1,aff(i))=cntall(g1,aff(i))+1
                cntall(g2,aff(i))=cntall(g2,aff(i))+1
                if (g1.eq.g2) nhom(aff(i))=nhom(aff(i))+1
              endif
   14       continue
          else
            do 15 i=1,num
              untyped(i)=.false.
              aff(i)=int(isaff(locus(i,trait),thresh,gt))
              if (locus(i,gene).lt.KNOWN) then
                untyped(i)=.true.
                if (aff(i).ne.MISS) nuntyp=nuntyp+1
              elseif (aff(i).eq.1.or.aff(i).eq.2) then
                g1=getnam(locus(i,gene),numal,name)
                g2=getnam(locus(i,gen2),numal,name)
                gtp=clcpos(g1,g2)
                cntall(gtp,aff(i))=cntall(gtp,aff(i))+1
              endif
   15       continue
          end if
          write(wrk2) num,nfound,
     &      (aff(i),fa(i),mo(i),untyped(i),i=1,num)
        end if
      goto 10
   20 continue
C
      eh1=0
      eh2=0
      eh12=0
      nca=0
      nco=0
      do 25 i=1,ncats 
        nco=nco+cntall(i,1)
        nca=nca+cntall(i,2)
        cntall(i,3)=cntall(i,1)+cntall(i,2)
        if (cntall(i,3).gt.0) df=df+1
   25 continue
C F statistics calculated if allelic test
      if (typ.eq.1) then
        do 26 i=1,ncats 
          eh1=eh1+cntall(i,1)*cntall(i,1)
          eh2=eh2+cntall(i,2)*cntall(i,2)
          eh12=eh12+cntall(i,1)*cntall(i,2)
   26   continue
        d1=max(1.0d0,dfloat(nco))
        d2=max(1.0d0,dfloat(nca))
        h0=1.0d0-dfloat(nhom(1))/d1-dfloat(nhom(2))/d2
        hs=0.5d0*(dfloat(nco*(nco-1)
     2     +2*nhom(1)-eh1)/d1/max(1.0d0,d1-2.0d0)
     3     +dfloat(nca*(nca-1)+2*nhom(2)-eh2)/d2/max(1.0d0,d2-2.0d0))
        ht=1.0d0-dfloat(eh12)/d1/d2
        fis=(hs-h0)/hs
        fit=(ht-h0)/ht
        fst=(ht-hs)/ht
      end if
C Calculate association statistic
      if (nca.gt.0 .and. nco.gt.0) then
        pexp=dfloat(nca)/dfloat(nca+nco)
        ochisq=twobyk(ncats,cntall,pexp)
        asyp=chip(ochisq,df)
      else
        pexp=0.0d0
        ochisq=0.0d0
        asyp=1.0d0
      end if

      if (plevel.gt.0) then
        write(*,'(/3a/a/a)') 
     2    '  ---- Association Analysis for "',locnam,'"----',
     3    '    Allele   Affected   Unaffected   Total    Dev',
     4    '  -----------------------------------------------'
        casden=max(1.0,float(nca))
        conden=max(1.0,float(nco))
        do 30 i=1,ncats  
          write(*,'(i8,2(2x,i5,1x,a1,f3.2,a1),i8,1x,f6.1)') 
     2     cntall(i,4),cntall(i,2),'(',float(cntall(i,2))/casden,')',
     3     cntall(i,1),'(',float(cntall(i,1))/conden,')',cntall(i,3),
     4     binz(cntall(i,2),cntall(i,3),pexp)
   30   continue
        write(*,'(a/a8,2(2x,i5,6x),i8)') 
     2    '  -----------------------------------------------',
     3      'Total',nca,nco,nca+nco
        write(*,'(/a,i6/a,i6)') 
     2    '       No. trait(+) marker(-) =',nuntyp,
     3    '       No. trait(+) marker(+) =',(nca+nco)/2
        if (typ.eq.1) then
          write(*,'(a,3(3x,f6.4))') 
     &      '                Fis, Fit, Fst =',fis, fit, fst
        end if
        write(*,'(a,f6.1/a,i4/a,3x,f6.4)')
     2    '   Contingency Pearson chi-sq =',ochisq,
     3    '   Nominal degrees of freedom =',df,
     4    '              Nominal P-value =',asyp
      end if
C
C if founders only, or no cases or no controls or iter=0, then
C Monte-Carlo procedure superfluous
C
      it=0
      tailp=0
      if (assfnd .or. nca.eq.0 .or. nco.eq.0 .or. iter.eq.0) then
        pval=1.0d0
      else
C
C Sequential Monte-Carlo P-value after Besag & Clifford Biometrika 1991
C P= tailp/it if tailp=mincnt or (tailp+1)/(it+1) if tailp<mincnt && it=iter
C
   49   continue
        if (it.eq.iter .or. tailp.eq.mincnt) goto 50
          it=it+1
          do 52 j=1,ncats  
          do 52 k=1,3
            cntall(j,k)=0
   52     continue
          rewind(wrk2)
   55     continue
            read(wrk2,end=70) num,nfound,
     &        (aff(i),fa(i),mo(i),untyped(i),i=1,num)
            call simped(num,nfound,fa,mo,cumfrq,set)
            if (typ.eq.1) then
              do 65 i=1,num
              if (.not.untyped(i).and.(aff(i).eq.1.or.aff(i).eq.2)) then
                cntall(set(i,1),aff(i))=cntall(set(i,1),aff(i))+1
                cntall(set(i,2),aff(i))=cntall(set(i,2),aff(i))+1
              endif
   65         continue
            else
              do 66 i=1,num
              if (.not.untyped(i).and.(aff(i).eq.1.or.aff(i).eq.2)) then
                gtp=clcpos(set(i,1),set(i,2))
                cntall(gtp,aff(i))=cntall(gtp,aff(i))+1
              endif
   66         continue
            end if
          goto 55
   70     continue

          do 80 i=1,ncats  
            cntall(i,3)=cntall(i,1)+cntall(i,2)
   80     continue
          chisq=twobyk(ncats,cntall,pexp)
          call moment(it,chisq,mchisq,vchisq)
          if (chisq.gt.ochisq .or. (chisq.eq.ochisq .and.
     2        random().gt.0.5))  then
            tailp=tailp+1
          end if
          if (plevel.gt.1) then
            write(*,'(/a,i4,a,f6.1)') 
     &        'Pseudosample ',it,': Chisq=',chisq
            do 85 i=1,ncats
              write(*,'(i8,2(2x,i5,1x,a1,f3.2,a1),i8)') 
     2          cntall(i,4),cntall(i,2),'(',
     3          float(cntall(i,2))/float(nca),')',cntall(i,1),'(',
     4          float(cntall(i,1))/float(nco),')',cntall(i,3)
   85        continue
          end if
          goto 49
   50   continue
        if (tailp.lt.mincnt) then
          tailp=tailp+1
          it=it+1
        end if
        vchisq=vchisq/dfloat(max(1,it-1))
        pval=dfloat(tailp)/dfloat(it)
      end if
      if (plevel.gt.0) then
        write(*,'(a,i4,a,i5,a,f6.4,a/a,f6.1,a,f6.1,a)')
     2    '      Equalled or exceeded by =',tailp,'/',it,
     3    ' simulated values (',pval,')',
     4    ' Mean (Var) simulated chi-sqs =',mchisq,' (',vchisq,')'
      else
        call phist(asyp,pval,histo)
        write(*,'(a10,2(1x,i6),1x,f10.1,2(1x,f6.4),1x,i6,1x,2a,1x,a)')
     2    locnam, (nca+nco)/2, df+1, ochisq, asyp, pval, it, 
     3    'AssX2-',ana,histo
      end if
      return
      end
C end-of-doassoc
C
C Pearson chi-sq for 2xK table (uses only cntall(,1-3))
C
      double precision function twobyk(nallele,cntall,pexp)
      integer MAXALL,MAXG
      parameter(MAXALL=60,MAXG=MAXALL*(MAXALL+1)/2)
      integer nallele, cntall(MAXG,4)
      double precision pexp
      integer i
      double precision num1,num2, den1, den2
      twobyk=0.0d0
      if (pexp.eq.0.0d0 .or. pexp.eq.1.0d0) return
      do 10 i=1,nallele
      if (cntall(i,3).gt.0) then
        den2=pexp*dfloat(cntall(i,3))
        den1=dfloat(cntall(i,3))-den2
        num2=dfloat(cntall(i,2))-den2
        num1=dfloat(cntall(i,1))-den1
        twobyk=twobyk+(num1*num1)/den1+(num2*num2)/den2
      end if
   10 continue
      return
      end
C end-of-twobyk
C
C Test the 4 possible unions of gametes 1 2 3 4 -> 13 14 23 24 
C if typ=0 return both parental contributions, else 1=pat, 2=mat
C
      subroutine trans(pg1,pg2,mg1,mg2,cg1,cg2,tr1,tr2,nt1,nt2,typ)
      integer MISS
      parameter(MISS=-9999)
      integer pg1,pg2,mg1,mg2,cg1,cg2,tr1,tr2,nt1,nt2,typ
      real random
      tr1=MISS
      tr2=MISS
      nt1=MISS
      nt2=MISS
      if ((pg1.eq.MISS).and.(mg1.ne.MISS).and.
     2    .not.((mg1.eq.cg1).and.(mg2.eq.cg2)) 
     3   .and.((mg1.eq.cg1).or.(mg1.eq.cg2))) then
        tr1=mg1
        nt1=mg2
        tr2=MISS
        nt2=MISS
      elseif((pg1.eq.MISS).and.(mg1.ne.MISS)
     2       .and..not.((mg1.eq.cg1).and.(mg2.eq.cg2)) 
     3       .and.((mg2.eq.cg1).or.(mg2.eq.cg2))) then 
        tr1=mg2
        nt1=mg1
        tr2=MISS
        nt2=MISS
      elseif((pg1.ne.MISS).and.(mg1.eq.MISS)
     2        .and..not.((pg1.eq.cg1).and.(pg2.eq.cg2))  
     3        .and.((pg1.eq.cg1).or.(pg1.eq.cg2))) then
        tr1=MISS
        nt1=MISS
        tr2=pg1
        nt2=pg2
      elseif((pg1.ne.MISS).and.(mg1.eq.MISS)
     2        .and..not.((pg1.eq.cg1).and.(pg2.eq.cg2))
     3        .and.((pg2.eq.cg1).or.(pg2.eq.cg2))) then
        tr1=MISS
        nt1=MISS
        tr2=pg2
        nt2=pg1
      elseif(pg1.eq.mg1 .and. pg2.eq.mg2 .and. 
     &       pg1.eq.cg1 .and. pg2.eq.cg2) then
        if (typ.eq.1 .or. typ.eq.2) then
          tr1=MISS
          nt1=MISS
          tr2=MISS
          nt2=MISS
        else if (random().gt.0.5) then
          tr1=mg1
          nt1=mg2
          tr2=pg2
          nt2=pg1
        else
          tr1=mg2
          nt1=mg1
          tr2=pg1
          nt2=pg2
        end if
      elseif(((pg1.eq.cg1).and.(mg1.eq.cg2))
     2        .or.((pg1.eq.cg2).and.(mg1.eq.cg1))) then
        tr1=mg1
        nt1=mg2
        tr2=pg1
        nt2=pg2
      elseif(((pg1.eq.cg1).and.(mg2.eq.cg2))
     2        .or.((pg1.eq.cg2).and.(mg2.eq.cg1))) then
        tr2=pg1
        nt2=pg2
        tr1=mg2
        nt1=mg1
      elseif(((pg2.eq.cg1).and.(mg1.eq.cg2))
     2        .or.((pg2.eq.cg2).and.(mg1.eq.cg1))) then
       tr2=pg2
       nt2=pg1
       tr1=mg1
       nt1=mg2
      elseif(((pg2.eq.cg1).and.(mg2.eq.cg2))
     2        .or.((pg2.eq.cg2).and.(mg2.eq.cg1))) then
       tr2=pg2
       nt2=pg1
       tr1=mg2
       nt1=mg1
      end if
C check to see which parental contribution to retain
      if (typ.eq.1) then
        tr2=MISS
        nt2=MISS
      elseif (typ.eq.2) then
        tr1=MISS
        nt1=MISS
      end if
      return
      end
C end-of-trans
C
C Transmission of X-linked marker to a male
      subroutine xtrans(mg1,mg2,cg1,cg2,tr1,tr2, nt1, nt2)
      integer MISS
      parameter(MISS=-9999)
      integer mg1,mg2,cg1,cg2,tr1,tr2,nt1,nt2
      tr1=MISS
      nt1=MISS
      tr2=MISS
      nt2=MISS
      if (mg1.ne.MISS) then 
        if ((mg1.eq.cg1).or.(mg1.eq.cg2)) then
          tr1=mg1
          nt1=mg2
        else if ((mg2.eq.cg1).or.(mg2.eq.cg2)) then 
          tr1=mg2
          nt1=mg1
        end if
      end if
      return
      end
C end-of-xtrans
C
C Increment counts of transmitted and nontransmitted alleles: parentwise
C
      subroutine incpo(tr,nt,nall,cntall)
      integer MAXALL,MAXG,MISS
      parameter(MAXALL=60,MAXG=MAXALL*(MAXALL+1)/2,MISS=-9999)
      integer tr,nt,nall,cntall(MAXG,4)
      integer i,j,a1,a2
      logical trans
      if (tr.eq.MISS.or.nt.eq.MISS.or.tr.eq.nt) return
      if (tr.le.nt) then
        trans=.true.
        a1=tr
        a2=nt
      else
        trans=.false.
        a1=nt
        a2=tr
      end if
      i=0
    5 continue
        i=i+1
      if (i.le.nall .and. (a1.gt.cntall(i,1).or.
     &    (a1.eq.cntall(i,1).and.a2.gt.cntall(i,2)))) goto 5
      if (i.le.nall .and. cntall(i,1).eq.a1.and.cntall(i,2).eq.a2) then
        if (trans) then
          cntall(i,3)=cntall(i,3)+1
        else
          cntall(i,4)=cntall(i,4)+1
        end if
      else
        do 20 j=nall,i,-1
        do 20 k=1,4
   20     cntall(j+1,k)=cntall(j,k)
        cntall(i,1)=a1
        cntall(i,2)=a2
        if(trans) then
          cntall(i,3)=1
          cntall(i,4)=0
        else
          cntall(i,3)=0
          cntall(i,4)=1
        end if
        nall=nall+1
      end if
      return
      end
C end-of-incpo
C
C Increment counts of transmitted and expected genotypes
C Revised after reading Thomas 1999
C
      subroutine incr(tr1,tr2,nt1,nt2,ngcount,gcount)
      integer MAXALL,MAXG,MISS
      parameter(MAXALL=60,MAXG=MAXALL*(MAXALL+1)/2,MISS=-9999)
      integer tr1,tr2,nt1,nt2,ngcount,gcount(MAXG,4)
C only use cases both parents typed
      if (nt1.eq.MISS .or. nt2.eq.MISS) return
C case
      call insgen(tr1,tr2,ngcount,gcount,3,1)
C 4 pseudo-sibs for control distribution
      call insgen(tr1,tr2,ngcount,gcount,4,1)
      call insgen(tr1,nt2,ngcount,gcount,4,1)
      call insgen(nt1,tr2,ngcount,gcount,4,1)
      call insgen(nt1,nt2,ngcount,gcount,4,1)
      return
      end
C end-of-incr
C
C update counts of genotypes or haplotypes for cases or controls -- 
C binary search and insertion sort
C
      subroutine insgen(a1,a2,ngcount,gcount,type,haplo)
      integer MAXALL, MAXG 
      parameter(MAXALL=60,MAXG=MAXALL*(MAXALL+1)/2)
      integer a1,a2,haplo,ngcount,gcount(MAXG,4),type
      integer g1,g2,hi,j,k,lo,pos
C if genotype, order by allele size rather than parent of origin
      if (haplo.eq.2 .or. a1.le.a2) then
        g1=a1
        g2=a2
      else
        g1=a2
        g2=a1
      end if
      pos=1
      hi=ngcount
      lo=1
    1 continue 
      if (hi.lt.lo) goto 5
        pos=(hi+lo)/2
        if (g1.gt.gcount(pos,1) .or.
     &      (g1.eq.gcount(pos,1) .and. g2.gt.gcount(pos,2))) then
          lo=pos+1
        elseif (g1.lt.gcount(pos,1).or.
     &      (g1.eq.gcount(pos,1) .and. g2.lt.gcount(pos,2))) then
          hi=pos-1
        else
          gcount(pos,type)=gcount(pos,type)+1
          return
        end if
      goto 1
    5 continue
C else create new category
      do 50 j=ngcount,pos,-1
      do 50 k=1,4
        gcount(j+1,k)=gcount(j,k)
   50 continue
      gcount(lo,1)=g1
      gcount(lo,2)=g2
      gcount(lo,3)=0
      gcount(lo,4)=0        
      gcount(lo,type)=1
      ngcount=ngcount+1
      return
      end
C end-of-insgen
C
C Monte-Carlo approach to various TDTs
C
      subroutine dotdt(wrk,wrk2,trait,locnam,gene,iter,mincnt,use2,typ,
     2             cutoff,gt,thresh,pedigree,actset,num,nfound,id,fa,mo,
     3             sex,locus, numloc, numal, name, untyped, set,
     4             nallele,cntall,ngcount,gcount,plevel)
      integer MAXALL, MAXG, MAXSIZ, MAXLOC, MISS, KNOWN
      parameter(MAXALL=60, MAXG=MAXALL*(MAXALL+1)/2, 
     &          MAXSIZ=1000, MAXLOC=120, MISS=-9999, KNOWN=0)
      integer cutoff,gene,iter,mincnt,plevel,trait,typ,use2,wrk,wrk2
      real thresh
      logical gt
      character*10 locnam
C pedigree structure
      character*10 pedigree
      integer sex(MAXSIZ)
      integer actset,num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), set(MAXSIZ,2)
      real locus(MAXSIZ,MAXLOC)
C allele frequencies structure
      integer numal, name(MAXALL)
C Genotype counts: allele1,allele2, number transmitted, number not trans
      integer nallele,cntall(MAXG,4), ngcount,gcount(MAXG,4)
C
      integer cg1,cg2,pg1,pg2,mg1,mg2,tr1,tr2,nt1,nt2
      logical last, untyped(MAXSIZ)
      integer alltr,allnt,df,gdf,gen2,i,it,j,k,mxiter,ntest,tailp,tot
      integer aff(MAXSIZ),naff,prob,probandi
      character*3 histo
      double precision celltdt, tdt, otdt, gtdt, mgtdt, mcnem, pval
      double precision asyp, bestm, bestp, ewens, ftdev
      character*7 gtp, gtp2
C functions 
      double precision binp, bonf, chip, clcchi, clcmcn, ln
      real isaff,random
      logical tdtuse
C
      df=0
      ewens=0.0d0
      gdf=0
      gen2=gene+1
      nallele=0
      ngcount=0
      ntest=0
      mgtdt=0.0d0
      probandi=0
      tot=0
      tdt=0.0d0
      do 2 i=1,MAXG
      do 2 j=1,4
        gcount(i,j)=0
        cntall(i,j)=0
    2 continue
      last=.false.
      rewind(wrk)
C
C If high print level, then list transmitted and nontransmitted alleles
C for each informative proband
C
      if (plevel.gt.1) then
        write(*,'(a/a)') 'Informative Child   Trans    Not Tr ',
     &                   'Pedigree  ID        Mat Pat  Mat Pat'
      end if
C
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

       if (actset.le.0) goto 10
C
         naff=0
         do 11 i=1,nfound
           untyped(i)=.false.
           if (locus(i,gene).lt.KNOWN) untyped(i)=.true.
   11    continue
         do 12 i=nfound+1,num
           untyped(i)=.false.
           if (locus(i,gene).lt.KNOWN) then
             untyped(i)=.true.
           else if (isaff(locus(i,trait),thresh,gt).eq.2.0 .and. 
     &              tdtuse(i,gene,naff,fa,mo,locus,use2)) then
C
C nonfounder affected & typed & 1 or 2 parents heterozygous at marker
C 
             naff=naff+1
             aff(naff)=i
             pg1=MISS
             pg2=MISS
             if (locus(fa(i),gene).gt.KNOWN) then
               pg1=int(locus(fa(i),gene))
               pg2=int(locus(fa(i),gen2))
             end if
             mg1=MISS
             mg2=MISS
             if (locus(mo(i),gene).gt.KNOWN) then
               mg1=int(locus(mo(i),gene))
               mg2=int(locus(mo(i),gen2))
             end if
             cg1=int(locus(i,gene))
             cg2=int(locus(i,gen2))
             call trans(pg1,pg2,mg1,mg2,cg1,cg2,tr1,tr2,nt1,nt2,typ)
             if (plevel.gt.1) then
               call wrgtp(tr1,tr2,gtp,2)
               call wrgtp(nt1,nt2,gtp2,2)
               write(*,'(a10,a8,2(1x,a8))') pedigree,id(i),gtp,gtp2
             end if
             call incpo(tr1,nt1,nallele,cntall)
             call incpo(tr2,nt2,nallele,cntall)
             call incr(tr1,tr2,nt1,nt2,ngcount,gcount)
           end if
   12    continue
         probandi=probandi+naff
         if (naff.gt.0) then
           do 14 i=1,num   
             set(i,1)=MISS
             set(i,2)=MISS
             if (locus(i,gene).gt.KNOWN) then
               set(i,1)=int(abs(locus(i,gene)))
               set(i,2)=int(abs(locus(i,gen2)))
             end if
   14      continue
           write(wrk2) naff,(aff(i),i=1,naff),num,nfound,
     &       (fa(i),mo(i),untyped(i),set(i,1),set(i,2),i=1,num) 
         end if
       goto 10
   20  continue
C
      if (plevel.gt.1) then
        write(*,*)
      end if
      if (plevel.gt.0) then
        write(*,'(/a,i3)') 'Number of informative probands: ',probandi
C
        write(*,'(/3a/a/a)') 
     2   '  - Allele by Allele TDT:"',locnam,'" -',
     3   '  Allele   Trans  Not Tr   TDT   P-value',
     4   '  --------------------------------------'
      end if
      bestm=0.0d0
      bestp=1.0d0
      do 215 i=1,numal
        alltr=0
        allnt=0
        do 220 j=1,nallele
          if (cntall(j,1).eq.name(i)) then
            alltr=alltr+cntall(j,3)
            allnt=allnt+cntall(j,4)
          elseif (cntall(j,2).eq.name(i)) then
            alltr=alltr+cntall(j,4)
            allnt=allnt+cntall(j,3)
          end if
  220   continue
        if ((alltr+allnt).gt.cutoff) then
          ntest=ntest+1
          mcnem=clcmcn(alltr,allnt)
          ewens=ewens+mcnem
          pval=binp(dfloat(alltr),dfloat(allnt))
          if (pval.lt.bestp) then
            bestp=pval
            bestm=mcnem
          end if
          if (plevel.gt.0) then
            write(*,'(3i8,f6.1,4x,f6.4)') 
     &        name(i),alltr,allnt,mcnem,pval 
          end if
        end if
  215 continue
      if (ntest.gt.1) ewens=dfloat(ntest-1)*ewens/dfloat(ntest)

      if (plevel.gt.0) then
        if (cutoff.gt.0)
     &     write(*,'(/a,i4)') 'Not using rows with totals   =<',cutoff
        if (ntest.gt.0) then
          write(*,'(/a,i4,3(/a,3x,f8.6)/)') 
     2    'No. of alleles used  = ',ntest,
     3    'Bonferroni corr. 5%  = ',bonf(ntest-1,0.05d0),
     4    'Bonferroni corr. 1%  = ',bonf(ntest-1,0.01d0),
     5    'Bonferroni corr. 0.1%= ',bonf(ntest-1,0.001d0)
        else
          write(*,'(a)') 'No alleles meet inclusion criteria'
        end if
      else
        if (ntest.gt.0) asyp=min(1.0d0,(ntest-1)*bestp)
        call phist(asyp,asyp,histo)
        write(*,'(a10,2(1x,i6),1x,f10.1,2(1x,f6.4),1x,i6,2(1x,a))')
     2    locnam, probandi, ntest, bestm, asyp, asyp,
     3    0, 'TDT-Best ', histo
      end if
C
      alltr=0
      allnt=0
      if (plevel.gt.0) then
        write(*,'(/a/a/a)') 
     2    '  -------- Global Allelic TDT --------',
     3    '   All 1   All 2    Tr=1    Tr=2   TDT',
     4    '  ------------------------------------'
      end if
      do 15 i=1,nallele
        celltdt=0.0d0
        alltr=alltr+cntall(i,3)
        allnt=allnt+cntall(i,4)
        if ((cntall(i,3)+cntall(i,4)).gt.cutoff) then
          celltdt=dfloat(cntall(i,3)-cntall(i,4))**2
     &            /dfloat(cntall(i,3)+cntall(i,4))
          tdt=tdt+celltdt
          df=df+1
        end if
        if (plevel.gt.0) then
          write(*,'(4i8,f6.1)') 
     &       cntall(i,1),cntall(i,2),cntall(i,3),cntall(i,4),celltdt
        end if
   15 continue
      tot=alltr+allnt
      asyp=1.0d0
      if (df.gt.0) asyp=chip(tdt,df)

      if (plevel.gt.0) then
        write(*,'(/a,f6.1)') 'Allelic TDT Pearson chi-square=',tdt
        if (cutoff.gt.0) then
           write(*,'(a,i4)') 'Not using rows with totals   =<',cutoff
        end if
        write(*,'(12x,a,i4)') 'Degrees of freedom=',df
        write(*,'(23x,a,3x,f6.4)') 'P-value=', asyp
      end if
      if (iter.gt.0 .and. tot.gt.0) then
        mxiter=10*iter
        call shuffle(nallele,cntall,tot,cutoff,tdt,mxiter,mincnt,
     &               pval)
      else
        mxiter=0
        pval=1.0d0
      end if
      if (plevel.gt.0) then
        write(*,'(a,i7,a,3x,f6.4)') 
     &   'Empiric P-value (',mxiter,' iter)=',pval
        write(*,'(/a,f6.1)') '  Ewens allelic TDT chi-square=',ewens
        write(*,'(12x,a,i4)') 'Degrees of freedom=',ntest-1
        write(*,'(23x,a,3x,f6.4)') 'P-value=',chip(ewens,ntest-1)
        write(*,'(/a/a/a)') 
     2    '  ----- Genotypic Transmission Test ------',
     3    '       Genotype     Trans  Expected   Dev',
     4    '  ----------------------------------------'
      else
        call phist(asyp,pval,histo)
        write(*,'(a10,2(1x,i6),1x,f10.1,2(1x,f6.4),1x,i6,2(1x,a))')
     2    locnam, probandi, df, tdt, asyp, pval,mxiter,'TDT-All  ',histo
        asyp=1.0d0
        df=max(0,df-1)
        if (df.gt.0) asyp=chip(ewens,df)
        call phist(asyp,asyp,histo)
        write(*,'(a10,2(1x,i6),1x,f10.1,2(1x,f6.4),1x,i6,2(1x,a))')
     2    locnam, probandi, df, ewens, asyp, asyp, 0, 
     3    'TDT-Ewens',histo
      end if

      otdt=0.0d0
      do 225 i=1,ngcount
        if (gcount(i,3).gt.cutoff) then
          gdf=gdf+1
          if (gcount(i,4).gt.cutoff) then
            otdt=otdt+dfloat(gcount(i,3))*
     &           ln(dfloat(4*gcount(i,3))/dfloat(gcount(i,4)))
          end if
        end if    
        call wrgtp(gcount(i,1),gcount(i,2),gtp,1)
        if (plevel.gt.0) then
          write(*,'(8x,a7,1x,i8,1x,f9.1,1x,f6.1)') 
     2     gtp,gcount(i,3),0.25d0*dfloat(gcount(i,4)),
     3     ftdev(dfloat(gcount(i,3)),0.25d0*dfloat(gcount(i,4)))
        end if
  225 continue
      otdt=otdt+otdt
      gdf=max(gdf-1,1)
      asyp=chip(otdt,gdf)
C
C Monte-Carlo only if iter>0
C
      it=0
      tailp=0
      if (iter.eq.0 .or. tot.eq.0) then
        pval=1.0d0
      else
C Sequential Monte-Carlo P-value after Besag & Clifford Biometrika 1991
C P= tailp/it if tailp=mincnt or (tailp+1)/(it+1) if tailp<mincnt && it=iter
   49   continue
        if (it.eq.iter .or. tailp.eq. mincnt) goto 50
          it=it+1
          do 52 j=1,ngcount
          do 52 k=1,4
            gcount(j,k)=0
   52     continue        
          ngcount=0
          rewind(wrk2)

   55     continue
            read(wrk2,end=70) naff,(aff(i),i=1,naff),num,nfound,
     &        (fa(i),mo(i),untyped(i),set(i,1),set(i,2),i=1,num) 
            call csimped(num,nfound,fa,mo,untyped,set)
            do 60 i=1,naff
              prob=aff(i)
              pg1=set(fa(prob),1)
              pg2=set(fa(prob),2)
              mg1=set(mo(prob),1)
              mg2=set(mo(prob),2)
              cg1=set(prob,1)
              cg2=set(prob,2)
              call trans(pg1,pg2,mg1,mg2,cg1,cg2,tr1,tr2,nt1,nt2,typ)
              call incr(tr1,tr2,nt1,nt2,ngcount,gcount)
   60       continue
          goto 55
   70     continue
          gtdt=clcchi(ngcount,gcount,cutoff)
          mgtdt=mgtdt+gtdt
          if (gtdt.gt.otdt .or. (gtdt.eq.otdt .and. 
     2        random().gt.0.5d0))  then
            tailp=tailp+1
          end if
          if (plevel.gt.1) then
            write(*,'(/a,i4,a,f6.1)') 
     &       'Pseudosample ',it,': gX2 =',gtdt
            do 325 i=1,ngcount
              call wrgtp(gcount(i,1),gcount(i,2),gtp,1)
  325         write(*,'(8x,a7,1x,2i8)') 
     &          gtp,gcount(i,3),gcount(i,4)
          end if
          goto 49
   50   continue
        if (tailp.lt.mincnt) then
          tailp=tailp+1
          it=it+1
        end if
        mgtdt=mgtdt/dfloat(it)
        pval=dfloat(tailp)/dfloat(it)
      end if
      if (plevel.gt.0) then
        write(*,'(/a,f6.1/a,i4)')
     2    'Genotypic Transmission Chi-sq =',otdt,
     3    '   Nominal degrees of freedom =',gdf
        if (cutoff.gt.0) then
          write(*,'(a,i4)') 'Not using rows with totals   =<',cutoff
        end if
        write(*,'(14x,a,3x,f6.4)') 'Nominal P-value =',asyp
        write(*,'(6x,a,i4,a,i4,a,f6.4,a/a,f6.1)')
     2    'Equalled or exceeded by =',tailp,'/',it,
     3    ' simulated values (',pval,')',
     4    'Mean of simulated chi-squares =',mgtdt
      else
        call phist(asyp,pval,histo)
        write(*,'(a10,2(1x,i6),1x,f10.1,2(1x,f6.4),1x,i6,2(1x,a))')
     &    locnam, probandi, gdf, otdt, asyp, pval, it,'TDT-Gtp  ',histo
      end if
      return
      end
C end-of-dotdt
C
C test if useful for TDT
C
      logical function tdtuse(idx,gene,naff,fa,mo,locus,use2)
      integer MAXSIZ, MAXLOC, KNOWN
      parameter(MAXSIZ=1000, MAXLOC=120, KNOWN=0)
      integer gene,idx, naff, use2
C pedigree structure
      integer fa(MAXSIZ),mo(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
      integer gen2

      gen2=gene+1
      tdtuse=.false.

C both parents untyped
      if (locus(fa(idx),gene).lt.KNOWN .and. 
     &    locus(mo(idx),gene).lt.KNOWN) then
        return
C only using one proband per family
      elseif (naff.gt.0 .and. use2.gt.2) then
        return
C one parent untyped and the other homozygous or same genotype as index
      elseif (locus(mo(idx),gene).lt.KNOWN .and. (use2.gt.1 .or.
     2        ((locus(fa(idx),gene).eq.locus(fa(idx),gen2) .or. 
     3        (locus(idx,gene).eq.locus(fa(idx),gene)
     4        .and. locus(idx,gen2).eq.locus(fa(idx),gen2)))))) then
        return
      elseif (locus(fa(idx),gene).lt.KNOWN .and. (use2.gt.1 .or.
     2        ((locus(mo(idx),gene).eq.locus(mo(idx),gen2) .or.
     3        (locus(idx,gene).eq.locus(mo(idx),gene)
     4        .and. locus(idx,gen2).eq.locus(mo(idx),gen2)))))) then
        return
C both parents homozygous 
      elseif (locus(fa(idx),gene).eq.locus(fa(idx),gen2) .and. 
     &        locus(mo(idx),gene).eq.locus(mo(idx),gen2)) then 
        return
C both parents same genotype as index
C     elseif (locus(idx,gene).eq.locus(fa(idx),gene) .and. 
C    2        locus(idx,gen2).eq.locus(fa(idx),gen2) .and. 
C    3        locus(idx,gene).eq.locus(mo(idx),gene) .and. 
C    4        locus(idx,gen2).eq.locus(mo(idx),gen2)) then
C       return
      end if
      tdtuse=.true.
      return
      end
C end-of-tdtuse
C
C randomization test for allelic TDT -- shuffle table ITER times 
C using TOT swaps per shuffle
C
      subroutine shuffle(nallele,cntall,tot,cutoff,tdt,mxiter,mincnt,
     &                   pvalue)
      integer MAXALL, MAXG
      parameter(MAXALL=60, MAXG=MAXALL*(MAXALL+1)/2)
      integer mxiter, mincnt
      double precision pvalue, tdt
C Genotype counts: all1, all2, #all1 trans, #all2 trans
      integer nallele,cntall(MAXG,4),tot,cutoff
C local variables
      integer toc,cum,oldcum,row,col
      integer i,it,swap,tailp
      double precision simtdt
C functions
      double precision clctdt
      integer irandom
      real random
C
C Sequential Monte-Carlo P-value after Besag & Clifford Biometrika 1991
C P= tailp/it if tailp=mincnt or (tailp+1)/(it+1) if tailp<mincnt && it=iter
C
      it=0
      tailp=0
    5 continue
      if (it.eq.mxiter .or. tailp.eq.mincnt) goto 10
        it=it+1
        do 20 i=1,tot
          swap=irandom(1,tot)
          oldcum=0
          do 25 row=1,nallele
          do 25 col=3,4
          if (cntall(row,col).gt.0) then
            cum=oldcum+cntall(row,col)
            if  (swap.le.cum .and. swap.gt.oldcum) 
     &      then
              toc=4
              if (col.eq.4) toc=3
              goto 26
            end if
            oldcum=cum
          end if
   25     continue
   26     continue
          cntall(row,col)=cntall(row,col)-1
          cntall(row,toc)=cntall(row,toc)+1
   20   continue
        simtdt=clctdt(nallele,cntall,cutoff)
        if (simtdt.gt.tdt .or. (simtdt.eq.tdt .and. 
     2      random().gt.0.5))  then
          tailp=tailp+1
        end if
      goto 5
   10 continue
      if (tailp.lt.mincnt) then
        tailp=tailp+1
        it=it+1
      end if
      mxiter=it
      pvalue=dfloat(tailp)/dfloat(mxiter)
      return
      end
C end-of-shuffle
C
C calculate symmetry pearson chi-square
C
      double precision function clctdt(ngcount,gcount,cutoff)
C
C Genotype counts
C genotype allele1,allele2, number transmitted, number not trans
      integer MAXALL,MAXG
      parameter(MAXALL=60,MAXG=MAXALL*(MAXALL+1)/2)
      integer ngcount,gcount(MAXG,4),cutoff
      integer j
      clctdt=0.0d0
      do 10 j=1,ngcount
      if ((gcount(j,3)+gcount(j,4)).gt.cutoff) then
        clctdt=clctdt+dfloat(gcount(j,3)-gcount(j,4))**2
     &         /dfloat(gcount(j,3)+gcount(j,4))
      end if
   10 continue
      return
      end
C end-of-clctdt
C
C calculate g.o.f. LR chi-square
C
      double precision function clcchi(ngcount,gcount,cutoff)
C
C Genotype counts
C genotype allele1,allele2, number transmitted, 
C expected number based on parental genotypes
C
      integer MAXALL,MAXG
      parameter(MAXALL=60,MAXG=MAXALL*(MAXALL+1)/2)
      integer ngcount,gcount(MAXG,4),cutoff
      integer j
      clcchi=0.0d0
      do 10 j=1,ngcount
      if (gcount(j,3).gt.cutoff .and. gcount(j,4).gt.cutoff) then
        clcchi=clcchi+dfloat(gcount(j,3))*
     &         log(dfloat(4*gcount(j,3))/dfloat(gcount(j,4)))
      end if
   10 continue
      clcchi=clcchi+clcchi
      return
      end
C end-of-clcchi
C
C Approach of Schaid and Sommer (1993), amplified by Knapp et al (1995)
C
C MM x MM   MM x MN   MM x NN   MN x MN    MN x NN    NN x NN    
C   MM      MM   MN     MN      MM MN NN   MN   NN      NN
C   n1      n2   n3     n4      n5 n6 n7   n8   n9      n10
C
C a=4*n1 + 3*n2 + 3*n3 + 2*n4 + 2*n5 + 2*n6 + 2*n7 + n8 + n9
C b=n2 + n3 + 2*n4 + 2*n5 + 2*n6 + 2*n7 + 3*n8 + 3*n9 + 4*n10
C c=n1 + n2 + n5
C d=n3 + n4 + n6 + n8
C
C providing n-c-d!=0 and a-2c-d!=0 then
C
C p=(a-2*c-d)/2n
C r1= (1-p)*d/(2*p*(n-c-d))
C r2= (1-p)^2 c/(p^2*(n-c-d))
C
C Here, actually done as the log-linear model, as the closed form
C standard error formulae are ugly
C
C
      subroutine nucseg(wrk,trait,gene,candal,x,r,b,cov,pedigree,actset,
     2             num,nfound,id,fa,mo,sex,locus, numloc, key, plevel)
      integer MAXCOV, MAXLOC, MAXIBD, MAXSIZ, MAXTER, KNOWN
      parameter(MAXSIZ=1000, MAXLOC=120, KNOWN=0,
     3          MAXIBD=1000, MAXTER=MAXIBD/2, 
     4          MAXCOV=MAXTER*(MAXTER+1)/2 )
      integer gene,plevel,trait,wrk
      real candal
C pedigree structure
      character*10 pedigree
      integer sex(MAXSIZ)
      integer actset,num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C work arrays for log-linear modelling
      double precision x(MAXTER), r(MAXCOV), b(MAXTER), cov(MAXCOV)
      integer key(MAXSIZ)
C local variables
      real count(16), cpgmod(40), hwemod(64)
      integer gen2, i, naff, pos
      character*7 gtp0, gtp1, gtp2
      logical last
      double precision lik0, lik1, p, p0, q, q0, r0, r1, r2,
     &                 e1,e2,e3,e4,e5,e6, se1, se2
C
C functions 
      double precision chip
C
      data hwemod / 1.0,4.0,0.0,1.0,1.0,3.0,0.0,1.0,1.0,3.0,0.0,1.0,
     2              1.0,3.0,1.0,0.0,1.0,3.0,1.0,0.0,1.0,2.0,1.0,0.0,
     3              1.0,2.0,1.0,0.0,1.0,2.0,0.0,1.0,1.0,2.0,1.0,0.0,
     4              1.0,2.0,1.0,0.0,1.0,2.0,0.0,0.0,1.0,1.0,1.0,0.0,
     5              1.0,1.0,1.0,0.0,1.0,1.0,0.0,0.0,1.0,1.0,0.0,0.0,
     6              1.0,0.0,0.0,0.0 /
      data cpgmod / 
     2 1.0,0.0,0.0,0.0,1.0,1.0,0.0,0.0,1.0,0.0,
     3 0.0,1.0,0.0,0.0,1.0,0.0,1.0,0.0,1.0,0.0,
     4 0.0,1.0,0.0,1.0,0.0,0.0,1.0,0.0,0.0,0.0,
     5 0.0,0.0,1.0,1.0,0.0,0.0,0.0,1.0,0.0,0.0 /
      gen2=gene+1
      naff=0
      do 1 i=1,10
        key(i)=0
    1 continue  
      if (plevel.gt.1) then
        write(*,'(/a)') 'Pedigree   ID         Child   Father  Mother'
      end if
      last=.false.
      rewind(wrk)
C
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

       if (actset.le.0) goto 10
C
         do 12 i=nfound+1,num
         if (locus(i,trait).eq.2.0 .and.
     2     locus(i,gene).gt.KNOWN .and. locus(fa(i),gene).gt.KNOWN .and.
     3     locus(mo(i),gene).gt.KNOWN)  then
           naff=naff+1
           nfa=0
           nmo=0
           nch=0
           if (locus(i,gene).eq.candal) nch=nch+1
           if (locus(i,gen2).eq.candal) nch=nch+1
           if (locus(fa(i),gene).eq.candal) nfa=nfa+1
           if (locus(fa(i),gen2).eq.candal) nfa=nfa+1
           if (locus(mo(i),gene).eq.candal) nmo=nmo+1
           if (locus(mo(i),gen2).eq.candal) nmo=nmo+1
           if (nmo.eq.1 .and. nfa.eq.1) then
             pos=7-nch
           else if ((nfa+nmo).gt.1) then
             pos=7-nfa-nmo-nch
           else
             pos=10-nfa-nmo-nch
           end if
           key(pos)=key(pos)+1
           if (plevel.gt.1) then
             write(*,'(a10,1x,a8,3(1x,i3,1x,i3))') pedigree,id(i),
     2         int(locus(i,gene)), int(locus(i,gen2)), 
     3         int(locus(fa(i),gene)), int(locus(fa(i),gen2)), 
     4         int(locus(mo(i),gene)), int(locus(mo(i),gen2)) 
           end if
         end if
   12    continue
       goto 10
   20 continue
      count(1)=float(key(1))
      count(2)=0.5*float(key(2))
      count(3)=count(2)
      count(4)=0.5*float(key(3))
      count(5)=count(4)
      count(6)=0.5*float(key(4))
      count(7)=count(6)
      count(8)=float(key(5))
      count(9)=0.5*float(key(6))
      count(10)=count(9)
      count(11)=float(key(7))
      count(12)=0.5*float(key(8))
      count(13)=count(12)
      count(14)=0.5*float(key(9))
      count(15)=count(14)
      count(16)=float(key(10))

      call loglin(16,4,2,count,hwemod,x,r,b,cov,lik0)
      p0=exp(b(2))
      p0=p0/(1.0d0+p0)
      q0=1.0d0-p0
      call loglin(16,4,4,count,hwemod,x,r,b,cov,lik1)
      p=exp(b(2))
      p=p/(1.0d0+p)
      q=1.0d0-p
      r1=b(3)
      r2=b(4)
      r0=p*p*exp(r2)+2*p*q*exp(r1)+q*q
      se1=1.96d0*sqrt(cov(6))
      se2=1.96d0*sqrt(cov(10))
      lik1=lik0-lik1
      lik1=lik1+lik1
C
      e1=p0*p0*p0*p0*dfloat(naff)
      e2=4*p0*q0*p0*p0*dfloat(naff)
      e3=2*p0*p0*q0*q0*dfloat(naff)
      e4=4*p0*q0*p0*q0*dfloat(naff)
      e5=4*p0*q0*q0*q0*dfloat(naff)
      e6=q*q*q*q*dfloat(naff)
      call wrgtp(int(candal),int(candal),gtp2,1)
      call wrgtp(int(candal),0,gtp1,1)
      call wrgtp(0,0,gtp0,1)

      write(*,'(/a/6x,a,9x,a,3(1x,a)/a)') 
     2  '------------------------------------------------------------',
     3  'Mating','Total Expected', gtp2, gtp1, gtp0,
     4  '------------------------------------------------------------' 
      write(*,50) gtp2,' x ',gtp2, key(1),e1,key(1),'x  ','x  ',
     2  gtp2,' x ',gtp1, key(2)+key(3),e2,key(2),key(3),'x  ',
     3  gtp2,' x ',gtp0, key(4),e3,'x  ',key(4),'x  ',
     4  gtp1,' x ',gtp1, key(5)+key(6)+key(7),e4,key(5),key(6),key(7),
     5  gtp1,' x ',gtp0, key(8)+key(9),e5,'x  ',key(8),key(9),
     6  gtp0,' x ',gtp0, key(10),e6,'x  ','x  ',key(10) 
   50 format(3a,i9,f9.1,(1x,i5,2x),2a8  /3a,i9,f9.1,2(1x,i5,2x),a8/
     2       3a,i9,f9.1,a8,(1x,i5,2x),a8/3a,i9,f9.1,3(1x,i5,2x)/
     3       3a,i9,f9.1,a8,2(1x,i5,2x)  /3a,i9,f9.1,2a8,1x,i5)
      write(*,'(a//a,i3,a,f5.3/a,i5)')  
     2  '------------------------------------------------------------',
     3  'Freq of ',int(candal),' allele   =     ',p,
     4  'N affected children  = ',naff 
      write(*,'(/a,f8.2,a,f5.3,a,2(/3(a,f8.2),a)/a,f8.2)') 
     2  'HWE Chi-square (2 df)= ',lik1,' (P=',chip(lik1,2),')',
     3  'Genotypic RR1 (f1)   = ',exp(r1),' (95%CI=',
     4     exp(r1-se1),' to ',exp(r1+se1),')',
     5  'Genotypic RR2 (f2)   = ',exp(r2),' (95%CI=',
     6     exp(r2-se2),' to ',exp(r2+se2),')',
     7  'Attributable risk    = ', (p*p*(exp(r2)-1.0d0)+
     8     2*p*q*(exp(r1)-1.0d0))/r0
C
C ML CPG test
C
      count(1)=float(key(2))
      count(2)=float(key(3))
      count(3)=float(key(5))
      count(4)=0.5*float(key(6))
      count(5)=count(4)
      count(6)=float(key(7))
      count(7)=float(key(8))
      count(8)=float(key(9))
      call loglin(8,5,3,count,cpgmod,x,r,b,cov,lik0)
      call loglin(8,5,5,count,cpgmod,x,r,b,cov,lik1)
      r1=b(4)
      r2=b(5)
      r0=p*p*exp(r2)+2*p*q*exp(r1)+q*q
      se1=1.96d0*sqrt(cov(10))
      se2=1.96d0*sqrt(cov(15))
      lik1=lik0-lik1
      lik1=lik1+lik1
      write(*,'(/a,f8.2,a,f5.3,a,2(/3(a,f8.2),a)/a,f8.2)') 
     2  'CPG Chi-sq    (2 df) = ',lik1,' (P=',chip(lik1,2),')',
     3  'Genotypic RR1 (f1)   = ',exp(r1),' (95%CI=',
     4     exp(r1-se1),' to ',exp(r1+se1),')',
     5  'Genotypic RR2 (f2)   = ',exp(r2),' (95%CI=',
     6     exp(r2-se1),' to ',exp(r2+se1),')',
     7  'Attributable risk    = ',(p*p*(exp(r2)-1.0d0)+
     8     2*p*q*(exp(r1)-1.0d0))/r0
C
      return
      end
C end-of-nucseg
C
C zero-trapped log
      double precision function ln(x)
      double precision x
      if (x.le.0.0d0) then
        ln=0.0d0
      else
        ln=log(x)
      end if
      return
      end
C end-of-ln
C
C perform sibship association permutation test
C
C Combines TDT with SDT: appropriate permutation set for each sibship
C
C If both parents genotyped, then each child can be drawn from 13,14,23,24
C If one or no parents genotyped, but may be reconstructed, then draw
C from mixture of obligate genotypes (those usable to reconstruct the missing
C parents) and 13,14,23,24.
C If cannot unequivocally reconstruct parental genotypes
C draw only from obligate (observed) genotypes among children
C
      subroutine rctdt(wrk,wrk2,trait,locnam,gene,iter,mincnt,gt,
     2             thresh,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     3             numloc, numal,name,cntall,aff,set,x,
     4             mtrans,vtrans,plevel)
C
      integer KNOWN, MAXALL, MAXG, MAXSIZ, MAXLOC, MISS
      double precision EPS
      parameter(EPS=1.0d-6,KNOWN=0, MAXALL=60, 
     2          MAXG=MAXALL*(MAXALL+1)/2,MAXSIZ=1000, 
     3          MAXLOC=120, MISS=-9999)
      integer gene,iter,mincnt,plevel,trait,wrk,wrk2
      real thresh
      logical gt
      character*10 locnam
C  Pedigree structure
      character*10 pedigree
      integer actset,num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ)
      integer sex(MAXSIZ)
      integer numloc
      real locus(MAXSIZ,MAXLOC)
C allele frequencies structure
      integer numal, name(MAXALL)
C array for allele counts in cases and controls
      integer cntall(MAXG,4)
C work arrays for counts and MC iteration
      integer aff(MAXSIZ), set(MAXSIZ,2)
      double precision x(MAXALL),mtrans(MAXALL),vtrans(MAXG)
C local variables
      integer contrib,df,gen2,i,it,j,k,naff,nuntyp,pos,tailp
      integer currf, currm, fin, mg1, mg2, pg1,pg2, nfam, 
     &        parall, ptyped, partyp(4,3)
      logical last
      character*3 histo
      real casden, conden
      double precision asyp, bestz, chisq, obs, 
     &                 mchisq, ochisq, pval, vchisq
C functions
      integer getnam
      logical rctuse
      real isaff
      double precision chip
C
      df=-1
      gen2=gene+1
      nca=0
      nco=0
      nfam=0
      nuntyp=0
      parall=0
      do 1 i=1,4
        partyp(i,1)=0
        partyp(i,2)=0
        partyp(i,3)=0
    1 continue
      do 2 j=1,numal  
        mtrans(j)=0.0d0
        vtrans(j)=0.0d0
        do 2 k=1,3
          cntall(j,k)=0
    2 continue
      mchisq=0.0d0
      vchisq=0.0d0
      if (plevel.gt.1) then
        write(*,'(/a/a)') 
     2    '----- Sibships used for RC-TDT -----',
     3    'Pedigree   Father   Mother   Aff Tot'
      end if

      last=.false.
      rewind(wrk)
    5 continue
        call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &             numloc, last)
        if (last) goto 20

        if (actset.le.0) goto 5
C
C Full sibs
C
        fin=num
        currf=fa(fin)
        currm=mo(fin)
        do 10 k=num-1,nfound,-1
          if (fa(k).ne.currf .or. mo(k).ne.currm) then
            contrib=0
            naff=0
            do 12 i=k+1,fin
            if (locus(i,gene).gt.KNOWN) then
              contrib=contrib+1
              set(contrib,1)=getnam(locus(i,gene),numal,name)
              set(contrib,2)=getnam(locus(i,gen2),numal,name)
              if (locus(i,trait).ne.MISS) then
                aff(contrib)=int(isaff(locus(i,trait),thresh,gt))
                naff=naff+aff(contrib)-1
              else
                nuntyp=nuntyp+1
              end if
            end if
   12       continue
C
C Skip if no usable individuals in this sibship
C
            if (contrib.gt.0 .and. naff.gt.0) then
              ptyped=1
              if (locus(currf,gene).gt.KNOWN) then
                ptyped=ptyped+1
                pg1=getnam(locus(currf,gene),numal,name)
                pg2=getnam(locus(currf,gen2),numal,name)
              else
                pg1=MISS
                pg2=MISS
              end if
              if (locus(currm,gene).gt.KNOWN) then
                ptyped=ptyped+2
                mg1=getnam(locus(currm,gene),numal,name)
                mg2=getnam(locus(currm,gen2),numal,name)
              else
                mg1=MISS
                mg2=MISS
              end if
              partyp(ptyped,1)=partyp(ptyped,1)+1
              call parimp(pg1,pg2,mg1,mg2,contrib,set,parall)
C
C Skip if family uninformative: need at least one heterozygote parent
C and if parental genotypes imputed, either affected and 
C unaffected offspring to permute, or more than two affected
C
              if (rctuse(pg1,pg2,mg1,mg2,ptyped,parall,contrib,naff))
     &        then
                partyp(ptyped,2)=partyp(ptyped,2)+1
                partyp(ptyped,3)=partyp(ptyped,3)+naff
                if (plevel.gt.1) then
                  write(*,'(a,2(1x,a),2(1x,i3))') 
     &              pedigree, id(currf), id(currm), naff, contrib
                end if
                nfam=nfam+1
                do 14 i=1,contrib
                if (aff(i).ne.MISS) then
                  cntall(set(i,1),aff(i))=cntall(set(i,1),aff(i))+1
                  cntall(set(i,2),aff(i))=cntall(set(i,2),aff(i))+1
                end if
   14           continue
                write(wrk2) pg1,pg2,mg1,mg2,contrib,
     &                      (aff(i),set(i,1),set(i,2),i=1,contrib)
              end if
            end if
C Now update to next sibship
            fin=k
            currf=fa(fin)
            currm=mo(fin)
          end if
   10   continue
C mark end of sibships in current pedigree
      goto 5
   20 continue

      do 25 j=1,numal
        nco=nco+cntall(j,1)
        nca=nca+cntall(j,2)
        cntall(j,3)=cntall(j,1)+cntall(j,2)
        if (cntall(j,3).gt.0) df=df+1
   25 continue
C
C MC estimation of mean and variance
C
      it=0
      tailp=0
      if (iter.eq.0 .or. nca.eq.0 .or. nfam.lt.1) then
        asyp=1.0d0
        pval=1.0d0
      else
C
        do 50 it=1,iter
          call rctsim(wrk2,pg1,pg2,mg1,mg2,contrib,aff,set,numal,x)
          call dssp(numal,it,1,x,mtrans,vtrans)
   50   continue
        do 60 j=1, numal*(numal+1)/2
          vtrans(j)=vtrans(j)/dfloat(max(1,it-1))
   60   continue
C
C Sequential P-value simulation
C
        ochisq=0.0d0
        pos=0
        do 65 j=1, numal
          obs=dfloat(cntall(j,2))
          if (mtrans(j).gt.EPS .and. obs.gt.EPS) then
            ochisq=ochisq+obs*log(obs/mtrans(j))
          end if    
   65   continue

        it=0
   69   continue
        if (it.eq.iter .or. tailp.eq.mincnt) goto 70
          it=it+1
          call rctsim(wrk2,pg1,pg2,mg1,mg2,contrib,aff,set,numal,x)
          chisq=0.0d0
          do 75 j=1, numal
          if (mtrans(j).gt.EPS .and. x(j).gt.EPS) then
            chisq=chisq+x(j)*log(x(j)/mtrans(j))
          end if    
   75     continue
          call moment(it,chisq,mchisq,vchisq)

          if (chisq.gt.ochisq .or. (chisq.eq.ochisq .and.
     2        random().gt.0.5))  then
            tailp=tailp+1
          end if
          if (plevel.gt.1) then
            write(*,'(/a,i4,a,f6.1)') 
     &        'Pseudosample ',it,': RC-TDT=',chisq
          end if
          goto 69
   70   continue
        if (tailp.lt.mincnt) then
          tailp=tailp+1
          it=it+1
        end if
        pval=dfloat(tailp)/dfloat(it)
      end if

      vchisq=vchisq/dfloat(max(1,it-1))
      bestz=0.0d0
      pos=0
      do 110 j=1, numal
        pos=pos+j
        if (vtrans(pos).gt.EPS) then
          x(j)=(dfloat(cntall(j,2))-mtrans(j))/sqrt(vtrans(pos))
        else
          x(j)=0.0d0
        end if
        if ((x(j)*x(j)).gt.abs(bestz)) bestz=x(j)*x(j)
  110 continue

      if (plevel.gt.0 .and. nca.eq.0) then
        write(*,'(/3a,3(/a,i6)))') 
     2 ' -------- Combined transmission test for "',locnam,'" --------',
     3    '                    marker(-) =',nuntyp,
     4    '       No. trait(+) marker(+) =',(nca+nco)/2,
     5    '          No. useful sibships =',nfam 
      else if (plevel.gt.0) then
        write(*,'(/3a/a/a)') 
     2 ' -------- Combined transmission test for "',locnam,'" --------',
     3 '   Allele   Affected   Unaffected   Total   E(Aff)    Z    P',
     5 ' -------------------------------------------------------------'
        casden=max(1.0,float(nca))
        conden=max(1.0,float(nco))
        do 30 j=1,numal
          write(*,'(i8,2(2x,i5,1x,a1,f3.2,a1),i7,2(1x,f6.1),1x,f6.4)')
     2     name(j),cntall(j,2),'(',float(cntall(j,2))/casden,')',
     3     cntall(j,1),'(',float(cntall(j,1))/conden,')',cntall(j,3),
     4     mtrans(j), x(j), chip(x(j)*x(j),1)
   30   continue
        write(*,'(a/a8,2(2x,i5,6x),i7)') 
     2 ' -------------------------------------------------------------',
     3      'Total',nca,nco,nca+nco
        write(*,'(3(/a,i6))') 
     2    '                    marker(-) =',nuntyp,
     3    '       No. trait(+) marker(+) =',(nca+nco)/2,
     4    '          No. useful sibships =',nfam 
        write(*,'(a,f6.1/a,i4)')
     2    ' Global association statistic =',ochisq,
     3    '           Degrees of freedom =',max(0,df) 
        write(*,'(a,i4,a,i5,a,f6.4,a/a,f6.1,a,f6.1,a)')
     2    '      Equalled or exceeded by =',tailp,'/',it,
     3    ' simulated values (',pval,')',
     4    ' Mean (Var) simulated chi-sqs =',mchisq,' (',vchisq,')'
        if (plevel.gt.1) then
          write(*,'(/a/a)') 
     2 '  Allele     Tr   E(Tr)  Cov(Tr)',
     3 ' ------- ------ ------- --------------------------------------'
          pos=0
          do 150 j=1, numal
            write(*,'(i8,i7,10(1x,f7.2):)')
     2         name(j),cntall(j,2),mtrans(j),(vtrans(k),k=pos+1,pos+j)
            pos=pos+j
  150     continue
          write(*,'(/a/a,4(/a,3(2x,i7)))') 
     2 '  Parents genotyped   No. Fams  Useable  Aff Off',
     3 ' ------------------   --------  -------  -------',
     4 '  None               ',partyp(1,1),partyp(1,2),partyp(1,3),
     5 '  Father only        ',partyp(2,1),partyp(2,2),partyp(2,3),
     6 '  Mother only        ',partyp(3,1),partyp(3,2),partyp(3,3),
     7 '  Both parents       ',partyp(4,1),partyp(4,2),partyp(4,3) 
        end if
      else if (nca.gt.0 .and. numal.gt.1) then
        asyp=chip(bestz,1)
        asyp=min(1.0d0,(numal-1)*asyp)
        call phist(asyp,pval,histo)
        write(*,'(a10,2(1x,i6),1x,f10.1,2(1x,f6.4),1x,i6,2(1x,a))')
     2    locnam, nca/2, numal, bestz, asyp, asyp,
     3    it, 'RC-TDT   ', histo
        
      end if
      return
      end
C end-of-rctdt   
C
C Make list of possible parental genotypes for this sibship
C
      subroutine parimp(pg1,pg2,mg1,mg2,nsibs,set,parall)

      integer KNOWN, MAXSIZ, MISS
      parameter(KNOWN=0, MAXSIZ=1000, MISS=-9999)

      integer nsibs, mg1,mg2, pg1,pg2, parall, set(MAXSIZ,2)
      integer g(4,2), het, i, p11, p12, p21, p22, tmp
      logical d1,d2,d3,d4

C Both parents genotyped
      if (pg1.gt.KNOWN .and. mg1.gt.KNOWN) then
        parall=4
        return 
      end if
C
C initialize g() with a heterozygote genotype if possible
      het=1
      do 10 i=1, nsibs
      if (set(i,1).ne.set(i,2)) then
        het=i
        goto 11
      end if
   10 continue
   11 continue
      g(1,1)=set(het,1)
      g(1,2)=set(het,2)
C Categorise sibs genotype
C in terms of which allele is shared with starting genotype
      do 3 i=2, 4
        g(i,1)=MISS
        g(i,2)=MISS
    3 continue

      do 30 i=1, nsibs
        d1=(set(i,1).eq.g(1,1))
        d4=(set(i,2).eq.g(1,2))
        if (.not.(d1 .and. d4)) then
          d2=(set(i,1).eq.g(1,2))
          d3=(set(i,2).eq.g(1,1))
          if (d1) then
            g(2,1)=set(i,1)
            g(2,2)=set(i,2)
          else if (d3) then
            g(2,1)=set(i,2)
            g(2,2)=set(i,1)
          else if (d2) then
            g(3,1)=set(i,1)
            g(3,2)=set(i,2)
          else if (d4) then
            g(3,1)=set(i,2)
            g(3,2)=set(i,1)
          else 
            g(4,1)=set(i,1)
            g(4,2)=set(i,2)
          end if
        end if
   30 continue
  
C Fix order of 4th genotype so consistent with others
      if ((g(2,2).ne.MISS .and. g(4,2).ne.g(2,2)) .or.
     &    (g(3,1).ne.MISS .and. g(4,1).ne.g(3,1))) then
        tmp=g(4,2)
        g(4,2)=g(4,1)
        g(4,1)=tmp
      end if
C Produce parental phenosets and compare to any known genotypes
      p11=g(1,1)
      p21=g(1,2)
      p12=MISS
      p22=MISS
      if (g(2,2).ne.MISS) p22=g(2,2)
      if (g(4,2).ne.MISS) p22=g(4,2)
      if (g(3,2).ne.MISS) p12=g(3,2)
      if (g(4,1).ne.MISS) p12=g(4,1)
      call order(p11,p12)
      call order(p21,p22)
      if ((mg1.gt.KNOWN .and. ((mg1.eq.p11 .and. mg2.eq.p12)  .or.
     2    (p21.ne.MISS .and. (mg1.ne.p21 .or. mg2.ne.p22)) .or.
     3    (p21.eq.MISS .and. mg1.ne.p22 .and. mg2.ne.p22)))  .or.
     4    (pg1.gt.KNOWN .and. ((pg1.eq.p21 .and. pg2.eq.p22) .or.
     5    (p11.ne.MISS .and. (pg1.ne.p11 .or. pg2.ne.p12)) .or.
     6    (p11.eq.MISS .and. pg1.ne.p12 .and. pg2.ne.p12)))) then
        call swap(p11,p21)
        call swap(p12,p22)
      end if
C Return observed and imputed genotypes
      if (mg1.le.KNOWN) then
        if (p21.ne.MISS) mg1= -p21
        if (p22.ne.MISS) mg2= -p22
      end if
      if (pg1.le.KNOWN) then
        if (p11.ne.MISS) pg1= -p11
        if (p12.ne.MISS) pg2= -p12
      end if

      parall=0
      if (pg1.ne.MISS) parall=parall+1
      if (pg2.ne.MISS) parall=parall+1
      if (mg1.ne.MISS) parall=parall+1
      if (mg2.ne.MISS) parall=parall+1
      return
      end
C end-of-parimp
C
C Simulate the null distribution of sibship genotypes
C Parental alleles imputed via the children must be transmitted 
C at least once to that sibship
C Furthermore, if two imputed alleles are the same in the two parents,
C then these must be transmitted together to at least one child
C
      subroutine rctperm(pg1,pg2,mg1,mg2,nsibs,set)

      integer KNOWN, MAXSIZ, MISS
      parameter(KNOWN=0, MAXSIZ=1000, MISS=-9999)

      integer nsibs,mg1,mg2,pg1,pg2, set(MAXSIZ,2)
      integer all(2,2),gen(2,2),hom0,homimp,i,imp0,imputd, 
     &        p1(2),p2(2),swap,tmp,tr1,tr2
C functions
      integer irandom, ranall

C Allow restart since rejection sampling to meet conditions

      do 2 i=1, 2
      do 2 j=1, 2
        all(i,j)=0
        gen(i,j)=0
    2 continue
      if (pg1.lt.KNOWN .and. pg1.ne.MISS) all(1,1)=1
      if (pg2.lt.KNOWN .and. pg2.ne.MISS) all(1,2)=1
      if (mg1.lt.KNOWN .and. mg1.ne.MISS) all(2,1)=1
      if (mg2.lt.KNOWN .and. mg2.ne.MISS) all(2,2)=1
      imp0=all(1,1)+all(1,2)+all(2,1)+all(2,2)

      if ((all(1,1)+all(2,1)).eq.2 .and. pg1.eq.mg1) gen(1,1)=1
      if ((all(1,1)+all(2,2)).eq.2 .and. pg1.eq.mg2) gen(1,2)=1
      if ((all(1,2)+all(2,1)).eq.2 .and. pg2.eq.mg1) gen(2,1)=1
      if ((all(1,2)+all(2,2)).eq.2 .and. pg2.eq.mg2) gen(2,2)=1
      hom0=gen(1,1)+gen(1,2)+gen(2,1)+gen(2,2)

    1 continue

      homimp=hom0
      imputd=imp0
      p1(1)=pg1
      p1(2)=pg2
      p2(1)=mg1
      p2(2)=mg2
      all(1,1)=gen(1,1)
      all(1,2)=gen(1,2)
      all(2,1)=gen(2,1)
      all(2,2)=gen(2,2)
      do 10 i=1, nsibs
        tr1=ranall(p1)
        tr2=ranall(p2)
        if (all(tr1,tr2).eq.1) then
          homimp=homimp-1
          all(tr1,tr2)=0
        end if
        call conoff(tr1,p1,imputd,set(i,1))
        call conoff(tr2,p2,imputd,set(i,2))
   10 continue

      if (imputd.gt.0 .or. homimp.gt.0) goto 1
C
C If matching conditions, now permute genotypes within sibship
C
      do 20 i=1,nsibs
        swap=irandom(1,nsibs)
        tmp=set(swap,1)
        set(swap,1)=set(i,1)
        set(i,1)=tmp
        tmp=set(swap,2)
        set(swap,2)=set(i,2)
        set(i,2)=tmp
   20 continue
      do 30 i=1,nsibs
        call order(set(i,1), set(i,2))
   30 continue
      return
      end
C end-of-rctperm
C
C Randomly transmit nonmissing alleles
      integer function ranall(par)
      integer MISS
      parameter(MISS=-9999)
      integer par(2)
C functions
      integer irandom
      if (par(1).ne.MISS .and. par(2).ne.MISS) then
        ranall=irandom(1,2)
      else if (par(2).eq.MISS) then
        ranall=1
      else
        ranall=2
      end if
      return
      end
C end-of-ranall
C 
C Conditional parent-offspring transmission
C Flag whether an imputed parental allele is transmitted 
      subroutine conoff(tr,par,imputd,off)
      integer KNOWN
      parameter (KNOWN=0)
      integer imputd,off,par(2),tr
      
      if (par(tr).lt.KNOWN) then
        imputd=imputd-1
        par(tr)= -par(tr)
      end if
      off=par(tr)
      return
      end
C end-of-condoff
C
C One simulation of entire set of informative nuclear families 
C
      subroutine rctsim(wrk2,pg1,pg2,mg1,mg2,nsibs,aff,set,numal,trans)
      integer MAXALL, MAXSIZ
      parameter(MAXALL=60, MAXSIZ=1000)

      integer mg1,mg2,nsibs,numal,pg1,pg2,wrk2

      integer aff(MAXSIZ), set(MAXSIZ,2)  
      double precision trans(MAXALL)

      integer i,j

      do 5 j=1,numal  
        trans(j)=0.0d0
    5 continue
      rewind(wrk2)
   10 continue
        read(wrk2,end=50) pg1,pg2,mg1,mg2,nsibs,
     &                   (aff(i),set(i,1),set(i,2),i=1,nsibs)
        call rctperm(pg1,pg2,mg1,mg2,nsibs,set)
        do 20 i=1,nsibs
        if (aff(i).eq.2) then
          trans(set(i,1))=trans(set(i,1))+1.0d0
          trans(set(i,2))=trans(set(i,2))+1.0d0
        end if
   20   continue
      goto 10
   50 continue
      return
      end
C end-of-rctsim
C
C test if useful for RC-TDT/FBAT
C
      logical function rctuse(pg1,pg2,mg1,mg2,
     &                        ptyped,parall,contrib,naff)
      integer MISS
      parameter (MISS=-9999)
      integer mg1,mg2,pg1,pg2
      integer contrib,naff,parall,ptyped
      logical h1, h2

      h1=(pg1.ne.MISS .and.abs(pg1).ne.abs(pg2))
      h2=(mg1.ne.MISS .and.abs(mg1).ne.abs(mg2))

      rctuse=.true.
C Both parents homozygous or insufficient parental genotypes
      if (.not.(h1.or.h2) .or.  parall.le.2) then
        rctuse=.false.
        return
C Both parents typed
      else if (ptyped.eq.4) then
        return
C Affected and unaffected children and 3 or 4 identifiable parental alleles
      else if (parall.gt.2 .and. contrib.gt.naff) then
        return
C More than 2 affected children and...
      else if (contrib.gt.2) then
C 4 parental alleles
        if (parall.eq.4) then 
          return
C or 3 parental alleles 12 x 3- or 1- x 23
        else if (h1 .and. abs(pg1).ne.abs(mg2) .and.
     &           abs(pg2).ne.abs(mg2)) then
          return
        else if (h2 .and. abs(mg1).ne.abs(pg2) .and.
     &           abs(mg2).ne.abs(pg2)) then
          return
        end if
      end if
      rctuse=.false.
      return
      end
C end-of-rctuse

C
C Locus structure:
C number of loci, locus name, locus type, and locus position in file
C loctype 1=marker 2=quant 3=affection 4-6=deleted
C
C     integer nloci
C     character*10 loc(MAXLOC)
C     integer loctyp(MAXLOC),locpos(MAXLOC)
C
C position of locus on sex-averaged linkage map
C
C     real map(MAXLOC)
C
C jth name 1=marker
C 
C third fourth first fifth second $m
C   6    7  8   9     10    11    12 13  14 15  16 17  18 19
C
        elseif (keyword.eq.'ord') then
          pos1=0
          pos2=0
          do 302 i=1,MAXLOC
            key1(i)=0
            key2(i)=0
  302     continue
          j=2
   29     continue
            call lister(j,narg,words,nloci,loc,i,last)
          if (.not.last) then
            if (i.lt.0) then
              type=-i
              do 301 i=1,nloci
              if (loctyp(i).eq.type) then
                pos1=pos1+1
                key1(pos1)=i
                pos2=pos2+1
                key2(pos2)=locpos(i)
                if (loctyp(i).eq.1) then
                  pos2=pos2+1
                  key2(pos2)=locpos(i)+1
                end if
              end if
  301         continue
            elseif (loctyp(i).lt.4) then
              pos1=pos1+1
              key1(pos1)=i
              pos2=pos2+1
              key2(pos2)=locpos(i)
              if (loctyp(i).eq.1) then
                pos2=pos2+1
                key2(pos2)=locpos(i)+1
              end if
            end if
            goto 29
          end if
          call newnam(wrknum, wrkfil)
          open(TWRK,file=wrkfil,form='unformatted')
          call order(WRK,TWRK,key1,key2,pedigree,num,nfound,id,fa,mo,
     &           sex,locus,numloc,nloci,loc,loctyp,locpos.map)
          close(WRK,status='delete')
          close(TWRK,status='keep')
          open(WRK,file=wrkfil,form='unformatted')
C
C Reorder loci in pedigree file, locus database
C
      subroutine order(wrk,twrk,ord,pedigree,num,nfound,id,fa,mo,sex,
     &             locus,numloc,nloci,loc,loctyp,locpos.map,plevel)
      integer MAXSIZ,MAXLOC
      parameter (MAXSIZ=1000,MAXLOC=120)
      integer plevel, twrk, wrk
C Pedigree structure
      character*10 pedigree
      integer num,nfound 
      character*8 id(MAXSIZ) 
      integer fa(MAXSIZ),mo(MAXSIZ),sex(MAXSIZ)
      integer numloc
      real locus(MAXSIZ,MAXLOC)
      logical last
C
C Locus structure:
C number of loci, locus name, locus type, and locus position in file
C loctype 1=marker 2=quant 3=affection 4-6=deleted
C
      integer nloci
      character*10 loc(MAXLOC)
      integer loctyp(MAXLOC),locpos(MAXLOC)
C
C position of locus on sex-averaged linkage map
C
      real map(MAXLOC)
C
      integer i

      last=.false.
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,num,nfound,id,fa,mo,sex,locus,numloc,
     &            last)
       if (last) goto 20

       do 30 i=1,num
         
   30  continue
 
       call wrkout(twrk,pedigree,num,nfound,id,fa,mo,sex,
     &             locus,numloc)
      goto 10
   20 continue

      write(*,'(/a,i5/)') 'Number of pedigrees selected=',nped

      return
      end
C end-of-order
C

C
C Evaluate and apply simple expressions either
C
C (1) pure arithmetic, so no effect on pedigree file
C (2) Dry run, so can test if will lead to a legal effect on pedigree file
C         all variables set to MISS
C (3) Pedigree operation -- individual-wise calculation and update
C
C The parser 
C
      subroutine parser(nterm,wtyp,expr,lbp,rbp,op,error)
      integer MAXLOC, MAXCOL, MISS, TOKNUM 
      parameter (MAXLOC=120, MAXCOL=MAXLOC+5, MISS=-9999, TOKNUM=44)

      integer error, nterm
      integer wtyp(MAXCOL)
      double precision expr(MAXCOL)
      integer lbp(0:TOKNUM), rbp(0:TOKNUM), op(0:TOKNUM)

C
C To allow if-then-else, start and end of block for parsing
C
      integer fin, posif, posth, posel, sta
      logical ismis, switch
C
C Main eval loop
C
    1 continue

C
C Read tag of each token and see if compound expression
C
      call findth(nterm,wtyp,posif,posth,posel)
C simple expression
      if (posif.eq.MISS) then
C empty list
        if (nterm.le.0) then
          nterm=1
          wtyp(nterm)=1000
          expr(nterm)=MISS
C evaluate
        else
          sta=1
          fin=nterm
          call simpev(sta,fin,nterm,wtyp,expr,lbp,rbp,op,error)
        end if
C complex expression -- evaluate if clause
      else if ((posth-posif).gt.1) then
        sta=posif+1
        fin=posth-1
        call simpev(sta,fin,nterm,wtyp,expr,lbp,rbp,op,error)
C -- DEBUG
C       write(*,*) 'Condition value: ', wtyp(sta), expr(sta), 
C    &             '==', (int(expr(sta)).ne.0)
C -- DEBUG
C if successfully evaluated
        if (sta.eq.fin .and. .not.ismis(wtyp(sta))) then
          switch=(int(expr(sta)).ne.0)
          call pull(posif,3,fin,nterm,wtyp,expr)
          call findth(nterm,wtyp,posif,posth,posel)
C remove either `else' predicate
          if (switch) then
            if (posel.ne.MISS) then
              sta=posel
              fin=nterm 
              call pull(sta,fin-sta+1,fin,nterm,wtyp,expr)
            end if
C or remove `then' predicate
          else
            if (posel.ne.MISS) then
              sta=1
              fin=posel
              call pull(sta,fin-sta+1,fin,nterm,wtyp,expr)
            else
              nterm=0
            end if
          end if
          goto 1
        else 
          error=1
        end if
C no `then'
      else 
        error=1
      end if
      return
      end
C end-of-parser
C
C The non-compound evaluator
C
      subroutine simpev(sta,fin,nterm,wtyp,expr,lbp,rbp,op,error)
      integer MAXLOC, MAXCOL, MISS, TOKNUM 
      parameter (MAXLOC=120, MAXCOL=MAXLOC+5, MISS=-9999, TOKNUM=44)

      integer error, fin, nterm, sta
      integer wtyp(MAXCOL)
      double precision expr(MAXCOL)
      integer lbp(0:TOKNUM), rbp(0:TOKNUM), op(0:TOKNUM)

      logical change, done, three
      integer adh1, adh2, adh3, adh4, cand1, cand2, cand3,
     &        iter, pos
C functions
      logical isdata, isop
C -- DEBUG
C     logical isenv
C     integer eow
C     parameter (ENVNUM=11)
C     character*6 env(ENVNUM), token(TOKNUM)
C     data token /'(',')','if','then','else','*','/',
C    2     '+','-','^','=','not','and','or','<','>',
C    3     'ge','le','ne','eq','neg','pos','abs','sqrt','log','exp',
C    4     'sin','cos','tan','asin','acos','atan','inht','int','round',
C    5     'istyp','untyp','rand','rnorm','pi','y','n','x','NUM'/
C     data env /'female','male','isfou','isnon',
C    &       'num','nfoun','anytyp','alltyp','numtyp','famnum','index'/
C -- DEBUG
C
C First convert compound operators (==,^=,<=,>=) to equivalent token
C
      pos=fin
   10 continue
        if (wtyp(pos).eq.11 .and. pos.gt.sta) then
          cand2=wtyp(pos-1)
          if (cand2.eq.11 .or. cand2.eq.10 .or.
     &        cand2.eq.15 .or. cand2.eq.16) then
            call compop(pos-1,sta,fin,nterm,wtyp,expr,error)
            pos=pos-1
          end if
        end if
        pos=pos-1
      if (pos.gt.sta) goto 10
C
C Then main eval loop
C
      change=.false.
      iter=0
      pos=sta-1
  100 continue
        iter=iter+1
        call incpos(pos,sta,fin)
        done=.false.
        error=0
C -- DEBUG
C       do kk=sta,fin
C       if (isenv(wtyp(kk))) then
C         write(*,'(a,$)') env(3000-wtyp(kk))(1:eow(env(3000-wtyp(kk))))
C       else if (isop(wtyp(kk))) then
C         write(*,'(a,$)') token(wtyp(kk))(1:eow(token(wtyp(kk))))
C       else if (wtyp(kk).eq.1000) then
C         write(*,'(a,f5.1,a,$)') ' ',expr(kk),' '
C       else if (isdata(wtyp(kk))) then
C         if (expr(kk).eq.MISS) then
C           write(*,'(a,$)') ' {x} '
C         else
C           write(*,'(a,f12.4,a,$)') ' {',expr(kk),'} '
C         end if
C       end if
C       end do
C       write(*,*)
C -- DEBUG
C
C an answer?
        if (sta.eq.fin) then
          if (isdata(wtyp(sta))) then
            done=.true.
          elseif (isop(wtyp(sta)) .and. op(wtyp(pos)).eq.10) then
            call zerop(pos,sta,fin,nterm,wtyp,expr,error)
            done=.true.
          elseif (error.ne.0) then
            done=.true.
          end if
        else 
C
C check next token and its neighbours (lookahead 1 and lookback 1)
C
          cand1=-1
          cand2=wtyp(pos)
          cand3=-1
          adh1=0
          adh2=0
          adh3=0
          adh4=0
          if (isop(cand2)) then
            adh2=lbp(cand2)
            adh3=rbp(cand2)
          end if
          if (pos.gt.sta) then
            cand1=wtyp(pos-1)
            if (isop(cand1)) then
              adh2=rbp(cand1)
            end if
          end if
          if (pos.gt.(sta+1) .and. isop(wtyp(pos-2))) then
            adh1=rbp(wtyp(pos-2))
          end if
          if (pos.lt.fin) then
            cand3=wtyp(pos+1)
            if (isop(cand3)) then
              adh3=lbp(cand3)
            end if
          end if
          if (pos.lt.(fin-1) .and. isop(wtyp(pos+2))) then
            adh4=lbp(wtyp(pos+2))
          end if
C
C Cases:   v v v, v v o, v o o, o v v, o o o     illegal
C          v o v, u o v                          binary operation
C          o v o                                 unary operation, brackets
C          o o v                                 unary
C
          three=((pos-sta).gt.0 .and. (fin-pos).gt.0)
C Zero function operation
          if (isop(cand2) .and. op(cand2).eq.10) then
            call zerop(pos,sta,fin,nterm,wtyp,expr,error)
            pos=pos-1
            change=.true.
C Brackets
          elseif (three .and. cand1.eq.1 .and. .not.isop(cand2) .and. 
     &        cand3.eq.2) then
            expr(pos-1)=expr(pos)
            wtyp(pos-1)=wtyp(pos)
            call pull(pos,2,fin,nterm,wtyp,expr)
            pos=pos-1
            change=.true.
C Unary minus or plus
          else if ((cand1.eq.-1 .or. 
     2       (three .and. isop(cand1) .and. cand1.ne.2)) .and. 
     3       (cand2.eq.8 .or. cand2.eq.9) .and. isdata(cand3)) then
            if (cand2.eq.9) then
              wtyp(pos)=21
            else
              wtyp(pos)=22
            end if
            pos=pos-1
            change=.true.
C Binary operation
          else if (three .and. .not.isop(cand1) .and. 
     2             isop(cand2) .and. .not.isop(cand3) .and.
     3             op(cand2).eq.2 .and.
     4             adh2.ge.adh1 .and. adh3.ge.adh4) then
            call binop(pos,sta,fin,nterm,wtyp,expr,error)
            pos=pos-1
            change=.true.
C Unary operation
          else if (isop(cand2) .and. isdata(cand3) .and.
     &             op(cand2).eq.1 .and. adh3.ge.adh4) then
            call unop(pos,sta,fin,nterm,wtyp,expr,error)
            pos=pos-1
            change=.true.
          end if
          if (error.ne.0) then
            done=.true.
          end if
        end if
C
C test if expression unevaluable: a complete scan without any operations
C
        if (pos.eq.fin) then
          if (change) then
            change=.false.
          else if (.not.done) then
            done=.true.
            error=1
          end if
        end if
 
      if (.not.done .and. iter.lt.5000) goto 100
      return
      end
C end-of-simpev
C
C Is a number, variable or operator
C
      logical function isdata(idx)
      integer idx
      isdata=(idx.ge.1000)
      return
      end
C end-of-isdata
C     logical function isnum(idx)
C     integer idx
C     isnum=(idx.eq.1000)
C     return
C     end
C end-of-isnum
      logical function isenv(idx)
      integer idx
      isenv=(idx.gt.3000 .and. idx.lt.4000)
      return
      end
C end-of-isenv
      logical function isvar(idx)
      integer idx
      isvar=((idx.gt.2000 .and. idx.lt.3000) .or. 
     &       (idx.gt.4000 .and. idx.lt.5000))
      return
      end
C end-of-isvar
      logical function isop(idx)
      integer idx
      isop=(idx.gt.0 .and. idx.lt.1000)
      return
      end
C end-of-isop
      logical function ismis(idx)
      integer idx
      ismis=(idx.ge.4000 .and. idx.lt.5000)
      return
      end
C end-of-ismis
C
C compound operators eg <= >= == ^=
C
      subroutine compop(pos,sta,fin,nterm,wtyp,expr,error)
      integer MAXLOC, MAXCOL, MISS
      parameter (MAXLOC=120, MAXCOL=MAXLOC+5, MISS=-9999) 
      integer error, fin, nterm, pos, sta
      integer wtyp(MAXCOL)
      double precision expr(MAXCOL)

      integer newop, op1, op2

      if (pos.eq.fin) then
        error=1
        return
      end if
      error=0
      op1=wtyp(pos)
      op2=wtyp(pos+1)
      newop=MISS
      if (op2.eq.11) then
        if (op1.eq.11) then
          newop=20
        elseif (op1.eq.15) then
          newop=18
        elseif (op1.eq.16) then
          newop=17
        elseif (op1.eq.10) then
          newop=19
        end if
      else
        error=1
        return
      end if
      wtyp(pos)=newop
      call pull(pos+1,1,fin,nterm,wtyp,expr)
      return
      end
C end-of-compop
C
C zero argument functions 
C
      subroutine zerop(pos,sta,fin,nterm,wtyp,expr,error)
      integer MAXLOC, MAXCOL, MISS
      parameter (MAXLOC=120, MAXCOL=MAXLOC+5, MISS=-9999) 
      integer error, fin, nterm, pos, sta
      integer wtyp(MAXCOL)
      double precision expr(MAXCOL)

      integer curr, restyp
      double precision res

      error=0
      curr=wtyp(pos)
      if (curr.eq.38) then
        res=dble(random())
        restyp=1000
      elseif (curr.eq.39) then
        res=dble(randn())
        restyp=1000
      elseif (curr.eq.40) then
        res=3.141592653590d0
        restyp=1000
      elseif (curr.eq.41) then
        res=1.0d0
        restyp=1000
      elseif (curr.eq.42) then
        res=0.0d0
        restyp=1000
      elseif (curr.eq.43) then
        res=MISS 
        restyp=4000
      elseif (curr.eq.44) then
        res=MISS 
        restyp=5000
      else
        res=MISS 
        restyp=4000
        error=1
      end if
      wtyp(pos)=restyp
      expr(pos)=res
      return
      end
C end-of-zerop
C
C unary operators
C
      subroutine unop(pos,sta,fin,nterm,wtyp,expr,error)
      integer MAXLOC, MAXCOL, MISS
      parameter (MAXLOC=120, MAXCOL=MAXLOC+5, MISS=-9999) 
      integer error, fin, nterm, pos, sta
      integer wtyp(MAXCOL)
      double precision expr(MAXCOL)

      integer curr, restyp
      double precision res, x

      restyp=1000
      res=MISS 
      if (pos.eq.fin) then
        error=1
        return
      end if
      error=0
      x=expr(pos+1)
      curr=wtyp(pos)
      if (wtyp(pos+1).ge.4000) then
        if (curr.eq.36) then
          res=0.0d0
        elseif (curr.eq.37) then
          res=1.0d0
        else
          res=MISS
          restyp=wtyp(pos+1)
        end if
      elseif (curr.eq.12) then
        if (x.eq.0.0d0) then 
          res=1.0d0
        else
          res=0.0d0
        end if
      elseif (curr.eq.24) then
        if (x.ge.0.0d0) then
          res=sqrt(x)
        else
          res=MISS 
          restyp=5000
        end if
      elseif (curr.eq.21) then
        res=-1.0d0*x
      elseif (curr.eq.23) then
        res=abs(x)
      elseif (curr.eq.25) then
        if (x.gt.0.0d0) then
          res=log(x)
        else
          res=MISS 
          restyp=5000
        end if
      elseif (curr.eq.26) then
        res=exp(x)
      elseif (curr.eq.27) then
        res=sin(x)
      elseif (curr.eq.28) then
        res=cos(x)
      elseif (curr.eq.29) then
        res=tan(x)
      elseif (curr.eq.30) then
        res=asin(x)
      elseif (curr.eq.31) then
        res=acos(x)
      elseif (curr.eq.32) then
        res=atan(x)
      elseif (curr.eq.33) then
        res=0.5d0*log((1.0d0+abs(x))/(1.0d0-abs(x)))
      elseif (curr.eq.34) then
        res=int(x)
      elseif (curr.eq.35) then
        res=anint(x)
      elseif (curr.eq.36 .or. curr.eq.37) then
        if (x.gt.0.0d0) then
          res=1.0d0
        else
          res=0.0d0
        end if
        if (curr.eq.37) res=1.0d0-res
      elseif (curr.eq.22) then
        res=x
      else
        restyp=5000
        res=MISS
        error=1
      end if
      wtyp(pos)=restyp
      expr(pos)=res
      call pull(pos+1,1,fin,nterm,wtyp,expr)
      return
      end
C end-of-unop
C
C binary operators
C
      subroutine binop(pos,sta,fin,nterm,wtyp,expr,error)
      integer MAXLOC, MAXCOL, MISS
      parameter (MAXLOC=120, MAXCOL=MAXLOC+5, MISS=-9999) 
      integer error, fin, nterm, pos, sta
      integer wtyp(MAXCOL)
      double precision expr(MAXCOL)

      integer curr, restyp, wx, wy
      double precision result, x, y
C functions
      logical ismis, isvar

      if (pos.eq.sta .or. pos.eq.fin) then
        error=1
        return
      end if

      restyp=1000
      result=MISS 
      error=0
      x=expr(pos-1)
      y=expr(pos+1)
      wx=wtyp(pos-1)
      wy=wtyp(pos+1)
      curr=wtyp(pos)
C
C Generic number NUM: NUM <- NUM op <any>  (used for detecting parse error)
      if ((wtyp(pos-1).eq.5000 .or. wtyp(pos+1).eq.5000)) then
        result=MISS
        restyp=5000
C
C Assignment:  <var> <- MISS  or  <var> <- <const>
C note var wtyp=2000+offset, missing var wtyp=4000+offset
      elseif (curr.eq.11) then
        if (ismis(wy)) then
          result=MISS
          restyp=4000
          if (isvar(wx) .and. .not.ismis(wx)) restyp=wx+2000
        else
          result=y
          restyp=wx
          if (isvar(wx) .and. ismis(wx)) restyp=wx-2000
        end if
C
C Equality or inequality: allows comparison with missing values
      elseif (curr.eq.19 .or. curr.eq.20) then
        if (x.eq.y) then
          result=1.0d0
        else
          result=0.0d0
        end if
        if (curr.eq.19) then
          result=1.0d0-result
        end if
C
C AND and OR allows (lazy) combination with missing values
C (T && x) = x   (T || x) = T    (F && x) = F   (F || x) = x
C
      elseif (curr.eq.13) then
        result=1.0d0
        if (x .eq.0.0d0 .or. y.eq.0.0d0) then
          result=0.0d0
        elseif (ismis(wx) .or. ismis(wy)) then 
          result=MISS
          restyp=4000
        end if
      elseif (curr.eq.14) then
        result=0.0d0
        if (x .eq.1.0d0 .or. y.eq.1.0d0) then
          result=1.0d0
        elseif (ismis(wx) .or. ismis(wy)) then 
          result=MISS
          restyp=4000
        end if
C
C All other operations with missing values lead to MISS as outcome
      elseif (ismis(wx) .or. ismis(wy)) then 
        result=MISS
        restyp=4000
C
C All other operations 
      elseif (curr.eq.6) then
        result=x*y
      elseif (curr.eq.7) then
        if (y.eq.0) then
          expr(pos-1)=MISS
          return
        else
          result=x/y
        end if
      elseif (curr.eq.8) then
        result=x+y
      elseif (curr.eq.9) then
        result=x-y
      elseif (curr.eq.10) then
        result=x**y
      elseif (curr.eq.16) then
        if (x.gt.y) then
          result=1.0d0
        else
          result=0.0d0
        end if
      elseif (curr.eq.15) then
        if (x.lt.y) then
          result=1.0d0
        else
          result=0.0d0
        end if
      elseif (curr.eq.17) then
        if (x.ge.y) then
          result=1.0d0
        else
          result=0.0d0
        end if
      elseif (curr.eq.18) then
        if (x.le.y) then
          result=1.0d0
        else
          result=0.0d0
        end if
      else
        error=1
        return
      end if
      wtyp(pos-1)=restyp
      expr(pos-1)=result
      call pull(pos,2,fin,nterm,wtyp,expr)
      return
      end
C end-of-binop
C
C Evaluate type of each term in expression word(farg...larg) and actn
C actn=0 error  =1 purely arithmetic  =2 legal
C
C Types are:   wtyp                 expr
C              -----------------    --------
C tokens       0    + 0...TOKNUM    -
C constant     1000                 value
C data         2000 + 1...NLOCI    (value)
C env          3000 + 1...ENVNUM   (value)
C              
C MISS         4000                 MISS  
C missing data 4000 + 1...NLOCI     MISS
C NUM          5000                 -   
C
      subroutine typwords(farg,larg,words,nloci,loc,loctyp,token,env,
     &                    wtyp,expr,actn)
      integer ENVNUM, KNOWN, MAXLOC, MAXCOL, MISS, TOKNUM 
      parameter (ENVNUM=11, KNOWN=0, MAXLOC=120, MAXCOL=MAXLOC+5, 
     &           MISS=-9999, TOKNUM=44)
      integer actn, farg, larg
      character*20 words(MAXCOL)
      integer nloci, loctyp(MAXLOC)
      character*10 loc(MAXLOC)
      character*6 env(ENVNUM), token(TOKNUM)
      integer wtyp(MAXCOL)
      double precision expr(MAXCOL)

      integer i, ienv, ilok, itok
C functions
      logical ismiss, isreal
      integer eow, isinenv
      real fval

      actn=1
      do 10 i=farg, larg
        expr(i)=MISS
        ienv=isinenv(words(i),ENVNUM,env)
        itok=isinenv(words(i),TOKNUM,token)
        ilok=isinenv(words(i),nloci,loc)
        if (itok.gt.0) then
          wtyp(i)=itok
        else if (ilok.gt.0) then
          wtyp(i)=2000+ilok
          actn=2
        else if (ienv.gt.0) then
          wtyp(i)=3000+ienv
        else if (ismiss(words(i))) then
          wtyp(i)=4001
        else if (isreal(words(i))) then
          wtyp(i)=1000
          expr(i)=dble(fval(words(i)))
        else
          actn=0
          write(*,'(3a)') 'ERROR: token "',words(i)(1:eow(words(i))),
     &                    '" not recognised.'
          return
        end if
   10 continue
      return
      end
C end-of-typwords
C
C If checking arguments via dry run of parser, 
C replace variable values with (generic) NUM
C
      subroutine dryrun(farg,larg,wtyp)

      integer MAXLOC, MAXCOL
      parameter (MAXLOC=120, MAXCOL=MAXLOC+5) 

      integer farg, larg, wtyp(MAXCOL)
      integer i

      do 10 i=farg, larg
      if (wtyp(i).gt.2000 .and. wtyp(i).lt.3000) then
        wtyp(i)=5000
      end if
   10 continue
      return
      end
C end-of-dryrun
C
C Pull up expr
C
      subroutine pull(pos,dec,fin,nterm,typ,expr)
      integer MAXLOC, MAXCOL
      parameter (MAXLOC=120, MAXCOL=MAXLOC+5) 
      integer dec, fin, nterm, pos
      integer typ(MAXCOL)
      double precision expr(MAXCOL)
      integer i

      do 10 i=pos,nterm-dec
        typ(i)=typ(i+dec)
        expr(i)=expr(i+dec)
   10 continue
      nterm=nterm-dec
      if (fin.ge.pos) fin=fin-dec
      return
      end
C end-of-pull
C
C  See if a string is a missing value
C
      logical function ismiss(string)
      character*(*) string
      ismiss=(string.eq.'x' .or. string.eq.'X' .or. string.eq.'.')
      return
      end
C end-of-ismiss
C
C  See if a string is a valid real number
C
      logical function isreal(string)
      character*20 string
      real v

      if (string.eq.'x' .or. string.eq.'X' .or. string.eq.'.' .or.
     2    string.eq.'y' .or. string.eq.'Y' .or. string.eq.' ' .or.
     3    string.eq.'n' .or. string.eq.'N') then
        isreal=.true.
      else
        read(string,'(f20.0)',err=10) v
        isreal=.true.
      end if 
      return
C error -- word is not a number
   10 continue
        isreal=.false.
      return
      end
C end-of-isreal
C
C Is a bound environmental variable? and if so where?
C
      integer function isinenv(word,nvar,envnam)
      integer nvar
      character*(*) word, envnam(*)

      do 10 isinenv=1, nvar
      if (envnam(isinenv).eq.word) then
        return
      end if
   10 continue
      isinenv=0
      return
      end
C end-of-isinenv
C 
C Is a reserved word
C
C     integer function istoken(word,toknum,token)
C     integer toknum
C     character*(*) word, token(toknum)

C     do 10 istoken=1, toknum
C     if (word.eq.token(istoken)) then
C       return
C     end if
C  10 continue
C     istoken=0
C     return
C     end
C end-of-istoken
C
C Increment counter mod maxpos
C
      subroutine incpos(pos,minpos,maxpos)
      integer maxpos, pos
      if (pos.ge.maxpos) then
        pos=minpos
      else
        pos=pos+1
      end if
      return
      end
C end-of-incpos
C
C Evaluate expression for each pedigree member
C
      subroutine evalped(wrk,twrk,narg,words,nloci,loc,loctyp,locpos,
     2             token,env,lbp,rbp,op,wtyp,expr,pedigree,actset,
     3             num,nfound,id,fa,mo,sex,locus,numloc,plevel)
      integer ENVNUM, MAXLOC, MAXCOL, MAXSIZ, MISS, TOKNUM 
      parameter (ENVNUM=11, MAXLOC=120, MAXCOL=MAXLOC+5, 
     &           MAXSIZ=1000, MISS=-9999, TOKNUM=44)
      integer numloc,narg,plevel,twrk,wrk

      character*20 words(MAXCOL)
      character*6 env(ENVNUM), token(TOKNUM)
      integer lbp(0:TOKNUM), rbp(0:TOKNUM), op(0:TOKNUM)
      integer wtyp(MAXCOL)
      double precision expr(MAXCOL)
C
C Locus structure:
C number of loci, locus name, locus type, and locus position in file
C loctyp 1=marker 2=x-marker 3=quant 4=affection 5-8=deleted
C
      integer nloci
      character*10 loc(MAXLOC)
      integer loctyp(MAXLOC),locpos(MAXLOC)

C Pedigree structure
      character*10 pedigree
      integer actset, num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
      logical last
C
      integer actn, eop, error, i, nchange, 
     &        nev, nerr, nmark, nmiss, nped, nterm, trget, tarpos
      real tmp, x1, x2
C functions
      integer eow
      logical ismis, isvar

      call cntmark(nloci,loctyp,nmark,1)

      last=.false.
      nchange=0
      nerr=0
      nev=0
      nmiss=0
      nped=0
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20
         if (actset.le.0) then
           call wrkout(twrk,pedigree,actset,num,nfound,id,fa,mo,sex,
     &                 locus,numloc)
           goto 10
         end if
C evaluate for each member of pedigree
        nped=nped+1
        eop=eow(pedigree)
        do 15 i=1, num
          nterm=narg
          call typwords(1,nterm,words,nloci,loc,loctyp,token,env,
     &                  wtyp,expr,actn)
C
C init variables in expr with value from locus() or environment
C
          call loadvar(i,1,nmark,nloci,loctyp,locpos,nev,nped,num,
     &                 nfound,sex, locus,1,nterm,wtyp,expr)
          call parser(nterm,wtyp,expr,lbp,rbp,op,error)
C Update pedigree value if appropriate
          if (nterm.eq.1 .and. error.eq.0) then
            if (.not.isvar(wtyp(1))) then
              if (plevel.gt.0) then
                write(*,*) pedigree(1:eow(pedigree)),'-',
     &                     id(i)(1:eow(id(i))),' => ',expr(1)
              end if
            else
              if (ismis(wtyp(1))) then 
                trget=wtyp(1)-4000
              else
                trget=wtyp(1)-2000
                if (expr(1).eq.MISS) expr(1)= -9999.001d0
              end if
              tarpos=locpos(trget)
              x1=sngl(expr(1))
              if (loctyp(trget).eq.4 .and. x1.ne.MISS) then
                if (x1.le.0.0) then
                  x1=1.0
                else
                  x1=2.0
                end if
              end if
              if (locus(i,tarpos).ne.MISS .and. x1.eq.MISS) then
                nmiss=nmiss+1
              end if
              nchange=nchange+1
C If result is a trait, set to new value
              if (loctyp(trget).eq.3 .or. loctyp(trget).eq.4) then
                if (plevel.gt.1) then
                   write(*,'(7a,f12.4,a,f12.4)') 
     2             'Recoded ',pedigree(1:eop),'-',id(i)(1:eow(id(i))),
     3             ' at "',loc(trget), '" from ',
     4             locus(i,tarpos),' to ',x1
                end if
                locus(i,tarpos)=x1
C
C else if result of evaluation is a marker, then repeat evaluation for 
C second allele, using second allele of all markers in expression
C
              else
                if (x1.ne.MISS) then
                  nterm=narg
                  call typwords(1,nterm,words,nloci,loc,loctyp,token,
     &                          env,wtyp,expr,actn)
                  call loadvar(i,2,nmark,nloci,loctyp,locpos,nev,nped,
     &                         num,nfound,sex,locus,1,nterm,wtyp,expr)
                  call parser(nterm,wtyp,expr,lbp,rbp,op,error)
                  x2=sngl(expr(1))
                  if (x2.eq.MISS) x1=MISS
                else
                  x2=MISS
                end if
                if (x1.gt.x2) then
                  tmp=x2
                  x2=x1
                  x1=tmp
                end if
                if (plevel.gt.1) then
                   write(*,'(6a,4(a,f4.0))') 
     2             'Recoded ',pedigree(1:eop),'-',id(i)(1:eow(id(i))),
     3             ' at "',loc(trget), '" from ',
     4             locus(i,tarpos),'/',locus(i,tarpos+1),' to ',
     5             x1,'/',x2
                end if
                locus(i,tarpos)=x1
                locus(i,tarpos+1)=x2
              end if
            end if
          else 
            nerr=nerr+1
            if (plevel.gt.0) then
              write(*,'(5a)') 
     2         'NOTE:  Could not evaluate expression for ',
     3         pedigree(1:eow(pedigree)),'-',id(i),'.'
            end if
          end if
   15   continue
        call wrkout(twrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &              numloc)
        nev=nev+num
      goto 10
   20 continue
      write(*,'(a,i6,a)') 'Recoded ',nchange,' values.'
      if (nmiss.gt.0) then
        write(*,'(a,i6,a)') 'Including ',nmiss,' values to missing.'
      end if
      if (nerr.gt.0) then
        write(*,'(a,i6,a,f5.1,a)') 
     2    'Could not evaluate expression for ',nerr,' records (',
     3    dfloat(100*nerr)/dfloat(nev),'%), which are left unchanged.' 
      end if
      return
      end
C end-of-evalped
C
C Find if/then/else
C
      subroutine findth(nterm,wtyp,posif,posth,posel)
      integer MISS
      parameter (MISS=-9999)
      integer nterm, posel, posif, posth, wtyp(nterm)
      integer i
      posif=MISS
      posth=MISS
      posel=MISS
      do 10 i=1, nterm
        if (wtyp(i).eq.3 .and. posif.eq.MISS) then
          posif=i
        else if (wtyp(i).eq.4 .and. posth.eq.MISS) then
          posth=i
        else if (wtyp(i).eq.5 .and. posel.eq.MISS) then
          posel=i
        end if
   10 continue
      return
      end
C end-of-findth
C
C Load variable values for ith individual
C code y and n as 1 and 0
C load whall'th allele value for a marker
C tot records number of records evaluated to date
C
      subroutine loadvar(idx,whall,nmark,nloci,loctyp,locpos,tot,nped,
     &                   num,nfound, sex,locus,sta,fin,wtyp,expr)
      integer  KNOWN, MAXCOL, MAXLOC, MAXSIZ, MISS
      parameter (KNOWN=0, MAXLOC=120, MAXCOL=MAXLOC+5, 
     &           MAXSIZ=1000, MISS=-9999)
      integer fin, idx, nloci, nmark, nped, sta, tot, whall

      integer wtyp(MAXCOL)
      double precision expr(MAXCOL)
      integer loctyp(MAXLOC),locpos(MAXLOC)

C Pedigree structure
      integer num, nfound
      integer sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)

      integer curr, i, j, iloc
C
C functions
      logical isenv, isvar

      do 10 j=sta,fin
        curr=wtyp(j)
C automatic/environmental variables
        if (isenv(curr)) then
          curr=curr-3000
          expr(j)=MISS
          wtyp(j)=1000
C female male
          if (curr.lt.3) then
            if (sex(idx).eq.MISS) then
              wtyp(j)=4000
            else
              expr(j)=dfloat(abs(sex(idx)-curr))
            end if
C isfou
          elseif (curr.eq.3) then
            expr(j)=0.0d0
            if (idx.le.nfound) expr(j)=1.0d0
C isnon 
          elseif (curr.eq.4) then
            expr(j)=0.0d0
            if (idx.gt.nfound) expr(j)=1.0d0
C num
          elseif (curr.eq.5) then
            expr(j)=dfloat(num)
C nfoun
          elseif (curr.eq.6) then
            expr(j)=dfloat(nfound)
C famnum
          elseif (curr.eq.10) then
            expr(j)=dfloat(nped)
C index
          elseif (curr.eq.11) then
            expr(j)=dfloat(tot+idx)
C anytyp alltyp numtyp 
          else
            iloc=0
            do 50 i=1, nloci
              if (loctyp(i).le.2 .and. locus(idx,locpos(i)).gt.KNOWN)
     &        then
                iloc=iloc+1
              end if
   50       continue
            expr(j)=0.0d0
            if (curr.eq.7) then
              if (iloc.gt.0) expr(j)=1.0d0
            else if (curr.eq.8) then
              if (iloc.eq.nmark) expr(j)=1.0d0
            else if (curr.eq.9) then
              expr(j)=dfloat(iloc)
            end if
          end if
C user defined variables
        elseif (isvar(curr)) then
          curr=curr-2000
          if (loctyp(curr).eq.4 .and. 
     &        locus(idx,locpos(curr)).ge.1) then
            expr(j)=dble(locus(idx,locpos(curr))-1.0)
          elseif (loctyp(curr).le.2 .and. whall.eq.2) then
            expr(j)=dble(locus(idx,locpos(curr)+1))
          else
            expr(j)=dble(locus(idx,locpos(curr)))
          end if
          if (expr(j).eq.MISS) wtyp(j)=4000+curr
        end if
   10 continue
      return
      end
C end-of-loadvar 
C
C Select pedigrees where probands meet a given criterion v2
C
      subroutine select(wrk,twrk,typ,nprob,farg,larg,words,nloci,loc,
     2             loctyp,locpos,token,env,lbp,rbp,op,wtyp,expr,
     3             pedigree,actset,num,nfound,id,fa,mo,sex,locus,numloc,
     4             nobs,plevel)
      integer ENVNUM, MAXLOC, MAXCOL, MAXSIZ, MISS, TOKNUM 
      parameter (ENVNUM=11, MAXLOC=120, MAXCOL=MAXLOC+5, 
     &           MAXSIZ=1000, MISS=-9999, TOKNUM=44)
      integer farg,larg,nobs,nprob,numloc,plevel,twrk,typ,wrk

      character*20 words(MAXCOL)
      character*6 env(ENVNUM), token(TOKNUM)
      integer lbp(0:TOKNUM), rbp(0:TOKNUM), op(0:TOKNUM)
      integer wtyp(MAXCOL)
      double precision expr(MAXCOL)
C
C Locus structure:
C number of loci, locus name, locus type, and locus position in file
C loctyp 1=marker 2=x-marker 3=quant 4=affection 5-8=deleted
C
      integer nloci
      character*10 loc(MAXLOC)
      integer loctyp(MAXLOC),locpos(MAXLOC)

C Pedigree structure
      character*10 pedigree
      integer actset, num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
      logical last
C
C
      integer actn, error, fin, idx, nmark, nped, nuse, sta, tot, uped
      logical useful
C functions
      integer eow

      call prexpr(typ, nprob, farg, larg, words)

      call cntmark(nloci,loctyp,nmark,1)
      nped=0
      uped=0
      nobs=0
      tot=0
      last=.false.
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20
 
       if (actset.gt.0) then
        useful=.false.
        nped=nped+1
        nuse=0
        eop=eow(pedigree)
        do 15 idx=1, num
          sta=farg
          fin=larg 
          nterm=larg
          call typwords(sta,fin,words,nloci,loc,loctyp,token,env,
     &                  wtyp,expr,actn)
C init variables in expr with value from locus() or environment
          call loadvar(idx,1,nmark,nloci,loctyp,locpos,tot,nped,
     &                 num,nfound,sex,locus,sta,fin,wtyp,expr)
          call simpev(sta,fin,nterm,wtyp,expr,lbp,rbp,op,error)
C test if condition true
          if (sta.eq.fin .and. error.eq.0 .and.
     &        expr(sta).ne.MISS .and. expr(sta).ne.0.0d0) then
             nuse=nuse+1
             if (typ.ne.5 .and. nuse .ge. nprob) then
               useful=.true.
               goto 100
             end if
          end if
   15   continue

        if (typ.eq.5 .and. nuse.eq.nprob) useful=.true.

  100   continue
        if (useful) then
          uped=uped+1
          nobs=nobs+num
          if (plevel.gt.1) then
            write(*,'(3a,a8)') 
     2      'Pedigree ',pedigree(1:eow(pedigree)),
     3      ' selected via person ',id(idx)
          end if
        else
          actset=-abs(actset)
        end if
        tot=tot+num
       end if
          call wrkout(twrk,pedigree,actset,num,nfound,id,fa,mo,sex,
     &                locus,numloc)
      goto 10
   20 continue

      write(*,'(/a,i5,a,i5,a/)') 
     &  'Number of pedigrees selected=',uped,' (',nobs,' individuals)'
      return
      end
C end-of-select
C 
C unselect or pack
      subroutine unsel(wrk,twrk,typ,pedigree,actset,num,nfound,
     &             id,fa,mo,sex,locus,numloc,nobs,plevel)
      integer ENVNUM, MAXLOC, MAXCOL, MAXSIZ, MISS, TOKNUM 
      parameter (ENVNUM=11, MAXLOC=120, MAXCOL=MAXLOC+5, 
     &           MAXSIZ=1000, MISS=-9999, TOKNUM=44)
      integer plevel,twrk,typ,wrk
C Pedigree structure
      character*10 pedigree
      integer actset, num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
      logical last

      integer nped, nobs, dped, dobs
C
      nped=0
      nobs=0
      dped=0
      dobs=0
      last=.false.
      rewind(wrk)
      if (typ.eq.1) then
   10   continue
         call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &              numloc, last)
         if (last) goto 20
            nped=nped+1
            nobs=nobs+num
            actset=1
            call wrkout(twrk,pedigree,actset,num,nfound,id,fa,mo,sex,
     &                  locus,numloc)
        goto 10
   20   continue
      else
   30   continue
         call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &              numloc, last)
         if (last) goto 40
          if (actset.gt.0) then  
            nped=nped+1
            nobs=nobs+num
            call wrkout(twrk,pedigree,actset,num,nfound,id,fa,mo,sex,
     &                  locus,numloc)
          else
            if (plevel.gt.1) then
              write(*,'(2a)') 'Deleting pedigree ', pedigree
            end if
            dped=dped+1
            dobs=dobs+num
          end if
        goto 30
   40   continue
      end if
      write(*,'(/a,i5,a,i5,a/)') 
     &  'Number of active pedigrees=',nped,' (',nobs,' individuals)'
      if (dped.gt.0) then
        write(*,'(/a,i5,a,i5,a/)') 
     &  'Permanently deleted ',dped,' pedigrees (',dobs,' individuals)'
      end if
      return
      end
C end-of-unsel
C
C Count or print individuals per pedigree fulfilling criterion
C 
      subroutine docount(wrk,typ,farg,larg,words,nloci,loc,
     2             loctyp,locpos,token,env,lbp,rbp,op,wtyp,expr,
     3             pedigree,actset,num,nfound,id,fa,mo,sex,
     4             locus,numloc,plevel)
      integer ENVNUM,MAXLOC,MAXCOL,MAXSIZ,MISS,TOKNUM 
      parameter (ENVNUM=11, MAXLOC=120, MAXCOL=MAXLOC+5, 
     &           MAXSIZ=1000, MISS=-9999, TOKNUM=44)
      integer farg,larg,numloc,plevel,typ,wrk

      character*20 words(MAXCOL)
      character*6 env(ENVNUM), token(TOKNUM)
      integer lbp(0:TOKNUM), rbp(0:TOKNUM), op(0:TOKNUM)
      integer wtyp(MAXCOL)
      double precision expr(MAXCOL)
C
C Locus structure:
C number of loci, locus name, locus type, and locus position in file
C loctyp 1=marker 2=x-marker 3=quant 4=affection 5-8=deleted
C
      integer nloci
      character*10 loc(MAXLOC)
      integer loctyp(MAXLOC),locpos(MAXLOC)

C Pedigree structure
      character*10 pedigree
      integer actset, num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
      logical last
C Local variables
      integer actn,arg1,argn,currf,currm,contrib,error,fin,idx,k,nmark
      integer naff,nped,nasp,nast,nasq,nuse,taff,tasp,tast,tasq,tot

      call prexpr(typ, 1, farg, larg, words)

      if (typ.eq.1) then
        write(*,'(a/a)') 'Pedigree   Con=T   Num  ASPs Trios    4+',
     &                   '---------- ----- ----- ----- ----- -----'
      end if
      call cntmark(nloci,loctyp,nmark,1)
      nped=0
      nuse=0
      taff=0
      tasp=0
      tast=0
      tasq=0
      tot=0
      last=.false.
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20
 
       if (actset.le.0) goto 10

        naff=0
        nasp=0
        nast=0
        nasq=0

        nped=nped+1
C founders
        do 95 idx=1,nfound
          arg1=farg
          argn=larg 
          nterm=larg
          call typwords(arg1,argn,words,nloci,loc,loctyp,token,env,
     &           wtyp,expr,actn)
          call loadvar(idx,1,nmark,nloci,loctyp,locpos,tot,nped,
     &                 num,nfound,sex, locus,arg1,argn,wtyp,expr)
          call simpev(arg1,argn,nterm,wtyp,expr,lbp,rbp,op,error)
          if (arg1.eq.argn .and. error.eq.0 .and.
     &         expr(arg1).ne.MISS .and. expr(arg1).ne.0.0d0) then
            naff=naff+1
            if (typ.eq.2) then
              call wrind(idx,pedigree,id,fa,mo,sex,
     &                   locus,nloci,loc,loctyp,locpos)
            end if
          end if
   95   continue
C nonfounders
        fin=num
        currf=fa(num)
        currm=mo(num)
        do 90 k=num-1,nfound,-1
          if (fa(k).ne.currf .or. mo(k).ne.currm) then
            nfam=nfam+1
            contrib=0
            do 92 idx=k+1,fin
              arg1=farg
              argn=larg 
              nterm=larg
              call typwords(arg1,argn,words,nloci,loc,loctyp,token,env,
     &               wtyp,expr,actn)
C init variables in expr with value from locus() or environment
              call loadvar(idx,1,nmark,nloci,loctyp,locpos,tot,nped,
     &               num,nfound,sex,locus,arg1,argn,wtyp,expr)
              call simpev(arg1,argn,nterm,wtyp,expr,lbp,rbp,op,error)
C test if condition true
              if (arg1.eq.argn .and. error.eq.0 .and.
     &         expr(arg1).ne.MISS .and. expr(arg1).ne.0.0d0) then
                naff=naff+1
                contrib=contrib+1
                if (typ.eq.2) then
                  call wrind(idx,pedigree,id,fa,mo,sex,
     &                       locus,nloci,loc,loctyp,locpos)
                end if
              end if
   92       continue
C Now update to next sibship
            if (contrib.eq.2) then
              nasp=nasp+1
            else if (contrib.eq.3) then
              nast=nast+1
            else if (contrib.gt.3) then
              nasq=nasq+1
            end if
            fin=k
            currf=fa(fin)
            currm=mo(fin)
          end if
   90   continue
        if (typ.eq.1 .and. plevel.ge.0 .and. naff.gt.0) then
          write(*,'(a,5(1x,i5))') pedigree, naff, num, nasp, nast, nasq
        end if
        taff=taff+naff
        tasp=tasp+nasp
        tast=tast+nast
        tasq=tasq+nasq
        tot=tot+num
        if (naff.gt.0) then
          nuse=nuse+1
        end if
      goto 10
   20 continue
      if (typ.eq.1) then
        write(*,'(a10,5(1x,i5))') 
     &    'Total     ',taff, tot, tasp, tast, tasq 
      end if
      write(*,'(/2(/a,i5,a,i5,a,f5.1,a))') 
     2  'Number of matched persons   =',taff,' out of ',tot,
     3   ' (',100.0d0*dfloat(taff)/dfloat(tot),'%)',
     4  'Number of matched pedigrees =',nuse,' out of ', nped,
     5   ' (',100.0d0*dfloat(nuse)/dfloat(nped),'%)' 
      return
      end
C end-of-docount 
C
C Delete data for individuals fulfilling criterion
C 
      subroutine seldel(wrk,twrk,nord,ord,farg,larg,words,nloci,loc,
     2             loctyp,locpos,token,env,lbp,rbp,op,wtyp,expr,
     3             pedigree,actset,num,nfound,id,fa,mo,sex,
     4             locus,numloc,plevel)
      integer ENVNUM,KNOWN,MAXLOC,MAXCOL,MAXSIZ,MISS,TOKNUM 
      parameter (ENVNUM=11, KNOWN=0, MAXLOC=120, MAXCOL=MAXLOC+5, 
     &           MAXSIZ=1000, MISS=-9999, TOKNUM=44)
      integer farg,larg,numloc,plevel,twrk,wrk
      integer nord, ord(MAXSIZ)

      character*20 words(MAXCOL)
      character*6 env(ENVNUM), token(TOKNUM)
      integer lbp(0:TOKNUM), rbp(0:TOKNUM), op(0:TOKNUM)
      integer wtyp(MAXCOL)
      double precision expr(MAXCOL)
C
C Locus structure:
C number of loci, locus name, locus type, and locus position in file
C loctyp 1=marker 2=x-marker 3=quant 4=affection 5-8=deleted
C
      integer nloci
      character*10 loc(MAXLOC)
      integer loctyp(MAXLOC),locpos(MAXLOC)

C Pedigree structure
      character*10 pedigree
      integer actset, num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
      logical last
C Local variables
      integer actn,arg1,argn,error,idx,k,nmark
      integer ndel,nped,tot
C functions
      integer eow

      call prexpr(6, nord, farg, larg, words)

      ndel=0
      nped=0
      tot=0
      last=.false.
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20
 
       if (actset.gt.0) then
         nped=nped+1
         do 95 idx=1,num
           arg1=farg
           argn=larg 
           nterm=larg
           call typwords(arg1,argn,words,nloci,loc,loctyp,token,env,
     &            wtyp,expr,actn)
           call loadvar(idx,1,nmark,nloci,loctyp,locpos,tot,nped,
     &                  num,nfound,sex, locus,arg1,argn,wtyp,expr)
           call simpev(arg1,argn,nterm,wtyp,expr,lbp,rbp,op,error)
           if (arg1.eq.argn .and. error.eq.0 .and.
     &          expr(arg1).ne.MISS .and. expr(arg1).ne.0.0d0) then
             ndel=ndel+1
             if (plevel.gt.1) then
               write(*,'(4a)') 
     &           'Deleting ', pedigree(1:eow(pedigree)), '-', id
             end if
             do 50 j=1, nord
               k=ord(j)
               pos=locpos(k)
               if ((loctyp(k).eq.1 .or. loctyp(k).eq.2) .and.
     &             locus(idx,pos).ge.KNOWN) then
                 locus(idx,pos)=-locus(idx,pos)
                 locus(idx,pos+1)=-locus(idx,pos+1)
               else if (loctyp(k).eq.3 .or. loctyp(k).eq.4) then
                 locus(idx,pos)=MISS
               end if
   50        continue
           end if
   95    continue
         tot=tot+num
       end if
        call wrkout(twrk,pedigree,actset,num,nfound,id,fa,mo,sex,
     &              locus,numloc)
      goto 10
   20 continue
      write(*,'(/2(/a,i5,a,i5,a,f5.1,a))') 
     2  'Number of deleted records   =',ndel,' out of ',tot,
     3   ' (',100.0d0*dfloat(ndel)/dfloat(tot),'%)' 
      return
      end
C end-of-seldel  
C
C
C Echo action to be performed
C
      subroutine prexpr(typ, nprob, farg, larg, words)
      integer MAXLOC,MAXCOL
      parameter (MAXLOC=120, MAXCOL=MAXLOC+5) 

      integer farg,larg,nprob,typ

      character*20 words(MAXCOL)
C Local variables
      integer k
C functions
      integer eow

      if (typ.eq.1) then
        write(*,'(/2a,$)') 
     &    'Count where "', words(farg)(1:eow(words(farg)))
      else if (typ.eq.2) then
        write(*,'(/2a,$)') 
     &    'Print where "', words(farg)(1:eow(words(farg)))
      else if (typ.eq.3) then
        write(*,'(/2a,$)') 
     &    'Selecting pedigrees where "', words(farg)(1:eow(words(farg)))
      else if (typ.eq.4) then
        write(*,'(/a,i3,2a,$)') 
     2    'Selecting pedigrees to contain ',nprob, 
     3    ' or more individuals where "',words(farg)(1:eow(words(farg)))
      else if (typ.eq.5) then
        write(*,'(/a,i3,2a,$)') 
     2  'Selecting pedigrees to contain exactly ',
     3  nprob,' individuals where "', words(farg)(1:eow(words(farg)))
      else if (typ.eq.6) then
        write(*,'(/a,i3,2a,$)') 
     2    'Zeroing ',nprob,' variables in each record where "', 
     3    words(farg)(1:eow(words(farg)))
      end if
      do 1 k=farg+1, larg
        write(*,'(1x,a,$)') words(k)(1:eow(words(k)))
    1 continue
      write(*,'(a/)') '":'
      return
      end
C end-of-prexpr

C
C check for simple inconsistencies between child and parent
C if requested, delete any problem genotypes (up to and including
C all genotypes for a nuclear family)
C
C error                                     action if droperr
C ----------------------------------------  ----------------------------
C 11=single parent-offspring inconsistency  delete child genotype
C 12=Multiple p-o inconsistencies           delete all nuclear fam genos
C 13=Inconsistencies between siblings       delete all nuclear fam genos
C 14=More than 4 alleles segregating        delete all nuclear fam genos
C
C
      subroutine check(pedigree,num,nfound,id,fa,mo,sex,locus,
     2                 nloci,loc,loctyp,locpos,set,xmale,
     3                 droperr,ndiscard,inconsist,plevel)
      integer KNOWN,MAXLOC,MAXSIZ,MISS
      parameter (KNOWN=0,MAXLOC=120,MAXSIZ=1000,MISS=-9999)
      integer droperr, inconsist, ndiscard, plevel
C Pedigree structure
      character*10 pedigree
      integer num,nfound 
      character*8 id(MAXSIZ) 
      integer fa(MAXSIZ),mo(MAXSIZ),sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C
      integer nloci
      character*10 loc(MAXLOC)
      integer loctyp(MAXLOC),locpos(MAXLOC)
C
C count of segregating alleles
      integer nall, allele(5)
C sibship genotypes
      integer set(MAXSIZ,2)
      logical xmale(MAXSIZ)
C other local variables
      integer c1,c2,currf,currm,eop,gene,gen2,i,j,
     &        nkids, p11,p12,p21,p22,sta
      integer bad1, bad2, badchild, errtyp
      integer ptyped
      logical err, thiserr, xlinkd
      character*7 gtp
C functions
      integer eow, parcon
      logical opcon
C
      eop=eow(pedigree)
      do 10 j=1,nloci
      if (loctyp(j).le.2) then 
        xlinkd=(loctyp(j).eq.2)
        badchild=MISS
        gene=locpos(j)
        gen2=gene+1
        nkids=0
        ptyped=0
        currf=MISS
        currm=MISS
C
C Check for male X-linked heterozygotes
        if (xlinkd) then
          err=.false.
          do 15 i=1, num
          if (sex(i).eq.1 .and. locus(i,gene).gt.KNOWN .and.
     &        locus(i,gene).ne.locus(i, gen2)) then
            call wrgtp(int(locus(i,gene)), int(locus(i,gen2)),gtp,1)
            write(*,'(/9a/)') 'ERROR: Heterozygous male ',
     2        pedigree(1:eop),'-',id(i)(1:eow(id(i))),
     3        ' at X-linked locus ',loc(j),' {',gtp,'}'
            if (droperr.gt.0) then
              locus(i,gene)=MISS
              locus(i,gen2)=MISS
            else
              err=.true.
              inconsist=inconsist+1
            end if
          end if
   15     continue
          if (err) return
        end if
C
C Check each nuclear family
C
        err=.false.
        do 20 i=nfound+1,num
C Print results of last sibship and do parents of current sibship
          if (fa(i).ne.currf .or. mo(i).ne.currm) then
            if (err) then
              if (nall.gt.4) errtyp=14
C Temporarily put back deleted genotype if errtyp=11
              if (badchild.ne.MISS) then
                locus(badchild,gene)=float(bad1)
                locus(badchild,gen2)=float(bad2)
              end if
C
C print only the list of genotypes for the family if verbosity low
C otherwise a pedigree drawing
C
              call famerr(loc(j),gene,pedigree,id,fa,mo,sex,locus,
     &                  currf,currm,badchild,sta,i-1,errtyp,plevel)
C
C And delete genotype if errtyp=11 or family if errtyp>11
              if (droperr.gt.0 .and. errtyp.ge.11) then
                call remfam(currf,currm,sta,i-1,gene,locus,ndiscard)
              end if
              err=.false.
            end if 
C initialize current sibship
            errtyp=0
            badchild=MISS
            sta=i
            nkids=0
            currf=fa(i)
            currm=mo(i)
            p11=int(locus(currf,gene))
            p12=int(locus(currf,gen2))
            p21=int(locus(currm,gene))
            p22=int(locus(currm,gen2))
            nall=0
            ptyped=0
            if (p11.gt.KNOWN) then
              ptyped=ptyped+1
              call addall(p11,nall,allele)
              call addall(p12,nall,allele)
            end if
            if (p21.gt.KNOWN) then
              ptyped=ptyped+2
              call addall(p21,nall,allele)
              call addall(p22,nall,allele)
            end if
          end if
C
C do current child if typed
C
          if (locus(i,gene).gt.KNOWN) then
            thiserr=.false.
            c1=int(locus(i,gene))
            c2=int(locus(i,gen2))
            nkids=nkids+1
            xmale(nkids)=(xlinkd .and. sex(i).eq.1)
            set(nkids,1)=c1
            set(nkids,2)=c2
C
C test for simple parent-offspring inconsistency
C if single error, try deleting just child
C
            if ((ptyped.eq.3 .and.
     2        parcon(c1,c2,p11,p12,p21,p22,xmale(nkids)).eq.0) .or.
     3        (ptyped.eq.1 .and. .not.xmale(nkids) .and. 
     4                           .not.opcon(c1,c2,p11,p12)) .or.
     5        (ptyped.eq.2 .and. .not.opcon(c1,c2,p21,p22))) then
              thiserr=.true.
              if (errtyp.eq.0) then
                errtyp=11
                badchild=i
                bad1=c1
                bad2=c2
                locus(i,gene)=MISS
                locus(i,gen2)=MISS
              elseif (errtyp.eq.11) then
                errtyp=12
              end if
C or too many alleles segregating in sibship
            else
              call addall(c1,nall,allele)
              call addall(c2,nall,allele)
              if (nall.gt.4 .or. (xlinkd .and. nall.gt.3)) then
                thiserr=.true.
                errtyp=14
C else test for more complex errors
              elseif (.not.err .and. ptyped.ne.3 .and. nkids.gt.1) 
     &        then
                call nuchek(xlinkd,ptyped,p11,p12,p21,p22,
     &                 nkids,set,xmale,nall,allele,thiserr)
                errtyp=13
              end if
            end if
C If an error, note the responsible child
            if (thiserr) then
              err=.true.
              if (droperr.eq.0) inconsist=inconsist+1
              call wrgtp(c1,c2,gtp,1)
              write(*,'(/9a/)') 'NOTE:  Inconsistency due child ',
     2          pedigree(1:eop),'-',id(i)(1:eow(id(i))),
     3          ' at locus ',loc(j),' {',gtp,'}'
            end if
          end if
   20   continue
C
C Last sibship 
C
        if (err) then
          if (nall.gt.4) errtyp=14
          if (badchild.ne.MISS) then
            locus(badchild,gene)=float(bad1)
            locus(badchild,gen2)=float(bad2)
          end if
          call famerr(loc(j),gene,pedigree,id,fa,mo,sex,locus,
     &                currf,currm,badchild,sta,i-1,errtyp,plevel)
          if (droperr.gt.0 .and. errtyp.ge.11) then
            call remfam(currf,currm,sta,i-1,gene,locus,ndiscard)
          end if
        end if 
      end if
   10 continue
      return
      end
C end-of-check
C
C identify parental alleles in nuclear family
C
      subroutine addall(iall,nall,allele)
      integer iall
      integer nall, allele(5)
      integer i
C find a match      
      do 10 i=1,nall
      if (iall.eq.allele(i)) then
        return
      end if
   10 continue
C else create new allele entry
      nall=nall+1
      if (nall.le.4) allele(nall)=iall
      return
      end
C end-of-addall
C
C nuclear family consistency check (untyped parents)
C
      subroutine nuchek(xlinkd,ptyped,p11,p12,p21,p22,
     &                  nkids,set,xmale,nall,allele,thiserr)
      integer KNOWN, MAXALL, MAXSIZ, MAXLOC, MISS
      parameter(KNOWN=0, MAXALL=60, MAXSIZ=1000,  
     &          MAXLOC=120, MISS=-9999)
      integer p11, p12, p21, p22, ptyped
      logical thiserr, xlinkd
C Pedigree structure
      integer nkids
      integer set(MAXSIZ,2)  
      logical xmale(MAXSIZ)
C
C count of segregating alleles, and frequency
      integer nall, allele(5)
C other local variables
      integer g1,g2,g3,g4
      integer i,mg1,mg2,pg1,pg2
      integer i1,i2,t1,t2
C functions
      integer parcon, whall
C
C While loop to list all possible genotypes
C initialize genotype indices
C
      if (ptyped.eq.1) then
        t1=1
        i1=1
        g1=whall(p11,nall,allele)
        g2=whall(p12,nall,allele)
      else
        t1=nall*(nall+1)/2
        i1=0
        g1=1
        g2=0
      end if
      if (ptyped.eq.2) then
        t2=1
        i2=1
        g3=whall(p21,nall,allele)
        g4=whall(p22,nall,allele)
      else
        t2=nall*(nall+1)/2
        i2=t2
        g3=1
        g4=0
      end if
C
C simulated nested do-loops
C check if inner loop completed once
C
      thiserr=.true.
  100 continue
        if (i2.eq.t2) then
          call couple(i1,t1,nall,g1,g2)
          pg1=allele(g1)
          pg2=allele(g2)
          if (xlinkd) pg2=pg1
          if (t2.gt.1) i2=0
        end if
        call couple(i2,t2,nall,g3,g4)
        mg1=allele(g3)
        mg2=allele(g4)
C       write(*,*) 'fa: ',pg1,'/',pg2,' ', mg1,'/', mg2
        do 10 i=1, nkids
C         write(*,*) 'Child ',i,' ',set(i,1),'/',set(i,2),' parcon=',
C    &      parcon(set(i,1),set(i,2),pg1,pg2,mg1,mg2,xmale(i))
        if (parcon(set(i,1),set(i,2),pg1,pg2,mg1,mg2,xmale(i)).eq.0) 
     &  then
          goto 55
        end if
   10   continue
C else (if consistent) return good news
          thiserr=.false.
          return
   55   continue
C end of while loop
      if (i1.ne.t1 .or. i2.ne.t2) goto 100
      return
      end
C end-of-nuchek
C
C Write out nuclear family error
C
      subroutine famerr(locnam,gene,pedigree,id,fa,mo,sex,locus,
     &                  currf,currm,badchild,sta,fin,errtyp,plevel)
      integer MAXSIZ, MAXLOC, MISS
      parameter(MAXSIZ=1000, MAXLOC=120, MISS=-9999)

      integer badchild,currf,currm,errtyp,fin,gene,plevel,sta

      character*10 locnam
      character*10 pedigree
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
      integer i, eop, gen2  
C
C functions
      integer eow
C
      eop=eow(pedigree)
      gen2=gene+1

      if (plevel.ge.0) then
        call describe(locnam,gene,pedigree,id,fa,mo,sex,locus,
     &                currf,currm,sta,fin,errtyp)
      else
        call inderr(pedigree, eop, id(currf), locnam, 
     &            int(locus(currf,gene)),int(locus(currf,gen2)))
        call inderr(pedigree, eop, id(currm), locnam, 
     &            int(locus(currm,gene)),int(locus(currm,gen2)))
        if (badchild.ne.MISS) then
           call inderr(pedigree, eop, id(badchild), locnam, 
     &            int(locus(badchild,gene)),int(locus(badchild,gen2)))
        else
          do 5 i=sta,fin
            call inderr(pedigree, eop, id(i), locnam, 
     &             int(locus(i,gene)),int(locus(i,gen2)))
    5     continue
        end if
      end if
      return
      end
C end-of-famerr
C
C write genotype for an individual flagged as a Mendelian error
C
      subroutine inderr(pedigree, eop, cid, locnam, all1, all2)
      integer MISS
      parameter (MISS=-9999)
      integer all1, all2, eop
      character*10 pedigree
      character*10 locnam
      character*8 cid
      character*7 gtp
C
      if (all1.eq.MISS) return

      call wrgtp(all1, all2, gtp,1)
      write(*,'(3a,1x,a,1x,2a)') pedigree(1:eop),'-',cid,
     &      locnam, gtp, ' Possible Mendelian error'
      return
      end
C end-of-inderr
C
C Drop a genotype from data if causing inconsistency
C
      subroutine remove(idx,gene,locus,ndiscard)

      integer KNOWN,MAXLOC,MAXSIZ,MISS
      parameter (KNOWN=0,MAXLOC=120,MAXSIZ=1000,MISS=-9999)
      integer gene, idx, ndiscard
      real locus(MAXSIZ,MAXLOC)
C
      if (locus(idx,gene).gt.KNOWN) then
        ndiscard=ndiscard+1
        locus(idx,gene)=MISS
        locus(idx,gene+1)=MISS
      end if
      return
      end
C end-of-remove
C
C drop a nuclear family's genotypes
C
      subroutine remfam(currf,currm,sta,fin,gene,locus,ndiscard)

      integer MAXLOC,MAXSIZ
      parameter (MAXLOC=120,MAXSIZ=1000)
      integer currf, currm, fin, gene, ndiscard, sta
      real locus(MAXSIZ,MAXLOC)

      integer i

      call remove(currf,gene,locus,ndiscard)
      call remove(currm,gene,locus,ndiscard)
      do 10 i=sta,fin
        call remove(i,gene,locus,ndiscard)
   10 continue
      return 
      end
C end-of-remfam
C
C set an entire family's genotypes to uninformative
C
      subroutine setall(gene,num,locus,val)
      integer MAXLOC,MAXSIZ
      parameter (MAXLOC=120,MAXSIZ=1000)
      integer gene
      real val, locus(MAXSIZ,MAXLOC)

      integer gen2, i
      
      gen2=gene+1
      do 10 i=1, num
        locus(i,gene)= val
        locus(i,gen2)= val
   10 continue
      return 
      end
C end-of-remall
C
C If Lange-Goradia algorithm not used, initialize genotypes for random walk
C algorithms via a conditional gene dropping algorithm
C
      subroutine start(locnam,xlinkd,gene,pedigree,num,nfound,
     2                 id,fa,mo,sex,locus,numal,name,cumfrq,
     3                 set,sibd,key,inconsist,plevel)
      integer MAXLOC, MAXSIZ, MISS, MAXALL
      parameter(MAXLOC=120, MAXSIZ=1000, MISS=-9999, MAXALL=60)
      integer gene, inconsist, plevel
C
C  Pedigree structure
      character*10 pedigree
      integer num,nfound 
      character*8 id(MAXSIZ) 
      integer fa(MAXSIZ),mo(MAXSIZ),sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C allele frequencies structure
      character*10 locnam
      logical xlinkd
      integer numal, name(MAXALL)
      double precision cumfrq(MAXALL)
      integer set(MAXSIZ,2), key(2*MAXSIZ), sibd(MAXSIZ,2)
C local variables
      integer found, g1, g2, gen2, i, failid, maxtry, restart
      logical fin
C functions
      integer eow, getnam


      found=0
      gen2=gene+1
      failid=MISS
      maxtry=5000
      do 5 i=1, num
        if (locus(i,gene).lt.0) then
          g1=MISS
          g2=MISS
        else
          g1=getnam(locus(i,gene),numal,name)
          g2=getnam(locus(i,gen2),numal,name)
        end if
        call update(i,g1,g2,set)
    5 continue
      do 10 i=1,nfound
        found=found+1
        sibd(i,1)=found
        found=found+1
        sibd(i,2)=found
   10 continue
C
C start of loop -- terminated by either a successful simulation
C of ibd, or bailout due <maxtry> iterations without success
C
      restart=0
   40 continue
        found=0
        do 45 i=1,nfound
          found=found+1
          key(found)=set(i,1)
          found=found+1
          key(found)=set(i,2)
   45   continue
        do 46 i=nfound+1,num
          sibd(i,1)=MISS
          sibd(i,2)=MISS
   46   continue

   50   continue
          fin=.true.
          do 70 i=nfound+1,num
          if (sibd(i,1).eq.MISS) then
            if (sibd(fa(i),1).ne.MISS .and. sibd(mo(i),1).ne.MISS) then
              call genof3(i,fa(i),mo(i),set,sibd,key,failid)
              if (failid.ne.MISS) then
                if (restart.lt.maxtry) then
                  restart=restart+1
                  if (plevel.gt.1) 
     2              write(*,*) 'Restart ',restart,' due to person ',
     3                id(failid),set(i,1),set(i,2)
                  goto 40
                else
                  write(*,'(4a/7x,3a,3(/7x,a)/)') 
     2    'ERROR: Unable to generate starting genotypes at locus ',
     3    locnam(1:eow(locnam)),' for pedigree ', pedigree,
     4    'due to parent(s) of person ',id(failid)(1:eow(id(failid))),
     5    '.','This is either due to a Mendelian inconsistency, ',
     6    'or because the pedigree is very large,',
     7    'in which case it may disappear if the job is rerun.'

                  inconsist=inconsist+1
                  return
                end if
              end if
            else
              fin=.false.
            end if
          end if
   70     continue
      if (.not.fin) goto 50
C
      call fillin(num,nfound,set,sibd,key,name,cumfrq,gene,locus)
      return
      end
C end-of-start
C
C  Drop ibd-alleles conditional on observed markers
C  and randomly where marker genotype not observed -- restart
C  if later generates inconsistency
C 
      subroutine genof3(idx,fa,mo,set,sibd,key,failid)
      integer MAXSIZ, MISS
      parameter(MAXSIZ=1000, MISS=-9999)
      integer idx,fa,mo,failid
      integer set(MAXSIZ,2),sibd(MAXSIZ,2),key(2*MAXSIZ)
      integer a1,a2,first,maxtrials,second,tr1,tr2,trials
C sample without replacement from {{1,2},{1,2},{1,2}}
      integer choice, seed, space(8)
C functions
      integer irandom
C
      failid=MISS
      maxtrials=8
      trials=0
      do 10 i=1,maxtrials
        space(i)=i
   10 continue

    1 continue

      trials=trials+1
      choice=irandom(trials, maxtrials)
      seed=space(choice)
      space(choice)=space(trials)

#ifdef F2C
      tr1=and(seed,4)/4+1
      tr2=and(seed,2)/2+1
      first=and(seed,1)+1
#endif F2C
#ifdef HPUX
      tr1=iand(seed,4)/4+1
      tr2=iand(seed,2)/2+1
      first=iand(seed,1)+1
#endif HPUX
#ifdef DEC
      tr1=iand(seed,4)/4+1
      tr2=iand(seed,2)/2+1
      first=iand(seed,1)+1
#endif DEC
#ifdef SUN
      tr1=and(seed,4)/4+1
      tr2=and(seed,2)/2+1
      first=and(seed,1)+1
#endif SUN

      second=3-first
      a1=sibd(fa,tr1)
      a2=sibd(mo,tr2)

      if (set(idx,1).eq.MISS) then
        sibd(idx,1)=a1
        sibd(idx,2)=a2
      elseif (key(a1).eq.MISS .and. key(a2).eq.MISS) then
        key(a1)=set(idx,first)
        key(a2)=set(idx,second)
        sibd(idx,1)=a1
        sibd(idx,2)=a2
      elseif (key(a1).eq.MISS .and. (set(idx,1).eq.key(a2) .or.
     &        set(idx,2).eq.key(a2))) then
        if (set(idx,1).eq.key(a2)) then
          key(a1)=set(idx,2)
          sibd(idx,1)=a2
          sibd(idx,2)=a1
        else
          key(a1)=set(idx,1)
          sibd(idx,1)=a1
          sibd(idx,2)=a2
        end if
      elseif (key(a2).eq.MISS .and. (set(idx,1).eq.key(a1) .or.
     &        set(idx,2).eq.key(a1))) then
        if (set(idx,1).eq.key(a1)) then
          key(a2)=set(idx,2)
          sibd(idx,1)=a1
          sibd(idx,2)=a2
        else
          key(a2)=set(idx,1)
          sibd(idx,1)=a2
          sibd(idx,2)=a1
        end if
      elseif (set(idx,1).eq.key(a1) .and. 
     &        set(idx,2).eq.key(a2)) then
        sibd(idx,1)=a1
        sibd(idx,2)=a2
      elseif (set(idx,1).eq.key(a2) .and. 
     &        set(idx,2).eq.key(a1)) then
        sibd(idx,1)=a2
        sibd(idx,2)=a1
      elseif (trials.lt.maxtrials) then
        goto 1
      else
        failid=idx
      end if
      return
      end
C end-of-genof3
C
C infer missing genotypes based on sibd values after run of start
C
      subroutine fillin(num,nfound,set,sibd,key,name,cumfrq,gene,locus)
      integer MAXALL, MAXLOC, MAXSIZ, MISS
      parameter(MAXALL=60, MAXLOC=120, MAXSIZ=1000, MISS=-9999)
      integer gene
C  Pedigree structure
      integer num, nfound, set(MAXSIZ,2), sibd(MAXSIZ,2), key(2*MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C  Cumulative allele frequencies
      integer name(MAXALL)
      double precision cumfrq(MAXALL)
C local variables
      integer g1,g2,gen2,i,tmp

      gen2=gene+1
      do 1 j=1,2*nfound
      if (key(j).eq.MISS) then
        do 2 i=1,num
        if (sibd(i,1).eq.j .and. set(i,1).ne.MISS) then
          key(j)=set(i,1)
        elseif (sibd(i,2).eq.j .and. set(i,2).ne.MISS) then
          key(j)=set(i,2)
        end if
    2   continue
        if (key(j).eq.MISS) then
          call found(cumfrq,g1)
          key(j)=g1
        end if
      end if
    1 continue
C
      do 5 i=1,num
      if (set(i,1).eq.MISS) then
        g1=name(key(sibd(i,1)))
        g2=name(key(sibd(i,2)))
        if (g1.gt.g2) then
          locus(i,gene)=-float(g2)
          locus(i,gen2)=-float(g1)
          tmp=sibd(i,1)
          sibd(i,1)=sibd(i,2)
          sibd(i,2)=tmp
        else
          locus(i,gene)=-float(g1)
          locus(i,gen2)=-float(g2)
        end if
      end if
    5 continue
      return
      end
C end-of-fillin
C
C Excluding genotypes from parental phenoset
C Straight Lange & Goradia AJHG 1987 40: 250-256
C
      subroutine exclude(imp,locnam,xlinkd,gene,pedigree,num,nfound,
     2               id,fa,mo,sex,locus,numal,name,alfrq,set,
     3               ngeno,gset,inconsist,imputd,plevel)
      integer MAXALL,MAXG,MAXLOC,MAXSIZ,MISS,KNOWN
      parameter (MAXALL=60,MAXG=MAXALL*(MAXALL+1)/2, MAXLOC=120,
     &           MAXSIZ=1000, MISS=-9999,KNOWN=0)
      integer imp,gene,inconsist,imputd,plevel 
C Pedigree structure
      character*10 pedigree
      integer num,nfound 
      character*8 id(MAXSIZ) 
      integer fa(MAXSIZ),mo(MAXSIZ),sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C allele frequencies structure
      character*10 locnam
      logical xlinkd
      integer numal, name(MAXALL)
      double precision alfrq(MAXALL)
C phenoset arrays - parents and propositus; set() carries ngeno's for ped
C if set(pos,2) is nonzero, skip this sibship to pos=set(pos,2)
C 
      integer set(MAXSIZ,2)
      integer ngeno, gset(MAXSIZ,MAXG,2)
C local variables
C currin=prior no. of errors; currf and currm=current parents
C sta,fin=boundaries of current sibship; mxgeno=commonest genotype
C gfrq=genotype freq; mult=2 if heterozygote; mxfrq=freq of commonest geno
C
      integer currin,currf,currm,sta,fin,gen2,mxgeno
      double precision gfrq,mult,mxfrq
C functions 
      integer eow
      double precision getfreq
C
      currin=inconsist
C
C initialize phenosets
      gen2=gene+1
      do 160 i=1,num
        if (locus(i,gene).ne.MISS) then
          set(i,1)=1
          gset(i,1,1)=int(locus(i,gene))
          gset(i,1,2)=int(locus(i,gen2))
        elseif (xlinkd .and. sex(i).eq.1) then
          ngeno=0
          do 165 j=1,numal
            ngeno=ngeno+1
            gset(i,ngeno,1)=name(j)
            gset(i,ngeno,2)=name(j)
  165     continue
          set(i,1)=ngeno
        else
          ngeno=0
          do 170 j=1,numal
          do 170 k=j,numal
            ngeno=ngeno+1
            gset(i,ngeno,1)=name(j)
            gset(i,ngeno,2)=name(k)
  170     continue
          set(i,1)=ngeno
        end if
        set(i,2)=0
  160 continue
C
C locate beginnings and ends of sibships
      sta=nfound+1
      currf=fa(sta)
      currm=mo(sta)
      do 175 i=nfound+1,num
      if (fa(i).ne.currf .or. mo(i).ne.currm) then
        currf=fa(i)
        currm=mo(i)
        set(sta,2)=i
        sta=i
      end if
  175 continue
C last is special case
      set(sta,2)=num+1   
C
C loop through all nuclear families until all phenosets finalised
C
      call exc(locnam,xlinkd,gene,pedigree,num,nfound,
     2         id,fa,mo,sex,locus,set,ngeno,gset,
     3         currf,currm,sta,fin,inconsist,plevel)
C
C update workfile (compulsory since this replaces old workfile)
C
      if (inconsist.gt.currin) then
        call setall(gene,num,locus,-float(name(1)))
        return
      else if (imp.eq.2 .or. imp.eq.4) then
        do 190 i=nfound+1,num
        if (set(i,2).ne.0) then
          currf=fa(i)
          currm=mo(i)
          if (set(currf,1).eq.2.and.set(currm,1).eq.2) then
            if (gset(currf,1,1).eq.gset(currm,1,1) .and. 
     2          gset(currf,1,2).eq.gset(currm,1,2) .and.
     3          gset(currf,2,1).eq.gset(currm,2,1) .and. 
     4          gset(currf,2,2).eq.gset(currm,2,2) ) 
     5      then
              imputd=imputd+2
              if (plevel.gt.0) then
                write(*,'(/a,i5,a,i5,2a/7x,3a,2(a,i3,a1,i3)/)')
     2            'NOTE:  Imputed spouses ',id(currf),' and ',id(currm),
     3            ' in pedigree ',pedigree(1:eow(pedigree)),
     4            'at locus "',locnam(1:eow(locnam)),'"',' to be ',
     5            gset(currf,1,1),'/',gset(currf,1,2),' and ',
     6            gset(currf,2,1),'/',gset(currf,2,2)
              end if
              locus(currf,gene)= -float(gset(currf,1,1))
              locus(currf,gen2)= -float(gset(currf,1,2))
              locus(currm,gene)= -float(gset(currf,2,1))
              locus(currm,gen2)= -float(gset(currf,2,2))
            end if
          end if
        end if
  190   continue
      end if
C
C write out phenosets for untyped individuals and update imputed loci
C
      do 195 i=1,num
      if (locus(i,gene).le.KNOWN) then
        ngeno=set(i,1)
        if (ngeno.eq.1) then
          imputd=imputd+1
          if (plevel.gt.0) then
            write(*,'(/7a,i3,a1,i3/)')
     2        'NOTE:  Imputed person ',pedigree(1:eow(pedigree)),'-',
     3        id(i)(1:eow(id(i))),' at locus "',locnam(1:eow(locnam)),
     4        '" to be ', gset(i,1,1),'/',gset(i,1,2)
          end if
          locus(i,gene)=float(gset(i,1,1))
          locus(i,gen2)=float(gset(i,1,2))
        end if
      end if
  195 continue
      if (plevel.gt.1) then
        call wrset(locnam,pedigree,num,id,set,gset)
      end if
C
C Now sequentially initialise so-far untyped individuals to be a 
C likely genotype.  Move through the pedigree, impute
C the current untyped individual, prune genotypes for the remaining
C untyped individuals thus made illegal, until end of pedigree.
C Denote initialised genotypes with negative allele values.
C
C Do not perform sequential imputation if Mendelian errors detected or imp>3.
C
C If failure of sequential imputation, switch to MC start() algorithm
C
      if (imp.gt.3 .or. inconsist.gt.currin) return

      do 200 i=1,num
        if (set(i,1).gt.1) then
          ngeno=set(i,1)
          mxfrq=0.0d0
          do 210 j=1,ngeno
            mult=2.0d0
            if (gset(i,j,1).eq.gset(i,j,2)) mult=1.0d0
            gfrq= mult*getfreq(gset(i,j,1),numal,name,alfrq)*
     &            getfreq(gset(i,j,2),numal,name,alfrq)
            if (gfrq.gt.mxfrq) then
              mxfrq=gfrq
              mxgeno=j
            end if
  210     continue
          locus(i,gene)= -float(gset(i,mxgeno,1))
          locus(i,gen2)= -float(gset(i,mxgeno,2))
          set(i,1)=1
          gset(i,1,1)= gset(i,mxgeno,1)
          gset(i,1,2)= gset(i,mxgeno,2)
          call exc(locnam,xlinkd,gene,pedigree,num,nfound,
     2             id,fa,mo,sex,locus,set,ngeno,gset,
     3             currf,currm,sta,fin,inconsist,-2)
C
C if only one genotype in phenoset but locus not yet updated then update
        elseif (locus(i,gene).eq.MISS) then
          locus(i,gene)= -float(gset(i,1,1))
          locus(i,gen2)= -float(gset(i,1,2))
        end if
C
C check for failure of algorithm -- may need to switch to start()
        if (inconsist.gt.currin) then
          inconsist=currin
          imp=imp+3
          return
        end if
  200 continue
      return      
      end
C end-of-exclude
C
C write out phenoset
C
      subroutine wrset(locnam,pedigree,num,id,set,gset)
      integer MAXALL,MAXG,MAXSIZ
      parameter(MAXALL=60,MAXG=MAXALL*(MAXALL+1)/2,MAXSIZ=1000)
      integer num,set(MAXSIZ,2)
      character*8 id(MAXSIZ)
      integer gset(MAXSIZ,MAXG,2)
      character*10 pedigree
      character*10 locnam
      integer i,j,ngeno
C functions
      integer eow
      write(*,'(/4a/a/a)') 
     2  'Phenosets for locus ',locnam(1:eow(locnam)),
     3  ' in pedigree ',pedigree, 'ID       Count    Legal Genotypes',
     4                            '-------- -------- ---------------'
      do 10 i=1,num
        ngeno=set(i,1)
        write(*,'(a8,1x,i8,7(1x,i3,a1,i3):)') id(i),ngeno,
     &    (gset(i,j,1),'/',gset(i,j,2),j=1,min(ngeno,7))
   10 continue
      write(*,*)
      return
      end
C end-of-wrset
C
C perform exclusion for the pedigree regardless of imputation level
C
      subroutine exc(locnam,xlinkd,gene,pedigree,num,nfound,
     2               id,fa,mo,sex,locus,set,ngeno,gset,
     3               currf,currm,sta,fin,inconsist,plevel)
      integer MAXALL,MAXG,MAXSIZ,MAXLOC
      parameter (MAXALL=60,MAXG=MAXALL*(MAXALL+1)/2,MAXSIZ=1000,
     &           MAXLOC=120)
      integer gene, sta, fin, currf, currm, inconsist, plevel
      logical xlinkd
C part of pedigree structure
      character*10 locnam, pedigree
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C pointers to sibships
      integer set(MAXSIZ,2)
C arrays to contain full phenosets for all pedigree members
      integer ngeno,gset(MAXSIZ,MAXG,2)
C local variables
      logical change,complete
      integer it,incon
C functions
      integer eow
C
      it=0
    1 continue
        change=.false.
        complete=.true.
        sta=nfound+1
        it=it+1
        if (plevel.gt.2) then
          write(*,'(/5a,i2/)') 'Pedigree ',pedigree,' locus ',locnam,
     &     ' Iteration ',it
        end if
C
C One iteration of pedigree - sibship by sibship
C
    5   continue
        if (sta.gt.num) goto 15
        if (set(sta,2).lt.0) then
           sta=-set(sta,2)
           goto 5
         end if
          currf=fa(sta)
          currm=mo(sta)
          fin=set(sta,2)-1
          if (plevel.gt.2) then
            write(*,'(4(a,a8))') 
     2        'Nuclear family: ',id(currf),' x ',id(currm),
     3        '   Off: ',id(sta),' to ',id(fin)
          end if
          incon=0
          call landg(xlinkd,sta,fin,sex,set,ngeno,gset,currf,currm,
     &               change,incon)
C
C check to see if completely unambiguous -- skip in future if true
C
          complete=.true.
          if (set(currf,1).gt.1.or.set(currm,1).gt.1) then
            complete=.false.
          else
            do 25 i=sta,fin
            if (set(i,1).gt.1) then
              complete=.false.
              goto 26
            end if
   25       continue
   26       continue
          end if
          if (complete) set(sta,2)=-fin-1
C
C Check for inconsistencies.
C If being used to generate starting genotypes, 
C don't print a worrying message.
C Old behaviour was to continue looking for errors, but probably cheapest
C to bail out now, as most are fall-out from the first inconsistency.
C
          if (incon.gt.0) then
            inconsist=inconsist+incon
            if (plevel.gt.-2) then
              write(*,'(/5a/)') 
     2          'NOTE:  Mendelian inconsistency in pedigree ',
     3           pedigree(1:eow(pedigree)),' at locus "',
     4           locnam(1:eow(locnam)),'".'
              call describe(locnam,gene,pedigree,id,fa,mo,sex,locus,
     &                      currf,currm,sta,fin,10)
              call famset(pedigree,currf,currm,sta,fin,gene,num,nfound,
     &                    id,fa,mo,locus,set,gset)
            end if
            return
          end if
C increment to next sibship
          sta=fin+1
        
        goto 5
   15   continue
C
C end of iteration through pedigree
        if (plevel.gt.2) then
          call wrset(locnam,pedigree,num,id,set,gset)
        end if
      if (change) goto 1
      return
      end
C end-of-exc
C
C 2nd version of impute -- following Lange & Goradia, 1987
C
      subroutine landg(xlinkd,sta,fin,sex,set,ngeno,gset,currf,currm,
     &                 change,incon)

      integer MAXALL,MAXG,MAXSIZ
      parameter (MAXALL=60,MAXG=MAXALL*(MAXALL+1)/2,MAXSIZ=1000)
      integer sta, fin, currf, currm
      integer sex(MAXSIZ), set(MAXSIZ,2)
      integer ngeno,gset(MAXSIZ,MAXG,2)
      logical chachi,change,con,pcon,xlinkd,xmale
C
      logical keep(MAXG),keep2(MAXG)
      integer i,j,k,l,ngeno1,ngeno2,totgen
C functions
      integer parcon
C
      xmale=.false.
      ngeno1=set(currf,1)
      ngeno2=set(currm,1)
      totgen=ngeno1+ngeno2
C
C first prune parental genotypes inconsistent with children
C
      do 5 j=1,ngeno1
    5   keep(j)=.false.
      do 6 k=1,ngeno2
    6   keep2(k)=.false.
      do 10 j=1,ngeno1
      do 10 k=1,ngeno2
        pcon=.true.
        do 15 i=sta,fin
          ngeno=set(i,1)
          xmale=(xlinkd .and. sex(i).eq.1)
          con=.false.
          do 16 l=1,ngeno
          if (parcon(gset(i,l,1),gset(i,l,2),gset(currf,j,1),
     2        gset(currf,j,2),gset(currm,k,1),gset(currm,k,2),
     3        xmale).gt.0) then
            con=.true.
          end if
   16     continue
          if (.not.con) then
            pcon=.false.
            goto 17
          end if
   15   continue
   17   continue
C
C save this parental genotype if consistent
C
        if (pcon) then
          keep(j)=.true.
          keep2(k)=.true.
        end if
   10 continue
      call prune(currf,ngeno1,gset,keep)
      call prune(currm,ngeno2,gset,keep2)
      if (totgen.ne.(ngeno1+ngeno2)) then
        change=.true.
        set(currf,1)=ngeno1
        set(currm,1)=ngeno2
        if (ngeno1.eq.0) then
          incon=incon+1
        end if
        if (ngeno2.eq.0) then
          incon=incon+1
        end if
      end if
C
C then examine each child's phenoset and remove genotypes inconsistent
C with the current parental phenosets
C
      do 25 i=sta,fin
        ngeno=set(i,1)
        xmale=(xlinkd .and. sex(i).eq.1)
        if (ngeno.gt.1) then
          do 26 l=1,ngeno
            keep(l)=.false.
            do 26 j=1,ngeno1
            do 26 k=1,ngeno2
            if (parcon(gset(i,l,1),gset(i,l,2),gset(currf,j,1),
     2          gset(currf,j,2),gset(currm,k,1),gset(currm,k,2),
     3          xmale).gt.0) then
              keep(l)=.true.
            end if
   26     continue
C see if any alterations made
          chachi=.false.
          do 27 l=1,ngeno
          if (.not.keep(l)) then
            chachi=.true.
            goto 28
          end if
   27     continue
   28     continue
          if (chachi) then
            change=.true.
            call prune(i,ngeno,gset,keep)
            set(i,1)=ngeno
            if (ngeno.eq.0) then
              incon=incon+1
            end if
          end if
        end if
   25 continue
      return
      end
C end-of-landg
C
C remove unwanted genotypes from phenoset
C
      subroutine prune(idx,ngeno,gset,keep)
      integer MAXALL,MAXG,MAXSIZ
      parameter (MAXALL=60,MAXG=MAXALL*(MAXALL+1)/2,MAXSIZ=1000)
      integer idx, ngeno, gset(MAXSIZ,MAXG,2)
      logical keep(MAXG)
      integer old,nkept
      nkept=0
      do 20 old=1,ngeno
      if (keep(old)) then
        nkept=nkept+1
        if (nkept.ne.old) call swapg(idx,gset,old,nkept)
      end if
   20 continue
C Mark end of old phenoset, so can print out if later needed
      gset(idx,ngeno+1,1)=0
      ngeno=nkept
      return
      end
C end-of-prune
C
C swap two genotypes within a phenoset array
C
      subroutine swapg(idx,gset,j,k)
      integer MAXALL,MAXG,MAXSIZ
      parameter (MAXALL=60,MAXG=MAXALL*(MAXALL+1)/2,MAXSIZ=1000)
      integer idx,j,k,gset(MAXSIZ,MAXG,2)
      integer tmp
      tmp=gset(idx,j,1)
      gset(idx,j,1)=gset(idx,k,1)
      gset(idx,k,1)=tmp
      tmp=gset(idx,j,2)
      gset(idx,j,2)=gset(idx,k,2)
      gset(idx,k,2)=tmp
      return
      end
C end-of-swapg
C
C Tests if child genotype consistent with parental genotypes:
C parcon=4*Pr(Child_genotype|Father_genotype,Mother_genotype)
C if xmale  TRUE then X-linked locus *and* male child
C
      integer function parcon(c1,c2,p11,p12,p21,p22,xmale)
      integer c1,c2,p11,p12,p21,p22
      logical xmale 
      parcon=0
      if (xmale) then
        if (c1.eq.p21) parcon=parcon+2
        if (c1.eq.p22) parcon=parcon+2
        return
      end if
      if ((c1.eq.p11 .and. c2.eq.p21) .or. (c1.eq.p21 .and. c2.eq.p11)) 
     &  parcon=parcon+1
      if ((c1.eq.p11 .and. c2.eq.p22) .or. (c1.eq.p22 .and. c2.eq.p11))
     &  parcon=parcon+1
      if ((c1.eq.p12 .and. c2.eq.p21) .or. (c1.eq.p21 .and. c2.eq.p12))
     &  parcon=parcon+1
      if ((c1.eq.p12 .and. c2.eq.p22) .or. (c1.eq.p22 .and. c2.eq.p12))
     &  parcon=parcon+1
      return
      end
C end-of-parcon
C
C test if child genotype consistent with one parental genotype
C
      logical function opcon(c1,c2,p1,p2)
      integer c1,c2,p1,p2
      opcon=.false.
      if (c1.eq.p1 .or. c1.eq.p2 .or. c2.eq.p1 .or. c2.eq.p2) 
     &  opcon=.true.
      return
      end
C end-of-opcon
C
C write out genotypes in nuclear family and grandparents
C
      subroutine describe(locnam,gene,pedigree,id,fa,mo,sex,locus,
     &                    currf,currm,sta,fin,mesg)
      integer MAXSIZ, MAXLOC, MISS, WIDE
      parameter(MAXSIZ=1000, MAXLOC=120, MISS=-9999, WIDE=12)

      integer currf, currm, fin, gene, mesg, sta
      character*10 locnam
      character*10 pedigree
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
      integer i, eol, eop, gen2, leftm, npars, pos, nsibs
      logical gp1, gp2  
      character*7 gtp
      character*10 chid
      character*128 lin
C
C functions
      integer eow
C
C
C else
C
C Check if useful to view
C
      if (mesg.lt.10) then
        npars=0
        if (locus(currf,gene).ne.MISS) npars=npars+1
        if (locus(currm,gene).ne.MISS) npars=npars+1
        nsibs=0
        do 5 i=sta,fin
        if (locus(i,gene).ne.MISS) then
          nsibs=nsibs+1 
        end if
    5   continue
        if (nsibs.eq.0 .or. (nsibs.eq.1 .and. npars.eq.0)) return
      end if
C
C if useful
C
      gen2=gene+1
      eop=eow(pedigree)
      lin=' '
      write(*,'(3a/a)') 'Locus "',locnam(1:eow(locnam)),'"',
     &                  '------------------'
      write(*,'(8a/)')
     2  'Sibship: ',pedigree(1:eop),'-',id(currf)(1:eow(id(currf))),
     3  ' x ',pedigree(1:eop),'-',id(currm)(1:eow(id(currm))) 
C
C write an edifying message, if supplied
C
      if (mesg.eq.10) then
        write(*,'(a/)') 
     &    'Multigenerational inconsistency between genotypes.'
      elseif (mesg.eq.11) then
        write(*,'(a/)') 
     &    'Inconsistency between parent and child genotypes.'
      elseif (mesg.eq.12) then
        write(*,'(a/)') 
     &    'Multiple inconsistencies between parent and child genotypes.'
      elseif (mesg.eq.13) then
        write(*,'(a/)') 
     &    'Inconsistency between sibling genotypes.'
      elseif (mesg.eq.14) then
        write(*,'(a/)') 
     &    'More than 4 alleles segregating in nuclear family.'
      elseif (mesg.eq.15) then
        write(*,'(a/)') 
     &    'Inconsistency between imputed parent and child genotypes.'
      end if
      gp1=(fa(currf).ne.MISS)
      gp2=(fa(currm).ne.MISS)
C
C Show grandparental generation if useful and present
C
      if (mesg.lt.11 .and. (gp1 .or. gp2)) then
        if (gp1) then
          call wrid('c',id(fa(currf)),chid,sex(fa(currf)))
          lin(17:26)=chid
          call wrid('c',id(mo(currf)),chid,sex(mo(currf)))
          lin(27:36)=chid
          eol=36
        end if
        if (gp2) then
          call wrid('c',id(fa(currm)),chid,sex(fa(currm)))
          lin(37:46)=chid
          call wrid('c',id(mo(currm)),chid,sex(mo(currm)))
          lin(47:56)=chid
          eol=56
        end if
        write(*,'(a)') lin(1:eol)
        lin=' '
        if (gp1) then
          call wrgtp(int(locus(fa(currf),gene)),
     &               int(locus(fa(currf),gen2)),gtp,1)
          lin(18:24)=gtp
          call wrgtp(int(locus(mo(currf),gene)),
     &               int(locus(mo(currf),gen2)),gtp,1)
          lin(28:34)=gtp
          eol=34
        end if
        if (gp2) then
          call wrgtp(int(locus(fa(currm),gene)),
     &               int(locus(fa(currm),gen2)),gtp,1)
          lin(38:44)=gtp
          call wrgtp(int(locus(mo(currm),gene)),
     &               int(locus(mo(currm),gen2)),gtp,1)
          lin(48:54)=gtp
          eol=54
        end if
        write(*,'(a)') lin(1:eol)
        lin=' '
        if (gp1) then
          lin(21:21)='|'
          lin(31:31)='|'
          eol=31
        end if
        if (gp2) then
          lin(41:41)='|'
          lin(51:51)='|'
          eol=51
        end if
        write(*,'(a)') lin(1:eol)
        lin=' '
        if (gp1) then
          lin(21:31)='+====+====+'
          eol=31
        end if
        if (gp2) then
          lin(41:51)='+====+====+'
          eol=51
        end if
        write(*,'(a)') lin(1:eol)
        lin=' '
        if (gp1) then
          lin(26:26)='|'
          eol=26
        end if
        if (gp2) then
          lin(46:46)='|'
          eol=46
        end if
        write(*,'(a)') lin(1:eol)
        lin=' '
      end if
C
C Now the parents of the nuclear family
C
      call wrid('c',id(currf),chid,sex(currf))
      lin(22:31)=chid
      call wrid('c',id(currm),chid,sex(currm))
      lin(42:51)=chid
      write(*,'(a)') lin(1:50)
      lin=' '
      call wrgtp(int(locus(currf,gene)),int(locus(currf,gen2)),gtp,1)
      lin(23:29)=gtp
      call wrgtp(int(locus(currm,gene)),int(locus(currm,gen2)),gtp,1)
      lin(43:49)=gtp
      write(*,'(a)') lin(1:49)
      lin=' '
      write(*,'(25x,a1,19x,a1/25x,a21/35x,a1)')
     &  '|','|','+=========+=========+','|'
C
C Then the children
C
      nsibs=fin-sta+1
      if (nsibs.eq.1) then
        call wrid('c',id(sta),chid,sex(sta))
        call wrgtp(int(locus(sta,gene)),int(locus(sta,gen2)),gtp,1)
        write(*,'(35x,a1/31x,a10/32x,a7)') '|',chid,gtp
      elseif (nsibs.gt.WIDE) then
        do 10 i=sta,fin
          call wrgtp(int(locus(i,gene)),int(locus(i,gen2)),gtp,1)
          write(*,'(28x,a8,1x,a7)') id(i),gtp
   10   continue
      else
        leftm=max(3,38-5*nsibs)
        pos=leftm+3
        do 15 i=1,nsibs-1
          lin(pos:pos+10)='+---------+'
          pos=pos+10
   15   continue
        lin(36:36)='+'
        write(*,'(a)') lin(1:pos)
        lin=' '
        pos=leftm+3
        do 20 i=1,nsibs
          lin(pos:pos)='|'
          pos=pos+10
   20   continue
        write(*,'(a)') lin(1:pos)
        lin=' '
        pos=leftm-1
        do 25 i=sta,fin
          call wrid('c',id(i),chid,sex(i))
          lin(pos:pos+9)=chid
          pos=pos+10
   25   continue
        write(*,'(a)') lin(1:pos)
        lin=' '
        pos=leftm
        do 30 i=sta,fin
          call wrgtp(int(locus(i,gene)),int(locus(i,gen2)),gtp,1)
          lin(pos:pos+6)=gtp
          pos=pos+10
   30   continue
        write(*,'(a)') lin(1:pos)
      end if
      write(*,*)
      return
      end
C end-of-describe
C
C Write out phenoset for a nuclear family (plus grandparents and halfsibs)
C Useful in detecting sources of long distance Mendelian inconsistencies.
C
      subroutine famset(pedigree,currf,currm,sta,fin,gene,num,nfound,
     &                  id,fa,mo,locus,set,gset)
      integer MAXALL,MAXG,MAXLOC,MAXSIZ,MISS
      parameter(MAXALL=60,MAXG=MAXALL*(MAXALL+1)/2,MAXLOC=120,
     &          MAXSIZ=1000,MISS=-9999)
      integer currf, currm, fin, gene, num, nfound, sta
      character*10 pedigree
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
      integer set(MAXSIZ,2), gset(MAXSIZ,MAXG,2)

      integer g1,g2,gen2,gfa,gmo,i
      logical found
C functions
      logical allinset

      gen2=gene+1

      write(*,'(a/a)') 'ID       Count    Problem phenosets',
     &                 '-------- -------- -----------------'
C Grandparental phenosets
      if (fa(currf).ne.MISS) then
        write(*,'(/a)') 'Paternal Gparents'
        call indset(fa(currf),gene,id,locus,set,gset)
        call indset(mo(currf),gene,id,locus,set,gset)
      end if
      if (fa(currm).ne.MISS) then
        write(*,'(/a)') 'Maternal Gparents'
        call indset(fa(currm),gene,id,locus,set,gset)
        call indset(mo(currm),gene,id,locus,set,gset)
      end if
C Uncles and aunts phenosets
      if (fa(currf).ne.MISS) then
        gfa=fa(currf)
        gmo=mo(currf)
        found=.false.
        do 20 i=nfound+1,num
        if (fa(i).eq.gfa .and. mo(i).eq.gmo .and. i.ne.currf) then
          if (.not.found) then
            write(*,'(/a)') 'Paternal Uncles/Aunts'
            found=.true.
          end if
          call indset(i,gene,id,locus,set,gset)
        end if  
   20   continue
      end if
      if (fa(currm).ne.MISS) then
        gfa=fa(currm)
        gmo=mo(currm)
        found=.false.
        do 30 i=nfound+1,num
        if (fa(i).eq.gfa .and. mo(i).eq.gmo .and. i.ne.currm) then
          if (.not.found) then
            write(*,'(/a)') 'Maternal Uncles/Aunts'
            found=.true.
          end if
          call indset(i,gene,id,locus,set,gset)
        end if  
   30   continue
      end if
C Parental phenosets
      write(*,'(/a)') 'Father'
      call indset(currf,gene,id,locus,set,gset)
      write(*,'(/a)') 'Mother'
      call indset(currm,gene,id,locus,set,gset)
C Sibship phenosets
      write(*,'(/a)') 'Children'
      do 10 i=sta,fin
        call indset(i,gene,id,locus,set,gset)
   10 continue
C Half-sib phenosets
      found=.false.
      do 40 i=nfound+1,num
      if (fa(i).eq.currf .and. mo(i).ne.currm) then
        if (.not.found) then
          write(*,'(/a)') 'Paternal Half-sibs'
          found=.true.
        end if
        call indset(i,gene,id,locus,set,gset)
      end if  
   40 continue
      found=.false.
      do 50 i=nfound+1,num
      if (fa(i).ne.currf .and. mo(i).eq.currm) then
        if (.not.found) then
          write(*,'(/a)') 'Maternal Half-sibs'
          found=.true.
        end if
        call indset(i,gene,id,locus,set,gset)
      end if  
   50 continue
      write(*,*)
C
C See if single allele might explain inconsistency between untyped parent 
C and offspring
C
      do 100 i=sta,fin
      if (locus(i,gene).ne.MISS) then
        g1=int(locus(i,gene))
        g2=int(locus(i,gen2))
        if (set(currf,1).eq.0) then
          call cntbad(currf,ngeno,gset)
          if (.not.allinset(currf,g1,ngeno,gset)) then
            call wroddall(pedigree,id(currf),id(i),g1)
          end if
          if (.not.allinset(currf,g2,ngeno,gset)) then
            call wroddall(pedigree,id(currf),id(i),g1)
          end if
        end if
        if (set(currm,1).eq.0) then
          call cntbad(currm,ngeno,gset)
          if (.not.allinset(currm,g1,ngeno,gset)) then
            call wroddall(pedigree,id(currm),id(i),g1)
          end if
          if (.not.allinset(currm,g2,ngeno,gset)) then
            call wroddall(pedigree,id(currm),id(i),g2)
          end if
        end if
      end if
  100 continue
      write(*,*)
      return
      end
C end-of-famset
C
C write out phenoset for an individual 
C
      subroutine indset(idx,gene,id,locus,set,gset)
      integer MAXALL,MAXG,MAXLOC,MAXSIZ,MISS
      parameter(MAXALL=60,MAXG=MAXALL*(MAXALL+1)/2,MAXLOC=120,
     &          MAXSIZ=1000,MISS=-9999)
      integer gene, idx, set(MAXSIZ,2)
      character*8 id(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
      integer gset(MAXSIZ,MAXG,2)
      integer gen2,i,ngeno

      gen2=gene+1
      if (locus(idx,gene).ne.MISS) then
        write(*,'(a8,1x,a8,1x,i3,a1,i3)') id(idx),'Typed',
     &    int(locus(idx,gene)), '/', int(locus(idx,gen2))
      elseif (set(idx,1).eq.0) then
        call cntbad(idx,ngeno,gset)
        write(*,'(a8,1x,a8,7(1x,i3,a1,i3):)') id(idx),'Problem',
     &    (gset(idx,i,1),'/',gset(idx,i,2),i=1,min(ngeno,7))
      else
        ngeno=set(idx,1)
        write(*,'(a8,1x,i8,7(1x,i3,a1,i3):)') id(idx),ngeno,
     &    (gset(idx,i,1),'/',gset(idx,i,2),i=1,min(ngeno,7))
      end if
      return
      end
C end-of-indset
C
C see if particular allele in phenoset for idx person
C
      logical function allinset(idx,iall,ngeno,gset)
      integer MAXALL,MAXG,MAXSIZ
      parameter(MAXALL=60,MAXG=MAXALL*(MAXALL+1)/2,MAXSIZ=1000)
      integer iall, idx, ngeno
      integer gset(MAXSIZ,MAXG,2)

      integer i

      allinset=.true.
      do 10 i=1,ngeno
      if (gset(idx,i,1).eq.iall .or. gset(idx,i,2).eq.iall) then
        return
      end if
   10 continue
C else if not found
      allinset=.false.
      return
      end
C end-of-allinset
C
C If phenoset contains zero legal genotypes, reconstruct last state
C
      subroutine cntbad(idx,ngeno,gset)
      integer MAXALL,MAXG,MAXSIZ
      parameter(MAXALL=60,MAXG=MAXALL*(MAXALL+1)/2,MAXSIZ=1000)
      integer idx, ngeno
      integer gset(MAXSIZ,MAXG,2)
      integer i

      do 10 i=1,MAXG
        if (gset(idx,i,1).eq.0) then
          ngeno=i-1
          return 
        end if
   10 continue
      ngeno=0
      return
      end
C end-of-cntbad
C
C If find an odd-allele-out, write out its location
C
      subroutine wroddall(pedigree,parent,child,iall)
      character*10 pedigree
      character*8 parent, child
      integer iall
      integer eop
C functions
      integer eow

      eop=eow(pedigree)

      write(*,'(5a,i3,5a)') 'Parent ',pedigree(1:eop),'-',
     2  parent(1:eow(parent)), ' cannot carry the ',
     3  iall,' allele found in child ',
     4  pedigree(1:eop),'-',child(1:eow(child)),'.'
      return
      end
C end-of-wroddall

C
C read in pedigree 
C
      subroutine pedin(strm,wrk,wrk2,addsex,link,pedigree,num,nfound,
     2                 id,fa,mo,sex,locus,ord,key1,key2,set,last,higen,
     3                 numloc,lin,words,nwarn,nfam,famerr,plevel)

      integer LINSIZ,MAXSIZ,MAXLOC,MAXCOL,MISS
      parameter (LINSIZ=1024,MAXSIZ=1000,MAXLOC=120,MAXCOL=MAXLOC+5,
     &           MISS=-9999)

      character*20 words(MAXCOL)
      character*(LINSIZ) lin

      integer higen, narg, nfam, nwarn, plevel, strm, wrk, wrk2
      logical addsex, famerr, last, link
C Pedigree structure
      character*10 pedigree
      integer num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      integer numloc
      real locus(MAXSIZ,MAXLOC)
C Work arrays for sorting etc
      integer key1(MAXSIZ),key2(MAXSIZ),key3(MAXSIZ),ord(MAXSIZ)  
      integer set(MAXSIZ,2)

      integer col,extra,eop,i,nerr,nfields,nid,offset,pos,sexfa,sexmo
      character*8 cfa, cid, cmo
C functions
      integer eow  
      real fval

      eop=0
      extra=0
      last=.false.
      nerr=0
      nfound=0 
      nid=0
      num=0
      offset=5
      if (addsex) offset=4
      nfields=offset+numloc
      pedigree=' '

      do 2 i=1,MAXSIZ
        key2(i)=0
    2 continue
C
C Read in pedigree data
C
    5 continue
        read(strm,'(a)',end=14) lin
        narg=MAXCOL
        call args(lin,narg,words,3)
        if (words(1)(1:1).eq.'!' .or. words(1)(1:1).eq.'#') then
          if (plevel.gt.1) write(*,'(a)') lin(1:79)
        elseif (words(1).eq.' ') then
          continue
        elseif (words(1).eq.'pedigree') then
          continue
        elseif (pedigree.eq.words(1)(1:10) .or. num.eq.0) then
          if (num.eq.0) then
            pedigree=words(1)(1:10)
            eop=eow(pedigree)
          elseif (nid.ge.MAXSIZ) then
            write(*,'(/3a,i4,a/7x,a/)') 
     2        'ERROR: Number of members for pedigree ',
     3        pedigree(1:eop), ' exceeds ',MAXSIZ,
     4        ', the maximum allowed.', 'Stopping prematurely.'
            close(strm,status='keep')
            close(wrk,status='delete')
            close(wrk2,status='delete')
            stop
          end if
          if (narg.ne.nfields) then
            nwarn=nwarn+1
            if (nwarn.le.25) then
              if (narg.lt.nfields) then
                write(*,'(/a/7x,a/)') 
     2          'ERROR: Insufficient number of data fields in:',
     3                  lin(1:72)
              else
                write(*,'(/a/7x,a/)') 
     2          'NOTE:  Excessive number of data fields in:',
     3                  lin(1:72)
              end if
            end if
          end if
          num=num+1
          pedigree=words(1)(1:10)
          cid=words(2)(1:8)
          cfa=words(3)(1:8)
          cmo=words(4)(1:8)
C sex
          sex(num)=MISS
          if (words(5).eq.'f'.or.words(5).eq.'F'.or.words(5).eq.'2') 
     &    then
            sex(num)=2
          elseif (words(5).eq.'m'.or.words(5).eq.'M'.or.words(5).eq.'1')
     &    then
            sex(num)=1
          end if
C sex may also be requested as a quantitative variable
          if (addsex) then
            if (sex(num).eq.2) then
              locus(num,1)=0.0
            elseif (sex(num).eq.1) then
              locus(num,1)=1.0
            else
              locus(num,1)=0.5
            end if
          end if
C
C all other variables
          col=5-offset
          if (link) then
            do 20 j=6,narg
              col=col+1
              locus(num,col)=fval(words(j))
              if (fval(words(j)).eq.0.0) locus(num,col)=MISS
   20       continue
          else
            do 30 j=6,narg
              col=col+1
              locus(num,col)=fval(words(j))
   30       continue
          end if
C
C pad if short of data
          do 40 j=col+1,numloc
            locus(num,j)=MISS
   40     continue
C
C Tabulate individual IDs, creating a pointer to the table of IDs,
C and a pointer to the position of the person
C
          call tabid(cid,nid,id,key2,1,key1(num))
          ord(key1(num))=num

          if (cfa.eq.'0'.or.cfa.eq.'X'.or.cfa.eq.'.') cfa='x'
          if (cmo.eq.'0'.or.cmo.eq.'X'.or.cmo.eq.'.') cmo='x'

          if (cid.eq.cfa .or. cid.eq.cmo) then
            write(*,'(/5a/)') 'ERROR: Person ',
     &        pedigree(1:eop),'-', cid(1:eow(cid)),' is his own parent.'
            famerr=.true.
          else if (cfa.ne.'x' .and. cfa.eq.cmo) then
            write(*,'(/7a/)') 'ERROR: Person ',
     2        pedigree(1:eop),'-', cfa(1:eow(cid)),
     3        ' is both father and mother of ', cid(1:eow(cid)),'.'
            famerr=.true.
          end if
C
C Tabulate parental IDs
C adding extra records where a parental ID is not specified
C
C nonfounder
          if (cfa.ne.'x' .and. cmo.ne.'x') then
            call tabid(cfa,nid,id,key2,0,fa(num))
            call tabid(cmo,nid,id,key2,0,mo(num))
C founder
          elseif (cfa.eq.'x' .and. cmo.eq.'x') then 
            nfound=nfound+1
            fa(num)=MISS
            mo(num)=MISS
C nonfounder with one parent not specified -- check if enough storage space
          elseif (nid.ge.MAXSIZ) then 
            write(*,'(/3a,i4,a/7x,a/)') 
     2        'ERROR: Number of members for pedigree ',
     3        pedigree(1:eop), ' will exceed ',MAXSIZ,
     4        ', the maximum allowed if a dummy record created.', 
     5        'Stopping prematurely.'
            close(strm,status='keep')
            close(wrk,status='delete')
            close(wrk2,status='delete')
            stop
C create new father
          elseif (cfa.eq.'x') then 
            call tabid(cmo,nid,id,key2,0,mo(num))
            extra=extra+1
            nid=nid+1
            fa(num)=nid
            write(cfa,'(a2,i3.3)') 'ZZ',extra
            id(nid)=cfa
            call mkdummy(num,nfound,1,addsex,fa,mo,sex,numloc,locus)
            ord(nid)=num
            key1(num)=nid
            key2(nid)=1
            if (plevel.ge.0) then
              write(*,'(/8a/)') 'NOTE:  Father of person ',
     2          pedigree(1:eop),'-',cid(1:eow(cid)),
     3          ' not specified.  Creating ',
     4          pedigree(1:eop),'-',cfa(1:eow(cfa)) 
            end if
C create new mother
          elseif (cmo.eq.'x') then 
            call tabid(cfa,nid,id,key2,0,fa(num))
            extra=extra+1
            nid=nid+1
            mo(num)=nid
            write(cmo,'(a2,i3.3)') 'ZZ',extra
            id(nid)=cmo
            call mkdummy(num,nfound,2,addsex,fa,mo,sex,numloc,locus)
            ord(nid)=num
            key1(num)=nid
            key2(nid)=1
            if (plevel.ge.0) then
              write(*,'(/8a/)') 'NOTE:  Mother of person ',
     2          pedigree(1:eop),'-',cid(1:eow(cid)),
     3          ' not specified.  Creating ',
     4          pedigree(1:eop),'-',cmo(1:eow(cmo)) 
            end if
          end if
        else
          backspace(strm)
          goto 15
        end if
        goto 5
C
C end of while loop
C
   14 last=.true.
   15 continue
C
C Check for errors 
C
      if (famerr) return
C By individual 
      do 100 i=1,nid
        if (key2(i).gt.1) then
          write(*,'(/5a/)') 'ERROR: Duplicate record for person ',
     &      pedigree(1:eop),'-',id(i)(1:eow(id(i))),'.'
          nerr=1
        elseif (key2(i).eq.0) then
          if (plevel.ge.0) then
            write(*,'(/5a/)') 'NOTE:  Creating dummy record for ',
     &        pedigree(1:eop),'-',id(i)(1:eow(id(i))),'.'
          end if
          if (num.eq.MAXSIZ) then
            write(*,'(/3a,i4,a/7x,a/)') 
     2        'ERROR: Number of members for pedigree ',
     3        pedigree(1:eop), ' will exceed ',MAXSIZ,
     4        ', the maximum allowed.', 'Stopping prematurely.'
            close(strm,status='keep')
            close(wrk,status='delete')
            close(wrk2,status='delete')
            stop
          end if
          j=MISS
          call mkdummy(num,nfound,j,addsex,fa,mo,sex,numloc,locus)
          ord(i)=num
          key1(num)=i
        end if
  100 continue
C
C By mating
      do 110 i=1,nid
      if (fa(i).ne.MISS .and. mo(i).ne.MISS) then
        sexfa=sex(ord(fa(i)))
        sexmo=sex(ord(mo(i)))
        if (sexfa.eq.1 .and. sexmo.eq.2) goto 110

        if ((sexfa.eq.2 .and. (sexmo.eq.1.or.sexmo.eq.MISS)) .or.
     &           (sexfa.eq.MISS .and. sexmo.eq.1)) then
          if (plevel.ge.0) then
            write(*,'(/5a/)') 'NOTE: Father and mother of person ',
     2        pedigree(1:eop),'-',id(i)(1:eow(id(i))),
     3        ' appear to be swapped around.  Reordering.'
          end if
          j=fa(i)
          fa(i)=mo(i)
          mo(i)=j
          sexfa=sex(ord(fa(i)))
          sexmo=sex(ord(mo(i)))
        elseif (sexfa.ne.MISS .and. sexfa.eq.sexmo) then
          write(*,'(/5a/)') 'ERROR: Parents of person ',
     2      pedigree(1:eop),'-',id(i)(1:eow(id(i))),
     3      ' appear to be the same sex.'
          nerr=1
        end if
C
C one reordered, fill in missing sexes
        if (sexfa.eq.1 .and. sexmo.eq.MISS) then
          if (plevel.ge.0) then
            write(*,'(/5a/7x,a)') 'NOTE:  Person ',
     2        pedigree(1:eop),'-',id(mo(i))(1:eow(id(mo(i)))),
     3        ' appears as a mother and sex was unspecified.',
     4        'Setting sex to female.'
          end if
          sex(ord(mo(i)))=2
        else if (sexfa.eq.MISS .and. sexmo.eq.2) then
          if (plevel.ge.0) then
            write(*,'(/5a/7x,a)') 'NOTE:  Person ',
     2        pedigree(1:eop),'-',id(fa(i))(1:eow(id(fa(i)))),
     3        ' appears as a father and sex was unspecified.',
     4        'Setting sex to male.'
          end if
          sex(ord(fa(i)))=1
        else if (sexfa.eq.MISS .and. sexmo.eq.MISS) then
          sex(ord(fa(i)))=1
          sex(ord(mo(i)))=2
        end if
      end if
  110 continue
      if (nerr.ne.0) then
        famerr=.true.
        return
      end if
C
C Sort the pedigree on generation number, id, and parental ID,
C returning the sorted position in ord
C
      call famsort(pedigree,num,nfound,nid,id,key1,fa,mo,key2,key3,ord,
     &             set,higen,nfam,nerr,plevel)
C
C Catch pedigree errors
      if (nerr.ne.0) then
        famerr=.true.
        return
      end if
C
C reorder the pedigree using external file
C
      do 140 i=1,num
        key2(ord(i))=i
  140 continue
      do 150 i=1,num
        pos=ord(i)
        if (fa(pos).ne.MISS) then
          write(wrk2) id(key1(pos)),key2(fa(pos)),key2(mo(pos)),
     &      sex(pos), (locus(pos,j),j=1,numloc)
        else
          write(wrk2) id(key1(pos)),MISS,MISS, sex(pos), 
     &      (locus(pos,j),j=1,numloc)
        end if
  150 continue
      rewind(wrk2)
      do 160 i=1,num
        read(wrk2) id(i),fa(i),mo(i),sex(i),(locus(i,j),j=1,numloc)
  160 continue
      return
      end
C end-of-pedin
C
C Tabulate alphanumeric IDs in order of appearance
C
      subroutine tabid(curid,nid,id,count,inc,pos)
      integer MAXSIZ, MISS
      parameter (MAXSIZ=1000,MISS=-9999)

      integer nid, pos
      character*8 curid  

      character*8 id(MAXSIZ)
      integer count(MAXSIZ)

      do 10 pos=1,nid
      if (id(pos).eq.curid) then
        count(pos)=count(pos)+inc
        return 
      end if
   10 continue

      if (nid.lt.MAXSIZ) then
        nid=nid+1
        pos=nid
        id(pos)=curid
        count(pos)=inc
      else
        pos=MISS
        write(*,'(a,i5,a/)') 'ERROR: More than ',MAXSIZ,' IDs in family'
      end if
      return
      end
C end-of-tabid
C
C Work out generation number ord(), then sort family on 
C founder status, generation number, parental ID, 
C and personal ID giving their position in ord().
C Returns the ranking in ord(), and the depth of the pedigree in higen
C
      subroutine famsort(pedigree,num,nfound,nid,id,pid,fa,mo,
     &                   key1,key2,ord,set,higen,nfam,nerr,plevel)
      integer MAXSIZ, MISS
      parameter (MAXSIZ=1000,MISS=-9999)
      integer higen, nerr, nfam, plevel
C Pedigree structure
      character*10 pedigree 
      character*8 id(MAXSIZ)
      integer num,nfound,pid(MAXSIZ),fa(MAXSIZ),mo(MAXSIZ)
      integer key1(MAXSIZ), key2(MAXSIZ), ord(MAXSIZ), set(MAXSIZ,2)
C
      integer curkey1, curkey2, i, maxgrp, nsub, stratum
C
C nsub=number of disjoint subpedigrees within "pedigree"; higen=number of
C generations in family; subped no. 1 largest, size maxgrp
C
C first change the parental ID pointer from id table position 
C to file position as required by connect() and gener()
C
      do 15 i=1,num
      if (fa(i).ne.MISS) then
        fa(i)=ord(fa(i))
        mo(i)=ord(mo(i))
      end if
   15 continue
C
C determine collating order of IDs in table
C
      call ascend(nid, key1)
      call csort(nid, id, key1)
C
C create reverse index from sorted table to original records
C so that the multiple key sort can be performed
C
      call ascend(nid, ord)
      call isort(1, nid, key1, ord, 2)
      do 20 i=1,num
        pid(i)=ord(pid(i))
   20 continue
C
C determine if one or more subpedigrees are present
C
      call connect(num,fa,mo,set,nsub,maxgrp)
C
C list any subpedigrees
C
      if (nsub.gt.1) then
        call wrsubped(pedigree,num,id,pid,set,nsub,maxgrp,plevel)
      end if
C
C get the generation number
C
      call gener(pedigree,num,fa,mo,nsub,set,key1,higen,nerr,plevel)
C
C and sort on generation number and foundership
C
      do 60 i=1,num
      if (fa(i).ne.MISS) then
        key1(i)=higen+key1(i)
      end if
   60 continue
      call ascend(num,ord)
      call isort(1,num,key1,ord,2)
C now on paternal ID
      do 160 i=nfound+1,num
        key2(i)=pid(fa(ord(i)))
  160 continue
      call msdsort(nfound+1,num,key1,key2,ord)
C now on maternal ID
      stratum=0
      curkey1=MISS
      curkey2=MISS
      do 260 i=nfound+1,num
        if (key1(i).ne.curkey1 .or. 
     &      key1(i).eq.curkey1 .and. key2(i).ne.curkey2) then
          stratum=stratum+1
          curkey1=key1(i)
          curkey2=key2(i)
        end if
        key2(i)=stratum
        key1(i)=pid(mo(ord(i)))
  260 continue
      call msdsort(nfound+1,num,key2,key1,ord)
C now on ID
      do 360 i=1,nfound
        key1(i)=0
        key2(i)=pid(ord(i))
  360 continue
      stratum=0
      curkey1=MISS
      curkey2=MISS
      do 370 i=nfound+1,num
        if (key2(i).ne.curkey1 .or. key1(i).ne.curkey2) then
          stratum=stratum+1
          curkey1=key2(i)
          curkey2=key1(i)
        end if
        key1(i)=stratum
        key2(i)=pid(ord(i))
  370 continue
      call isort(1, nfound, key2, ord, 2)
      call msdsort(nfound+1,num,key1,key2,ord)
      nfam=stratum
      return
      end
C end-of-famsort
C
C MSD radix sort key1, key2
C
      subroutine msdsort(bot,top,key1,key2,ord)
      integer MAXSIZ
      parameter(MAXSIZ=1000)
      integer bot, top
      integer key1(MAXSIZ),key2(MAXSIZ),ord(MAXSIZ)
      integer curkey,fin,i,sta

      curkey=key1(bot)
      sta=bot
      fin=bot
      do 197 i=bot+1,top
        if (key1(i).eq.curkey) then
          fin=i
        else
          call isort(sta, fin, key2, ord, 2)
          sta=i
          fin=i
          curkey=key1(sta)
        end if
  197 continue
      call isort(sta, fin, key2, ord, 2)
      return
      end
C end-of-msdsort
C
C Create dummy records for added individals
C
      subroutine mkdummy(num,nfound,sx,addsex,fa,mo,sex,numloc,locus)
      integer MAXLOC, MAXSIZ, MISS
      parameter (MAXLOC=120,MAXSIZ=1000,MISS=-9999)

      integer nfound,num,numloc,sx
      logical addsex
      integer fa(MAXSIZ),mo(MAXSIZ),sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
      integer j

      num=num+1
      nfound=nfound+1
      fa(num)=MISS
      mo(num)=MISS
      sex(num)=sx
      do 15 j=1,numloc
        locus(num,j)=MISS
   15 continue
      if (addsex) then
        if (sex(num).eq.2) then
          locus(num,1)=0.0
        elseif (sex(num).eq.1) then
          locus(num,1)=1.0
        else
          locus(num,1)=0.5
        end if
      end if
      return
      end
C end-of-mkdummy
C
C Read pedigree from work file
C
      subroutine wrkin(wrk,pedigree,actset, num,nfound,id,fa,mo,sex,
     &                 locus,numloc,last)
      integer MAXSIZ,MAXLOC
      parameter (MAXSIZ=1000,MAXLOC=120)
C Pedigree structure
      character*10 pedigree
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      integer actset,num,nfound,numloc,wrk
      real locus(MAXSIZ,MAXLOC)
      logical last
      integer i,j
      last=.false.
      read(wrk,end=30) pedigree,actset,num,nfound
      do 20 i=1,num
        read(wrk) id(i),fa(i),mo(i),sex(i),(locus(i,j),j=1,numloc)
   20 continue
      return
C
   30 last=.true.
      return
      end
C end-of-wrkin
C
C Write pedigree to work file
C
      subroutine wrkout(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,
     &                  locus,numloc)
      integer MAXSIZ,MAXLOC
      parameter (MAXSIZ=1000,MAXLOC=120)
C Pedigree structure
      character*10 pedigree
      integer actset, num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      integer numloc,wrk
      real locus(MAXSIZ,MAXLOC)
      integer i

      write(wrk) pedigree, actset, num, nfound
      do 10 i=1,num
        write(wrk) id(i),fa(i),mo(i),sex(i),(locus(i,j),j=1,numloc)
   10 continue
      return
      end
C end-of-wrkout
C
C Add extra blank columns to the dataset
C
      subroutine addvar(wrk,twrk,newloc,pedigree,actset,num,nfound,
     &                  id,fa,mo,sex,locus,numloc)
      integer MAXSIZ, MAXLOC, MISS
      parameter(MAXSIZ=1000, MAXLOC=120, MISS=-9999)

      integer newloc, wrk, twrk

      character*10 pedigree
      integer num,nfound 
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ),mo(MAXSIZ),sex(MAXSIZ)
      integer numloc
      real locus(MAXSIZ,MAXLOC)
C
      integer actset,i,j
      logical last

      last=.false.
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc,last)
       if (last) goto 20
        do 15 i=1,num
        do 15 j=numloc+1,newloc
          locus(i,j)=MISS
   15   continue
        call wrkout(twrk,pedigree,actset,num,nfound,id,fa,mo,sex,
     &              locus,newloc)
      goto 10
   20 continue
      return
      end
C end-of-addvar

C
C perform Haseman-Elston sib-pair regression: two-point Cardon & Fulker
C
      subroutine twopair(wrk,trait,mark1,mark2,th1,th2,th12,
     2              pedigree,actset,num,nfound,id, fa, mo, sex, locus, 
     3              numloc,numal,name,alfrq,numal2,name2,alfrq2)
C
C  Pedigree structure
      integer KNOWN, MAXALL, MAXSIZ, MAXLOC, MISS
      parameter(KNOWN=0,MAXALL=60,MAXSIZ=1000,MAXLOC=120,MISS=-9999)
      character*10 pedigree
      integer actset,num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      integer numloc
      real locus(MAXSIZ,MAXLOC)
      integer trait,mark1,mark2,wrk
      real th1,th2,th12
C
C allele frequencies within entire sample for given locus 
C
      integer numal, name(MAXALL)
      double precision alfrq(MAXALL)
      integer numal2, name2(MAXALL)
      double precision alfrq2(MAXALL)
C local variables
      integer contrib,df,hsibs,i,ifail,j,mark12,mark22,sibs
C regression results
      double precision x(4),r(10),b(3),cov(10)
      double precision mux,alpha,sea,beta,seb,tvalb,pi1,pi2
C
      logical last,samefa,samemo
      character*16 error
C functions
      double precision fibd,hibd,pihat, probst
C
      df=0
      ifail=1
      mark12=mark1+1
      mark22=mark2+1
      last=.false.
      hsibs=0
      sibs=0
      mux=0.0d0
      call inicov(4, 10, r)
      rewind(wrk)
    5 continue
        call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &             numloc, last)
        if (last) goto 20

        if (actset.le.0) goto 5

        do 10 i=nfound+1,num-1
         contrib=0 
         do 15 j=i+1,num
          samefa=(fa(i).eq.fa(j))
          samemo=(mo(i).eq.mo(j))
C
C Share at least one parent and both trait & marker values present
C
        if (locus(i,trait).ne.MISS .and. locus(j,trait).ne.MISS  .and.
     2      locus(i,mark1).gt.KNOWN .and. locus(j,mark1).gt.KNOWN .and.
     3      locus(i,mark2).gt.KNOWN .and. locus(j,mark2).gt.KNOWN .and.
     4      (samefa.or.samemo))  then
C full or half sibs
          if (contrib.eq.0) contrib=1
          sibs=sibs+1
          x(1)=1.0d0
          x(4)=dble(locus(i,trait)-locus(j,trait))**2
          if (samefa.and.samemo) then
C full sib
            pi1=fibd(locus(i,mark1),locus(i,mark12),
     2               locus(j,mark1),locus(j,mark12),
     3               locus(fa(i),mark1),locus(fa(i),mark12),
     4               locus(mo(i),mark1),locus(mo(i),mark12),
     5               numal,name,alfrq )
            pi2=fibd(locus(i,mark2),locus(i,mark22),
     2               locus(j,mark2),locus(j,mark22),
     3               locus(fa(i),mark2),locus(fa(i),mark22),
     4               locus(mo(i),mark2),locus(mo(i),mark22),
     5               numal2,name2,alfrq2 )
            x(2)=0.0d0
            x(3)=pihat(1,th1, th2, th12, pi1, pi2)
          else
C half sib
            hsibs=hsibs+1
            x(2)=1.0d0
            if (samefa) then
              pi1=hibd(locus(i,mark1),locus(i,mark12),
     2                 locus(j,mark1),locus(j,mark12),
     3                 locus(mo(i),mark1),locus(mo(i),mark12),
     4                 locus(fa(i),mark1),locus(fa(i),mark12),
     5                 locus(mo(j),mark1),locus(mo(j),mark12))
              pi2=hibd(locus(i,mark2),locus(i,mark22),
     2                 locus(j,mark2),locus(j,mark22),
     3                 locus(mo(i),mark2),locus(mo(i),mark22),
     4                 locus(fa(i),mark2),locus(fa(i),mark22),
     5                 locus(mo(j),mark2),locus(mo(j),mark22))
              x(3)=pihat(2,th1, th2, th12, pi1, pi2)
            else
              pi1=hibd(locus(i,mark1),locus(i,mark12),
     2                 locus(j,mark1),locus(j,mark12),
     3                 locus(fa(i),mark1),locus(fa(i),mark12),
     4                 locus(mo(i),mark1),locus(mo(i),mark12),
     5                 locus(fa(j),mark1),locus(fa(j),mark12))
              pi2=hibd(locus(i,mark2),locus(i,mark22),
     2                 locus(j,mark2),locus(j,mark22),
     3                 locus(fa(i),mark2),locus(fa(i),mark22),
     4                 locus(mo(i),mark2),locus(mo(i),mark22),
     5                 locus(fa(j),mark2),locus(fa(j),mark22))
              x(3)=pihat(2,th1, th2, th12, pi1, pi2)
            end if
          end if
          mux=mux+x(3)
          call givenc(r, 10, 4, x, 1.0d0, ifail)
        end if              
   15   continue
        df=df+contrib
   10  continue
      goto 5
   20 continue
C 
      mux=mux/dfloat(sibs)
      call alias(r, 10, 4, 1.0d-5, x, ifail)
      call bsub(r, 10, 4, b, 3, ifail)
      call var(r, 10, cov, 10, 4, sibs, 1, ifail)
      alpha=b(1)
      sea=sqrt(cov(1))
      beta=b(3)
      seb=sqrt(cov(6))
      tvalb=beta/seb
      error='                '
      if (ifail.ne.0) error='Regression error'
      df=df-2
      write(*,99) th12,th1,th2,sibs,mux,alpha,beta,
     2            tvalb,probst(tvalb,df,ifail),error,hsibs,
     3            sea, seb, df
   99 format(f5.3,3x,f5.3,2x,f5.3,1x,i4,2x,f5.3,2(3x,f9.3),3x,f6.2,
     2       4x,f5.3,/2x,a16,3x,i4,' (hsibs)',2(' (',f9.3,')'),
     3       '(df=',i4,')')
      return
      end
C end-of-twopair
C
C estimate regression coefficients for E(pi)=intercpt+b1*pi1+b2*pi2
C using Olson 1995
C
      double precision function pihat(typ, th1, th2, th12, pi1, pi2)
      integer typ
      real th1, th2, th12
      double precision pi1, pi2
      double precision a0, b1, b2, psi1, psi2, psi12
      psi1=1.0d0-2.0d0*dble(th1)*(1.0d0-dble(th1))
      psi2=1.0d0-2.0d0*dble(th2)*(1.0d0-dble(th2))
      psi12=1.0d0-2.0d0*dble(th12)*(1.0d0-dble(th12))
      a0=(1.0d0-psi1)*(1.0d0-psi2)/psi12
      b1=-psi2*(1.0d0-psi2)*(1-2.0d0*psi1)/psi12/(1-psi12)
      b2=-psi1*(1.0d0-psi1)*(1-2.0d0*psi2)/psi12/(1-psi12)
      if (typ.eq.2) a0=a0/2.0d0
      pihat=a0+b1*pi1+b2*pi2
      return
      end
C end-of-pihat
C
C Monte-Carlo approach to estimating IBD sharing at a marker
C
      subroutine wribd(wrk,gene,iter,burnin,typ,pedigree,actset,num,
     2              nfound,id,fa,mo,sex,locus, numloc,numal,name,
     3              alfrq,gfrq,untyped,set,set2,sibd,key,
     4              ibdcount, plevel)
      integer IBDSIZ, KNOWN, MAXALL, MAXG, MAXIBD, MAXSIZ, MAXLOC, MISS
      parameter(MAXALL=60, MAXG=MAXALL*(MAXALL+1)/2, MAXSIZ=1000, 
     2          MAXLOC=120, MISS=-9999, KNOWN=0, 
     3          MAXIBD=1000, IBDSIZ=MAXIBD*(MAXIBD+1)/2)
      integer burnin,gene,iter,wrk,plevel,typ
C  Pedigree structure
      character*10 pedigree
      integer actset,num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ)
      integer sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C allele frequencies structure
      integer numal, name(MAXALL)
      double precision alfrq(MAXALL), gfrq(MAXG)
C work arrays for metropolis algorithm
      integer nuntyp
      logical untyped(MAXSIZ)
      integer set(MAXSIZ,2), sibd(MAXSIZ,2), key(2*MAXSIZ)
C metropolis work arrays
      integer set2(MAXSIZ,2)
C untyped matings
      integer nummat, cntmat(MAXALL,2)
C ibd sharing
      double precision ibdcount(IBDSIZ)
C local variables
      integer g1,g2,gen2,i,idx,j,nfam
      logical alltyp,last,useful
      real den
      double precision zibd
C functions
      integer getnam

      if (typ.gt.2) then
        den=1.0
      else
        den=1.0/float(2*iter)
      end if
      gen2=gene+1
      last=.false.
      nfam=0
      rewind(wrk)
    5 continue
        call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &             numloc, last)
        if (last) goto 20

        if (actset.le.0 .or. num.gt.MAXIBD) goto 5
C
C test if informative pedigree -- at least one relative pair with
C marker genotype for both members
C
        useful=.false.
        do 7 i=1,num
        if (locus(i,gene).gt.KNOWN) then
          do 8 j=max(nfound+1,i+1),num
          if (locus(j,gene).gt.KNOWN) then
            useful=.true.
            goto 9
          end if
    8     continue
        end if
    7   continue
    9   continue
C
        if (.not.useful) goto 5
C
C Load genotypes into set()
        nfam=nfam+1
        nuntyp=0
        alltyp=.true.
        do 12 i=1,num
          if (locus(i,gene).le.KNOWN) then
            alltyp=.false.
            untyped(i)=.true.
            nuntyp=nuntyp+1
            if (locus(i,gene).eq.0 .or. locus(i,gene).eq.MISS) then
              g1=MISS
              g2=MISS
            else
              g1=getnam(-locus(i,gene),numal,name)
              g2=getnam(-locus(i,gen2),numal,name)
            end if
          else
            untyped(i)=.false.
            g1=getnam(locus(i,gene),numal,name)
            g2=getnam(locus(i,gen2),numal,name)
          end if
          call update(i,g1,g2,set)
   12   continue
        do 13 idx=1,num*(num-1)/2
          ibdcount(idx)=0.0d0
   13   continue
C
C IBS
C
        if (typ.gt.2) then
          idx=0
          do 15 i=2,num
            do 16 j=1,i-1
              idx=idx+1
              if (untyped(i) .or. untyped(j)) then
                ibdcount(idx)=-1.0d0
              else
                call share(set(i,1),set(i,2),
     &                     set(j,1),set(j,2),zibd)
                ibdcount(idx)=zibd
              end if
   16       continue
   15     continue
C
C IBD: all genotypes known
C
        elseif (alltyp) then
          do 10 it=1,iter
            call simibd(2,pedigree,num,nfound,fa,mo,set,sibd)
            idx=0
            do 25 i=2,num
              do 26 j=1,i-1
                idx=idx+1
                call share(sibd(i,1),sibd(i,2),
     &                     sibd(j,1),sibd(j,2),zibd)
                ibdcount(idx)=ibdcount(idx)+zibd+zibd
   26         continue
   25       continue
   10     continue
        else
C IBD: some untyped markers:
C produce genotype frequencies for Metropolis criterion
C enumerate untyped founder matings
          call genot(numal,alfrq,ngtp,gfrq)
          call tabmat(num,nfound,fa,mo,untyped,nummat,cntmat)
C Metropolis simulation of genotypes
          if (plevel.gt.1) then
            write(*,'(/2a,4(/a,i4))') 
     2        'Metropolis simulation of pedigree ',pedigree,
     3        'Untyped Individuals: ',nuntyp,
     4        'Possible genotypes : ',ngtp,
     5        'UnT x UnT matings  : ',nummat,
     6        'Burn-in (iters)    : ',burnin
          end if
          do 44 it=1,burnin
            call drop(it,pedigree,num,nfound,id,fa,mo,nummat,
     &             cntmat,untyped,numal,gfrq,set,set2,sibd,key,0)
   44     continue
          do 45 it=1,iter
            call drop(it,pedigree,num,nfound,id,fa,mo,nummat,
     &             cntmat,untyped,numal,gfrq,set,set2,sibd,key,plevel)
            call simibd(1,pedigree,num,nfound,fa,mo,set,set2)
            idx=0
            do 65 i=2,num
              do 66 j=1,i-1
                idx=idx+1
                call share(sibd(i,1),sibd(i,2),
     &                     sibd(j,1),sibd(j,2),zibd)
                ibdcount(idx)=ibdcount(idx)+zibd+zibd
   66         continue
   65       continue
   45     continue
        end if
        
        idx=0
        if (mod(typ,2).eq.1) then
          write(*,'(/2a/a8,1x,f5.2)') 'Pedigree ',pedigree,id(1),1.0
          do 70 i=2,num
            write(*,'(a8,1x,50f5.2,(/6x,50f5.2):)') 
     2        id(i), (den*ibdcount(j), j=idx+1,idx+i-1), 1.0
            idx=idx+i-1
   70     continue
        else
          do 80 i=2,num
          do 80 j=1,i-1
            idx=idx+1
            write(*,'(a10,2(1x,a8),1x,f6.3)') 
     &        pedigree, id(i), id(j), den*ibdcount(idx)
   80     continue
        end if
      goto 5
   20 continue
C
      return
      end
C end-of-wribd  
C
C Write kinship coefficients 
C
      subroutine dokin(wrk,typ,pedigree,actset,num,nfound,id,fa,mo,
     &                 sex,locus,numloc,ibdcount)
      integer IBDSIZ,MAXIBD,MAXSIZ,MAXLOC
      parameter (MAXSIZ=1000,MAXLOC=120,MAXIBD=1000, 
     &           IBDSIZ=MAXIBD*(MAXIBD+1)/2)
      integer nfound,actset,num,numloc,typ,wrk
C Pedigree structure
      character*10 pedigree
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ)
      integer sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C Array to contain kinship coefficients
      double precision ibdcount(IBDSIZ)
C
C local variables: gk,gl,hk,hl are parent-pair indices for dominance
      integer gk,gl,hk,hl,i,idx,j,tot
      double precision dom, meanf
      logical last
C functions
      integer clcpos

      meanf=0.0d0
      tot=0
      if (typ.eq.3) then
        write(*,'(3(/a)/2(/a))')
     2   '--------------------------------------------------',
     3   'Individuals with non-zero inbreeding coefficient',
     4   '--------------------------------------------------',
     5   'Pedigree   Person   Father   Mother   F',
     6   '---------- -------- -------- -------- -----'
      else
        write(*,'(3(/a))')
     2   '--------------------------------------------------',
     3   'Coefficient of relationship for all relative pairs',
     4   '--------------------------------------------------'
        if (typ.eq.2) then
          write(*,'(a//a/)') 
     2      'NOTE:  Writing one relative pair per record',
     3      'Pedigree   Person-1 Person-2    R     K'
        end if
      end if

      last=.false.
      rewind(wrk)
    5 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

       if (actset.le.0 .or. num.gt.MAXIBD) goto 5
C 
        call kinship(num,nfound,fa,mo,ibdcount)

        if (typ.eq.3) then
          idx=0
          tot=tot+num
          do 70 i=1,num
            idx=idx+i
            if (ibdcount(idx).gt.1.0d0) then
              meanf=meanf+ibdcount(idx)-1.0d0
              write(*,'(a10,3(1x,a8),1x,f5.3)') 
     &          pedigree,id(i),id(fa(i)),id(mo(i)),ibdcount(idx)-1.0d0
            end if
   70     continue
        else  
          idx=0
          if (typ.eq.1) then
            write(*,'(/2a)') 'Pedigree ',pedigree
            do 75 i=1,num
              write(*,'(a5,1x,50f5.2,(/6x,50f5.2):)') 
     2          id(i), (ibdcount(j), j=idx+1,idx+i)
              idx=idx+i
   75       continue
          else
            do 80 i=1,num
            do 80 j=1,i  
              idx=idx+1
              if (i.eq.j) then
                dom=1.0d0
              elseif (i.gt.nfound .and. j.gt.nfound) then
                gk=clcpos(fa(i),fa(j))
                hl=clcpos(mo(i),mo(j))
                gl=clcpos(fa(i),mo(j))
                hk=clcpos(mo(i),fa(j))
                dom=ibdcount(gk)*ibdcount(hl)+ibdcount(gl)*ibdcount(hk)
                dom=0.25d0*dom
              else
                dom=0.0d0
              end if
              write(*,'(a10,2(1x,a8),1x,f5.3,1x,f5.3)') 
     &          pedigree, id(i), id(j), ibdcount(idx), dom
   80       continue
          end if
        end if
      goto 5
   20 continue
      if (typ.eq.3) then
        if (tot.gt.0) meanf=meanf/dfloat(tot)
        write(*,'(/a,1x,f8.6,a,i5,a)') 'Mean inbreeding coefficient = ',
     &    meanf,' (based on ',tot,' individuals)'
      end if   
      return
      end
C end-of-dokin
C
C Calculate kinship coefficient
C
      subroutine kinship(num,nfound,fa,mo,ibdcount)
      integer IBDSIZ, MAXIBD, MAXSIZ
      parameter (MAXSIZ=1000, MAXIBD=1000, IBDSIZ=MAXIBD*(MAXIBD+1)/2)
      integer nfound,num
C Pedigree structure
      integer fa(MAXSIZ),mo(MAXSIZ)
C Array to contain kinship coefficients
      double precision ibdcount(IBDSIZ)
C local variables
      integer i,idx,j,posfa,posmo
C functions
      integer clcpos

      idx=0
      do 50 i=1,nfound
        do 55 j=1,i-1
          idx=idx+1
          ibdcount(idx)=0.0d0
   55   continue
        idx=idx+1
        ibdcount(idx)=1.0d0
   50 continue
      do 60 i=nfound+1, num
        do 65 j=1,i-1
          idx=idx+1
          posfa=clcpos(fa(i),j)
          posmo=clcpos(mo(i),j)
          ibdcount(idx)=0.5d0*(ibdcount(posfa)+ibdcount(posmo))
   65   continue
        idx=idx+1
        posfa=clcpos(fa(i),mo(i))
        ibdcount(idx)=1.0d0+0.5d0*ibdcount(posfa)
   60 continue
      return
      end
C end-of-kinship
C
C Calculate coefficient of fraternity
C
      subroutine frater(num,nfound,fa,mo,kin,dom)
      integer IBDSIZ, MAXIBD, MAXSIZ
      parameter (MAXSIZ=1000, MAXIBD=1000, IBDSIZ=MAXIBD*(MAXIBD+1)/2)
      integer nfound,num
C Pedigree structure
      integer fa(MAXSIZ),mo(MAXSIZ)
C Array to contain domship coefficients
      double precision kin(IBDSIZ), dom(IBDSIZ)
C local variables
      integer i,idx,j,gk,gl,hl,hk
C functions
      integer clcpos

      idx=0
      do 80 i=1,num
      do 80 j=1,i  
        idx=idx+1
        if (i.eq.j) then
          dom(idx)=1.0d0
        elseif (i.gt.nfound .and. j.gt.nfound) then
          gk=clcpos(fa(i),fa(j))
          hl=clcpos(mo(i),mo(j))
          gl=clcpos(fa(i),mo(j))
          hk=clcpos(mo(i),fa(j))
          dom(idx)=0.25d0 * (kin(gk)*kin(hl)+
     &                       kin(gl)*kin(hk))
        else
          dom(idx)=0.0d0
        end if
   80 continue
      return
      end
C end-of-frater
C
C Do ibs sharing ASP analysis as per Lange 1986 and Bishop 1990
C
      subroutine doasp(wrk,trait,locnam,gene,gt,thresh,pedigree,
     2                 actset,num,nfound,id,fa,mo,sex,locus,numloc,
     3                 numal,name,alfrq,ibd,untyped,set,plevel)
      integer IBDSIZ, KNOWN, MAXALL, MAXIBD, MAXSIZ, MAXLOC, MISS
      parameter(MAXIBD=1000, IBDSIZ=MAXIBD*(MAXIBD+1)/2, KNOWN=0,
     &          MAXALL=60, MAXSIZ=1000, MAXLOC=120, MISS=-9999)
      integer gene,actset,num,numloc,plevel,trait,wrk
      real thresh
      logical gt
      character*10 locnam
C Pedigree structure
      character*10 pedigree
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ)
      integer sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C allele frequencies structure
      integer numal, name(MAXALL)
      double precision alfrq(MAXALL)
C sibship ibd array 
      double precision ibd(IBDSIZ)
C work arrays for nucibd
      integer set(MAXSIZ,2)
      logical untyped(MAXSIZ)
C calculate expected ibs statistics for marker
      double precision p, p2, p4, pp, pq, pq2, q, f(3), h(3)
C 2 df chi-square
      integer tabf(3),tabh(3)
      double precision chif, chih, ef, eh, ex, muf, muh, mux, obs
C
      integer contrib,currf, currm, fin,gen2,i,ibs,j,k,nfs,nhs,pos
      character*3 histo
      double precision ibdp, ibsp, zibd
      logical last
C functions
      integer getnam
      real isaff
      double precision binp, chip

      muf=0.0d0
      muh=0.0d0
      mux=0.0d0
      do 1 i=1,3
        tabf(i)=0
        tabh(i)=0
    1 continue
      gen2=gene+1
      pedigree=' '
      last=.false.
      rewind(wrk)
C Calculate expected values for ibs statistic
      p2=0.0d0
      p4=0.0d0
      pp=0.0d0
      pq2=0.0d0
      do 3 i=1,numal
        p=alfrq(i)
        q=1.0d0-p
        p=p*p
        q=q*q
        p2=p2+p
        pq2=pq2+p*q
        p4=p4+p*p
        do 3 j=i+1,numal
          p=alfrq(i)
          q=alfrq(j)
          pq=1.0d0-p-q
          pp=pp+p*q*pq*pq
    3 continue
      f(3)=0.25d0*(1.0d0+2.0d0*p2*(1.0d0+p2)-p4)
      f(1)=0.25d0*(pq2+pp+pp)
      f(2)=1.0d0-f(3)-f(1)
      ef=f(3)+0.5d0*f(2)
      h(3)=0.5d0*(p2*(1.0d0+p2+p2)-p4)
      h(1)=2.0d0*f(1)
      h(2)=1.0d0-h(3)-h(1)
      eh=h(3)+0.5d0*h(2)
C
    5 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

        if (actset.le.0) goto 5
C
        do 7 i=1,num
        if (locus(i,gene).gt.KNOWN) then
          untyped(i)=.false.
          set(i,1)=getnam(locus(i,gene),numal,name)
          set(i,2)=getnam(locus(i,gen2),numal,name)
        else  
          untyped(i)=.true.
          set(i,1)=MISS
          set(i,2)=MISS
        end if
    7   continue
        fin=num
        currf=fa(fin)
        currm=mo(fin)
C only iterate nonfounders -- sibship by sibship
        do 90 k=num-1,nfound,-1
          if (fa(k).ne.currf .or. mo(k).ne.currm) then
            contrib=0
            do 92 i=k+1,fin
            if (isaff(locus(i,trait),thresh,gt).eq.2.0 .and.
     &          .not.untyped(i)) then
              contrib=contrib+1
            end if
   92       continue
C
C Skip if no usable individuals in this sibship
C
            if (contrib.gt.0) then

            call nucibd(gene,currf,currm,k+1,fin,set,untyped,ibd,
     &                  numal, name, alfrq)
            pos=0
            do 95 i=k+1,fin
              do 97 j=k+1,i-1
                pos=pos+1
                if (isaff(locus(i,trait),thresh,gt).eq.2.0 .and.
     2              isaff(locus(j,trait),thresh,gt).eq.2.0 .and.
     3              .not.untyped(i) .and. .not.untyped(j))
     4          then
                  sibs=sibs+1
                  call share(set(i,1), set(i,2),
     &                       set(j,1), set(j,2), zibd)
                  ibs=int(2.0d0*zibd)+1
                  mux=mux+ibd(pos)
                  tabf(ibs)=tabf(ibs)+1
                end if
   97         continue
              pos=pos+1
   95       continue
C
C half-sibs related to current sibship -- only scan sibships not yet visited
C stored in different style to full sibs
C
            do 300 i=nfound+1,k
              if (fa(i).eq.currf .or. mo(i).eq.currm .and.
     2            isaff(locus(i,trait),thresh,gt).eq.2.0 .and.
     3            .not.untyped(i)) then
                contrib=contrib+1
                do 302 j=k+1,fin
                if (isaff(locus(j,trait),thresh,gt).eq.2.0 .and.
     &              .not.untyped(j)) then
                  hsibs=hsibs+1
                  call share(set(i,1), set(i,2),
     &                       set(j,1), set(j,2), zibd)
                  ibs=int(2.0d0*zibd)+1
                  tabh(ibs)=tabh(ibs)+1
                end if
  302           continue
              end if
  300       continue

            end if
C Now update to next sibship
            fin=k
            currf=fa(fin)
            currm=mo(fin)
          end if
   90   continue
      goto 5 
   20 continue

      nfs=tabf(3)+tabf(2)+tabf(1)
      nhs=tabh(3)+tabh(2)+tabh(1)
      if (nfs.gt.0) muf=0.5d0*dfloat(2*tabf(3)+tabf(2))/dfloat(nfs)
      if (nhs.gt.0) muh=0.5d0*dfloat(2*tabh(3)+tabh(2))/dfloat(nhs)
      if (plevel.gt.0) then
        write(*,'(3a/)') 
     &    '----------- ASP analysis for "',locnam,'" --------------'
        write(*,'(2(12x,a/),2(a,i6,2x,3i6,6x,f6.4,3x,f6.4/))')
     2              'No. of  IBS Sharing         Mean IBS sharing',
     3              'Pairs   2/2   1/2   0/2         Obs      Exp',
     4    'Full-sibs',nfs,tabf(3),tabf(2),tabf(1), muf, ef,
     5    'Half-sibs',nhs,tabh(3),tabh(2),tabh(1), muh, eh
        write(*,'(2(12x,a/),2(a,8x,3f6.3/))')
     2              'Expectd IBS Sharing',
     3              '        2/2   1/2   0/2  ',
     4    'Full-sibs',f(3),f(2),f(1), 'Half-sibs',h(3),h(2),h(1)
      end if
      if (nfs.gt.0) then
        chif=0.0d0
        do 25 i=1,3
          ex=dfloat(nfs)*f(i)
          obs=dfloat(tabf(i))
          if (obs.gt.0.001d0 .and. ex.gt.0.001d0) then
            chif=chif+obs*log(obs/ex)
          end if
   25   continue
        chif=chif+chif
        ibsp=chip(chif,2)
        ibdp=binp(2.0d0*mux,dfloat(2*nfs)-2.0d0*mux)
        if (plevel.gt.0) then
          write(*,'(a,f6.1,a,f6.4,a/a,f6.4,a,f6.4,a)') 
     2    'Full-Sib Chi-square (2 df) =',chif,' (P=',ibsp,')',
     3    'Mean full-sib IBD sharing  =',mux/dfloat(nfs),
     4    ' (P=',ibdp,')'
          if (muf.lt.ef) then
            write(*,'(/a/)') 
     &        'NOTE:  Full-sib IBS sharing less than expected.'
          end if
        else
          call phist(ibsp,ibdp,histo)
          write(*,'(a10,1x,i6,5(1x,f6.4),2(1x,a))')
     &    locnam, nfs, muf, ef, ibsp, mux/dfloat(nfs), ibdp, 'ASP',histo
        end if
      end if
      if (nhs.gt.0) then
        chih=0.0d0
        do 35 i=1,3
          ex=dfloat(nhs)*h(i)
          obs=dfloat(tabh(i))
          if (obs.gt.0.001d0 .and. ex.gt.0.001d0) then
            chih=chih+obs*log(obs/ex)
          end if
   35   continue
        chih=chih+chih
        ibsp=chip(chih,2)
        if (plevel.gt.0) then
          write(*,'(a,f6.1,a,f6.4,a)') 
     &      'Half-Sib Chi-square (2 df) =',chih,' (P=',ibsp,')'
          if (muh.lt.eh) then
            write(*,'(/a/)') 
     &      'NOTE:  Half-sib IBS sharing less than expected.'
          end if
        end if
      end if
      return
      end
C end-of-doasp
C
C Perform monte-carlo based APM analysis
C
      subroutine doapm(wrk,trait,locnam,gene,typ,iter,burnin,gt,thresh,
     2                 pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     3                 numloc,numal,name,alfrq,cumfrq,gfrq,
     4                 set,set2,sibd,key,untyped,plevel)
C
      integer MAXALL, MAXG, MAXSIZ, MAXLOC, MISS, KNOWN
      parameter(MAXALL=60, MAXG=MAXALL*(MAXALL+1)/2, MAXSIZ=1000, 
     &          MAXLOC=120, MISS=-9999, KNOWN=0)
      integer burnin,gene,iter,plevel,trait,typ,wrk
      real thresh
      logical gt
      character*10 locnam
C pedigree structure
      character*10 pedigree
      integer sex(MAXSIZ)
      integer actset,num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ)
      integer set(MAXSIZ,2),sibd(MAXSIZ,2)
      logical untyped(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C metropolis work arrays
      integer set2(MAXSIZ,2),key(2*MAXSIZ)
C untyped matings
      integer nummat, cntmat(MAXALL,2)
C allele frequencies structure
      integer numal, name(MAXALL)
      double precision alfrq(MAXALL), cumfrq(MAXALL), gfrq(MAXG)
C
C list of affected individuals
C storage is affected ID in aff(1...aff), unaffected ID in aff(unaff...MAXSIZ)
C
      integer naff, unaff, aff(MAXSIZ)
C other local variables
      logical alltyp,fin,last
      integer gen2,g1,g2,i,j,k,nt,ut
      character*3 histo
      double precision den
C families containing AA, AU, UU, AA+AU, GPM/WH pairs
      logical pair(5)
C number of families containing AA, AU, UU, or any AA, AU, UU pairs
      integer nfam(4)
C ibd [,1] or ibs [,1-3] based statistics
      double precision wt,z(5,3),oz(5,3),t(5,3),sz(5,3),v(5,3)
      double precision n(5,3), d(5,3), pval(5,3), zsum(5,3)
C functions
      integer eow, getnam
      real isaff
      double precision makewt, simil, ppnd, zp
C
      if (numal.eq.0) then
        return
      end if
      den=dfloat(iter)
      gen2=gene+1
      nt=0
      ut=0
      do 4 j=1,4
        nfam(j)=0
    4 continue
      do 5 j=1,5
      do 5 k=1,3
        zsum(j,k)=0.0d0
        n(j,k)=0.0d0
        d(j,k)=0.0d0
    5 continue

      if (plevel.gt.0) then
        write(*,'(/3a/)') 
     &    '----------- APM analysis for "',locnam,'" --------------'
      end if

      last=.false.
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

        if (actset.le.0) goto 10
C
C transfer genotype to set() and record if typed in untyped()
C record affection status in set2(,2)
C
         alltyp=.true.
         nuntyp=0
         do 6 i=1,num
          if (locus(i,gene).le.KNOWN) then
            alltyp=.false.
            untyped(i)=.true.
            nuntyp=nuntyp+1
            if (locus(i,gene).eq.0 .or. locus(i,gene).eq.MISS) then
              if (typ.eq.1) then
                g1=0
                g2=0
              else
                write(*,'(a/7x,a)') 
     2            'ERROR: Starting genotypes were not generated.',
     3            'Imputation must be set to higher than -1.'
                return 
              end if
            else
              g1=getnam(-locus(i,gene),numal,name)
              g2=getnam(-locus(i,gen2),numal,name)
            end if
          else
            untyped(i)=.false.
            g1=getnam(locus(i,gene),numal,name)
            g2=getnam(locus(i,gen2),numal,name)
          end if
          call update(i,g1,g2,set)
          set2(i,2)=int(isaff(locus(i,trait),thresh,gt))
          set2(i,1)=0
    6   continue
C
C store number of offspring in set2(,1)
C
        do 7 i=nfound+1,num
          set2(fa(i),1)=set2(fa(i),1)+1
          set2(mo(i),1)=set2(mo(i),1)+1
    7   continue
C
C trim uninformative persons ie untyped individuals with no offspring
C by setting their affection status to missing -- update their parents
C offspring number (so that end with number of informative offspring)
C
    8   continue
          fin=.true.
          do 9 i=1,num
          if (set2(i,1).eq.0 .and. untyped(i)) then
            fin=.false.
            set2(i,1)=MISS
            set2(i,2)=MISS
            set2(fa(i),1)=set2(fa(i),1)-1
            set2(mo(i),1)=set2(mo(i),1)-1
          end if
    9     continue
        if (.not.fin) goto 8
C
C transfer affection status to list
C
        naff=0
        unaff=MAXSIZ+1
        do 12 i=1,num
        if (.not.untyped(i) .or. typ.eq.2) then
          if (set2(i,2).eq.2) then
            naff=naff+1
            aff(naff)=i
          elseif (set2(i,2).eq.1) then
            unaff=unaff-1
            aff(unaff)=i
          end if
        end if
   12   continue
         unaff=MAXSIZ+1-unaff
C
C check if family appropriate for different (or any) statistics
C
         if ((naff+unaff).lt.2 .or. num.le.3) then
           if (plevel.gt.0) write(*,'(a,a10//a,/)')
     &       'Pedigree ',pedigree, ' Insufficient persons typed'
           goto 10
         end if
         nfam(4)=nfam(4)+1
         pair(1)=.false.
         pair(2)=.false.
         pair(3)=.false.
         pair(4)=.true.
         pair(5)=.false.
         if (naff.gt.1) then
           nfam(1)=nfam(1)+1
           pair(1)=.true.
           pair(5)=.true.
         end if
         if (naff.gt.0 .and. unaff.gt.0) then
           nfam(2)=nfam(2)+1
           pair(2)=.true.
           if (typ.eq.1) pair(5)=.true.
         end if
         if (unaff.gt.1) then
           nfam(3)=nfam(3)+1
           pair(3)=.true.
         end if
         nt=nt+naff
         ut=ut+unaff
C if ibs based statistic
         if (typ.eq.1) then
           call clcibs(naff,unaff,aff,alfrq,set,oz)
           do 11 j=1,5
           do 11 k=1,3
             pval(j,k)=0.0d0
             sz(j,k)=0.0d0
             v(j,k)=0.0d0
   11      continue
C
C generate ibs distribution under null
C
           do 14 i=1, iter
             call simped(num,nfound,fa,mo,cumfrq,set)
             call clcibs(naff,unaff,aff,alfrq,set,z)
C 
C only update statistic if appropriate family
C
             do 13 j=1,5
             if (pair(j)) then
               do 113 k=1,3
                 if (j.ne.2) then
                   if (z(j,k).gt.oz(j,k) .or. (z(j,k).eq.oz(j,k) .and.
     &               random().gt.0.5)) pval(j,k)=pval(j,k)+1.0d0
                 else
                   if (z(j,k).lt.oz(j,k) .or. (z(j,k).eq.oz(j,k) .and.
     &               random().gt.0.5)) pval(j,k)=pval(j,k)+1.0d0
                 end if
                 call moment(i,z(j,k),sz(j,k),v(j,k))
  113          continue
             end if
   13        continue
   14      continue
C
           do 17 j=1,5
           if (pair(j)) then
             do 117 k=1,3
               if (pval(j,k).eq.0.0d0) then
                 pval(j,k)=0.5d0/den
               elseif (pval(j,k).eq.den) then
                 pval(j,k)=1.0d0-0.5d0/den
               else
                 pval(j,k)=pval(j,k)/den
               end if
               zsum(j,k)=zsum(j,k)+ppnd(1.0d0-pval(j,k))
               v(j,k)=v(j,k)/dfloat(max(1,iter-1))
               if (v(j,k).gt.0) then
                 wt=makewt(j,naff,unaff,v(j,k))
                 t(j,k)=(oz(j,k)-sz(j,k))/sqrt(v(j,k))
                 n(j,k)=n(j,k)+wt*(oz(j,k)-sz(j,k))
                 d(j,k)=d(j,k)+wt*wt*v(j,k)
               else
                 t(j,k)=0.0d0
               end if
  117        continue
           else
             t(j,1)=0.0d0
             t(j,2)=0.0d0
             t(j,3)=0.0d0
           end if  
   17      continue
           if (plevel.gt.1) then
             write(*,'(a,a10,a/a,3(/a,4(1x,f10.3),1x,f6.4))')
     2       'Pedigree ',pedigree,
     3       '  E(Z)     Var(Z)         Z          T      MC-P',
     4       'Aff-Aff',
     5       'f(p) = 1        ',sz(1,1),v(1,1),oz(1,1),t(1,1),pval(1,1),
     6       'f(p) = 1/sqrt(p)',sz(1,2),v(1,2),oz(1,2),t(1,2),pval(1,2),
     7       'f(p) = 1/p      ',sz(1,3),v(1,3),oz(1,3),t(1,3),pval(1,3)
             write(*,'(a,3(/a,4(1x,f10.3),1x,f6.4))')
     2       'Aff-UnA',
     3       'f(p) = 1        ',sz(2,1),v(2,1),oz(2,1),t(2,1),pval(2,1),
     4       'f(p) = 1/sqrt(p)',sz(2,2),v(2,2),oz(2,2),t(2,2),pval(2,2),
     5       'f(p) = 1/p      ',sz(2,3),v(2,3),oz(2,3),t(2,3),pval(2,3)
             write(*,'(a,3(/a,4(1x,f10.3),1x,f6.4))')
     2       'Aff-Aff v. Aff-UnA',
     3       'f(p) = 1        ',sz(5,1),v(5,1),oz(5,1),t(5,1),pval(5,1),
     4       'f(p) = 1/sqrt(p)',sz(5,2),v(5,2),oz(5,2),t(5,2),pval(5,2),
     5       'f(p) = 1/p      ',sz(5,3),v(5,3),oz(5,3),t(5,3),pval(5,3)
             write(*,'(a,3(/a,4(1x,f10.3),1x,f6.4))')
     2       'GPM',
     4       'f(p) = 1        ',sz(4,1),v(4,1),oz(4,1),t(4,1),pval(4,1),
     5       'f(p) = 1/sqrt(p)',sz(4,2),v(4,2),oz(4,2),t(4,2),pval(4,2),
     6       'f(p) = 1/p      ',sz(4,3),v(4,3),oz(4,3),t(4,3),pval(4,3)
             write(*,'(/a,10(1x,a)/(10x,10(1x,a)):)') 
     &         'Affecteds:',(id(aff(i))(1:eow(id(aff(i)))),i=1,naff)
             write(*,'(a,10(1x,a)/(10x,10(1x,a)):)') 
     2         'Unaffectd:',(id(aff(i))(1:eow(id(aff(i)))),
     3                       i=MAXSIZ+1-unaff,MAXSIZ)
             write(*,'(/i5,a,i5,a/)') 
     &          naff,' affecteds and ',unaff,' unaffecteds used'
           end if
C else ibd based statistic calculated
        elseif (typ.eq.2) then
           sz(1,1)=0.0d0
           sz(2,1)=0.0d0
           sz(3,1)=0.0d0
           sz(4,1)=0.0d0
           sz(5,1)=0.0d0
           if (alltyp) then
             do 22 i=1,iter
               call simibd(2,pedigree,num,nfound,fa,mo,set,sibd)
               call clcibd(naff,unaff,aff,sibd,z)
               sz(1,1)=sz(1,1)+z(1,1)
               sz(2,1)=sz(2,1)+z(2,1)
               sz(3,1)=sz(3,1)+z(3,1)
               sz(4,1)=sz(4,1)+z(4,1)
               sz(5,1)=sz(5,1)+simil(nfound,naff,aff,sibd,key)
   22        continue
           else
C some untyped markers:
C produce genotype frequencies for Metropolis criterion
C enumerate untyped founder matings
             call genot(numal,alfrq,ngtp,gfrq)
             call tabmat(num,nfound,fa,mo,untyped,nummat,cntmat)
C
C Metropolis simulation of genotypes
C
             if (plevel.gt.2) then
               write(*,'(/2a,4(/a,i4))') 
     2           'Metropolis simulation of pedigree ',pedigree,
     3           'Untyped Individuals: ',nuntyp,
     4           'Possible genotypes : ',ngtp,
     5           'UnT x UnT matings  : ',nummat,
     6           'Burn-in (iters)    : ',burnin
             end if
             do 24 it=1,burnin
               call drop(it,pedigree,num,nfound,id,fa,mo,nummat,
     2                   cntmat,untyped,numal,gfrq,set,set2,sibd,
     3                   key,0)
   24        continue
             do 25 it=1,iter
               call drop(it,pedigree,num,nfound,id,fa,mo,nummat,
     2                   cntmat,untyped,numal,gfrq,set,set2,sibd,
     3                   key,plevel)
               call clcibd(naff,unaff,aff,sibd,z)
               sz(1,1)=sz(1,1)+z(1,1)
               sz(2,1)=sz(2,1)+z(2,1)
               sz(3,1)=sz(3,1)+z(3,1)
               sz(4,1)=sz(4,1)+z(4,1)
               sz(5,1)=sz(5,1)+simil(nfound,naff,aff,sibd,key)
   25        continue
           end if
C
C now take mean statistics over different ibd realizations
C
           oz(1,1)=sz(1,1)/den
           oz(2,1)=sz(2,1)/den
           oz(3,1)=sz(3,1)/den
           oz(4,1)=sz(4,1)/den
           oz(5,1)=sz(5,1)/den
C
C generate ibd distribution under null
C
           do 29 j=1,5
             pval(j,1)=0.0d0
             sz(j,1)=0.0d0
             v(j,1)=0.0d0
   29      continue
           do 30 i=1, iter
             call simibd(1,pedigree,num,nfound,fa,mo,set,sibd)
             call clcibd(naff,unaff,aff,sibd,z)
             z(5,1)=simil(nfound,naff,aff,sibd,key)
             do 130 j=1,5
             if (pair(j)) then
               if (j.ne.2) then
                 if (z(j,1).gt.oz(j,1) .or. (z(j,1).eq.oz(j,1) .and.
     &               random().gt.0.5)) pval(j,1)=pval(j,1)+1.0d0
               else
                 if (z(j,1).lt.oz(j,1) .or. (z(j,1).eq.oz(j,1) .and.
     &               random().gt.0.5)) pval(j,1)=pval(j,1)+1.0d0
               end if
               call moment(i,z(j,1),sz(j,1),v(j,1))
             end if
  130        continue
   30      continue
           do 36 j=1,5
           if (pair(j)) then
             if (pval(j,1).eq.0.0d0) then
               pval(j,1)=0.5d0/den
             elseif (pval(j,1).eq.den) then
               pval(j,1)=1.0d0-0.5d0/den
             else
               pval(j,1)=pval(j,1)/den
             end if
             zsum(j,1)=zsum(j,1)+ppnd(1.0d0-pval(j,1))
             v(j,1)=v(j,1)/dfloat(max(1,iter-1))
             if (v(j,1).gt.0.0d0) then
               t(j,1)=(oz(j,1)-sz(j,1))/sqrt(v(j,1))
               wt=makewt(j,naff,unaff,v(j,1))
               n(j,1)=n(j,1)+wt*(oz(j,1)-sz(j,1))
               d(j,1)=d(j,1)+wt*wt*v(j,1)
             else
               t(j,1)=0.0d0
             end if
           else
             t(j,1)=0.0d0
           end if
   36      continue
           if (plevel.gt.1) then
             write(*,'(a,a10,a,4(/a,4(1x,f10.3),1x,f6.4))')
     2       'Pedigree ',pedigree,
     3       '  E(Z)     Var(Z)         Z          T      MC-P',
     4       'ibd-based Af-Af ',sz(1,1),v(1,1),oz(1,1),t(1,1),pval(1,1),
     5       'ibd-based Af-Un ',sz(2,1),v(2,1),oz(2,1),t(2,1),pval(2,1),
     6       'ibd-based GPM   ',sz(4,1),v(4,1),oz(4,1),t(4,1),pval(4,1),
     7       'Whit-Halp Score ',sz(5,1),v(5,1),oz(5,1),t(5,1),pval(5,1)
             write(*,'(/a,10(1x,a)/(10x,10(1x,a)):)') 
     &         'Affecteds:',(id(aff(i))(1:eow(id(aff(i)))),i=1,naff)
             write(*,'(a,10(1x,a)/(10x,10(1x,a)):)') 
     2         'Unaffectd:',(id(aff(i))(1:eow(id(aff(i)))),
     3                       i=MAXSIZ+1-unaff,MAXSIZ)
             write(*,'(/i5,a,i5,a/)') 
     &          naff,' affecteds and ',unaff,' unaffecteds used'
           end if
        end if
C end of main loop
      goto 10
   20 continue
      if (plevel.gt.0) then
        write(*,'(/a)')
     &    'Overall statistics        T  NFam  Asy-P InvZ-P' 
      end if
      if (typ.eq.1) then
        do 45 j=1,5
        do 45 k=1,3
          if (nfam(min(j,4)).gt.0) then
            zsum(j,k)=zp(zsum(j,k)/sqrt(dfloat(nfam(min(j,4)))))
          end if
          if (d(j,k).gt.0.0d0) then
            t(j,k)=n(j,k)/sqrt(d(j,k))
          else
            t(j,k)=0.0d0
          end if
   45   continue
        if (plevel.gt.0) then
          write(*,'(a,3(/a,1x,f10.3,1x,i5,2(1x,f6.4)))')
     2      'Aff-Aff',
     3      'f(p) = 1        ',t(1,1),nfam(1),zp(t(1,1)),zsum(1,1),
     4      'f(p) = 1/sqrt(p)',t(1,2),nfam(1),zp(t(1,2)),zsum(1,2),
     5      'f(p) = 1/p      ',t(1,3),nfam(1),zp(t(1,3)),zsum(1,3) 
          write(*,'(a,3(/a,1x,f10.3,1x,i5,2(1x,f6.4)))')
     2      'Aff-UnA',
     3      'f(p) = 1        ',t(2,1),nfam(2),zp(-t(2,1)),zsum(2,1),
     4      'f(p) = 1/sqrt(p)',t(2,2),nfam(2),zp(-t(2,2)),zsum(2,2),
     5      'f(p) = 1/p      ',t(2,3),nfam(2),zp(-t(2,3)),zsum(2,3) 
          write(*,'(a,3(/a,1x,f10.3,1x,i5,2(1x,f6.4)))')
     2      'Aff-Aff v. Aff-UnA',
     3      'f(p) = 1        ',t(5,1),nfam(4),zp(t(5,1)),zsum(5,1),
     4      'f(p) = 1/sqrt(p)',t(5,2),nfam(4),zp(t(5,2)),zsum(5,2),
     5      'f(p) = 1/p      ',t(5,3),nfam(4),zp(t(5,3)),zsum(5,3) 
          write(*,'(a,3(/a,1x,f10.3,1x,i5,2(1x,f6.4)))')
     2      'GPM',
     3      'f(p) = 1        ',t(4,1),nfam(4),zp(t(4,1)),zsum(4,1),
     4      'f(p) = 1/sqrt(p)',t(4,2),nfam(4),zp(t(4,2)),zsum(4,2),
     5      'f(p) = 1/p      ',t(4,3),nfam(4),zp(t(4,3)),zsum(4,3) 
          write(*,'(/a,i5,a,i5,a)') 
     &      'Total of ',nt,' affecteds and ',ut,' unaffecteds used.'
        else
          call phist(zp(t(1,2)), zsum(1,2), histo)
          write(*,'(a10,2(1x,i6),1x,f10.1,2(1x,f6.4),1x,i6,2(1x,a))')
     2      locnam,nfam(1),nt,t(1,2),zp(t(1,2)),zsum(1,2),iter,
     3      'APM-IBS',histo
          call phist(zp(t(4,2)), zsum(4,2), histo)
          write(*,'(a10,2(1x,i6),1x,f10.1,2(1x,f6.4),1x,i6,2(1x,a))')
     2      locnam,nfam(4),nt,t(4,2),zp(t(4,2)),zsum(4,2),iter,
     3      'GPM-IBS',histo
        end if
      elseif (typ.eq.2) then
        if (nfam(1).gt.0) then
          zsum(1,1)=zp(zsum(1,1)/sqrt(dfloat(nfam(1))))
          zsum(5,1)=zp(zsum(5,1)/sqrt(dfloat(nfam(1))))
        end if
        if (nfam(2).gt.0) zsum(2,1)=zp(zsum(2,1)/sqrt(dfloat(nfam(2))))
        if (nfam(4).gt.0) zsum(4,1)=zp(zsum(4,1)/sqrt(dfloat(nfam(4))))
        do 50 j=1,5
        if (d(j,1).gt.0.0d0) then
          t(j,1)=n(j,1)/sqrt(d(j,1))
        else
          t(j,1)=0.0d0
        end if
   50   continue

        if (plevel.gt.0) then
          write(*,'(4(/a,1x,f10.3,1x,i5,2(1x,f6.4)))')
     2      'ibd-based Af-Af ',t(1,1),nfam(1),zp(t(1,1)),zsum(1,1),
     3      'ibd-based Af-Un ',t(2,1),nfam(2),zp(-t(2,1)),zsum(2,1),
     4      'ibd-based GPM   ',t(4,1),nfam(4),zp(t(4,1)),zsum(4,1),
     5      'Whit-Halp Score ',t(5,1),nfam(1),zp(t(5,1)),zsum(5,1) 
          write(*,'(/a,i5,a,i5,a)') 
     &      'Total of ',nt,' affecteds and ',ut,' unaffecteds used.'
        else
          call phist(zp(t(1,1)), zsum(1,1), histo)
          write(*,'(a10,2(1x,i6),1x,f10.1,2(1x,f6.4),1x,i6,2(1x,a))')
     2      locnam,nfam(1),nt,t(1,1),zp(t(1,1)),zsum(1,1),iter,
     3      'APM-IBD',histo
          call phist(zp(t(4,1)), zsum(4,1), histo)
          write(*,'(a10,2(1x,i6),1x,f10.1,2(1x,f6.4),1x,i6,2(1x,a))')
     2      locnam,nfam(4),nt,t(4,1),zp(t(4,1)),zsum(4,1),iter,
     3      'GPM-IBD',histo
        end if
      end if
      return
      end
C end-of-doapm
C
C calculate some plausible weights to allow combination of APM statistics
C from different pedigrees
C type=1 pair=AA, 2 AU, 3 UU, 4 GPM, 5 W-H
C
      double precision function makewt(typ,naff,unaff,var)
      integer typ, naff, unaff
      double precision var
      makewt=0.0d0
      if ((typ.eq.1 .or. typ.eq.5) .and. naff.gt.1) then
        makewt=sqrt(dfloat(naff-1))/sqrt(var)
      elseif (typ.eq.3 .and. unaff.gt.1) then
        makewt=sqrt(dfloat(unaff-1))/sqrt(var)
      elseif (typ.eq.2 .and.(naff+unaff).gt.1) then
        makewt=sqrt(dfloat(naff+unaff-1))/sqrt(var)
      elseif (typ.eq.4 .and.(naff+unaff).gt.1) then
        makewt=dfloat(naff+unaff-1)
        makewt=sqrt(0.5d0*makewt*(makewt-1.0d0))/sqrt(var)
      end if
      return
      end
C end-of-makewt
C
C calculate ibs statistic 
C                      
      subroutine clcibs(naff,unaff,aff,alfrq,set,z)
      integer MAXSIZ, MAXALL
      parameter(MAXSIZ=1000, MAXALL=60)
      integer naff,unaff,aff(MAXSIZ),set(MAXSIZ,2)
      double precision alfrq(MAXALL), z(5,3)
      integer i,j,g1,g2,g3,g4,p1,p2
      double precision d1,d2,pr1,pr2
C functions
      double precision delta
      do 5 i=1,5
      do 5 j=1,3
        z(i,j)=0.0d0
    5 continue
C AA statistic
      if (naff.gt.1) then
      do 10 i=1,naff-1
        p1=aff(i)
        g1=set(p1,1)
        g2=set(p1,2)
        pr1=1.0d0/alfrq(g1)
        pr2=1.0d0/alfrq(g2)
        do 10 j=i+1,naff
          p2=aff(j)
C --- the most recent versions of APM exclude parent-offspring pairs
C --- as a method to increase power to detect linkage over association
C           if (fa(p1).ne.p2 .and. mo(p1).ne.p2 .and.
C    &        fa(p2).ne.p1.and.mo(p2).ne.p1) then
C
          g3=set(p2,1)
          g4=set(p2,2)
          d1=delta(g1,g3)+delta(g1,g4)
          d2=delta(g2,g3)+delta(g2,g4)
          z(1,1)=z(1,1)+d1+d2
          z(1,2)=z(1,2)+d1*sqrt(pr1)+d2*sqrt(pr2)
          z(1,3)=z(1,3)+d1*pr1+d2*pr2
   10 continue
      end if
C AU statistic
      if (naff.gt.0 .and. unaff.gt.0) then
      do 20 i=1,naff
        p1=aff(i)
        g1=set(p1,1)
        g2=set(p1,2)
        pr1=1.0d0/alfrq(g1)
        pr2=1.0d0/alfrq(g2)
        do 20 j=MAXSIZ+1-unaff,MAXSIZ
          p2=aff(j)
          g3=set(p2,1)
          g4=set(p2,2)
          d1=delta(g1,g3)+delta(g1,g4)
          d2=delta(g2,g3)+delta(g2,g4)
          z(2,1)=z(2,1)+d1+d2
          z(2,2)=z(2,2)+d1*sqrt(pr1)+d2*sqrt(pr2)
          z(2,3)=z(2,3)+d1*pr1+d2*pr2
   20 continue
      end if
C UU statistic
      if (unaff.gt.1) then
      do 30 i=MAXSIZ+1-unaff,MAXSIZ-1
        p1=aff(i)
        g1=set(p1,1)
        g2=set(p1,2)
        pr1=1.0d0/alfrq(g1)
        pr2=1.0d0/alfrq(g2)
        do 30 j=i+1,MAXSIZ
          p2=aff(j)
          g3=set(p2,1)
          g4=set(p2,2)
          d1=delta(g1,g3)+delta(g1,g4)
          d2=delta(g2,g3)+delta(g2,g4)
          z(3,1)=z(3,1)+d1+d2
          z(3,2)=z(3,2)+d1*sqrt(pr1)+d2*sqrt(pr2)
          z(3,3)=z(3,3)+d1*pr1+d2*pr2
   30 continue
      end if
C Rescale appropriately
      do 40 i=1,3
      do 40 j=1,3
        z(i,j)=0.25d0*z(i,j)
   40 continue
C Combined statistic
      if (naff.gt.1) then
        z(4,1)=z(4,1)+z(1,1)/naff/(naff-1)
        z(4,2)=z(4,2)+z(1,2)/naff/(naff-1)
        z(4,3)=z(4,3)+z(1,3)/naff/(naff-1)
      end if
      if (naff.gt.1 .and. unaff.gt.1) then
        z(5,1)=2.0d0*z(4,1)-z(2,1)/naff/unaff
        z(5,2)=2.0d0*z(4,2)-z(2,2)/naff/unaff
        z(5,3)=2.0d0*z(4,3)-z(2,3)/naff/unaff
        z(4,1)=z(4,1)-z(2,1)/naff/unaff
        z(4,2)=z(4,2)-z(2,2)/naff/unaff
        z(4,3)=z(4,3)-z(2,3)/naff/unaff
      end if
      if (unaff.gt.1) then
        z(4,1)=z(4,1)+z(3,1)/unaff/(unaff-1)
        z(4,2)=z(4,2)+z(3,2)/unaff/(unaff-1)
        z(4,3)=z(4,3)+z(3,3)/unaff/(unaff-1)
      end if
      return
      end
C end-of-clcibs
C
C measure of IBS sharing 
C
      double precision function delta(g1,g2)
      integer g1, g2
      delta=1.0d0
      if (g1.ne.g2) delta=0.0d0
      return
      end
C end-of-delta
C
C calculate ibd sharing statistic based on simulated ibd
C
      subroutine clcibd(naff,unaff,aff,sibd,zibd)
      integer MAXSIZ
      parameter(MAXSIZ=1000)
      integer naff,unaff,aff(MAXSIZ),sibd(MAXSIZ,2)
      double precision zibd(5,3)
      integer i,j,g1,g2,g3,g4,p1,p2
      double precision ibd

      zibd(1,1)=0.0d0
      zibd(2,1)=0.0d0
      zibd(3,1)=0.0d0
      zibd(4,1)=0.0d0
      zibd(5,1)=0.0d0
C AA statistic
      if (naff.gt.1) then
      do 10 i=1,naff-1
        p1=aff(i)
        g1=sibd(p1,1)
        g2=sibd(p1,2)
        do 10 j=i+1,naff
          p2=aff(j)
          g3=sibd(p2,1)
          g4=sibd(p2,2)
          call share(g1,g2,g3,g4,ibd)
          zibd(1,1)=zibd(1,1)+ibd
   10 continue
      end if
C AU statistic
      if (naff.gt.0 .and. unaff.gt.0) then
      do 20 i=1,naff
        p1=aff(i)
        g1=sibd(p1,1)
        g2=sibd(p1,2)
        do 20 j=MAXSIZ+1-unaff,MAXSIZ
          p2=aff(j)
          g3=sibd(p2,1)
          g4=sibd(p2,2)
          call share(g1,g2,g3,g4,ibd)
          zibd(2,1)=zibd(2,1)+ibd
   20 continue
      end if
C UU statistic
      if (unaff.gt.1) then
      do 30 i=MAXSIZ+1-unaff,MAXSIZ-1
        p1=aff(i)
        g1=sibd(p1,1)
        g2=sibd(p1,2)
        do 30 j=i+1,MAXSIZ
          p2=aff(j)
          g3=sibd(p2,1)
          g4=sibd(p2,2)
          call share(g1,g2,g3,g4,ibd)
          zibd(3,1)=zibd(3,1)+ibd
   30 continue
      end if
C Combined statistic
      if (naff.gt.1) 
     &  zibd(4,1)=zibd(4,1)+zibd(1,1)/naff/(naff-1)
      if (naff.gt.1 .and. unaff.gt.1) 
     &  zibd(4,1)=zibd(4,1)-zibd(2,1)/naff/unaff
      if (unaff.gt.1) 
     &  zibd(4,1)=zibd(4,1)+zibd(3,1)/unaff/(unaff-1)
      return
      end
C end-of-clcibd
C
C return IBD sharing for relative pair based on ibd-alleles
C
      subroutine share(g1,g2,g3,g4,zibd)
      integer g1,g2,g3,g4
      double precision zibd
      if ((g1.eq.g3 .and. g2.eq.g4).or.(g1.eq.g4 .and. g2.eq.g3)) then
        zibd=1.0d0
      elseif (g1.eq.g3 .or. g1.eq.g4 .or. g2.eq.g3 .or. g2.eq.g4) then
        zibd=0.5d0
      else
        zibd=0.0d0
      end if
      return
      end
C end-of-share
C
C Whittemore's & Halpern's (Biometrics 1994; 50:118-127) measure
C of ibd sharing for multiple relatives
C
C for a set of N individuals, enumerate 2**N vectors containing
C one ibd-allele from each person.  For each such set u_i, calculate
C a measure of overall similarity as the number of [additional] "nontrivial"
C permutations of that set that leave u unchanged.  For example, if
C 3 individuals are {1/2} {1/3} {1/2}, there are 8 u's, which give a total
C abc  Legal permutations (excl obs)   of 10 possible permutations, with
C 111  5    acb, bac, bca, cab, cba    a mean of 10/8.  If a 4th relative
C 112  1    bac                        was ibd-genotype {4/5}, the mean
C 131  1    cba                        would be 10/16.  The mean score (S)
C 132  0                               is used to derive a standardized
C 211  1    acb                        score [S-E(S)]/SD(S), as in the APM
C 212  1    cba                        method, although direct enumeration
C 231  0                               is of course feasible for small N.
C 232  1    cba                        
C
C Randomized version
C
      double precision function simil(nfound,naff,aff,sibd,key)
      integer MAXSIZ
      parameter(MAXSIZ=1000)
      integer nfound, naff, aff(MAXSIZ), sibd(MAXSIZ,2)
      integer key(2*MAXSIZ)
      integer i,idx,j,k,tperm
      double precision perm, sum
C functions
      integer irandom
      double precision fact
C
      sum=0.0d0
C
C enumerate all permutations if number of probands (n) < 10
C otherwise sample 1024 random permutations from 2^n
C calls bitwise and, either as and() or iand(), depending on system
C
      if (naff.lt.10) then
        tperm=2**naff
        do 10 i=1,tperm 
          do 15 j=1,2*nfound
            key(j)=0
   15     continue
          k=1
          do 20 j=1,naff
            idx=1

#ifdef F2C
            if (k.eq.and(i,k)) idx=2
#endif F2C
#ifdef HPUX
            if (k.eq.iand(i,k)) idx=2
#endif HPUX
#ifdef DEC
            if (k.eq.iand(i,k)) idx=2
#endif DEC
#ifdef SUN
            if (k.eq.and(i,k)) idx=2
#endif SUN

            k=2*k
            key(sibd(aff(j),idx))=key(sibd(aff(j),idx))+1
   20     continue
          perm=0.0d0
          do 25 j=1,2*nfound
          if (key(j).gt.1) then
            if (perm.eq.0.0d0) then
              perm=fact(key(j))
            else
              perm=perm*fact(key(j))
            end if
          end if
   25     continue
          perm=max(perm-1.0d0,0.0d0)
          sum=sum+perm
   10   continue
      else
        tperm=1024
        do 110 i=1,tperm
          do 115 j=1,2*nfound
            key(j)=0
  115     continue
          do 120 j=1,naff
            idx=irandom(1,2)
            key(sibd(aff(j),idx))=key(sibd(aff(j),idx))+1
  120     continue
          perm=0.0d0
          do 125 j=1,2*nfound
          if (key(j).gt.1) then
            if (perm.eq.0.0d0) then
              perm=fact(key(j))
            else
              perm=perm*fact(key(j))
            end if
          end if
  125     continue
          perm=max(perm-1.0d0,0.0d0)
          sum=sum+perm
  110   continue
      end if
      simil=sum/dfloat(tperm)
      return
      end
C end-of-simil
C 
C update new genotype
C
      subroutine update(idx,all1,all2,set)
      integer MAXSIZ
      parameter(MAXSIZ=1000)
      integer idx, all1, all2
      integer set(MAXSIZ,2)
      if (all1.gt.all2) then
        set(idx,2)=all1
        set(idx,1)=all2
      else
        set(idx,1)=all1
        set(idx,2)=all2
      end if
      return
      end
C end-of-update
C
C Count alleles in pair of relatives or spouses
C
      subroutine countall(p1,p2,p3,p4,nallele,nmiss)
      integer MISS
      parameter(MISS=-9999)
      integer nallele, nmiss, p1,p2,p3,p4
      nallele=0
      nmiss=0
      if (p1.eq.MISS) then
        nmiss=1
      else
        nallele=1
      end if
      if (p2.eq.MISS) then
        nmiss=nmiss+1
      elseif (p1.ne.p2) then
        nallele=nallele+1
      end if
      if (p3.eq.MISS) then 
        nmiss=nmiss+1
      elseif ((p1.ne.p3).and.(p2.ne.p3)) then
        nallele=nallele+1
      end if
      if (p4.eq.MISS) then
        nmiss=nmiss+1
      elseif ((p1.ne.p4).and.(p2.ne.p4).and.(p3.ne.p4)) then
        nallele=nallele+1
      end if
      return
      end
C end-of-countall

C
C extracts narg arguments from input string s
C
C typ=1  whitespace separated
C typ=2  whitespace separated or reserved character (id by opchar())
C typ=3  whitespace or slash separated (so genotypes can be written a/b)
C
      subroutine args(s,narg,arg,typ)
      character*(*) s
      integer narg, typ
      character*(*) arg(narg)
      integer eol,i,iarg,n,sarg,sol
C functions
      integer eow, sow
      logical opchar

      do 5 i=1,narg
        arg(i)=' '
    5 continue
      sol=sow(s)
      eol=eow(s)

      n=1
      i=sol
C
C start of main loop
   30 continue

      if (i.gt.eol) goto 40
        if (typ.eq.2 .and. opchar(s(i:i))) then
          arg(n)=s(i:i)
          n=n+1
        elseif (typ.eq.3 .and. n.gt.4 .and. s(i:i).eq.'/') then
          continue
        elseif (s(i:i).eq.'"') then
          iarg=-1
          i=i+1
          sarg=i
   45     continue
          if (i.gt.eol .or. s(i:i).eq.'"') goto 60
            iarg=iarg+1
            i=i+1
          goto 45
        elseif (s(i:i).ne.' ' .and. s(i:i).ne.'\t') then
          iarg=-1
          sarg=i
   50     continue
          if (i.gt.eol .or. s(i:i).eq.' ' .or. s(i:i).eq.'\t' .or.
     2        s(i:i).eq.'"' .or. 
     3        (typ.eq.2 .and. opchar(s(i:i))) .or.
     4        (typ.eq.3 .and. s(i:i).eq.'/')) then
            i=i-1
            goto 60
          end if
            iarg=iarg+1
            i=i+1
          goto 50
   60     continue
C        
          arg(n)=s(sarg:(sarg+iarg))
          n=n+1
        end if
        i=i+1
      goto 30
   40 continue
C
C return # arguments actually found 
      narg=n-1
      return
      end 
C end-of-arg
C
C is a reserved character for primitives?  "()*+-/<=>^"
C
      logical function opchar(ch)
      character*1 ch
      integer ich
      ich=ichar(ch)
      opchar=((ich.ge.40 .and. ich.le.43) .or. ich.eq.45 .or. 
     &  ich.eq.47 .or. (ich.ge.60 .and. ich.le.62) .or. ich.eq.94)
      return
      end
C end-of-opchar
C
C character to integer conversion via internal read
C
      integer function ival(string)
      integer MISS
      parameter(MISS=-9999)
      character*20 string
      integer i
      if (string.eq.' ') then
        ival=0
      elseif (string.eq.'x' .or. string.eq.'X' .or. string.eq.'.') then
        ival=MISS
      else
        read(string,'(i20)',err=10) i
        ival=i
      end if 
      return
C error -- word is not an integer
   10 write(*,'(2a/)') 'ERROR: Unable to read integer ',string
      ival=0
      return
      end
C end-of-ival
C
C character to float conversion via internal read
C
      real function fval(string)
      integer BLANK, MISS
      parameter(BLANK=-9999,MISS=-9999)
      character*20 string
      real v

      if (string.eq.' ' .or. string.eq.'-') then
        fval=BLANK
      elseif (string.eq.'x' .or. string.eq.'X' .or. string.eq.'.') then
        fval=MISS
      elseif (string.eq.'y' .or. string.eq.'Y') then
        fval=2.0
      elseif (string.eq.'n' .or. string.eq.'N') then
        fval=1.0
      else
        read(string,'(f20.0)',err=10) v
        fval=v
      end if 
      return
C error -- word is not a number
   10 write(*,'(2a/)') 'ERROR: Unable to read real number ',string
      fval=0.0
      return
      end
C end-of-fval
C
C skip leading whitespace
C
      integer function sow(string)
      character*(*) string
      do 10 i=1,len(string)
   10   if (string(i:i).ne.' ' .and. string(i:i).ne.'\t') goto 20
   20 sow=i
      return
      end
C
C find end of string
C
      integer function eow(string)
      character*(*) string
      do 10 i=len(string),1,-1
   10   if (string(i:i).ne.' ') goto 20
   20 eow=i
      return
      end
C end-of-eow
C
C Justify a string of characters within a string
C
      subroutine juststr(just,string,length)
      integer length
      character*1 just
      character*(*) string
      integer fin,i,j,sta

      sta=0
   10 continue
        sta=sta+1
      if (string(sta:sta).eq.' '.and. sta.le.length) goto 10
      fin=length+1
   20 continue
        fin=fin-1
      if (string(fin:fin).eq.' '.and. fin.gt.0) goto 20
      
      i=length-fin+sta
      if (just.eq.'c') then
        i=(i+1)/2
      elseif (just.eq.'l') then
        i=1
      end if
      j=i+fin-sta
C This seems to be quickest
      string(i:j)=string(sta:fin)
      string(1:i-1)=' '
      string(j+1:length)=' '
      return
      end
C end-of-juststr
C
C hash an integer to a two character string 01-99,A-Z,a-z,a-z...
C append to name
C
      subroutine makeind(idx,eos,string)
      integer eos, idx
      character*10 string
      integer d1, d2, i
      character*2 ch

      if (idx.lt.100) then
        write(ch,'(i2.2)') idx
      elseif (idx.lt.776) then
        i=idx-100
        d1=65+i/26
        d2=65+mod(i,26)
        ch(1:1)=char(d1)
        ch(2:2)=char(d2)
      else
        i=idx-776
        d1=i/26
        d2=mod(i,26)
        ch(1:1)=char(97+mod(d1,26))
        ch(2:2)=char(97+mod(d2,26))
      end if

C add sibship number to pedigree name if short enough
      if (eos.lt.8) then
        string(eos+1:eos+1)='_'
        string(eos+2:eos+3)=ch
      else
C check if danger of nonunique new name
        if (string(8:8).eq.'_' .and. eos.eq.10) then
          d1=1
          do 10 i=2,10
            d1=mod(d1*ichar(string(i:i)),1048576)
   10     continue
          write(string,'(i10.10)') d1
        end if
        string(3:3)='_'
        string(1:2)=ch
      end if

      return
      end
C end-of-makeind
C
C write id as justified (l,c,r) string, possibly indicating sex
C as male [101] or female (102)
C
      subroutine wrid(just,id,chid,sx)
      integer sx
      character*8 id
      character*1 just
      character*10 chid
C local variables
      integer i
      character*1 left(2),right(2)
C functions
      integer eow

      data left(1),left(2),right(1),right(2) /'[','(',']',')'/

      chid=' '
      if (sx.eq.1 .or. sx.eq.2) then
        i=eow(id)
        chid(1:1)=left(sx)
        chid(2:i+1)=id
        chid(i+2:i+2)=right(sx)
      else
        chid=id
      end if
      call juststr(just,chid,10)
      return
      end
C end-of-wrid
C
C write out genotype 
C
      subroutine wrgtp(all1,all2,gtp,sep)
      integer MISS,KNOWN
      parameter(MISS=-9999,KNOWN=0)
      integer all1,all2,sep
      character*(*) gtp
      character*3 all

      integer isep, mid

      isep=0
      mid=len(gtp)/2+1
      gtp=' '
      if (all1.eq.MISS) then 
        all='  x'
      elseif (all1.eq.KNOWN) then
        all='  -'
      elseif (all1.lt.KNOWN) then
        isep=2
        write(all,'(i3)') -all1
      else
        write(all,'(i3)') all1
      end if
      gtp(mid-3:mid-1)=all

      if (all2.eq.MISS) then 
        all='x  '
      elseif (all2.eq.KNOWN) then
        all='-  '
      elseif (all2.lt.KNOWN) then
        isep=2
        write(all,'(i3)') -all2
      else
        write(all,'(i3)') all2
      end if
      call juststr('l',all,3)
      gtp(mid+1:mid+3)=all

      if (sep.eq.1) then
        gtp(mid:mid)='/'
      elseif (isep.ne.0) then
        gtp(mid:mid)=':'
      end if

      return
      end
C end-of-wrgtp
C
C write out trait value to a string
C
      subroutine wrtrait(value,str,typ)
      integer typ
      real value
      character*10 str
      if (typ.eq.1 .or. typ.eq.2) then
        call wrgtp(int(value)/1000,mod(int(value),1000),str,1)
      else if (typ.eq.4) then
        str='     y'
        if (value.eq.1.0) str='     n'
      else
        write(str,'(f10.4)') value
      end if
      return
      end
C end-of-wrtrait
C
C binary trait as character
C
      subroutine wraff(value,ch)
      real value
      character*1 ch
      ch='x'
      if (value .eq. 1.0) then
        ch='n'
      elseif (value .eq. 2.0) then
        ch='y'
      end if
      return
      end
C end-of-wraff
C
C write P-values as a histogram: . + * ** ***
C
      subroutine phist(pval1, pval2, histo)
      double precision pval1, pval2
      character*3 histo
      double precision pval

      pval=min(pval1, pval2)
      histo='.  '
      if (pval.lt.0.0001d0) then
        histo='***'
      elseif (pval.lt.0.001d0) then
        histo='**'
      elseif (pval.lt.0.01d0) then
        histo='*'
      elseif (pval.lt.0.1d0) then
        histo='+'
      end if
      return
      end
C end-of-phist
C 
C write a string with leading "x" if starts with an integer
C Loki and R for example do not allow variable names that start with a digit
C
      subroutine addlet(old, new)
      character*(*) old, new
      character*1 ch
      ch=old(1:1)
      if (ichar(ch).ge.48 .and. ichar(ch).le.57) then
        new='x' // old
      else
        new=old
      end if
      return
      end
C end-of-addlet 
C
C concatenate directory to existing filename
C
      subroutine cat(dirnam,filnam)
      character*(*) dirnam, filnam
      integer len1,len2
C functions
      integer eow

      len1=eow(dirnam)
      if (len1.gt.0) then
        call slash(dirnam,len1)
        len2=eow(filnam)
        if ((len1+len2).gt.len(filnam)) then
          write(*,'(a,i3,a/7x,3a/)') 
     2      'ERROR: Path name exceeds ',len(filnam),' characters.',
     3      'File path remains "',filnam(1:len2),'".'
        else      
          filnam(len1+1:len1+len2+1)=filnam(1:len2)
          filnam(1:len1)=dirnam(1:len1)
        end if
      end if
      return
      end 
C end-of-cat
C
C test what character used to separate directories
C
      subroutine slash(dirnam,lend)
      character*(*) dirnam
      integer lend
      integer i
      character*1 sla

      sla='\\'
      do 10 i=1,lend
      if (dirnam(i:i).eq.'/') then
        sla='/'
        goto 11
      end if
   10 continue
   11 continue
      if (dirnam(lend:lend).ne.sla) then
        lend=lend+1
        dirnam(lend:lend)=sla
      end if
      return
      end
C end-of-slash
C
C create workfile name 8.3 prefix '.' suffix
C
      subroutine uniqnam(seed, filnam, suffix)
      integer seed
      character*(*) filnam
      character*3 suffix
      integer i,j
      j=seed
      filnam='sp------'
      if (len(filnam).lt.12) return
      do 10 i=4,8
        filnam(i:i)=char(97+mod(j,26))
        j=j/26
   10 continue
      filnam(9:9)='.'
      filnam(10:12)=suffix
      return
      end
C end-of-uniqnam
C
C create new workfile name
C
      subroutine newnam(wrknum, wrkfil)
      integer wrknum
      character*(*) wrkfil
      integer j
C functions
      integer eow
      wrknum=wrknum+1
      if (wrknum.eq.10) wrknum=1
      j=eow(wrkfil)
      wrkfil(j:j)=char(48+wrknum)
      return
      end
C end-of-newnam
C
C Create a new file (deleting old instances of that name
C
      subroutine mknewfil(str, filnam, wrkdir)
      integer str
      character*(*) filnam, wrkdir
      logical filexist

      call cat(wrkdir,filnam)
      inquire(file=filnam,exist=filexist)
      if (filexist) then
        open(str,file=filnam)
        close(str,status='delete')
      end if
      return
      end
C end-of-mknewfil
C
C Write out program information
C
      subroutine info(burnin,imp,iter,ix,iy,iz,mapf,mincnt,plevel,
     2             showorig,addsex,chek,droperr,prompt,use2,
     3             datdir,version,wrkdir)
      integer HAPSIZ, IBDSIZ, LINSIZ, MAXALL, MAXG, MAXHAP,  
     &        MAXIBD, MAXSIZ, MAXLOC, MISS, WRKSIZ
      parameter(LINSIZ=1024, MAXALL=60, MAXG=MAXALL*(MAXALL+1)/2, 
     2   MAXSIZ=1000, MAXLOC=120, MAXHAP=MAXLOC/2, MISS=-9999, 
     3   MAXCOL=MAXLOC+5, HAPSIZ=MAXSIZ*MAXLOC,WRKSIZ=MAXSIZ*MAXG*2,
     4   MAXIBD=1000, IBDSIZ=MAXIBD*(MAXIBD+1)/2)
      integer burnin, droperr, imp, iter, ix, iy, iz, mapf, 
     &        mincnt, plevel, showorig, use2, wrkspace
      logical addsex, chek, prompt
      character*40 version
      character*40 datdir,wrkdir 
      character*7 map(2)

      data map(1)/'Haldane'/,map(2)/'Kosambi'/

      wrkspace=max(WRKSIZ, HAPSIZ+7*MAXSIZ+10*MAXG+5*MAXALL+3*IBDSIZ)
     &         +MAXSIZ*(MAXLOC+4)
      write(*,'(2a/)') 
     &        'Program version      = ',version
      write(*,'(6(a,i5/))') 
     2        'Maximum record length= ',LINSIZ,
     3        'Maximum pedigree size= ',MAXSIZ,
     4        'Maximum # phenotypes = ',MAXLOC,
     5        'Maximum # alleles    = ',MAXALL,
     6        'Maximum # genotypes  = ',MAXG,
     7        'Maximum # haplotypes = ',MAXHAP
      write(*,'(3(a,i5/))')
     2        'Imputation level     = ',imp,
     3        'Simple Mendel checks = ',chek,
     4        'Drop incon. genotypes= ',droperr
      write(*,'(4(a,i5/),a,3(1x,i5)/)') 
     2        'No. parents for TDT >= ',use2,
     3        'Maximum MC iterations= ',iter,
     4        'Min numerator P-value= ',mincnt,
     5        'Burn-in MC iterations= ',burnin,
     6        'Seeds for RNG (AS183)=',ix,iy,iz
      write(*,'(a,i5,a/)')    
     2        'Main workspace size  = ', wrkspace/256,' kB'
      write(*,'(a,l5/a,l5/a,i5/a,i5/)')    
     2        'Add dummy var for sex= ',addsex,
     3        'Show prompt string   = ',prompt,
     4        'Output detail level  = ',plevel,
     5        'Haplotype detail lvl = ',showorig
      write(*,'(2(2a/))')    
     2        'Data file directory  = ',datdir,
     3        'Work file directory  = ',wrkdir
      write(*,'(2a/)') 
     &        'Map function         = ',map(mapf)
      return
      end
C end-of-info
C
C brief online help
C
      subroutine help(type)
      integer type
C
      if (type.eq.5) then
        write(*,'(a/a//a//a//a)')
     2  'Keywords can be shortened to the first 3 letters.',
     3  'Help prints a brief summary of all commands:',
     4  '  help [all | globals | data | analysis]',
     5  'For full online help:',
     6  '  $ your_favourite_HTML_browser sib-pair.html'
        return
      end if
      if (type.eq.1 .or. type.eq.2) then
        write(*,'(a)') 
     2  '*Globals*','!|# {comment}', '%|$ {shell command}', 
     3  'hel [all|glo|dat|ana] {help}','qui|bye {exit}','cle {reset}',
     4  'inc|loc <fil> {include commands}','lis [mar|tra] {list loci}',
     5  'sho map {show current marker map}',
     6  'inf {program info}','tim {total elapsed time}' 
       write(*,'(a)') 
     2  'set pro [on|off] {display prompt}','set ech [on|off] {echo}',
     3  'set out|ple -1|0|1|2|ver|on|off {output verbosity}',
     4  'set hap 0|1|2|ver|on|off {haplotype detail}',
     5  'set nde [<nwid>] <ndec> {output pedigree decimal digits}',
     6  'set wei fou {weight allele frequencies}' 
       write(*,'(a)') 
     2  'set ite|bur <it> {maximum iters | burn-in iters}',
     3  'set min <num> {required numerator approximate P-values}',
     4  'set see <s1> <s2> <s3> {RNG seeds}', 
     5  'set err [on|off] {remove nuclear family mendelian errors}', 
     6  'set tdt both|one|fir {parents typed for TDT}' 
       write(*,'(a)') 
     2  'set map fun kos|hal {set mapping function}',
     3  'pch <x2> <df> {Chi-square P-value}',
     4  'pro <num> <den> <width> {CI for proportion}',
     5  'sml <pA> <penAA> <penAB> <penBB> {recurrence risks}',
     6  'grr <prev> <pA> <GRR> [<add|dom|rec>] {recurrence risks}' 
        write(*,'(a)') '*Operators/functions*',
     2  '( ) if then else * / + - ^ = not and or < > ge le ne eq',
     3  '>= <= ^= == neg pos abs sqrt log exp sin cos tan asin acos',
     4  ' atan inht int round istyp untyp rand rnorm pi y n',
     5  'female male isfou isnon num nfoun',
     6  'anytyp alltyp numtyp famnum index'
      end if
      if (type.eq.1 .or. type.eq.3) then
        write(*,'(a)') 
     2  '*Data*','set dat|wor <path> {data | work directory}',
     3  'set imp 0|1|2|3|off|on {impute unmeasured genotypes}',
     4  'set loc <nam> mar|xma|qua|aff {declare locus position,type}',
     5  'rea ped <fil>|inline {declare pedigree file}',
     6  'rea lin <fil>|inline {declare pedigree file Linkage type}'  
        write(*,'(a)') 
     2  'rea loc lin <fil> {read Linkage locus position,type,map}',
     3  'set map <pos1>...<posN> {set marker map positions}',
     4  'set dis <dis12> <dis23>...<disN-1N> {set map distances (cM)}' 
        write(*,'(a)') 
     2  'set sex on {add dummy variable}',
     3  'run {read in pedigree data}',
     4  'kee <loc1>.[to]..<locN> [$m|$q|$a] {retain loci in analysis}',
     5  'dro <loc1>.[to]..<locN> [$m|$q|$a] {drop loci from analysis}',
     6  'und [<loc1>.[to]..<locN> [$m|$q|$a]] {return loci to analysis}'
        write(*,'(a)')
     2  'sel [con <npro> whe] <expr> {select pedigrees for analysis}',
     3  'sel ped [not [in]] <ped1>...<pedN> {select on pedigree name}',
     4  'uns {return pedigrees to analysis}',
     5  'pac {delete unselected pedigrees}' 
        write(*,'(a)')
     2  'rec <loc> <val1>...<valN> to <new> {recode old values to new}',
     3  'com <mar1>...<marN> [<thr>] {recode rare alleles}',
     4  'tra <loc> <div> <sub> <pow> <lo> <hi> {power transform}',
     5  'ran <tra> <rank> {rank trait values}',
     6  'kap <tra> <cen> [res] {survivor function estimate}'  
        write(*,'(a)')
     2  'adj <tra> on <loc1> [to <xval>|m|f] {linear regress adjust}' ,
     3  'res <tra> on <loc1>...<locN> [com] {linear regress resid}',
     4  'pre <tra> on <loc1>...<locN> [com] {linear regress predicted}',
     5  'imp <tra> on <loc1>...<locN> [com] {linear regress imputation}'
        write(*,'(a)')
     2  'edi <ped> <per>|all <loc> [to] <val1> [<val2>] {edit data}',
     3  'del <ped> <per>|all {set all data missing for person or}',
     4  'del [<loc1>...<locN>] whe <expr> {set selected data missing}',
     5  'sta <loc> [fam] {standardize trait value}' 
        write(*,'(a)')
     2  'nuc [<maxsibs>] [gra] {convert to (trimmed) nuclear families}',
     3  'sub {divide into subpedigrees (if compound)}', 
     4  'pru <tra> {prune unaffecteds}' ,
     5  'cas <tra> {divide into unrelated cases}' 
        write(*,'(a)')
     2  'pri ped <ped1>...<pedN> [id <id1>...<idN>] {print data}',
     3  'wri {print data}',
     4  'wri <fil> {write gas type ped file}'
        write(*,'(2a)')
     2  'wri arl [par|all]|asp|cri|dot|fis|gas|gda|gh [dum]|lin [dum]',
     3  '|men|mim|ped|phe|sag|tcl <fil> {write ped file}' 
        write(*,'(a/2a)')
     2 'wri pap {write PAP trip.dat and phen.dat}',
     3 'wri loc asp|fis|gas|gh [dum]|lin [dum]|lok|men|mer|sag|tcl',
     4 ' <fil> {write locus file}'  
        write(*,'(a)')
     5 'wri loc sib <fil> [<pedfil>] {write Sib-pair script}',
     5 'wri loc pap {write PAP header.dat and popln.dat}' ,
     6 'wri map men|mer|lok <fil> {write MENDEL or MERLIN map file}' 
      end if
      if (type.eq.1 .or. type.eq.4) then
        write(*,'(a)')
     2  '*Analysis*','gen [<ped>] {summarize pedigree(s)}',
     3  'cou|pri [whe] <expr> {count or print where expression true}',
     4  'hap [<bin tra>] {show sibship haplotypes}',
     5  'anc <tra> [ove|und <thr>] {common ancestor of most probands}',
     6  'fre|des [<loc>] {descriptive statistics}',
     7  'his <qua tra> {histogram and normality test}'  
        write(*,'(a)')
     2  'mea|cor [<loc1>..<locN>] {phenotypic means and correlations}',
     3  'tab <tr1> [<tr2>...<trN>] {contingency table}', 
     4  'kru <qua tra> <loc> {Kruskall-Wallis test}', 
     6  'reg <tra> on <loc1>.[to]..<locN> {linear/logist regression}',
     7  'mix <qua tra> [[<num>] [nor|poo|exp|poi]] {test admixture}' 
       write(*,'(a)')
     2  'hwe [fou] {test HWE}',
     3  'dis <loc1> <loc2> {intragametic association}',
     4  'hom [<tra> [ove|und <thr>]] {marker homozygosity}'  
       write(*,'(a)')
     2  'dav <tra> <pro> {segregation ratios under ascertainment}',
     3  'kin [pai|inb] {kinship/inbreeding coeffs}',
     4  'ib[s|d] <loc> [pai] {relative pair ibs/ibd sharing at marker}',
     5  'cki {sib pair ibs sharing at multiple markers}', 
     6  'sha {rel pair ibs sharing at multiple markers}', 
     7  'ass <tra> [ove|und <thr>] [fou] [gen] {allelic association}' 
       write(*,'(a)')
     2  'tdt <tra> [ove|und <thr>] [pat|mat] {several TDTs}',
     3  'sch <tra> <mar> [<all>] {Schaid & Sommer HWE test}',
     4  'asp <tra> [ove|und <thr>] {affected sib-pair IBS}', 
     5  'apm <tra> [ove|und <thr>] [ibd|ibs] {IBS or IBD APM}' 
       write(*,'(2a/a/a/a)')
     2  'sib <tra> [<wei>] [sim] [cor <r> [mea <m>]',
     3  ' [sd|var <v>]] {S&P QTL linkage}',
     4  'vis <tra> [<wei>] [sim] {V&H H-E regression}',
     5  'he1 <tra> [<wei>] [sim] {Trad H-E regression}',
     6  'he2 <tra> [<wei>] [sim] {Cross-product H-E regression}' 
       write(*,'(a)')
     4  'two <tra> <loc1> <loc2> <theta> {two-point Haseman-Elston}',
     5  'qtl <tra> {Variance components sib-pair linkage}',
     6  'var <tra> {Variance components trait analysis }' 
      end if
C     write(*,*)
      return
      end
C end-of-help
C pass line to shell -- requires existence of fairly 
C                       standard routine system()
C
      subroutine shell(lin)
      character*(*) lin
      integer sta,fin
      external system
      sta=0
    5 continue
        sta=sta+1
      if (lin(sta:sta).ne.'$' .and. lin(sta:sta).ne.'%') goto 5
    7 continue
        sta=sta+1
      if (lin(sta:sta).eq.' ') goto 7
      fin=len(lin)
   10 continue
        fin=fin-1
      if (lin(fin:fin).eq.' ') goto 10
      write(*,'(a/3a/a)') '!','! "',lin(sta:min(fin,75)),'"','!'
      call system(lin(sta:fin))
      return
      end
C end-of-shell
C
C write elapsed time since last asked
C
      subroutine stamp(t0)
      integer elapsed, t0
C functions
#ifdef F2C
      integer time
      elapsed=time()-t0
#else
      real secnds
      elapsed=int(secnds(float(t0)))
#endif F2C
      if (elapsed.lt.120) then
        write(*,'(/a,i5,a)') 
     &    'This job took ',elapsed,' seconds'
      elseif (elapsed.lt.7200) then
        write(*,'(/a,f5.1,a)') 
     &    'This job took ',float(elapsed)/60.0,' minutes'
      else
        write(*,'(/a,f5.1,a)') 
     &    'This job took ',float(elapsed)/3600.0,' hours'
      end if
      return
      end
C end-of-stamp
C
C determine if index person is affected or unaffected
C
      real function isaff(val,thresh,gt)
      integer MISS
      parameter(MISS=-9999)
      real val, thresh
      logical gt

      isaff=val
      if (thresh.ne.MISS .and. isaff.ne.MISS) then
        if ((gt .and. isaff.gt.thresh) .or.
     &     (.not.gt .and. isaff.lt.thresh)) then
          isaff=2.0
        else
          isaff=1.0
        end if
      end if
      return
      end
C end-of-isaff
C
C swap alleles so ordered consistently
C      
      subroutine order(all1,all2)
      integer all1,all2,swp
      if (all1.gt.all2) then
         swp=all1
         all1=all2
         all2=swp
      end if
      return
      end
C end-of-order
C
C swap alleles
C      
      subroutine swap(all1,all2)
      integer all1,all2,swp
      swp=all1
      all1=all2
      all2=swp
      return
      end
C end-of-swap 
C
C determine if word is name of a trait locus
C typ1=10, any locus type
C typ1,typ2=1..5, that locus type only
C
      subroutine gettrait(name,typ1,typ2,nloci,loc,loctyp,trait)
      integer MAXLOC, MISS
      parameter(MAXLOC=120, MISS=-9999)
      character*10 name
      integer nloci, trait, typ1, typ2
      character*10 loc(MAXLOC)
      integer loctyp(MAXLOC)
C functions
      integer eow

      trait=MISS
      if (name.eq.' ') return
      do 5 i=1,nloci
      if (name.eq.loc(i) .and. 
     2    (loctyp(i).eq.typ1 .or. loctyp(i).eq.typ2 .or. typ1.eq.10)) 
     3 then
        trait=i
        return
       end if
    5 continue
      write(*,'(/3a/)') 'NOTE:  Unable to find requested variable "', 
     &                   name(1:eow(name)),'".'
      return  
      end
C end-of-gettrait
C
C Get a single binary trait or dichotomized quantitative trait
C
      subroutine getbin(sta,fin,words,nloci,loc,loctyp,
     &                  trait,gt,thresh)
      integer MAXLOC, MISS
      parameter(MAXLOC=120, MISS=-9999)
      integer fin, nloci, sta, trait
      character*20 words(fin)  
      logical gt
      real thresh
      character*10 loc(MAXLOC)
      integer loctyp(MAXLOC)

      call gettrait(words(sta),3,4,nloci,loc,loctyp,trait)

      gt=.true.
      thresh=MISS
      do 10 i=sta+1, fin-1
        if (words(i)(1:3).eq.'ove') then
          thresh=fval(words(i+1))
        elseif (words(i)(1:3).eq.'und') then
          gt=.false.
          thresh=fval(words(i+1))
        end if  
   10 continue
      if (trait.ne.MISS .and. thresh.eq.MISS .and. 
     &    loctyp(trait).eq.3) then
        trait=MISS
      end if
      return
      end
C end-of-getbin
C
C load list of traits into an array
C
      subroutine loadnam(sta,fin,words,nloci,loc,loctyp,chosen,
     &                   nterms,terms,typ)
      integer MAXLOC
      parameter(MAXLOC=120)

      integer fin, nloci, sta, typ
      integer nterms, terms(*)
      character*20 words(fin)  
      character*10 loc(MAXLOC)
      integer chosen(MAXLOC), loctyp(MAXLOC)
C local variables
      integer i, locnum, offset, pos, span

      do 1 locnum=1, nloci
        chosen(locnum)=0
    1 continue
      nterms=0
C empty list is all loci
      if (sta.gt.fin) then
        if (typ.eq.1) then
          do 5 locnum=1,nloci
          if (loctyp(locnum).le.4) then
            nterms=nterms+1
            chosen(locnum)=nterms
          end if
    5     continue
        else
          do 6 locnum=1,nloci
          if (loctyp(locnum).ge.5) then
            nterms=nterms+1
            chosen(locnum)=nterms
          end if
    6     continue
        end if
      end if

      pos=sta
      i=0
      locnum=1
      offset=0
      if (typ.eq.2) offset=3
   10 continue
      if (pos.gt.fin) goto 40
        if (words(pos)(1:1).eq.'$') then
          if (words(pos)(2:2).eq.'m') then
            i=1
          elseif (words(pos)(2:2).eq.'x') then
            i=2
          elseif (words(pos)(2:2).eq.'q') then
            i=3
          elseif (words(pos)(2:2).eq.'a') then
            i=4
          end if
          i=i+offset
          do 20 locnum=1,nloci
          if (loctyp(locnum).eq.i .and. chosen(locnum).eq.0) then
            nterms=nterms+1
            chosen(locnum)=nterms
          end if
   20     continue
          locnum=1
          pos=pos+1
        else
          span=0
          if (words(pos).eq.'to' .or. words(pos).eq.'--') then
            span=locnum
            pos=pos+1
          end if
          if (pos.le.fin) then
            locnum=isinenv(words(pos)(1:10),nloci,loc)
          else
            locnum=nloci
          end if
          if (locnum.eq.0) then
            write(*,'(2a/)') 'ERROR: Unable to find locus ',words(pos)
          else     
            if (span.eq.0) span=locnum
            call order(span,locnum)
            if (typ.eq.1) then
              do 30 i=span,locnum
              if (loctyp(i).le.4 .and. chosen(i).eq.0) then
                nterms=nterms+1
                chosen(i)=nterms
              end if
   30         continue
            else
              do 31 i=span,locnum
              if (loctyp(i).ge.5 .and. chosen(i).eq.0) then
                nterms=nterms+1
                chosen(i)=nterms
              end if
   31         continue
            end if
          end if
          pos=pos+1
        end if
      goto 10
   40 continue

      do 50 locnum=1,nloci
      if (chosen(locnum).gt.0) then
        terms(chosen(locnum))=locnum
      end if
   50 continue
      return
      end
C end-of-loadnam
C
C List of active loci
C
      subroutine listloci(nloci,loc,loctyp,locpos,typ)
      integer MAXLOC
      parameter (MAXLOC=120)
      integer typ
C
C Locus structure:
C
      integer nloci
      character*10 loc(MAXLOC)
      integer loctyp(MAXLOC),locpos(MAXLOC)
      character*1 typloc(8)

      integer i,eon,nmark,pos
C functions
      integer eow
      double precision bonf

      data typloc/'m','x','q','a','d','d','d','d'/

      if (typ.eq.1) then
        nmark=0
        write(*,'(2(/a10,1x,a4,1x,a8))') 
     2    'Locus     ','Type','Position', 
     3    '----------','----','--------'
        do 5 i=1,nloci
        if (loctyp(i).le.2) then
          nmark=nmark+1
          write(*,'(a10,2x,a1,3x,i3,a2,i3)') 
     &      loc(i),typloc(loctyp(i)),locpos(i)+5,'--',locpos(i)+6
        else
          write(*,'(a10,2x,a1,3x,i3)') 
     &      loc(i),typloc(loctyp(i)),locpos(i)+5
        end if
    5   continue
        write(*,'(/a,i4,3(/a,3x,f8.6)/)') 
     2    'Number of marker loci= ',nmark,
     3    'Bonferroni corr. 5%  = ',bonf(nmark,0.05d0),
     4    'Bonferroni corr. 1%  = ',bonf(nmark,0.01d0),
     5    'Bonferroni corr. 0.1%= ',bonf(nmark,0.001d0)
      elseif (typ.eq.2) then
        pos=0
        do 15 i=1,nloci
          eon=eow(loc(i))
          pos=pos+eon+1
          if (loctyp(i).eq.3 .or. loctyp(i).eq.4) then
            pos=pos+1
            call newlin(78,pos,eon+2)
            write(*,'(2a,$)') loc(i)(1:eon),'* '
          else if (loctyp(i).le.2) then
            call newlin(78,pos,eon+2)
            write(*,'(2a,$)') loc(i)(1:eon),' '
          else
            pos=pos+2
            call newlin(78,pos,eon+2)
            write(*,'(3a,$)') '(',loc(i)(1:eon),') '
          end if
   15   continue
        write(*,*)
      end if
      return
      end
C end-of-listloci
C 
      subroutine newlin(eol,pos,newpos)
      integer eol, newpos, pos
      if (pos.gt.eol) then
        pos=newpos
        write(*,*)
      end if
      return
      end
C end-of-newlin
C
C Count active codominant markers or active loci
C
      subroutine cntmark(nloci,loctyp,nmark,typ)
      integer MAXLOC
      parameter(MAXLOC=120)
      integer nloci, nmark, loctyp(MAXLOC), typ
      integer i

      nmark=0
      if (typ.eq.1) then
        do 10 i=1,nloci
          if (loctyp(i).le.2) nmark=nmark+1
   10   continue
      else
        do 20 i=1,nloci
          if (loctyp(i).le.4) nmark=nmark+1
   20   continue
      end if
      return
      end
C end-of-cntmark
C 
C test if all genotypes missing for this locus at this pedigree
C
      logical function allmiss(gene,num,locus)
      integer MAXSIZ,MAXLOC,MISS
      parameter (MAXSIZ=1000,MAXLOC=120,MISS=-9999)
      integer gene, num
      real locus(MAXSIZ,MAXLOC)
      integer i
      allmiss=.true.
      do 150 i=1,num
      if (locus(i,gene).ne.MISS) then
        allmiss=.false.
        goto 151
      end if
  150 continue
  151 continue
      return
      end
C end-of-allmiss
C 
C test if all genotypes nonmissing for this locus at this pedigree
C
      logical function alltyped(gene,num,locus)
      integer MAXSIZ,MAXLOC,MISS
      parameter (MAXSIZ=1000,MAXLOC=120,MISS=-9999)
      integer gene, num
      real locus(MAXSIZ,MAXLOC)
      integer i
      alltyped=.true.
      do 150 i=1,num
      if (locus(i,gene).eq.MISS) then
        alltyped=.false.
        goto 151
      end if
  150 continue
  151 continue
      return
      end
C end-of-alltyped
C
C Get a line from the stream
      subroutine getlin(strm,narg,words,lin,skipbl)
      integer LINSIZ, MAXLOC, MAXCOL
      parameter (LINSIZ=1024, MAXLOC=120, MAXCOL=MAXLOC+5)
      integer narg, skipbl, strm
C character array to initially read data into
      character*(LINSIZ) lin
      character*20 words(MAXCOL)
   10 continue
        narg=0
        read(strm,'(a)',end=20) lin(1:LINSIZ)
        narg=MAXCOL
        call args(lin,narg,words,1)
      if (skipbl.eq.1 .and. narg.eq.0) goto 10
   20 continue
      return
      end
C end-of-getlin
C
C Read a Linkage locus file
C
      subroutine rdlinloc(strm,lin,words,nloci,loc,
     &                    locpos,loctyp,locord,map,numloc)
      integer LINSIZ, MAXLOC, MAXCOL
      parameter (LINSIZ=1024, MAXLOC=120, MAXCOL=MAXLOC+5)
      integer nloci, numloc, strm
      character*10 loc(MAXLOC)
      integer loctyp(MAXLOC), locpos(MAXLOC)
      real map(MAXLOC)
      integer locord(MAXLOC)
C character array to initially read data into
      character*(LINSIZ) lin
      character*20 words(MAXCOL)
C local variables
      integer nlocl, nmark, ntrait, i, i1, i2, j, lpos, pos, typ, xlink
      logical err, iscm
      real r1, r2
C functions
      integer eow, ival

      err=.false.
      read(strm,*) nlocl, i1, xlink, i2
      if (nlocl.gt.MAXLOC) then
        write(*,'(a/7x,2a,i3,a/)') 
     2    'ERROR: Maximum number of declared loci exceeded.',
     3           'Since locus types not yet read in, ',
     4           'only the first ', MAXLOC/2 ,' loci will be read in.'
        err=.true.
        nlocl=MAXLOC/2
      end if
      read(strm,*) i1, r1, r2, i2
      read(strm,*) (locord(i), i=1, nlocl)
      if (err) then
        call ascend(nlocl, locpos)
        call isort(1, nlocl, locord, locpos, 2)
        call copy(nlocl, locpos, locord)
      end if
      nloci=nlocl
      nmark=0
      ntrait=0
      pos=0
      do 10 i=1, nlocl
        pos=pos+1
        call getlin(strm,narg,words,lin,1)
        typ=ival(words(1))
        lpos=locord(pos)
        if (narg.eq.4) loc(lpos)=words(4)

        if (typ.eq.3) then
          nmark=nmark+1
          if (narg.ne.4) then
            write(loc(lpos),'(a,i3.3)') 'mar', nmark
          end if
          read(strm,*) 
          loctyp(lpos)=1
          if (xlink.eq.1) loctyp(lpos)=2
        elseif (typ.eq.1 .or. typ.eq.0) then
          ntrait=ntrait+1
          if (narg.ne.4) then
            write(loc(lpos),'(a,i3.3)') 'trait', ntrait
          end if
          read(strm,*) 
          if (typ.eq.1) then
            loctyp(lpos)=4
            read(strm,*) i1
C add in liability class as quantitative trait if necessary
            if (i1.gt.1) then
              nloci=nloci+1
              if (nloci.lt.MAXLOC) then
                write(*,'(/3a)') 
     2 'NOTE:  Liability class for "',loc(lpos)(1:eow(loc(lpos))),
     3 '" added as quantitative variable.'
                call insloc(pos,lpos,nloci,loc,loctyp,locpos,map,locord)
                loc(lpos+1)=loc(lpos)(1:min(eow(loc(lpos)), 8)) // '_l'
                loctyp(lpos+1)=3
                pos=pos+1
              end if
            end if
            do 30 j=1, i1
              read(strm,*)
   30       continue
          else
            loctyp(lpos)=3
            do 40 j=1,4
              read(strm,*)
   40       continue
          end if
        end if
   10 continue

      numloc=1
      do 15 i=1, nloci
        locpos(i)=numloc
        numloc=numloc+1
        if (loctyp(i).eq.1 .or. loctyp(i).eq.2) numloc=numloc+1
   15 continue
      numloc=numloc-1
      read(strm,*) i1, i2
      narg=nlocl-1
      call getlin(strm,narg,words,lin,1)
      iscm=.false.
      do 50 i=1, nlocl-1
      if (fval(words(i)).gt.0.5) then
        iscm=.true.
        goto 51
      end if
   50 continue
   51 continue
      dist=0.0
      map(1)=dist
      if (iscm) then
        do 60 i=2, nlocl-1
          map(i)=dist+fval(words(i))
          dist=map(i)
   60   continue
      else
        do 70 i=2, nlocl-1
          map(i)=dist-0.5*log(1.0-fval(words(i)))
          dist=map(i)
   70   continue
      end if
      return
      end
C end-of-rdlinloc
C 
C insert a locus into the locus list
C locord is rewritten such that the inserted locus's locord is locord(pos)+1
C other details of the slot are left blank
C
      subroutine insloc(pos,lpos,nloci,loc,loctyp,locpos,map,locord)
      integer MAXLOC, MAXCOL
      parameter (MAXLOC=120, MAXCOL=MAXLOC+5)
      integer lpos, nloci, pos
      character*10 loc(MAXLOC)
      integer loctyp(MAXLOC), locpos(MAXLOC), locord(MAXLOC)
      real map(MAXLOC)
      integer i

      if (nloci.gt.MAXLOC) then
        write(*,'(a,7x,a,i3,a)') 
     2    'ERROR: Maximum number of declared loci exceeded.' ,
     3    'An additional locus cannot be inserted at ',pos,'.'
        return
      end if
      do 10 i=lpos+1, nloci-1
        loc(i+1)=loc(i)
        loctyp(i+1)=loctyp(i)
        locpos(i+1)=locpos(i)
        map(i+1)=map(i)
   10 continue
      do 15 i=pos+1, nloci-1
        locord(i+1)=locord(i)
   15 continue
      do 20 i=1,nloci 
        if (locord(i).gt.lpos) locord(i)=locord(i)+1
   20 continue
      locord(pos+1)=lpos+1
      return
      end
C end-of-insloc
C
C Find the start of a "where" clause
      integer function findwh(farg, larg, narg, args)
      integer farg, larg, narg
      character*(*) args(narg)
      integer i
      do 10 i=farg, larg  
        if (args(i).eq.'whe' .or. args(i).eq.'where') then
          findwh=i
          return
        end if
   10 continue
      findwh=0
      return
      end
C end-of-findwh
C

C
C See if all members of a pedigree are connected
C
      subroutine connect(num,fa,mo,set,nsub,maxgrp)
      integer MAXSIZ,MISS
      parameter(MAXSIZ=1000,MISS=-9999)

      integer maxgrp, nsub
      integer num, fa(MAXSIZ), mo(MAXSIZ)
      integer set(MAXSIZ,2)
C local variables
      integer biggrp,i,idx,numgrp
      logical fin
C
      do 1 i=1,num
        set(i,1)=MISS
        set(i,2)=MISS
    1 continue

      biggrp=1
      idx=1
      maxgrp=0
      numgrp=1
      nsub=1
      set(idx,1)=nsub
      set(idx,2)=idx

      if (num.eq.1) return
C
C while able to update, indicate if individual is part of cluster
C connected to index individual
C
    5 continue
        fin=.true.
        do 10 i=1,num
        if (set(i,1).eq.nsub .and. fa(i).ne.MISS) then
          if (set(fa(i),1).eq.MISS) then
            call addlist(fa(i),idx,set)
            numgrp=numgrp+1
            fin=.false.
          end if
          if (set(mo(i),1).eq.MISS) then
            call addlist(mo(i),idx,set)
            numgrp=numgrp+1
            fin=.false.
          end if
        elseif (set(i,1).eq.MISS) then
          if (fa(i).ne.MISS .and. 
     &        (set(fa(i),1).eq.nsub .or. set(mo(i),1).eq.nsub)) then
            call addlist(i,idx,set)
            numgrp=numgrp+1
            fin=.false.
          end if
        end if
   10   continue
      if (.not.fin) goto 5
C
C Test whether ungrouped individuals remain in pedigree
C If yes, initiate new group around a new index and iterate
C
      if (numgrp.gt.maxgrp) then
        biggrp=nsub
        maxgrp=numgrp
      end if
      do 20 i=1,num
      if (set(i,1).eq.MISS) then
        idx=i
        nsub=nsub+1
        set(idx,1)=nsub
        set(idx,2)=idx
        numgrp=1
        goto 5
      end if
   20 continue
C
C Make biggest subpedigree No. 1
C
      if (biggrp.ne.1) then
        do 25 i=1,num
          if (set(i,1).eq.biggrp) then
            set(i,1)=1
          elseif (set(i,1).eq.1) then
            set(i,1)=biggrp
          end if
   25   continue
      end if
      return
      end
C end-of-connect
C
C shift an individual from the list of ungrouped individuals
C to the appropriate group (subpedigree) nucleating around the index person.
C
      subroutine addlist(pos,idx,set)
      integer MAXSIZ
      parameter (MAXSIZ=1000)
      integer idx,pos
      integer set(MAXSIZ,2)
C
C add the current person to the list after the index person for that family
C
      set(pos,2)=set(idx,2)
      set(pos,1)=set(idx,1)
      set(idx,2)=pos
      return
      end
C end-of-addlist
C
C find list number <target>
C
      subroutine findlist(target,num,set,pos)
      integer MAXSIZ,MISS
      parameter (MAXSIZ=1000,MISS=-9999)
      integer num,pos,target 
      integer set(MAXSIZ,2)
      do 10 pos=1,num
      if (set(pos,1).eq.target) then
        return
      end if
   10 continue
C list not found
      pos=MISS
      return
      end
C end-of-findlist
C
C List the members of pedigree(s)
C
      subroutine wrsubped(pedigree,num,id,key,set,nsub,maxgrp,plevel)
      integer MAXSIZ,MISS
      parameter(MAXSIZ=1000,MISS=-9999)

      integer maxgrp, nsub, plevel
      character*10 pedigree  
      character*8 id(MAXSIZ)
      integer num, key(MAXSIZ)
      integer set(MAXSIZ,2)
C local variables
      integer eop,i
C functions
      integer eow
C
      eop=eow(pedigree)
      write(*,'(/3a,i4,a/7x,a,i4,a/)') 'NOTE:  Pedigree ', 
     2  pedigree(1:eop),' contains ',nsub,' disjoint pedigrees.',
     3  'The largest subpedigree contains ',maxgrp,' members.'
      if (num-maxgrp.lt.20 .and. maxgrp.gt.num/3) then
        do 30 i=1,num
        if (set(i,1).ne.1) then
          write(*,'(/5a)') 
     2   'NOTE:  ',pedigree(1:eop),'-', id(key(i))(1:eow(id(key(i)))),
     3   ' is not a member of the main pedigree.' 
        end if
   30   continue
        write(*,*) 
      end if
      if (plevel.gt.1) then
        write(*,'(/a,i3,a/)') 
     &    'Members of largest subpedigree (N=',maxgrp,')'
        do 40 i=1,num
        if (set(i,1).eq.1) then
          write(*,'(3a)') pedigree(1:eop),'-', id(i)(1:eow(id(i)))  
        end if
   40   continue
        write(*,*)
      end if
      return
      end
C end-of-wrsubped
C
C Work out generation number ord().
C Visit every person in each subpedigree in turn.
C The missing value for generation must be a large negative value.
C
      subroutine gener(pedigree,num,fa,mo,nsub,set,ord,higen,
     &                 nerr,plevel)
      integer MAXSIZ,MISGEN,MISS
      parameter (MAXSIZ=1000,MISGEN=-9999,MISS=-9999)
      integer higen, nerr, plevel
C Pedigree structure
      character*10 pedigree
      integer num, fa(MAXSIZ), mo(MAXSIZ)
      integer ord(MAXSIZ), set(MAXSIZ,2)
C
C
      integer cfa, cgen, cmo, curped, dit, eop, i, idx, it, maxit
      integer logen, upgen
      logical fin, fin2
C functions
      integer eow

      eop=eow(pedigree)
      higen=1
      maxit=2*num
      do 5 i=1,num
        ord(i)=MISGEN
    5 continue
C
C do each subpedigree in turn
C 
      do 10 curped=1,nsub

      call findlist(curped,num,set,idx)
      upgen=0
      logen=0
      ord(idx)=0
      if (plevel.gt.1) then
        write(*,'(a,i5,a,i5)') 'Evaluating sub-pedigree ',curped,
     &    ' via index person ',idx
      end if 

      it=0
      i=idx
C
C Each iteration moves as far down the pedigree as possible then
C moves up no more than one generation
C
   15 continue
        it=it+1
        fin=.true.
C down leg
        dit=0
  100   continue
          fin2=.true.
          dit=dit+1
          if (dit.gt.maxit) then
            write(*,'(/5a/)') 
     2        'ERROR:  Probable illegal loop (eg own grandfather) ',
     3        'in pedigree ', pedigree(1:eop), '.'
            nerr=1
            return
          end if 

  115     continue      
            if (fa(i).ne.MISS) then
              cfa=fa(i)
              cmo=mo(i)
              cgen=max(ord(cfa),ord(cmo))+1
              if ((ord(cfa).ne.MISGEN .or. ord(cmo).ne.MISGEN) .and.
     2            ord(i).ne.cgen) then
                fin2=.false.
                ord(i)=cgen
              end if
            end if
            i=set(i,2)
          if (i.ne.idx) goto 115

        if (.not.fin2) goto 100
C up leg
  215   continue      
          if (fa(i).ne.MISS) then
            cgen=ord(i)
            if (cgen.ne.MISGEN) then
              cfa=fa(i)
              cmo=mo(i)
              if (ord(cfa).eq.MISGEN .or. 
     &            (fa(cfa).eq.MISS .and. cgen.le.ord(cfa))) then
                ord(cfa)=cgen-1
                fin=.false.
              end if
              if (ord(cmo).eq.MISGEN .or.
     &            (fa(cmo).eq.MISS .and. cgen.le.ord(cmo))) then
                ord(cmo)=cgen-1
                fin=.false.
              end if
            end if
          end if
          i=set(i,2)
        if (i.ne.idx) goto 215
C check if finished and update max and min generation number
      if (.not. fin .and. it.le.maxit) goto 15
      if (it.gt.maxit) then 
        write(*,'(/a,i3,a/7x,4a/)') 
     2    'NOTE:  Exceeded ',maxit,' iterations while calculating',
     3    'generation number for pedigree ', pedigree(1:eop), 
     4    ', subpedigree ',curped
      end if
C
C end of main loop
C
C adjust generation numbering to 1..G for founders, marry-ins etc
C
   20 continue     
        if (ord(i).gt.upgen) then
          upgen=ord(i)
        elseif (ord(i).lt.logen) then
          logen=ord(i)
        end if
        i=set(i,2)
      if (i.ne.idx) goto 20
      logen=1-logen
      upgen=upgen+logen
C
   25 continue
        if (fa(i).eq.MISS) then
          ord(i)=ord(i)+logen
        else
          ord(i)=MISGEN
        end if
        i=set(i,2)
      if (i.ne.idx) goto 25
C
C redo nonfounders, now that all founders set correctly
C
      it=0
   30 continue
        it=it+1
        fin=.true.
C
C if both parents have a known generation number, set index to
C max(fa_gen,mo_gen)+1
C
   35   continue
          if (fa(i).ne.MISS) then
            cfa=fa(i)
            cmo=mo(i)
            if (ord(i).eq.MISGEN) then
              if (ord(cfa).ne.MISGEN .and. ord(cmo).ne.MISGEN) 
     &        then
                ord(i)=max(ord(cfa),ord(cmo))+1
              else
                fin=.false.
              end if
            end if
          end if
          i=set(i,2)
        if (i.ne.idx) goto 35

      if (.not.fin) goto 30

      if (upgen.gt.higen) higen=upgen
C
   10 continue
C
      return
      end
C end-of-gener
C
C Write out pedigrees as list of nuclear families plus marry-ins by
C generation number
C
      subroutine dogen(wrk,twrk,pedigree,actset,num,nfound,id,fa,mo,sex,
     &                 locus, numloc,ord,set,trait,plevel)
      integer MAXSIZ,MAXLOC,MISS
      parameter (MAXSIZ=1000,MAXLOC=120,MISS=-9999)
      integer plevel, trait, twrk, wrk
C Pedigree structure
      character*10 pedigree
      integer actset, num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      integer ord(MAXSIZ), set(MAXSIZ,2)
      integer numloc
      real locus(MAXSIZ,MAXLOC)
      logical last
      integer biggest,curped,deepest,eop,higen,i,maxgrp,nped,nsub,
     &        onegen,onemem,nerr,nobs,totgen
      character*10 bigped, deeped
C functions
      integer eow
C
      biggest=0
      bigped=' '
      deeped=' '
      deepest=0
      nerr=0
      nobs=0
      nped=0
      onegen=0
      onemem=0
      totgen=0
      if (plevel.lt.1) then
        write(*,'(a)') 'Pedigree    Size Fndrs  Gens Disjoint',
     &                 '---------- ----- ----- ----- --------'
      end if

      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

        if (actset.gt.0) then
         if (num.gt.1 .or. plevel.gt.1) then
           eop=eow(pedigree)
           call connect(num,fa,mo,set,nsub,maxgrp)
           call gener(pedigree,num,fa,mo,nsub,set,ord,higen,nerr,0)
           if (plevel.gt.0) then
             write(*,'(/a,a10,a,i5,a,i5,a,i2/)') 
     2         'Pedigree ',pedigree,' No=',num,' No founders=',nfound, 
     3         ' No generations=',higen
             if (nsub.gt.1) then
               write(*,'(3x,3a,i4,a/)') 
     2           'Disjoint sub-pedigree ',pedigree(1:eop),
     3           '-001 (largest, N=',maxgrp,')'
             end if
             call wrgen(num,id,fa,mo,1,set,higen,ord)
             if (nsub.gt.1 .and. (nsub.le.10 .or. plevel.gt.0)) then
               do 15 curped=2,nsub
                 write(*,'(/3x,3a,i3.3/)') 
     &             'Disjoint sub-pedigree ',pedigree(1:eop),'-',curped
                 call wrgen(num,id,fa,mo,curped,set,higen,ord)
   15          continue
             end if
           else if (nsub.gt.1) then
             write(*,'(a10,3(1x,i5),3x,a,i4)') 
     &         pedigree, num, nfound, higen, 'y,', nsub
           else
             write(*,'(a10,3(1x,i5))') 
     &         pedigree, num, nfound, higen
           end if
         else
           higen=1
           ord(1)=1
         end if
         if (num.eq.1) onemem=onemem+1
         if (higen.eq.1) onegen=onegen+1
         if (num.gt.biggest) then
           biggest=num
           bigped=pedigree
         end if
         if (higen.gt.deepest) then
           deepest=higen
           deeped=pedigree
         end if
         totgen=totgen+higen
         nped=nped+1
         nobs=nobs+num
C
C save the generation number to a quantitative variable if requested
         if (trait.ne.MISS) then
           do 17 i=1,num
             locus(i,trait)=float(ord(i))
   17      continue
           call wrkout(twrk,pedigree,actset,num,nfound,id,fa,mo,sex,
     &                 locus,numloc)
         end if
        end if
      goto 10
   20 continue
      write(*,'(/a,i5/a,i5)') 
     2  'Total number of pedigrees  = ',nped,
     3  'Number with only 1 member  = ',onemem 
      write(*,'(a,i5,3a/a,i5,3a)') 
     4  'Largest pedigree (members) = ',biggest,
     5  ' (Pedigree ',bigped(1:eow(bigped)),')',
     6  'Deepest pedigree (genrtns) = ',deepest,
     7  ' (Pedigree ',deeped(1:eow(deeped)),')' 
      write(*,'(/a,f5.1/a,f5.1)') 
     2  'Mean size of pedigrees     = ',dfloat(nobs)/dfloat(nped),
     3  'Mean pedigree depth        = ',dfloat(totgen)/dfloat(nped) 
      if (nped.gt.onegen) then
        write(*,'(a,f5.1/a,f5.1)') 
     2  'Mean size where >1 members = ',
     3   dfloat(nobs-onegen)/dfloat(nped-onemem),
     4  'Mean depth where >1 members= ',
     5   dfloat(totgen-onegen)/dfloat(nped-onegen)
      end if
      return
      end
C end-of-dogen
C
C Write out structure and generation numbers
C   List of sibships by generation number
C
      subroutine wrgen(num,id,fa,mo,curped,set,higen,ord)
      integer MAXSIZ,MISS
      parameter (MAXSIZ=1000,MISS=-9999)
      integer curped, higen
C Pedigree structure
      integer num
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ)
      integer ord(MAXSIZ), set(MAXSIZ,2)
C
C assorted counters, indices
C
      integer cfa, cmo, eoi, eoi2, i, j, mat, pos
C Functions
      integer eow

      do 20 j=1,higen
        cfa=MISS
        cmo=MISS
        pos=0
        write(*,'(1x,i3,a,$)') j,': '
        do 25 i=1,num
        if (ord(i).eq.j .and. set(i,1).eq.curped) then
          if (fa(i).ne.MISS) then
            if (fa(i).ne.cfa .or. mo(i).ne.cmo) then
              cfa=fa(i)
              cmo=mo(i)
              eoi=eow(id(cfa))
              eoi2=eow(id(cmo))
              mat=eoi+eoi2+12
              pos=mat
              write(*,'(/7x,5a,$)') 
     &          '{',id(cfa)(1:eoi),' x ',id(cmo)(1:eoi2),'}'
            end if
            eoi=eow(id(i))
            pos=pos+eoi+2
            if (pos.gt.78) then
              pos=mat+eoi+2
              write(*,'(/a,$)') '            '
              do 26 k=13,mat-1
                write(*,'(a1,$)') ' '
   26         continue
              write(*,'(a,$)') '+'
            end if
            write(*,'(2a,$)') '--',id(i)(1:eoi)
          else
            eoi=eow(id(i))
            pos=pos+eoi+3
            if (pos.gt.78) then
              write(*,'(/a,$)') '      '
              pos=eoi+9
            end if
            write(*,'(1x,3a,$)') '(',id(i)(1:eoi),')'
          end if
        end if
   25   continue
        write(*,*)
   20 continue
      return
      end
C end-of-wrgen
C
C Find the ancestor(s) shared by the maximum number of affecteds
C
      subroutine ancest(wrk,locnam,trait,gt,thresh,pedigree,actset,num,
     &                  nfound, id,fa,mo,sex,locus,numloc,aff,plevel)
      integer MAXLOC,MAXSIZ,MISS
      parameter(MAXLOC=120,MAXSIZ=1000,MISS=-9999)

      integer plevel, trait, wrk
      logical gt
      character*10 locnam
      real thresh
      character*10 pedigree  
      character*8 id(MAXSIZ)
      integer actset,num, fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      integer numloc
      real locus(MAXSIZ,MAXLOC)
      integer aff(MAXSIZ)
C local variables
      integer bestid, nid, bestfa, nfa, bestmo, nmo, i, totaff
      logical last
C functions
      real isaff
C
      write(*,'(/a/3a/a)')
     2  '--------------------------------------------------',
     3  'Ancestors of probands with trait "',locnam,'"',
     4  '--------------------------------------------------' 
      if (thresh.ne.MISS) then
        if (gt) then
          write(*,'(a,f9.4/)') 
     &      'NOTE:  Proband defined as trait value > ',thresh
        else
          write(*,'(a,f9.4/)') 
     &      'NOTE:  Proband defined as trait value < ',thresh
        end if
      end if
      write(*,'(/a/a)')
     2  'Pedigree   Father   Mother   Number of Affected Descendents',
     3  '---------- -------- -------- ------------------------------'
      last=.false.
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20
C 
C Skip if singleton
C
       if (actset.le.0 .or. num.le.3) goto 10

         totaff=0
         do 25 i=1,num
         if (isaff(locus(i,trait),thresh,gt).eq.2.0) then
           aff(i)=1
           totaff=totaff+1
         else
           aff(i)=0
         end if
   25    continue
C 
C Skip if nobody affected
C
       if (totaff.eq.0) goto 10
C
C Accumulate counts of descendents who are affected
C
         bestid=MISS
         nid=0
         bestfa=MISS
         nfa=0
         bestmo=MISS
         nmo=0
         do 30 i=num,nfound+1,-1
           aff(fa(i))=aff(fa(i))+aff(i)
           aff(mo(i))=aff(mo(i))+aff(i)
   30    continue
C
C Find largest count of affecteds as low in the pedigree as possible
C
         do 40 i=num,nfound+1,-1
           if (aff(i).gt.nid) then
             nid=aff(i)
             bestid=i
           end if
           if ((aff(fa(i))+aff(mo(i))).gt.(nfa+nmo)) then
             bestfa=fa(i)
             nfa=aff(fa(i))
             bestmo=mo(i)
             nmo=aff(mo(i))
           end if
   40    continue
         do 50 i=nfound,1,-1
           if (aff(i).gt.nid) then
             nid=aff(i)
             bestid=i
           end if
   50    continue
C
C Write the best individual ancestor and ancestral mating
C
         call wrdesc(pedigree,id(bestid),sex(bestid),nid,totaff)
         write(*,'(a10,1x,a8,1x,a8,1x,2(i4,a,f5.1,a))') 
     2     pedigree,id(bestfa),id(bestmo),
     3     nfa,' (',float(100*nfa)/float(totaff),'%), ',
     4     nmo,' (',float(100*nmo)/float(totaff),'%)'
         if (plevel.gt.1) then
           write(*,*) 
           do 100 i=1, num
           if (aff(i).gt.1) then
             call wrdesc(pedigree,id(i),sex(i),aff(i),totaff)
           end if
  100      continue
           write(*,*) 
         end if
       goto 10
   20 continue
      return
      end
C end-of-ancest
C write person and number of descendants
      subroutine wrdesc(pedigree,cid,sx,ndesc,ntot)
      character*10 pedigree
      character*8 cid
      integer ndesc, ntot, sx
      if (sx.eq.1) then
        write(*,'(a10,1x,a8,10x,i4,a,f5.1,a)') pedigree,cid,
     &     ndesc,' (',float(100*ndesc)/float(ntot),'%)'
      else
        write(*,'(a10,10x,a8,1x,i4,a,f5.1,a)') pedigree,cid,
     &     ndesc,' (',float(100*ndesc)/float(ntot),'%)'
      end if
      return
      end
C end-of-wrdesc
C
C Prune pedigree to ancestors shared by affecteds
C
      subroutine prunep(wrk,twrk,locnam,trait,gt,thresh,
     2                  pedigree,num,nfound,id,fa,mo,sex,locus,numloc,
     3                  key,ord,set,plevel)
      integer MAXLOC,MAXSIZ,MISS
      parameter(MAXLOC=120,MAXSIZ=1000,MISS=-9999)

      integer plevel, trait, twrk, wrk
      logical gt
      character*10 locnam
      real thresh
      character*10 pedigree  
      character*8 id(MAXSIZ)
      integer actset,num, fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      integer numloc
      real locus(MAXSIZ,MAXLOC)
      integer key(MAXSIZ), ord(MAXSIZ), set(MAXSIZ,2)
C local variables
      integer i, no, nf, naff, pos, totno, totnum
      logical last
C functions
      real isaff
C

      totno=0
      totnum=0
      
      write(*,'(/a/3a/a)')
     2  '--------------------------------------------------',
     3  ' Pruning pedigrees of probands with trait "',locnam,'"',
     4  '--------------------------------------------------' 
      if (thresh.ne.MISS) then
        if (gt) then
          write(*,'(a,f9.4/)') 
     &      'NOTE:  Proband defined as trait value > ',thresh
        else
          write(*,'(a,f9.4/)') 
     &      'NOTE:  Proband defined as trait value < ',thresh
        end if
      end if
      if (plevel.gt.1) then
        write(*,'(a/a/)') 
     2    '           Number of        Pedigree Size',
     3    'Pedigree   Index Cases  Original       New'
      end if

      last=.false.
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20
C 
         if (actset.le.0) then
           call wrkout(twrk,pedigree,actset,num,nfound,id,fa,mo,sex,
     &                 locus,numloc)
           goto 10
         end if

         totnum=totnum+num
         naff=0
         do 25 i=1,num
           if (isaff(locus(i,trait),thresh,gt).eq.2.0) then
             set(i,1)=1
             set(i,2)=1
             naff=naff+1
           else
             set(i,1)=0
             set(i,2)=0
           end if
           ord(i)=0
   25    continue
C 
C Skip if nobody affected
C
       if (naff.eq.0) goto 10
C
C Accumulate counts of descendents who are affected
C
         do 30 i=num,nfound+1,-1
           set(fa(i),1)=set(fa(i),1)+set(i,1)
           set(mo(i),1)=set(mo(i),1)+set(i,1)
   30    continue
C
C Find MRCAs 
         do 40 i=nfound+1, num
         if (set(i,1).ne.0) then
           if (set(fa(i),1).gt.set(i,1)) set(fa(i),2)=1
           if (set(mo(i),1).gt.set(i,1)) set(mo(i),2)=1
         end if
   40    continue
C Add connectors and other parents, if needed
         do 50 i=nfound+1, num
           if (set(i,1).ne.0) then
             if (set(fa(i),2).ne.0) set(i,2)=1
             if (set(mo(i),2).ne.0) set(i,2)=1
           end if
           if (set(i,2).ne.0) then
             if (set(fa(i),2).ne.0) set(mo(i),2)=1
             if (set(mo(i),2).ne.0) set(fa(i),2)=1
           end if
   50    continue
C
C New founders
         nf=0
         do 60 i=1, nfound
         if (set(i,2).ne.0) then
           nf=nf+1
           ord(i)=nf
         end if
   60    continue
         do 70 i=nfound+1, num
         if (set(i,2).ne.0 .and. 
     &       set(fa(i),2).eq.0 .and. set(mo(i),2).eq.0) then
           nf=nf+1
           ord(i)=nf
           fa(i)=MISS
           mo(i)=MISS
         end if
   70    continue
C New nonfounders
         no=nf
         do 80 i=nfound+1, num
         if (set(i,2).ne.0 .and. ord(i).eq.0) then
           no=no+1
           ord(i)=no
           fa(i)=ord(fa(i))
           mo(i)=ord(mo(i))
         end if
   80    continue
         totno=totno+no
C write new pedigree
         if (plevel.gt.1) then
           write(*,'(a10,1x,i5,2(8x,i5))') pedigree, naff, num, no
         end if
         do 100 i=1,num
         if (ord(i).ne.0) then
           key(ord(i))=i
         end if
  100    continue
         write(twrk) pedigree, actset, no, nf
         do 110 i=1,no
           pos=key(i)
           write(twrk) id(pos),fa(pos),mo(pos),sex(pos),
     &                 (locus(pos,j),j=1,numloc)
  110    continue
       goto 10
   20 continue
      write(*,'(/a,i5,a)') 
     &  'Dropped ',totnum-totno, ' pedigree members.'
      return
      end
C end-of-prunep

C
C Create order of loci for outputting a pedigree
C  1 = as is
C  2 = LINKAGE
C  3 = GENEHUNTER
C  4 = MENDEL
C
      subroutine lorder(typ,nloci,loctyp,nord,locord)
      integer MAXLOC
      parameter(MAXLOC=120)

      integer typ
C Locus structure
      integer nloci,loctyp(MAXLOC)
C Printing order of loci
      integer nord,locord(MAXLOC)

      integer i
C
C Default is no manipulation
C
      if (typ.lt.2) then
        nord=nloci
        do 10 i=1,nloci
          locord(i)=i
   10   continue
C
C else Genehunter 2 ordering
C
      else
        nord=0
C no more than one binary trait if typ=3
        if (typ.eq.2 .or. typ.eq.3) then
          do 20 i=1,nloci
          if (loctyp(i).eq.4) then
            nord=nord+1
            locord(nord)=i
            if (typ.eq.3) goto 21
          end if
   20     continue
   21     continue
        end if
C all the markers 
        do 30 i=1,nloci
        if (loctyp(i).eq.1 .or. loctyp(i).eq.2) then
          nord=nord+1
          locord(nord)=i
        end if
   30   continue
C MENDEL factors
        if (typ.eq.4) then
          do 40 i=1,nloci
          if (loctyp(i).eq.4) then
            nord=nord+1
            locord(nord)=i
          end if
   40     continue
        end if
C then the quantitative traits
        do 50 i=1,nloci
        if (loctyp(i).eq.3) then
          nord=nord+1
          locord(nord)=i
        end if
   50   continue
      end if
      return
      end
C end-of-order
C
C Write map 
C
C 10 = table for Sib-pair output
C  0 = LINKAGE
C  1 = LINKAGE plus dummy binary trait
C  2 = GENEHUNTER plus dummy binary trait
C  3 = GENEHUNTER
C  4 = MENDEL
C  5 = ASPEX
C  6 = MERLIN
C  7 = LOKI  
C  8 = STRUCTURE
C
      subroutine wrmap(ostr,typ,mapf,nloci,loc,loctyp,nord,locord, map)
      integer MAXLOC, MISS
      parameter(MAXLOC=120,MISS=-9999)

      integer mapf, ostr, typ
C Locus structure
      integer nloci,loctyp(MAXLOC)
      character*10 loc(MAXLOC)
C Printing order of loci
      integer nord,locord(MAXLOC)
C position of locus on sex-averaged linkage map
      real map(MAXLOC)

      integer i, k
      logical frst
      character*11 tnam
      real dist
C functions
      real invmap
C show map
      dist=0.0
      frst=.true.
      if (typ.eq.10) then
        write(*,'(/a//a/a)') 'User specified marker map:',
     2    'Marker    Pos (cM)   Theta' ,
     3    '------    --------   -----' 
        do 20 i=1,nloci
        if (loctyp(i).le.2 .and. map(i).ne.MISS) then
          dist=map(i)-dist
          if (dist.lt.0.0) dist=1000.0
          write(*,'(a10,f8.2,f8.3)') loc(i),map(i),invmap(dist,mapf)
          dist=map(i)
        end if
   20   continue
        write(*,*)
C write Linkage or Genehunter locus file map
      else if (typ.ge.0 .and. typ.le.3) then
        dist=MISS
        if (typ.eq.1 .or. typ.eq.2) write(OSTR,'(a,$)') '  .000'
        do 30 k=1,nord 
        i=locord(k)
        if (loctyp(i).le.4) then
          if (frst) then
            frst=.not.frst
          elseif (dist.ne.MISS .and. map(i).ge.dist) then
            if (typ.eq.2 .or.typ.eq.3) then
              write(ostr,'(1x,f6.2,$)') max(0.01,map(i)-dist)
            else
              write(ostr,'(1x,f6.4,$)') invmap(map(i)-dist,mapf)
            end if
          else
            if (typ.eq.2 .or. typ.eq.3) then
              write(ostr,'(a,$)') ' 0.0'
            else
              write(ostr,'(a,$)') ' .4999'
            end if
          end if
          dist=map(i)
        end if
   30   continue
C MENDEL map file
      else if (typ.eq.4) then
        do 40 i=1,nloci
        if (loctyp(i).le.4) then
          if (frst) then
            frst=.not.frst
          elseif (dist.ne.MISS .and. map(i).ge.dist) then
            dist=map(i)-dist
            write(ostr,'(8x,f8.4,f8.4)') 
     &        invmap(dist,mapf), invmap(dist,mapf)
          else
            write(ostr,'(8x,f8.4,f8.4)') 0.5, 0.5
          end if
          dist=map(i)
          write(ostr,'(a8)') loc(i)
        end if
   40   continue
C ASPEX map 
      else if (typ.eq.5) then
        k=0
        write(ostr,'(a,$)') 'set dist {'
        do 50 i=1,nloci
        if (loctyp(i).le.2) then
          k=k+1
          if (map(i).ne.MISS .and. map(i).ge.dist) then
            write(ostr,'(1x,f5.3,$)') 
     &        max(0.001,0.01*(map(i)-dist))
            dist=map(i)
          elseif (dist.eq.0.0) then
            write(ostr,'(a,$)') ' 0.001'
            dist=-100.0
          else
            write(ostr,'(a,$)') ' 0.50'
            dist=-100.0
          end if
          if (k.eq.6) then
            k=0
            write(ostr,'(/a,$)') '          '
          end if
        end if
   50   continue
        write(ostr,'(a)') ' 0.01 }'
C MERLIN map file
      else if (typ.eq.6) then
        do 60 i=1,nloci
        if (loctyp(i).le.2 .and. map(i).ne.MISS) then
          write(ostr,'(a,a10,f8.2)') '1 ',loc(i),map(i)
        end if
   60   continue
C LOKI parameter file map positions
      else if (typ.eq.7) then
        write(ostr,'(a/a//a,f8.2/)') 
     &    'ITERATIONS 1000', 'START OUTPUT 50,1', 'TOTAL MAP 3600.0'
        do 80 i=1,nloci
        if (loctyp(i).eq.1 .and. map(i).ne.MISS) then
          call addlet(loc(i), tnam)
          write(ostr,'(a,a10,f8.2)') 'POSITION ',tnam,map(i)
        end if
   80   continue
C STRUCTURE datafile map positions
      else if (typ.eq.8) then
        do 90 i=1,nloci
        if (loctyp(i).le.2) then
          write(ostr,'(1x,a,$)') loc(i)
        end if
   90   continue
        write(ostr,'(a)') ' '
        do 100 i=1,nloci
        if (loctyp(i).le.2) then
          if (frst) then
            frst=.not.frst
            write(ostr,'(1x,a2,$)') '-1'
          elseif (dist.ne.MISS .and. map(i).ge.dist) then
            dist=map(i)-dist
            write(ostr,'(1x,f7.2,$)') dist
          else
            write(ostr,'(1x,a2,$)') '-1'
          end if
          dist=map(i)
        end if
  100   continue
        write(ostr,*)
      end if
      return
      end
C end-of-wrmap
C
C Write out pedigree header with locus names 
C
      subroutine pedhead(longnam,nwid,nloci,loc,loctyp,locpos,lin)
      integer LINSIZ,MAXLOC
      parameter (LINSIZ=1024,MAXLOC=120)
      integer longnam,nwid
C Locus structure
      character*10 loc(MAXLOC)
      integer nloci,loctyp(MAXLOC),locpos(MAXLOC)
      character*(LINSIZ) lin
C local variables
      integer eos,i,j,pos
      character*3 sex
C functions
      integer eow
      data sex /'sex'/

      write(*,'(/a)') '!'
      do 10 i=1,2
        lin='!'
        pos=longnam+29
        lin(pos:pos)=sex(i:i)
        pos=pos+2
        do 15 j=1,nloci
        if(loctyp(j).le.2) then
           pos=pos+9
        elseif(loctyp(j).eq.3) then
           pos=pos+nwid+2
        elseif(loctyp(j).eq.4) then
           eos=max(0,3-eow(loc(j)))
           if (eos.lt.i) lin(pos:pos)=loc(j)(i-eos:i-eos)
           pos=pos+2
        end if
   15   continue
        write(*,'(a)') lin(1:pos)
   10 continue

      lin(1:longnam)='! Pedigree'
      pos=longnam+3
      lin(pos:pos+27)='Person   Father   Mother  x'
      pos=pos+28

      do 25 j=1,nloci
      if(loctyp(j).le.2) then
         eos=eow(loc(j))
         lin(pos+8-eos:pos+7)=loc(j)(1:eos)
         pos=pos+9
      elseif(loctyp(j).eq.3) then
         eos=min(nwid,eow(loc(j)))
         lin(pos+nwid-eos:pos+nwid-1)=loc(j)(1:eos)
         pos=pos+nwid+2
      elseif(loctyp(j).eq.4) then
         eos=max(0,3-eow(loc(j)))
         lin(pos:pos)=loc(j)(i-eos:i-eos)
         pos=pos+2
      end if
   25 continue
      write(*,'(a/a)') lin(1:pos),'!'
      return
      end
C end-of-pedhead
C
C Write out pedigree using GAS format
C
      subroutine pedout(wrk,strm,typ,imp,nwid,ndec,longnam,
     2             pedigree,actset,num,nfound,
     3             id,fa,mo,sex,locus,nloci,loctyp,locpos,numloc,lin)
      integer LINSIZ,KNOWN,MAXSIZ,MAXLOC,MISS
      parameter (LINSIZ=1024,KNOWN=0,MAXSIZ=1000,MAXLOC=120,MISS=-9999)
      integer imp,longnam,ndec,nwid,strm,typ,wrk
C Pedigree structure
      character*10 pedigree
      integer actset,num,nfound 
      character*8 id(MAXSIZ) 
      integer fa(MAXSIZ),mo(MAXSIZ),sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C Locus structure
      integer nloci,loctyp(MAXLOC),locpos(MAXLOC)
      character*(LINSIZ) lin
C local variables
      character*1 sep
      character*2 cdec, cwid
      character*8 fdec
      character*20 loc20,miss20

      integer i,j,pos
      logical last, noimp
C functions
      integer sow
C
C quantitative variable format
  
      sep=' '
      if (typ.eq.2) sep='/'
      write(cwid,'(i2)') nwid
      write(cdec,'(i2)') ndec
      write(fdec,'(5a)') 
     &  '(f', cwid(sow(cwid):2),'.',cdec(sow(cdec):2),')'
      miss20=' '
      pos=min(nwid-ndec,19)
      miss20(pos:pos)='x'

      noimp=(imp.ne.3 .and. imp.ne.6)
      last=.false.
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

       if (actset.le.0) goto 10

        do 15 i=1,num
C compulsory data
          lin=' '
          lin(1:longnam)=pedigree(1:longnam)
          pos=longnam+2 
          loc20=id(i)
          call juststr('r',loc20,8)
          lin(pos:pos+7)=loc20(1:8)
          pos=pos+9
          if (fa(i).eq.MISS) then
            lin(pos:pos+17)='       x        x'
            pos=pos+18
          else
            loc20=id(fa(i))
            call juststr('r',loc20,8)
            lin(pos:pos+7)=loc20(1:8)
            pos=pos+9
            loc20=id(mo(i))
            call juststr('r',loc20,8)
            lin(pos:pos+7)=loc20(1:8)
            pos=pos+9
          end if
          if (sex(i).eq.2) then
            lin(pos:pos)='f'
          elseif (sex(i).eq.1) then
            lin(pos:pos)='m'
          else
            lin(pos:pos)='x'
          end if
          pos=pos+2
C phenotypes
          do 25 j=1,nloci
          if(loctyp(j).le.2) then
             if(locus(i,locpos(j)).eq.MISS .or. 
     &          (noimp .and. locus(i,locpos(j)).le.KNOWN)) then
               write(loc20,'(1x,a3,a1,a3)') 'x',sep,'x'
             else
               write(loc20,'(1x,i3,a1,i3)') 
     2           int(abs(locus(i,locpos(j)))),sep, 
     3           int(abs(locus(i,locpos(j)+1)))
             end if
             lin(pos:pos+7)=loc20(1:8)
             pos=pos+9
          elseif(loctyp(j).eq.3) then
             if(locus(i,locpos(j)).eq.MISS) then
               write(loc20,'(a)') miss20
             else
               write(loc20,fdec) locus(i,locpos(j))
             end if
             lin(pos:pos+nwid-1)=loc20(1:nwid)
             pos=pos+nwid+2
          elseif(loctyp(j).eq.4) then
             if (locus(i,locpos(j)).eq.MISS .or.
     &           locus(i,locpos(j)).eq.0.0) then
               lin(pos:pos)='x'
             elseif(locus(i,locpos(j)).eq.1.0) then
               lin(pos:pos)='n'
             elseif(locus(i,locpos(j)).eq.2.0) then
               lin(pos:pos)='y'
             end if
             pos=pos+2
          end if
   25     continue
          write(strm,'(a)') lin(1:pos-2)
   15   continue
      goto 10
   20 continue
      return
      end
C end-of-pedout
C
C Write out PAP pedigree
C
      subroutine wrpap(wrk,wrk2,trip,phen,pedigree,actset,num,nfound,
     2                 id,fa,mo,sex,locus,nloci,loctyp,locpos,numloc,
     3                 numal,name,alfrq)
      integer KNOWN,LINSIZ,MAXALL,MAXSIZ,MAXLOC,MISS
      parameter (KNOWN=0,LINSIZ=1024,MAXALL=60,MAXSIZ=1000,
     &           MAXLOC=120,MISS=-9999)
      integer phen,trip,wrk,wrk2
C Pedigree structure
      character*10 pedigree
      character*8 id(MAXSIZ)
      integer actset,num,nfound,fa(MAXSIZ),mo(MAXSIZ),sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C Locus structure
      integer nloci,loctyp(MAXLOC),locpos(MAXLOC)
      character*(LINSIZ) lin
      character*8 loc1
C allele frequencies structure
      integer numal, name(MAXALL)
      double precision alfrq(MAXALL)
C local variables
      integer eop,famcnt,famno,g1,g2,i,j,pos,nfam,sx 
      logical last
C functions
      integer eow, getnam
C
C A unique ID number is obtained for each individual by adding the famno
C (which increases in multiples of famcnt, minimum 1000) to their position
C 1..num
C 
      famcnt=int(10.0**int(max(3.0,1.0+log10(float(MAXSIZ)))))
      famno=0
      nfam=0
      pedigree=' '
      last=.false.
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

         if (actset.le.0) goto 10

         nfam=nfam+1
         famno=famno+famcnt
         eop=eow(pedigree)
         lin=' '
         if (num.eq.nfound) then
           do 14 i=1,num
           if (sex(i).eq.1) then
             write(trip,'(4i8,4a)') 
     &       nfam,famno+i,famno+num+i,0,' # ',pedigree(1:eop),'-',id(i)
           else
             write(trip,'(4i8,4a)') 
     &       nfam,famno+num+i,famno+i,0,' # ',pedigree(1:eop),'-',id(i)
           end if
   14      continue
         end if
         do 15 i=1,num
           rewind(wrk2)
           sx=1
           if (sex(i).eq.2) sx=2
           if (fa(i).ne.MISS.and.mo(i).ne.MISS) then
             write(trip,'(4i8,9a)') 
     2       nfam,famno+fa(i),famno+mo(i),famno+i,
     3       ' # ',pedigree(1:eop),'-',id(i),
     4       ' (',id(fa(i))(1:eow(id(fa(i)))),' x ',
     5            id(mo(i))(1:eow(id(mo(i)))),')'
           end if
           write(loc1,'(i8)') famno+i
           lin(1:8)=loc1
           write(loc1,'(i8)') sx
           lin(9:16)=loc1
           pos=17
           do 17 j=1,nloci
             if (pos.gt.122) then
               write(phen,'(a)') lin(1:pos-1)
               lin(1:pos-1)=' '
               pos=1
             end if 
            if (loctyp(j).eq.1) then
              read(wrk2) numal,(name(k),k=1,numal),(alfrq(k),k=1,numal)
              if (locus(i,locpos(j)).lt.KNOWN) then
                write(loc1,'(a8)') '   -9999'
              else
                g1=getnam(locus(i,locpos(j)),numal,name)
                g2=getnam(locus(i,locpos(j)+1),numal,name)
                write(loc1,'(i8)') g2*(g2-1)/2+g1
              end if
              lin(pos:pos+7)=loc1
              pos=pos+8
            elseif (loctyp(j).eq.3) then
             if (locus(i,locpos(j)).eq.MISS) then
               write(loc1,'(a8)') '   -9999'
             else
               write(loc1,'(f8.4)') locus(i,locpos(j))
             end if
             lin(pos:pos+7)=loc1
             pos=pos+8
           elseif (loctyp(j).eq.4) then
             if (locus(i,locpos(j)).eq.MISS) then
               write(loc1,'(a8)') '   -9999'
             elseif (locus(i,locpos(j)).eq.1) then
               write(loc1,'(a8)') '1'
             elseif (locus(i,locpos(j)).eq.2) then
               write(loc1,'(a8)') '2'
             end if
             lin(pos:pos+7)=loc1
             pos=pos+8
           end if
   17      continue
           if (pos.gt.1) then
             write(phen,'(a)') lin(1:pos-1)
             lin(1:pos-1)=' '
             pos=1
           end if 
   15    continue
      goto 10
   20 continue
      return
      end
C end-of-wrpap
C
C Write out SAGE pedigree
C
      subroutine wrsage(wrk,strm,pedigree,actset,num,id,fa,mo,sex,locus,
     &                  nloci, loctyp,locpos,numloc)
      integer LINSIZ,MAXSIZ,MAXLOC,MISS
      parameter (LINSIZ=1024,MAXSIZ=1000,MAXLOC=120,MISS=-9999)
      integer strm,wrk,actset,num
C Pedigree structure
      character*10 pedigree
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ),mo(MAXSIZ),sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C Locus structure
      integer nloci,loctyp(MAXLOC),locpos(MAXLOC)
      character*(LINSIZ) lin
      character*9 loc1
      character*4 loc2
      character*1 sx
      integer i,j,pos,nfound,nfam
      logical last
      nfam=0
      pedigree=' '
      last=.false.
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

         if (actset.le.0) goto 10

         nfam=nfam+1
         pos=1
         lin=' '

         do 15 i=1,num
           sx='M'
           if (sex(i).eq.2) sx='F'
           if (fa(i).eq.MISS.and.mo(i).eq.MISS) then
             write(strm,'(a5,i5,a8,16x,a1)') 
     &          'fsp  ',nfam,id(i),sx
           else
             write(strm,'(a5,i5,3a8,a1)') 
     &          'fsp  ',nfam,id(i),id(fa(i)),id(mo(i)),sx
           end if
           do 17 j=1,nloci
             if (pos.gt.122) then
               write(strm,'(a)') lin(1:pos-1)
               lin(1:pos-1)=' '
               pos=1
             end if 
            if (loctyp(j).eq.1) then
              if (locus(i,locpos(j)).eq.MISS) then
                write(loc1,'(a9)') ' '
              else
                write(loc1,'(i4.4,a1,i4.4)') 
     &            int(locus(i,locpos(j))),'/',int(locus(i,locpos(j)+1))
              end if
              lin(pos:pos+8)=loc1
              pos=pos+9
            elseif (loctyp(j).eq.3) then
             if (locus(i,locpos(j)).eq.MISS) then
               write(loc1,'(1x,f8.4)') -99.0
             else
               write(loc1,'(1x,f8.4)') locus(i,locpos(j))
             end if
             lin(pos:pos+8)=loc1
             pos=pos+9
           elseif (loctyp(j).eq.4) then
             if (locus(i,locpos(j)).eq.MISS) then
               write(loc2,'(1x,a3)') '-99'
             elseif (locus(i,locpos(j)).eq.1) then
               write(loc2,'(1x,a3)') '1'
             elseif (locus(i,locpos(j)).eq.2) then
               write(loc2,'(1x,a3)') '2'
             end if
             lin(pos:pos+3)=loc2
             pos=pos+4
           end if
   17      continue
           if (pos.gt.1) then
             write(strm,'(a)') lin(1:pos-1)
             lin(1:pos-1)=' '
             pos=1
           end if 
   15    continue
      goto 10
   20 continue

      return
      end
C end-of-wrsage
C
C write out linkage type file
C
      subroutine wrlink(wrk,wrk2,strm,typ,nwid,ndec,pedigree,actset,
     2             num, nfound,id,fa,mo,sex,locus,nloci,loctyp,locpos,
     3             nord,locord,numloc,numal,name,alfrq)
      integer KNOWN,LINSIZ,MAXSIZ,MAXLOC,MISS,MAXALL
      parameter (KNOWN=0,LINSIZ=1024,MAXSIZ=1000,MAXLOC=120,
     &           MISS=-9999,MAXALL=60)
      integer ndec,nwid,strm,typ,wrk,wrk2
C Pedigree structure
      character*10 pedigree
      integer actset, num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ),mo(MAXSIZ),sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C Locus structure
      integer nloci,loctyp(MAXLOC),locpos(MAXLOC)
C Printing order of loci
      integer nord,locord(MAXLOC)
C allele frequencies structure
      integer numal, name(MAXALL)
      double precision alfrq(MAXALL)
C
      character*(LINSIZ) lin
      character*2 cdec, cwid
      character*8 fdec
      character*20 loc20,miss20
      character*1 sx
      integer i,j,k,l,pos
      logical last
C functions
      integer getnam, sow
C
C quantitative variable format 
      write(cwid,'(i2)') nwid
      write(cdec,'(i2)') ndec
      write(fdec,'(5a)') 
     &  '(f', cwid(sow(cwid):2),'.',cdec(sow(cdec):2),')'
      miss20=' '
      pos=min(nwid-ndec,19)
      if (typ.eq.2 .or. typ.eq.3) then
        miss20(pos:pos)='-'
      else
        miss20(pos:pos)='0'
      end if

      pedigree=' '
      last=.false.
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

        if (actset.le.0) goto 10

        do 15 i=1,num
          rewind(wrk2)
          lin=' '
          sx='1'
          if (sex(i).eq.2) sx='2'
          write(loc20,'(a10,1x,a8)') pedigree,id(i)
          lin(1:19)=loc20(1:19)
          if (fa(i).eq.MISS) then
            write(loc20,'(1x,a8,1x,a8,1x,a1)') '0       ','0       ',sx
          else
            write(loc20,'(1x,a8,1x,a8,1x,a1)') id(fa(i)),id(mo(i)),sx
          end if
          lin(20:39)=loc20
          pos=41
C Add dummy binary trait when asked
          if (typ.eq.1 .or. typ.eq.2) then
            lin(41:43)=' 2 '
            pos=44
          end if
          do 25 l=1,nord
            j=locord(l)
            if (loctyp(j).le.2) then
              read(wrk2) numal,(name(k),k=1,numal),(alfrq(k),k=1,numal)
              if(locus(i,locpos(j)).le.KNOWN) then
                write(loc20,'(1x,a3,1x,a3)') '0','0'
              else
                write(loc20,'(1x,i3,1x,i3)') 
     2           getnam(locus(i,locpos(j)),numal,name),
     3           getnam(locus(i,locpos(j)+1),numal,name)
              end if
              lin(pos:pos+7)=loc20(1:8)
              pos=pos+9
            elseif (loctyp(j).eq.3) then
              if(locus(i,locpos(j)).eq.MISS) then
                write(loc20,'(a)') miss20
              elseif(locus(i,locpos(j)).eq.0.0) then
                write(loc20,'(a)') '  0.000001'
              else
                write(loc20,fdec) locus(i,locpos(j))
              end if
              lin(pos:pos+nwid-1)=loc20(1:nwid)
              pos=pos+nwid+2
            elseif (loctyp(j).eq.4) then
              if (locus(i,locpos(j)).eq.1) then
                lin(pos:pos)='1'
              elseif (locus(i,locpos(j)).eq.2.0) then
                lin(pos:pos)='2'
              else
                lin(pos:pos)='0'
              end if
              pos=pos+2
            end if
   25     continue
         write(strm,'(a)') lin(1:pos-1)
   15   continue
      goto 10
   20 continue
      return
      end
C end-of-wrlink
C
C write out CRI-MAP type file
C
      subroutine wrcri(wrk,wrk2,strm,pedigree,actset,num,id,fa,mo,sex,
     2                 locus,nloci,loctyp,locpos,numloc,
     3                 numal,name,alfrq)
      integer KNOWN,LINSIZ,MAXSIZ,MAXLOC,MISS,MAXALL
      parameter (KNOWN=0,LINSIZ=1024,MAXSIZ=1000,MAXLOC=120,
     &           MISS=-9999,MAXALL=60)
      integer strm,wrk,wrk2,actset,num
C Pedigree structure
      character*10 pedigree
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ),mo(MAXSIZ),sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C Locus structure
      integer nloci,loctyp(MAXLOC),locpos(MAXLOC)
C allele frequencies structure
      integer numal, name(MAXALL)
      double precision alfrq(MAXALL)
C
      character*(LINSIZ) lin
      character*8 part1
      character*20 part2
      character*9 loc1
      character*1 sx
      integer i,j,pos,nfound
      logical last
C functions
      integer getnam
C
      pedigree=' '
      last=.false.
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

        if (actset.le.0) goto 10

        write(strm,'(1x,a10/1x,i3)') pedigree, num
        do 15 i=1,num
          rewind(wrk2)
          lin=' '
          write(part1,'(a8)') id(i)
          sx='0'
          if (sex(i).eq.2) sx='1'
          if (fa(i).eq.MISS) then
            write(part2,'(1x,a8,1x,a8,1x,a1)') '0       ','0       ',sx
          else
            write(part2,'(1x,a8,1x,a8,1x,a1)') id(fa(i)),id(mo(i)),sx
          end if
          lin(1:8)=part1
          lin(9:28)=part2
          pos=29
          do 25 j=1,nloci
          if(loctyp(j).eq.1) then
             read(wrk2) numal,(name(k),k=1,numal),(alfrq(k),k=1,numal)
             if(locus(i,locpos(j)).le.KNOWN) then
               write(loc1,'(1x,a3,1x,a3)') '0','0'
             else
               write(loc1,'(1x,i3,1x,i3)') 
     2          getnam(locus(i,locpos(j)),numal,name),
     3          getnam(locus(i,locpos(j)+1),numal,name)
             end if
             lin(pos:pos+8)=loc1
             pos=pos+9
          end if
   25     continue
         write(strm,'(a)') lin(1:pos-1)
   15   continue
      goto 10
   20 continue
      return
      end
C end-of-wrcri
C
C write out FISHER or MENDEL type pedigree file
C
      subroutine wrfish(wrk,strm,pedigree,actset,num,nfound,id,fa,mo,
     2                  sex, locus,nloci,loctyp,locpos,numloc,nord,
     3                  locord, fstyle)
      integer KNOWN,LINSIZ,MAXSIZ,MAXLOC,MISS
      parameter (KNOWN=0,LINSIZ=1024,MAXSIZ=1000,MAXLOC=120,MISS=-9999)
      integer strm,wrk,fstyle
C Pedigree structure
      character*10 pedigree
      character*8 id(MAXSIZ)
      integer actset,num,nfound,fa(MAXSIZ),mo(MAXSIZ),sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C Locus structure
      integer nloci,loctyp(MAXLOC),locpos(MAXLOC)
C Printing order of loci
      integer nord,locord(MAXLOC)

      character*(LINSIZ) lin
      character*22 part2
      character*9 loc1
      character*1 sx
      integer i,j,k,pos,nlp
      logical last
      pedigree=' '
      last=.false.
      nlp=0
      do 1 i=1,nloci
        if(loctyp(i).le.4) nlp=nlp+1
    1 continue
      if (fstyle.eq.1) then
        write(strm,'(1x,a/1x,a,i3,a)') 
     &      '(2(i3,1x),a8)','(a8,2(1x,a8),2(1x,a1),',nlp,'(1x,a8))'
      else
        write(strm,'(1x,a/1x,a,i3,a)') 
     &      '(i3,1x,a8)','(a8,2(1x,a8),2(1x,a1),',nlp,'(1x,a8))'
      end if
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

        if (actset.le.0) goto 10

        if (fstyle.eq.1) then
          write(strm,'(2(i3,1x),a8)') 0,num,pedigree(1:8)
        else
          write(strm,'(i3,1x,a8)') num,pedigree(1:8)
        end if
        do 15 i=1,num
          lin=' '
          sx='M'
          if (sex(i).eq.2) sx='F'
          lin(1:8)=id(i)
          if (fa(i).eq.MISS) then
            write(part2,'(1x,a8,1x,a8,1x,a1,1x,a1)') ' ',' ',sx,' '
          else
            write(part2,'(1x,a8,1x,a8,1x,a1,1x,a1)') 
     &            id(fa(i)),id(mo(i)),sx,' '
          end if
          lin(9:30)=part2
          pos=31
          do 25 k=1,nord 
            j=locord(k)
            if (loctyp(j).le.2) then
              if (locus(i,locpos(j)).le.KNOWN) then
                write(loc1,'(1x,a8)') ' '
              else
                write(loc1,'(2x,i3.3,a1,i3.3)') 
     2            abs(int(locus(i,locpos(j)))),'/',
     3            abs(int(locus(i,locpos(j)+1)))
              end if
              lin(pos:pos+8)=loc1
              pos=pos+9
            elseif(loctyp(j).eq.3) then
              if(locus(i,locpos(j)).eq.MISS) then
                write(loc1,'(1x,a8)') ' '
              else
                write(loc1,'(1x,f8.4)') locus(i,locpos(j))
              end if
              lin(pos:pos+8)=loc1
              pos=pos+9
            elseif(loctyp(j).eq.4) then
              if(locus(i,locpos(j)).eq.1.0) then
                write(loc1,'(1x,a8)') 'NORMAL  '
              elseif(locus(i,locpos(j)).eq.2.0) then
                write(loc1,'(1x,a8)') 'AFFECTED'
              else
                write(loc1,'(1x,a8)') ' '
              end if
              lin(pos:pos+8)=loc1
              pos=pos+9
            end if
   25     continue
          write(strm,'(a)') lin(1:pos-1)
   15   continue
      goto 10
   20 continue
      return
      end
C end-of-wrfish
C
C write out Arlequin data file (haplotype data)
C
      subroutine wrarl(wrk,wrk2,strm,pedigree,actset,num,nfound,id,fa,
     2                 mo,sex, locus,nloci,loc,loctyp,locpos,numloc,
     3                 mar,hset,typ)
      integer KNOWN,MAXHAP,MAXSIZ,MAXLOC,MISS
      parameter (KNOWN=0,MAXSIZ=1000,MAXLOC=120,
     &           MAXHAP=MAXLOC/2,MISS=-9999)
      integer strm,typ,wrk,wrk2
C Pedigree structure
      character*10 pedigree
      character*8 id(MAXSIZ)
      integer actset,num,nfound,fa(MAXSIZ),mo(MAXSIZ),sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C Locus structure
      integer nloci,loctyp(MAXLOC),locpos(MAXLOC)
      character*10 loc(MAXLOC)
C
C Storage space for haplotypes
      integer hset(MAXSIZ,MAXHAP,2)
C List of active marker loci
      integer mar(MAXLOC)
C local variables
      integer gene,gen2,i,j,k,maxid,maxinf,ninf,nlp,nsamp
      integer nt1, nt2, tr1, tr2
      character*3 all  
      logical last

      nlp=0
      do 1 j=1,nloci
      if (loctyp(j).eq.1) then
        nlp=nlp+1
        mar(nlp)=locpos(j)
      end if
    1 continue
      nsamp=0

      pedigree=' '
      last=.false.
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

        if (actset.le.0) goto 10
C
C Go through pedigree, either all member genotypes
        if (typ.eq.0) then
         do 12 i=1,num
           ninf=0
           do 13 j=1,nlp
             gene=mar(j)
             gen2=gene+1
             hset(1,j,1)=MISS
             hset(1,j,2)=MISS
             if (locus(i,gene).gt.KNOWN) then
               ninf=ninf+1
               hset(1,j,1)=int(locus(i,gene))
               hset(1,j,2)=int(locus(i,gen2))
             end if
   13      continue
           if (ninf.gt.1) then
             nsamp=nsamp+1
             write(wrk2) ((hset(1,j,k),j=1,nlp),k=1,2)
           end if
   12    continue
        else
C
C or the most useful callable haplotype per family
         maxid=0
         maxinf=0
         do 15 i=nfound+1,num
           ninf=0
           do 16 j=1,nlp
             gene=mar(j)
             gen2=gene+1
             if (locus(i,gene).gt.KNOWN .and. locus(fa(i),gene).gt.KNOWN
     2           .and. locus(mo(i),gene).gt.KNOWN) then
               ninf=ninf+1
               call trans(int(locus(fa(i),gene)),int(locus(fa(i),gen2)),
     2                    int(locus(mo(i),gene)),int(locus(mo(i),gen2)),
     3                    int(locus(i,gene)), int(locus(i,gen2)),
     4                    tr1,tr2,nt1,nt2,0)
               hset(i,j,1)=tr1
               hset(i,j,2)=tr2
               hset(mo(i),j,1)=tr1
               hset(mo(i),j,2)=nt1
               hset(fa(i),j,1)=tr2
               hset(fa(i),j,2)=nt2
             else
               hset(i,j,1)=MISS
               hset(i,j,2)=MISS
               hset(mo(i),j,1)=MISS
               hset(mo(i),j,2)=MISS
               hset(fa(i),j,1)=MISS
               hset(fa(i),j,2)=MISS
             end if
   16      continue
           if (ninf.gt.maxinf) then
             maxinf=ninf
             maxid=i
           end if
   15    continue
         if (maxinf.gt.1) then
           if (typ.eq.1) then
             nsamp=nsamp+1
             write(wrk2) ((hset(maxid,j,k),j=1,nlp),k=1,2)
           else
             nsamp=nsamp+2
             write(wrk2) ((hset(fa(maxid),j,k),j=1,nlp),k=1,2)
             write(wrk2) ((hset(mo(maxid),j,k),j=1,nlp),k=1,2)
           end if
         end if
        end if
      goto 10
   20 continue
C
C Write haplotypes
C
      write(strm,'(a/a/a/a)') 
     &  '#','# Arlequin format data written by Sib-pair','#','[Profile]' 
      if (typ.eq.0) then
        write(strm,'(3x,a)') 
     &    'Title="Genotype data: All genotyped individuals"' 
      else if (typ.eq.1) then
        write(strm,'(3x,a)') 
     &    'Title="Haplotype data: one child per family"' 
      else
        write(strm,'(3x,a)') 
     &   'Title="Haplotype data: two parents per family"' 
      end if
      write(strm,'(3x,a)') 
     2  'NbSamples=1', 'GenotypicData=1'  
      write(strm,'(3x,a,i1)') 'GameticPhase=',min(typ,1)
      write(strm,'(3x,a)') 
     2  'RecessiveData=0','DataType=STANDARD',
     3  'LocusSeparator=WHITESPACE','MissingData="x"'
      write(strm,'(a/3x,a/6x,a/6x,a,i5/6x,a)') '[Data]','[[Samples]]',
     &  'SampleName="Population 1"', 'SampleSize=',nsamp,'SampleData= {'
C
      rewind(wrk2)
      do 50 i=1,nsamp
        read(wrk2) ((hset(1,j,k),j=1,nlp),k=1,2)
        write(strm,'(i10,i3,$)') i,1 
        do 60 j=1,nlp
          call wrall(hset(1,j,1),all)
          write(strm,'(1x,a3,$)') all
   60   continue
        write(strm,'(/12x,a,$)') ' '
        do 65 j=1,nlp
          call wrall(hset(1,j,2),all)
          write(strm,'(1x,a3,$)') all
   65   continue
        write(strm,*)
   50 continue
      write(strm,'(6x,a)') '}'
      return
      end
C end-of-wrarl 
C
C write out data file used by Jonathon Pritchard's structure program
C
      subroutine wrprd(wrk,strm,trait,pedigree,actset,num,nfound,id,fa,
     &             mo,sex,locus,nloci,loc,loctyp,locpos,numloc,typ)
      integer KNOWN,LMISS,LINSIZ,MAXSIZ,MAXLOC,MISS
      parameter (KNOWN=0,LINSIZ=1024,MAXSIZ=1000,MAXLOC=120,
     &           LMISS=-9, MISS=-9999)
      integer strm,trait,wrk
      integer typ
C Pedigree structure
      character*10 pedigree
      character*8 id(MAXSIZ)
      integer actset,num,nfound,fa(MAXSIZ),mo(MAXSIZ),sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C Locus structure
      integer nloci,loctyp(MAXLOC),locpos(MAXLOC)
      character*10 loc(MAXLOC)

      integer eop,fin,g1,g2,i,j,tval
      logical last
C functions
      integer eow

      pedigree=' '
      last=.false.

      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

        if (actset.le.0) goto 10

        eop=eow(pedigree)
        fin=num
        if (typ.eq.1) fin=nfound
        do 15 i=1,fin
          if (trait.eq.MISS) then
            tval=0
          else
            tval=int(locus(i,trait))-1
          end if
          write(strm, '(3a, 2(1x, i2),$)') 
     &      pedigree(1:eop),'-',id(i)(1:eow(id(i))), 1, tval
          do 25 j=1,nloci
          if (loctyp(j).eq.1) then
            g1=int(locus(i,locpos(j)))
            g2=int(locus(i,locpos(j)+1))
            if (g1.le.KNOWN) then
              g1=LMISS
              g2=LMISS
            end if
            write(strm,'(1x,i3,1x,i3,$)') g1,g2
          end if
   25     continue
          write(strm,*) 
   15   continue
      goto 10
   20 continue
      return
      end
C end-of-wrprd 
C
C write out Nexus gdatype data file used by GDA
C
      subroutine wrgda(wrk,strm,pedigree,actset,num,nfound,id,fa,mo,sex,
     &                 locus,nloci,loc,loctyp,locpos,numloc,typ)
      integer KNOWN,LINSIZ,MAXSIZ,MAXLOC,MISS
      parameter (KNOWN=0,LINSIZ=1024,MAXSIZ=1000,MAXLOC=120,MISS=-9999)
      integer strm,wrk
      integer typ
C Pedigree structure
      character*10 pedigree
      character*8 id(MAXSIZ)
      integer actset,num,nfound,fa(MAXSIZ),mo(MAXSIZ),sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C Locus structure
      integer nloci,loctyp(MAXLOC),locpos(MAXLOC)
      character*10 loc(MAXLOC)
      character*(LINSIZ) lin
      character*9 loc1
      integer eop,fin,i,j,n,nlp,pos
      logical last
C functions
      integer eow

      pedigree=' '
      last=.false.
      n=0
      nlp=0
      do 1 j=1,nloci
        if(loctyp(j).eq.1) nlp=nlp+1
    1 continue
      write(strm,'(3(a/),a,i3,a,2(/a))') 
     2  '#nexus','[ Nexus gdatype format data written by Sib-pair ]',
     3  'begin gdadata;', 'dimensions nloci=',nlp,' npops=1;',
     5  'format tokens labels missing=x datapoint=standard;',
     6  'locusallelelabels'
      i=0
      do 2 j=1,nloci
      if (loctyp(j).eq.1) then
        i=i+1
        if (i.lt.nlp) then
          write(strm,'(2x,i3,1x,2a)')   i,loc(j),','
        else
          write(strm,'(2x,i3,1x,a,3(/a))') i,loc(j),';','matrix','Pop1:'
        end if
      end if
    2 continue

      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

        if (actset.le.0) goto 10

        eop=eow(pedigree)
        fin=num
        if (typ.eq.1) fin=nfound
        do 15 i=1,fin
          lin=' '
          n=n+1
          write(loc1,'(1x,i8)') n
          lin(1:9)=loc1
          pos=10
          do 25 j=1,nloci
          if (loctyp(j).eq.1) then
            if (locus(i,locpos(j)).le.KNOWN) then
              write(loc1,'(1x,a8)') '   x/x  '
            else
              write(loc1,'(2x,i3.3,a1,i3.3)') 
     &          int(locus(i,locpos(j))),'/',int(locus(i,locpos(j)+1))
            end if
            lin(pos:pos+8)=loc1
            pos=pos+9
          end if
   25     continue
          lin(pos:pos+2)=' [ '
          pos=pos+3
          lin(pos:pos+eop-1)=pedigree
          pos=pos+eop
          write(loc1,'(1x,a8)') id(i)
          lin(pos:pos+8)=loc1
          lin(pos+9:pos+11)=' ] '
          write(strm,'(a)') lin(1:pos+11)
   15   continue
      goto 10
   20 continue
      write(strm,'(a/a)') ';','end;'
      return
      end
C end-of-wrgda 
C
C write out Mapmaker-Sibs phenotype file
C
      subroutine wrphe(wrk,strm,pedigree,actset,num,nfound,id,fa,mo,sex,
     &                 locus,nloci,loctyp,locpos,numloc)
      integer MAXSIZ,MAXLOC,MISS
      parameter (MAXSIZ=1000,MAXLOC=120,MISS=-9999)
      integer strm,wrk
C Pedigree structure
      character*10 pedigree
      character*8 id(MAXSIZ)
      integer actset,num,nfound,fa(MAXSIZ),mo(MAXSIZ),sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C Locus structure
      integer nloci,loctyp(MAXLOC),locpos(MAXLOC)
      integer eop,i,j,nlp
      logical last
      character*8 chid
C functions
      integer eow

      pedigree=' '
      last=.false.
      nlp=0
      do 1 j=1,nloci
        if(loctyp(j).eq.3) nlp=nlp+1
    1 continue
      write(strm,'(i3)') nlp

      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

        if (actset.le.0) goto 10

        eop=eow(pedigree)
        do 15 i=nfound+1,num
          call wrid('l',id(i),chid,0)
          write(strm,'(a,1x,a,$)') pedigree(1:eop),chid(1:eow(chid))
          do 25 j=1,nloci
          if (loctyp(j).eq.3) then
            if (locus(i,locpos(j)).eq.MISS) then
              write(strm,'(1x,a9,$)') '    -    '
            else
              write(strm,'(1x,f9.4,$)') locus(i,locpos(j))
            end if
          end if
   25     continue
          write(strm,*)
   15   continue
      goto 10
   20 continue
      return
      end
C end-of-wrphe 
C
C Describe pedigree using dot graphics language
C
      subroutine wrdot(wrk,strm,trait,pedigree,actset,num,nfound,
     &             id,fa,mo,sex,locus,nloci,loctyp,locpos,numloc,lin)
      integer LINSIZ,KNOWN,MAXSIZ,MAXLOC,MISS
      parameter (LINSIZ=1024,KNOWN=0,MAXSIZ=1000,MAXLOC=120,MISS=-9999)
      integer trait,strm,wrk
C Pedigree structure
      character*10 pedigree
      integer actset,num,nfound 
      character*8 id(MAXSIZ) 
      integer fa(MAXSIZ),mo(MAXSIZ),sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C Locus structure
      integer nloci,loctyp(MAXLOC),locpos(MAXLOC)
      character*(LINSIZ) lin
C local variables
      character*8 marriage, shape, shade
      integer currf, currm, i,nfam
      logical last
C functions
      integer eow
C
      last=.false.
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

        if (actset.le.0) goto 10

        write(strm,'(3a/a/a/a/3a/a/)') 
     2    'digraph Ped_', pedigree, ' {',
     3    '# page = "8.2677165,11.692913" ;', 'ratio = "auto" ;',
     4    'mincross = 2.0 ;', 'label = "Pedigree ', 
     5    pedigree(1:eow(pedigree)), '" ;','rotate = 90 ;'
        do 15 i=1,num
          if (sex(i).eq.1) then
            shape='circle'
          elseif (sex(i).eq.2) then
            shape='box'
          else
            shape='diamond'
          end if
          if (trait.ne.MISS .and. locus(i,trait).eq.2) then
            shade='grey'
          else
            shade='white'
          end if
          write(strm,'(7a)') '"',id(i)(1:eow(id(i))),'" [shape=',shape,
     &      ', regular=1,style=filled,fillcolor=',shade,'] ;'
   15   continue
        nfam=0
        currf=MISS   
        currm=MISS   
        do 25 i=nfound+1, num
          if (fa(i).ne.currf .or. mo(i).ne.currm) then
            nfam=nfam+1
            write(marriage,'(a4,i4.4)') 'marr',nfam
            currf=fa(i)
            currm=mo(i)
            write(strm,'(4a/5a/5a)') '"', marriage,'" [shape=diamond,',
     2        'style=filled,label="",height=.1,width=.1] ;',
     3        '"',id(currf)(1:eow(id(currf))),'" -> "', marriage,
     4        '" [dir=none,weight=1] ;',  
     5        '"',id(currm)(1:eow(id(currm))),'" -> "', marriage,
     6        '" [dir=none,weight=1] ;'
          end if
          write(strm,'(5a)') '"', marriage,'" -> "',id(i)(1:eow(id(i))),
     &     '" [dir=none, weight=2] ;'
   25   continue
        write(strm,'(a)')  '}'
      goto 10
   20 continue
      return
      end
C end-of-wrdot 
C
C Write out data for particular pedigree or particular person 
C
      subroutine showdata(wrk,fped,fid,larg,words,
     2              nloci,loc,loctyp,locpos, pedigree,
     3              actset,num,nfound,id,fa,mo,sex,locus, numloc)
      integer MAXLOC, MAXCOL, MAXSIZ, MISS
      parameter (MAXLOC=120, MAXCOL=MAXLOC+5, MAXSIZ=1000, MISS=-9999)

      integer fid,fped,larg,wrk
      character*20 words(MAXCOL)
C Pedigree structure
      character*10 pedigree
      integer actset,num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C Locus structure
      character*10 loc(MAXLOC)
      integer nloci,loctyp(MAXLOC),locpos(MAXLOC)
C
      integer i, j, nrec
      logical found, last

      nrec=0
      last=.false.
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

        if (actset.le.0) goto 10

        found=.false.
        do 50 j=fped, fid-2
        if (pedigree.eq.words(j)(1:10)) then
          found=.not.found
          goto 60
        end if
   50   continue
   60   continue
        if (found) then
          if (fid.gt.larg) then
            do 70 i=1, num
              call wrind(i,pedigree,id,fa,mo,sex,
     &                   locus,nloci,loc,loctyp,locpos)
   70       continue
            nrec=nrec+num
          else
            do 75 i=1, num
              do 80 j=fid, larg 
              if (id(i).eq.words(j)(1:8)) then
                call wrind(i,pedigree,id,fa,mo,sex,
     &                     locus,nloci,loc,loctyp,locpos)
                nrec=nrec+1
                goto 75
              end if
   80         continue
   75       continue
          end if
        end if
      goto 10
   20 continue
      write(*,'(/a,i6,a)') 'Printed ',nrec,' records.'
      return
      end
C end-of-showdata
C
C write out data for an individual
C
      subroutine wrind(idx,pedigree,id,fa,mo,sex,
     &                 locus,nloci,loc,loctyp,locpos)
      integer KNOWN,MAXSIZ,MAXLOC,MISS
      parameter (KNOWN=0,MAXSIZ=1000,MAXLOC=120,MISS=-9999)
      integer idx
C Pedigree structure
      character*10 pedigree
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ),mo(MAXSIZ),sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C Locus structure
      character*10 loc(MAXLOC)
      integer nloci,loctyp(MAXLOC),locpos(MAXLOC)
C local variables
      integer j, lpos
      character*1 ch
      character*7 gtp
      character*10 curloc, cval
C functions
      integer eow

      ch='x'
      if (sex(idx).eq.1) then
        ch='m'
      else if (sex(idx).eq.2) then
        ch='f'
      end if

      write(*,'(6a,1x,$)') 'id=', pedigree(1:eow(pedigree)),'-',
     &                    id(idx)(1:eow(id(idx))),' sex=',ch
      do 25 j=1,nloci
      if (loctyp(j).le.4) then
        lpos=locpos(j)
        curloc=loc(j)
        if (locus(idx,lpos).eq.MISS) then
          write(*,'(1x,2a,1x,$)') curloc(1:eow(curloc)), '=x'
        else if (loctyp(j).le.2) then
          if (locus(idx,lpos).le.KNOWN) then
            write(*,'(1x,2a,1x,$)') curloc(1:eow(curloc)), '=x'
          else
            call wrgtp(int(locus(idx,lpos)), 
     &                 int(locus(idx,lpos+1)),gtp,1)
            call juststr('l',gtp,7)
            write(*,'(1x,3a,1x,$)') 
     &         curloc(1:eow(curloc)), '=', gtp(1:eow(gtp))
          end if
        else if (loctyp(j).eq.4) then
          call wraff(locus(idx,lpos),ch)
          write(*,'(1x,3a,1x,$)') curloc(1:eow(curloc)), '=', ch
        else 
          call wrtrait(locus(idx,lpos),cval,3)
          call juststr('l',cval,10)
          write(*,'(1x,3a,1x,$)') 
     &        curloc(1:eow(curloc)), '=', cval(1:eow(cval))
        end if
      end if
   25 continue
      write(*,*)
      return
      end
C end-of-wrind 

C
C perform Haseman-Elston sib-pair regression: univariate
C using squared difference or centred cross-product 
C and ibds estimated from the entire sibship
C if missing parental genotypes 
C
      subroutine sibpair(wrk,wrk2,trait,locnam,gene,type,mche,iter,
     2              mincnt,weight,pedigree,num,nfound,id,fa,mo,sex,
     3              locus,numloc,numal,name,alfrq,cumfrq,ibd,
     4              untyped,set,plevel)
C
      integer KNOWN, MAXALL, MAXG, MAXSIZ, MAXLOC, MISS
      parameter(KNOWN=0, MAXALL=60, MAXG=MAXALL*(MAXALL+1)/2, 
     &          MAXSIZ=1000, MAXLOC=120, MISS=-9999)
      integer gene,iter,mincnt,plevel,trait,type,weight,wrk,wrk2
      logical mche
      character*10 locnam
C  Pedigree structure
      character*10 pedigree
      integer num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ)
      integer sex(MAXSIZ)
      integer numloc
      real locus(MAXSIZ,MAXLOC)
C allele frequencies structure
      integer numal, name(MAXALL)
      double precision alfrq(MAXALL)
      double precision cumfrq(MAXALL)
C sibship ibd array 
      double precision ibd(MAXG)
C work arrays for MC iteration
      integer set(MAXSIZ,2)
      logical untyped(MAXSIZ)
C local variables
      integer contrib,df,famdf,gen2,hsibs,i,it,j,k,ped,pos,sibs
      integer currf, currm, fin, nfam, nped, sta, tailp
      logical last, mhs, phs
      character*3 histo
C regression results
      integer afail, bfail, vfail
      double precision x(4),r(10),b(3),cov(10)
      double precision asyp,beta,mub,mux,muy,
     &                 oalpha,obeta,pval,sdb,sea,seb,tvalb,wt
C functions
      integer getnam
      double precision hibd, probst, regwt
C
      gen2=gene+1
C
C Obtain trait mean, sib and half-sib trait correlations
C
      df=0
      hsibs=0
      sibs=0
      muy=0.0d0
      last=.false.
      rewind(wrk)
    5 continue
        call wrkin(wrk,pedigree,num,nfound,id,fa,mo,sex,locus,numloc,
     &             last)
        if (last) goto 10
        do 3 i=1,num
        if (locus(i,trait).ne.MISS) then
          df=df+1
          muy=muy+dble(locus(i,trait))
        end if
    3   continue
      goto 5
   10 continue
      muy=muy/dfloat(df)
C
C Calculate centred cross-products for each pair
C
      df=0
      nfam=0
      nped=0
      sibs=0
      mux=0.0d0
      call inicov(4, 10, r)
      last=.false.
      rewind(wrk)
   50 continue
        call wrkin(wrk,pedigree,num,nfound,id,fa,mo,sex,locus,numloc,
     &             last)
        if (last) goto 200
C
C record if typed in untyped() and write file for MC routine
C
        nped=nped+1
        do 70 i=1,num
        if (locus(i,gene).gt.KNOWN) then
          untyped(i)=.false.
          set(i,1)=getnam(locus(i,gene),numal,name)
          set(i,2)=getnam(locus(i,gen2),numal,name)
        else  
          untyped(i)=.true.
          set(i,1)=MISS
          set(i,2)=MISS
        end if
   70   continue
        write(wrk2) num,nfound,(fa(i),mo(i),untyped(i),i=1,num)
C
C Full sibs
C
        famdf=0
        fin=num
        currf=fa(fin)
        currm=mo(fin)
        do 90 k=num-1,nfound,-1
          if (fa(k).ne.currf .or. mo(k).ne.currm) then
            nfam=nfam+1
            contrib=0
            do 92 i=k+1,fin
            if (locus(i,trait).ne.MISS .and. .not.untyped(i)) then
              contrib=contrib+1
            end if
   92       continue
C
C Skip if no usable individuals in this sibship
C
            if (contrib.gt.0) then

            df=df+contrib-1
            famdf=famdf+contrib-1
            write(wrk2) currf, currm, k+1, fin, contrib*(contrib-1)/2
            call nucibd(gene,currf,currm,k+1,fin,set,untyped,ibd,
     &                  numal, name, alfrq)
            pos=0
            do 95 i=k+1,fin-1
              do 97 j=i+1,fin
                pos=pos+1
                if (locus(i,trait).ne.MISS .and. 
     2              locus(j,trait).ne.MISS .and.
     3              .not.untyped(i) .and. .not.untyped(j)) 
     4          then
                  sibs=sibs+1
                  wt=regwt(weight,i,j,locus)
                  x(1)=1.0d0
                  x(2)=0.0d0
                  x(3)=ibd(pos)
                  if (type.eq.2) then
                    x(4)=(dble(locus(i,trait))-muy)*
     &                   (dble(locus(j,trait))-muy)
                  else
                    x(4)=dble(locus(i,trait)-locus(j,trait))**2
                  end if
                  mux=mux+x(3)
                  write(wrk2) pos,wt,x(4)
                  call givenc(r, 10, 4, x, wt, afail)
                end if
   97         continue
   95       continue
C
C half-sibs related to current sibship -- only scan sibships not yet visited
C stored in different style to full sibs
C
            do 300 i=nfound+1,k
              phs=(fa(i).eq.currf)
              mhs=(mo(i).eq.currm)
              if ((phs .or. mhs) .and. 
     &            locus(i,trait).ne.MISS .and. .not.untyped(i)) then
                write(wrk2) contrib 
                do 302 j=k+1,fin
                if (locus(j,trait).ne.MISS .and. .not.untyped(j)) then
                  hsibs=hsibs+1
                  wt=regwt(weight,i,j,locus)
                  x(1)=1.0d0
                  x(2)=1.0d0
                  if (type.eq.2) then
                    x(4)=(dble(locus(i,trait))-muy)*
     &                   (dble(locus(j,trait))-muy)
                  else
                    x(4)=dble(locus(i,trait)-locus(j,trait))**2
                  end if
                  if (phs) then
                    x(3)=hibd(float(set(i,1)),float(set(i,2)),
     2                        float(set(j,1)),float(set(j,2)),
     3                        float(set(mo(i),1)),float(set(mo(i),2)),
     4                        float(set(fa(i),1)),float(set(fa(i),2)),
     5                        float(set(mo(j),1)),float(set(mo(j),2)))
                    write(wrk2) i,j,mo(i),fa(i),mo(j),wt,x(4)
                  else
                    x(3)=hibd(float(set(i,1)),float(set(i,2)),
     2                        float(set(j,1)),float(set(j,2)),
     3                        float(set(fa(i),1)),float(set(fa(i),2)),
     4                        float(set(mo(i),1)),float(set(mo(i),2)),
     5                        float(set(fa(j),1)),float(set(fa(j),2)))
                    write(wrk2) i,j,fa(i),mo(i),fa(j),wt,x(4)
                  end if
                  call givenc(r, 10, 4, x, wt, afail)
                end if
  302           continue
              end if
  300       continue
C mark last halfsib pair
            write(wrk2) 0

            end if
C Now update to next sibship
            fin=k
            currf=fa(fin)
            currm=mo(fin)
          end if
   90   continue
C mark end of sibships in current pedigree
        write(wrk2) MISS, MISS, MISS, MISS, MISS
      goto 50
  200 continue

      if (df.gt.0) then
        mux=mux/dfloat(sibs)
        call alias(r, 10, 4, 1.0d-15, x, afail)
        call bsub(r, 10, 4, b, 3, bfail)
        call var(r, 10, cov, 10, 4, sibs, 1, vfail)
        oalpha=b(1)
        sea=sqrt(cov(1))
        obeta=b(3)
        seb=sqrt(cov(6))
        tvalb=obeta/seb
        if (afail.gt.0 .or. bfail.gt.0 .or. vfail.gt.0) then
          write(*,'(/a,3(/7x,a,i3))') 
     2      'ERROR: Problem in regression (AS164) subroutines.',
     3             'Aliasing Ifail=',afail,
     4             'Backsub  Ifail=',bfail,
     5             'Variance Ifail=',vfail 
        end if
        df=df-2
        if (type.eq.2) then
          asyp=1.0d0-probst(tvalb,df,afail)
        else
          asyp=probst(tvalb,df,afail)
        end if
      else
        mux=0.0d0
        oalpha=0.0d0
        sea=0.0d0
        obeta=0.0d0
        seb=0.0d0
        tvalb=0.0d0
        df=0
        asyp=1.0d0
      end if
C
C MC P-value estimation
C
      it=0
      tailp=0
      mub=0.0d0
      sdb=0.0d0
      if (.not.mche .or. iter.eq.0 .or. df.lt.1) then
        pval=1.0d0
      else
C
C Now can simulate genotypes and do sequential P-value simulation
C
  299   continue
        if (it.eq.iter .or. tailp.eq. mincnt) goto 400
          it=it+1
          call inicov(4, 10, r)
          rewind(wrk2)
          do 330 ped=1,nped
            read(wrk2) num,nfound,(fa(i),mo(i),untyped(i),i=1,num)
            call simped(num,nfound,fa,mo,cumfrq,set)
            do 335 i=1,num
            if (untyped(i)) then
              set(i,1)=MISS
              set(i,2)=MISS
            end if
  335       continue
C     
C read list of sibships -- last one is labelled as missing parents
C     
  500       continue
              read(wrk2) currf, currm, sta, fin, npairs
        
            if (currf.eq.MISS) goto 501
        
              call nucibd(gene,currf,currm,sta,fin,set,untyped,ibd,
     &                    numal, name, alfrq)
              do 310 k=1,npairs
                read(wrk2) pos,wt,x(4)
                x(1)=1.0d0
                x(2)=0.0d0
                x(3)=ibd(pos)
                call givenc(r, 10, 4, x, wt, afail)
  310         continue
C     
C list of half-sib pairs follows each sibship
C     
  503         continue
                read(wrk2) npairs
              if (npairs.le.0) goto 504
                do 311 k=1,npairs
                  read(wrk2) i,j,currf,commp,currm,wt,x(4)
                  x(1)=1.0d0
                  x(2)=1.0d0
                  x(3)=hibd(float(set(i,1)),float(set(i,2)),
     2                      float(set(j,1)),float(set(j,2)),
     3                      float(set(currf,1)),float(set(currf,2)),
     4                      float(set(commp,1)),float(set(commp,2)),
     5                      float(set(currm,1)),float(set(currm,2)))
                  call givenc(r, 10, 4, x, wt, afail)
  311           continue
              goto 503
  504         continue
                
            goto 500
  501       continue
        
  330     continue
          call alias(r, 10, 4, 1.0d-15, x, afail)
          call bsub(r, 10, 4, b, 3, bfail)
          beta=b(3)
          call moment(it,beta,mub,sdb)
          if ((type.eq.1 .and. beta.lt.obeta) .or. 
     2        (type.eq.2 .and. beta.gt.obeta) .or. 
     3        (beta.eq.obeta .and. random().gt.0.5d0)) 
     4    then
            tailp=tailp+1
          end if
          if (plevel.gt.1) then
            write(*,'(a,i4,a,f12.4,a,2i3)') 
     &        'Pseudosample ',it,': Beta=', beta, ' Ifail=',afail, bfail
          end if
        
          goto 299
  400   continue
        if (tailp.lt.mincnt) then
          tailp=tailp+1
          it=it+1
        end if
        sdb=sqrt(sdb/dfloat(max(1,it-1)))
        pval=dfloat(tailp)/dfloat(it)
      end if
      if (plevel.gt.0) then
        write(*,'(/a,i5,a,i5,a/a,i5/a,f5.3)') 
     2    'No. full-sib pairs = ',sibs, ' (in ',nfam,' sibships)',
     2    'No. half-sib pairs = ',hsibs,
     3    'Mean full-sib ibd  = ',mux
        write(*,'(a,f10.4,a,f10.4,a/a,f10.4,a,f10.4,a)')
     2    'Intercept (f-s)    = ',oalpha,' (ase=',sea,')',
     3    'Slope              = ',obeta, ' (ase=',seb,')'
        write(*,'(a,f10.4,a,i3,a,f6.4,a)')
     2    't value            = ',tvalb,' (df=',df,
     3    ', P=', asyp ,')' 
        write(*,'(/a,i4,a,i5,a,f6.4,a/a,f12.4,a,f12.4,a)')
     2    'Equalled or exceeded by =',tailp,'/',it,
     3    ' simulated values (',pval,')',
     4    'Mean (SD) simulated Beta=',mub,' (',sdb,')'
      else
        call phist(asyp,pval,histo)
        write(*,'(a10,2(1x,i6),1x,f10.1,2(1x,f6.4),1x,i6,2(1x,a))')
     &    locnam, sibs, hsibs, tvalb, asyp, pval, it, 'H-E',histo
      end if
      return
      end
C end-of-sibpair
C
C Routines to calculate ibd sharing using full sibship information
C where parent(s) untyped.
C
C ibd(1..nsib*(nsib-1)/2)
C prall(5) probs for 1..4 observed alleles plus all others
C
C 1. enumerate alleles segregating among children
C 2. generate short list of genotypes for parents
C 3. sum up ibd sharing for each pair of sibs for each genotype freq
C 
      subroutine nucibd(gene,cfa,cmo,sta,fin,set,untyped,ibd,
     &                  numal, name, alfrq)

      integer KNOWN,MAXALL,MAXG,MAXLOC,MAXSIZ,MISS
      parameter (KNOWN=0,MAXALL=60,MAXG=MAXALL*(MAXALL+1)/2,
     &           MAXLOC=120,MAXSIZ=1000,MISS=-9999)
      integer gene
C Pedigree structure
      integer cfa, cmo, fin, sta, set(MAXSIZ,2)  
      logical untyped(MAXSIZ)
C allele frequencies structure
      integer numal, name(MAXALL)
      double precision alfrq(MAXALL)
C
      double precision ibd(MAXG)
C
C count of segregating alleles, and frequency
      integer nall, allele(5)
      double precision prall(5)
C other local variables
      integer g1,g2,g3,g4
      integer gen2,i,j,npairs,mg1,mg2,pg1,pg2,pos
      integer i1,i2,t1,t2
      double precision lik
C functions
      integer parcon, whall
      double precision shibd

      gen2=gene+1
      pos=0

      ptyped=0
      if (.not.untyped(cfa)) then
        ptyped=ptyped+1
        pg1=set(cfa,1)
        pg2=set(cfa,2)
      end if
      if (.not.untyped(cmo)) then
        ptyped=ptyped+2
        mg1=set(cmo,1)
        mg2=set(cmo,2)
      end if

      if (ptyped.eq.3) then
        do 120 i=sta, fin-1
        do 120 j=i+1, fin
          pos=pos+1
          ibd(pos)=shibd(set(i,1),set(i,2),set(j,1),set(j,2),
     &                   pg1, pg2, mg1, mg2)
  120   continue
        return
      end if
C
C else sum over all possible parental genotypes
C
      nall=0
      if (ptyped.eq.1) then
        call addall(pg1,nall,allele)
        call addall(pg2,nall,allele)
      elseif (ptyped.eq.2) then
        call addall(mg1,nall,allele)
        call addall(mg2,nall,allele)
      end if
      do 1 i=sta, fin
      if (.not.untyped(i)) then
        call addall(set(i,1),nall,allele)
        call addall(set(i,2),nall,allele)
      end if
    1 continue

      npairs=(fin-sta+1)*(fin-sta)/2
C first check
      if (nall.gt.4) then
        write(*,'(a)') 'ERROR:  Mendelian inconsistency detected.'
        do 3 pos=1,npairs
          ibd(pos)=0.5d0
    3   continue
        return
      end if
C else continue
      do 4 pos=1,npairs
        ibd(pos)=0.0d0
    4 continue
      nall=nall+1
      allele(nall)=0 
      prall(nall)=1.0d0
      do 2 i=1,nall-1
        prall(i)=alfrq(allele(i))
        prall(nall)=prall(nall)-prall(i)
    2 continue
C
C While loop to list all possible genotypes
C initialize genotype indices
C
      if (ptyped.eq.1) then
        t1=1
        i1=1
        g1=whall(pg1,nall,allele)
        g2=whall(pg2,nall,allele)
      else
        t1=nall*(nall+1)/2
        i1=0
        g1=1
        g2=0
      end if
      if (ptyped.eq.2) then
        t2=1
        i2=1
        g3=whall(mg1,nall,allele)
        g4=whall(mg2,nall,allele)
      else
        t2=nall*(nall+1)/2
        i2=t2
        g3=1
        g4=0
      end if
C
C simulated nested do-loops
C check if inner loop completed once
C
      totp=0.0d0

  100 continue
        if (i2.eq.t2) then
          call couple(i1,t1,nall,g1,g2)
          pg1=allele(g1)
          pg2=allele(g2)
          if (t2.gt.1) i2=0
        end if
        call couple(i2,t2,nall,g3,g4)
        mg1=allele(g3)
        mg2=allele(g4)
        do 10 i=sta,fin
        if (.not.untyped(i) .and. 
     &      parcon(set(i,1),set(i,2),pg1,pg2,mg1,mg2).eq.0) then
          goto 55
        end if
   10   continue
C
C else (if consistent) calculate likelihood
C
C L = Pr(G) = Pr(Children & Parents) = Pr(P) Pr(C|P) 
C   = Prod{ Pr(P_j) } Prod { Pr(C_i | Father_i Mother_i }
C
        lik=prall(g1)*prall(g2)*prall(g3)*prall(g4)
        if (g1.ne.g2) lik=lik+lik
        if (g3.ne.g4) lik=lik+lik
        do 15 i=sta,fin
        if (.not.untyped(i)) then
          lik=lik*0.25d0*
     &        dfloat(parcon(set(i,1),set(i,2),pg1,pg2,mg1,mg2))
        end if
   15   continue

        totp=totp+lik
C
        pos=0
        do 20 i=sta, fin-1
        do 20 j=i+1, fin
          pos=pos+1
          ibd(pos)=ibd(pos)+
     2             lik*shibd(set(i,1),set(i,2),set(j,1),set(j,2),
     3                       pg1,pg2,mg1,mg2)
   20   continue
   55   continue
C end of while loop
      if (i1.ne.t1 .or. i2.ne.t2) goto 100
C abort if error else rescale likelihood
      if (totp.eq.0.0d0) then
        write(*,'(a)') 'ERROR:  Mendelian inconsistency detected.'
        do 32 pos=1,npairs
          ibd(pos)=0.5d0
   32   continue
      else
        totp=1.0d0/totp
        do 33 pos=1,npairs
          ibd(pos)=min(1.0d0,totp*ibd(pos))
   33   continue
      end if
      return
      end
C end-of-nucibd
C
C Enumerate all combinations of i ~ I(1..range) with itself
C If index=tot then return last tuple
C
      subroutine couple(idx,tot,range,i1,i2)
      integer idx,i1,i2,range,tot

      if (idx.eq.tot) return

      idx=idx+1
      i2=i2+1
      if (i2.gt.range) then
        i1=i1+1
        if (i1.gt.range) i1=1
        i2=i1
      end if
      return
      end
C end-of-couple
C
C Find index of allele segregating in nuclear family
C
      integer function whall(iall,nall,allele)
      integer iall, nall, allele(5)
      integer i
      do 10 i=1,nall-1
      if (iall.eq.allele(i)) then
        whall=i
        return
      end if
   10 continue
      whall=nall
      return
      end
C end-of-whall
C
C Calculate ibd sharing for full sibs when parental genotypes known
C
      double precision function shibd(c11,c12,c21,c22,p11,p12,p21,p22)
      integer KNOWN, MISS
      parameter(KNOWN=0, MISS=-9999)
      integer c11,c12,c21,c22,p11,p12,p21,p22

      logical h1, h2
      integer nallele, nmiss, cnallele
      integer shared
C 
C overall expectation 
      shibd=0.5d0
C
C deal with simplest cases
      call countall(c11,c12,c21,c22,cnallele,nmiss)
      if (cnallele.eq.4 .or.(c11.ne.c21 .and. c11.ne.c22 .and.
     &    c12.ne.c21 .and. c12.ne.c22)) then
        shibd=0.0d0
        return
      end if
      call countall(p11,p12,p21,p22,nallele,nmiss)
C
      h1=.false.
      h2=.false.
      if (p11.ne.p12) h1=.true.
      if (p21.ne.p22) h2=.true.
      shared=MISS
      if (nallele.eq.3 .and. h1 .and. h2) then
        shared=p11
        if (p11.ne.p21 .and. p11.ne.p22) shared=p12
      end if
      if (nallele.eq.4 .or. (nallele.eq.3 .and. h1.and.h2)) then
        if (c11.eq.c21 .and. c12.eq.c22 ) then
          shibd=1.0d0
        elseif (c11.ne.c12 .and. c21.ne.c22 .and.
     3      (((c11.eq.c21.or.c11.eq.c22) .and. c11.eq.shared ) .or.
     4      ((c12.eq.c21.or.c12.eq.c22) .and. c12.eq.shared ))) 
     5  then
          shibd=0.0d0
        end if
      elseif (nallele.eq.3) then
        shibd=0.25d0
        if (c11.eq.c21 .and. c12.eq.c22 ) shibd=0.75d0
      else
        if (h1 .and. h2) then
          if (c11.eq.c21 .and. c12.eq.c22) then
            shibd=1.0d0
            if (c11.ne.c22) shibd=0.5d0
          end if
        elseif (h1 .or. h2) then  
          shibd=0.25d0
          if (c11.eq.c21 .and. c12.eq.c22) shibd=0.75d0
        end if
      end if
      return
      end
C end-of-shibd
C
C Calculate regression weight
C
      double precision function regwt(weight,i,j,locus)
      integer MAXSIZ, MAXLOC, MISS
      parameter(MAXSIZ=1000, MAXLOC=120, MISS=-9999)
      integer i,j,weight
      real locus(MAXSIZ,MAXLOC)
      if (weight.ne.MISS .and. 
     2    locus(i,weight).ne.MISS .and.
     3    locus(j,weight).ne.MISS) then
        regwt=0.5d0*dble(locus(i,weight)+locus(j,weight))
      else
        regwt=1.0d0
      end if
      return
      end
C end-of-regwt
C
C Calculate ibd sharing for full sibs 
C
      double precision function fibd(c11,c12,c21,c22,p11,p12,p21,p22, 
     &                               numal,name,alfrq)
      integer KNOWN, MAXALL, MISS
      parameter(KNOWN=0, MAXALL=60, MISS=-9999)
      integer nallele, nmiss, cnallele, cnmiss
      real c11,c12,c21,c22,p11,p12,p21,p22
      logical h1, h2
C allele frequencies structure
      integer numal, name(MAXALL)
      double precision alfrq(MAXALL)
      integer ic11,ic12,ic21,ic22,ip11,ip12,ip21,ip22,t1,t2
      integer shared, unshared
      double precision pr1, pr2
C functions
      double precision getfreq
C 
C overall expectation 
      fibd=0.5d0
      ic11=MISS
      ic12=MISS
      ic21=MISS
      ic22=MISS
      if (c11.gt.KNOWN) ic11=int(c11)
      if (c12.gt.KNOWN) ic12=int(c12)
      if (c21.gt.KNOWN) ic21=int(c21)
      if (c22.gt.KNOWN) ic22=int(c22)
C
C deal with simplest cases
      call countall(ic11,ic12,ic21,ic22,cnallele,cnmiss)
      if (cnmiss.gt.0) then 
        return
      elseif (cnallele.eq.4 .or.(ic11.ne.ic21 .and. ic11.ne.ic22 .and.
     &        ic12.ne.ic21 .and. ic12.ne.ic22)) then
        fibd=0.0d0
        return
      end if
      ip11=MISS
      ip12=MISS
      ip21=MISS
      ip22=MISS
      if (p11.gt.KNOWN) ip11=int(p11)
      if (p12.gt.KNOWN) ip12=int(p12)
      if (p21.gt.KNOWN) ip21=int(p21)
      if (p22.gt.KNOWN) ip22=int(p22)
      call countall(ip11,ip12,ip21,ip22,nallele,nmiss)
      if (nallele.eq.1.and.nmiss.eq.0) return
C
C deal with all missing parental genotypes
      if (nmiss.eq.4) then
        if (cnallele.eq.1) then
          fibd=1.0d0/(1.0d0+getfreq(ic11,numal,name,alfrq))
        elseif (cnallele.eq.2) then
          if (ic11.eq.ic12) then
            fibd=1.0d0/2.0d0/(1.0d0+getfreq(ic11,numal,name,alfrq))
          elseif (ic21.eq.ic22) then
            fibd=1.0d0/2.0d0/(1.0d0+getfreq(ic21,numal,name,alfrq))
          else
            pr1=getfreq(ic11,numal,name,alfrq)
            pr2=getfreq(ic12,numal,name,alfrq)
            fibd=(2.0d0+pr1+pr2)/2.0d0/(1.0d0+pr1+pr2+2.0d0*pr1*pr2)
          end if
        elseif (cnallele.eq.3) then
          if (ic11.eq.ic21.or.ic11.eq.ic22) then
            fibd=1.0d0/2.0d0/(1.0d0+
     &           2.0d0*getfreq(ic11,numal,name,alfrq))
          else
            fibd=1.0d0/2.0d0/(1.0d0+
     &           2.0d0*getfreq(ic21,numal,name,alfrq))
          end if
        end if
C     write(*,'(a,i1,a,f5.3)') 'nallele=',nallele,' ibd=',fibd
C     write(*,'(a)') 'Child-1   Child-2   Parent-1  Parent-2'
C     write(*,'(8i5)') ic11,ic12,ic21,ic22,ip11,ip12,ip21,ip22
        return
      end if
C
C else do case where only one parent has been typed
C
      if ((ip11.eq.MISS.and.ip12.eq.MISS) .or. 
     &    (ip21.eq.MISS.and.ip22.eq.MISS)) then
        if (ip11.eq.MISS) then
          t1=ip21
          t2=ip22
        else
          t1=ip11
          t2=ip12
        end if
C       write(*,*) 't1,t2=',t1,t2,' cnallele=',cnallele
C       write(*,*) 'freq=',getfreq(ic11,numal,name,alfrq)
        h1=.false.
        if (t1.ne.t2) h1=.true.
        if (cnallele.eq.1) then
          pr1=getfreq(ic11,numal,name,alfrq)
          if (t1.eq.ic11.and..not.h1) then
C --------- fibd=(3.0d0-getfreq(ic11,numal,name,alfrq))/4.0d0
            fibd=(3.0d0+pr1)/(4.0d0+4.0d0*pr1)
          else
            fibd=(2.0d0*pr1+1.0d0)/(3.0d0*pr1+1.0d0)
          end if
        elseif (cnallele.eq.2) then
          if (ic11.eq.ic12) then
C first child is homozygote and second is heterozygote
            unshared=ic21
            if (ic21.eq.ic11) unshared=ic22
            if (.not.h1) then
               fibd=0.25d0
            elseif (t1.eq.unshared .or. t2.eq.unshared) then
               pr1=getfreq(ic11,numal,name,alfrq)
               pr2=getfreq(unshared,numal,name,alfrq)
               fibd=0.5d0*(1.0d0+pr2)/(1+pr1+pr2)
C ------------ fibd=1.0d0/2.0d0/(1.0d0+getfreq(ic11,numal,name,alfrq))
            else
               fibd=1.0d0
            end if
          elseif (ic21.eq.ic22) then
C second child is homozygote and first is heterozygote
            unshared=ic11
            if (ic11.eq.ic21) unshared=ic12
            if (.not.h1) then
               fibd=0.25d0
            elseif (t1.eq.unshared .or. t2.eq.unshared) then
               pr1=getfreq(ic21,numal,name,alfrq)
               pr2=getfreq(unshared,numal,name,alfrq)
               fibd=0.5d0*(1.0d0+pr2)/(1+pr1+pr2)
C ------------ fibd=1.0d0/2.0d0/(1.0d0+getfreq(ic21,numal,name,alfrq))
            else
               fibd=1.0d0
            end if
          else
C 12-12 sibpair
            if (.not.h1) then
              if (t1.eq.ic11) then
                pr1=getfreq(ic12,numal,name,alfrq)
              else
                pr1=getfreq(ic11,numal,name,alfrq)
              end if
              fibd=(3.0d0+pr1)/4.0d0/(1.0d0+pr1)
            elseif (t1.eq.ic11 .and. t2.eq.ic12) then
              pr1=getfreq(ic11,numal,name,alfrq)
              pr2=getfreq(ic12,numal,name,alfrq)
              fibd=0.5d0*(pr1*(2.0d0+pr1)+pr2*(2.0d0+pr2))/(pr1+pr2)/
     &             (1.0d0+pr1+pr2)
C             fibd=((pr1-pr2)**2+2.0d0*(pr1+pr2))/
C    &             2.0d0/(pr1**2+pr1+pr2+pr2**2)
            else
              if (t1.eq.ic11) then
                pr1=getfreq(ic12,numal,name,alfrq)
              else
                pr1=getfreq(ic11,numal,name,alfrq)
              end if
              fibd=(2.0d0+pr1)/2.0d0/(1.0d0+pr1)
            end if
          end if
        elseif (cnallele.eq.3) then
          shared=ic11
          if (ic12.eq.ic21 .or. ic12.eq.ic22) shared=ic12
          if ((t1.eq.ic11.and.t2.eq.ic12) .or.
     &        (t1.eq.ic21.and.t2.eq.ic22)) then
            pr1=getfreq(t1,numal,name,alfrq)
            pr2=getfreq(t2,numal,name,alfrq)
            if (t2.eq.shared) then
              fibd=0.5d0*pr1/(pr1+pr2)
            else
              fibd=0.5d0*pr2/(pr1+pr2)
            end if
          else
            pr1=getfreq(shared,numal,name,alfrq)
            fibd=0.25d0*(2.0d0-pr1)
          end if
        end if
C ---------------------------- Diagnostic Print
C     write(*,'(a,i1,a,f5.3)') 'nallele=',nallele,' ibd=',fibd
C     write(*,'(a)') 'Child-1   Child-2   Parent-1  Parent-2'
C     write(*,'(8i5)') ic11,ic12,ic21,ic22,ip11,ip12,ip21,ip22
C ------------------------ End Diagnostic Print
        return
      end if
C
C proceed to case where all parental genotypes known
      h1=.false.
      h2=.false.
      if (ip11.ne.ip12) h1=.true.
      if (ip21.ne.ip22) h2=.true.
      shared=MISS
      if (nallele.eq.3 .and.h1.and.h2) then
        shared=ip11
        if (ip11.ne.ip21.and.ip11.ne.ip22) shared=ip12
      end if
      if (nallele.eq.4 .or. (nallele.eq.3 .and. h1.and.h2)) then
        if (ic11.eq.ic21 .and. ic12.eq.ic22 ) then
          fibd=1.0d0
        elseif (ic11.ne.ic12 .and. ic21.ne.ic22 .and.
     3      (((ic11.eq.ic21.or.ic11.eq.ic22) .and. ic11.eq.shared ) .or.
     4      ((ic12.eq.ic21.or.ic12.eq.ic22) .and. ic12.eq.shared ))) 
     5  then
          fibd=0.0d0
        end if
      elseif (nallele.eq.3) then
        fibd=0.25d0
        if (ic11.eq.ic21 .and. ic12.eq.ic22 ) fibd=0.75d0
      else
        if (h1 .and. h2) then
          if (ic11.eq.ic21 .and. ic12.eq.ic22) then
            fibd=1.0d0
            if (ic11.ne.ic22) fibd=0.5d0
          end if
        elseif (h1 .or. h2) then  
          fibd=0.25d0
          if (ic11.eq.ic21 .and. ic12.eq.ic22) fibd=0.75d0
        end if
      end if
C------------------------------- Diagnostic Print
C     write(*,'(a,i1,a,f5.3)') 'nallele=',nallele,' ibd=',fibd
C     write(*,'(a)') 'Child-1   Child-2   Parent-1  Parent-2'
C     write(*,'(8i5)') ic11,ic12,ic21,ic22,ip11,ip12,ip21,ip22
C--------------------------- End Diagnostic Print
      return
      end
C end-of-fibd
C
C estimate ibd score for a pair of half-sibs -- parents known
C tabulations of number of genes expected shared ibd
C
      double precision function hibd(c11,c12,c21,c22,
     &                               p11,p12,pc1,pc2,p21,p22)
      integer KNOWN, MISS
      parameter(KNOWN=0, MISS=-9999)
      real c11,c12,c21,c22,p11,p12,pc1,pc2,p21,p22
      integer ic11,ic12,ic21,ic22,ip11,ip12,ipc1,ipc2,ip21,ip22
      integer tr1, tr2, nt1, nt2, cnallele, cnmiss
      logical  c1, c2

      hibd=0.25d0
C if homozygote common parent, no linkage information
      if (pc1.gt.KNOWN .and. pc1.eq.pc2) return

      ic11=int(c11)
      ic12=int(c12)
      ic21=int(c21)
      ic22=int(c22)
C
C deal with simplest cases
      call countall(ic11,ic12,ic21,ic22,cnallele,cnmiss)
      if (cnallele.eq.4 .or. (ic11.ne.ic21 .and. ic11.ne.ic22 .and.
     &    ic12.ne.ic21 .and. ic12.ne.ic22)) then
        hibd=0.0d0
        return
      end if
      ip11=MISS
      ip12=MISS
      ip21=MISS
      ip22=MISS
      if (p11.gt.KNOWN) ip11=int(p11)
      if (p12.gt.KNOWN) ip12=int(p12)
      if (p21.gt.KNOWN) ip21=int(p21)
      if (p22.gt.KNOWN) ip22=int(p22)
C
C missing common parent -- tr1 and tr2 are inferred transmitted alleles
C from the common parent to child 1 and 2; have already done
C sibpairs where unique genotypes
C
      if (pc1.le.KNOWN) then
        if (ic11.ne.ip11 .or. ic12.ne.ip12) then
          tr1=ic11
          if (ic11.eq.ip11 .or. ic11.eq.ip12) tr1=ic12
          if (ic21.ne.ip21 .or. ic22.ne.ip22) then
            tr2=ic21
            if (ic21.eq.ip21 .or. ic21.eq.ip22) tr2=ic22
            if (tr1.ne.tr2) hibd=0.0d0
          end if
        end if
        return
      else
        ipc1=int(pc1)
        ipc2=int(pc2)
      end if

      c1=(ipc1.eq.ip11 .and. ipc2.eq.ip12)
      c2=(ipc1.eq.ip21 .and. ipc2.eq.ip22)

      if (c1.and.c2) then
C
C 12 x 12 x 12 matings
        if (ic11.eq.ic12 .and. ic21.eq.ic22) then
          if (ic11.eq.ic21) then
            hibd=0.5d0
          elseif (ic11.ne.ic21) then
            hibd=0.0d0
          end if
        end if
      elseif ((c1.and..not.c2) .and. (ic11.eq.ic12)) then
C
C child1 not same genotype as 12 x 12 parents else hibd=0.25
C nt1 is the common parent's allele not transmitted to child1
        hibd=0.0d0
        nt1=ipc1
        if (ic11.eq.ipc1) nt1=ipc2
        if (ic21.ne.nt1 .and. ic22.ne.nt1) hibd=0.5d0
      elseif ((.not.c1.and.c2) .and.(ic21.eq.ic22)) then
C
C child2 not same genotype as 12 x 12 parents else hibd=0.25
C nt2 is the common parent's allele not transmitted to child2
        hibd=0.0d0
        nt2=ipc1
        if (ic21.eq.ipc1) nt2=ipc2
        if (ic11.ne.nt2 .and. ic12.ne.nt2) hibd=0.5d0
      elseif(.not.(c1.or.c2)) then
C
C !12 x 12 x !12 matings
        hibd=0.0d0
        nt1=ipc1
        if ((ic11.eq.ipc1 .and.(ic12.eq.ip11 .or.ic12.eq.ip12)) .or.
     2      (ic12.eq.ipc1 .and.(ic11.eq.ip11 .or. ic11.eq.ip12))) 
     3  then
          nt1=ipc2
        end if
        nt2=ipc1
        if ((ic21.eq.ipc1 .and.(ic22.eq.ip21 .or. ic22.eq.ip22)) .or.
     2      (ic22.eq.ipc1 .and.(ic21.eq.ip21 .or. ic21.eq.ip22))) 
     3  then
          nt2=int(pc2)
        end if
        if (nt1.eq.nt2) hibd=0.5d0
      end if
C
C     write(*,'(a,f5.3)') 'ibd=',hibd
C     write(*,*) 'Child-1   Child-2   Parent-1  Parent-12 Parent-2'
C     write(*,'(10fi.0)') ic11,ic12,ic21,ic22,ip11,ip12,ipc1,ipc2,ip21,ip22
      return
      end
C end-of-hibd
      

C
C Count alleles in entire sample -- codominant system
C Either unweighted or weighted by number of founders in pedigree
C
C If imputation has been done and fndr=2, then return the 
C count of alleles in the founders, both observed and imputed
C
      subroutine freq(wrk,gene,pedigree,actset,num,nfound,id,fa,mo,sex,
     &                locus, numloc,numal,name,fndr,alfrq,typed)
      integer KNOWN,MAXSIZ,MAXLOC,MAXALL,MISS
      parameter (KNOWN=0,MAXSIZ=1000,MAXLOC=120,MAXALL=60,MISS=-9999)
C Pedigree structure
      character*10 pedigree
      integer actset,num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      integer fndr, numloc, gene, wrk, typed
      real locus(MAXSIZ,MAXLOC)
      logical last
C
C allele frequencies structure
      integer tfound, numal, name(MAXALL)
      double precision alfrq(MAXALL)
C
      integer action, den, gen2, i
      double precision wei

      action=fndr
      gen2=gene+1

C global restart if unimputed genotypes present and fndr=2
C
  999 continue

      numal=0
      typed=0
      tfound=0

      last=.false.
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

       if (actset.le.0) goto 10
C
C Count observed alleles and skip if none
       den=0
       do 12 i=1,num
         if (locus(i,gene).gt.KNOWN) den=den+1
         if (locus(i,gen2).gt.KNOWN) den=den+1
   12  continue
       if (den.eq.0) goto 10
C
C If fndr=2 only count alleles in founders
C If fndr=1 weight count in this pedigree by number of founders
C
       tfound=tfound+nfound
       typed=typed+den
       wei=1.0d0
       if (action.eq.1) wei=dfloat(nfound)/dfloat(den)

       if (action.lt.2) then
         do 15 i=1,num
           if (locus(i,gene).gt.KNOWN) then
             call tab(int(locus(i,gene)),numal,name,alfrq,wei)
           end if
           if (locus(i,gen2).gt.KNOWN) then
             call tab(int(locus(i,gen2)),numal,name,alfrq,wei)
           end if
   15    continue
       else
         do 17 i=1,nfound
           if (locus(i,gene).ne.MISS) then
             call tab(int(abs(locus(i,gene))),numal,name,alfrq,wei)
           else
             action=0
             goto 999
           end if
           if (locus(i,gen2).ne.MISS) then
             call tab(int(abs(locus(i,gen2))),numal,name,alfrq,wei)
           else
             action=0
             goto 999
           end if
   17    continue
       end if
      goto 10
   20 continue

      if (action.gt.0) then
        wei=1.0d0/dfloat(action*tfound)
      else
        wei=1.0d0/dfloat(max(1,typed))
      end if
      do 30 i=1,numal
        alfrq(i)=wei*alfrq(i)
   30 continue
      return
      end
C end-of-freq
C
C update table of counts of alleles -- binary search and insertion sort
C
      subroutine tab(curr,numal,name,alfrq,wei)
      integer MAXALL
      parameter(MAXALL=60)
      integer curr, numal, name(MAXALL)
      double precision wei, alfrq(MAXALL)
      integer hi,i,lo,pos

      hi=numal
      lo=1

    1 continue 
      if (hi.lt.lo) goto 5
        pos=(hi+lo)/2
        if (curr.gt.name(pos)) then
          lo=pos+1
        elseif (curr.lt.name(pos)) then
          hi=pos-1
        else
          alfrq(pos)=alfrq(pos)+wei
          return
        end if
      goto 1
    5 continue
C else
      if (numal.lt.MAXALL) then
        do 2 i=numal,lo,-1
          name(i+1)=name(i)
          alfrq(i+1)=alfrq(i)
    2   continue
        numal=numal+1
        name(lo)=curr
        alfrq(lo)=wei
      else
        write(*,'(/a,i2,a/7x,a/)') 
     2    'ERROR: Number of alleles for locus exceeds ',MAXALL,
     3    ', the maximum allowed.','Stopping prematurely.'
        stop
      end if
      return
      end
C end-of-tab
C
C Write out frequencies
C
      subroutine wrfreq(strm,locus,numal,name,alfrq,mappos,
     &                  typed,nobs,fstyle)
      integer MAXALL
      parameter (MAXALL=60)
      character*10 locus
      integer fstyle, nobs, strm, typed
C allele frequencies structure
      integer numal, name(MAXALL)
      double precision alfrq(MAXALL)
C map position
      real mappos
C local variables
      integer i,j,nlines
      character*8 mentyp
      double precision corr,het,uninf

      if (fstyle.eq.1) then
        corr=1.0d0
        het=0.0d0
        uninf=0.0d0
        write(*,'(/a/a,a10,a/a/a)')
     2   '------------------------------------------------',
     3   'Allele frequencies for locus "',locus,'"',
     4   '------------------------------------------------',
     7   '   Allele  Frequency   Count  Histogram'
        if (numal.eq.0) then
          write(*,'(/6x,a)') 'No nonmissing genotypes'
        else
          do 25 i=1,numal
            write(*,'(4x,i4,5x,f6.4,4x,i5,2x,20a1:)') 
     2        name(i),alfrq(i),nint(float(typed)*alfrq(i)),
     3        ('*',j=1,max(1,nint(20.0d0*alfrq(i))))
            het=het+alfrq(i)*alfrq(i)
   25     continue
          do 27 i=1,numal-1
          do 27 j=i+1,numal
            uninf=uninf+2.0d0*alfrq(i)*alfrq(j)*alfrq(i)*alfrq(j)
   27     continue
          if (typed.gt.1) corr=dfloat(typed)/dfloat(typed-1)
          het=1.0d0-het
          write(*,'(/a,i4,2(/a,3x,f6.4)/a,i4,1x,a,f5.1,a)')
     2     'Number of alleles    = ',numal,
     3     'Heterozygosity (Hu)  = ',corr*het,
     4     'Poly. Inf. Content   = ',het-uninf,
     5     'Number persons typed = ',typed/2,
     6     '(',float(50*typed)/float(nobs),'%)'
        end if
C scratch file
      elseif (fstyle.eq.3) then
        write(strm) numal,(name(i),i=1,numal),(alfrq(i),i=1,numal)
C GAS locus file
      elseif (fstyle.eq.4) then
        call precis(numal,alfrq,4)
        write(strm,'(1x,i3,100(1x,f6.4):)') numal,(alfrq(i),i=1,numal)
        write(strm,'(1x,a,100(1x,i3):)') 'name ',(name(i),i=1,numal)
C SAGE locus file
      elseif (fstyle.eq.5) then
        call precis(numal,alfrq,4)
        write(strm,'(a10)') locus
        do 35 i=1,numal
   35     write(strm,'(1x,i4.4,a,f6.4)') name(i),' = ',alfrq(i)
        write(strm,'(1x,a1)') ';'
        do 40 i=1,numal
        do 40 j=i,numal
   40     write(strm,'(1x,4(i4.4,a))') 
     2       name(i),'/',name(j),' = {',name(i),'/',name(j),'}'
        write(strm,'(1x,a1)') ';'
C new style MENDEL locus file -- used by simwalk and relpair
      elseif (fstyle.eq.7 .or. fstyle.eq.10) then
        mentyp='AUTOSOME'
        if (fstyle.eq.10) mentyp='X-LINKED'
        call precis(numal,alfrq,6)
        write(strm,'(2a8,2i2,i4,1x,f8.3)') 
     &    locus,mentyp,numal, 0, 1, max(0.0,0.01*mappos)
        do 45 i=1,numal
          write(strm,'(5x,i3.3,f8.6)') name(i),alfrq(i)
   45   continue
C Linkage locus file
      elseif (fstyle.eq.8) then
        if (numal.eq.0) then
          write(strm,'(a,1x,a10/a)') 
     &      '3     2  #',locus, '    0.5    0.5'
        else
          call precis(numal,alfrq,4)
          write(strm,'(i1,1x,i5,1x,a1,1x,a10)') 3,numal,'#',locus
          write(strm,'(100(1x,f6.4):)') (alfrq(i),i=1,numal)
        end if
C PAP popln.dat file
      elseif (fstyle.eq.9) then
        nlines=(numal+4)/5
        write(strm,'(i4,a,a10)') nlines,' F F # ',locus
        write(strm,'(i3,5(d15.7))') numal,(alfrq(i),i=1,numal)
      end if
      return
      end
C end-of-wrfreq
C
C remove rounding errors in allele frequencies printed out to precision ndec
C from f3.1 to f9.7
C
      subroutine precis(numal,alfrq,ndec)
      integer MAXALL
      parameter (MAXALL=60)
      integer ndec
C allele frequencies structure
      integer numal
      double precision alfrq(MAXALL)
C topall is most common allele, and the one where we add our correction
      integer i, topall
      character*1 ch
      character*6 fdec
      character*10 buff
      double precision rounded, topfrq, tot

C set print format
      fdec='(f0.0)'
      write(ch,'(i1)') ndec+2
      fdec(3:3)=ch
      write(ch,'(i1)') ndec
      fdec(5:5)=ch
C rewrite to given precision, and calculate accumulated error
      topall=1
      topfrq=0.0d0
      tot=0.0d0
      do 10 i=1,numal
        write(buff,fdec) alfrq(i)
        read(buff,fdec) rounded
        alfrq(i)=rounded
        if (rounded.gt.topfrq) then
          topfrq=rounded
          topall=i
        end if
        tot=tot+rounded
   10 continue
      alfrq(topall)=alfrq(topall)+1.0d0-tot
      return
      end
C end-of-precis
C
C Identify the most common allele
      integer function topall(numal,name,alfrq)
      integer MAXALL
      parameter (MAXALL=60)
C allele frequencies structure
      integer numal, name(MAXALL)
      double precision alfrq(MAXALL)
      integer i
      double precision top
      top=0.0d0
      topall=0
      do 10 i=1,numal
      if (alfrq(i).gt.top) then
        top=alfrq(i)
        topall=name(i)
      end if
   10 continue
      return
      end
C end-of-topall
C
C Monte-Carlo test for HWE
C
      subroutine dohwe(wrk,wrk2,locnam,gene,iter,mincnt,hwefnd,
     2             pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     3             numloc,  numal, name, cumfrq, set, untyped, 
     4             ngcount,gcount,plevel)
      integer MAXALL, MAXG, MAXSIZ, MAXLOC, KNOWN
      parameter(MAXALL=60, MAXG=MAXALL*(MAXALL+1)/2, 
     &          MAXSIZ=1000, MAXLOC=120, KNOWN=0)
      integer gene,iter,mincnt,plevel,wrk,wrk2
      logical hwefnd
      character*10 locnam
C pedigree structure
      character*10 pedigree
      integer sex(MAXSIZ)
      integer actset,num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), set(MAXSIZ,2)
      real locus(MAXSIZ,MAXLOC)
      logical untyped(MAXSIZ)
C allele frequencies structure
      integer numal, name(MAXALL)
      double precision cumfrq(MAXALL)
C Genotype counts: allele1,allele2, genotype count, 
C                  ith allele count
      integer ngcount,gcount(MAXG,4)
C
      integer df, g1, g2, gen2, i, it, j, k, tailp, tot
      double precision asyp, chisq, expf, invden, ochisq, mchisq, 
     &  pval, vchisq
      character*3 histo
      character*7 gtp
      logical last
C functions 
      integer getnam
      real random
      double precision chip, ftdev, hwechi
C
      gen2=gene+1
      ngcount=0
      do 1 j=1,numal
      do 1 k=j,numal
        ngcount=ngcount+1
        gcount(ngcount,1)=j
        gcount(ngcount,2)=k
        gcount(ngcount,3)=0
        gcount(ngcount,4)=0
    1 continue
      it=0
      tot=0
      last=.false.
      rewind(wrk)
C
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

       if (actset.le.0) goto 10
C
         do 12 i=1,nfound
         if (locus(i,gene).lt.KNOWN) then
           untyped(i)=.true.
         else
           tot=tot+1
           untyped(i)=.false.
           g1=getnam(locus(i,gene),numal,name)
           g2=getnam(locus(i,gen2),numal,name)
           call tabgen(g1,g2,ngcount,gcount)
         end if
   12    continue
         if (.not.hwefnd) then
           do 13 i=nfound+1,num
           if (locus(i,gene).lt.KNOWN) then
             untyped(i)=.true.
           else
             tot=tot+1
             untyped(i)=.false.
             g1=getnam(locus(i,gene),numal,name)
             g2=getnam(locus(i,gen2),numal,name)
             call tabgen(g1,g2,ngcount,gcount)
           end if
   13      continue
           write(wrk2) num,nfound, (fa(i),mo(i),untyped(i),i=1,num)
        end if
      goto 10
   20 continue

      ochisq=hwechi(ngcount,gcount,tot)
      df=ngcount-numal

      if (plevel.gt.0) then
        write(*,'(/3a/a/a)') 
     2   '  -------- Observed Genotypes at "',locnam,'" --------',
     3   '       Genotype          Observed    Expected  Deviate',
     4   '  ----------------------------------------------------'
        invden=0.25d0/dfloat(tot)
        do 25 i=1,ngcount
          call wrgtp(name(gcount(i,1)),name(gcount(i,2)),gtp,1)
          expf=dfloat(gcount(gcount(i,1),4)*gcount(gcount(i,2),4)) *
     &         invden
          if (gcount(i,1).ne.gcount(i,2)) expf=expf+expf
          write(*,'(8x,a7,3x,i8,a,f5.3,a,f10.1,1x,f8.1)') 
     2      gtp, gcount(i,3), ' (',dfloat(gcount(i,3))/dfloat(tot),') ',
     3      expf, ftdev(dfloat(gcount(i,3)),expf)
   25   continue
        write(*,'(a/10x,a,3x,i8,a)') 
     2   '  ----------------------------------------------------',
     3   'Total', tot,' (1.000)'
        write(*,'(/a,i4/a,f6.1/a,i4/a,3x,f6.4)')
     2  '       Number of genotypes =',tot,
     3  '  Hardy-Weinberg LR chi-sq =',ochisq,
     4  'Nominal degrees of freedom =',df,
     5  '           Nominal P-value =',chip(ochisq,df)
      end if  
C
C MC sequential P-value for HWE
C
      if (.not.hwefnd .and. iter.gt.0 .and. ngcount.gt.1) then
        mchisq=0.0d0
        tailp=0
        vchisq=0.0d0
   49   continue
        if (it.eq.iter .or. tailp.eq.mincnt) goto 50
          it=it+1
          ngcount=0
          do 52 j=1,numal
          do 52 k=j,numal
            ngcount=ngcount+1
            gcount(ngcount,1)=j
            gcount(ngcount,2)=k
            gcount(ngcount,3)=0
            gcount(ngcount,4)=0
   52     continue
          rewind(wrk2)
   55     continue
            read(wrk2,end=70) num,nfound, 
     &                        (fa(i),mo(i),untyped(i),i=1,num)
            call simped(num,nfound,fa,mo,cumfrq,set)
            do 65 i=1,num
            if (.not.untyped(i)) then
              call tabgen(set(i,1),set(i,2),ngcount,gcount)
            endif
   65       continue
          goto 55
   70     continue
          chisq=hwechi(ngcount,gcount,tot)
          call moment(it,chisq,mchisq,vchisq)
          if (chisq.gt.ochisq .or. (chisq.eq.ochisq .and.
     2        random().gt.0.5))  then
            tailp=tailp+1
          end if
          if (plevel.gt.1) then
            write(*,'(a,i4,a,f6.1)') 
     &        'Pseudosample ',it,': Chisq=',chisq
              if (plevel.gt.2) then
                do 75 j=1,ngcount
	          write(*,*) ' ',gcount(j,1),gcount(j,2),gcount(j,3)
   75           continue
              end if
          end if
          goto 49
   50   continue
        if (tailp.lt.mincnt) then
          tailp=tailp+1
          it=it+1
        end if
        vchisq=vchisq/dfloat(max(1,it-1))
        pval=dfloat(tailp)/dfloat(it)
      else
        tailp=0
        pval=1.0d0
      end if
      if (plevel.gt.0) then
        write(*,'(a,i4,a,i5,a,f6.4,a/a,f6.1,a,f6.1,a)')
     2    '      Equalled or exceeded by =',tailp,'/',it,
     3    ' simulated values (',pval,')',
     4    ' Mean (Var) simulated chi-sqs =',mchisq,' (',vchisq,')'
      else
        asyp=chip(ochisq,df)
        call phist(asyp,pval,histo)
        write(*,'(a10,2(1x,i6),1x,f10.1,2(1x,f6.4),1x,i6,2(1x,a))') 
     2    locnam, tot, ngcount, ochisq, chip(ochisq,df), pval, it, 
     3     'HWE',histo
      end if
      return
      end
C end-of-dohwe
C
C Increment counts of genotypes and alleles for HWE test
C Storage of allele counts in gcount(,4) indexed from 1..nall
C by array index.  By contrast, genotypes indexed by gcount(,1..2).
C
      subroutine tabgen(a1,a2,ngcount,gcount)
      integer MAXALL,MAXG
      parameter(MAXALL=60,MAXG=MAXALL*(MAXALL+1)/2)
      integer a1,a2,ngcount,gcount(MAXG,4)
      integer i,j
C allele counts
      gcount(a1,4)=gcount(a1,4)+1
      gcount(a2,4)=gcount(a2,4)+1
C genotype count, insertion sort to index appropriately
      i=0
    5 continue
        i=i+1
      if (i.le.ngcount .and. (a1.gt.gcount(i,1).or.
     &    (a1.eq.gcount(i,1).and.a2.gt.gcount(i,2)))) goto 5
      if (i.le.ngcount .and. gcount(i,1).eq.a1 .and. gcount(i,2).eq.a2)
     & then
        gcount(i,3)=gcount(i,3)+1
      else
        do 20 j=ngcount,i,-1
        do 20 k=1,3
   20     gcount(j+1,k)=gcount(j,k)
        gcount(i,1)=a1
        gcount(i,2)=a2
        gcount(i,3)=1
        ngcount=ngcount+1
      end if
      return
      end
C end-of-tabgen
C
C Calculate Gibbs chi-square for HWE
C
      double precision function hwechi(ngcount,gcount,tot)
      integer MAXALL, MAXG
      double precision EPS
      parameter(EPS=1.0d-5, MAXALL=60, MAXG=MAXALL*(MAXALL+1)/2)
C allele frequencies and genotype counts
      integer gcount(MAXG,4), ngcount, tot
      integer i
      double precision c,e,o 

      c=0.25d0/dfloat(tot)
      hwechi=0.0d0
      do 30 i=1,ngcount
        o=dfloat(gcount(i,3))
        e=c*dfloat(gcount(gcount(i,1),4)*gcount(gcount(i,2),4))
        if (gcount(i,1).ne.gcount(i,2)) e=e+e
        if (e.gt.EPS .and. o.gt.EPS) then
          hwechi=hwechi+o*log(o/e)
        end if
   30 continue
      hwechi=hwechi+hwechi
      return
      end
C end-of-hwechi
C
C marker homozygosity in all subjects or just probands -- codominant system
C
      subroutine dohomoz(wrk,wrk2,trait,locnam,gene,iter,mincnt,gt,
     2             thresh,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     3             numloc,numal,alfrq,cumfrq,untyped,set,plevel)
      integer KNOWN,MAXSIZ,MAXLOC,MAXALL,MISS
      parameter (KNOWN=0,MAXSIZ=1000,MAXLOC=120,MAXALL=60,MISS=-9999)
      integer gene,iter,mincnt,numloc,plevel,trait,wrk,wrk2
      real thresh
      logical gt
      character*10 locnam
C Pedigree structure
      character*10 pedigree
      integer actset,num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), set(MAXSIZ,2)
      integer sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
      logical last, untyped(MAXSIZ)
C allele frequencies structure
      integer numal
      double precision alfrq(MAXALL), cumfrq(MAXALL)
C 
C homozygosity analysis -- limited to cases
      integer ehomoz, homoz, nca
      integer aff(MAXSIZ),gen2,i,it,tailp
      character*3 histo
      double precision den, ef, expp, fcoeff, obs, pval
C functions
      real isaff, random
      double precision binz

      expp=0.0d0
      gen2=gene+1
      homoz=0
      it=0
      nca=0
      do 5 i=1,numal
        expp=expp+alfrq(i)*alfrq(i)
    5 continue
      last=.false.
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

       if (actset.le.0) goto 10
C

        if (trait.eq.MISS) then
          do 13 i=1,num
            aff(i)=2
   13     continue
        else
          do 14 i=1,num
            aff(i)=int(isaff(locus(i,trait),thresh,gt))
   14     continue
        end if
        do 15 i=1,num
          untyped(i)=.false.
          set(i,1)=int(locus(i,gene))
          set(i,2)=int(locus(i,gen2))
          if (set(i,1).lt.KNOWN) then
            untyped(i)=.true.
          elseif (aff(i).eq.2) then
            nca=nca+1
            if (set(i,1).eq.set(i,2)) homoz=homoz+1 
          endif
   15   continue
        write(wrk2) num,nfound,
     &      (aff(i),fa(i),mo(i),untyped(i),i=1,num)
      goto 10
   20 continue
        
      if (nca.gt.0) then
        den=1.0d0/dfloat(nca)
        obs=den*dfloat(homoz)
        fcoeff=(obs-expp)/(1.0d0-expp)
      else
        obs=0.0d0
        fcoeff=0.0d0
      end if
C
C if iter=0 or nca=0, Monte-Carlo procedure superfluous
C
      if (iter.gt.0 .and. nca.gt.0) then
C
C Sequential Monte-Carlo P-value after Besag & Clifford Biometrika 1991
C P= tailp/it if tailp=mincnt or (tailp+1)/(it+1) if tailp<mincnt && it=iter
C
        tailp=0
   49   continue
        if (it.eq.iter .or. tailp.eq.mincnt) goto 50
          it=it+1
          ehomoz=0
          rewind(wrk2)
   55     continue
            read(wrk2,end=70) num,nfound,
     &        (aff(i),fa(i),mo(i),untyped(i),i=1,num)
            call simped(num,nfound,fa,mo,cumfrq,set)
            do 65 i=1,num
            if (.not.untyped(i) .and. aff(i).eq.2 .and.
     &          set(i,1).eq.set(i,2)) ehomoz=ehomoz+1 
   65       continue
          goto 55
   70     continue
          
          ef=abs((den*dfloat(ehomoz)-expp)/(1.0d0-expp))

          if (ef.gt.abs(fcoeff) .or. (ehomoz.eq.homoz .and.
     2        random().gt.0.5))  then
            tailp=tailp+1
          end if
          if (plevel.gt.1) then
            write(*,'(/a,i4,a,i5)') 
     &        'Pseudosample ',it,': No. homoz=',ehomoz
          end if
          goto 49
   50   continue
        if (tailp.lt.mincnt) then
          tailp=tailp+1
          it=it+1
        end if
        pval=dfloat(tailp)/dfloat(it)
      else
        pval=1.0d0
      end if
      call phist(pval,pval,histo)
      write(*,'(a10,1x,i4,3(1x,f6.4),1x,f6.1,1x,f6.4,1x,i6,2(1x,a))')
     2  locnam, nca, obs, expp, fcoeff, binz(homoz,nca,expp), 
     3   pval, it, 'HOM', histo
      return
      end
C end-of-dohomoz
C
C
C find allele frequency
C
      double precision function getfreq(all,numal,name,alfrq)
      integer MAXALL
      parameter (MAXALL=60)
      integer numal, name(MAXALL)
      double precision alfrq(MAXALL)
      integer all
      integer i, iall
      iall=abs(all)
      call match(iall,numal,name,i)
      if (i.ne.0) then
        getfreq=alfrq(i)
      else
        write(*,'(a/a,i3,a)') 
     &    'Error in routine getfreq','Looking for ',iall,' in:'
        do 99 i=1,numal
   99     write(*,*) name(i), alfrq(i)
        getfreq=0.0d0
      end if
      return
      end
C end-of-getfreq
C
C find index for allele
C
      integer function getnam(rall,numal,name)
      integer MAXALL,MISS
      parameter (MAXALL=60, MISS=-9999)
      integer numal, name(MAXALL)
      real rall
      integer i,iall

      getnam=MISS
      if (rall.eq.MISS) return

      iall=int(abs(rall))
      call match(iall,numal,name,i)
      if (i.ne.0) then
        getnam=i
      else
        write(*,'(a/a,i3,a)') 
     &    'Error in routine getnam', 'Looking for ',iall,' in:'
        do 99 i=1,numal
          write(*,*) name(i)
   99   continue
      end if
      return
      end
C end-of-getnam
C
C produce cumulative allele frequencies
C
      subroutine accum(numal,alfrq,cumfrq)
      integer MAXALL
      parameter (MAXALL=60)
      integer numal
      double precision alfrq(MAXALL), cumfrq(MAXALL)
      cumfrq(1)=alfrq(1)
      cumfrq(numal)=1.0d0
      do 10 i=2,numal-1
         cumfrq(i)=cumfrq(i-1)+alfrq(i)
   10 continue
      return
      end
C end-of-accum
C
C produce genotype frequencies for Metropolis algorithm
C
      subroutine genot(numal,alfrq,ngtp,gfrq)
      integer MAXALL, MAXG
      parameter(MAXALL=60, MAXG=MAXALL*(MAXALL+1)/2)
C allele frequencies structure
      integer numal, ngtp
      double precision alfrq(MAXALL), gfrq(MAXG)
C local variables
      integer i

      ngtp=0
      do 5 i=1,numal
      do 5 j=1,i
        ngtp=ngtp+1
        gfrq(ngtp)=alfrq(i)*alfrq(j)
    5 continue
      return
      end
C end-of-genot
C
C Do ibs sharing in parents as per Bishop 1990
C
      subroutine domar(wrk,gene,pedigree,actset,num,nfound, 
     2                 id,fa,mo,sex,locus,numloc,
     3                 numal,name,alfrq,plevel)
      integer KNOWN,MAXALL,MAXSIZ,MAXLOC,MISS
      parameter (KNOWN=0,MAXALL=60,MAXSIZ=1000,MAXLOC=120,MISS=-9999)
      integer gene,actset,num,numloc,plevel,wrk
C Pedigree structure
      character*10 pedigree
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ)
      integer sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C allele frequencies structure
      integer numal, name(MAXALL)
      double precision alfrq(MAXALL)
C calculate expected ibs statistics for marker
      double precision p, p2, p4, pp, pq, pq2, q, f(3)
C 2 df chi-square
      integer tab(3)
      double precision chisq, ef, expn, mu, obsn
C
      integer currf, currm, g1,g2,g3,g4,gen2,i,ibd,j,nmat
      double precision zibd
      logical last
C functions
      double precision chip

      mu=0.0d0
      do 1 i=1,3
        tab(i)=0
    1 continue
      gen2=gene+1

C Calculate expected values for ibs statistic
      p2=0.0d0
      p4=0.0d0
      pp=0.0d0
      pq2=0.0d0
      do 3 i=1,numal
        p=alfrq(i)
        q=1.0d0-p
        p=p*p
        q=q*q
        pq2=pq2+p*q
        p4=p4+p*p
        do 3 j=i+1,numal
          p=alfrq(i)
          q=alfrq(j)
          p2=p2+p*p*q*q
          pq=1.0d0-p-q
          pp=pp+p*q*pq*pq
    3 continue
      f(1)=pq2+pp+pp
      f(3)=4.0d0*p2+p4
      f(2)=1.0d0-f(3)-f(1)
      ef=f(3)+0.5d0*f(2)
C
      rewind(wrk)
      last=.false.
    5 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

        if (actset.le.0) goto 5
C 
         currf=MISS
         currm=MISS
         nmat=0
         do 13 i=nfound+1,num
           g1=int(locus(fa(i),gene))
           g3=int(locus(mo(i),gene))
           if ((fa(i).ne.currf .or. mo(i).ne.currm) .and.
     &         g1.gt.KNOWN .and. g3.gt.KNOWN) then
             nmat=nmat+1
             currf=fa(i)
             currm=mo(i)
             g2=int(locus(fa(i),gen2))
             g4=int(locus(mo(i),gen2))
             call share(g1,g2,g3,g4,zibd)
             ibd=int(2.0d0*zibd)+1
             tab(ibd)=tab(ibd)+1
           end if
   13    continue
      goto 5 
   20 continue
      nmat=tab(3)+tab(2)+tab(1)
      if (nmat.gt.0) mu=0.5d0*dfloat(2*tab(3)+tab(2))/dfloat(nmat)
      write(*,'(/a,i4/a,3x,f6.4,a,f6.4,a)')
     2   '   Number of typed matings =',nmat,
     3   ' Parental mean IBS sharing =',  mu, ' (Expected=',ef,')'
      if (nmat.gt.0) then
        chisq=0.0d0
        do 25 i=1,3
          expn=dfloat(nmat)*f(i)
          obsn=dfloat(tab(i))
          if (obsn.gt.0.001d0 .and. expn.gt.0.001d0) then
            chisq=chisq+obsn*log(obsn/expn) 
          end if
   25   continue
        chisq=chisq+chisq
        write(*,'(a,f6.1,a,f6.4,a)')
     &   ' Sharing Chi-square (2 df) =',chisq,' (P=',chip(chisq,2),')' 
      end if
      if (plevel.gt.0) then
        q=1.0d0/dfloat(max(nmat,1))
        write(*,'(2(/21x,a),2(/a,3f8.1))')
     2    'IBS Sharing','2/2     1/2     0/2', 'Observed sharing',
     3    q*dfloat(tab(3)),q*dfloat(tab(2)),q*dfloat(tab(1)),
     4    'Expected sharing', f(3),f(2),f(1) 
      end if
      return
      end
C end-of-domar
C
C Check if multilocus ibs sharing for pairs of sibs is consistent 
C with purported relationship.  Again as per Bishop et al 1990
C
      subroutine ckibs(wrk,wrk2,pedigree,actset,num,nfound,id,fa,mo,sex,
     &              locus, numloc,nloci,loctyp,locpos,numal,name,alfrq)
      integer MAXALL,MAXSIZ,MAXLOC,KNOWN
      parameter (MAXALL=60,MAXSIZ=1000,MAXLOC=120,KNOWN=0)

      integer wrk,wrk2
C Pedigree structure
      integer actset,num, nfound
      character*10 pedigree
      character*8 id(MAXSIZ) 
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
      integer numloc
C
C locus structure
      integer nloci
      integer loctyp(MAXLOC),locpos(MAXLOC)
C allele frequencies structure
      integer numal, name(MAXALL)
      double precision alfrq(MAXALL)
C expected ibs statistics for each marker
      double precision e2(MAXLOC,2)
      double precision p, p2, p4
C
      integer den,g1,g2,g3,g4,gene,gen2,i,j,k,npairs,sib
      double precision ex, mibs, mean, var, z
      logical last, samefa, samemo
C
      mean=0.0d0
      npairs=0
      var=0.0d0
      pedigree=' '
      last=.false.
      rewind(wrk)
      rewind(wrk2)
C Calculate expected values for ibs=2 statistic
      do 2 k=1,nloci
      if (loctyp(k).eq.1) then
        read(wrk2) numal,(name(i),i=1,numal),(alfrq(i),i=1,numal)
        p2=0.0d0
        p4=0.0d0
        do 3 i=1,numal
          p=alfrq(i)
          p=p*p
          p2=p2+p
          p4=p4+p*p
    3   continue
        e2(k,1)=0.25d0*(1.0d0+2.0d0*p2*(1.0d0+p2)-p4)
        e2(k,2)=0.5d0*(p2*(1.0d0+p2+p2)-p4)
      end if
    2 continue
C
      write(*,'(4(/a))')
     2  '------------------------------------------------------------',
     3  'Estimated Prob(IBS=2) over all markers for sib-pairs',
     4  '------------------------------------------------------------',
     5  'Pedigree    Pers-1   Pers-2    ibs=2     Exp     Dev   Mrkrs'
    5 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

        if (actset.le.0) goto 5
C
C only iterate nonfounders
        do 10 i=nfound+1,num-1
          do 15 j=i+1,num
            samefa=(fa(i).eq.fa(j))
            samemo=(mo(i).eq.mo(j))
C
C Share a parent
C
            if (samefa.or.samemo) then
              den=0
              ex=0.0d0
              mibs=0.0d0
              if (samefa .and. samemo) then
                sib=1
              else
                sib=2
              end if
              do 30 k=1,nloci
              if (loctyp(k).eq.1) then
                gene=locpos(k)
                g1=int(locus(i,gene))
                g3=int(locus(j,gene))
                if (g1.gt.KNOWN .and. g3.gt.KNOWN) then
                  den=den+1
                  gen2=gene+1
                  g2=int(locus(i,gen2))
                  g4=int(locus(j,gen2))
                  ex=ex+e2(k,sib)
                  if ((g1.eq.g3 .and. g2.eq.g4).or.
     &                (g1.eq.g4 .and. g2.eq.g3)) then
                    mibs=mibs+1.0d0
                  end if
                end if
              end if
   30         continue
              if (den.gt.0) then
                npairs=npairs+1
                z=sqrt(mibs)+sqrt(mibs+1)-sqrt(4*ex+1)
                mibs=mibs/dfloat(den)
                ex=ex/dfloat(den)
                call moment(npairs,mibs,mean,var)
                write(*,'(a,2(a8,1x),2(2x,f6.4),1x,f7.2,2x,i3)') 
     &             pedigree, id(i), id(j), mibs, ex, z, den
              end if
            end if
   15     continue
   10   continue
      goto 5 
   20 continue
      if (npairs.gt.1) var=var/(npairs-1)
      write(*,'(/a,f6.4,a,f6.4,a/)') 
     &  'Grand mean P(ibs=2)=',mean,' (SD=',dsqrt(var),')'
      return
      end
C end-of-ckibs
C
C Calculate observed and expected mean IBS for all pairs of relatives
C Expected distribution simulated using given map
C
      subroutine allibs(wrk,wrk2,iter,nloci,loc,loctyp,locpos,
     2             map,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     3             numloc, hset,ibscount,dev,numal,cumfrq,typ,plevel)
      integer IBDSIZ,KNOWN,MAXALL,MAXHAP,MAXIBD,MAXSIZ,MAXLOC,MISS
      parameter(KNOWN=0, MAXALL=60, MAXSIZ=1000, MAXLOC=120,
     2          MAXHAP=MAXLOC/2, MISS=-9999,
     3          MAXIBD=1000, IBDSIZ=MAXIBD*(MAXIBD+1)/2)
      integer iter,plevel,typ,wrk,wrk2
C
C Pedigree structure
      character*10 pedigree
      integer actset,num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
      integer numloc
C
C Locus structure 
      integer nloci
      character*10 loc(MAXLOC)
      integer loctyp(MAXLOC),locpos(MAXLOC)
C
C position of locus on sex-averaged linkage map
C
      real map(MAXLOC)
C
C allele and genotype frequencies within entire sample for given locus 
C
      integer numal
      double precision cumfrq(MAXALL)
C
C Storage space for haplotypes
      integer hset(MAXSIZ,MAXHAP,2)
C
C mean ibs sharing for all relative pairs
C
      double precision ibscount(IBDSIZ), dev(IBDSIZ)
C
C Marker list and intermarker distances
      integer nmark, mark(MAXHAP)  
      real recdist(MAXHAP)
C 
      integer gene, gen2, i, j, n, npairs, pos, score
      character*8 fid, mid
      real dist
      double precision crit, den, maxdev
      logical last 
C functions
      real invmap

      dist=0.0
      nmark=0
      do 1 j=1,nloci
      if (loctyp(j).eq.1) then
        nmark=nmark+1
        mark(nmark)=j
        if (map(j).ne.MISS .and. map(j).ge.dist) then
          recdist(nmark)=invmap(map(j)-dist,1)
          dist=map(j)
        else
          recdist(nmark)=0.50
          dist=-1000.0
        end if
        if (nmark.eq.MAXHAP) goto 2
      end if
    1 continue
    2 continue

      den=1.0d0/(dfloat(max(1,iter)))

      write(*,'(4(/a))')
     2  '------------------------------------------------------------',
     3  'IBS sharing outlier pairs contributed by each person',
     4  '------------------------------------------------------------',
     5  'Pedigree   Person   Father   Mother   Max Dev  Outlier Pairs'
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

        if (actset.le.0 .or. num.gt.MAXIBD) goto 10

        crit=0.95d0
        do 25 i=1,num
        do 25 j=1,nmark
          gene=locpos(mark(j))
          gen2=gene+1
          if (locus(i,gene).gt.KNOWN) then
            hset(i,j,1)=int(locus(i,gene))
            hset(i,j,2)=int(locus(i,gen2))
          else
            hset(i,j,1)=MISS
            hset(i,j,2)=MISS
          end if
   25   continue

        npairs=num*(num-1)/2
        do 90 i=1,npairs
          ibscount(i)=0.0d0
          dev(i)=0.0d0
   90   continue
        
        call allshare(num,ibscount,nmark,hset)
        
        do 100 it=1,iter
          if (plevel.gt.2) write(*,'(/a,i5)') pedigree,it
          call simhap(wrk2,nmark,mark,recdist,numal,cumfrq,
     &                num,nfound,fa,mo,hset,plevel) 
          call expshare(num,ibscount,dev,nmark,hset)
  100   continue
        
        do 105 pos=1,npairs
          dev(pos)=den*dev(pos)
  105   continue
        
        if (typ.eq.1) then
          do 110 i=1,num 
            n=0
            score=0
            maxdev=0.0d0
            pos=(i-2)*(i-1)/2
            do 115 j=1,i-1
              pos=pos+1
              if (ibscount(pos).ne.MISS) then
                n=n+1
                if (abs(dev(pos)).gt.abs(maxdev)) maxdev=dev(pos)
                if (abs(dev(pos)).ge.crit) score=score+1
              end if
  115       continue
            pos=1+(i-1)*i/2
            do 116 j=i+1,num 
              pos=pos+j-2
              if (ibscount(pos).ne.MISS) then
                n=n+1
                if (abs(dev(pos)).gt.abs(maxdev)) maxdev=dev(pos)
                if (abs(dev(pos)).ge.crit) score=score+1
              end if
  116       continue
            if (score.gt.0) then
              fid='x'
              mid='x'
              if (fa(i).ne.MISS) fid=id(fa(i))
              if (mo(i).ne.MISS) mid=id(mo(i))
              write(*,'(a,3(1x,a8),1x,f7.2,1x,i5,a1,i5,1x,5a:)') 
     2         pedigree,id(i),fid,mid,maxdev,score,'/',n,
     3         ('*',j=1,5*score/n)
          end if
  110     continue
        end if
        if (typ.eq.2 .or. plevel.gt.1) then
          if (plevel.gt.1) crit=0.0d0
          write(*,'(//a//a)')
     2      'Estimated Sum(IBS) over all markers for relative pairs',
     3      'Pedigree   Pers-1   Pers-2  Sum(IBS)     Dev'
          pos=0
          do 120 i=2,num 
          do 120 j=1,i-1
            pos=pos+1
            if (ibscount(pos).ne.MISS .and. abs(dev(pos)).ge.crit) then
              write(*,'(a,2(1x,a8),2(1x,f7.2))') 
     &         pedigree, id(i), id(j), ibscount(pos),dev(pos)
            end if
  120     continue
          write(*,*)
        end if

      goto 10
   20 continue
      return
      end
C end-of-allibs 
C
C Simulate haplotypes for all family members for given map
C
      subroutine simhap(wrk2,nmark,mark,recdist,numal,cumfrq,
     &                  num,nfound,fa,mo,hset,plevel) 
      integer KNOWN,MAXALL,MAXHAP,MAXSIZ,MAXLOC,MISS
      parameter(KNOWN=0,MAXALL=60, MAXSIZ=1000,MAXLOC=120,
     &          MAXHAP=MAXLOC/2,MISS=-9999)
      integer plevel, wrk2
C
C Pedigree structure
      integer num, nfound
      integer fa(MAXSIZ), mo(MAXSIZ)
C Marker list and intermarker distances
      integer nmark, mark(MAXHAP)  
      real recdist(MAXHAP)
C
C allele and genotype frequencies within entire sample for given locus 
C
      integer numal
      double precision cumfrq(MAXALL)
C
C Storage space for haplotypes
      integer hset(MAXSIZ,MAXHAP,2)

      integer i,ismiss,j
      logical fin, done(MAXSIZ)
C
C Initialize founders
C
      rewind(wrk2)
      do 30 j=1,nmark 
        read(wrk2) numal,(cumfrq(i),i=1,numal)
        do 31 i=1,nfound
          ismiss=sign(1,hset(i,j,1))
          call found(cumfrq,hset(i,j,1))
          hset(i,j,1)=ismiss*hset(i,j,1)
          call found(cumfrq,hset(i,j,2))
          hset(i,j,2)=ismiss*hset(i,j,2)
   31   continue
   30 continue
      do 32 i=1,nfound
        done(i)=.true.
   32 continue
      do 33 i=nfound+1,num
        done(i)=.false.
   33 continue
C
C then gene drop the nonfounders genotypes
C
   40 continue
        fin=.true.
        do 50 i=nfound+1,num
        if (.not.done(i)) then
          if (done(fa(i)) .and. done(mo(i))) then
            call genof6(i,fa(i),mo(i),nmark,hset,recdist)
            done(i)=.true.
          else
            fin=.false.
          end if
        end if
   50   continue
      if (.not.fin) go to 40

      if (plevel.gt.2) then
        do 100 i=1,num
          write(*,'(i4,100i3:)') i,(hset(i,j,1),j=1,nmark)
          write(*,'(4x,100i3:)')   (hset(i,j,2),j=1,nmark)
  100   continue
      end if
      return
      end
C end-of-simhap
C
C transmit haplotypes from each parent to child, including possibility
C of recombination within haplotype
C 
      subroutine genof6(idx,fa,mo,nmark,hset,recdist)
      integer MAXLOC, MAXSIZ, MAXHAP
      parameter(MAXLOC=120, MAXSIZ=1000, MAXHAP=60)
      integer idx,fa,mo,nmark,hset(MAXSIZ,MAXHAP,2)
      real recdist(MAXHAP)
C local variables
      integer fagranp,mogranp,ismiss,j
C functions
      integer irandom
      real random
C
      fagranp=irandom(1,2)
      mogranp=irandom(1,2)
      do 50 j=1,nmark
        ismiss=sign(1,hset(idx,j,1))
        if (recdist(j).gt.random()) fagranp=3-fagranp
        if (recdist(j).gt.random()) mogranp=3-mogranp
        hset(idx,j,1)=ismiss*abs(hset(fa,j,fagranp))
        hset(idx,j,2)=ismiss*abs(hset(mo,j,mogranp))
   50 continue
      return
      end
C end-of-genof6
C
C Calculate sum of ibs statistics for all markers
C
      subroutine allshare(num,ibscount,nmark,hset)
      integer IBDSIZ, KNOWN, MAXHAP, MAXIBD, MAXSIZ, MAXLOC, MISS
      parameter(KNOWN=0,MAXSIZ=1000,MAXLOC=120, MAXHAP=MAXLOC/2,
     &          MISS=-9999 , MAXIBD=1000, IBDSIZ=MAXIBD*(MAXIBD+1)/2)
      integer nmark, num
C Storage space for haplotypes
      integer hset(MAXSIZ,MAXHAP,2)
C mean ibs sharing for all relative pairs
      double precision ibscount(IBDSIZ)
C local variables
      integer i,j,k,n,pos
      double precision tibs, zibs

      pos=0
      do 10 i=2,num
      do 10 j=1,i-1
        pos=pos+1
        n=0
        tibs=0.0d0
        do 20 k=1,nmark
        if (hset(i,k,1).gt.KNOWN .and. hset(j,k,1).gt.KNOWN) then
          n=n+1
          call share(hset(i,k,1),hset(i,k,2),
     &               hset(j,k,1),hset(j,k,2),zibs)
          tibs=tibs+zibs+zibs
        end if
   20   continue
        if (n.gt.0) then
          ibscount(pos)=tibs
        else
          ibscount(pos)=MISS
        end if
   10 continue
      return
      end
C end-of-allshare
C
C Accumulate null-hypothesis simulated ibs statistics for all markers
C
      subroutine expshare(num,ibscount,dev,nmark,hset)
      integer IBDSIZ, KNOWN, MAXHAP, MAXIBD, MAXSIZ, MAXLOC, MISS
      parameter(KNOWN=0,MAXSIZ=1000,MAXLOC=120, MAXHAP=MAXLOC/2,
     &          MISS=-9999 , MAXIBD=1000, IBDSIZ=MAXIBD*(MAXIBD+1)/2)
      integer nmark, num
C Storage space for haplotypes
      integer hset(MAXSIZ,MAXHAP,2)
C comparison to null hypothesis ibs sharing for all relative pairs
      double precision ibscount(IBDSIZ), dev(IBDSIZ)
C local variables
      integer i,j,k,pos
      double precision tibs, zibs

      pos=0
      do 10 i=2,num
      do 10 j=1,i-1
        tibs=0.0d0
        pos=pos+1
        if (ibscount(pos).ne.MISS) then
          do 20 k=1,nmark
          if (hset(i,k,1).gt.KNOWN .and. hset(j,k,1).gt.KNOWN) then
            call share(hset(i,k,1),hset(i,k,2),
     &                 hset(j,k,1),hset(j,k,2),zibs)
            tibs=tibs+zibs+zibs
          end if
   20     continue
          if (tibs.gt.ibscount(pos) .or. 
     &        (tibs.eq.ibscount(pos) .and. random().gt.0.5)) then
            dev(pos)=dev(pos)+1.0d0
          else
            dev(pos)=dev(pos)-1.0d0
          end if
        end if
   10 continue
      return
      end
C end-of-expshare

C
C extract unrelated individuals with information for a criterion trait
C
      subroutine wricas(wrk,twrk,trait,pedigree,actset,
     &                  num,nfound,id,fa,mo,sex,locus,numloc)
      integer MAXSIZ,MAXLOC,MISS
      parameter (MAXSIZ=1000,MAXLOC=120,MISS=-9999)
      integer trait,wrk,twrk
C Pedigree structure
      character*10 pedigree
      integer actset,num,nfound 
      character*8 id(MAXSIZ) 
      integer fa(MAXSIZ),mo(MAXSIZ),sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)

      integer aff(MAXSIZ)

      logical last
      integer eop, i, nuse, tuse
      character*10 fam
C functions
      integer eow
      
      tuse=0
      last=.false.
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

        if (actset.le.0) then
          call wrkout(twrk,pedigree,actset,num,nfound,id,fa,mo,sex,
     &                locus,numloc)
          goto 10
        end if
       
        do 50 i=1, nfound
          if (locus(i,trait).ne.MISS) then
            aff(i)=2
          else
            aff(i)=1
          end if
   50   continue
        do 70 i=nfound+1, num
          if (aff(fa(i)).eq.1 .and. aff(mo(i)).eq.1) then 
            if (locus(i,trait).ne.MISS) then
              aff(i)=2
              aff(fa(i))=3
              aff(mo(i))=3
            else 
              aff(i)=1
            end if
          else 
            aff(i)=3
          end if
   70   continue

        nuse=0
        eop=eow(pedigree)
        do 100 i=1, num
        if (aff(i).eq.2) then
          nuse=nuse+1
          fam=pedigree
          call makeind(nuse,eop,fam)
          write(twrk) fam, actset, 1, 1  
          write(twrk) id(i),MISS,MISS,sex(i),(locus(i,j),j=1,numloc)
        end if
  100   continue
        tuse=tuse+nuse
      goto 10
   20 continue
      write(*,'(a,i6,a)') 'Extracted ',tuse,' cases.'
      return
      end
C end-of-getcas 
C
C convert into nuclear families, duplicating individuals as needed
C
      subroutine nuclear(wrk,twrk,pedigree,actset,num,nfound,
     &                   id,fa,mo,sex,locus,numloc,maxsibs,typ)
      integer MAXSIZ,MAXLOC
      parameter (MAXSIZ=1000,MAXLOC=120)
      integer maxsibs,wrk,twrk,typ
C Pedigree structure
      character*10 pedigree
      integer actset,num,nfound 
      character*8 id(MAXSIZ) 
      integer fa(MAXSIZ),mo(MAXSIZ),sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
      logical last

      integer currf, currm, eop, nuc, pos, sta

C functions
      integer eow

      maxsibs=maxsibs-1

      last=.false.
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

       if (nfound.eq.num .or. actset.le.0) then
         call wrkout(twrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &              numloc)
       else
         nuc=0
         eop=eow(pedigree)
         pos=nfound+1
         sta=pos
         currf=fa(sta)
         currm=mo(sta)
   50    continue
           if (fa(pos).ne.currf .or. mo(pos).ne.currm) 
     &     then
             nuc=nuc+1
             call onefam(twrk,pedigree,actset,num,nfound,
     2               id,fa,mo,sex,locus,numloc,maxsibs,
     3               eop, nuc, currf, currm, sta, pos-1, typ)
             sta=pos
             currf=fa(sta)
             currm=mo(sta)
           end if
           pos=pos+1
         if (pos.le.num) goto 50
C last sibship
         nuc=nuc+1
         call onefam(twrk,pedigree,actset,num,nfound,
     2           id,fa,mo,sex,locus,numloc,maxsibs,
     3           eop, nuc, currf, currm, sta, num, typ)
       end if
      goto 10
   20 continue
      return
      end
C end-of-nuclear
C
C write out current nuclear family -- with or without grandparents
C
      subroutine onefam(twrk,pedigree,actset,num,nfound,
     2                  id,fa,mo,sex,locus,numloc,maxsibs,
     3                  eop, nuc, currf, currm, sta, fin, typ)
      integer MAXSIZ,MAXLOC,MISS
      parameter (MAXSIZ=1000,MAXLOC=120,MISS=-9999)
      integer maxsibs, twrk, typ
      integer currf, currm, eop, fin, nuc, sta
C Pedigree structure
      character*10 pedigree
      integer actset,num,nfound 
      character*8 id(MAXSIZ) 
      integer fa(MAXSIZ),mo(MAXSIZ),sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)

      character*10 fam
      integer gp1, gp2, gp3, gp4, i, j, nfou, nsibs, p1, p2

      fam=pedigree
      call makeind(nuc,eop,fam)
      nsibs=min(fin-sta,maxsibs)+1
      nfou=0
      gp1=MISS
      gp2=MISS
      gp3=MISS
      gp4=MISS
      p1=1
      p2=2
      if (typ.eq.2) then
        if (currf.gt.nfound) then
          nfou=nfou+2
          p1=p1+2
          p2=p2+2
          gp1=1
          gp2=2
        end if
        if (currm.gt.nfound) then
          nfou=nfou+2
          p1=p1+2
          p2=p2+2
          gp3=max(gp2,0)+1
          gp4=gp3+1
        end if
      end if
      write(twrk) fam, actset, nsibs+2+nfou, max(2,nfou)
C Grandparents
      if (typ.eq.2) then
        if (currf.gt.nfound) then
          write(twrk) id(fa(currf)),MISS,MISS,1, 
     &      (locus(fa(currf),j),j=1,numloc)
          write(twrk) id(mo(currf)),MISS,MISS,2, 
     &      (locus(mo(currf),j),j=1,numloc)
        end if
        if (currm.gt.nfound) then
          write(twrk) id(fa(currm)),MISS,MISS,1, 
     &      (locus(fa(currm),j),j=1,numloc)
          write(twrk) id(mo(currm)),MISS,MISS,2, 
     &      (locus(mo(currm),j),j=1,numloc)
        end if
      end if
C Parents
      write(twrk) id(currf),gp1,gp2,1, 
     &  (locus(currf,j),j=1,numloc)
      write(twrk) id(currm),gp3,gp4,2, 
     &  (locus(currm,j),j=1,numloc)
C Children
      do 55 i=sta,min(sta+maxsibs,fin)
        write(twrk) id(i),p1,p2,sex(i),
     &    (locus(i,j),j=1,numloc)
   55 continue
      return
      end
C end-of-onefam 
C
C chop into disjoint subpedigrees
C note that the pointers in set(,2) do not follow the sort order of
C the pedigree, as connect() moves both up and down the generations
C
      subroutine disjoin(wrk,twrk,pedigree,actset,num,nfound,id,fa,mo,
     &                   sex,locus,numloc,ord,set,plevel)
      integer MAXSIZ,MAXLOC,MISS
      parameter (MAXSIZ=1000,MAXLOC=120,MISS=-9999)
      integer plevel, wrk, twrk
C Pedigree structure
      character*10 pedigree
      integer actset,num,nfound 
      character*8 id(MAXSIZ) 
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      integer ord(MAXSIZ), set(MAXSIZ,2)
      integer numloc
      real locus(MAXSIZ,MAXLOC)
      logical last
      integer curped, eop, maxgrp, nf, nsub, no
      character*10 fam
C functions
      integer eow
C
      last=.false.
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20
         if (actset.le.0) then
           call wrkout(twrk,pedigree,actset,num,nfound,id,fa,mo,sex,
     &                 locus,numloc)
           goto 10
         end if
         call connect(num,fa,mo,set,nsub,maxgrp)
         if (plevel.gt.0) then
           write(*,'(3a,i4,a)') 'Pedigree ',pedigree,' written out as ',
     &       nsub,' pedigrees.'
         end if
         if (nsub.eq.1) then
           call wrkout(twrk,pedigree,actset,num,nfound,id,fa,mo,sex,
     &                 locus,numloc)
         else
           eop=eow(pedigree)
           do 15 curped=1,nsub
             nf=0
             no=0
             do 25 i=1,nfound
             if (set(i,1).eq.curped) then
               no=no+1
               nf=nf+1
               ord(i)=no
             end if
   25        continue
             do 26 i=nfound+1,num 
             if (set(i,1).eq.curped) then
               no=no+1
               ord(i)=no
             end if
   26        continue
             fam=pedigree
             call makeind(curped,eop,fam)
             if (plevel.gt.1) then
               write(*,'(2a)') 'Created pedigree ',fam
             end if
             write(twrk) fam, actset, no, nf
             do 30 i=1,nfound
             if (set(i,1).eq.curped) then
               write(twrk) id(i),MISS,MISS,sex(i),
     &           (locus(i,j),j=1,numloc)
             end if
   30        continue
             do 31 i=nfound+1,num 
             if (set(i,1).eq.curped) then
               write(twrk) id(i),ord(fa(i)),ord(mo(i)),sex(i),
     &           (locus(i,j),j=1,numloc)
             end if
   31        continue
   15      continue
         end if
      goto 10
   20 continue
      return
      end
C end-of-disjoin
C
C Edit alleles for particular gene for particular person 
C
      subroutine edit(wrk,twrk,tped,tid,gene,loc,loctyp,all1,all2,
     2                pedigree,actset,num,nfound,id,fa,mo,sex,
     3                locus,numloc)
      integer MAXSIZ,MAXLOC,MISS
      parameter (MAXSIZ=1000,MAXLOC=120,MISS=-9999)
      integer twrk,wrk
C target pedigree,id,replacement alleles
      character*8 tid
      character*10 tped,loc
      integer gene,loctyp
      real all1,all2
C Pedigree structure
      character*10 pedigree
      integer actset,num,nfound 
      character*8 id(MAXSIZ) 
      integer fa(MAXSIZ),mo(MAXSIZ),sex(MAXSIZ)
      integer numloc
      real locus(MAXSIZ,MAXLOC)
      logical last
C
      integer i,j,eop,gen2
      logical all
      real tmp
      character*1 newbin,oldbin
      character*7 newgtp,oldgtp
      character*10 chid
C functions
      integer eow

      all=(tid.eq.'all     ')
      eop=eow(tped)
      gen2=gene+1
      last=.false.
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20
        if (actset.gt.0 .and. tped .eq. pedigree) then
          do 15 i=1,num
          if (all .or. tid .eq. id(i)) then
            call wrid('l',id(i),chid,0)
            if (gene .eq. MISS) then
              write(*,'(4a)') 
     2          'Deleting all data for ',
     3          pedigree(1:eop),'-',chid(1:eow(chid)) 
              do 12 j=1,numloc
                locus(i,j)=MISS
   12         continue
            elseif (loctyp .le. 2) then
              if (all1.gt.all2) then
                tmp=all1
                all1=all2
                all2=tmp
              end if
              call wrgtp(int(all1),int(all2),newgtp,1)
              call wrgtp(int(locus(i,gene)),int(locus(i,gen2)),oldgtp,1)
              write(*,'(10a)') 
     2          'Changing ',pedigree(1:eop),'-',chid(1:eow(chid)),
     3          ' at locus "',loc(1:eow(loc)), 
     4          '" from ',oldgtp, ' to ',newgtp
              locus(i,gene)=all1
              locus(i,gen2)=all2
            elseif (loctyp .eq. 3) then
              write(*,'(7a,f8.4,a,f8.4)') 
     2          'Changing ',pedigree(1:eop),'-',chid(1:eow(chid)),
     3          ' at locus "',loc(1:eow(loc)),
     4          '" from ',locus(i,gene),' to ',all1
              locus(i,gene)=all1
            elseif (loctyp .eq. 4) then
              call wraff(all1,newbin)
              call wraff(locus(i,gene),oldbin)
              write(*,'(7a,a8,a,a8)') 
     2          'Changing ',pedigree(1:eop),'-',chid(1:eow(chid)),
     3          ' at locus "',loc,
     4          '" from ', oldbin,' to ',newbin
              locus(i,gene)=all1
            end if
          end if
   15     continue
        end if
        call wrkout(twrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &              numloc)
      goto 10
   20 continue
      return
      end
C end-of-edit
C
C include or exclude a list of pedigrees
C
      subroutine selped(wrk,twrk,typ,farg,larg,words,pedigree,actset,
     &                  num, nfound,id,fa,mo,sex,locus,numloc,plevel)
      integer MAXLOC, MAXCOL, MAXSIZ, MISS
      parameter (MAXLOC=120, MAXCOL=MAXLOC+5, MAXSIZ=1000, MISS=-9999)

      integer farg,larg,plevel,twrk,typ,wrk
      character*20 words(MAXCOL)
C Pedigree structure
      character*10 pedigree
      integer actset, num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
      logical last
C
      integer i, nfam
      logical found, ltyp

      ltyp=.not.(typ.eq.1) 

      nfam=0
      last=.false.
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20
        found=ltyp
        do 50 i=farg, larg
        if (actset.gt.0 .and. pedigree.eq.words(i)(1:10)) then
          found=.not.found
          goto 60
        end if
   50   continue

   60   continue
        if (found) then
          nfam=nfam+1
          if (plevel.gt.0) write(*,'(2a)') 'Selected pedigree ',pedigree
        else
          actset=-abs(actset)
        end if
        call wrkout(twrk,pedigree,actset,num,nfound,id,fa,mo,sex,
     &              locus,numloc)
      goto 10
   20 continue
      write(*,'(/a,i6,a)') 'Selected ',nfam,' pedigrees.'
      return
      end
C end-of-selped
C
C identify rare alleles at a marker locus and list for combination
C
      subroutine combine(crit,recto,nf,recfro,numal,name,alfrq)
      integer KNOWN,MAXSIZ,MAXLOC,MAXALL
      parameter (KNOWN=0,MAXSIZ=1000,MAXLOC=120,MAXALL=60)
      integer nf
      real crit,recto,recfro(MAXALL)
C allele frequencies within entire sample for given locus 
      integer numal, name(MAXALL)
      double precision alfrq(MAXALL)

      nf=0
      do 10 i=1, numal
      if (alfrq(i).le.crit) then
        nf=nf+1
        recfro(nf)=name(i)
      end if
   10 continue
C recode to 999 or nearest available allele number
      recto=1000.0
   20 continue
        recto=recto-1.0
      do 30 i=1, numal
        if (int(recto).eq.name(i)) goto 20
   30 continue
      return
      end
C end-of-combine
C
C recode alleles or values for particular locus -- 
C replace all "from" values with "to" values
C
      subroutine recode(wrk,twrk,loc,gene,typ,recto,nf,recfro,
     &             pedigree,actset,num,nfound,id,fa,mo,sex,locus,numloc)
      integer KNOWN,MAXSIZ,MAXLOC,MAXALL
      parameter (KNOWN=0,MAXSIZ=1000,MAXLOC=120,MAXALL=60)
      integer gene,nf,twrk,typ,wrk
      character*10 loc
      real recto,recfro(MAXALL)
C Pedigree structure
      character*10 pedigree
      integer actset,num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
      logical last
C
      integer i,j,gen2, nchange

      write(*,'(/a,a10)') 'Recoding locus ',loc
      write(*,'(a,30(1x,f4.0):)') 'From: ',(recfro(i),i=1,nf)
      write(*,'(a,1x,f4.0/)')     'To  : ',recto

      gen2=gene+1
      nchange=0
      last=.false.
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20
        if (actset.gt.0) then
          if (typ.eq.1) then
            do 15 i=1,num
            do 15 j=1,nf
              if (abs(locus(i,gene)).eq.recfro(j)) then
                locus(i,gene)=sign(1.0,locus(i,gene))*recto
                if (locus(i,gene).gt.KNOWN) nchange=nchange+1
              end if
              if (abs(locus(i,gen2)).eq.recfro(j)) then
                locus(i,gen2)=sign(1.0,locus(i,gen2))*recto
                if (locus(i,gen2).gt.KNOWN) nchange=nchange+1
              end if
   15       continue
          else
            do 25 i=1,num
            do 25 j=1,nf
              if (locus(i,gene).eq.recfro(j)) then
                locus(i,gene)=recto
                nchange=nchange+1
              end if
   25       continue
          end if
        end if
        call wrkout(twrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &              numloc)
      goto 10
   20 continue
      write(*,'(a,i6,a)') 'Recoded ',nchange,' values.'
      return
      end
C end-of-recode
C
C Kaplan-Meier estimator of survival function and the Nelson-Aalen 
C estimator of cumulative hazard.
C The Nelson-Aalen estimator is used to produce residuals, if requested.
C These are the deviance residuals of Therneau et al Biometrika 1990:
C equivalent to a variance-stabilized transformed martingale residual.
C
C
      subroutine prodlim(wrk,twrk,trait,censor,pedigree,actset,num,
     2             nfound,id,fa,mo,sex,locus,numloc,
     3             onset,haz,set,typ,plevel)
C
      integer MAXSIZ, MAXLOC, MISS
      parameter(MAXSIZ=1000, MAXLOC=120, MISS=-9999)
      integer censor, plevel, trait, twrk, typ, wrk
C  Pedigree structure
      character*10 pedigree
      integer actset, num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      integer numloc
      real locus(MAXSIZ,MAXLOC)
C Age at onset, associated survival function
      integer naff, nobs, nvals, unaff
      real onset(MAXSIZ), haz(MAXSIZ)
      integer set(MAXSIZ,2)
C local variables
      integer i,j,k
      real res,x
      double precision dn, na, pl, va
      logical last

      naff=0
      nobs=0
      nvals=0
      do 1 i=1,MAXSIZ
        set(i,1)=0
        set(i,2)=0
    1 continue

      last=.false.
      rewind(wrk)
    5 continue
        call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &             numloc, last)
        if (last) goto 20

        if (actset.gt.0) then
         do 10 i=1,num
         if (locus(i,trait).ne.MISS) then
           nobs=nobs+1
           x=locus(i,trait)
           j=0
   15      continue
             j=j+1
           if (x.gt.onset(j) .and. j.le.nvals) goto 15
           if (x.ne.onset(j)) then
             if (nvals.lt.MAXSIZ) then
               do 30 k=nvals,j,-1
                 onset(k+1)=onset(k)
                 set(k+1,1)=set(k,1)
                 set(k+1,2)=set(k,2)
   30          continue
               nvals=nvals+1
               onset(j)=x
               set(j,1)=0
               set(j,2)=0
             else
               j=nvals
             end if
           end if
           set(j,2)=set(j,2)+1
           if (locus(i,censor).eq.2) then
             naff=naff+1
             set(j,1)=set(j,1)+1
           end if
         end if
   10    continue
        end if
      goto 5
   20 continue

      if (plevel.gt.1) then
        write(*,'(2(/a))') 
     2    ' Rank  Age-at-onset  Failed     Obs',
     3    ' ----------------------------------' 
        do 50 j=1,nvals
          write(*,'(1x,i4,2x,f12.4,2i8)') j,onset(j),set(j,1),set(j,2)
   50   continue
      end if
      write(*,'(2(/a))') 
     2  ' Age-at-onset   Failed  Riskset   H(t)   S(t)    ase',
     3  ' ---------------------------------------------------' 
      na=0.0d0
      pl=1.0d0
      va=0.0d0
      unaff=nobs-naff
      do 110 j=1,nvals
        if (set(j,1).ne.0) then
          dn=dfloat(set(j,1))/dfloat(nobs)
          na=na+dn
          pl=pl*(1.0d0-dn)
          va=va+dn/dfloat(max(1,nobs-set(j,1)))
          write(*,'(1x,f12.4,2(1x,i8),3(1x,f6.4))') 
     &      onset(j),set(j,1),nobs,na,pl,pl*sqrt(va)
        end if
        haz(j)=sngl(na)
        nobs=nobs-set(j,2)
  110 continue
      write(*,'(/a/a//i5,a,i5,a)')
     2  ' H(t) = Nelson-Aalen estimator of integrated hazard',
     3  ' S(t) = Kaplan-Meier estimator of survivor function',
     4  naff,' affecteds and ',unaff,' unaffecteds used'
      if (typ.eq.1) return
C
C else replace age-at-onset with residual
C
      rewind(wrk)
  175 continue
        call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &             numloc, last)
        if (last) goto 190

        if (actset.gt.0) then
         do 180 i=1,num
         if (locus(i,trait).ne.MISS) then
           x=locus(i,trait)
           j=0
  185      continue
             j=j+1
           if (x.gt.onset(j) .and. j.le.nvals) goto 185
           if (locus(i,censor).eq.2.0) then
             res=1.0-haz(j)
             locus(i,trait)=sign(1.0,res)*sqrt(-2.0*(res+log(1.0-res)))
           else
             locus(i,trait)=-sqrt(2.0*haz(j))
           end if
         end if
  180    continue
        end if
        call wrkout(twrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &              numloc)
      goto 175
  190 continue
      return
      end
C end-of-prodlim
C
C standardization of quantitative trait overall or *within* family
C as required by the approach of Commenge 
C
      subroutine stand(wrk,twrk,trait,pedigree,actset,num,
     &             nfound,id,fa,mo,sex,locus,numloc,typ)
C
      integer MAXSIZ, MAXLOC, MISS
      parameter(MAXSIZ=1000, MAXLOC=120, MISS=-9999)
      integer wrk, twrk, trait, typ
C  Pedigree structure
      character*10 pedigree
      integer actset, num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      integer numloc
      real locus(MAXSIZ,MAXLOC)
      integer i, n
      double precision mu, sd
      logical last

      last=.false.
      rewind(wrk)
      if (typ.eq.2) then
    5   continue
          call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &               numloc, last)
          if (last) goto 20

          if (actset.gt.0) then
            n=0
            mu=0.0d0
            sd=0.0d0
            do 10 i=1,num
            if (locus(i,trait).ne.MISS) then
              n=n+1
              call moment(n,dble(locus(i,trait)),mu,sd)
            end if
   10       continue
C
            if (n.gt.0) then
              sd=sqrt(sd/dfloat(max(1,n-1)))
              do 30 i=1,num
              if (locus(i,trait).ne.MISS) then
                locus(i,trait)=sngl((dble(locus(i,trait))-mu)/sd)
              end if
   30         continue
            end if
          end if
          call wrkout(twrk,pedigree,actset,num,nfound,id,fa,mo,sex,
     &                locus, numloc)
        goto 5
   20   continue
      elseif (typ.eq.1) then
        n=0
        mu=0.0d0
        sd=0.0d0
   55   continue
          call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &               numloc, last)
          if (last) goto 70

          if (actset.gt.0) then
            do 60 i=1,num
            if (locus(i,trait).ne.MISS) then
              n=n+1
              call moment(n,dble(locus(i,trait)),mu,sd)
            end if
   60       continue
          end if
        goto 55
   70   continue
C
        sd=sqrt(sd/dfloat(max(1,n-1)))
        rewind(wrk)
   75   continue
          call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &               numloc, last)
          if (last) goto 90
          if (actset.gt.0) then
            do 80 i=1,num
            if (locus(i,trait).ne.MISS) then
              locus(i,trait)=sngl((dble(locus(i,trait))-mu)/sd)
            end if
   80       continue
          end if
          call wrkout(twrk,pedigree,actset,num,nfound,id,fa,mo,sex,
     &                locus, numloc)
        goto 75
   90   continue
      end if
      return
      end
C end-of-stand
C
C linear regression correction of quantitative trait 1 versus trait 2
C
      subroutine adjust(wrk,twrk,ytrait,xtrait,adjval,pedigree,actset,
     &                  num,nfound,id,fa,mo,sex,locus,numloc,plevel)
C
      integer MAXSIZ, MAXLOC, MISS
      parameter(MAXSIZ=1000, MAXLOC=120, MISS=-9999)
      integer wrk, twrk, ytrait, xtrait, plevel
      real adjval
C  Pedigree structure
      character*10 pedigree
      integer actset,num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      integer numloc
      real locus(MAXSIZ,MAXLOC)
      integer n, i, ifail
      logical last
C regression results
      double precision x(3),r(6),b(2)
      double precision alpha,beta,mux 
      n=0
      ifail=0
      mux=0.0d0
      call inicov(3, 6, r)

      last=.false.
      rewind(wrk)
    5 continue
        call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &             numloc, last)
        if (last) goto 20

        if (actset.gt.0) then
         do 10 i=1,num
         if (locus(i,ytrait).ne.MISS .and. locus(i,xtrait).ne.MISS) then
           n=n+1
           x(1)=1.0d0
           x(2)=dble(locus(i,xtrait))
           x(3)=dble(locus(i,ytrait))
           mux=mux+x(2)
           call givenc(r, 6, 3, x, 1.0d0, ifail)
         end if
   10    continue
        end if
      goto 5
   20 continue
C
      call bsub(r, 6, 3, b, 2, ifail)
      alpha=b(1)
      beta=b(2)
      mux=mux/dfloat(n) 
      if (adjval.eq.MISS) adjval=sngl(mux)
      if (plevel.gt.0) then
        write(*,'(a,f12.4/2(a,f12.4),a,i4,a/)') 
     2    'Adjusting to x-value of ',adjval,
     3    'y = ',alpha,' + ',beta,' * x  (based on ',n,' values)' 
      end if
      if (ifail.gt.0) then
        write(*,'(a/)') 'ERROR: Regression routine problem.'
        return
      end if
C
      rewind(wrk)
   25 continue
        call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &             numloc, last)
        if (last) goto 40

        if (actset.gt.0) then
         do 30 i=1,num
         if (locus(i,ytrait).ne.MISS) then
           if (locus(i,xtrait).ne.MISS) then
             locus(i,ytrait)=locus(i,ytrait)+
     &                       sngl(beta*dble(adjval-locus(i,xtrait)))
           else
             locus(i,ytrait)=locus(i,ytrait)+
     &                       sngl(beta*(dble(adjval)-mux))
           end if
         end if
   30    continue
        end if
        call wrkout(twrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &              numloc)
      goto 25
   40 continue
      return
      end
C end-of-adjust
C
C transform quantitative trait value
C
C t(x) =    { (x-offset)/divisor }                    Power == 1
C t(x) = log{ (x-offset)/divisor }                    Power == 0
C t(x) =   [{ (x-offset)/divisor }**Power - 1]/Power  Power != 0 && !=1
C Resulting values can be truncated above or below
C
      subroutine boxcox(wrk,twrk,trait,offset,divisor,power,loval,hival,
     &             pedigree,actset,num,nfound,id,fa,mo,sex,locus,numloc)
      integer MAXSIZ,MAXLOC,MISS
      parameter (MAXSIZ=1000,MAXLOC=120,MISS=-9999)
      integer trait,twrk,wrk
      real divisor, hival, loval, offset, power
C Pedigree structure
      character*10 pedigree
      integer actset, num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
      logical last
C
      integer i,ifault
      real x

      ifault=0
      last=.false.
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

       if (actset.gt.0) then
        if (power.eq.1.0) then
          do 15 i=1,num
          if (locus(i,trait).ne.MISS) then
            locus(i,trait)=(locus(i,trait)-offset)/divisor
          end if
   15     continue
        elseif (power.eq.0.0) then
          do 25 i=1,num
          if (locus(i,trait).ne.MISS) then
            x=(locus(i,trait)-offset)/divisor
            if (x.le.0) then
              ifault=ifault+1
              locus(i,trait)=MISS
            else
              locus(i,trait)=log(x)
            end if
          end if
   25     continue
        else
          do 35 i=1,num
          if (locus(i,trait).ne.MISS) then
            x=(locus(i,trait)-offset)/divisor
            if ((mod(power,1.0).ne.0.0 .and. x.lt.0) .or.
     2          (power.lt.0.0 .and. x.eq.0.0))  then
              ifault=ifault+1
              locus(i,trait)=MISS
            else
              locus(i,trait)=(x**power-1.0)/power
            end if
          end if
   35     continue
        end if
        if (loval.ne.MISS) then
          do 45 i=1,num
          if (locus(i,trait).ne.MISS .and. locus(i,trait).lt.loval) then
            locus(i,trait)=loval
          end if
   45     continue
        end if
        if (hival.ne.MISS) then
          do 55 i=1,num
          if (locus(i,trait).ne.MISS .and. locus(i,trait).gt.hival) then
            locus(i,trait)=hival
          end if
   55     continue
        end if
       end if
        call wrkout(twrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &              numloc)
      goto 10
   20 continue

      if (ifault.gt.0) then
        write(*,'(/a,i5,2a/7x,a/)') 
     2    'NOTE:  There were ',ifault,' trait values that could not be',
     3    ' transformed as requested.','New values were set to missing.'
      end if
      return
      end
C end-of-boxcox
C
C Convert a genotype to a quantitative trait
      subroutine factor(wrk,twrk,trget, gene, numal, name, 
     2                  pedigree,actset,num,nfound,id,fa,mo,sex, 
     3                  locus,numloc)
      integer KNOWN,MAXSIZ,MAXLOC,MAXALL,MISS
      parameter (KNOWN=0,MAXSIZ=1000,MAXLOC=120,MAXALL=60,MISS=-9999)
      integer gene,numloc,trget,twrk,wrk
C alleles at the marker
      integer numal, name(MAXALL)
C Pedigree structure
      character*10 pedigree
      integer actset, num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
      logical last
C
      integer g1,g2,gen2,i
C functions
      integer getnam

      gen2=gene+1
      last=.false.
      rewind(wrk)
   10 continue
       call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &            numloc, last)
       if (last) goto 20

        if (actset.gt.0) then
          do 30 i=1,num
            locus(i,trget)=MISS
            if (locus(i,gene).gt.KNOWN) then
              g1=getnam(locus(i,gene),numal,name)
              g2=getnam(locus(i,gen2),numal,name)
              locus(i,trget)=float(numal*(g1-1)+g2)
            end if
   30     continue
        end if
        call wrkout(twrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &              numloc)
      goto 10
   20 continue
      return
      end
C end-of-factor
C
      subroutine dorank(wrk,twrk,trget,trait,pedigree,actset,num,nfound,
     &             id,fa,mo,sex,locus,numloc,value,count)
C
      integer MAXSIZ, MAXLOC, MISS
      parameter(MAXSIZ=1000,MAXLOC=120,MISS=-9999)
      integer trget, trait, twrk, wrk
C  Pedigree structure
      character*10 pedigree
      integer actset, num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ), sex(MAXSIZ)
      integer numloc
      real locus(MAXSIZ,MAXLOC)
C Quantitative trait values
      integer nvals
      real value(MAXSIZ)
      integer count(MAXSIZ)
C local variables
      integer i
      logical last
C functions
      real rank
C
      nvals=0
C
C Tabulate sorted values and frequencies
      last=.false.
      rewind(wrk)
    5 continue
        call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &             numloc, last)
        if (last) goto 20

        if (actset.gt.0) then
         do 10 i=1,num
         if (locus(i,trait).ne.MISS) then
           call qtab(locus(i,trait),nvals,value,count)
         end if
   10    continue
        end if
      goto 5
   20 continue
C Replace with cumulative counts
      do 100 i=2, nvals
        count(i)=count(i)+count(i-1)
  100 continue
C
C Give rank of each record
      last=.false.
      rewind(wrk)
   25 continue
        call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &             numloc, last)
        if (last) goto 40

        if (actset.gt.0) then
          do 30 i=1,num
          if (locus(i,trait).ne.MISS) then
            locus(i,trget)=rank(locus(i,trait),nvals,value,count)
          end if
   30     continue
        end if
        call wrkout(twrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &              numloc)
      goto 25
   40 continue
      return
      end
C end-of-dorank
C
C Binary search for closest position of value in an ascending sorted array
C Closest position
C
      real function rank(val,num,key,cumcnt)
      integer num, cumcnt(*)
      real val, key(*)
      
      integer hi, lo, pos

      hi=num
      lo=1
   10 continue
        pos=(hi+lo)/2
        if (val.gt.key(pos)) then
          lo=pos+1
        elseif (val.lt.key(pos)) then
          hi=pos-1
        else
          goto 20
        end if
      if (hi.ge.lo) goto 10
   20 continue
      lo=0
      if (pos.gt.1) lo=cumcnt(pos-1)
      rank=0.5*float(lo+cumcnt(pos)+1)
      return
      end
C end-of-rank 

C
C Modified random walk simulation (one iteration) of pedigree 
C missing genotypes (Metropolis-Hastings algorithm) --
C proposal uses founder allele mutations propagated throughout then
C pedigree conditional on (identity by) descent, swapping ibd
C origins for heterozygotes, alternated with 
C a randomization of descent conditional on marker genotype.
C This procedure has the advantage of being quick.  It is speeded further
C for Untyped x Untyped founder matings by resimulating each mating's 
C joint genotype conditional on offspring.
C
      subroutine drop(it,pedigree,num,nfound,id,fa,mo,nummat,
     2                cntmat,untyped,numal,gfrq,set,set2,sibd,
     3                key, plevel)
      integer MAXALL, MAXG, MAXSIZ
      parameter(MAXALL=60, MAXG=MAXALL*(MAXALL+1)/2,
     &          MAXSIZ=1000)

      integer it,plevel
C pedigree structure
      character*10 pedigree
      integer num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ)
C genotypic arrays for pedigree: current, proposed; resulting ibd status
      integer set(MAXSIZ,2), set2(MAXSIZ,2)
      integer sibd(MAXSIZ,2), key(2*MAXSIZ)
C indicator of untyped individual
      logical untyped(MAXSIZ)
C allele frequencies structure
      integer numal
      double precision gfrq(MAXG)
C number of untyped matings -- used to decide number and type of mutations
      integer nummat, cntmat(MAXALL,2)
C local variables
      integer i, par1, par2, typ
      logical xmale
      double precision lr, qa 
C functions
      integer irandom, parcon

      xmale=.false.
C
C Do ibd dropping
C
      typ=irandom(1,3)
      if (plevel.gt.2) then
        write(*,*) 'Proposal type ',type
      end if
      if (typ.eq.1) then
        do 10 i=1,num
          set2(i,1)=set(i,1)
          set2(i,2)=set(i,2)
   10   continue
        call fsimped(it,pedigree,num,nfound,id,fa,mo,set2,sibd,
     &               untyped,key,plevel)
C
C Or mutate founder allele(s)
C
      elseif (typ.eq.2) then
        call simibd(2,pedigree,num,nfound,fa,mo,set,sibd)
        call mutate(numal,num,nfound,set,sibd,set2,untyped)
C
C Or switch parents of origin
C
      else
        call simibd(2,pedigree,num,nfound,fa,mo,set,sibd)
        call switch(num,nfound,fa,mo,set,sibd,set2,untyped)
      end if
C
C Untyped x Untyped founder matings can be treated specially by
C simulating these genotypes conditional on offspring.
C
      do 20 mat=1,nummat
        par1=cntmat(mat,1)
        par2=cntmat(mat,2)
        call simnuc(num,nfound,fa,mo,set2,par1,par2,numal)
   20 continue
C
C now check if the proposal is an acceptable one
C
      if (plevel.gt.2) then
        do 999 i=1,num
          write(*,*) id(i), set(i,1), set(i,2), '->',
     &      set2(i,1), set2(i,2), '{',sibd(i,1),sibd(i,2),'}'
  999   continue
      end if

      lr=1.0d0
      do 100 i=1,nfound
      if (untyped(i)) then
        lr=lr*gfrq(set2(i,2)*(set2(i,2)-1)/2+set2(i,1))/
     &        gfrq(set(i,2)*(set(i,2)-1)/2+set(i,1))
      end if
  100 continue
      do 110 i=nfound+1,num
        par2=parcon(set2(i,1),set2(i,2),set2(fa(i),1),set2(fa(i),2),
     &              set2(mo(i),1),set2(mo(i),2),xmale)
        par1=parcon(set(i,1),set(i,2),set(fa(i),1),set(fa(i),2),
     &              set(mo(i),1),set(mo(i),2),xmale)
        if (par1.ne.par2) then
          lr=lr*dfloat(par2)/dfloat(par1)
        end if
  110 continue
      qa=min(1.0d0,lr)
C
C If accepted, update genotypes
C
      if (qa.gt.random()) then
        if (plevel.gt.2) then
          write(*,*) 'Proposal accepted'
        end if
        do 150 i=1,num
        if (untyped(i)) then
          set(i,1)=set2(i,1)
          set(i,2)=set2(i,2)
        end if
  150   continue
      end if
      if (plevel.gt.1) then
        write(*,*) 'Simulated missing genotypes for iteration ',it
        do 160 i=1,num
        if (untyped(i)) then
          write(*,'(i5,1x,a8,2(1x,i3))') it,id(i),set(i,1),set(i,2)
        end if
  160   continue
      end if
      return
      end
C end-of-drop
C 
C  Simulate parental genotypes for untyped x untyped
C  mating conditional on offspring genotypes
C  Family may be contained within larger pedigree, and
C  multiple spouses are possible
C
      subroutine simnuc(num,nfound,fa,mo,set,par1,par2,numal)
C
C  Pedigree structure
      integer MAXALL, MAXG, MAXSIZ, MISS
      parameter(MAXALL=60, MAXG=MAXALL*(MAXALL+1)/2,
     &          MAXSIZ=1000, MISS=-9999)
      integer num, nfound, fa(MAXSIZ),mo(MAXSIZ), set(MAXSIZ,2)
      integer par1, par2
C local variables
      integer fin, i, sta
      integer target, totp
C functions
      integer irandom

      sta=MISS
      fin=MISS
      do 10 i=nfound+1,num
      if (par1.eq.fa(i) .or. par2.eq.mo(i)) then
        if (sta.eq.MISS) then
          sta=i
          fin=i
        elseif (i.gt.fin) then
          fin=i
        end if
      end if
   10 continue
C
      target=MAXG*MAXG
      call nuclik(fa,mo,set,par1,par2,sta,fin,
     &            numal,target,totp)
      target=irandom(1,totp)
      call nuclik(fa,mo,set,par1,par2,sta,fin,
     &            numal,target,totp)
C
      return
      end
C end-of-simnuc
C
C Nuclik is run twice, once to calculate the total number <totp> of the
C legal genotypes (with target=MAXG*MAXG), the second time to select a 
C parental genotype.
C
      subroutine nuclik(fa,mo,set,par1,par2,sta,fin,
     &                  numal,targt,totp)
      integer MAXSIZ
      parameter(MAXSIZ=1000)
      integer targt, totp
C  Pedigree structure
      integer fa(MAXSIZ),mo(MAXSIZ), set(MAXSIZ,2)
      integer fin, mg1, mg2, par1, par2, pg1, pg2, sta
C allele frequencies structure
      integer numal

C local variables
      integer i
      logical xmale
C functions
      integer parcon
C 
      xmale=.false.
      totp=0

      do 5 mg2=1,numal
      do 5 mg1=1,mg2
      do 5 pg2=1,numal
      do 5 pg1=1,pg2
        set(par1,1)=pg1
        set(par1,2)=pg2
        set(par2,1)=mg1
        set(par2,2)=mg2
        do 10 i=sta,fin
        if ((par1.eq.fa(i) .or. par2.eq.mo(i)) .and. 
     2      parcon(set(i,1),set(i,2),set(fa(i),1),set(fa(i),2),
     3             set(mo(i),1),set(mo(i),2),xmale).eq.0) then
          goto 55
        end if
   10   continue
C
C else (if consistent) add to legal genotypes
C
          totp=totp+1
C
C check to see if have selected current parental genotypes
C
          if (totp.eq.targt) then
            return
          end if
   55   continue
    5 continue
      return
      end
C end-of-nuclik
C
C Mutate 1-4 allele in untyped founders.  Can never fail, due "backmutation".
C
C (1) mutate an allele never transmitted to a typed individual
C (2) swap parent of origin if have no offspring sharing ibd-allele
C
      subroutine mutate(numal,num,nfound,set,sibd,set2,untyped)
      integer MAXSIZ
      parameter (MAXSIZ=1000)
      integer numal
C Pedigree structure
      integer num, nfound
      integer set(MAXSIZ,2), sibd(MAXSIZ,2), set2(MAXSIZ,2)
      logical untyped(MAXSIZ)
C
C mut designates ibd-allele, prop the corresponding marker allele
      integer nmut
      integer mut(4), prop(4)
      integer g1,g2,i,j
C functions
      integer irandom

    1 continue

        nmut=irandom(1,4)
        do 5 j=1,nmut
          mut(j)=irandom(1,2*nfound)
          prop(j)=irandom(1,numal)
    5    continue
         do 10 i=1,num
           g1=set(i,1)
           g2=set(i,2)
           do 15 j=1, nmut
             if (sibd(i,1).eq.mut(j)) g1=prop(j)
             if (sibd(i,2).eq.mut(j)) g2=prop(j)
   15      continue
           call order(g1,g2)
C midloop break
      if ( .not.untyped(i) .and.
     &     (set(i,1).ne.g1 .or. set(i,2).ne.g2)) then
        goto 1
      end if
C
          call update(i,g1,g2,set2)
   10   continue
      return
      end
C end-of-mutate
C
C Do a switch of grandparent of origin of alleles = switch lineage
C
      subroutine switch(num,nfound,fa,mo,set,sibd,set2,untyped)
      integer KNOWN,MAXSIZ,MISS
      parameter (KNOWN=0,MAXSIZ=1000,MISS=-9999)
C Pedigree structure
      integer num, nfound, fa(MAXSIZ), mo(MAXSIZ)
      integer set(MAXSIZ,2), sibd(MAXSIZ,2), set2(MAXSIZ,2)
      logical untyped(MAXSIZ)
C
      integer g(2), i, idx, ntrials, par
      logical fin, xmale

C functions
      integer irandom, parcon

      xmale=.false.
      ntrials=0

    1 continue
C
      ntrials=ntrials+1
C
C give up if <num> unsuccessful trials
C
      if (ntrials.gt.num) then
        do 220 i=1,num
          set2(i,1)=set(i,1)
          set2(i,2)=set(i,2)
  220   continue
        return
      end if
C
C provide a heterozygote candidate with both parents untyped
C
      idx=irandom(nfound+1,num)

      if (set(idx,1).eq.set(idx,2) .or. 
     &     .not.untyped(fa(idx)) .or. .not.untyped(mo(idx))) then
         goto 1
      end if
C 
      do 10 i=1,num
        set2(i,1)=MISS
        set2(i,2)=MISS
   10 continue
      g(2)=set(idx,1)
      g(1)=set(idx,2)
      set2(idx,1)=1
      set2(idx,2)=2
C
C Each iteration moves as far up the pedigree as possible 
C
   15 continue
        fin=.true.
        do 100 i=nfound+1,num
        if (set2(i,1).ne.MISS) then
          par=fa(i)
          if (set2(par,1).eq.MISS .and. untyped(par)) then
            call cpibd(par,i,sibd,set2,KNOWN)
            fin=.false.
          end if
          par=mo(i)
          if (set2(par,1).eq.MISS .and. untyped(par)) then
            call cpibd(par,i,sibd,set2,KNOWN)
            fin=.false.
          end if
        end if
  100   continue
      if (.not.fin) goto 15
C
C See if reached one (loop) or two untyped founders, so swap feasible
C
      par=0
      do 110 i=1,nfound
      if (set2(i,1).gt.KNOWN .or. set2(i,2).gt.KNOWN) then
        par=par+1
      end if
  110 continue
      if (par.eq.0) then
        goto 1
      end if
C
C swap appropriate alleles of simulated genotype
C
      do 150 i=1,num
        if (set2(i,1).gt.KNOWN) set2(i,1)=g(set2(i,1))
        if (set2(i,2).gt.KNOWN) set2(i,2)=g(set2(i,2))
        if (set2(i,1).le.KNOWN) set2(i,1)=set(i,1)
        if (set2(i,2).le.KNOWN) set2(i,2)=set(i,2)
        call order(set2(i,1),set2(i,2))
        if (i.gt.nfound .and. parcon(set2(i,1),set2(i,2),
     2      set2(fa(i),1),set2(fa(i),2),set2(mo(i),1),
     3      set2(mo(i),2), xmale).eq.0) then
          goto 1
        end if
  150 continue
      return
      end
C end-of-switch
C
C Copy ibd for a pair of relatives.
C Person j has a typing-genotype at sibd2, person i does not.
C The typing-allele corresponding to that shared at sibd()
C is "transmitted" to person i from person j.
C
      subroutine cpibd(i,j,sibd,sibd2,imiss)
      integer MAXSIZ, MISS
      parameter(MAXSIZ=1000,MISS=-9999)
      integer i,imiss,j
      integer sibd(MAXSIZ,2), sibd2(MAXSIZ,2)

      if (sibd(i,1).eq.sibd(j,1)) then
        sibd2(i,1)=sibd2(j,1)
      end if
      if (sibd(i,1).eq.sibd(j,2)) then
        sibd2(i,1)=sibd2(j,2)
      end if
      if (sibd(i,2).eq.sibd(j,1)) then
        sibd2(i,2)=sibd2(j,1)
      end if
      if (sibd(i,2).eq.sibd(j,2)) then
        sibd2(i,2)=sibd2(j,2)
      end if
      if (sibd2(i,1).eq.MISS) sibd2(i,1)=imiss
      return
      end
C end-of-cpibd
C
C Simulate (gene-dropping) genotypes at a single locus
C Conditioning on typed ``founder'' genotypes (true founders/marry-ins
C plus individuals without typed parents) heading informative
C chains of descent 
C
      subroutine csimped(num,nfound,fa,mo,untyped,set)
C
C  Pedigree structure
      integer MAXSIZ, MISS
      parameter(MAXSIZ=1000, MISS=-9999)
      integer num,nfound,fa(MAXSIZ),mo(MAXSIZ), set(MAXSIZ,2)
      logical untyped(MAXSIZ)
      integer i
      logical fin
      do 15 i=nfound+1,num
      if (.not.untyped(fa(i)) .and. .not.untyped(mo(i))) then
        set(i,1)=MISS
        set(i,2)=MISS
      end if
   15 continue

C
C Main loop -- only update individuals with two typed parents
C
      iter=0
   20 continue      
        iter=iter+1
        fin=.true.
        do 30 i=nfound+1,num
        if (set(i,1).eq.MISS .and. 
     &      .not.untyped(fa(i)) .and..not.untyped(mo(i))) then
          if (set(fa(i),1).ne.MISS .and. set(mo(i),1).ne.MISS) 
     &    then
            call genoff(i,fa(i),mo(i),set)
          else
            fin=.false.
          end if
        end if
   30   continue
      if (.not.fin) goto 20
      return
      end
C end-of-csimped
C
C Simulate pedigree conditional on all founders (all must be typed) and 
C typed nonfounders
C
      subroutine fsimped(it,pedigree,num,nfound,id,fa,mo,set,sibd,
     &                   untyped,key,plevel)
      integer MAXSIZ, MISS 
      parameter(MAXSIZ=1000, MISS=-9999)
      integer it, plevel
C  Pedigree structure
      character*10 pedigree
      integer num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ)
      integer set(MAXSIZ,2), sibd(MAXSIZ,2)
      integer key(2*MAXSIZ)
      logical untyped(MAXSIZ)
C local variables
      integer found, i, failid, maxtry, restart
      logical fin

      maxtry=2000
      found=0
      do 10 i=1,nfound
        found=found+1
        sibd(i,1)=found
        key(found)=set(i,1)
        found=found+1
        sibd(i,2)=found
        key(found)=set(i,2)
   10 continue
C
C start of loop -- terminated by either a successful simulation
C of ibd & genotypes of nonfounders, or bailout due <maxtry> iterations 
C without success
C
      restart=0
   40 continue
        found=0
        do 15 i=1,nfound
          if (untyped(i)) then
            key(found+1)=-set(i,1)
            key(found+2)=-set(i,2)
          end if
          found=found+2
   15   continue
        do 46 i=nfound+1,num
          sibd(i,1)=MISS
          sibd(i,2)=MISS
   46   continue

   50   continue
          fin=.true.
          do 70 i=nfound+1,num
          if (sibd(i,1).eq.MISS) then
            if (sibd(fa(i),1).ne.MISS .and. sibd(mo(i),1).ne.MISS) then
              call genof4(i,fa(i),mo(i),set,sibd,untyped,key,failid)
              if (failid.ne.MISS) then
                if (restart.lt.maxtry) then
                  restart=restart+1
                  goto 40
                else
                  if (plevel.gt.0) then
                    write(*,'(/a,i4,a/7x,a,a8,2a/)') 
     2 'NOTE:  In iteration ',it,' of the Metropolis algorithm, ',
     3        'simulation of ibd had to restart due to person ',
     4        id(failid),' in pedigree ',pedigree
                    if (plevel.gt.1) then
                      do 997 j=1,nfound
                        write(*,'(a8,a,2(1x,i3),a,2(1x,i3),a,l1)') 
     2                    id(j),'       x       x',set(j,1), set(j,2),
     3                    ' {', sibd(j,1),sibd(j,2), '} ',untyped(j)
  997                 continue
                      do 998 j=nfound+1,num
                        write(*,'(3a8,2(1x,i3),a,2(1x,i3),a,l1)') 
     2                    id(j),id(fa(j)),id(mo(j)), set(j,1), set(j,2),
     3                    ' {', sibd(j,1),sibd(j,2), '} ',untyped(j)
  998                 continue
                    end if
                  end if
                  call simibd(2,pedigree,num,nfound,fa,mo,set,sibd)
                  return
                end if
              end if
            else
              fin=.false.
            end if
          end if
   70     continue
      if (.not.fin) goto 50
C
      call fill2(num,set,sibd,untyped,key)
      return
      end
C end-of-fsimped
C
C  Drop ibd-alleles conditional on observed markers
C  and randomly where marker genotype not observed -- restart
C  if later generates inconsistency
C  This version assumes all founders are typed 
C 
      subroutine genof4(idx,fa,mo,set,sibd,untyped,key,failid)
      integer KNOWN, MAXSIZ, MISS
      parameter(KNOWN=0, MAXSIZ=1000, MISS=-9999)
      integer idx,fa,mo,failid
      integer set(MAXSIZ,2),sibd(MAXSIZ,2),key(2*MAXSIZ)
      logical untyped(MAXSIZ)
      integer a1,a2,first,maxtrials, second, tr1,tr2,trials
C sample without replacement from {{1,2},{1,2}}
      integer choice, i, seed, space(4)
C functions
      integer irandom

C
      failid=MISS
      maxtrials=4
      trials=0
      do 10 i=1,maxtrials
        space(i)=i
   10 continue

    1 continue

      trials=trials+1
      choice=irandom(trials, maxtrials)
      seed=space(choice)
      space(choice)=space(trials)

#ifdef F2C
      tr1=and(seed,2)/2+1
      tr2=and(seed,1)+1
#endif F2C
#ifdef HPUX
      tr2=iand(seed,2)/2+1
      tr1=iand(seed,1)+1
#endif HPUX
#ifdef DEC
      tr1=iand(seed,2)/2+1
      tr2=iand(seed,1)+1
#endif DEC
#ifdef SUN
      tr1=and(seed,2)/2+1
      tr2=and(seed,1)+1
#endif SUN

      a1=sibd(fa,tr1)
      a2=sibd(mo,tr2)

C     write(*,*) 'In GENOF4():'
C      
C     write(*,*) 'Alleles: ',key(1),key(2),key(3),key(4),key(5),key(6)
C     write(*,*) 'Person #',idx,set(idx,1),'/',set(idx,2),
C    &           ' Untyped: ',untyped(idx)
C     write(*,*) 'Father #',fa, set(fa,1),'/',set(fa,2),
C    &           ' Untyped: ',untyped(fa)
C     write(*,*) 'Mother #',mo, set(mo,1),'/',set(mo,2),
C    &           ' Untyped: ',untyped(mo)
C     write(*,*) 'Transmitting: ',a1,' [',key(a1),' ], ',
C    &                            a2,' [',key(a2),' ]'
C
      if (untyped(idx)) then
        sibd(idx,1)=a1
        sibd(idx,2)=a2
      elseif (key(a1).lt.KNOWN .and. key(a2).lt.KNOWN) then
        first=irandom(1,2)
        second=3-first
        sibd(idx,first)=a1
        sibd(idx,second)=a2
        key(a1)=set(idx,first)
        key(a2)=set(idx,second)
      elseif (key(a1).lt.KNOWN .and. set(idx,1).eq.key(a2)) then
        sibd(idx,1)=a2
        sibd(idx,2)=a1
        key(a1)=set(idx,2)
      elseif (key(a1).lt.KNOWN .and. set(idx,2).eq.key(a2)) then
        sibd(idx,1)=a1
        sibd(idx,2)=a2
        key(a1)=set(idx,1)
      elseif (key(a2).lt.KNOWN .and. set(idx,2).eq.key(a1)) then
        sibd(idx,1)=a2
        sibd(idx,2)=a1
        key(a2)=set(idx,1)
      elseif (key(a2).lt.KNOWN .and. set(idx,1).eq.key(a1)) then
        sibd(idx,1)=a1
        sibd(idx,2)=a2
        key(a2)=set(idx,2)
      elseif (set(idx,1).eq.key(a1) .and. 
     &        set(idx,2).eq.key(a2)) then
        sibd(idx,1)=a1
        sibd(idx,2)=a2
      elseif (set(idx,1).eq.key(a2) .and. 
     &        set(idx,2).eq.key(a1)) then
        sibd(idx,1)=a2
        sibd(idx,2)=a1
      elseif (trials.lt.maxtrials) then
        goto 1
      else
        failid=idx
      end if
      return
      end
C end-of-genof4
C
C infer missing genotypes based on sibd values after run of fsimped
C assume all founders are typed
C
      subroutine fill2(num,set,sibd,untyped,key)
      integer MAXSIZ
      parameter(MAXSIZ=1000)
C  Pedigree structure
      integer num, set(MAXSIZ,2), sibd(MAXSIZ,2), key(2*MAXSIZ)
      logical untyped(MAXSIZ)
C local variables
      integer g1,g2,i,tmp
C
      do 5 i=1,num
      if (untyped(i)) then
        g1=abs(key(sibd(i,1)))
        g2=abs(key(sibd(i,2)))
        if (g1.gt.g2) then
          tmp=g1
          g1=g2
          g2=tmp
          tmp=sibd(i,1)
          sibd(i,1)=sibd(i,2)
          sibd(i,2)=tmp
        end if
        set(i,1)=g1
        set(i,2)=g2
      end if
    5 continue
      return
      end
C end-of-fill2
C 
C  Simulate (gene-dropping) genotypes at a single locus
C  in a pedigree of arbitrary complexity 
C
      subroutine simped(num,nfound,fa,mo,cumfrq,set)
C
C  Pedigree structure
      integer MAXSIZ, MISS, MAXALL
      parameter(MAXSIZ=1000, MISS=-9999, MAXALL=60)
      integer num, nfound, fa(MAXSIZ),mo(MAXSIZ), set(MAXSIZ,2)
      double precision cumfrq(MAXALL)
      integer i
      logical fin
      do 10 i=1,nfound
         call found(cumfrq,set(i,1))
         call found(cumfrq,set(i,2))
         call order(set(i,1),set(i,2))
   10 continue
      do 15 i=nfound+1,num
         set(i,1)=MISS
         set(i,2)=MISS
   15 continue

   20 continue      
        fin=.true.
        do 30 i=nfound+1,num
        if (set(i,1).eq.MISS) then
          if (set(fa(i),1).ne.MISS.and.set(mo(i),1).ne.MISS) 
     &    then
            call genoff(i,fa(i),mo(i),set)
          else
            fin=.false.
          end if
        end if
   30   continue
      if (.not.fin) goto 20
      return
      end
C end-of-simped
C
C founder frequency
C
      subroutine found(cumfrq,allele)
      integer MAXALL
      parameter(MAXALL=60)
      integer allele
      double precision cumfrq(MAXALL)
      real x
C functions
      real random
      x=random()
      allele=0
   10 continue
        allele=allele+1
      if (x.gt.cumfrq(allele)) goto 10
      return
      end
C end-of-found
C
C transmit genes from parents to child
C 
      subroutine genoff(idx,fa,mo,set)
      integer MAXSIZ
      parameter(MAXSIZ=1000)
      integer idx,fa,mo,set(MAXSIZ,2),a1,a2
      real random
      if (random().gt.0.5) then
        a1=set(fa,1)
      else
        a1=set(fa,2)
      end if
      if (random().gt.0.5) then
        a2=set(mo,1)
      else
        a2=set(mo,2)
      end if
      if (a1.gt.a2) then
        set(idx,1)=a2
        set(idx,2)=a1
      else
        set(idx,1)=a1
        set(idx,2)=a2
      end if
      return
      end
C end-of-genoff
C 
C  Given genotypes at a single locus in a pedigree of arbitrary complexity, 
C  generate ibd by gene dropping a perfectly informative marker a la
C  John Blangero.
C  Type=1 unconditional, =2, conditional on observed markers
C
      subroutine simibd(typ,pedigree,num,nfound,fa,mo,set,sibd)
C
C  Pedigree structure
      integer MAXSIZ, MISS
      parameter(MAXSIZ=1000, MISS=-9999)
      character*10 pedigree
      integer typ, num, nfound, fa(MAXSIZ),mo(MAXSIZ)
      integer set(MAXSIZ,2), sibd(MAXSIZ,2)
      integer i, found
      logical fin
      found=0
      do 10 i=1,nfound
        found=found+1
        sibd(i,1)=found
        found=found+1
        sibd(i,2)=found
   10 continue
      do 15 i=nfound+1,num
        sibd(i,1)=MISS
        sibd(i,2)=MISS
   15 continue
C
      if (typ.eq.1) then
   20   continue      
          fin=.true.
          do 30 i=nfound+1,num
          if (sibd(i,1).eq.MISS) then
            if (sibd(fa(i),1).ne.MISS.and.sibd(mo(i),1).ne.MISS) 
     &      then
              call genoff(i,fa(i),mo(i),sibd)
             else
              fin=.false.
            end if
          end if
   30     continue
        if (.not.fin) goto 20
      elseif (typ.eq.2) then
   50   continue      
          fin=.true.
          do 60 i=nfound+1,num
          if (sibd(i,1).eq.MISS) then
            if (sibd(fa(i),1).ne.MISS.and.sibd(mo(i),1).ne.MISS) 
     &      then
              call genof2(pedigree,i,fa(i),mo(i),set,sibd)
            else
              fin=.false.
            end if
          end if
   60     continue
        if (.not.fin) goto 50
      end if
      return
      end
C end-of-simibd
C
C transmit ibd-marker from parents to child, 
C test if consistent with observed marker
C In this version 12/99, the sibd pairs are ordered by the collating
C order of the marker alleles they represent and
C not the collating order of the sibd allele.
C 
      subroutine genof2(pedigree,idx,fa,mo,set,sibd)
      integer MAXSIZ
      parameter(MAXSIZ=1000)
      character*10 pedigree
      integer idx,fa,mo,set(MAXSIZ,2),sibd(MAXSIZ,2)
      integer c1, c2, maxtrials, par1, par2, tr1, tr2, trials
C sample without replacement from {{1,2},{1,2}}
      integer choice, i, seed, space(4)
C functions
      integer irandom
C
      maxtrials=4
      trials=0
      do 10 i=1,maxtrials
        space(i)=i
   10 continue

      c1=set(idx,1)
      c2=set(idx,2)
    1 continue
        trials=trials+1
        choice=irandom(trials, maxtrials)
        seed=space(choice)
        space(choice)=space(trials)

#ifdef F2C
        tr1=and(seed,2)/2+1
        tr2=and(seed,1)+1
#endif F2C
#ifdef HPUX
        tr2=iand(seed,2)/2+1
        tr1=iand(seed,1)+1
#endif HPUX
#ifdef DEC
        tr1=iand(seed,2)/2+1
        tr2=iand(seed,1)+1
#endif DEC
#ifdef SUN
        tr1=and(seed,2)/2+1
        tr2=and(seed,1)+1
#endif SUN

        par1=set(fa,tr1)
        par2=set(mo,tr2)
C
C     write(*,*) 'Prop: ',trials,' choice:',choice,
C    2   ' space: ',(space(i),i=1,4),
C    3   ' seed: ',seed,'-> ',tr1,tr2
      if (c1.eq.par1 .and. c2.eq.par2) then
        sibd(idx,1)=sibd(fa,tr1)
        sibd(idx,2)=sibd(mo,tr2)
      elseif (c1.eq.par2.and.c2.eq.par1) then
        sibd(idx,1)=sibd(mo,tr2)
        sibd(idx,2)=sibd(fa,tr1)
      elseif (trials.lt.maxtrials) then
        goto 1
      else 
        write(*,'(a/7x,a/a/)') 
     2    'ERROR: Probable mendelian inconsistency encountered',
     3    'performing ibd simulation.  Stopping prematurely.'
        write(*,*) 'In pedigree ',pedigree,', index person #',idx,
     2    ' has genotype: ',c1,c2,' Parental genotypes: ',
     3    set(fa,1),set(fa,2),' & ',set(mo,1),set(mo,2)
        stop
      end if
      return
      end
C end-of-genof2
C
C count the untyped founder x founder matings for use by Metropolis algs
C
      subroutine tabmat(num,nfound,fa,mo,untyped,nummat,cntmat)
      integer MAXALL, MAXSIZ
      parameter(MAXALL=60, MAXSIZ=1000)
      integer num,nfound,fa(MAXSIZ),mo(MAXSIZ)
      logical untyped(MAXSIZ)
      integer nummat, cntmat(MAXALL,2)
C local variables
      integer i

      nummat=0
      do 5 i=1,MAXALL
        cntmat(i,1)=0
        cntmat(i,2)=0
    5 continue
      do 10 i=nfound+1,num
      if (untyped(fa(i)) .and. untyped(mo(i)) .and.
     &    fa(i).le.nfound .and. mo(i).le.nfound) then
        call mattab(fa(i),mo(i),nummat,cntmat)
      end if
   10 continue 
      return
      end
C end-of-tabmat
C
C update list of matings -- simple insertion sort
C
      subroutine mattab(key1,key2,num,cnt)
      integer MAXALL
      parameter(MAXALL=60)
      integer key1, key2, num, cnt(MAXALL,2)
      integer i,pos
      pos=0
    1 continue 
        pos=pos+1
      if (pos.le.num .and. (key1.gt.cnt(pos,1) .or.
     &    (key1.eq.cnt(pos,1) .and. key2.gt.cnt(pos,2)))) goto 1
      if (pos.gt.num .or. key2.ne.cnt(pos,2)) then
        if (num.gt.MAXALL) then
          write(*,'(a,i2,a/)') 
     &      'ERROR: More than ',MAXALL,' UnT x UnT founder matings.'
        else
          do 2 i=num,pos,-1
            cnt(i+1,1)=cnt(i,1)
            cnt(i+1,2)=cnt(i,2)
    2     continue
          num=num+1
          cnt(pos,1)=key1
          cnt(pos,2)=key2
        end if
      end if
      return
      end
C end-of-mattab

C
C Variance components analysis 
C
      subroutine sibqtl(wrk,twrk,tranam,trait,locnam,gene,pedigree,
     2                  actset,num, nfound,id,fa,mo,sex,locus,numloc,
     3              numal,name,alfrq, untyped,set,a,c,plevel)
      integer KNOWN,MAXALL,IBDSIZ,MAXIBD,NPAR,MAXSIZ,MAXLOC,MISS
      parameter (KNOWN=0, MAXALL=60,MAXSIZ=1000,MAXLOC=120,MAXPAR=4,
     &           MAXIBD=1000, IBDSIZ=MAXIBD*(MAXIBD+1)/2, MISS=-9999)
C
      integer MAXFN
      double precision GRADTL
      parameter (GRADTL = 1.0d-12, MAXFN = 1000)
C
      integer gene,trait,twrk,wrk,plevel
      character*10 locnam, tranam
C  Pedigree structure
      character*10 pedigree
      integer actset,num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ)
      integer sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C allele frequencies structure
      integer numal, name(MAXALL)
      double precision alfrq(MAXALL)
C Array to contain covariances and inverse
      double precision a(IBDSIZ), c(IBDSIZ)
C work arrays
      integer set(MAXSIZ,2)
      logical untyped(MAXSIZ)
      double precision x(MAXPAR), w(MAXPAR*(MAXPAR+5))
      double precision m(MAXSIZ),w1(MAXSIZ),w2(MAXSIZ),y(MAXSIZ)
C local variables
      integer currf, currm, fin, gen2, i, i1, i2, i3, i4, ier, iter,
     &        j, k, nn, pos, sibs, tot, typ
      character*3 histo
      logical last
      double precision aelik, asyp, aqelik, d2, lod, ymean, yvar
C functions
      integer getnam
      double precision chip

      if (plevel.gt.0) then
        write(*,'(/a/a,a10,a,a10,a/a)') 
     2  '-----------------------------------------------------',
     3  'VC linkage analysis for "',tranam,'" v "' ,locnam,'"',
     4  '-----------------------------------------------------' 
      end if

      gen2=gene+1
      last=.false.
      nfam=0
      npar=4
      sibs=0
      tot=0 
      typ=2
      ymean=0.0d0
      yvar=0.0d0
      rewind(wrk)
    5 continue
        call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &             numloc, last)
        if (last) goto 20
C
        if (actset.le.0) goto 5
C
        do 70 i=1,num
        if (locus(i,gene).gt.KNOWN) then
          untyped(i)=.false.
          set(i,1)=getnam(locus(i,gene),numal,name)
          set(i,2)=getnam(locus(i,gen2),numal,name)
        else  
          untyped(i)=.true.
          set(i,1)=MISS
          set(i,2)=MISS
        end if
   70   continue
C
C Full sibs
C
        fin=num
        currf=fa(fin)
        currm=mo(fin)
        do 90 k=num-1,nfound,-1
          if (fa(k).ne.currf .or. mo(k).ne.currm) then
            nobs=0
            do 92 i=k+1,fin
            if (locus(i,trait).ne.MISS .and. .not.untyped(i)) then 
              nobs=nobs+1
              tot=tot+1
              y(nobs)=dble(locus(i,trait))
              call moment(tot,y(nobs),ymean,yvar)
            end if
   92       continue
C
C Skip if no usable individuals in this sibship
C else reduce ibd matrix to that for phenotyped individuals only
C
            if (nobs.gt.0) then
              nfam=nfam+1
              sibs=sibs+nobs*(nobs-1)/2
C kinships
              call filltri(nobs,nobs*(nobs+1)/2,c,1.0d0,0.5d0)
C ibds
              call nucibd(gene,currf,currm,k+1,fin,set,
     &                untyped, a, numal, name, alfrq)
              nn=0
              pos=0
              do 60 i=k+1,fin
                do 65 j=k+1,i
                  pos=pos+1
                  if (locus(i,trait).ne.MISS .and. .not.untyped(i) .and.
     &                locus(j,trait).ne.MISS .and. .not.untyped(j)) then
                    nn=nn+1
                    a(nn)=a(pos)
                  end if
   65           continue
   60         continue
C     pos=0
C     do kk=1, nobs
C       write(*,'(i2,1x,f8.4,100(1x,f6.4):)') kk,y(kk),(a(pos+i),i=1,kk)
C       pos=pos+kk
C     end do
              write(twrk) nobs, nn, (y(i),i=1,nobs), 
     &                    (c(i), i=1, nn), (a(i),i=1, nn)
            end if
C Now update to next sibship
            fin=k
            currf=fa(fin)
            currm=mo(fin)
          end if
   90   continue
C
      goto 5
   20 continue
C
C plug in starting values and iterate for MLEs
C
      if (sibs.eq.0) return

      yvar=yvar/dfloat(tot)

      npar=3
      x(1)=ymean
      x(2)=0.1d0*yvar
      x(3)=0.9d0*yvar
C
      aelik=0.0d0
      typ=1
      call initvm(npar, i1,i2,i3,i4, ier)
      call varmet(npar,x,aelik,w(i3),w,w(i1),w(i2),w(i4),
     &       gradtl,maxfn,ier,iter,twrk,typ,y,a,c,m,w1,w2,plevel)
      if (ier.ne.0) call vmerr(ier, maxfn)

      call mvnlik(twrk,typ,npar,x,y,a,aelik,c,m,w1,w2)

      npar=4
      typ=2
      x(4)=abs(x(3))
      x(3)=0.1d0*abs(x(2))
      x(2)=0.9d0*abs(x(2))
      aqelik=0.0d0
      call initvm(npar, i1,i2,i3,i4, ier)
      call varmet(npar,x,aqelik,w(i3),w,w(i1),w(i2),w(i4),
     &       gradtl,maxfn,ier,iter,twrk,typ,y,a,c,m,w1,w2,plevel)
      if (ier.ne.0) call vmerr(ier, maxfn)

      call mvnlik(twrk,typ,npar,x,y,a,aqelik,c,m,w1,w2)
      d2=aelik-aqelik
      lod=0.217142d0*d2
      asyp=chip(d2,1)

      x(2)=abs(x(2))
      x(3)=abs(x(3))
      x(4)=abs(x(4))
      yvar=100.0d0/(x(2)+x(3)+x(4))
      if (plevel.gt.0) then
        write(*,'(2(/a,i5))') 
     2    'Number of sibships         = ', nfam,
     3    'Number of observations     = ', tot  
        write(*,'(a,f12.6,3(/a,f12.6,a,f5.1,a))') 
     2  'Trait mean                 = ', x(1),
     3  'Additive genetic variance  = ', x(2), ' (',x(2)*yvar,'%)',
     3  'QTL genetic variance       = ', x(3), ' (',x(3)*yvar,'%)',
     4  'Environmental variance     = ', x(4), ' (',x(4)*yvar,'%)' 
        write(*,'(a,f8.2,4x,a,f5.2,a/a,i5)') 
     5  'Linkage chi-square (lod)   = ', d2,' (',lod,')',
     6  'Total function evaluations = ', iter 
      else
        call phist(asyp,1.0d0,histo)
        write(*,'(a10,1x,i6,3x,a,4x,f10.1,2(1x,f6.4),1x,i6,2(1x,a))')
     &    locnam, sibs, '-', lod, asyp, 1.0d0, 0, 'VC ',histo
      end if
      return
      end
C end-of-sibqtl 
C
C Variance components analysis 
C
      subroutine varcom(wrk,twrk,locnam,trait,pedigree,actset,num,
     2              nfound,id,fa,mo,sex,locus,numloc,
     3              untyped,a,c,plevel,typ)
      integer IBDSIZ,MAXIBD,NPAR,MAXSIZ,MAXLOC,MISS
      parameter (MAXSIZ=1000,MAXLOC=120,MAXPAR=4,MAXIBD=1000, 
     &           IBDSIZ=MAXIBD*(MAXIBD+1)/2, MISS=-9999)
C
      integer MAXFN
      double precision GRADTL
      parameter (GRADTL = 1.0d-12, MAXFN = 1000)
C
      integer trait,twrk,typ,wrk,plevel
      character*10 locnam
C  Pedigree structure
      character*10 pedigree
      integer actset,num, nfound
      character*8 id(MAXSIZ)
      integer fa(MAXSIZ), mo(MAXSIZ)
      integer sex(MAXSIZ)
      real locus(MAXSIZ,MAXLOC)
C Array to contain covariances and inverse
      double precision a(IBDSIZ), c(IBDSIZ)
C work arrays
      logical untyped(MAXSIZ)
      double precision x(MAXPAR), w(MAXPAR*(MAXPAR+5))
      double precision m(MAXSIZ),w1(MAXSIZ),w2(MAXSIZ),y(MAXSIZ)
C local variables
      integer i, i1,i2,i3,i4,ier, iter1, iter2, modl, nn, pos, tot
      logical last
      double precision lik, lik_ae, domtest, gentest,
     &                 va, vd, ve, ymean, yvar
C functions
      double precision chip

      last=.false.
      nfam=0
      tot=0 
      lik=0.0d0
      lik_ae=0.0d0
      ymean=0.0d0
      yvar=0.0d0
      rewind(wrk)
    5 continue
        call wrkin(wrk,pedigree,actset,num,nfound,id,fa,mo,sex,locus,
     &             numloc, last)
        if (last) goto 20
C
        if (actset.le.0) goto 5
C
        nfam=nfam+1
        nobs=0

        do 50 i=1,num
        if (locus(i,trait).ne.MISS) then
          untyped(i)=.false.
          nobs=nobs+1
          tot=tot+1
          y(nobs)=dble(locus(i,trait))
          call moment(tot,y(nobs),ymean,yvar)
        else
          untyped(i)=.true.
        end if
   50   continue

        call kinship(num,nfound,fa,mo,a)
        call frater(num,nfound,fa,mo,a,c)
        if (nobs.ne.num) then
          nn=0
          pos=0
          do 60 i=1, num
            if (.not.untyped(i)) then
              do 65 j=1,i
              if (.not.untyped(j)) then
                nn=nn+1
                a(nn)=a(pos+j)
                c(nn)=c(pos+j)
              end if
   65         continue
            end if
            pos=pos+i
   60     continue
        else
          nn=nobs*(nobs+1)/2
        end if
        if (nobs.gt.0) then
          write(twrk) nobs, nn, (y(i),i=1,nobs),
     &                (a(i),i=1, nn), (c(i),i=1, nn)
        end if
C
      goto 5
   20 continue
      yvar=yvar/dfloat(tot)
C
      write(*,'(/a/a,a10,a/a)') 
     2  '------------------------------------------------',
     3  'Variance components analysis for "',locnam,'"',
     4  '------------------------------------------------' 
      write(*,'(2(/a,i5))') 
     2  'Number of families         = ', nfam,
     3  'Number of observations     = ', tot  
C
C plug in starting values and iterate for MLEs
C ADE
C
      x(1)=ymean
      x(2)=0.1d0*yvar
      if (typ.eq.2) then
        modl=2
        npar=4
        typ=2
        x(3)=0.0d0
        x(4)=0.9d0*yvar

        call initvm(npar, i1,i2,i3,i4, ier)
        call varmet(npar,x,lik,w(i3),w,w(i1),w(i2),w(i4),
     &         gradtl,maxfn,ier,iter1,twrk,modl,y,a,c,m,w1,w2,plevel)
C
        if (ier.ne.0) call vmerr(ier, maxfn)
        
        call mvnlik(twrk,modl,npar,x,y,a,lik,c,m,w1,w2)
        va=abs(x(2))
        vd=abs(x(3))
        ve=abs(x(4))

C starting values for AE run
        x(2)=va+vd
        x(3)=ve
      else
        x(3)=0.9d0*yvar
      end if
C AE
      npar=3
      modl=1

      call initvm(npar, i1,i2,i3,i4, ier)
      call varmet(npar,x,lik_ae,w(i3),w,w(i1),w(i2),w(i4),
     &       gradtl,maxfn,ier,iter2,twrk,modl,y,a,c,m,w1,w2,plevel)
C
      if (ier.ne.0) call vmerr(ier, maxfn)
      domtest=lik_ae-lik
      if (typ.eq.1 .or. domtest .le. 3.84d0) then
        call mvnlik(twrk,modl,npar,x,y,a,lik,c,m,w1,w2)
        va=abs(x(2))
        vd=0.0d0
        ve=abs(x(3))
      else
        npar=4
      end if
C test A(D)E v E
      gentest=dfloat(tot)*(log(yvar)+1.0d0)-lik

      yvar=100.0d0/(va + vd + ve)
      write(*,'(a,f12.6/a,f12.6,a,f5.1,a)') 
     2  'Trait mean                 = ', x(1),
     3  'Additive genetic variance  = ', va  , ' (',va*yvar,'%)' 
      if (npar.eq.4) then
        write(*,'(a,f12.6,a,f5.1,a)') 
     &  'Dominance genetic variance = ', vd  , ' (',vd*yvar,'%)' 
      end if
      write(*,'(a,f12.6,a,f5.1,a/a,f12.6)')
     2  'Environmental variance     = ', ve  , ' (',ve*yvar,'%)',
     3  'Model loglikelihood        = ', -0.5d0*lik 
      if (typ.eq.2) then
        write(*,'(/a,f8.2,4x,a,i1,a,f5.3,a)') 
     2    'Chi-square testing VD=0    = ', domtest,
     3    ' (df=',1,', P=',chip(domtest,1),')' 
      end if
      write(*,'(/a,f8.2,4x,a,i1,a,f5.3,a)') 
     4  'Chi-square testing VG=0    = ', gentest,
     5  ' (df=',npar-2,', P=',chip(gentest,npar-2),')' 
      write(*,'(a,i5)') 
     &  'Total function evaluations = ', max(iter1,iter2) 
      return
      end
C end-of-varcom 
C
C MVN model loglikelihood
C
      subroutine mvnlik(twrk,typ,npar,x,y,a,q,c,m,w1,w2)
C
      integer IBDSIZ, MAXSIZ
      parameter (MAXSIZ=1000, IBDSIZ=MAXSIZ*(MAXSIZ+1)/2)

      integer npar, typ, twrk
      double precision x(*),q
      double precision y(MAXSIZ), a(IBDSIZ)
C work arrays
      double precision c(IBDSIZ),m(MAXSIZ),w1(MAXSIZ),w2(MAXSIZ)
C local variables
      integer i, ifault, n, nn, nullty, pos
      double precision quad, logdet, va, ve, vq, ymean

      ifault=0
      nullty=0
      q=0.0d0
      ymean=x(1)
      va=abs(x(2))
      vq=0.0d0
      ve=abs(x(npar))
      if (typ.eq.2) vq=abs(x(3))
      
      rewind(twrk)
   10 continue
        read(twrk,end=50) n, nn, (y(i),i=1,n), 
     &                    (a(i),i=1, nn), (c(i),i=1, nn)
        pos=0
        do 15 i=1,nn
          a(i)=a(i)*va+c(i)*vq
   15   continue
        do 20 i=1,n
          pos=pos+i
          m(i)=ymean
          a(pos)=a(pos)+ve
   20   continue
        call syminv(a,n,nn,c,w1,logdet,nullty,ifault)

        if (ifault.ne.0) then 
          q=1.0d99
        else
          call quadmult(n,y,m,nn,c,w1,w2,quad)
          q=q+logdet+quad
        end if
      goto 10
   50 continue

      return
      end
C end-of-mvnlik
C
C AS 319 Varmet: likelihood function work arrays passed directly
C                likelihood function explicitly named
C
      subroutine varmet(npar,b,f0,g,h,c,d,t,gradtl,maxfn,ifault,ifn,
     &                  twrk,typ,y,a,ainv,m,w1,w2,plevel)
      integer IBDSIZ, ICMAX, MAXIBD, MAXSIZ
      double precision TOLER, W
      parameter (ICMAX=20, MAXSIZ=1000,MAXIBD=1000, 
     &           IBDSIZ=MAXIBD*(MAXIBD+1)/2,TOLER=0.00001d0, W=0.2d0)
      integer ifn, plevel, twrk, typ
      double precision b(npar),f0, g(npar), h(npar,npar),c(npar),
     &                 d(npar),t(2*npar),gradtl,d1,s,ck,f1,d2
      double precision y(MAXSIZ), a(IBDSIZ)
C work arrays
      double precision ainv(IBDSIZ),m(MAXSIZ),w1(MAXSIZ),w2(MAXSIZ)
C local variables
      integer i, ic, icount, ilast, ig, k, l, np
C
      ig = 0
      ifn = 0
      ifault = 0
      np = npar + 1
C
      call mvnlik(twrk,typ,npar,b,y,a,f0,ainv,m,w1,w2)
      ifn = ifn + 1
      if (plevel.gt.1) then
        write(*,'(i4,5(1x,f12.6):)') ifn,f0,(b(i),i=1, npar)
      end if
C
      call grad(npar,b,f0,g,t(np),gradtl,ifault,
     &          twrk,typ,y,a,ainv,m,w1,w2)
      if (ifault.gt.0) return
C
      ig = ig + 1
      ifn = ifn + npar
      if (ifn.gt.maxfn) then
        ifault = 4
        return
      endif
C
   10 do 30 k = 1,npar
         do 20 l = 1,npar
            h(k,l) = 0.0d0
   20    continue
         h(k,k) = 1.00d0
   30 continue
      ilast = ig
C
   40 do 50 i = 1,npar
         d(i) = b(i)
         c(i) = g(i)
   50 continue
C
      d1 = 0.0d0
      do 70 i = 1,npar
         s = 0.0d0
         do 60 j = 1,npar
            s = s - h(i,j)*g(j)
   60    continue
         t(i) = s
         d1 = d1 - s*g(i)
   70 continue
C
      if(d1.le.0.0d0) then
         if(ilast.eq.ig) then
            return
         endif
         go to 10
      else
         ck = 1.0d0
         ic = 0
   90    icount = 0
         do 100 i = 1,npar
            b(i) = d(i) + ck*t(i)
            if(b(i).eq.d(i)) then
               icount = icount + 1
            endif
  100    continue
C
         if(icount.ge.npar) then
            if(ilast.eq.ig) then
               return
            endif
            go to 10
         else
            call mvnlik(twrk,typ,npar,b,y,a,f1,ainv,m,w1,w2)
            ifn = ifn + 1
            if (plevel.gt.1) then
              write(*,'(i4,5(1x,f12.6):)') ifn,f1,(b(i),i=1, npar)
            end if
            if (ifn.gt.maxfn) then
              ifault = 4
              return
            else if (f1.eq.1.0d99) then
              ck = W * ck
              ic = ic+1
              if (ic.gt.ICMAX) then
                ifault = 3
                return
              endif
              go to 90
C
            else if(f1.ge.f0 - d1*ck*TOLER) then
               ck = W * ck
               go to 90
            else
               f0 = f1
               call grad(npar,b,f0,g,t(np),gradtl,ifault,
     &                   twrk,typ,y,a,ainv,m,w1,w2)
               if(ifault.gt.0) then
                  return
               endif
               ig = ig + 1
               ifn = ifn + npar
               if(ifn.gt.maxfn) then
                  ifault = 4
                  return
               endif
C
               d1 = 0.0d0
               do 130 i = 1,npar
                  t(i) = ck*t(i)
                  c(i) = g(i) - c(i)
                  d1 = d1 + t(i)*c(i)
  130          continue
C
               if(d1.le.0.0d0) then
                  goto 10
               endif
C
               d2 = 0.0d0
               do 150 i = 1,npar
                  s = 0.0d0
                  do 140 j = 1,npar
                     s = s + h(i,j)*c(j)
  140             continue
                  d(i) = s
                  d2 = d2 + s*c(i)
  150          continue
               d2 = 1.0d0 + d2/d1
C
               do 170 i = 1,npar
                  do 170 j = 1,npar
                     h(i,j) = h(i,j) - (t(i)*d(j) + d(i)*t(j) -
     &               d2*t(i)*t(j))/d1
  170          continue
            endif
         endif
      endif
      go to 40
      end
C end-of-varmet
C
C Approximate gradient
C
      subroutine grad(npar,b,f0,g,sa,er,ifault,
     &                twrk,typ,y,a,c,m,w1,w2)
      integer IBDSIZ, MAXIBD, MAXSIZ
      parameter (MAXSIZ=1000,MAXIBD=1000, 
     &           IBDSIZ=MAXIBD*(MAXIBD+1)/2)
      integer ifault, twrk, typ
      double precision b(npar),er,f0,g(npar),h,sa(npar)
      double precision y(MAXSIZ), a(IBDSIZ)
C work arrays
      double precision c(IBDSIZ),m(MAXSIZ),w1(MAXSIZ),w2(MAXSIZ)
C local variables 
      integer i, jc, jcmax
      double precision f1
C
      jcmax=npar-2
      jc = 0
C
      do 20 i = 1,npar
        h =(dabs(b(i)) +dsqrt(er)) *dsqrt(er)
        sa(i) = b(i)
        b(i) = b(i) + h
        call mvnlik(twrk,typ,npar,b,y,a,f1,c,m,w1,w2)
        b(i) = sa(i)
C
        if (f1.eq.1.0d99) then
          f1 = f0 + h
          jc = jc + 1
        endif
C
        g(i) = (f1 -f0)/h
   20 continue
C
      if (jc.gt.jcmax) ifault = 2
      return
      end
C end-of-grad
C 
C Initialize varmet work arrays etc
C
      subroutine initvm(npar, i1,i2,i3,i4, ier)
      integer i1,i2,i3,i4,ier,npar
      ier=0
      i1 = npar*npar + 1
      i2 = i1 + npar
      i3 = i2 + npar
      i4 = i3 + npar
      return
      end
C end-of-initvar
C
C varmet error messages
C
      subroutine vmerr(ier, maxfn)
      integer ier, maxfn
      if (ier.eq.1) then
        write(*,'(/a/)') 'ERROR: Likelihood undefined at initial value.'
      else if (ier.eq.2) then
        write(*,'(/a/)') 'ERROR: Gradient undefined in too many dims.'
      else if (ier.eq.3) then
        write(*,'(/a/)') 'ERROR: Unable to find minimum.'
      else if (ier.eq.4) then
        write(*,'(/a,i4,a/)') 'ERROR: Exceeded ',maxfn,' evaluations.'
      end if
      return
      end
C end-of-vmerr
